(function () {
	var KL = (function () {
		var NameSpace = {
			__nsName: "",
			__namespace: true,
			getType: function (typeName) {
				return NamespaceType._getType(typeName);
			},
			registerEnum: function (theEnumName, theEnum, excludeInvertion, escLoading) {
				var arrInvert = [];
				var keys = [];
				for (var key in theEnum) {
					if (!excludeInvertion)
						arrInvert[theEnum[key]] = key;
					keys.push(key);
				}
				this.registerClass(theEnumName, theEnum, escLoading);
				theEnum.__enum = true;
				theEnum._keys = keys;
				theEnum._invert = arrInvert;
				theEnum.getKeys = function () {
					return this._keys;
				};
				theEnum.getKeyByValue = function (val) {
					if (typeof (this._invert[val]) != "undefined")
						return this._invert[val];
					return null;
				};
				return this;
			},
			registerClass: function (theClassName, theClass, escLoading) {
				theClass.__class = true;
				var __className = this.__nsName + "." + theClassName;
				if( typeof(theClass) == "function" ){
					theClass["extend"] = this.classExted;
					theClass.prototype.toString = (function (nm) { return function () { return nm; }; })(__className);
					theClass.prototype.constructor = theClass;
				}
				this[theClassName] = theClass;
				NamespaceType._registerType(__className, theClass);
				return this;
			},
			registerNS: function (nsName) {
				var ns = new NamespaceType(nsName);
				ns.__nsName = this.__nsName + "." + nsName;
				this[nsName] = ns;
				NamespaceType._registerType(ns.__nsName, ns);
				return ns;
			},
			classExted: function(superclass){
				var superclassProto = ( typeof( superclass ) == "function" ? superclass.prototype : ( typeof (superclass) == "object"? superclass : {} ));
				var publicMembersProto = null;
				var toStr = null;
				if( this.prototype ){
					
					publicMembersProto = this.prototype;
					toStr = this.prototype.toString;
				}
				var f = function(){};
				f.prototype = superclassProto;
				this.prototype = new f();
				this.prototype.constructor = this;
				if( !!publicMembersProto ){
					for( var prop in publicMembersProto ){
						if( publicMembersProto.hasOwnProperty( prop ) )
							this.prototype[prop] = publicMembersProto[prop];
					}
				}
				if( toStr )
					this.prototype.toString = toStr;
				this._super = superclassProto.constructor || Object;
			}
		};
		var NamespaceType = function (nsName) { this.__nsName = nsName; };
		NamespaceType.prototype = NameSpace;
		NamespaceType._types = {};
		NamespaceType._registerType = function (typeName, type) {
			this._types[typeName] = type;
		};
		NamespaceType._getType = function (typeName) {
			return this._types[typeName];
		};
		
		return new NamespaceType("KL");
	})();
	window.KL = KL;
KL.registerNS("Utils");
(function () {
	var Log = {
		__class: true,
		_i: 0,
		logLevel: 0,
		lvlMap: ["error", "warn", "log", "info"],
		type: {
			ERROR: 0,
			WARNING: 1,
			LOG: 2,
			INFO: 3
		},
		write: function (text, type) {
			var typeIndx = +(type || type === 0 ? type : Log.type.LOG);
			if( typeIndx <= this.logLevel ){
				typeVal =  this.lvlMap[typeIndx];
				var color = "black",
					extraparams = Array.prototype.slice.call( arguments, 2 );
				switch (typeIndx) {
					case this.type.INFO: color = "gray"; break;
					case this.type.WARNING: color = "orange"; break;
					case this.type.ERROR: color = "red"; break;
					default: typeVal = this.lvlMap[this.type.LOG]; break;
				}
				try { console[typeVal].apply(console, [].concat(([this._i, " " + typeVal + ". ", (new Date()).toGMTString(), " ", text]).join("")).concat(extraparams) ); } catch (e) {}
				this._i++;
			}
		},
		clear: function () {
			this._i = 0;
		},
		setLogLevel: function(lvl){
			this.logLevel = +(lvl || this.type.ERROR);
			KL.Web.Application.getContext().setData( KL.Web.Context.DataTypes.LogLevel, this.logLevel );
		}
	};
	Log.clear();
	KL.Utils.registerClass("Log", Log);
})()
;
(function () {
	var Delegate = {
		__class: true,
		create: function (obj, fn, params) {
			if (!obj)
				throw "Base object is required";
			if (!fn || typeof(fn) != "function"){
				throw "Function is required";
			}
			var args1 = Array.prototype.slice.call(arguments, 2);
			return function () {
				var args = args1.concat(Array.prototype.slice.call(arguments));
				args.push(this);
				return fn.apply(obj, args);
			};
		}
	};
	KL.Utils.registerClass("Delegate", Delegate);
})()
;
(function () {
	var StringHelper = {
		__class: true,
		formatTemplate: function (str, obj) {
			if (!str)
				return "";
			if (!obj)
				return str;
			str = this._decodeBraces(str).replace(/\{([^}]+)\}/gim, function (a, b) { return (typeof (obj[b]) == "undefined" ? a : obj[b]); });
			return str;
		},
		format: function (str, args) {
			if (!str)
				return "";
			if (arguments.length < 2)
				return str;
			str = this._decodeBraces(str);
			for (var i = 1, l = arguments.length; i < l; i++)
				str = str.replace(new RegExp("(\\{" + (i - 1) + "\\})", "g"), arguments[i]);
			return str;
		},
		_decodeBraces: function (str) {
			return str.replace(
				new RegExp("(\\" + encodeURIComponent("{") + "|\\" + encodeURIComponent("}") + ")", "gm"),
				function (a) { return decodeURIComponent(a); }
			);
		},
		
		_isCropString: function (str) {
			if (!str) return false;
			if (str.lastIndexOf("...")==str.length-3)
				return true;
			return false;
		},
		cropString: function (str, len, no3dots) {
			str = str||"";
			if (str.length > len)
				return str.substr(0, len) + (no3dots?"":"...");
			return str;
		},
		wordBreak: function (str, len) {
			len = len && !isNaN(len) ? len : 5;
			str = str.replace(new RegExp("(\.{" + len + "})", "gim"), "$1<span class=\"wbr\"></span>");
			return str;
		},
		htmlEncode: function (str) {
			return (str||"").replace(/([\<\>\"\&])/gim, function (a) {
				return ({
					"<": "&lt;",
					">": "&gt;",
					"\"": "&quot;",
					"<": "&lt;",
					"&": "&amp;"
				})[a] || a;
			});
		},
		addSlashes: function (str) {
			return str.replace(/([\t\n\r\"\\])/gim, function (a) {
				return ({
					"\t": "\\t",
					"\n": "\\n",
					"\r": "\\r",
					"\"": "\\\"",
					"\\": "\\\\"
				})[a] || a;
			});
		},
		checkFileName: function (str) {
            var reg = /[\r\n\\\/:*?\"\<\>\|]/gi;
			return !reg.test(str);
		},
		rtrim: function(str, chars) {
			chars = chars || "\\s";
			return str.replace(new RegExp("[" + chars + "]+$", "g"), "");
		},
		ltrim: function(str, chars) {
			chars = chars || "\\s";
			return str.replace(new RegExp("^[" + chars + "]+", "g"), "");
		}
	};
	KL.Utils.registerClass("StringHelper", StringHelper);
})()
;
(function () {
	var daysNums = {
		"su": 0,
		"mo": 1,
		"tu": 2,
		"we": 3,
		"th": 4,
		"fr": 5,
		"sa": 6
	};
	function getNumSufixRulesFn(){
		if( !this.strings["__applyNumSuffixRules"] ){
			var rulesFn = [],
				map = this.strings["RulesNumsSuffixes"];
			for( var ruleName in map ){
				var rules_i = $.trim(([]).concat(map[ruleName]).join(")||(")
					.replace(/(and|or|not|\<\>|!=|==|=)/gi, function(a){
						return ({
							"and": " && ",
							"or": " || ",
							"not": " !",
							"<>": "!=",
							"=": "=="
						})[a]||" || ";
					}));
				if( !!rules_i )
					rulesFn.push( "if(("+rules_i+"))\n\treturn '"+ruleName+"';" )
			}
			this.strings["__applyNumSuffixRules"] = new Function( "n", rulesFn.join("\n else ") + "\n return 'Plural';" );
		}
		return this.strings["__applyNumSuffixRules"];
	}
	var Localization = function (lang, app) {
		this.scriptId = "scriptLocalization_loadr" + (new Date()).getTime();
		this._tmpCurLang = lang;
		Localization._inst = this;
		this._app = app;
	};
	Localization.prototype = {
		strings: null,
		_app: null,
		count: 0,
		_stringsCache: {},
		_tmpCurLang: "en",
		defaultLang: "en",
		_langs: [],
		_langsList: null,
		resourceBaseURL: "resources/",
		langsListUrl: "resources/langs.json",
		resourceLink: "{0}resource_{1}.js?{2}",
		scriptId: "",
		eltPrefix: "str-local-",
		tplPrefix: "tpl-local-",
		inited: false,
		init: function () {
			this._loadLangsList();
		},
		setLanguage: function (lang) {
			var Delegate = KL.Utils.Delegate;
			if (this.strings && this.strings.Language == lang)
				return;
			if (!!this._stringsCache[lang]) {
				window.setTimeout(Delegate.create(this, this.applyResources, this._stringsCache[lang], true), 0);
			} else {
				this.strings = {};
				this.loadResources(lang);
			}
		},
		getLangName: function (lang) {
			return this._langsList[lang]||lang;
		},
		getLangsList: function () {
			return this._langs;
		},
		_loadLangsList: function () {
			var Delegate = KL.Utils.Delegate;
			$.ajax({
				type: "GET",
				url: this.resourceBaseURL,
				async: true,
				scriptCharset: "UTF-8",
				dataType: "html",
				success: Delegate.create(this, this._getAvailableLangs),
				error: Delegate.create(this, this._ajaxError, "List of available resources can not be loaded."),
				timeout: 60000
			});
		},
		_ajaxError: function (text) {
			KL.Utils.Log.write("Localization._ajaxError: " + text, KL.Utils.Log.type.ERROR, Array.prototype.slice.call(arguments, 1));
		},
		_applyLangsList: function (lang, oldData, data) {
			if (data) {
				data = oldData?$.extend( oldData, data ):data;
				if( data.error && /(lang=[a-zA-Z_\-]+)/.test(data.error) ){
					var otherLangs = [],
						matches = data.error.split("&");
					delete data.error;
					
					for (var indx = 0, l = matches.length; indx < l; indx++) {
						otherLangs.push( matches[indx].split("=")[1] );
					}
					this._loadLangsNamesList(otherLangs, lang, data);
				}else{
					delete data.error;
					this._langsList = data;
					this.loadResources(lang);
				}
			}else
				KL.Utils.Log.write("Localization._applyLangsList: No available languages list loaded", KL.Utils.Log.type.ERROR);
		},
		_getAvailableLangs: function (data) {
			var matches = (data + "").match(/resource_([\w\-]+)\.js/gim);
			var objData = {};
			var last_lang = "";
			for (var indx = 0, l = matches.length; indx < l; indx++) {
				var lang = matches[indx].match(/_([^\.]+)\./i)[1];
				if (!objData[lang]) {
					this._langs.push(lang);
				}
				objData[lang] = true;
				last_lang = lang;
			}
			if (!!last_lang) {
				var lang = last_lang;
				if (this._langs.length > 1 && objData[this._tmpCurLang])
					lang = this._tmpCurLang;
				else if (this._langs.length > 1 && objData[this.defaultLang])
					lang = this.defaultLang;
				
				this._loadLangsNamesList(this._langs, lang);
			} else
				KL.Utils.Log.write("Localization._getAvailableLangs: No Language Available", KL.Utils.Log.type.ERROR);
		},
		_loadLangsNamesList: function( langs, lang, oldData ){
			var Delegate = KL.Utils.Delegate;
			$.ajax({
				type: "GET",
				url: this.langsListUrl,
				data: { "lang": langs },
				traditional: true,
				scriptCharset: "UTF-8",
				dataType: "json",
				success: Delegate.create(this, this._applyLangsList, lang, oldData),
				error: Delegate.create(this, this._ajaxError, "List of available languages can not be loaded."),
				timeout: 60000
			});
		},
		loadResources: function (lang) {
			var Delegate = KL.Utils.Delegate;
			var src = KL.Utils.StringHelper.format(
				this.resourceLink,
				this.resourceBaseURL,
				$.trim(lang),
				(new Date()).getTime()
			);
			$.ajax({
				type: "GET",
				url: src,
				async: true,
				scriptCharset: "UTF-8",
				dataType: "html",
				success: Delegate.create(this, this._resourceLoadedHandler, lang),
				error: Delegate.create(this, this._ajaxError, "Can not load resources for language: " + lang + "."),
				timeout: 60000
			});
		},
		_resourceLoadedHandler: function (lang, data) {
			var strings = null;
			try {
				strings = eval("(" + data + ")");
			} catch (e) {
				KL.Utils.Log.write("Localization._resourceLoadedHandler: Strings eval Error=" + (e.Message || e.message), KL.Utils.Log.type.ERROR);
				this._ajaxError("Invalid resources data for language: " + lang + ".");
				return;
			}
			if( strings ){
				$(this._app).one( "patchready", KL.Utils.Delegate.create( this, function(l, s){
					try {
						this.applyResources(s);
					} catch (e) {
						KL.Utils.Log.write("Localization._resourceLoadedHandler: Resources apply Error=" + (e.Message || e.message), KL.Utils.Log.type.ERROR);
						this._ajaxError("Can not apply resources data for language: " + l + ".");
					}
				}, lang, strings ) );
				this._app.applyPatch( lang, strings.requires );
			}
		},
		getCurrLang: function () {
			return this._tmpCurLang;
		},
		applyResources: function (strings) {
			var Delegate = KL.Utils.Delegate;
			this.strings = strings;
			strings._keys = [];
			for (var strId in strings) {
				if (strings[strId] instanceof String || typeof (strId) == "string") {
					strings._keys.push(strId);
				}
			}
			var lang = this.strings.Language;
			this._stringsCache[lang] = this.strings;
			KL.Utils.Log.write("Localization.applyResources: " + lang);
			document.title = this.getLocaleValueString("LabelTitleProductName");
			$("html").attr("lang", lang);
			this._applyId++;
			this._tmpCurLang = lang;
			this._localizeDatepicker(strings);
			var res = this.applyDelayed(null);
			$(res).bind("onresourceapplied", KL.Utils.Delegate.create(this, this._triggerLangLoaded));
		},
		_localizeDatepicker: function (strings) {
			if ($.datepicker && strings["ResDatepickerDateFormat"])
				$.timeselect.setDefaults({
					"timeFormat": strings.ResTimeSelectFormat||"24h",
					"amSign": strings.ResTimeSelectAM||"am",
					"pmSign": strings.ResTimeSelectPM||"pm"
				});
				$.datepicker.setDefaults({
					"firstDay": daysNums[(strings.ResFirstWeekDay||"sunday").toLowerCase()],
					"dateFormat": strings.ResDatepickerDateFormat,
					"nextText": strings.ResDatepickerNextText,
					"prevText": strings.ResDatepickerPrevText,
					"yearSuffix": strings.ResDatepickerYearSuffix,
					"showMonthAfterYear": strings.ResDatepickerMonthAfterYear,
					"dayNames": [
						strings.ResDayNameSun,
						strings.ResDayNameMon,
						strings.ResDayNameTue,
						strings.ResDayNameWed,
						strings.ResDayNameThu,
						strings.ResDayNameFri,
						strings.ResDayNameSat
					],
					"dayNamesMin": [
						strings.ResDayShortNameSun,
						strings.ResDayShortNameMon,
						strings.ResDayShortNameTue,
						strings.ResDayShortNameWed,
						strings.ResDayShortNameThu,
						strings.ResDayShortNameFri,
						strings.ResDayShortNameSat
					],
					"dayNamesShort": [
						strings.ResDayShortNameSun,
						strings.ResDayShortNameMon,
						strings.ResDayShortNameTue,
						strings.ResDayShortNameWed,
						strings.ResDayShortNameThu,
						strings.ResDayShortNameFri,
						strings.ResDayShortNameSat
					],
					"monthNames": [
						strings.ResMonthJan,
						strings.ResMonthFeb,
						strings.ResMonthMar,
						strings.ResMonthApr,
						strings.ResMonthMay,
						strings.ResMonthJun,
						strings.ResMonthJul,
						strings.ResMonthAug,
						strings.ResMonthSep,
						strings.ResMonthOct,
						strings.ResMonthNov,
						strings.ResMonthDec
					],
					"monthNamesShort": [
						strings.ResShortMonthJan,
						strings.ResShortMonthFeb,
						strings.ResShortMonthMar,
						strings.ResShortMonthApr,
						strings.ResShortMonthMay,
						strings.ResShortMonthJun,
						strings.ResShortMonthJul,
						strings.ResShortMonthAug,
						strings.ResShortMonthSep,
						strings.ResShortMonthOct,
						strings.ResShortMonthNov,
						strings.ResShortMonthDec
					]
				});
		},
		_triggerLangLoaded: function () {
			$(this).trigger("onlangloaded", [this.strings.Language]);
		},
		_applyId: 0,
		_contexts: null,
		_applyResults: [],
		applyDelayed: function (context) {
			var Delegate = KL.Utils.Delegate;
			this._applyId++;
			this._applyResults[this._applyId] = { id: this._applyId };
			window.setTimeout(Delegate.create(this, this._apply, context, this._applyId), 20);
			return this._applyResults[this._applyId];
		},
		_apply: function (context, applyId) {
			if (!this.strings)
				return;
			var ctx = $(!!context ? context : document.body);
			var Delegate = KL.Utils.Delegate;
			ctx.find("[class*=" + this.eltPrefix + "], [class*=" + this.tplPrefix + "]").each(Delegate.create(this, this._applyStringI));
			this._triggerApplied(applyId);
		},
		_strPattern: /str\-local\-([0-9a-z_]*)/gi,
		_tplPattern: /tpl\-local\-([0-9a-z_]*)/gi,
		_applyStringI: function (indx, elt) {
			window.setTimeout(KL.Utils.Delegate.create(this, function () {
				this._strPattern.lastIndex = 0;
				this._tplPattern.lastIndex = 0;
				var classN = (this._strPattern).exec(elt.className);
				if (!!classN && classN.length > 1) {
					var val = this.getLocaleValueString(classN[1].toString()),
						$elt = $(elt);
					elt.innerHTML = val;
					if( $elt.data("local-apply-title") )
						$elt.attr("title", val);
				} else {
					classN = this._tplPattern.exec(elt.className);
					if (!!classN && classN.length > 1)
						this._applyEltObjStr(classN[1].toString(), elt);
				}
			}), 0);
		},
		
		_triggerApplied: function (applyId) {
			if (this._applyResults[applyId]) {
				$(this._applyResults[applyId]).trigger("onresourceapplied");
				this._applyResults[applyId] = null;
			}
		},
		_applyEltObjStr: function (strId, elt) {
			var $this = $(elt);
			if (!!$this.data("TemplateMethod") && !!$this.data("TemplateData")) {
				if (typeof (this[$this.data("TemplateMethod")]) == "function") {
					$this.html(this[$this.data("TemplateMethod")]($this.data("TemplateData"), strId));
				}
			}else
				KL.Utils.Log.write("Localization._applyEltObjStr: String " + strId + " has no required " + (!$this.data("TemplateMethod") ? " method " : "-") + (!$this.data("TemplateData") ? "data" : "-"), KL.Utils.Log.type.WARNING);
		},
		stringExists: function (strId) {
			if (!this.strings)
				return false;
			return !!this.strings[strId];
		},
		getLocaleSuffixNum : function ( val ) {
			var fn = getNumSufixRulesFn.call(this);
			
			return fn(val);
		},
		getText: function (txt) {
			return this.stringExists(txt) ? this.getLocaleString(txt) : txt;
		},
		
		getNoDateStr: function () {
			return this.getLocaleString("ResDateUnknown");
		},
		getLocalDate: function (dateObj) {
			if (!dateObj || !dateObj.isDate || !dateObj.hasValue)
				return $(this.getNoDateStr());
			return $((['<span class="', this.tplPrefix, 'ResMiddleDateFormat">', this._getLocalFormatDateStr(dateObj, "ResMiddleDateFormat"), "</span>"]).join("")).data("TemplateData", dateObj).data("TemplateMethod", "_getLocalFormatDateStr");
		},
		getLocalShortDate: function (dateObj) {
			if (!dateObj || !dateObj.isDate || !dateObj.hasValue)
				return $(this.getNoDateStr());
			return $((['<span class="', this.tplPrefix, 'ResShortDateFormat">', this._getLocalFormatDateStr(dateObj, "ResShortDateFormat"), "</span>"]).join("")).data("TemplateData", dateObj).data("TemplateMethod", "_getLocalFormatDateStr");
		},
		getLocalLongDate: function (dateObj) {
			if (!dateObj || !dateObj.isDate || !dateObj.hasValue)
				return $(this.getNoDateStr());
			return $((['<span class="', this.tplPrefix, 'ResDateFormat">', this._getLocalFormatDateStr(dateObj, "ResDateFormat"), "</span>"]).join("")).data("TemplateData", dateObj).data("TemplateMethod", "_getLocalFormatDateStr");
		},
		getLocalLongDateTime: function (dateObj) {
			if (!dateObj || !dateObj.isDate || !dateObj.hasValue)
				return $(this.getNoDateStr());
			return $((['<span class="', this.tplPrefix, 'ResLongDateTimeFormat">', this._getLocalFormatDateStr(dateObj, "ResLongDateTimeFormat"), "</span>"]).join("")).data("TemplateData", dateObj).data("TemplateMethod", "_getLocalFormatDateStr");
		},
		getLocalDateTime: function (dateObj, strId) {
			if (!dateObj || !dateObj.isDate || !dateObj.hasValue)
				return $(this.getNoDateStr());
			strId = strId || "ResDateTimeFormat";
			return $((['<span class="', this.tplPrefix, strId, '">', this._getLocalFormatDateStr(dateObj, strId), "</span>"]).join("")).data("TemplateData", dateObj).data("TemplateMethod", "_getLocalFormatDateStr");
		},
		getLocalUserName: function (user) {
			return $((['<span class="', this.tplPrefix, 'TemplateUserName">', this._getLocalUserNameStr(user), "</span>"]).join("")).data("TemplateData", user).data("TemplateMethod", "_getLocalUserNameStr");
		},
		getLocalDaysCount: function (num) {
			return $((['<span class="', this.tplPrefix, 'TemplateDaysCount">', this._getLocalDaysCountStr(num), "</span>"]).join("")).data("TemplateData", num).data("TemplateMethod", "_getLocalDaysCountStr");
		},
		prepareDateObj: function(dateObj){
			dateObj["WeekDayName"] = this.strings["ResDayName" + dateObj._weekDayId];
			dateObj["WeekDayShortName"] = this.strings["ResDayShortName" + dateObj._weekDayId];
			dateObj["DatePostfix"] = this.strings["ResDatePostfix" + (dateObj.DayNum % 10)];
			dateObj["MonthName"] = this.strings["ResMonth" + dateObj._monthId];
			dateObj["MonthDateName"] = this.strings["ResDateMonth" + dateObj._monthId];
			dateObj["MonthShortName"] = this.strings["ResShortMonth" + dateObj._monthId];
		},
		_getLocalFormatDateStr: function (dateObj, tplId) {
			this.prepareDateObj(dateObj);
			return this.strings[tplId] ? KL.Utils.StringHelper.formatTemplate(this.strings[tplId], dateObj) : tplId;
		},
		_getLocalDaysCountStr: function (data) {
			return (this.strings && this.strings["TemplateDaysCount"]) ? KL.Utils.StringHelper.format(this.strings["TemplateDaysCount"], data) : "TemplateDaysCount";
		},
		_getLocalUserNameStr: function (user) {
			return (this.strings && this.strings["TemplateUserName"]) ? KL.Utils.StringHelper.formatTemplate(this.strings["TemplateUserName"], { UserName: KL.Utils.StringHelper.cropString(user.UserName, 64) }) : "TemplateUserName";
		},
		getLocaleString: function (strId, showHint) {
			var val = this.getLocaleValueString(strId),
				hint = showHint===true?' title="' +("" + val).replace(/["\>\<]g/, "")+ '"' : "";
			return (['<span class="', this.eltPrefix, strId, '"',hint,' data-local-apply-title="',showHint===true?"true":"false",'">', val, "</span>"]).join("");
		},
		getKeyValue: function (strId) {
			return this.strings?this.strings[strId]:null;
		},
		getLocaleValueString: function (strId) {
			return ((this.strings && this.strings[strId]) ? this.strings[strId] : strId);
		},
		getLocaleValueFormatString: function (strId, args) {
			var data = Array.prototype.slice.call(arguments, 1);
			return this._getLocaleStringObjStr(data, strId);
		},
		getLocaleStringObj: function (strId, args) {
			var data = Array.prototype.slice.call(arguments, 1);
			return $(([
				'<span class="', this.tplPrefix, strId, '">', this._getLocaleStringObjStr(data, strId), "</span>"]).join("")
			).data("TemplateData", data).data("TemplateMethod", "_getLocaleStringObjStr");
		},
		getLocaleStringTemplateObj: function (strId, data) {
			return $('<span class="' + this.tplPrefix + strId + '">' + this._getLocaleStringTemplateObjStr(data, strId) + "</span>")
					.data("TemplateData", data).data("TemplateMethod", "_getLocaleStringTemplateObjStr");
		},
		getLocaleStringNumObj: function( strBase, num ){
			var data = Array.prototype.slice.call(arguments, 1);
			return $(([
				'<span class="', this.tplPrefix, strBase, '">', this._getLocaleStringNumObjStr(data, strBase), "</span>"]).join("")
			).data("TemplateData", data).data("TemplateMethod", "_getLocaleStringNumObjStr");
		},
		getLocaleStringNumTemplateObj: function( strBase, data, numField ){
			var dataObj = {dataObj: data, "numField": numField};
			return $(([
				'<span class="', this.tplPrefix, strBase, '">', this._getLocaleStringNumTplObjStr(dataObj, strBase), "</span>"]).join("")
			).data("TemplateData", dataObj).data("TemplateMethod", "_getLocaleStringNumTplObjStr");
		},
		_objsCache: {},
		makeLocaleStringObj: function (ctrlId, strId, args) {
			var data = ([ctrlId, "getLocaleStringObj"]).concat( Array.prototype.slice.call(arguments, 1) );
			return this._makeLocaleStringObj.apply(this, data);
		},
		makeLocaleStringTemplateObj: function (ctrlId, strId, args) {
			return this._makeLocaleStringObj(ctrlId, "getLocaleStringTemplateObj", strId, args);
		},
		makeLocaleStringNumObj: function (ctrlId, strId, num) {
			var data = ([ctrlId, "getLocaleStringNumObj"]).concat( Array.prototype.slice.call(arguments, 1) );
			return this._makeLocaleStringObj.apply(this, data);
		},
		makeLocaleStringNumTemplateObj: function (ctrlId, strId, args) {
			var data = ([ctrlId, "getLocaleStringNumTemplateObj"]).concat( Array.prototype.slice.call(arguments, 1) );
			return this._makeLocaleStringObj.apply(this, data);
		},
		_makeLocaleStringObj: function (ctrlId, methodName, strId, args) {
			var count = this._objsCache[ctrlId + "_count"] || 0;
			this._objsCache[ctrlId] = this._objsCache[ctrlId] || {};
			var data = Array.prototype.slice.call(arguments, 2);
			var dId = "id_" + ctrlId + "_localeStr" + count;
			this._objsCache[ctrlId][dId] = { methodName: methodName, data: data };
			this._objsCache[ctrlId + "_count"] = count + 1;
			return "<span class='" + dId + "'></span>";
		},
		applyStingObjs: function (ctrlId, ctrlElt) {
			var strs = this._objsCache[ctrlId];
			if (strs) {
				for (var strObjId in strs) {
					var elt = ctrlElt.find("." + strObjId),
						methodFn = this[strs[strObjId].methodName];
					if (elt.length > 0 && typeof(methodFn) == "function") {
						var elt_i = methodFn.apply(this, strs[strObjId].data);
						elt.replaceWith(function () { return elt_i.clone(true); });
						delete strs[strObjId];
					}
				}
				delete this._objsCache[ctrlId];
				delete this._objsCache[ctrlId + "_count"];
			}
		},
		_getLocaleStringObjStr: function (arrData, strId) {
			return (this.strings && this.strings[strId]) ? KL.Utils.StringHelper.format.apply(KL.Utils.StringHelper, [this.strings[strId]].concat(arrData)) : strId;
		},
		_getLocaleStringTemplateObjStr: function (dataObj, strId) {
			if(dataObj.isDate || dataObj.hasValue)
				this.prepareDateObj(dataObj);
			
			return (this.strings && this.strings[strId]) ? KL.Utils.StringHelper.formatTemplate(this.strings[strId], dataObj) : strId;
		},
		_getLocaleStringNumObjStr: function(data, strBase){
			var fn = getNumSufixRulesFn.call(this);
			var strId = strBase +"_" + fn.apply( this, data );
			return this._getLocaleStringObjStr( data, strId );
		},
		_getLocaleStringNumTplObjStr: function(data, strBase){
			var fn = getNumSufixRulesFn.call(this);
			var strId = strBase +"_" + fn.apply( this, ([]).concat(data.dataObj[data.numField]) );
			return this._getLocaleStringTemplateObjStr( data.dataObj, strId );
		}
	};
	Localization._inst = null;
	Localization.getInstance = function () {
		return this._inst;
	};
	KL.Utils.registerClass("Localization", Localization);
})();
;
(function () {
	var Localization = KL.Utils.Localization;
	var Exception = function (id, message) {
		var msg = Exception.getExceptionText(id);
		this.message = msg || message;
		this.number = id;
	};
	Exception.prototype = new Error();
	Exception.__class = true;
	Exception.ExceptionTypes = {
		"InternalServer"			: 0,
		"ServerStopped"				: 1,
		"SessionIdNotFound"			: 2,
		"Authentication"			: 3,
		"NoLicense"					: 4,
		"AccessDenied"				: 5,
		"ChangePassword"			: 6,
		"UnknownAction"				: 7,
		"DeletingDefaultGroup"		: 8,
		"GreateGroupDuplicateName"	: 9,
		"InvalidSettingsValue"		: 12,
		"DeliverMessage"			: 14,
		"InvalidLdapSettings"		: 15,
		"LdapScriptIsNotSet"		: 16,
		"DeliverMessageProhibited"	: 19,
		"ConfiguratorError"			: 20,
		"BinaryNotExist"			: 21,
		"StartFailed"				: 22,
		"TaskAlreadyStarted"		: 23,
		"TaskAlreadyStopped"		: 24,
		"WatchdogError"				: 25,
		"TaskNotExist"				: 26,
		"LicenseError"				: 27,
		"NoSchedule"				: 28,
		"NoNextStart"				: 29,
		"TaskDirCreateFailed"		: 30,
		"ConnRefused"				: 31, 
		"SystemError"				: 32, 
		"ScriptError"				: 33, 
		"AccountNotfound"			: 34, 
		"AuthDisabled"				: 35, 
		"LoginOrPasswordIncorrect"	: 36, 
		"LoginOrPasswordEmpty"		: 37, 
		"EntryNotFound"				: 38, 
		"EntryIdEmpty"				: 39, 
		"UnexpectedError"			: 40, 
		"ReportDirNoAccess"			: 41, 
		"PdfGenerationError"		: 42, 
		"FormatError"				: 43, 
		"GenericError"				: 44, 
		"RemoveError"				: 45, 
		"ReportNotExists"			: 46, 
		"IncorrectParams"			: 47, 
		"SendReportError"			: 48, 
		"UnexpectedShutdown"		: 49, 
		"ReportSaveError"			: 50, 
		"IllegalFileName"			: 51, 
		"ProhibitedAction"			: 1003, 
		"PasswordNotMatch"			: 1004, 
		"PasswordIsNotSet"			: 1005, 
		"NonASCIISymbolExists"		: 1006, 
		"NoThreeKindOfChars"		: 1007, 
		"StringTooShort"			: 1008, 
		"EmptyPassword"				: 1009, 
		"ResetWebHelpdeskPasswordFailed"	: 1011,
		"ImportProductVersionNotMutch"		: 1012,
		"UpdateTask_LicenseError"			: 1109,
		"HTTPInternalServerError"			: 500,
		"HTTPNotFoundError"					: 404,
		"UnknownActionHandler"				: 1002,
		"TaskIsRunning"						: 1105,
		"LdapSearchByStringError"			: 1203,
		"Auth_UserAlreadyExists"				: 1228,
		"Auth_LoginDoesNotMatchRequirements"	: 1230,
		"DbUnexpectedError"					: 1401,
		"DbDatabaseError"					: 1402,
		"DbNoBases"							: 1403,
		"SaveAppSettingsUexpectedError"		: 1501,
		"SaveAppSettingsInvalidSettingsError"	: 1511,
		
		"LicenseUnexpectedError"			: 1601,
		"LicenseNoKeyInstalled"				: 1602,
		"LicenseKeyBlacklisted"				: 1603,
		"LicenseKeyExpired"					: 1604,
		"LicenseKeyNotFound"				: 1605,
		"LicenseTrialPeriodOver"			: 1606,
		"LicenseBlacklistInvalid"			: 1607,
		"LicenseKeyInvalid"					: 1608,
		"LicenseKeyCorrupted"				: 1609,
		"LicenseKeyNoSupport"				: 1610,
		"LicenseKeyAlreadyInUse"			: 1611,
		"LicenseTrialAlreadyInUse"			: 1612,
		"LicenseCantBeUsedAsReserved"		: 1613,
		"LicenseCantRegMoreKeys"			: 1614,
		"LicenseCantRegBetaKey"				: 1615,
		"LicenseCantRegNonbetaKey"			: 1616,
		"LicenseCantRegSecondTrial"			: 1617,
		"LicenseCantRegInvalidReserve"		: 1618,
		"LicenseCantRegExpiredReserve"		: 1619,
		"LicenseCantRegExpiredNoncom"		: 1620,
		"LicenseInternalError"				: 1621, 
		"LicenseNotInitialized"				: 1622, 
		"LicenseSDataCorrupted"				: 1623, 
		"LicenseWriteSDataError"			: 1624, 
		"LicenseReadSDataError"				: 1625, 
		"LicenseKeyWrongProduct"			: 1626, 
		"LicenseKeyCreationDateInvalid"		: 1627, 
		"LicenseKeyInstallDateInvalid"		: 1628, 
		"LicenseSignatureInvalid"			: 1628, 
		"LicenseSignatureError"				: 1630, 
		"LicenseIllegalUpdate"				: 1631, 
		"LicenseInconsistentUpdate"			: 1632, 
		"LicenseConflictsWithCommercial"	: 1633, 
		"LicenseInvalidArgument"			: 1634, 
		"LicenseSubscrAsReservedError"		: 1635, 
		"Backup_UnexpectedError"			:1701, 
		"Backup_DatabaseError"				:1702, 
		"Backup_NoMessage"					:1703, 
		"Backup_BackupIsEmpty"				:1704, 
		"Backup_MessageAlreadyExist"		:1705, 
		"Backup_EmptyAccount"				:1706, 
		"Backup_NoPermissionToDeliver"		:1707, 
		"Backup_AvThreatsRestorationNotAllowed"	:1708, 
		"Backup_FileError"					:1709, 
		"Backup_FileWriteError"				:1710, 
		"Backup_OperationTimeout"			:1711, 
 		"Facade_HelpdeskBWAccessDisabled"	:1830, 
 		"Facade_HelpdeskAccountDisabled"	:1831, 
		"Facade_CorruptedSettingsArchive" 	:1832, 
		"Facade_CannotWriteVersionFile"		:1833, 
		"Facade_VersionFileReadError"		:1834, 
		"Facade_TempDirCreationFailed"		:1835 
	};
	
	var _errMsgsMap = {
			"InternalServer": "ErrorServerConnectionLost",
			"ServerStopped": "ErrorServerNotStarted",
			"SessionIdNotFound": "ErrorBadSID",
			"UnknownActionHandler": "ErrorUnknownActionHandler",
			"TaskIsRunning": "TaskIsRunning",
			
			"Authentication": "ErrorBadLogin",
			"NoLicense": "ErrorNoLicense",
			"AccessDenied": "ErrorAccessDenied",
			"ChangePassword": "ErrorChangePassword",
			"UnknownAction": "ErrorUnknownAction",
			"HTTPInternalServerError": "ErrorHTTPInternalServer",
			"DeletingDefaultGroup": "ErrorDeletingDefaultGroup",
			"GreateGroupDuplicateName": "ErrorGreateGroupDuplicateName",
			"InvalidSettingsValue": "ErrorInvalidSettingsValue",
			"InvalidLdapSettings": "ErrorInvalidLdapSettings",
			"LdapScriptIsNotSet": "ErrorLdapScriptIsNotSet",
			"SystemError":	"Error",
			"ConfiguratorError": "ErrorConfiguratorError",
			"BinaryNotExist": "ErrorBinaryNotExist",
			"StartFailed": "ErrorStartFailed",
			"TaskAlreadyStarted": "ErrorTaskAlreadyStarted",
			"TaskAlreadyStopped": "ErrorTaskAlreadyStopped",
			"WatchdogError": "ErrorWatchdogError",
			"TaskNotExist": "ErrorTaskNotExist",
			"LicenseError": "ErrorLicenseError",
			"NoSchedule": "ErrorNoSchedule",
			"NoNextStart": "ErrorNoNextStart",
			"TaskDirCreateFailed": "ErrorTaskDirCreateFailed",
			"ConnRefused": "ErrorConnRefused",
			"SystemError": "ErrorSystemError",
			"ScriptError": "ErrorScriptError",
			"AccountNotfound": "ErrorAccountNotfound",
			"AuthDisabled": "ErrorAuthDisabled",
			"LoginOrPasswordIncorrect": "ErrorLoginOrPasswordIncorrect",
			"LoginOrPasswordEmpty": "ErrorLoginOrPasswordEmpty",
			"EntryNotFound": "ErrorEntryNotFound",
			"EntryIdEmpty": "ErrorEntryIdEmpty",
			"ProhibitedAction": "ErrorProhibitedAction",
			"DeliverMessage" :"ErrorProhibitedAction",
			"DeliverMessageProhibited":"ErrorDeliverMessageProhibited",
			"PasswordNotMatch": "ErrorPasswordNotMatch",
			"PasswordIsNotSet": "ErrorPasswordIsNotSet",
			"NonASCIISymbolExist": "ErrorNonASCIISymbolExists",
			"NoThreeKindOfChars": "ErrorNoThreeKindOfChars",
			"StringTooShort": "ErrorStringTooShort",
			"EmptyPassword": "ErrorEmptyPassword",
			"DbUnexpectedError": "ErrorDbUnexpected",
			"DbDatabaseError": "ErrorDbDatabase",
			"DbNoBases": "ErrorDbNoBases",
			"LdapSearchByStringError"			: "ErrorLdapSearchFailed",
			"Auth_LoginDoesNotMatchRequirements": "ErrorLoginDoesNotMatchRequirements",
			"SaveAppSettingsInvalidSettingsError": "ErrorSaveAppSettingsInvalidSettings",
			"LicenseUnexpectedError"			: "ErrorLicenseUnexpectedErr",
			"LicenseNoKeyInstalled"				: "ErrorLicenseNoKeyInstalled",
			"LicenseKeyBlacklisted"				: "ErrorLicenseKeyBlacklisted",
			"LicenseKeyExpired"					: "ErrorLicenseKeyExpired",
			"LicenseKeyNotFound"				: "ErrorLicenseKeyNotFound",
			"LicenseTrialPeriodOver"			: "ErrorLicenseTrialPeriodOver",
			"LicenseBlacklistInvalid"			: "ErrorLicenseBlacklistInvalid",
			"LicenseKeyInvalid"					: "ErrorLicenseKeyInvalid",
			"LicenseKeyCorrupted"				: "ErrorLicenseKeyCorrupted",
			"LicenseKeyNoSupport"				: "ErrorLicenseKeyNoSupport",
			"LicenseKeyAlreadyInUse"			: "ErrorLicenseKeyAlreadyInUse",
			"LicenseTrialAlreadyInUse"			: "ErrorLicenseTrialAlreadyInUse",
			"LicenseCantBeUsedAsReserved"		: "ErrorLicenseCantBeUsedAsReserved",
			"LicenseCantRegMoreKeys"			: "ErrorLicenseCantRegMoreKeys",
			"LicenseCantRegBetaKey"				: "ErrorLicenseCantRegBetaKey",
			"LicenseCantRegNonbetaKey"			: "ErrorLicenseCantRegNonbetaKey",
			"LicenseCantRegSecondTrial"			: "ErrorLicenseCantRegSecondTrial",
			"LicenseCantRegInvalidReserve"		: "ErrorLicenseCantRegInvalidReserve",
			"LicenseCantRegExpiredReserve"		: "ErrorLicenseCantRegExpiredReserve",
			"LicenseCantRegExpiredNoncom"		: "ErrorLicenseCantRegExpiredNoncom",
			"LicenseInternalError"				: "ErrorLicenseInternal", 
			"LicenseNotInitialized"				: "ErrorLicenseNotInitialized", 
			"LicenseSDataCorrupted"				: "ErrorLicenseSDataCorrupted", 
			"LicenseWriteSDataError"			: "ErrorLicenseWriteSData", 
			"LicenseReadSDataError"				: "ErrorLicenseReadSData", 
			"LicenseKeyWrongProduct"			: "ErrorLicenseKeyWrongProduct", 
			"LicenseKeyCreationDateInvalid"		: "ErrorLicenseKeyCreationDateInvalid", 
			"LicenseKeyInstallDateInvalid"		: "ErrorLicenseKeyInstallDateInvalid", 
			"LicenseSignatureInvalid"			: "ErrorLicenseSignatureInvalid", 
			"LicenseSignatureError"				: "ErrorLicenseSignature", 
			"LicenseIllegalUpdate"				: "ErrorLicenseIllegalUpdate", 
			"LicenseInconsistentUpdate"			: "ErrorLicenseInconsistentUpdate", 
			"LicenseConflictsWithCommercial"	: "ErrorLicenseConflictsWithCommercial", 
			"LicenseInvalidArgument"			: "ErrorLicenseInvalidArgument", 
			"LicenseSubscrAsReservedError"		: "ErrorLicenseSubscrAsReserved", 
			"UpdateTask_LicenseError"				:"Error_StartUpdate_License",
			"Backup_UnexpectedError"				:"ErrorBackup_UnexpectedError",
			"Backup_DatabaseError"					:"ErrorBackup_DatabaseError",
			"Backup_NoMessage"						:"ErrorBackup_NoMessage",
			"Backup_BackupIsEmpty"					:"ErorrBackup_BackupIsEmpty",
			"Backup_MessageAlreadyExist"			:"ErrorBackup_MessageAlreadyExist",
			"Backup_EmptyAccount"					:"ErrorBackup_EmptyAccount",
			"Backup_NoPermissionToDeliver"			:"ErrorBackup_NoPermissionToDeliver",
			"Backup_AvThreatsRestorationNotAllowed"	:"ErrorDeliverMessageProhibited",//:"ErrorBackup_AvThreatsRestorationNotAllowed",
			"Backup_FileError"						:"ErrorBackup_FileError",
			"ImportProductVersionNotMutch"			:"ErrorImportProductVersionNotMutch",
			"ResetWebHelpdeskPasswordFailed"		:"ErrorResetWebHelpdeskPasswordFailed"
	};
	Exception.getExceptionText = function (exceptionId) {
		var str = "";
		var type = Exception.ExceptionTypes.getKeyByValue(exceptionId);
		if (type && _errMsgsMap[type]) {
			str = _errMsgsMap[type];
			if (Localization.getInstance().stringExists(str))
				str = Localization.getInstance().getLocaleString(str);
		}
		return str;
	};
	KL.Utils.registerEnum("Exception.ExceptionTypes", Exception.ExceptionTypes, false, true);
	KL.Utils.registerClass("Exception", Exception);
})();
;
(function () {
	var JSON = {
		encode: function (data) {
			var Log = KL.Utils.Log;
			var str = data;
			if (data === null) {
				str = "null";
			} else if (typeof (data) == "function") {
				str = "null";
			} else if (typeof (data) == "undefined") {
				str = "";
			} else if (data instanceof Array) {
				str = this._encodeArray(data);
			} else if (parseFloat(data) === parseFloat(data) && parseFloat(data).toString() === data) {
				str = data;
			} else if (typeof (data) == "string" || data instanceof String) {
				str = '"' + KL.Utils.StringHelper.addSlashes(data) + '"';
			} else if (typeof (data) == "boolean" || data instanceof Boolean) {
				str = !!data ? "true" : "false";
			} else if (typeof (data) == "object") {
				str = this._encodeObj(data);
			}
			return str;
		},
		decode: function (str) {
			var obj = null;
			try {
				obj = eval("(" + str + ")");
			} catch (e) { }
			return obj;
		},
		_encodeArray: function (data) {
			var str = [];
			for (var i = 0, l = data.length; i < l; i++) {
				if (typeof (data[i]) != "function" && typeof (data[i]) != "undefined")
					str.push(this.encode(data[i]));
			}
			return "[" + str.join(",") + "]";
		},
		_encodeObj: function (data) {
			var str = [];
			for (var param in data) {
				if (typeof (data[param]) != "function" && typeof (data[param]) != "undefined")
					str.push('"' + param + '":' + this.encode(data[param]));
			}
			return "{" + str.join(",") + "}";
		}
	};
	KL.Utils.registerClass("JSON", JSON);
})()
;
(function () {
	var StringHelper = KL.Utils.StringHelper;
	var Template = function (tplStr) {
		this.templateString = tplStr;
	};
	Template.prototype = {
		
		loadComplete: null,
		loadError: null,
		templateString: "",
		headerTemplate: "",
		footerTemplate: "",
		bindData: function (obj) {
			var strOut = ""; //;
			if (obj instanceof Array) {
				strOut = [];
				for (var i = 0, l = obj.length; i < l; i++) {
					$(this).trigger("onitemdatabind", [obj[i]]);
					strOut.push(StringHelper.formatTemplate(this.templateString, obj[i]));
				}
				strOut = strOut.join("");
			} else {
				strOut = StringHelper.formatTemplate(this.templateString, obj);
			}
			$(this).trigger("ondatabound", [strOut]);
			return strOut;
		}
	};
	Template.__class = true;
	KL.Utils.registerClass("Template", Template);
})()
;
(function () {
	var Localization = KL.Utils.Localization;
	var DateTime = function (d) {
		if (d != null)
			this._create(d);
	};
	DateTime._objsCount = 0;
	DateTime.prototype = {
		isDate: true,
		hasValue: false,
		Time: 0,
		_id: "",
		DayNum: 1,
		Day: "01",
		DatePostfix: "",
		_weekDayId: "",
		WeekDayNum: 1,
		WeekDay: "01",
		WeekDayName: "",
		WeekDayShortName: "",
		_monthId: "",
		MonthNum: 1,
		Month: "01",
		MonthName: "",
		MonthDateName: "",
		MonthShortName: "",
		Year: "1970",
		YearNum: "70",
		HoursNum: 0,
		Hours: "00",
		Hours12Num: 12,
		Hours12: "12",
		MeridiemSign: "am",
		MinutesNum: 0,
		Minutes: "00",
		SecondsNum: 0,
		Seconds: "00",
		TzAbbr: "GMT",
		TzOffset: "0000",
		TzOffsetNum: "0000",
		_create: function (date) {
			this.hasValue = typeof (date) != "undefined" && date != null && (date instanceof Date);
			this.Time = (new Date()).getTime();
			this._id = this.Time + "" + DateTime._objsCount;
			if (this.hasValue) {
				this._id = date.getTime() + "" + DateTime._objsCount;
				this.setDay(date.getDate(), date.getDay());
				this.setMonth(date.getMonth());
				this.setYear(date.getFullYear());
				this.setHours(date.getHours());
				this.setMinutes(date.getMinutes());
				this.setSeconds(date.getSeconds());
				this.setTimezoneName( "GMT" );
				this.setTimezoneOffset( -date.getTimezoneOffset()*60 );
				this.Time = date.getTime();
			}
			DateTime._objsCount++;
		},
		setDay: function (day, weekDay) {
			this.DayNum = day;
			this.Day = ("00" + day).slice(-2);
			this.DatePostfix = "";
			if (typeof weekDay != "undefined" && weekDay !== null && !isNaN(weekDay)) {
				this._weekDayId = DateHelper.DaysEnum[weekDay];
				this.WeekDayNum = weekDay + 1;
				this.WeekDay = ("00" + this.WeekDayNum).slice(-2);
				this.WeekDayName = "";
				this.WeekDayShortName = "";
			}
		},
		setMonth: function (month) {
			this._monthId = DateHelper.MonthsEnum[month];
			this.MonthNum = month + 1;
			this.Month = ("00" + this.MonthNum).slice(-2);
			this.MonthName = "";
			this.MonthDateName = "";
			this.MonthShortName = "";
		},
		setYear: function (year) {
			this.Year = year;
			this.YearNum = ("00" + this.Year).slice(-2);
		},
		setHours: function (hours) {
			this.HoursNum = hours;
			this.Hours = ("00" + this.HoursNum).slice(-2);
			this.Hours12Num = this.HoursNum > 12 ? this.HoursNum - 12 : (this.HoursNum == 0 ? 12 : this.HoursNum);
			this.Hours12 = ("00" + this.HoursUTCNum).slice(-2);
			this.MeridiemSign = this.HoursNum >= 12 ? "pm" : "am";
		},
		setMinutes: function (minutes) {
			this.MinutesNum = minutes;
			this.Minutes = ("00" + this.MinutesNum).slice(-2);
		},
		setSeconds: function (seconds) {
			this.SecondsNum = seconds;
			this.Seconds = ("00" + this.SecondsNum).slice(-2);
		},
		setTimezoneName: function( tzName ){
			this.TzAbbr = tzName;
		},
		setTimezoneOffset: function( offset ){
			var num = offset/(60*60)
			this.TzOffsetNum = num;
			this.TzOffset = (num>0?"+":"-") + ("0000" + (Math.floor(Math.abs(num))*100 + (60*(num%1).toFixed())) ).slice(-4);
		}
	};
	var serverTime = null,
		localTime = null;
	var DateHelper = {
		_localeDates: {},
		DiffApproximations: { Seconds: 4, Minutes: 3, Hours: 2, Days: 1, Years: 0 },
		MonthsEnum: ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"],
		DaysEnum: ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"],
		isServerTimeSet: function(){
			return !!serverTime;
		},
		setServerTime: function(time){
			localTime = new Date();
			serverTime = time;
		},
		dateDiffToServer: function(date, approximation, diffSeparator){
			var st = new Date();
			if( serverTime )
				st = this.dateFromUTC( serverTime.time );
			return this.dateDiff( date, st, approximation, diffSeparator );
		},
		getServerTime: function(){
			return this.toServerTime(null);
		},
		toServerTime: function(timestamp){
			var d = new Date(),
				st = new Date();
			localTime = localTime || new Date();
			if( !serverTime )
				serverTime = { time: d.getTime()/1000, tz: { tzAbbr: "GMT", tzOffset: -d.getTimezoneOffset()*60 } };
			
			if( timestamp )
				st = this.dateFromUTC( timestamp );
			else
				st = this.dateFromUTC( serverTime.time + (new Date() - localTime)/1000 );
			st.setTime( st.getTime() + d.getTimezoneOffset()*60*1000 + serverTime.tz.tzOffset*1000 );
			return st;
		},
		getWeekdayName: function (wdayNum) {
			return KL.Utils.Localization.getInstance().getLocaleString("ResDayName" + this.DaysEnum[wdayNum] || this.DaysEnum[0]);
		},
		getWeekdayNameShort: function (wdayNum) {
			return KL.Utils.Localization.getInstance().getLocaleString("ResDayShortName" + this.DaysEnum[wdayNum] || this.DaysEnum[0]);
		},
		dateDiff: function (date1, date2, approximation, diffSeparator) {
			approximation = typeof (approximation) == "undefined" ? this.DiffApproximations.Seconds : approximation;
			var strOut = [],
				localization = Localization.getInstance();
			
			var diffText = [
				localization.getLocaleString("ResDateDiffYears"),
				localization.getLocaleString("ResDateDiffDays"),
				localization.getLocaleString("ResDateDiffHours"),
				localization.getLocaleString("ResDateDiffMinutes"),
				localization.getLocaleString("ResDateDiffSeconds")
			];
			var diffProps = ["years","days","hours","min","sec"];
			
			var dd = this.dateDiffNum(date1, date2);
			for (var i = 0, l = diffText.length; i < l; i++) {
				var val_i = dd[diffProps[i]];
				if ( val_i!= 0 && i <= approximation)
					strOut.push(val_i + "" + diffText[i]);
			}
			return strOut.join(diffSeparator||", ");
		},
		dateDiffNum: function(date1, date2){
			var d = new Date();
			var diff = Math.floor(Math.abs((date1 || d).getTime() - (date2 || d).getTime()) / 1000);
			var dd = { sec: 0, min: 0, hours: 0, days: 0, years: 0 };
			
			dd.sec = diff % 60; //seconds;
			diff = Math.floor(diff / 60);
			dd.min = [diff % 60]; //minutes;
			diff = Math.floor(diff / 60);
			dd.hours = diff % 24; //hours;
			diff = Math.floor(diff / 24);
			dd.days = diff % 365; //Days;
			dd.years = Math.floor(diff / 365); //Years;
			return dd;
		},
		dateFromUTC: function (intUnixTimeStamp) {
			var d = null;
			if (intUnixTimeStamp > 0) {
				d = new Date();
				var utc = new Date();
				var timeStamp = (intUnixTimeStamp * 1000);// - d.getTimezoneOffset() * 60000;
				utc.setTime(timeStamp);
				d.setTime(timeStamp);
				
				
			}
			return d;
		},
		createDate: function (intUnixTimeStamp) {
			var d = this.dateFromUTC(intUnixTimeStamp);
			return this.getDateTimeObj(d);
		},
		createGMTDate: function (intUnixTimeStamp) {
			var d = new Date();
			var offset = d.getTimezoneOffset();
			var timeStamp = intUnixTimeStamp * 1000 + offset  * 60000;
			d.setTime(timeStamp);
			var offset1 = d.getTimezoneOffset();
			if (offset!=offset1) {
				timeStamp = intUnixTimeStamp * 1000 + offset1  * 60000;
				d.setTime(timeStamp);
			}	
			return this.getDateTimeObj(d);
		},
		getDateTimeObj: function (date) {
			var dateobj = new DateTime(date || null);
			this._objsCount++;
			return dateobj;
		},
		getGMTDate: function (ctrlId, intUnixTimeStamp, strId) {
			var count = this._localeDates[ctrlId + "_count"] || 0;
			this._localeDates[ctrlId] = this._localeDates[ctrlId] || {};
			var dId = "id_" + ctrlId + "_date" + count;
			this._localeDates[ctrlId][dId] = Localization.getInstance()
					.getLocalDateTime(this.createGMTDate(intUnixTimeStamp), strId);
			this._localeDates[ctrlId + "_count"] = count + 1;
			return "<span class='" + dId + "'></span>";
		},
		getLocaleDate: function (ctrlId, intUnixTimeStamp, strId) {
			var count = this._localeDates[ctrlId + "_count"] || 0;
			this._localeDates[ctrlId] = this._localeDates[ctrlId] || {};
			var dId = "id_" + ctrlId + "_date" + count;
			this._localeDates[ctrlId][dId] = Localization.getInstance()
					.getLocalDateTime(this.createDate(intUnixTimeStamp), strId);
			this._localeDates[ctrlId + "_count"] = count + 1;
			return "<span class='" + dId + "'></span>";
		},
		applyLocaleDates: function (ctrlId, ctrlElt) {
			var dates = this._localeDates[ctrlId];
			for (var dateId in dates) {
				var elt = ctrlElt.find("." + dateId);
				if (elt.length > 0) {
					elt.replaceWith(function () { return dates[dateId].clone(true); });
					delete dates[dateId];
				}
			}
			delete this._localeDates[ctrlId + "_count"];
		}
	};
	KL.Utils.registerClass("DateHelper", DateHelper);
})()
;
(function () {
	var PageHash = function () {
		this._hash = {};
	};
	PageHash.prototype = {
		
		_hash: null,
		_timer: null,
		setParam: function (key, val) {
			this._hash[key] = val;
			if (typeof (val) == "undefined" || val === null)
				delete this._hash[key];
			var hash = [];
			for (var param in this._hash) {
				if (this._hash.hasOwnProperty(param) && typeof (this._hash[param]) != "undefined")
					hash.push(param + "=" + this._hash[param]);
			}
			window.location.hash = hash.join("|");
		},
		resetParams: function () {
			this._hash = {};
			window.location.hash = "";
		},
		getParamValue: function (key) {
			if (!!this._hash)
				return this._hash[key];
			return null;
		},
		loadHash: function () {
			if (this._timer)
				window.clearTimeout(this._timer);
			var hash = this._parseParams(window.location.hash);
			this._mergeHash(hash);
			try{
				this._timer = window.setTimeout(KL.Utils.Delegate.create(this, this.loadHash), 200);
			} catch (e) { }
		},
		destroy: function () {
			if (this._timer)
				window.clearTimeout(this._timer);
		},
		_mergeHash: function (hash) {
			for (var param in hash)
				this._mergeParam(param, $.trim(hash[param]));
			this._hash = hash;
		},
		_mergeParam: function (paramName, value) {
			if (!this._hash.hasOwnProperty(paramName) || typeof (this._hash[paramName]) == "undefined" || this._hash[paramName] != value) {
				this._fireChangeEvent(paramName, value);
				delete this._hash[paramName];
			}
		},
		_parseParams: function (paramsStr) {
			var _url = paramsStr;
			try {
				_url = decodeURIComponent(_url);
			} catch (e) { }
			var commands = _url.replace("#", "").split("|");
			var curr_hash = {};
			for (var ci = 0, cl = commands.length; ci < cl; ci++) {
				var objSplited = commands[ci].split("=");
				if (objSplited.length > 1)
					curr_hash[$.trim(objSplited[0])] = $.trim(objSplited[1]);
			}
			return curr_hash;
		},
		_fireChangeEvent: function (paramName, value) {
			var evtName = "on" + paramName + "change";
			$(this).trigger(evtName, [value]);
		}
	};
	PageHash.create = function (app) {
		var inst = new PageHash();
		inst.loadHash();
		return inst;
	};
	KL.Utils.registerClass("PageHash", PageHash);
})()
;
(function () {
	var ObjectHelper = {
		setObjValueByPath: function (obj, xpath, val) {
			var paths = xpath.split(".");
			var o = obj;
			for (var i = 0, l = paths.length - 1; i < l; i++) {
				if (typeof (o[paths[i]]) == "undefined")
					o[paths[i]] = {};
				o = o[paths[i]];
			}
			var paramName = paths.pop();
			o[paramName] = val;
		},
		getObjValueByPath: function (obj, xpath) {
			var paths = xpath.split(".");
			var o = obj;
			for (var i = 0, l = paths.length; i < l; i++) {
				if (typeof (o[paths[i]]) == "undefined")
					return null;
				o = o[paths[i]];
			}
			return o;
		},
		testVersions: function(ver1, ver2){
			ver1 = $.trim(ver1);
			ver2 = $.trim(ver2);
			var isOk = (ver1 == ver2);
			if( !isOk ){
				var verUp = null;
				var verCurr = null;
				if( ver1.indexOf("+") != -1 ){
					verUp = ver1.replace("+", "").split( /[^\d]/g );
					verCurr = ver2.split( /[^\d]/g );
				}else if( ver2.indexOf("+") != -1 ){
					verUp = ver2.replace("+", "").split( /[^\d]/g );
					verCurr = ver1.split( /[^\d]/g );
				}
				if( verUp != null ){
					var isEqual;
					for( var i=0, l= Math.max(verUp.length, verCurr.length ); i<l; i++){
						isEqual = false;
						var curr_i = ((verCurr[i]||0)*1);
						var up_i = ((verUp[i]||0)*1);
						isOk = curr_i > up_i;
						if( isOk || (curr_i < up_i) )
							 break;
						isEqual = true;
					}
					isOk = isOk || isEqual;
				}
			}
			return isOk;
		},
		getListLength: function (val) {
			if (val instanceof Array)
				return val.length;
			return 0;
		},
		mapValues: function (obj, map, data) {
			for (var i = 0, l = map.length; i < l; i++)
				this._setMappingValue(data, map[i], obj);
		},
		_setMappingValue: function (data, mapItem, obj) {
			if (!mapItem || !mapItem.elt)
				return;
			var elt = obj.getFormElement(mapItem.elt);
			if (!!elt && !!mapItem["datasource"]) {
				if (mapItem.get !== null) {
					var val = this.getObjValueByPath(data, mapItem.datasource);
					if (mapItem.get && typeof (obj[mapItem.get]) == "function")
						obj[mapItem.get](data, elt, val);
					else
						elt.val(val);
					elt.data("default-value", val);
				}
			}
		},
		arrRemove: function (arr, n) {
			return arr.slice(0, n).concat(arr.slice((n >= 0 ? n : arr.length + n) + 1));
		}
	};
	KL.Utils.registerClass("ObjectHelper", ObjectHelper);
})()
;
(function () {
	var UserHelper = {
		isAllowed: function(userTypeCode){
			var UserTypes = KL.Utils.UserTypes,
				context = KL.Web.Application.getContext(),
				currUserType = context.getData(KL.Web.Context.DataTypes.UserType) || UserTypes.User,
				map = {"always": currUserType, "admin": UserTypes.Admin, "user": UserTypes.User, "helpdesk": UserTypes.HelpDesk, "bwlistviewer": null },
				codes = (""+userTypeCode||"").toLowerCase().split(/[,]/gi),
				allowed = !userTypeCode;
			for( var i=0, l=codes.length; i<l && !allowed; i++ ){
				if( map[codes[i]] === null ){
					var appSettings = context.getAppSettings();
					allowed = allowed || ( currUserType == UserTypes.HelpDesk && appSettings && appSettings.helpdeskSettings && !!appSettings.helpdeskSettings.accessBlackWhiteList );
				} else
					allowed = allowed || (currUserType == map[codes[i]]);
			}
			return allowed;
		},
		isAdmin: function(){
			return KL.Web.Application.getContext().getData(KL.Web.Context.DataTypes.UserType) == KL.Utils.UserTypes.Admin;
		},
		isPriveleged: function(){
			return KL.Web.Application.getContext().getData(KL.Web.Context.DataTypes.UserType) !== KL.Utils.UserTypes.User;
		},
		getUserGreeting: function (text, ctrlId) {
			var ctx = KL.Web.Application.getContext();
			var txt = text;
			if (ctx !== null) {
				var localization = KL.Utils.Localization.getInstance();
				txt = ctx.getData(KL.Web.Context.DataTypes.UserName);
				if (localization.stringExists(text))
					txt = localization.makeLocaleStringObj(ctrlId, text, txt);
			}
			return txt;
		},
		getHelpDeskUserName: function(val, ctrlId, data, fieldName){
			var userName = "";
			if(data && data.items && data.items.length > 0){
				for(var i=0, l=data.items.length; i<l; i++){
					if( data.items[i].permissionType == KL.Utils.UserTypes.HelpDesk )
						userName = data.items[i].accountName;
				}
			}
			return userName;
		}
	};
	KL.Utils.registerClass("UserHelper", UserHelper);
})()
;
(function () {
	var UserTypes = {
		"Admin": 1,
		"User": 2,
		"HelpDesk": 3
	};
	KL.Utils.registerEnum("UserTypes", UserTypes);
})()
;
(function(){
	var CRC32 = {
		generate: function (str) {
			function encodeUtf8(argString) {
				var string = (argString + '');
				var utftext = "";
				var start, end;
				var stringl = 0;
				start = end = 0;
				stringl = string.length;
				for (var n = 0; n < stringl; n++) {
					var c1 = string.charCodeAt(n);
					var enc = null;
					if (c1 < 128) {
						end++;
					} else if (c1 > 127 && c1 < 2048) {
						enc = String.fromCharCode((c1 >> 6) | 192) + String.fromCharCode((c1 & 63) | 128);
					} else {
						enc = String.fromCharCode((c1 >> 12) | 224) + String.fromCharCode(((c1 >> 6) & 63) | 128) + String.fromCharCode((c1 & 63) | 128);
					}
					if (enc !== null) {
						if (end > start) {
							utftext += string.substring(start, end);
						}
						utftext += enc;
						start = end = n + 1;
					}
				}
				if (end > start) {
					utftext += string.substring(start, string.length);
				}
				return utftext;
			}
			function Hex32(val) {
				var n;
				var str1;
				var str2;
				n = val & 0xFFFF;
				str1 = n.toString(16).toUpperCase();
				while (str1.length < 4) {
					str1 = "0" + str1;
				}
				n = (val >>> 16) & 0xFFFF;
				str2 = n.toString(16).toUpperCase();
				while (str2.length < 4) {
					str2 = "0" + str2;
				}
				return str2 + str1;
			}
			str = encodeUtf8(str);
			var table = "00000000 77073096 EE0E612C 990951BA 076DC419 706AF48F E963A535 9E6495A3 0EDB8832 79DCB8A4 E0D5E91E 97D2D988 09B64C2B 7EB17CBD E7B82D07 90BF1D91 1DB71064 6AB020F2 F3B97148 84BE41DE 1ADAD47D 6DDDE4EB F4D4B551 83D385C7 136C9856 646BA8C0 FD62F97A 8A65C9EC 14015C4F 63066CD9 FA0F3D63 8D080DF5 3B6E20C8 4C69105E D56041E4 A2677172 3C03E4D1 4B04D447 D20D85FD A50AB56B 35B5A8FA 42B2986C DBBBC9D6 ACBCF940 32D86CE3 45DF5C75 DCD60DCF ABD13D59 26D930AC 51DE003A C8D75180 BFD06116 21B4F4B5 56B3C423 CFBA9599 B8BDA50F 2802B89E 5F058808 C60CD9B2 B10BE924 2F6F7C87 58684C11 C1611DAB B6662D3D 76DC4190 01DB7106 98D220BC EFD5102A 71B18589 06B6B51F 9FBFE4A5 E8B8D433 7807C9A2 0F00F934 9609A88E E10E9818 7F6A0DBB 086D3D2D 91646C97 E6635C01 6B6B51F4 1C6C6162 856530D8 F262004E 6C0695ED 1B01A57B 8208F4C1 F50FC457 65B0D9C6 12B7E950 8BBEB8EA FCB9887C 62DD1DDF 15DA2D49 8CD37CF3 FBD44C65 4DB26158 3AB551CE A3BC0074 D4BB30E2 4ADFA541 3DD895D7 A4D1C46D D3D6F4FB 4369E96A 346ED9FC AD678846 DA60B8D0 44042D73 33031DE5 AA0A4C5F DD0D7CC9 5005713C 270241AA BE0B1010 C90C2086 5768B525 206F85B3 B966D409 CE61E49F 5EDEF90E 29D9C998 B0D09822 C7D7A8B4 59B33D17 2EB40D81 B7BD5C3B C0BA6CAD EDB88320 9ABFB3B6 03B6E20C 74B1D29A EAD54739 9DD277AF 04DB2615 73DC1683 E3630B12 94643B84 0D6D6A3E 7A6A5AA8 E40ECF0B 9309FF9D 0A00AE27 7D079EB1 F00F9344 8708A3D2 1E01F268 6906C2FE F762575D 806567CB 196C3671 6E6B06E7 FED41B76 89D32BE0 10DA7A5A 67DD4ACC F9B9DF6F 8EBEEFF9 17B7BE43 60B08ED5 D6D6A3E8 A1D1937E 38D8C2C4 4FDFF252 D1BB67F1 A6BC5767 3FB506DD 48B2364B D80D2BDA AF0A1B4C 36034AF6 41047A60 DF60EFC3 A867DF55 316E8EEF 4669BE79 CB61B38C BC66831A 256FD2A0 5268E236 CC0C7795 BB0B4703 220216B9 5505262F C5BA3BBE B2BD0B28 2BB45A92 5CB36A04 C2D7FFA7 B5D0CF31 2CD99E8B 5BDEAE1D 9B64C2B0 EC63F226 756AA39C 026D930A 9C0906A9 EB0E363F 72076785 05005713 95BF4A82 E2B87A14 7BB12BAE 0CB61B38 92D28E9B E5D5BE0D 7CDCEFB7 0BDBDF21 86D3D2D4 F1D4E242 68DDB3F8 1FDA836E 81BE16CD F6B9265B 6FB077E1 18B74777 88085AE6 FF0F6A70 66063BCA 11010B5C 8F659EFF F862AE69 616BFFD3 166CCF45 A00AE278 D70DD2EE 4E048354 3903B3C2 A7672661 D06016F7 4969474D 3E6E77DB AED16A4A D9D65ADC 40DF0B66 37D83BF0 A9BCAE53 DEBB9EC5 47B2CF7F 30B5FFE9 BDBDF21C CABAC28A 53B39330 24B4A3A6 BAD03605 CDD70693 54DE5729 23D967BF B3667A2E C4614AB8 5D681B02 2A6F2B94 B40BBE37 C30C8EA1 5A05DF1B 2D02EF8D";
			var crc = 0;
			var x = 0;
			var y = 0;
			crc = crc ^ (-1);
			for (var i = 0; i < str.length; i++) {
				y = (crc ^ str.charCodeAt(i)) & 0xFF;
				x = "0x" + table.substr(y * 9, 8);
				crc = (crc >>> 8) ^ x;
			}
			crc = crc ^ (-1);
			return Hex32(crc);
		}
	};
	KL.Utils.registerClass("CRC32", CRC32);
})()
;
(function () {
	var TooltipHelper = {
		makeTooltips: function(triggers, ctrl, elt){
			var tips = [];
			triggers.each(function () {
				var tip = "." + $(this).attr("rel");
				tips.push(tip);
				$(this).tooltip({
					offset: [-10, 0],
					tip: tip,
					onBeforeShow: function () { $(tip).detach().appendTo($(document.body)); }
				});
			});
			elt.find(".tooltip").hide();
			
			$(ctrl).bind("onbeforehide", function(){
				for( var i=0, l=tips.length; i<l; i++ )
					$( tips[i] ).remove();
			});
		}
	};
	KL.Utils.registerClass("TooltipHelper", TooltipHelper);
})();
;
(function(){
	function Loader(ctrl, elt){
		this._elt = $('<div class="loaderWrap"><div class="loader"></div></div>').appendTo($(".pageWrap"));
		this._ctrl = ctrl;
		window.setTimeout(KL.Utils.Delegate.create( this, this._init, elt ), 100);
	}
	Loader.prototype = {
		_showTimer: null,
		_ajustTimer: null,
		_hideTimer: null,
		_elt: null,
		_ctrl: null,
		_ctrlElt: null,
		show: function(){
			if (this._hideTimer)
				window.clearTimeout(this._hideTimer);
			if (this._ajustTimer)
				window.clearInterval(this._ajustTimer);
			if( this._showTimer )
				window.clearTimeout(this._showTimer);
			this._showTimer = null;
			
			this._ajustTimer = null;
			this._ajustTimer = window.setInterval(KL.Utils.Delegate.create( this, this._ajust ), 500);
		},
		hide: function(force){
			if( this._showTimer )
				window.clearTimeout(this._showTimer);
			this._showTimer = null;
			if( force )
				this._remove();
			else
				this._hideTimer = window.setTimeout(KL.Utils.Delegate.create(this, this._remove), 500);
		},
		_init: function(elt){
			if( elt && this._elt && "length" in elt ){
				var zIndx = 0;
				var elt1 = elt[0];
				
				while( elt1 && elt1 != document.body ){
					zIndx += parseInt($(elt1).css( "z-index" )+"",0) || 0;
					elt1 = elt1.offsetParent;
				}
				this._elt.css({
					"left": elt.offset().left,
					"top": elt.offset().top,
					"width": elt.width(),
					"height": elt.height(),
					"z-index": zIndx+1
				});
			}
		},
		_ajust: function(){
			var elt = this._ctrl.getElt();
			if ( elt && this._elt && !this._ctrl._hidden && this._ctrl._enabled ) {
				var offset = elt.offset();
				this._elt.animate({
					"left": offset.left,
					"top": offset.top,
					"width": elt.width(),
					"height": elt.height()
				});
			} else {
				window.clearInterval(this._ajustTimer);
				this._ajustTimer = null;
			}
		},
		_remove: function () {
			if (this._elt){
				$(this._elt).fadeOut(KL.Utils.Delegate.create(this, function(){
					this._elt.remove();
					this._hideTimer = null;
					this._elt = null;
					$(this).trigger("closed");
				}));
			}
		}
	};
	KL.Utils.registerClass("Loader", Loader);
})()
;
KL.registerNS("Data");
(function () {
	var SettingLimit = function (limitInfo) {
		if (limitInfo) {
		}
	};
	SettingLimit.prototype = {
		validate: function (value) {
			return true;
		}
	};
	SettingLimit.create = function (type, limitInfo) {
		var limit = null;
		switch ((type+"").toLowerCase()) {
			case "string": limit = new KL.Data.StringLimit(limitInfo); break;
			case "number": limit = new KL.Data.NumberLimit(limitInfo); break;
			case "boolean": limit = new KL.Data.BoolLimit(limitInfo); break;
			default: limit = new SettingLimit(limitInfo); break;
		}
		return limit;
	};
	KL.Data.registerClass("SettingLimit", SettingLimit);
})()
;
(function (undef) {
	var BoolLimit = function (limitInfo) {
		BoolLimit._super.call(this, limitInfo);
	};
	BoolLimit.prototype = {
		validate: function (value) {
			return true;
		}
	};
	KL.Data.registerClass("BoolLimit", BoolLimit);
	BoolLimit.extend(KL.Data.SettingLimit);
})()
;
(function () {
	function setRawData( val ){
		var data = val;
	
		this._val = val;
	}
	var Setting = function (limitInfo) {
		this.name = limitInfo.name;
		this.type = limitInfo.type || typeof(null);
		this.dataField = limitInfo.field;
		this.limits = KL.Data.SettingLimit.create(this.type, limitInfo);
	};
	Setting.prototype = {
		name: "",
		resourceId: "",
		limits: null,
		blockable: false,
		blocked: false,
		type: "",
		dataField: "",
		isChanged: false,
		_val: null,
		getQueryParams: function () {
			return KL.Utils.JSON.encode(this._val);
		},
		getViewData: function(){
			return this.getValue();
		},
		getValue: function () {
			var data = this._val;
			if( this.dataField )
				data = KL.Utils.ObjectHelper.getObjValueByPath( data, this.dataField );
			return data;
		},
		applyData: function(e, data, isLoadingComplete){
			KL.Utils.Log.write( "Setting[" + this.name +"].applyData: called" );
			setRawData.call(this, data);
			$( this ).trigger("onvaluechange", [this.getViewData(), isLoadingComplete]);
			this.notifyChanged(null, data, !!isLoadingComplete);
		},
		setValue: function (val, isLoadingComplete) {
			KL.Utils.Log.write( "Setting[" + this.name +"].setValue: called" );
			var data = this._val;
			if( this.dataField )
				KL.Utils.ObjectHelper.setObjValueByPath( data, this.dataField, val );
			else
				data = val;
			setRawData.call(this, data);
			this.notifyChanged(null, data, !!isLoadingComplete);
		},
		update: function( data, isLoadingComplete ){
			KL.Utils.Log.write( "Setting[" + this.name +"].update: called" );
			if(!this.isChanged){
				setRawData.call(this, data);
				$( this ).trigger("onvaluechange", [this.getViewData(), isLoadingComplete]);
				window.setTimeout( KL.Utils.Delegate.create(this, function(d, lc){
					$(this).trigger("onupdate", [d, lc]);
				}, data, isLoadingComplete ), 0);
			}
			
			this.isChanged = false;
		},
		notifyChanged: function(evt, data, isLoadingComplete){
			KL.Utils.Log.write( "Setting["+ this.name +"].notifyChanged: called"  );
			this.isChanged = true;
			
			window.setTimeout( KL.Utils.Delegate.create(this, function(d, lc, e){
				$(this).trigger("onupdate", [d, lc]);
				window.setTimeout( KL.Utils.Delegate.create(this, function(d, e){
					$(this).trigger(e, [d]);
				}, d, e ), 0);
			}, data, isLoadingComplete, evt || $.Event("ondatachange") ), 0);
		},
		validate: function (val) {
			var retVal = true;
			if (this.limits != null) {
				retVal = this.limits.validate(val);
			}
			return retVal;
		},
		destroy: function () {
			this.limits = null;
			this._val = null;
		}
	};
	KL.Data.registerClass("Setting", Setting);
})()
;
(function (undef) {
	var StringLimit = function (limitInfo) {
		var Log = KL.Utils.Log;
		StringLimit._super.call(this, limitInfo);
		if (!!limitInfo) {
			this.minLength = limitInfo.minlength ? limitInfo.minlength : 0;
			this.maxLength = limitInfo.maxlength ? limitInfo.maxlength : 0;
			this.regex = limitInfo.regex ? new RegExp("^"+limitInfo.regex+"$", "i") : null;
		}
	};
	StringLimit.prototype = {
		minLength: 0,
		maxLength: 0,
		regex: null,
		validate: function (val) {
			var Log = KL.Utils.Log;
			val = (val || "") + "";
			if (this.minLength > 0 && val.length < this.minLength)
				return false;
			if (this.maxLength > 0 && val.length > this.maxLength)
				return false;
			if (this.regex != null && !this.regex.test(val))
				return false;
			return true;
		}
	};
	KL.Data.registerClass("StringLimit", StringLimit);
	StringLimit.extend(KL.Data.SettingLimit);
})()
;
(function (undef) {
	var NumberLimit = function (limitInfo) {
		var Log = KL.Utils.Log;
		NumberLimit._super.call(this, limitInfo);
		if (!!limitInfo) {
			this.minValue = limitInfo.min ? limitInfo.min : null;
			this.maxValue = limitInfo.max ? limitInfo.max : null;
		}
	};
	NumberLimit.prototype = {
		minValue: null,
		maxValue: null,
		validate: function (value) {
			var Log = KL.Utils.Log;
			value = new Number(value);
			if (isNaN(value))
				return false;
			if (this.maxValue !== null && this.maxValue < value)
				return false;
			if (this.minValue !== null && this.minValue > value)
				return false;
			return true;
		}
	};
	KL.Data.registerClass("NumberLimit", NumberLimit);
	NumberLimit.extend( KL.Data.SettingLimit );
})()
;
(function(){
	function Model(){
	}
	Model.prototype = {
		_data: null,
		getData: function(){ return this._data; },
		getViewData: function(){ return this._data; },
		getQueryParams: function(){ return this._data; },
		update: function(val){ this._data = val; },
		validate: function(){ return true; }
	};
	Model.create = function( typeName ){
		var modelType = KL.getType( typeName );
		if(modelType){
			var inst = new modelType();
			if( inst instanceof Model )
				return inst;
		}
		return null;
	};
	KL.Data.registerClass("Model", Model);
})()
;
(function(){
	var types = {},
		insts = {},
	SettingManager = {
		create: function (limitInfo) {
			var s = null;
			if( limitInfo ){
				KL.Utils.Log.write("SettingManager.create: creating setting");
				var Setting = KL.Data.Setting,
					base = limitInfo.base? this.getSetting(limitInfo.base): null,
					type = limitInfo.type?types[limitInfo.type]:Setting;
				s = new (type||Setting)(limitInfo);
				
				if( base ){
					KL.Utils.Log.write("SettingManager.create: Base setting for " + s.name + " is " + base.name);
					$(base).on("onupdate", KL.Utils.Delegate.create( s, function(e, val, a){ this.update(val, a); } ));
					$(s).on("ondatachange", KL.Utils.Delegate.create( base, base.notifyChanged));
				}
				insts[s.name] = s;
			}
			return s;
		},
		getSetting: function(name){
			KL.Utils.Log.write("SettingManager.getSetting: Searching for " + name);
			return insts[name] || null;
		},
		addType: function(settingType){
			if( typeof(settingType) == "function" ){
				settingType.extend(KL.Data.Setting);
				types[settingType.prototype.toString()] = settingType;
			}else{
				KL.Utils.Log.write("SettingManager.addType: What is it? " + settingType);
			}
		}
	};
	KL.Data.registerClass("SettingManager", SettingManager);
})()
;
KL.Data.registerNS("Queries");
(function(){
	var appQueries = {items: [], currIndex: 0};
	function _loadNextQuery(evt, data, isLoadComplete){
		if( ( evt && evt.isPropagationStopped() ) || !isLoadComplete ){
			return;
		}
		if( appQueries && appQueries.items && appQueries.items.length > appQueries.currIndex ){
			var q = appQueries.items[ appQueries.currIndex ];
			appQueries.currIndex++;
			if( KL.Utils.UserHelper.isAllowed(q.roleVisible) )
				q.loadData();
			else
				_loadNextQuery.call(this, evt, null, isLoadComplete);
		}else
			$(this).trigger( "appready" );
	}
	function _createQuery(app, queryInfo, dp) {
		var q = new KL.Data.Queries.DataQuery(queryInfo, app, dp);
		var d = app.getDependencies(q.id);
		if (d) {
			for (var i = 0, l = d.length; i < l; i++)
				d[i].applyToSender();
		}
		return q;
	}
	var QueryCreator = {
		loadNext: function(){
			_loadNextQuery.call(this, null, null, true);
		},
		resetCounter: function(){
			appQueries.currIndex = 0;
		},
		makeAppQuery: function ( data, app, dataProvider, successCallback, errCallback ){
			var q = _createQuery.call(this, app ,data, dataProvider),
				Delegate = KL.Utils.Delegate;
			if(successCallback)
				$(q).bind("onsuccess", successCallback );
			if(errCallback)
				$(q).bind( "onerror", errCallback );
			$(q).bind("onsuccess", Delegate.create( this, _loadNextQuery ) );
			appQueries.items.push( q );
			return q;
		},
		createQueries: function( queriesData, app, dataProvider ){
			window.setTimeout( KL.Utils.Delegate.create(this, function(){
				if (queriesData instanceof Array) {
					for (var i = 0, l = queriesData.length; i < l; i++)
						_createQuery.call(this, app, queriesData[i], dataProvider);
				} else
					_createQuery.call(this, app, queriesData, dataProvider);
				$(this).trigger("ready");
			}), 10);
		}
	};
	KL.Data.Queries.registerClass("QueryCreator", QueryCreator);
})()
;
(function () {
	var _insts = {};
	function _setLoadingStarted(){
		if (this._loading)
			return false;
		this._loading = true;
		KL.Utils.Log.write("DataQuery.loadData: Loading data (" + this.id + ")");
		this.stopTimeout();
		this._iscanceled = false;
		var params = _getParams.call(this);
		this._timeoutStopped = false;
		window.setTimeout(KL.Utils.Delegate.create(this, function () {
			$(this).trigger("onloadstarted");
		}), 0);
		return params;
	}
	function _getParams () {
		var params = { "action": this.action };
		if (this._params)
			params = _getControlsParams.call(this,params);
		if (this._paramsset)
			params = _getParamsset.call(this, params);
		if (this._modelData)
			params = _getModelsData.call(this, params);
		return params;
	}
	function _getControlsParams (params) {
		for (var paramName in this._params) {
			var param = this._params[paramName];
			var paramVal;
			if (typeof (param) != "object") {
				paramVal = param.toString();
			} else {
				paramVal = _getParam.call(this, param.page, param.id, param.action);
			}
			if (typeof (paramVal) != "undefined" && paramVal !== "") {
				params[paramName] = paramVal;
			}
		}
		return params;
	}
	function _getParamsset (params) {
		if (this._paramsset instanceof Array) {
			for (var i = 0, l = this._paramsset.lenght; i < l; i++) {
				var paramSetVal = _getParam.call(this, this._paramsset[i].page, this._paramsset[i].id, (this._paramsset[i].action ? this._paramsset[i].action : "getValueRecursive"));
				params = $.extend(params, paramSetVal);
			}
		} else {
			var paramSetVal = _getParam.call(this, this._paramsset.page, this._paramsset.id, (this._paramsset.action ? this._paramsset.action : "getValueRecursive"));
			params = $.extend(params, paramSetVal);
		}
		return params;
	}
	function _getModelsData(params) {
		if (typeof (this._modelData) == "string") {
			_getModelData.call(this, this._modelData, null, params);
		} else {
			for ( var paramName in this._modelData )
				_getModelData.call(this, this._modelData[paramName], paramName, params);
		}
		return params;
	}
	function _getModelData(modelInfo, paramName, params) {
		var model = null;
		var action = "";
		if (typeof (modelInfo) == "string")
			model = this._app.getSetting(modelInfo);
		else {
			model = this._app.getSetting(modelInfo.name);
			action = modelInfo.action;
		}
		action = action || "getQueryParams";
		if (model) {
			var modelParams = model[action].call(model);
			if (!!paramName)
				params[paramName] = modelParams;
			else
				$.extend(params, modelParams);
		}
	}
	function _getParam(pageId, ctrlId, action) {
		var val = null;
		if (!!pageId && !!ctrlId) {
			var page = this._app.getPage(pageId);
			if (!!page) {
				action = !!action ? action : "getValue";
				var ctrl = page.getControl(ctrlId);
				if (!!ctrl && typeof (ctrl[action]) == "function")
					val = ctrl[action].call(ctrl);
			}
		}
		return val;
	}
	function _loadSuccess(val, isLoadPending) {
		if (this._iscanceled)
			return false;
		var Delegate = KL.Utils.Delegate;
		window.setTimeout(Delegate.create(this, function () {
			var e = $.Event("onsuccess");
			$(this).trigger(e, [val, !isLoadPending]);
			this._iscanceled = e.isDefaultPrevented();
			KL.Utils.Log.write("DataQuery[" + this.id + "]._loadSuccess: retval= " + this._iscanceled);
			_triggerLoadComplete.call(this, isLoadPending);
		}), 0);
		if (this.timeout != 0 && !this._timeoutStopped && !isLoadPending) {
			KL.Utils.Log.write("DataQuery._loadSuccess:" + this.id + " refreshing by timer.");
			this._timer = window.setTimeout(Delegate.create(this, this.loadData), this.timeout);
		}
	}
	function _loadError(val) {
		KL.Utils.Log.write("DataQuery._loadError: Ooooopsy. " + this.id + " not loaded.", KL.Utils.Log.type.WARNING);
		window.setTimeout(KL.Utils.Delegate.create(this, function () {
			$(this).trigger("onerror", [val]);
			_triggerLoadComplete.call(this);
		}), 0);
	}
	function _triggerLoadComplete(isLoadPending) {
		this._loading = false;
		window.setTimeout(KL.Utils.Delegate.create(this, function () {
			$(this).trigger(isLoadPending ? "onloadpending" : "onloadcomplete");
		}), 0);
	}
	function DataQuery(query, app, dp) {
		this.id = query.id;
		_insts[this.id] = this;
		this._app = app;
		this._dataProvider = dp;
		this._dataType = query.type || this._dataType;
		this._params = !!query.params ? query.params : {};
		this._paramsset = !!query.paramsset ? query.paramsset : null;
		this._modelData = !!query.model ? query.model : null;
		this._isHidden = !!query.hidden;
		this.roleVisible = (typeof query.roleVisible != "undefined")? query.roleVisible : this.roleVisible;
		this._iscanceled = false;
		if (query.action)
			this.action = query.action;
		if (typeof (query.timeout) == 'number') {
			this.timeout = query.timeout;
		}
	};
	DataQuery.prototype = {
		action: "",
		id: "",
		timeout: 0,
		_app: null,
		_params: null,
		_paramsset: null,
		_modelData: null,
		_page: null,
		_dataProvider: null,
		_timeoutStopped: false,
		_timer: null,
		_dataType: "json",
		_iscanceled: false,
		_loading: false,
		_isHidden: false,
		roleVisible: "always",
		loadFile: function () {
			var params = _getParams.call(this);
			var url = this._dataProvider.openURL(params);
			if( this._isHidden ){
				var ifrId = "downloadFileIframe";
				$("#"+ifrId).remove();
				$( '<iframe style="position: absolute; left: -100em; top: 100em; width: 10px; height: 10px;" id="'+ifrId+'" />' )
					.attr("src", url)
					.appendTo($(document.body));
			} else
				window.open(url, "window_" + this.action, "menubar=no,location=no,resizable=no,scrollbars=no,status=no,width=420,height=230");
		},
		loadData: function () {
			var params = _setLoadingStarted.call(this);
			if( params !== false ){
				KL.Utils.Log.write("DataQuery.loadData: Loading data (" + this.id + ")");
				var Delegate = KL.Utils.Delegate;
				this._dataProvider.loadData(
					params,
					Delegate.create(this, _loadSuccess),
					Delegate.create(this, _loadError),
					this._dataType
				);
			}else
				KL.Utils.Log.write("DataQuery.loadData: Query is active cancelling loading data (" + this.id + ")", KL.Utils.Log.type.WARNING);
		},
		uploadData: function (e, form) {
			var params = _setLoadingStarted.call(this);
			if( params !== false ){
				var Delegate = KL.Utils.Delegate;
				this._dataProvider.uploadData(
					params,
					form,
					Delegate.create(this, _loadSuccess),
					Delegate.create(this, _loadError)
				);
			}
		},
		stopTimeout: function () {
			if (this._timer != null)
				window.clearTimeout(this._timer);
			KL.Utils.Log.write("DataQuery["+this.id+"].stopTimeout: Stopping timeout for " + this.action);
			this._timer = null;
			this._timeoutStopped = true;
		}
	};
	DataQuery.getInstance = function (id) {
		var r = id ? _insts[id] : null;
		return r || null;
	};
	KL.Data.Queries.registerClass("DataQuery", DataQuery);
})()
;
KL.registerNS("HTTP");
(function () {
	var RequestInfo = function (data, url, callback, errorCallback, method, contentType, urlParams) {
		RequestInfo._id = RequestInfo._id || 0;
		this.id = "rq" + (RequestInfo._id++);
		this.data = data || null;
		this.url = url || "";
		this.callback = callback || null;
		this.errorCallback = errorCallback || null;
		this.method = method || RequestInfo.Methods.GET;
		this.contentType = contentType || RequestInfo.Types.JSON;
		this.urlParams = urlParams || null;
		if (this.data)
			this.action = this.data["action"];
	};
	RequestInfo.prototype = {
		id: 0,
		data: null,
		url: "",
		callback: null,
		errorCallback: null,
		method: "",
		contentType: "",
		isloading: false,
		urlParams: null,
		action: "",
		form: null
	};
	RequestInfo.Methods = {
		GET: "get",
		POST: "post"
	};
	RequestInfo.Types = {
		JSON: "json",
		HTML: "html",
		XML: "xml",
		Text: "text"
	};
	KL.HTTP.registerClass("RequestInfo", RequestInfo);
})()
;
(function () {
	var RequestInfo = KL.HTTP.RequestInfo;
	var StringHelper = KL.Utils.StringHelper;
	var Delegate = KL.Utils.Delegate;
	var denyParams = {"data": true, "error": true, "action": true, "actionid": true},
		abortedText = "abort";
	var DataProvider = function () {
		$(HttpProvider).bind("onerror", Delegate.create(this, function(e, err) {
			$(this).trigger("onerror", [err]);
		}));
	};
	var HttpProvider = {
		complete: true,
		_currRequest: null,
		AjaxResult: { OK: "ok", Error: "error" },
		_loading: false,
		_closeLoaderTimer: null,
		queue: null,
		_baseUrl: "cgi-bin/klwi?{1}&cb={0}",
		
		_ajax: null,
		_getBaseUrl: function (actionId) {
			if (DataProvider._urls && DataProvider._urls[actionId]) {
				return DataProvider._urls[actionId];
			}
			return this._baseUrl;
		},
		load: function (request) {
			var Log = KL.Utils.Log;
			this._loadStart();
			if (!!request["data"] && !!request.data["action_id"]) {
				Log.write("HttpProvider.load(" + request.action + "): loading next part of data for id " + request.data["action_id"]);
				window.clearTimeout(this._actionIdTimers[request.data["action_id"]]);
				this._actionIdTimers[request.data["action_id"]] = null;
			}
			this.queue = this.queue||[];
			if (!this.complete) {
				this.queue.push(request);
				Log.write("HttpProvider.load(" + request.action + "): added to queue");
				return;
			}
			this._currRequest = request;
			this.complete = false;
			Log.write("HttpProvider.load(" + request.action + "): loading " + request.url + " " + request.contentType);
			this._ajax = $.ajax({
				type: request.method,
				url: request.url,
				async: true,
				data: request.data,
				scriptCharset: "UTF-8",
				dataType: request.contentType,
				success: Delegate.create(this, this._ajaxSuccess, request),
				error: Delegate.create(this, this._ajaxError, request),
				traditional: true,
				timeout: 60000
			});
		},
		upload: function(request, form){
			if(form){
				request.form = form;
				this._loadStart();
				this.queue = this.queue||[];
				if (!this.complete) {
					this.queue.push(request);
					KL.Utils.Log.write("HttpProvider.upload(" + request.action + "): added to queue");
					return;
				}
				var ifrId = "upload_iframe_" + (new Date()).getTime();
				var ifrCount = 0;
				while (document.getElementById(ifrId + ifrCount))
					ifrCount = ifrCount ? ifrCount + 1 : 1;
				ifrId += ifrCount;
				var callbackName = KL.Utils.CRC32.generate( ifrId );
				window[ callbackName ] = KL.Utils.Delegate.create( this, this._uploadCallback, ifrId, callbackName, request );
				request.data.callback = callbackName;
				var event = document.all ? "ready" : "load";
				$('<iframe allowtransparency="allowtransparency" frameborder="0" id="' + ifrId + '" name="' + ifrId + '"></iframe>').css({ "position": "absolute", "width": "1px", "height": "1px", "left": "0px", "top": "1px" })
					.appendTo($(document.body));
				this._currRequest = request;
				this.complete = false;
				form.attr({
					"action": HttpProvider.getUrl(request),
					"target": ifrId,
					"enctype": "multipart/form-data",
					"method": "post"
				}).submit();
			}
		},
		_uploadCallback: function (iframeId, callbackName, request, data) {
			window[callbackName] = null;
			try{
				delete window[callbackName];
				$("#" + iframeId).remove();
			}catch(e){}
			this._ajaxSuccess(request, data);
		},
		retryLastRequest: function () {
			var request = this._currRequest;
			this.loadRequest(request);
		},
		loadRequest: function (request) {
			if (request == null)
				return;
			if( !!request.form )
				this.upload(request,request.form);
			else
				this.load(request);
		},
		getUrl: function (request) {
			var Log = KL.Utils.Log;
			var qs = "";
			var url = this._baseUrl;
			if (request.data != null) {
				if (request.data["action"]) {
					qs = "action=" + request.data.action;
					url = this._getBaseUrl(request.data.action);
				}
			
				if (request.method == RequestInfo.Methods.GET)
					qs = $.param(request.data, true);
				else
					delete request.data["action"];
				url = StringHelper.formatTemplate(url, request.data );
			}
			return StringHelper.format(url, (new Date()).getTime(), qs);
		},
		_ajaxSuccess: function (request, data) {
			var Log = KL.Utils.Log;
			Log.write("HttpProvider._ajaxSuccess(" + request.action + "): Request is got for " + request.url);
			var typeName = (request.contentType + "").toLowerCase();
			if (!!({ "text": true, "html": true })[typeName]) {
				try {
					var json = eval("(" + data + ")");
					data = json;
					Log.write("HttpProvider._ajaxSuccess(" + request.action + "): Request is OK");
				} catch (e) {
					Log.write("HttpProvider._ajaxSuccess(" + request.action + "): parse error " + e.message, Log.type.WARNING);
				}
			}
			if (!data || !!data.error) {
				Log.write("HttpProvider._ajaxSuccess(" + request.action + "): Request is NOT OK", Log.type.WARNING);
				this._ajaxError(request, !!data ? data : { error: { id: 0, message: "No data"} });
				return;
			}
			this._currRequest = null;
			
			var isPending = (typeof (data["action_id"]) != "undefined");
			var proceed = true;
			if ((typeof (request.callback) + "").toLowerCase() == "function") {
				if (request.contentType == RequestInfo.Types.JSON) {
					
					var retData = data["data"];
					if ( !(isPending && (typeof (retData) == "undefined" || retData === null))) {
						for( var paramName in data ){
							if( data.hasOwnProperty( paramName ) && !(denyParams)[(""+paramName).toLowerCase()] ){
								retData = retData || {};
								retData[paramName] = data[paramName];
							}
						}
						proceed = request.callback(retData, isPending);
					}else
						Log.write("HttpProvider._ajaxSuccess(" + request.action + "): Do not call a callback - pending data");
				} else {
					Log.write("HttpProvider._ajaxSuccess(" + request.action + "): Calling an HTML callback");
					proceed = request.callback(data, isPending);
				}
			} else
				Log.write("HttpProvider._ajaxSuccess(" + request.action + "): No callback");
			if (isPending && (proceed !== false))
				this._tryLoadActionResult(data.action_id, request);
			window.setTimeout(Delegate.create(this, this._checkQueue), 0);
		},
		_actionIdTimers: {},
		_tryLoadActionResult: function (actionId, request) {
			if (!!this._actionIdTimers[actionId])
				window.clearTimeout(this._actionIdTimers[actionId]);
			this._actionIdTimers[actionId] = null;
			
			KL.Utils.Log.write("HttpProvider._tryLoadActionResult(" + request.action + "): Requerying data for id " + actionId);
			var rInfo = new RequestInfo(
				{ "action_id": actionId },
				request.url,
				request.callback,
				request.errorCallback,
				request.method,
				request.contentType
			);
			rInfo.action = request.action;
			rInfo.id = request.id;
			this._actionIdTimers[actionId] = window.setTimeout(Delegate.create(this, this.load, rInfo), 1000);
		},
		_ajaxError: function (request, result, textStatus) {
			var abortId = -1000;
			var Log = KL.Utils.Log;
			this.complete = true;
			var err = { id: textStatus==abortedText?abortId:500, message: "Server error" };
			if (!!result) {
				if (!!result.error && typeof (result.error) != "function")
					err = result.error;
				else {
					try {
						err.id = result.status || err.id;
						err.message = result.statusText || err.message;
						if (textStatus == abortedText || result.statusText == abortedText)
							err.id = abortId;
					} catch (e) {
						Log.write("HttpProvider._ajaxError(" + request.action + "): Crap happened on error detection ", Log.type.WARNING, e);
					}
				}
			}
			Log.write("HttpProvider._ajaxError(" + request.action + "): Huston we have a problem[" + err.id + "]: " + err.message, Log.type.WARNING);
			if ((typeof (request.errorCallback) + "").toLowerCase() == "function") {
				Log.write("HttpProvider._ajaxError: Calling error callback", Log.type.WARNING);
				request.errorCallback(err);
			}
			if (err.id == abortId)
				Log.write("HttpProvider._ajaxError: Request aborted", Log.type.WARNING);
			else
				$(this).trigger("onerror", [err]);
		},
		clearQueue: function (force) {
			var Log = KL.Utils.Log;
			this.complete = true;
			if( this.queue ){
				Log.write("HttpProvider.clearQueue: dismissing " + this.queue.length + " requests");
				for( var i=0, l=this.queue.length; i<l; i++ )
					this._ajaxError(this.queue[i], null, abortedText);
			}
			this.queue = [];
			Log.write("HttpProvider.clearQueue: No more requests queued");
			this._loadEnd();
			if (force && this._ajax) {
				try {
					this._ajax.abort();
					Log.write("HttpProvider.clearQueue(): AJAX aborted ", Log.type.WARNING);
				} catch (e) {
					Log.write("HttpProvider.clearQueue(): Error aborting AJAX request " + e.message, Log.type.WARNING);
				}
			}
		},
		_checkQueue: function () {
			this.complete = true;
			if (!this.queue)
				this.queue = [];
			
			KL.Utils.Log.write("HttpProvider._checkQueue: Looking for next request " + this.queue.length);
			if (this.queue.length > 0) {
				var next = this.queue[0];
				this.queue = this.queue.slice(1);
				KL.Utils.Log.write("HttpProvider._checkQueue: Preparing to load next request ", null, next);
				this.loadRequest(next);
			} else {
				KL.Utils.Log.write("HttpProvider._checkQueue: Finally nothing to load any more.");
				this.clearQueue();
			}
		},
		_loadStart: function () {
			if (!this._loading) {
				this._loading = true;
			}
		},
		_loadEnd: function () {
			if (this._closeLoaderTimer != null) {
				window.clearTimeout(this._closeLoaderTimer);
				this._closeLoaderTimer = null;
			}
			KL.Utils.Log.write("HttpProvider._loadEnd: Preparing to fire loadend event.");
			this._closeLoaderTimer = window.setTimeout(function () {
				if (HttpProvider._loading) {
					KL.Utils.Log.write("HttpProvider._loadEnd: Firing loadend event.");
					$(HttpProvider).trigger("onloadend");
					HttpProvider._loading = false;
				}
			}, 200);
		}
	};
	DataProvider.prototype = {
		_urls: null,
		contentType: "json",
		loadData: function (data, callBack, errorCallback, contentType) {
			var Log = KL.Utils.Log;
			var request = new RequestInfo(data, "", callBack, errorCallback, RequestInfo.Methods.POST, (contentType || this.contentType));
			request.url = HttpProvider.getUrl(request);
			HttpProvider.load(request);
			return request.id;
		},
		stopLoading: function (force) {
			KL.Utils.Log.write("DataProvider.stopLoading: Sopping loading"+ (force?" ANYWAY!":"."));
			HttpProvider.clearQueue(force);
		},
		loadURL: function (url, method, data, callBack, errorCallback, contentType) {
			var Log = KL.Utils.Log;
			var m = RequestInfo.Methods[(method + "").toUpperCase()] ? RequestInfo.Methods[(method + "").toUpperCase()] : RequestInfo.Methods.GET;
			var request = new RequestInfo(data, url, callBack, errorCallback, m, (contentType || this.contentType));
			HttpProvider.load(request);
			return request.id;
		},
		openURL: function (data) {
			var request = new RequestInfo(data, "", null, null, RequestInfo.Methods.GET, this.contentType);
			return HttpProvider.getUrl(request);
		},
		uploadData: function( data, form, callBack, errorCallback ){
			var request = new RequestInfo(data, "", callBack, errorCallback, RequestInfo.Methods.GET, this.contentType);
			HttpProvider.upload(request, form);
			return request.id;
		}
	};
	KL.HTTP.registerClass("DataProvider", DataProvider);
})();
;
KL.registerNS("Web");
(function () {
	var Delegate = KL.Utils.Delegate;
	var Log = KL.Utils.Log;
	function Context(app) {
		this.data = null;
		this._app = app;
		this._loadCookieData();
		$(app).bind("onapplicationready", Delegate.create(this, this._init));
	};
	Context.DataTypes = {
		"LogLevel": "LogLevel",
		"UserName": "UserName",
		"UserType": "UserType",
		"Lang": "lang",
		"ServerTime": "serverTime",
		"UiVersion": "Version",
		"LoginEnabled": "canLogin"
	};
	Context.prototype = {
		Application: null,
		_cookieKey: "AppData",
		data: null,
		_inited: false,
		_app: null,
		_appSettings: null,
		_ksnParticipationActivated: false,
		_licenseData:null,
		waitStartedTask : {
			"AVS":0,
			"ASP":0,
			"AVS_ASP":0
		},
		protectionState : {
			"AV":false,
			"AS":false,
			"CF":false,
			"AP":false
		},
		setServerTime: function( time ){
			this.setData(Context.DataTypes.ServerTime, time);
			KL.Utils.DateHelper.setServerTime(time);
		},
		getServerTime: function(){
			return KL.Utils.DateHelper.getServerTime();
		},
		getIsLicenseAsEnabled: function(){
			var FunctionalityLevel = KL.LMS.Enums.FunctionalityLevel;
			var functionalityLvl = this._licenseData ? this._licenseData.functionalityLevel : FunctionalityLevel.Unknown;
			return $.inArray(functionalityLvl, [
				FunctionalityLevel.AntiSpamWithoutUpdates,
				FunctionalityLevel.FunctionWithoutUpdates,
				FunctionalityLevel.AntiSpamFunctionality,
				FunctionalityLevel.FullFunctionality
			]) != -1;
		},
		getIsLicenseAvEnabled: function(){
			var FunctionalityLevel = KL.LMS.Enums.FunctionalityLevel;
			var functionalityLvl = this._licenseData ? this._licenseData.functionalityLevel : FunctionalityLevel.Unknown;
			return $.inArray(functionalityLvl, [
				FunctionalityLevel.AntiVirusWithoutUpdates,
				FunctionalityLevel.FunctionWithoutUpdates,
				FunctionalityLevel.AntiVirusFunctionality,
				FunctionalityLevel.FullFunctionality
			]) != -1;
		},
		getIsLicenseApEnabled: function(){
			var FunctionalityLevel = KL.LMS.Enums.FunctionalityLevel;
			var functionalityLvl = this._licenseData ? this._licenseData.functionalityLevel : FunctionalityLevel.Unknown;
			return $.inArray(functionalityLvl, [
				FunctionalityLevel.AntiSpamWithoutUpdates,
				FunctionalityLevel.FunctionWithoutUpdates,
				FunctionalityLevel.AntiSpamFunctionality,
				FunctionalityLevel.FullFunctionality
			]) != -1;
		},
		getIsLicenseCfEnabled: function(){
			return !!this._licenseData;
		},
		setProtectionState:function (val) {
			this.protectionState["AS"] = val.scanLogic.asSettings.enableAsScan;
			this.protectionState["AV"] = val.scanLogic.avSettings.enableAvScan;
			this.protectionState["CF"] = val.scanLogic.cfSettings.enableCfScan;
			this.protectionState["AP"] = val.scanLogic.apSettings.enableApScan;
		},
		getProtectionState:function (key,val) {
			return ({
				"AS": this.getIsLicenseAsEnabled,
				"AV": this.getIsLicenseAvEnabled,
				"CF": this.getIsLicenseCfEnabled,
				"AP": this.getIsLicenseApEnabled
			})[key].call(this) && this.protectionState[key];
		},
		setStartedTask:function (key,val) {
			this.waitStartedTask[key]=val;
		},
		getStartedTask:function (key) {
			return this.waitStartedTask[key];
		},
		setAppSettings: function(obj){
			this._appSettings = obj;
		},
		getAppSettings: function(obj){
			return this._appSettings;
		},
		setKsnParticipationActivated: function(obj) {
			if (obj.ksnParticipationActivated != "undefined")
				this._ksnParticipationActivated = obj.ksnParticipationActivated;
		},
		getKsnParticipationActivated: function(obj) {
			return this._ksnParticipationActivated;
		},
		getData: function (key) {
			if (!key)
				return this.data;
			if (this.data && typeof(this.data[key]) != "undefined" )
				return this.data[key];
			return null;
		},
		setData: function (key, val) {
			this.data[key] = val;
			if (typeof(val) == "undefined" || val === null )
				delete this.data[key];
			this._storeCookie();
		},
		_init: function () {
			Log.write("Context._init: Called");
			
			var logLevel = this.getData( Context.DataTypes.LogLevel );
			KL.Utils.Log.setLogLevel(logLevel);
			
			var localization = new KL.Utils.Localization(this.data ? this.data.lang : null, this._app);
			$(localization).bind("onlangloaded", Delegate.create(this, this.setLanguage));
			localization.init();
		},
		setLicenseData: function(data){
			this._licenseData = data;
			$(this).trigger("onlicensechanged");
		},
		getLicenseData: function(){
			return this._licenseData;
		},
		getLanguage: function () {
			Log.write("Context.getLanguage: Called");
			return this.data ? this.data.lang || "" : "";
		},
		setLanguage: function (evt, lang) {
			Log.write("Context.setLanguage: Called Lang is " + lang);
			if (!this.data)
				this.data = {};
			this.data.lang = lang;
			this._storeCookie();
			if (!this._inited) {
				KL.Utils.Log.write("Context.setLanguage: Startin Application");
				this._inited = true;
				$(this).trigger("oncontextready");
			}
			this._inited = true;
		},
		isInited: function () {
			return this._inited;
		},
		_loadCookieData: function () {
			Log.write("Context._loadCookieData: Called (" + document.cookie + ")");
			var cookie = document.cookie.split(";");
			this.data = {};
			try {
				for (var i = 0, l = cookie.length; i < l; i++) {
					Log.write("Context._loadCookieData: " + i + " cookie");
					var cookie_i = cookie[i].split("=");
					Log.write("Context._loadCookieData: key is " + cookie_i[0]);
					if ($.trim(cookie_i[0]) == this._cookieKey) {
						Log.write("Context._loadCookieData: Cookie found " + decodeURIComponent(cookie_i[1]));
						this.data = eval("(" + decodeURIComponent(cookie_i[1]) + ")");
						return;
					}
				}
			} catch (e) {
				Log.write("Context._loadCookieData: No Cookie found", Log.type.ERROR);
				this.data = {};
			}
		},
		_storeCookie: function () {
			Log.write("Context._storeCookie: Called");
			var expDate = new Date();
			expDate.setFullYear(expDate.getFullYear() + 100);
			if (this.data !== null) {
				var val = KL.Utils.JSON.encode(this.data);
				Log.write("Context._storeCookie: Saving data " + val);
				var cookie = [this._cookieKey + "=" + encodeURIComponent(val + ""), "path=/", "expires=" + expDate.toGMTString()];
				document.cookie = cookie.join("; ");
				Log.write("Context._storeCookie: Cookie stored " + cookie.join("; "));
			}
		}
	};
	Context.create = function (app) {
		var c = new Context(app);
		return c;
	};
	KL.Web.registerClass("Context", Context);
})()
;
KL.Web.registerNS("Controls");
(function () {
	function _toggleEnabled (isEnabled) {
		var elt = this.getElt();
		this._enabled = isEnabled;
		if (elt) {
			elt.attr("disabled", !isEnabled);
			if (!!this._children) {
				for (var i = 0, l = this._children.length; i < l; i++)
					_toggleEnabled.call(this._children[i], isEnabled);
			}
		}
		this.onToggleEnabled(isEnabled);
	}
	var Control = function (id, setting) {
		if (id) {
			this.id = id;
			if (setting) {
				this._setting = setting;
				$(setting).bind("onvaluechange", KL.Utils.Delegate.create(this, this._bind));
			}
		}
	};
	Control.prototype = {
		constructor: Control,
		_page: null,
		id: "",
		param: null,
		_elt: null,
		_children: null,
		_parent: null,
		_value: null,
		_hidden: true,
		_setting: null,
		_loader: null,
		_forceCloseLoader: false,
		_enabled: true,
		_cancelSettingBind: false,
		_partialValueComplete: true,
		errorWrap: ".errorMsg",
		errorText: ".errorMsg",
		controltemplate: null,
		cssclass: "",
		role_visible: "",
		onInit: function () { },
		onDataBind: function () { },
		onBeforeInit: function () { },
		onBeforeShow: function () { },
		onBeforeHide: function () { },
		onToggleEnabled: function () { },
		onHidden: function () { },
		onShown: function () { },
		onChildDataBound: function () { },
		onLocalizationComplete: function () { },
		onDestroy: function () { },
		onPageParamChanged: function (val) { },
		onPreRender: function () { },
		onRenderComplete: function () { },
		onInitInteraction: function () { },
		
		
		
		isVisible: function () {
			return !this._hidden;
		},
		setParent: function (parent) {
			this._parent = parent;
		},
		_changeUrlParam: function (val) {
			if (!!this.param)
				this._page.getApplication().setPageParam(this.param, val);
		},
		_pageHashChangeHandler: function (evt, value) {
			if (typeof (this.onPageParamChanged) == "function")
				this.onPageParamChanged(value);
		},
		_getTemplate: function () {
			var html = null;
			if (!this._page)
				throw "Control " + this.id + " has no page somehow";
			if (!!this.controltemplate)
				html = this._page.getApplication().getCtrlTemplate(this.controltemplate);
			else
				html = this._page.getApplication().getCtrlTemplate(this.toString());
			if (!html){
				KL.Utils.Log.write("Control[" + this + "]._getTemplate: No template for "  + this.toString() + "[" + this.id + "]", KL.Utils.Log.type.WARNING);
			}
			return html;
		},
		getElt: function () {
			return this._elt;
		},
		_childChangeHandler: function (evtObj) {
			$(this).trigger(evtObj, Array.prototype.slice.call(arguments, 1));
		},
		_childDataBoundHandler: function (e, sender) {
			if ((typeof (this.onChildDataBound) + "").toLowerCase() == "function") {
				this.onChildDataBound(sender);
			}
		},
		addSubcontrol: function (ctrl) {
			if (!!ctrl) {
				var Delegate = KL.Utils.Delegate;
				if (!this._children)
					this._children = [];
				this._children.push(ctrl);
				$(ctrl).bind("onchange", Delegate.create(this, this._childChangeHandler))
					.bind("ondatabindcomplete", Delegate.create(this, this._childDataBoundHandler));
			}
		},
		setPage: function (page) {
			this._page = page;
		},
		getSettingName: function () {
			if (this._setting)
				return this._setting.name;
			return "";
		},
		applyValue: function (evt, val, isLoadComplete) {
			this.hideError();
			if( this._setting )
				this._setting.applyData( evt, val, isLoadComplete );
		},
		applyError: function (evt, err) {
			this.showError(err.id, KL.Utils.StringHelper.htmlEncode(err.message + ""));
		},
		showError: function (errNum, text) {
			var elt = this.getElt();
			if (elt) {
				var localization = KL.Utils.Localization.getInstance();
				var exceptionText = KL.Utils.Exception.getExceptionText(errNum);
				if (localization.stringExists(text))
					text = localization.getLocaleString(text);
				elt.find(this.errorWrap).show();
				elt.find(this.errorText).html(exceptionText || text);
			}
		},
		hideError: function () {
			var elt = this.getElt();
			if (elt) {
				if ((typeof (this.onErrorHide) + "").toLowerCase() == "function")
					this.onErrorHide();
				elt.find(this.errorWrap).hide();
			}
		},
		getValue: function(){
			var val = this._value;
			if( this._setting )
				this._setting.getValue();
			return val;
		},
		getValueRecursive: function () {
			var retVal = {};
			var key = !!this._setting ? this._setting.name : this.id;
			var val = this.getValue();
			if (val !== null)
				retVal[key] = val;
			if (this._children) {
				for (var i = 0, l = this._children.length; i < l; i++)
					retVal = $.extend(retVal, this._children[i].getValueRecursive());
			}
			return retVal;
		},
		setValue: function (val) {
			this.hideError();
			KL.Utils.Log.write("Control.setValue: setting value \"" + val + "\" to " + this.id);
			if (this._setting) {
				this._setting.applyData(null,val,true);
			}
		},
		setValuePartial: function (val) {
			this.setValue(val);
		},
		_bind: function (evt, val, isLoadingComplete) {
			this.hideError();
			if (this._cancelSettingBind) {
				this._cancelSettingBind = false;
				return;
			}
			this._value = val;
			this.onDataBind(val, isLoadingComplete);
			this._forceCloseLoader = true;
			this.hideLoading();
			var Delegate = KL.Utils.Delegate;
			window.setTimeout(Delegate.create(this, this._triggerBindComplete), 0);
			var elt = this.getElt();
			if (elt) {
				var localizationResult = KL.Utils.Localization.getInstance().applyDelayed(elt);
				$(localizationResult).bind("onresourceapplied", Delegate.create(this, this._localizationComplete));
			}
		},
		getSetting: function () {
			return this._setting;
		},
		validate: function (val) {
			var Log = KL.Utils.Log;
			val = (typeof(val) === "undefined") ? this.getValue() : val;
			if (this._setting) {
				if (!this._setting.validate(val))
					return false;
			}
			return true;
		},
		_render: function (container) {
			var html = this._getTemplate();
			if (!html) {
				throw "Control[" + this + "]._render: no html for id=" + this.id;
			}
			if ((typeof (this.onPreRender) + "").toLowerCase() == "function") {
				if (this.onPreRender() === false)
					return false;
			}
			this._elt = $(html);
			container = container || this._parent.getChildrenContainer();
			if (!!container) {
				this._elt.appendTo(container).addClass(this.id);
			} else {
				throw "Control[" + this + "]._render: no room for id=" + this.id;
			}
			if ((typeof (this.onInitInteraction) + "").toLowerCase() == "function") {
				if (this.onInitInteraction() === false)
					return false;
			}
			if ((typeof (this.onRenderComplete) + "").toLowerCase() == "function") {
				this.onRenderComplete();
			}
		},
		init: function () {
			if ((typeof (this.onBeforeInit) + "").toLowerCase() == "function") {
				this.onBeforeInit();
			}
			if (!!this._children) {
				for (var i = 0, l = this._children.length; i < l; i++) {
					this._children[i].init();
				}
			}
			if ((typeof (this.onInit) + "").toLowerCase() == "function") {
				this.onInit();
			}
			$(this).trigger("oninit", [this]);
		},
		getChildrenContainer: function () {
			var elt = this.getElt();
			var container = null;
			if (elt) {
				if (elt.hasClass("_subcontrols"))
					container = elt;
				else
					container = elt.find("._subcontrols").eq(0);
				if (container.length == 0) {
					throw "Control[" + this + "].getChildrenContainer: no place for children id=" + this.id;
					container = null;
				}
			} else
				throw "Control[" + this + "("+this.id+")].getChildrenContainer: no element id=" + this.id;
			return container;
		},
		
		isControlVisible:function (val) {
			return !val || KL.Utils.UserHelper.isAllowed(val);
		},
		show: function (container) {
			if (!this._hidden || !this.isControlVisible(this.role_visible))
				return;
			if (container instanceof $.Event)
				container = null;
			if ((!container) && !this._parent) {
				KL.Utils.Log.write("Control[" + this + "].show: Control id=" + this.id + ": has no parent (" + this._parent + ")", KL.Utils.Log.type.WARNING);
				return;
			}
			KL.Utils.Log.write("Control[" + this + "].show: Showing id=" + this.id);
			
			
			var evt = $.Event("onbeforeshow");
			$(this).trigger(evt, [this]);
			if (evt.isPropagationStopped())
				return;
			try {
				if (this._render(container) === false) {
					KL.Utils.Log.write("Control[" + this + "].show: Render cancelled id=" + this.id);
					return;
				}
			} catch (e) {
				KL.Utils.Log.write("Control[" + this + "].show: Control id=" + this.id + " has not been rendered:\n " + (e.message || e), KL.Utils.Log.type.WARNING);
				return;
			}
			var elt = this.getElt();
			if (elt && this.cssclass)
				elt.addClass(this.cssclass);
				
			if ((typeof (this.onBeforeShow) + "").toLowerCase() == "function") {
				if (this.onBeforeShow() === false) {
					KL.Utils.Log.write("Control[" + this + "].show: Showing cancelled id=" + this.id);
					return;
				}
			}
			if (elt) {
					elt.show();
			} else {
				KL.Utils.Log.write("Control[" + this + "].show: No elements got id=" + this.id);
			}
			
			this.hideError();
			this._hidden = false;
			if (this._loader)
				this._loader.show();
			if (!!this._children) {
				for (var i = 0, l = this._children.length; i < l; i++) {
					this._children[i].show();
				}
			}
			if (elt) {
				var localizationResult = KL.Utils.Localization.getInstance().applyDelayed(elt);
				$(localizationResult).bind("onresourceapplied", KL.Utils.Delegate.create(this, this._localizationComplete));
			}
			if ((typeof (this.onShown) + "").toLowerCase() == "function")
				this.onShown();
			$(this).trigger("onshow", [this]);
		},
		setInvisible: function (evt, canceldom) {
			var elt = this.getElt();
			if (elt && canceldom !== true)
				elt.hide();
			
			if(this._loader)
				this._loader.hide(true);
			if (!!this._children) {
				for (var i = 0, l = this._children.length; i < l; i++)
					this._children[i].setInvisible(evt, true);
			}
			this._triggerEvt("onsetinvisible");
		},
		_triggerEvt: function( evtname ){
			$(this).trigger(evtname, [this]);
		},
		setVisible: function (evt, canceldom) {
			var elt = this.getElt();
			if (elt && canceldom !== true)
				elt.show();
			if (!!this._children) {
				for (var i = 0, l = this._children.length; i < l; i++)
					this._children[i].setVisible(evt,true);
			}
			this._triggerEvt("onsetvisible");
		},
		_beforeHide: function () {
			$(this).trigger("onbeforehide");
			if ((typeof (this.onBeforeHide) + "").toLowerCase() == "function") {
				if (this.onBeforeHide() === false)
					return false;
				if (!!this._children) {
					for (var i = 0, l = this._children.length; i < l; i++) {
						var c = this._children[i];
						if ((typeof (c._beforeHide) + "").toLowerCase() == "function" && c._beforeHide() === false)
							return false;
					}
				}
			}
		},
		hide: function () {
			if (!this._hidden) {
				KL.Utils.Log.write("Control.hide: hiding control id=" + this.id);
				if (this._beforeHide() === false) {
					return false;
				}
				KL.Utils.Log.write("Control[" + this + "].hide: Hiding id=" + this.id);
				var elt = this.getElt();
				if (elt) {
					elt.remove();
				}
				this.setHidden();
			}
		},
		setHidden: function () {
			this._hidden = true;
			this._elt = null;
			if(this._loader)
				this._loader.hide(true);
			if (!!this._children) {
				for (var i = 0, l = this._children.length; i < l; i++) {
					this._children[i].setHidden();
				}
			}
			if ((typeof (this.onHidden) + "").toLowerCase() == "function") {
				this.onHidden();
			}
			$(this).trigger("onhide", [this]);
		},
		showLoading: function () {
			KL.Utils.Log.write("Control.showLoading: called for id=" + this.id);
			this.hideError();
			if( !this._loader )
				this._createLoader();
			if( this._loader )
				this._loader.show();
		},
		_createLoader: function(){
			if (!this._hidden && this._enabled && !this._loader) {
				var elt = this.getElt();
				if (elt){
					this._loader = new KL.Utils.Loader( this, elt );
					$(this._loader).on( "closed", KL.Utils.Delegate.create(this, function(){
						this._loader = null;
					}) );
				}
			}
		},
		hideLoading: function () {
			KL.Utils.Log.write("Control.hideLoading: called for id=" + this.id);
			if (this._loader)
				this._loader.hide();
		},
		enable: function () {
			this._enabled = true;
			_toggleEnabled.call(this, true);
		},
		disable: function () {
			this._enabled = false;
			_toggleEnabled.call(this, false);
		},
		_fireChangeEvent: function () {
			KL.Utils.Log.write("Control._fireOnChange: called");
			var val = this.getValue();
			if (this._setting) {
				this._setting.applyData(null, val, true)
			} 
			$(this).trigger("onchange", [this, val]);
		},
		_triggerBindComplete: function () {
			$(this).trigger("ondatabindcomplete", [this]);
		},
		_localizationComplete: function () {
			if ((typeof (this.onLocalizationComplete) + "").toLowerCase() == "function") {
				this.onLocalizationComplete();
			}
		},
		_onError: function () {
			var elt = this.getElt();
			if (elt)
				elt.addClass("ctrlError");
			this.hideLoading();
		},
		destroy: function () {
			if ((typeof (this.onDestroy) + "").toLowerCase() == "function")
				this.onDestroy();
			if (this._setting)
				this._setting.destroy();
			this._setting = null;
			if (this._children) {
				for (var ctrlId in this._children) {
					if ((typeof (this._children[ctrlId].destroy) + "").toLowerCase() == "function")
						this._children[ctrlId].destroy();
				}
			}
			$(this).unbind();
			this._children = null;
		}
	};
	KL.Web.Controls.registerClass("Control", Control);
})()
;
(function () {
	var controlsCount = 0;
	var ControlFab = function () {
		var Log = KL.Utils.Log;
	};
	ControlFab.prototype = {
		createControl: function (ctrlInfo, parent, page) {
			var Log = KL.Utils.Log;
			var type = KL.getType(ctrlInfo.type);
			if (!type) {
				Log.write("ControlFab.createControl: can not find type " + ctrlInfo.type, Log.type.WARNING);
				return;
			}
			var id = ctrlInfo.id || "control" + ( controlsCount++ );
			delete ctrlInfo.id;
			var s = null;
			if (typeof (ctrlInfo["setting"]) != "undefined") {
				Log.write("ControlFab.createControl: control id=" + id + "; has setting id=" + ctrlInfo.setting);
				s = page.getApplication().getSetting(ctrlInfo.setting);
				if( !s ){
					Log.write("ControlFab.createControl: setting id=" + ctrlInfo.setting + " doesn't exist. Creating");
					s = page.getApplication().addSetting({"name": ctrlInfo.setting});
				}
				delete ctrlInfo.setting;
			}
			return this._newCtrl(id, type, ctrlInfo, s, parent, page);
		},
		_newCtrl: function (id, type, ctrlInfo, s, parent, page) {
			var Log = KL.Utils.Log;
			var c = null;
			try {
				c = new type(id, s);
				if (ctrlInfo["param"])
					this._applyHashChanges(ctrlInfo["param"], c, page);
				if (!!c) {
					if (typeof (ctrlInfo["elements"]) != "undefined") {
						for (var i = 0, l = ctrlInfo.elements.length; i < l; i++)
							c.addSubcontrol(this.createControl(ctrlInfo.elements[i], c, page));
						delete ctrlInfo.elements;
					}
					$.extend(c, ctrlInfo);
					c.setPage(page);
					c.setParent(parent);
					page.registerControl(c);
				} else {
					Log.write("ControlFab._newCtrl: Can not create instance of  type " + ctrlInfo.type + " with id=" + id + ";", Log.type.WARNING);
				}
			} catch (e) {  Log.write("ControlFab._newCtrl: Error["+e.message+"] creating control with id=" + id + " of type " + ctrlInfo.type + ";", Log.type.WARNING); }
			if (!c)
				Log.write("ControlFab._newCtrl: Can not create control with id=" + id + " of type " + ctrlInfo.type + ";", Log.type.WARNING);
			return c;
		},
		_applyHashChanges: function (paramName, ctrl, page) {
			page.getApplication().registerUrlChangeEvent(ctrl, paramName);
		}
	};
	ControlFab.__class = true;
	KL.Web.Controls.registerClass("ControlFab", ControlFab);
})()
;
(function () {
	var CheckBox = function (id, initValue) {
		CheckBox._super.call(this, id, initValue);
	};
	CheckBox.prototype = {
		_chbox: null,
		_label: null,
		onDataBind: function (val) {
			KL.Utils.Log.write("CheckBox.onDataBind: called");
			if (!!this._chbox)
				this._chbox.attr("checked", !!val);
		},
		onInitInteraction: function () {
			KL.Utils.Log.write("CheckBox.onInit: called");
			var elt = this.getElt();
			if (elt) {
				this._chbox = elt.find("input[type=checkbox]");
				this._label = elt.find(".labelText");
				if (this._chbox.length == 0)
					this._chbox = null;
				if (!!this._chbox)
					this._chbox.click(KL.Utils.Delegate.create(this, this._chboxClick));
				this.setText(this.text||"");
			}
		},
		setText: function (txt) {
			var localization = KL.Utils.Localization.getInstance();
			txt = this._tryApplyHelper(txt);
			if (localization.stringExists(txt))
				txt = localization.getLocaleString(txt);
			var elt = this.getElt();
			if (elt) {
				elt.find(".labelText").html(txt);
				if (this.helper) {
					localization.applyStingObjs(this.id, elt);
					KL.Utils.DateHelper.applyLocaleDates(this.id, elt);
				}
			}
		},
		_tryApplyHelper: function (data) {
			var retVal = data;
			if (this.helper) {
				try {
					var h = eval("(" + this.helper + ")");
					if ((typeof (h[this.helpermethod]) + "").toLowerCase() == "function")
						retVal = h[this.helpermethod](data, this.id);
				} catch (e) { }
			}
			return retVal;
		},
		_chboxClick: function (e) {
			if (!!e) {
				e.stopPropagation();
			}
			KL.Utils.Log.write("CheckBox._chboxClick: called");
			if (!!this._chbox) {
				var val = this._chbox.attr("checked");
				this.setValue(!!val);
				this._fireChangeEvent();
			}
		}
	};
	KL.Web.Controls.registerClass("CheckBox", CheckBox);
	CheckBox.extend(KL.Web.Controls.Control);
})()
;
(function () {
	var Button = function (id, setting) {
		Button._super.call(this, id, setting);
	};
	
	Button.prototype = {
		_enabled: true,
		text: "",
		width: 0,
		onBtnInited: function () { },
		setText: function (txt) {
			var localization = KL.Utils.Localization.getInstance();
			if (localization.stringExists(txt))
				txt = localization.getLocaleString(txt);
			var elt = this.getElt();
			if (elt)
				elt.find(".btnText").html(txt);
		},
		onInitInteraction: function () {
			var elt = this.getElt();
			if (elt) {
				elt.click(KL.Utils.Delegate.create(this, this._clickHandler));
				if (!!this._value || !!this.text) {
					this.setText(this._value || this.text);
				}
				if (!isNaN(this.width) && this.width > 0)
					elt.find(".center").css({ "min-width": 0, "width": this.width });
				if (!isNaN(this.left) && this.left > 0)
					elt.css({ "position": "absolute", "left": this.left });
				if (typeof (this.onBtnInited) == "function")
					this.onBtnInited();
			}
		},
		onToggleEnabled: function () {
			var elt = this.getElt();
			if (elt)
				elt.toggleClass("btnDisabled", !this._enabled);
		},
		_clickHandler: function (e) {
			if (!!e) {
				e.preventDefault();
				e.stopPropagation();
			}
			if (!this._enabled)
				return;
			$(this).trigger("onclick", this._setting ? this._setting.getValue() : null);
		},
		onDataBind: function (data) {
			this.setText(data);
		}
	};
	KL.Web.Controls.registerClass("Button", Button);
	Button.extend( KL.Web.Controls.Control );
})()
;
(function () {
	var LinkButton = function (id, setting) {
		LinkButton._super.call(this, id, setting);
	};
	LinkButton.prototype = {
		_enabled: true,
		text: "",
		helper: "",
		helpermethod: "",
		applyText: function (evt, txt) {
			this.setText(txt);
		},
		setText: function (txt) {
			var localization = KL.Utils.Localization.getInstance();
			txt = this._tryApplyHelper(txt);
			if (localization.stringExists(txt))
				txt = localization.getLocaleString(txt);
			var elt = this.getElt();
			if (elt) {
				elt.html(txt);
				if (this.helper) {
					localization.applyStingObjs(this.id, elt);
					KL.Utils.DateHelper.applyLocaleDates(this.id, elt);
				}
			}
		},
		_tryApplyHelper: function (data) {
			var retVal = data;
			if (this.helper) {
				try {
					var h = eval("(" + this.helper + ")");
					if ((typeof (h[this.helpermethod]) + "").toLowerCase() == "function")
						retVal = h[this.helpermethod](data, this.id);
				} catch (e) {  }
			}
			return retVal;
		}
	};
	KL.Web.Controls.registerClass("LinkButton", LinkButton);
	LinkButton.extend(KL.Web.Controls.Button);
})()
;
(function(){
	var HelpBtn = function(id, setting){
		HelpBtn._super.call(this, id, setting);
	};
	HelpBtn.prototype = {
		_baseUrl: "help/{0}/index.htm",
		setText: function(){},
		_clickHandler: function (e) {
			if (!!e) {
				e.preventDefault();
				e.stopPropagation();
			}
			if (!this._enabled)
				return;
			var lang = KL.Web.Application.getContext().getLanguage();
			var url = KL.Utils.StringHelper.format( this._baseUrl, lang );
			window.open(url, "klmsHelp", "");
		}
	}
	KL.Web.Controls.registerClass("HelpBtn", HelpBtn);
	HelpBtn.extend(KL.Web.Controls.Button);
})();
;
(function () {
	var ListViewControl = function (id, setting) {
		ListViewControl._super.call(this, id, setting);
	};
	ListViewControl.prototype = {
		_listContainer: null,
		_template: null,
		_data: null,
		idField: "",
		onBeforeDataBind: function () { },
		
		getKeyDataFromIdField: function (data){
				return data[this.idField];
		},
		
		setValue: function (val) {
			if (this._listContainer) {
				this._listContainer.empty();
				if (this._setting)
					this._setting.applyData(null, val, true);
			}
		},
		onInitInteraction: function () {
			this._listContainer = this.getElt();
			if (this._listContainer)
				this._initList();
		},
		_initList: function () {
			this._template = new KL.Utils.Template(this._listContainer.html());
			this._listContainer.empty();
		},
		dataBound: function (strOut) { },
		itemDataBind: function (itemData) { },
		itemDataBound: function (row, itemData) { },
		onDataBind: function (data) {
			if (this.onBeforeDataBind(data) === false)
				return;
			this._data = null;
			if (data.items) {
				this._listContainer.empty();
				this._data = data;
				for (var i = 0, l = data.items.length; i < l; i++) {
					var item_i = data.getItem?data.getItem(i):data.items[i];
						proceed_i = this.itemDataBind(item_i, i);
					if (proceed_i !== false) {
						var row = $(this._template.bindData(item_i))
							.appendTo(this._listContainer)
							.addClass((i % 2 ? "oddItem" : "evenItem"))
							.mouseover(function () { $(this).addClass("itemOver"); })
							.mouseout(function () { $(this).removeClass("itemOver"); })
							.data("itemData", item_i);
						this.itemDataBound(row, item_i);
					}
				}
			}
			this.dataBound(this._data);
		},
		onHidden: function () {
			if (this._listContainer)
				this._listContainer.empty();
		}
	};
	KL.Web.Controls.registerClass("ListViewControl", ListViewControl);
	ListViewControl.extend( KL.Web.Controls.Control );
})()
;
(function () {
	var ModalDialog = function (id) {
		ModalDialog._super.call( this, id, null );
	};
	ModalDialog.prototype = {
		width: 500,
		_title: "",
		_dialogClass: "",
		onDialogInit: function () { },
		setDialogClass: function (val) {
			var elt = this.getElt();
			if (elt)
				elt.dialog("option", { dialogClass: "modalDialog " + val });
			this._dialogClass = val;
		},
		setTitle: function (val) {
			this._title = val;
			var elt = this.getElt();
			if (elt)
				elt.dialog("option", "title", this.getTitle());
		},
		getTitle: function () {
			var localization = KL.Utils.Localization.getInstance();
			var text = this._title;
			if (localization.stringExists(text))
				text = localization.getLocaleString(text);
			var data = this._page.getApplication().getContext().getData();
			if (data)
				text = KL.Utils.StringHelper.formatTemplate(text, data);
			return text;
		},
		onInitInteraction: function () {
			var Delegate = KL.Utils.Delegate;
			var elt = this.getElt();
			if (elt) {
				elt.dialog({
					dialogClass: "modalDialog" + (this._dialogClass ? " " + this._dialogClass : ""),
					modal: true,
					autoOpen: false,
					resizable: false,
					height: "auto",
					minHeight: 0,
					beforeClose: Delegate.create(this, this._onBeforeCloseHandler),
					open: Delegate.create(this, this._onOpenHandler),
					close: Delegate.create(this, this._onCloseDialog)
				});
			}
			if (typeof (this.onDialogInit) == "function")
				this.onDialogInit();
		},
		_onBeforeCloseHandler: function () {
			$(this).trigger("onbeforeclose", [this]);
		},
		_onOpenHandler: function () {
			this._hidden = false;
			$(this).trigger("onshow", [this]);
		},
		onShown: function () {
			$(this).trigger("onbeforeopen", [this]);
			var elt = this.getElt();
			if (elt) {
				elt.dialog("option", {
					title: this.getTitle(),
					width: this.width,
					dialogClass: "modalDialog" + (this._dialogClass ? " " + this._dialogClass : ""),
					position: ["center", 100]
				});
				elt.dialog("open");
				$(document.body).css("overflow", "hidden");
			}
		},
		closeDialog: function () {
			var elt = this.getElt();
			if (elt)
				elt.dialog("close");
		},
		_onCloseDialog: function () {
			this.hide();
			$(document.body).css("overflow", "auto");
			$(this).trigger("ondialogclose", [this]);
		}
	};
	KL.Web.Controls.registerClass("ModalDialog", ModalDialog);
	ModalDialog.extend( KL.Web.Controls.Control );
})()
;
(function () {
	var CheckBoxList = function (id, setting) {
		CheckBoxList._super.call(this, id, setting);
	};
	KL.Web.Controls.registerClass("CheckBoxList", CheckBoxList);
	CheckBoxList.extend(KL.Web.Controls.Control);
})()
;
(function () {
	var GridViewControl = function (id, setting) {
		GridViewControl._super.call(this, id, setting );
	};
	GridViewControl.prototype = {
		pageSize: 40,
		cellHeight: 10,
		pageNum: 0,
		filterName: "",
		filterValue: "",
		sortBy: "",
		sortOrder: 0,
		rowsselectable: true,
		rowshoverable: true,
		enterrowonclick: false,
		_currCount: 0,
		_allSelected: false,
		selectedCount: 0,
		selectedItems: null,
		usectrlclick: false,
		multiselect: true,
		columns: null,
		checkboxenabled: true,
		gridDataBound: function (strOut) { },
		onRowEnter: function (strOut) { },
		onGridInit: function (elt) { },
		onBeforeItemSelected: function (elt) { },
		onInitInteraction: function () {
			var elt = this.getElt();
			if (elt) {
				this._listContainer = elt.find(".gridContent .item").parent();
				this.rowsselectable = (this.rowsselectable == "true") ||
					(this.rowsselectable == "True") ||
					(this.rowsselectable == 1) || this.rowsselectable;
				if (this.columns)
					this._initColumns();
				this._initList();
				if (this.checkboxenabled && elt.find(".gridHeader input[type=checkbox]").length > 0) {
					elt.find(".gridHeader input[type=checkbox]").click(KL.Utils.Delegate.create(this, this._selectAllRows));
				}
				if (typeof (this.onGridInit) == "function")
					this.onGridInit(elt);
			}
			this.selectedItems = {};
		},
		
		
		resizeGrid: function(){
			var elt = this.getElt();
			if (elt) {
				var gridContentHeight = elt.find(".gridContent");
				var scrollHeight = gridContentHeight[0].scrollHeight;
				var clientHeight = gridContentHeight[0].clientHeight;
				KL.Utils.Log.write("GridViewControl.resizeGrid: scrollHeight=" + scrollHeight+" clientHeight="+clientHeight);
				return (scrollHeight>clientHeight) ;
			}
		},
		
		getGridLength: function(from){
			var result = this._data.items.length;
			if (this.isSetPageSize)
				result = Math.min(this._data.items.length, from + (this.pageSize-this._currCount));
			return result;
		},
		
		initPageSize: function(row,value){
			if (!this.isSetPageSize)
				if (this.resizeGrid()) {
					row.hide();
					this.pageSize = value;
					this._data.pageSize = this.pageSize;
					return true;
				}
			return false;
		},
		
		
		isSetPageSize: false,
		getPageNum: function () { return this.pageNum; },
		getPageSize: function () { return this.pageSize; },
		getFilterName: function () { return this.filterName; },
		getFilter: function () { return this.filterValue; },
		getSortBy: function () { return this.sortBy; },
		getSortOrder: function () { return this.sortOrder; },
		setPageNum: function (e, pageNum) {
			KL.Utils.Log.write("GridViewControl.constructor: page num=" + pageNum);
			this.pageNum = pageNum || 0;
			$(this).trigger("onpagechange", [this]);
		},
		setPageSize: function (e, pageSize) {
			this.pageSize = pageSize;
			this.isSetPageSize = true;
			$(this).trigger("onpagechange", [this]);
		},
		_initColumns: function () {
			var elt = this.getElt();
			if (elt) {
				var localization = KL.Utils.Localization.getInstance();
				var header = elt.find(".headerCell").parent();
				var row = elt.find(".cell").parent();
				if (header.length > 0 && row.length > 0) {
					var headerCellHtml = header.html();
					var cellHtml = row.html();
					header.empty();
					row.empty();
					for (var i = 0; i < this.columns.length; i++) {
						var title = this.columns[i].title;
						if (localization.stringExists(title))
							title = localization.getLocaleString(title);
						$(headerCellHtml).appendTo(header).html(title);
						var cellDataTpl = "{" + (this.columns[i].datafield ? this.columns[i].datafield : "cell" + i) + "}";
						$(cellHtml).appendTo(row).html(cellDataTpl);
					}
				}
			}
		},
		itemDataBound: function (row, itemData) {
			var rowId = this.getKeyDataFromIdField(itemData);
			if (this.selectedItems[rowId])
				this._toggleRowSelection(row, true);
		},
		dataBound: function (data) {
			var Delegate = KL.Utils.Delegate;
			this._listContainer.find(".gridRow").each(Delegate.create(this, this._initRowInteractions));
			this._fireRowSelectionEvt();
			if (typeof (this.gridDataBound) == "function")
				this.gridDataBound(data);
			$(this).trigger("ondatabound", [this._data]);
		},
		_initRowInteractions: function (indx, row) {
			var Delegate = KL.Utils.Delegate;
			row = $(row);
			if (!row.data("is-row-interaction-enabled")) {
				row.data("is-row-interaction-enabled", true);
				row.click(Delegate.create(this, this.rowClick, row))
					.find("a").click(Delegate.create(this, this._editRowClickHandler, row));
				if (this.checkboxenabled)
					row.find("input[type=checkbox]").eq(0).click(Delegate.create(this, this.toggleRow, row));
				if (this.rowshoverable) {
					row.hover(
						function () { $(this).addClass("rowOver"); },
						function () { $(this).removeClass("rowOver"); }
					);
				}
			}
		},
		rowClick: function (row, e) {
			if (this.rowsselectable) {
				var isOn = row.data("rowFlag");
				KL.Utils.Log.write("GridViewControl.rowClick: " + typeof isOn);
				if (this.checkboxenabled)
					row.find("input[type=checkbox]").eq(0).attr("checked", !isOn);
				this.toggleRow(row, e);
			} else if (this.enterrowonclick) {
				this._editRowClickHandler(row, e);
			}
		},
		_editRowClickHandler: function (row, e) {
			e.preventDefault();
			e.stopPropagation();
			this._removeSelection();
			if (this.onRowEnter(row, e) !== false)
				$(this).trigger("onrowenter", [row]);
		},
		_selectAllRows: function (e) {
			var elt = this.getElt();
			if (elt) {
				var isOn = elt.find(".gridHeader input[type=checkbox]").is(":checked");
				this.selectedItems = {};
				this._listContainer.find(".item").each(KL.Utils.Delegate.create(this, function (indx, item) {
					var $item  = $(item);
					if ((typeof (this.onBeforeItemSelected) == "function" && this.onBeforeItemSelected($item) === false) || $item.is( ":hidden" ))
						return;
					this._toggleRowSelection($item, isOn);
					if (isOn) {
						var rowData = $item.data("itemData");
						var rowId = this.getKeyDataFromIdField(rowData); ////rowData[this.idField];
						this.selectedItems[rowId] = rowData;
					}
				}));
				this._fireRowSelectionEvt();
			}
		},
		
		toggleRow: function (row, e) {
			e.stopPropagation();
			KL.Utils.Log.write("GridViewControl.toggleRow: " + row.data("rowFlag"));
			var elt = this.getElt();
			if (typeof (this.onBeforeItemSelected) == "function" && this.onBeforeItemSelected(row) === false)
				return;
			if (elt && this.checkboxenabled)
				elt.find(".gridHeader input[type=checkbox]").attr("checked", false);
			this._toggleRowSelected(row, e);
			this._fireRowSelectionEvt();
		},
		_toggleRowSelected: function (row, evt) {
			var isOn = !row.data("rowFlag");
			var rowData = row.data("itemData");
			var rowId = this.getKeyDataFromIdField(rowData); //rowData[this.idField];
			if ((evt && !evt.ctrlKey && this.usectrlclick) || !this.multiselect)
				this._removeSelection();
			this._toggleRowSelection(row, isOn);
			if (isOn) {
				this.selectedItems[rowId] = rowData;
			} else {
				if (this.selectedItems[rowId])
					delete this.selectedItems[rowId];
			}
		},
		_toggleRowSelection: function (row, isOn) {
			row.toggleClass("rowSelected", isOn);
			if (this.checkboxenabled)
				row.find("input[type=checkbox]").eq(0).attr("checked", isOn);
			row.data("rowFlag", isOn);
		},
		getSeletedRowsId: function () {
			var data = [];
			for (var itemId in this.selectedItems)
				data.push(itemId);
			return data;
		},
		getSelectedCount: function(){
			var count = 0;
			for( var i in this.selectedItems )
				count++;
			return count;
		},
		deleteRows: function () {
			var Delegate = KL.Utils.Delegate;
			var localization = KL.Utils.Localization.getInstance();
			var count = this.getSelectedCount();
			var dialogResult = this._page.getApplication().openConfirm(
				localization.makeLocaleStringObj(this.id, "LabelDeleteItemsConfirm", count),
				localization.getLocaleString("LabelTitleDeleteItems"),
				{ "ok": "BtnDelete", "cancel": "BtnCancel" }
			);
			$(dialogResult).bind("onok", Delegate.create(this, this._deleteSelected));
			localization.applyStingObjs(this.id, dialogResult.elt);
		},
		_removeSelection: function () {
			this.selectedItems = {};
			var rows = this._listContainer.find(".rowSelected").removeClass("rowSelected");
			rows.data("rowFlag", false);
			if (this.checkboxenabled) {
				this._listContainer.closest(".grid").find(".gridHeader input[type=checkbox]").attr("checked", false);
				rows.find("input[type=checkbox]").attr("checked", false);
			}
		},
		_deleteSelected: function () {
			var data = this.getSeletedRowsId();
			$(this).trigger("onrowsdelete", [this.idField, data]);
		},
		_fireRowSelectionEvt: function () {
			$(this).trigger("onrowselected", [this.getSelectedCount()]);
		}
	};
	KL.Web.Controls.registerClass("GridViewControl", GridViewControl);
	GridViewControl.extend(KL.Web.Controls.ListViewControl);
})()
;
(function () {
	var HiddenField = function (id, setting) {
		HiddenField._super.call(this, id, setting);
	};
		
	HiddenField.prototype = {
		getValue: function () {
			return $.trim(this.getElt().val());
		},
		setValue: function (str) {
			if (!this.validate(str)) {
				KL.Utils.Log.write("HiddenField.setValue: " + str + " is not a valid value");
				return;
			}
			if (this._setting) {
				this._setting.setValue(str);
			}
			this.getElt().val(str);
		}
	};
	KL.Web.Controls.registerClass("HiddenField", HiddenField);
	HiddenField.extend(KL.Web.Controls.Control);
})()
;
(function () {
	var TextBox = function (id, setting) {
		TextBox._super.call( this, id, setting );
	};
	TextBox.prototype = {
		placeholder: "",
		input: null,
		onInitInteraction: function () {
			this._initFieldInteraction();
		},
		_initFieldInteraction: function () {
			var Delegate = KL.Utils.Delegate;
			this.keypresTimer = null;
			var elt = this.getElt();
			if (elt) {
				this.input = elt;
				elt.blur(Delegate.create(this, this._fireOnChange))
					.keyup(Delegate.create(this, this._textChangeHandler));
				if (this.placeholder)
					this._initPlaceholder(elt);
			}
		},
		_initPlaceholder: function (elt) {
			var localization = KL.Utils.Localization.getInstance();
			var text = this.placeholder;
			if (localization.stringExists(text))
				text = localization.getLocaleString(text);
			var placeholder_support = !!('placeholder' in document.createElement('input'));
			if (!placeholder_support) {
				this.input.wrap("<span class='inputWrap'></span>");
				var wrap = this.input.closest(".inputWrap");
				var placeholder = $("<span class='placeholder'></span>").appendTo(wrap);
				placeholder.click(KL.Utils.Delegate.create(this, this._hidePlaceholder, this.input, placeholder, false));
				this.input.blur(KL.Utils.Delegate.create(this, this._showPlaceholder, this.input, placeholder))
					.focus(KL.Utils.Delegate.create(this, this._hidePlaceholder, this.input, placeholder, true));
				placeholder.text(text);
			} else
				this.input.attr("placeholder", text);
		},
		_hidePlaceholder: function (tb, ph, escFocus) {
			ph.hide();
			if (!escFocus)
				tb.focus();
		},
		_showPlaceholder: function (tb, ph) {
			if ($.trim(tb.val()) == '')
				ph.show()
		},
		setFieldValue: function (str) {
			if (!!this.input)
				this.input.val(str);
		},
		getValue: function () {
			var val = "";
			if (!!this.input)
				val = $.trim(this.input.val());
			return val;
		},
		setValue: function (str) {
			Log.write("TextBox.setValue: called");
			if (!this.validate(str)) {
				Log.write("TextBox.setValue: " + str + " is not a valid value");
				return;
			}
			if (this._setting)
				this._setting.setValue(str);
			this.setFieldValue(str);
		},
		onDataBind: function (data) {
			this.setFieldValue(data);
		},
		_textChangeHandler: function () {
			if (this.keypresTimer != null)
				window.clearTimeout(this.keypresTimer);
			this.keypresTimer = window.setTimeout(KL.Utils.Delegate.create(this, this._fireOnChange), 400);
		},
		_fireOnChange: function () {
			var Log = KL.Utils.Log;
			this.keypresTimer = null;
			Log.write("TextBox._fireOnChange: Called");
			var val = this.getValue();
			if (!val)
				return;
			Log.write("TextBox._fireOnChange: firing event");
			this._fireChangeEvent();
		},
		onHidden: function () {
			this.input = null;
		}
	};
	KL.Web.Controls.registerClass("TextBox", TextBox);
	TextBox.extend(KL.Web.Controls.Control);
})()
;
(function () {
	var AutocompleteBox = function (id, setting) {
		this.keypresTimer = null;
		AutocompleteBox._super.call(this, id, setting );
	};
	AutocompleteBox.prototype = {
		helper: null,
		multiselect: false,
		_value: null,
		_input: null,
		_ddown: null,
		_datacource: null,
		_overItem: null,
		_currentIndx: null,
		_revHash: null,
		getValue: function () {
			var Log = KL.Utils.Log;
			this._value = null;
			var val = $.trim(this._input.val()).toLowerCase();
			if (!!val) {
				if (this.multiselect) {
					this._value = [];
					var terms = val.split(/[,]/gi);
					for (var i = 0, l = terms.length; i < l; i++) {
						var term_i = $.trim(terms[i]);
						if (!!this._revHash[term_i]) {
							this._value.push(this._revHash[term_i]);
						} // else
					}
					this._value = this._value.length > 0 ? this._value : null;
				} else {
					this._value = this._revHash[val] || null;
				}
			} // else
			return this._value;
		},
		onInit: function () {
			if (!!this.helper) {
				try {
					this.helper = eval("(" + this.helper + ")");
				} catch (e) {
					this.helper = null;
				}
			}
			var Delegate = KL.Utils.Delegate;
			this._input = this.getElt().find("input");
			this._ddown = $('<ul class="autocompleteDDown"></ul>').appendTo($(document.body));
			this._input.val("");
			this._ddown.empty().hide();
			this._input
				.keyup(Delegate.create(this, this._tryOpen))
				.blur(Delegate.create(this, this._tryClose));
		},
		_openTimer: null,
		_closeTimer: null,
		_isopen: false,
		_tryOpen: function (evt) {
			if (this._openTimer)
				window.clearTimeout(this._openTimer);
			if (!!evt) {
				evt.preventDefault();
				evt.stopPropagation();
			}
			this._openTimer = null;
			switch (evt.keyCode) {
				case 13:
					this._itemSelect(this._overItem);
				case 27:
					this._close();
					return false;
					break;
				case 38:
					this._goPrev();
					break;
				case 40:
					this._goNext();
					break;
				default:
					this._openTimer = window.setTimeout(KL.Utils.Delegate.create(this, this._open), 300);
					break;
			}
		},
		_tryClose: function () {
			if (this._closeTimer)
				window.clearTimeout(this._closeTimer);
			this._closeTimer = window.setTimeout(KL.Utils.Delegate.create(this, this._close), 300);
		},
		_open:  function () {
			this._overItem = null;
			this._currentIndx = null;
			this._isopen = true;
			this._ddown.empty();
			var val = $.trim(this._input.val()).toLowerCase();
			if (!!val) {
				if (this.multiselect) {
					var terms = val.split(/[,]/gi);
					val = terms.pop();
				}
				var itesCount = 0;
				for (var i = 0, l = this._datacource.length; i < l; i++) {
					if ((this._datacource[i].label + "").toLowerCase().indexOf(val) != -1) {
						this._renderItem(this._datacource[i]);
						itesCount++;
					}
				}
				if (itesCount > 0) {
					this._ddown.show();
					var elt = this.getElt();
					var pos = elt.offset();
					this._ddown.css({
						"width": elt.width(),
						"left": pos.left,
						"top": pos.top + elt.height()
					});
				}
			} else {
				this._triggerEvt();
				this._close();
			}
		},
		_close: function () {
			if (this._closeTimer)
				window.clearTimeout(this._closeTimer);
			this._closeTimer = null;
			this._ddown.hide().empty();
		},
		_goNext: function () {
			if (this._isopen) {
				var indx = this._currentIndx == null ? 0 : this._currentIndx + 1;
				this._goToItem(indx);
			}
		},
		_goPrev: function () {
			if (this._isopen) {
				var indx = this._currentIndx == null ? 0 : this._currentIndx - 1;
				this._goToItem(indx);
			}
		},
		_goToItem: function (indx) {
			var max = this._ddown.find("li").length;
			indx = indx < 0 ? max - 1 : (indx >= max ? 0 : indx);
			this._currentIndx = indx;
			this._itemOver(this._ddown.find("li").eq(indx));
		},
		_itemOver: function (li) {
			this._ddown.find("li").removeClass("over");
			this._overItem = li.data("dataItem");
			li.addClass("over");
		},
		_itemSelect: function (itemData) {
			if (this.multiselect)
				this._selectMultiple(itemData);
			else
				this._selectSingle(itemData);
			this._triggerEvt();
			return false;
		},
		_triggerEvt: function () {
			$(this).trigger("onchange", [this.getValue()]);
		},
		_selectSingle: function (itemData) {
			this._input.val(itemData.value);
		},
		_selectMultiple: function (itemData) {
			var terms = (this._input.val() + "").split(/[,]/gi);
			terms.pop();
			terms.push(itemData.value);
			this._input.val(terms.join(","));
		},
		_renderItem: function (item) {
			var Delegate = KL.Utils.Delegate;
			var itemElt = $("<li></li>")
				.data("dataItem", item)
				.appendTo(this._ddown);
			$("<a>" + item.label + "</a>").appendTo(itemElt)
				.mouseover(Delegate.create(this, this._itemOver, itemElt))
				.click(Delegate.create(this, this._itemSelect, item));
			return itemElt;
		},
		applyDataset: function (e, data) {
			if (data.items) {
				var ds = this.helper ? this.helper.getDataSource(data.items) : data.items;
				this._revHash = {};
				for (var i = 0, l = ds.length; i < l; i++) {
					var c = 1;
					var val = ds[i].value;
					while (!!this._revHash[ds[i].value.toLowerCase()]) {
						ds[i].value = val + " (" + c + ")";
						c++;
					}
					this._revHash[ds[i].value.toLowerCase()] = ds[i];
				}
				this._datacource = ds;
				this._triggerEvt();
			}
		}
		
	};
	KL.Web.Controls.registerClass("AutocompleteBox", AutocompleteBox);
	AutocompleteBox.extend( KL.Web.Controls.TextBox );
})()
;
(function () {
	var PasswdBox = function (id, setting) {
		PasswdBox._super.call(this, id, setting);
	};
	PasswdBox.prototype = {
		_dummyValue: "",
		_checkFocus: function () {
			var elt = this.getElt();
			if (elt.val() == this._dummyValue)
				elt.val("");
		},
		_checkBlur: function () {
			if ($.trim(this.getElt().val()) == "")
				this.setFieldValue("");
		},
		onInitInteraction: function () {
			var Delegate = KL.Utils.Delegate;
			var elt = this.getElt();
			if (elt) {
				this.input = elt;
				elt.focus(Delegate.create(this, this._checkFocus))
					.blur(Delegate.create(this, this._checkBlur))
					.keyup(Delegate.create(this, this._textChangeHandler));
				if (this.placeholder)
					this._initPlaceholder(elt);
			}
			this.setFieldValue("");
		},
		getValue: function () {
			var val = "";
			if (!!this.input)
				val = $.trim(this.input.val());
			return val == this._dummyValue ? "" : val;
		},
		setFieldValue: function (str) {
			var elt = this.getElt();
			if ($.trim(str) != "")
				elt.val(str);
			else
				elt.val(this._dummyValue);
		}
	};
	KL.Web.Controls.registerClass("PasswdBox", PasswdBox);
	PasswdBox.extend(KL.Web.Controls.TextBox);
})()
;
(function () {
	var FormControl = function (id, setting) {
		FormControl._super.call(this, id, setting);
	};
	FormControl.prototype = {
		_form: null,
		_bindData: function (data) { },
		successWrap: ".successMsg",
		_checkFieldTimeoutId: null,
		_toggleSubmitEnabled: function (enabled) {
			this._form.find("button[type=submit], input[type=submit]").attr("disabled", !enabled);
		},
		getValue: function () {
			return this.getValueRecursive();
		},
		getValueRecursive: function () {
			var arrData = this._form.serializeArray();
			var data = {};
			for (var i = 0, l = arrData.length; i < l; i++) {
				if (data[arrData[i].name]) {
					data[arrData[i].name] = ([]).concat(data[arrData[i].name]).concat(arrData[i].value);
				} else
					data[arrData[i].name] = arrData[i].value;
			}
			return data;
		},
		onFormInit: function () { },
		onFormSubmit: function () { },
		onBeforeShow: function () {
			this.hideError();
			this.hideSuccess();
			this._form.find("input[type=text], input[type=password]").val("");
			this.checkFieldEmpty(true);
		},
		setValue: function (data) {
			if (!this.validate(data))
				throw "Invalid value";
			this._bindData(data);
		},
		onInitInteraction: function () {
			var Delegate = KL.Utils.Delegate;
			var elt = this.getElt();
			if (!elt) {
				KL.Utils.Log.write(this + "[" + this.id + "]" + ".onInitInteraction: No element is found", KL.Utils.Log.type.WARNING);
				return;
			}
			this._form = elt.find("form");
			this._form.submit(Delegate.create(this, this._submitHandler))
				.find("input[type=text],input[type=password],select")
				.click(Delegate.create(this, this.checkFieldEmpty, false))
				.keyup(Delegate.create(this, this.checkFieldEmpty, false))
				.change(Delegate.create(this, this.checkFieldEmpty, false)).val("");
			this.hideError();
			this.hideSuccess();
			if ((typeof (this.onFormInit) + "").toLowerCase() == "function")
				this.onFormInit();
		},
		onToggleEnabled: function (isEnabled) {
			this._form.find("input,select,textarea,button").attr("disabled", !isEnabled);
		},
		_submitHandler: function () {
			var proceed = true;
			var Log = KL.Utils.Log;
			if ((typeof (this.onFormSubmit) + "").toLowerCase() == "function")
				proceed = this.onFormSubmit();
			if (proceed || typeof (proceed) == "undefined") {
				$(this).trigger("onformsubmit", [this.getValueRecursive()]);
			}
			return false;
		},
		_isEnabled: function(){
			var enabled = true;
			this._form.find("input[required], textarea[required], select[required]").each(
				function () {
					enabled = enabled && !!($.trim($(this).val() + ""));
				}
			);
			if (this._children) {
				for (var i = 0, l = this._children.length; i < l; i++) {
					enabled = enabled && this._children[i].validate();
				}
			}
			return enabled ;
		},
		
		checkFieldEmpty: function (escTimeout) {
			var enabled = this._isEnabled();
			this._toggleSubmitEnabled(enabled)
			var Delegate = KL.Utils.Delegate;
			if (enabled) {
				this.hideError();
				this.hideSuccess();
				window.clearInterval(this._checkFieldTimeoutId);
				this._checkFieldTimeoutId = null;
			} else if (!this._checkFieldTimeoutId && !escTimeout && !this._hidden)
				this._checkFieldTimeoutId = window.setInterval(Delegate.create(this, this.checkFieldEmpty, false), 300);
		},
		showSuccess: function () {
			this._form.find(this.successWrap).show();
		},
		hideSuccess: function () {
			if ((typeof (this.onSuccessHide) + "").toLowerCase() == "function")
				this.onSuccessHide();
			this._form.find(this.successWrap).hide();
		}
	};
	KL.Web.Controls.registerClass("FormControl", FormControl);
	FormControl.extend( KL.Web.Controls.Control );
})()
;
(function () {
	var Label = function (id, setting) {
		Label._super.call(this, id, setting);
	};
	Label.prototype = {
		text: "",
		helper: "",
		helpermethod: "",
		applyText: function (evt, txt) {
			this.setText(txt);
		},
		setText: function (txt) {
			var localization = KL.Utils.Localization.getInstance();
			txt = this._tryApplyHelper(txt);
			if (localization.stringExists(txt))
				txt = localization.getLocaleString(txt);
			var elt = this.getElt();
			if (elt) {
				elt.html(txt);
				if (this.helper) {
					localization.applyStingObjs(this.id, elt);
					KL.Utils.DateHelper.applyLocaleDates(this.id, elt);
				}
			}
		},
		onInitInteraction: function () {
			if (!!this._value || !!this.text)
				this.setText(this._value || this.text);
		},
		_tryApplyHelper: function (data) {
			var retVal = data;
			if (this.helper) {
				try {
					var h = eval("(" + this.helper + ")");
					if ((typeof (h[this.helpermethod]) + "").toLowerCase() == "function")
						retVal = h[this.helpermethod](data, this.id);
				} catch (e) {  }
			}
			return retVal;
		},
		onDataBind: function (data) {
			this.setText(data);
		}
	};
	KL.Web.Controls.registerClass("Label", Label);
	Label.extend(KL.Web.Controls.Control);
})()
;
(function () {
	var RadioButtonsList = function (id, setting) {
		RadioButtonsList._super.call(this, id, setting);
	};
	RadioButtonsList.prototype = {};
	KL.Web.Controls.registerClass("RadioButtonsList", RadioButtonsList);
	RadioButtonsList.extend(KL.Web.Controls.ListViewControl);
})()
;
(function () {
	var Panel = function (id, setting) {
		Panel._super.call(this, id, setting);
	};
	Panel.prototype = {};
	KL.Web.Controls.registerClass("Panel", Panel);
	Panel.extend(KL.Web.Controls.Control);
})()
;
(function () {
	var TitledPanel = function (id, setting) {
		TitledPanel._super.call( this, id, setting );
	};
	TitledPanel.prototype = {
		titletext: "",
		onInitInteraction: function () {
			var elt = this.getElt();
			if (elt) {
				if (this.titletext) {
					var localization = KL.Utils.Localization.getInstance();
					if (localization.stringExists(this.titletext))
						this.titletext = localization.getLocaleString(this.titletext);
					elt.find(">.pnlTitle")
						.find(".titleText").html(this.titletext);
				}
			}
		}
	};
	
	KL.Web.Controls.registerClass("TitledPanel", TitledPanel);
	TitledPanel.extend(KL.Web.Controls.Control);
})()
;
(function () {
	var CollapsePanel = function (id, setting) {
		CollapsePanel._super.call(this, id, setting);
	};
	CollapsePanel.prototype = {
		titletext: "",
		_collapsed: false,
		onInitInteraction: function () {
			var localization = KL.Utils.Localization.getInstance();
			this._collapsed = true;
			this._setPanelClass();
			var elt = this.getElt();
			if (localization.stringExists(this.titletext))
				this.titletext = localization.getLocaleString(this.titletext);
			elt.find(".pnlTitle")
				.click(KL.Utils.Delegate.create(this, this._togglePanelCollapsed))
				.find(".titleText").html(this.titletext);
			elt.find(".pnlPreview:eq(0)").show();
			elt.find(".pnlContent:eq(0)").hide();
		},
		collapsePanel: function () {
			this._collapsed = false;
			this._togglePanelCollapsed();
		},
		expandPanel: function () {
			if (!!this._enabled) {
				this._collapsed = true;
				this._togglePanelCollapsed();
			}
		},
		onToggleEnabled: function (isEnabled) {
			if (!isEnabled) {
				this.collapsePanel();
			}
		},
		_togglePanelCollapsed: function () {
			this._collapsed = !this._collapsed;
			var elt = this.getElt();
			elt.find(".pnlPreview:eq(0)")[!this._collapsed ? "slideUp" : "slideDown"]("fast");
			elt.find(".pnlContent:eq(0)")[!this._collapsed ? "slideDown" : "slideUp"](
				"fast",
				KL.Utils.Delegate.create(this, this._setPanelClass)
			);
			$(this).trigger(this._collapsed ? "oncollapsed" : "onexpanded");
		},
		_setPanelClass: function () {
			this.getElt().toggleClass("expanded", !this._collapsed);
		}
	};
	KL.Web.Controls.registerClass("CollapsePanel", CollapsePanel);
	CollapsePanel.extend( KL.Web.Controls.Panel );
})()
;
(function () {
	var Toolbar = function (id, setting) {
		Toolbar._super.call( this, id, setting );
	};
	Toolbar.prototype = {
		titletext: "",
		isbottom: false,
		istall: false,
		onInitInteraction: function () {
			var elt = this.getElt();
			if (!!elt) {
				if (!!this.titletext) {
					var localization = KL.Utils.Localization.getInstance();
					if (localization.stringExists(this.titletext))
						this.titletext = localization.getLocaleString(this.titletext);
					elt.find(".barTitle").html(this.titletext);
				}
				if (this.isbottom)
					elt.addClass("bottomToolbar");
				if (this.istall)
					elt.addClass("tallToolbar");
			}
		},
		toggleButtons: function (evt, count) {
			KL.Utils.Log.write("Toolbar.toggleButtons["+this.id+"]: Called " + count);
			if (!count) $(this).trigger("onactionsdisabled");
			else
			if (count == 0) {
				$(this).trigger("onactionsdisabled");
			} else if (count == 1) {
				$(this).trigger("onsingleitemaction");
			} else {
				$(this).trigger("onmultipleitemsaction");
			}
		},
		
		setPriorityButtons: function (evt, type) {
			switch (type){
				case 0 : $(this).trigger("ondownprioritydisabled");break;
				case 1 : $(this).trigger("onupprioritydisabled");break;
				case 2 : $(this).trigger("onupdownprioritydisabled");break;
				default : 
			}
		}
	};
	KL.Web.Controls.registerClass("Toolbar", Toolbar);
	Toolbar.extend(KL.Web.Controls.Control);
})()
;
(function () {
	var TabPanel = function (id, setting) {
		TabPanel._super.call(this, id, setting);
	};
	TabPanel.prototype = {
		onInit: function () { },
		onShow: function () { }
	};
	KL.Web.Controls.registerClass("TabPanel", TabPanel);
	TabPanel.extend( KL.Web.Controls.Panel );
})()
;
(function () {
	var TabsList = function (id, initValue) {
		TabsList._super.call(this, id, initValue);
	};
	TabsList.prototype = {
		selectedItem: 0,
		_tabContainer: null,
		items: null,
		tabs: null,
		typeAccount: "",
		separatorText: "",
		onTabInit: function () { },
		onTabsInited: function () { },
		onTabShow: function () { },
		onInitInteraction: function (panelId) {
			this._tabContainer = this.getElt().find(".tab:eq(0)").parent();
			this._initTabs(panelId);
			if (typeof (this.onTabsInited) == "function")
				this.onTabsInited();
		},
		
		initPageParamChanged: function () {
			this.onPageParamChanged(0);
		},
		isTabVisible: function (val) {
			return KL.Utils.UserHelper.isAllowed(val);
		},
		_initTabs: function (panelId) {
			this.tabs = [];
			this._children = null;
			var s = this;
			var tabTemplate = this._tabContainer.html();
			this._tabContainer.empty();
			var UserHelper = KL.Utils.UserHelper;
			var Delegate = KL.Utils.Delegate;
			for (var i = 0, indx = 0, l = this.items.length; i < l; i++) {
				var dataItem = this.items[i];
				if (UserHelper.isAllowed(dataItem.role_visible)) {
					if (!!this.separatorText && indx > 0)
						this._tabContainer.append(this.separatorText);
					var tab_i = $(tabTemplate).addClass("tabBtn" + i);
					tab_i.appendTo(this._tabContainer)
					.click(Delegate.create(this, this.tabClick, indx))
					.data("tabsItem", dataItem);
					this.tabs.push(tab_i);
					if (typeof (this.onTabInit) == "function")
						this.onTabInit(indx, tab_i, dataItem);
					indx++;
				} else
					this._cancelPanelShow(dataItem.panel);
			}
		},
		onBeforeShow: function () {
			var localization = KL.Utils.Localization.getInstance();
			var val = this.getValue();
			if (!!this.param) {
				var initVal = this._page.getApplication().getPageParam(this.param);
				if (initVal !== null && this.tabs[initVal])
					this.selectedItem = initVal;
			}
			for (var i = 0, l = this.tabs.length; i < l; i++) {
				var dataItem = this.tabs[i].data("tabsItem");
				var text = dataItem.text;
				if (localization.stringExists(text)) {
					text = localization.getLocaleString(text);
					if (val)
						text = KL.Utils.StringHelper.formatTemplate(text, val);
				}
				this.tabs[i].find(".tabBtn").html(text);
				this._initPanel(dataItem.panel, i);
			}
		},
		onShown: function(){
			this._showIndxTab(this.selectedItem);
		},
		_initPanel: function (pnlId, indx) {
			var pnl = this._page.getControl($.trim(pnlId));
			if (pnl)
				$(pnl).one("onbeforeshow", KL.Utils.Delegate.create(this, this._proceedShowing, indx));
		},
		_cancelPanelShow: function (pnlId) {
			var pnl = this._page.getControl($.trim(pnlId));
			if (pnl)
				$(pnl).one("onbeforeshow", function (e) { e.stopPropagation(); });
		},
		openPanel: function (pnlId) {
			this._showPanel(pnlId);
		},
		_showPanel: function (pnlId) {
			for (var i = 0, l = this.tabs.length; i < l; i++) {
				var dataItem = this.tabs[i].data("tabsItem");
				if (dataItem.panel == pnlId) {
					if (this._hidden)
						this.show();
					this._showIndxTab(i);
					return;
				}
			}
		},
		onPageParamChanged: function (pnlId) {
			this._showIndxTab(pnlId);
		},
		getRoleDefaultTab: function () {
			return 0;
		},
		_showIndxTab: function (indx) {
			if (!this.tabs[indx])
				indx = this.getRoleDefaultTab();
			this.selectedItem = indx;
			this._itemClick(this.selectedItem, null);
		},
		tabClick: function (indx, e) {
			if( this._itemClick(indx, e) === false )
				this._page.getApplication().setLastCancelledCtrlEvent(KL.Utils.Delegate.create(this,  this.tabClick, indx, e));
		},
		_itemClick: function (indx, e) {
			if (!!e) {
				e.preventDefault();
				e.stopPropagation();
			}
			if (!this._enabled) return;
			if (!!this.tabs[indx]) {
				this.selectedItem = indx;
				var curPnl = this._hideOthers();
				if (curPnl !== false) {
					$(this.tabs).each(function () { $(this).removeClass("selected"); });
					$(this.tabs[indx]).addClass("selected");
					if (!!curPnl && !curPnl.isVisible() && curPnl.show() === false)
						return false;
					this._changeUrlParam(indx);
				} else
					return false;
			}
		},
		onToggleEnabled: function (isEnabled) {
			var elt = this.getElt();
			if (elt) {
				elt.toggleClass("disabled", !isEnabled);
			}
		},
		_hideOthers: function () {
			var curPnl = null;
			
			for (var i = 0, l = this.tabs.length; i < l; i++) {
				var dataItem = this.tabs[i].data("tabsItem");
				var pnl = this._page.getControl($.trim(dataItem.panel));
				if (pnl) {
					if (pnl.hide() === false)
						return false;
					if (i == this.selectedItem)
						curPnl = pnl;
				}
			}
			return curPnl;
		},
		_proceedShowing: function (indx, e) {
			if (indx != this.selectedItem)
				e.stopPropagation();
		}
	};
	KL.Web.Controls.registerClass("TabsList", TabsList);
	TabsList.extend(KL.Web.Controls.Control);
})()
;
(function () {
	var Wizard = function (id, setting) {
		Wizard._super.call(this, id, setting);
	};
	Wizard.prototype = {
		errorWrap: ".errorMsg",
		errorText: ".errorMsg",
		successWrap: ".successMsg",
		onTabsInited: function () {
			this.hideError();
		},
		onShown: function () {
			this.hideError();
		},
		onTabInit: function (indx, tab, panel) {
			var Delegate = KL.Utils.Delegate;
			var elt = this.getElt();
			elt.find(".innerLoader").hide();
			elt.find(".btnNext").click(Delegate.create(this, this._nextBtnHandler, panel, indx));
			elt.find(".btnBack").click(Delegate.create(this, this._backBtnHandler, panel, indx));
			elt.find(".btnCancel").click(Delegate.create(this, this._cancelBtnHandler));
		},
		showNextStep: function () {
			this._showStep(this.selectedItem + 1);
		},
		showPrewStep: function () {
			this._showStep(this.selectedItem - 1);
		},
		_nextBtnHandler: function (panel, index, evt) {
			if (!!evt) {
				evt.preventDefault();
				evt.stopPropagation();
			}
			this.hideError();
			this.getElt().find(".innerLoader").show();
			this.getElt().find(".btnNext").hide();
			$(panel).trigger("onstepcomplete");
		},
		_backBtnHandler: function (panel, index) {
			this._showStep(index - 1);
		},
		_showStep: function (index) {
			if (index >= 0 && index < this.panels.length) {
				this.getElt().find(".btnNext").show();
				this.getElt().find(".innerLoader").hide();
				this.itemClick(this.tabs[index], index);
			}
		},
		onTabShow: function () {
			this.hideError();
		},
		_cancelBtnHandler: function () {
			this.hideError();
			$(this).trigger("onwizardcancel");
		},
		onDataBind: function (data) {
			this.hideError();
		},
		applyError: function (evt, err) {
			this.showError(err.id, err.message);
		},
		showError: function (errNum, text) {
			var localization = KL.Utils.Localization.getInstance();
			var exceprionText = ""; //Exception.getExceptionText(errNum);
			if (localization.stringExists(text))
				text = localization.getLocaleString(text);
			var elt = this.getElt();
			elt.find(this.errorWrap).show();
			elt.find(this.errorText).html(exceprionText || text);
		},
		hideError: function () {
			if ((typeof (this.onErrorHide) + "").toLowerCase() == "function")
				this.onErrorHide();
			var elt = this.getElt();
			elt.find(this.errorWrap).hide();
		},
		showSuccess: function () {
			this.hideError();
			this.getElt().find(this.successWrap).show();
		},
		hideSuccess: function () {
			if ((typeof (this.onSuccessHide) + "").toLowerCase() == "function")
				this.onSuccessHide();
			this.getElt().find(this.successWrap).hide();
		}
	};
	KL.Web.Controls.registerClass("Wizard", Wizard);
	Wizard.extend(KL.Web.Controls.TabsList);
})()
;
(function () {
	var MainNav = function (id, initValue) {
		MainNav._super.call(this, id, initValue);
	};
	MainNav.prototype = {
		onInitInteraction: function () {
			this.selectedItem = 0;
			this._tabContainer = this.getElt().find(".menuItem").parent();
			this._initTabs();
		},
		onBeforeShow: function () {
			var localization = KL.Utils.Localization.getInstance();
			
			if (!!this.param) {
				var initVal = this._page.getApplication().getPageParam(this.param);
				if (initVal !== null && this.tabs[initVal])
					this.selectedItem = initVal;
			}
			for (var i = 0, l = this.tabs.length; i < l; i++) {
				var dataItem = this.tabs[i].data("tabsItem");
				var text = dataItem.text;
				if (localization.stringExists(text))
					text = localization.getLocaleString(text);
				this.tabs[i].find(".menuItemText").html(text);
				this._initPanel(dataItem.panel, i);
			}
		},
		getRoleDefaultTab: function () {
			return KL.Utils.UserHelper.isAdmin() ?0:1;
		}
	};
	KL.Web.Controls.registerClass("MainNav", MainNav);
	MainNav.extend(KL.Web.Controls.TabsList);
})()
;
(function () {
	var AccordionPanel = function (id, setting) {
		AccordionPanel._super.call(this, id, setting );
	};
	AccordionPanel.prototype = {
		onInit: function () { },
		collapse: function (forceHide) {
			var elt = this.getElt();
			if (elt) {
				if(forceHide){
					elt.hide();
					this._triggerEvt("oncollapsed");
				}else
					elt.slideUp(KL.Utils.Delegate.create( this, this._triggerEvt, "oncollapsed" ));
			}
		},
		expand: function (forceShow) {
			var elt = this.getElt();
			if (elt) {
				if(forceShow){
					elt.show();
					this._triggerEvt("onexpanded");
				}else
					elt.slideDown(KL.Utils.Delegate.create( this, this._triggerEvt, "onexpanded" ));
			}
		},
		_triggerEvt: function(evtName){
			$(this).trigger( evtName, [this] );
		}
	};
	KL.Web.Controls.registerClass("AccordionPanel", AccordionPanel);
	AccordionPanel.extend( KL.Web.Controls.Panel );
})()
;
(function () {
	var AccordionTab = function (id, setting) {
		KL.Utils.Log.write("AccordionTab.constructor: called id=" + id);
		AccordionTab._super.call(this, id, setting);
	};
	AccordionTab.prototype = {
		opentext: "",
		onBtnInited: function () {
			var elt = this.getElt();
			if (elt)
				elt.hover(
					KL.Utils.Delegate.create(this, this._hover, true),
					KL.Utils.Delegate.create(this, this._hover, false)
				);
		},
		_hover: function (isOver) {
			var elt = this.getElt();
			if (elt)
				elt.toggleClass("tabOver", isOver);
		},
		setText: function (txt) {
			var elt = this.getElt();
			var localization = KL.Utils.Localization.getInstance();
			if (localization.stringExists(txt))
				txt = localization.getLocaleString(txt);
			if (elt) {
				elt.find(".tabTitle").html(txt);
				var txt1 = txt;
				if (this.opentext) {
					txt1 = this.opentext;
					if (localization.stringExists(txt1))
						txt1 = localization.getLocaleString(txt1);
				}
				elt.find(".tabOpenTitle").html(txt1);
			}
		},
		showPreview: function (forceShow) {
			var elt = this.getElt();
			if (elt)
				elt.find(".itemPreview")[forceShow ? "show" : "slideDown"]();
		},
		hidePreview: function (forceHide) {
			var elt = this.getElt();
			if (elt)
				elt.find(".itemPreview")[forceHide ? "hide" : "slideUp"]();
		}
	};
	KL.Web.Controls.registerClass("AccordionTab", AccordionTab);
	AccordionTab.extend(KL.Web.Controls.Button);
})()
;
(function () {
	var AccordionItem = function (id, setting) {
		AccordionItem._super.call(this, id, setting);
	};
	AccordionItem.prototype = {
		tab: null,
		panel: null,
		expanded: false,
		onInit: function () {
			var AccordionPanel = KL.Web.Controls.AccordionPanel;
			var AccordionTab = KL.Web.Controls.AccordionTab;
			for (var i = 0, l = this._children.length; i < l; i++) {
				if (this._children[i] instanceof AccordionTab)
					this.tab = this._children[i];
				else if (this._children[i] instanceof AccordionPanel) {
					this.panel = this._children[i];
					$(this.panel).bind("oncollapsed", KL.Utils.Delegate.create(this, this._panelCollapsed));
				}
			}
			$(this.tab).bind("onclick", KL.Utils.Delegate.create(this, this._toggle));
		},
		_toggle: function () {
			this[this.expanded ? "collapse" : "expand"](false);
		},
		collapse: function (forceHide) {
			if (this.tab)
				this.tab.showPreview(forceHide);
			if (this.panel)
				this.panel.collapse(forceHide);
			this.expanded = false;
			$(this).trigger("oncollapse", [forceHide]);
		},
		expand: function (forceShow, e) {
			if (!!e) {
				e.preventDefault();
				e.stopPropagation();
			}
			var elt = this.getElt();
			if (elt){
				elt.prev().addClass("preExpanded");
				elt.addClass("expanded");
			}
			if (this.tab)
				this.tab.hidePreview(forceShow);
			if (this.panel)
				this.panel.expand(forceShow);
			this.expanded = true;
			$(this).trigger("onexpand", [forceShow]);
		},
		_panelCollapsed: function(){
			var elt = this.getElt();
			if (elt){
				elt.prev().removeClass("preExpanded");
				elt.removeClass("expanded");
			}
		}
	};
	KL.Web.Controls.registerClass("AccordionItem", AccordionItem);
	AccordionItem.extend( KL.Web.Controls.Control );
})()
;
(function () {
	var Accordion = function (id, initValue) {
		Accordion._super.call(this, id, initValue);
	};
	Accordion.prototype = {
		
		items: null,
		panelOnShow: function (indx) { },
		panelOnHide: function (indx) { },
		onInit: function () {
			var Delegate = KL.Utils.Delegate;
			var AccordionItem = KL.Web.Controls.AccordionItem;
			KL.Utils.Log.write("Accordion.onInit: called id=" + this.id);
			this.selectedItem = 0;
			this.items = [];
			for (var i = 0, l = this._children.length; i < l; i++) {
				if (this._children[i] instanceof AccordionItem) {
					$(this._children[i]).bind("onexpand", Delegate.create(this, this._hideOtherPanels, this.items.length));
					this.items.push(this._children[i]);
				}
			}
		},
		onShown: function () {
			this.selectedItem = 0;
			var indx = this.selectedItem;
			this.selectedItem = -1;
			this._showPanel(indx, true);
		},
		_showPanel: function (indx, forceShow, e) {
			KL.Utils.Log.write("Accordion.itemClick: Item " + indx + " clicked for id=" + this.id);
			if (indx != this.selectedItem)
				this.showPanel(indx, forceShow);
			else
				this.selectedItem = -1;
		},
		_hideOtherPanels: function (indx, e, forceHide) {
			this.panelOnShow(indx, forceHide);
			this.selectedItem = indx;
			this.hidePanels(forceHide);
		},
		hidePanels: function (forceHide) {
			KL.Utils.Log.write("Accordion.hidePanels: called id=" + this.id);
			for (var i = 0, l = this.items.length; i < l; i++) {
				if (this.selectedItem != i) {
					this.panelOnHide(i, forceHide);
					this.items[i].collapse(forceHide);
				}
			}
		},
		showPanel: function (indx, forceShow) {
			KL.Utils.Log.write("Accordion.showPanel: Showing panel " + indx + " id=" + this.id);
			if (!!this.items[indx])
				this.items[indx].expand(forceShow);
		}
	};
	KL.Web.Controls.registerClass("Accordion", Accordion);
	Accordion.extend( KL.Web.Controls.Control );
})()
;
(function () {
	var Paging = function (id, setting) {
		Paging._super.call(this, id, setting);
	};
	Paging.prototype = {
		_pageNum: 1,
		_pageSize: 20,
		_totalCount: 0,
		_pageLenght: 0,
		_startIndex: 0,
		_listContainer: null,
		_template: null,
		onInitInteraction: function () {
			this._listContainer = this.getElt().find(".pagingBtns");
			this._template = new KL.Utils.Template(this._listContainer.html());
			this._listContainer.empty();
		},
		onDataBind: function (data) {
			var localization = KL.Utils.Localization.getInstance();
			if (typeof (data.page) != "undefined")
				this._pageNum = data.page + 1;
			if (typeof (data.count) != "undefined")
				this._pageLenght = data.count;
			if (typeof (data.pageSize) != "undefined")
				this._pageSize = data.pageSize;
			else
				this._pageSize = this._pageLenght;
			if (typeof (data.total) != "undefined")
				this._totalCount = data.total;
			if (typeof (data.offset) != "undefined")
				this._startIndex = data.offset;
			this._listContainer.empty();
			var maxPage = Math.ceil(this._totalCount / this._pageSize);
			var startIndx = this._pageNum - 2;
			startIndx = startIndx < 1 ? 1 : startIndx;
			var endIndx = startIndx + 5;
			endIndx = endIndx > maxPage ? maxPage : endIndx;
			var pagingInfo = "";
			if (this._totalCount > 0)
				pagingInfo = localization.getLocaleStringObj("LabelPagerInfo", this._startIndex + 1, (this._startIndex + this._pageLenght), this._totalCount);
			else
				pagingInfo = localization.getLocaleString("LabelPagerNoItems");
			this.getElt().find(".pagingInfo").empty().append(pagingInfo);
			if (this._totalCount > 0) {
				if (startIndx > 1)
					this._bindPage(1, 1);
				if (startIndx > 2)
					this._listContainer.append("...");
				for (var i = startIndx; i <= endIndx; i++) {
					this._bindPage(i, i);
				}
				if (endIndx < (maxPage - 1))
					this._listContainer.append("...");
				if (endIndx < maxPage)
					this._bindPage(maxPage, maxPage);
			}
		},
		_bindPage: function (pageNum, text) {
			var Delegate = KL.Utils.Delegate;
			var itemElt = $(this._template.bindData({ "pageNum": pageNum, "pageText": text }))
				.appendTo(this._listContainer)
				.click(Delegate.create(this, this._pageClick, pageNum - 1));
			if (pageNum == this._pageNum)
				itemElt.addClass("selected");
		},
		_pageClick: function (pageNum, e) {
			if (!!e) {
				e.preventDefault();
				e.stopPropagation();
			}
			$(this).trigger("onpagechange", [pageNum]);
		}
	};
	KL.Web.Controls.registerClass("Paging", Paging);
	Paging.extend(KL.Web.Controls.Control);
})()
;
(function () {
	var PagingFBNL = function (id, setting) {
		PagingFBNL._super.call(this, id, setting);
	};
	PagingFBNL.prototype = {
		_pageNum: 1,
		_pageSize: 20,
		_totalCount: 0,
		_pageLenght: 0,
		_startIndex: 0,
		_listContainer: null,
		_template: null,
		_isEmptyResponse: true,
		onInitInteraction: function () {
			var localization = KL.Utils.Localization.getInstance();
			var elt = this.getElt();
			if (elt) {
				this._listContainer = elt.find(".pagingBtns");
				this._template = new KL.Utils.Template(this._listContainer.html());
				this._listContainer.empty();
				this._bindPage(0, "|<");
				this._bindPage(1, "<");
				this._bindPage(2, ">");
				this._bindPage(3, ">|");
				elt.find(".pagingInfo").empty().html(localization.getLocaleString("LabelPagerNoItems"));
				elt.find(".pagingTotal").empty();
			}
		},
		resetData: function (e,pageNum,data) {
			this.onDataBind(data);
		},
		
		setTotalCount: function(e,count){
			var localization = KL.Utils.Localization.getInstance();
			var elt = this.getElt();
			if (elt) {
			}
		},
		
		initData: function (e,data) {
			this.onDataBind(data);
		},
	
		onDataBind: function (data) {
			var pagingInfo = "";
			var localization = KL.Utils.Localization.getInstance();
			var elt = this.getElt();
			if (elt) {
				if (data) {
					KL.Utils.Log.write(this + ".onDataBind: data.count"+data.count, KL.Utils.Log.type.WARNING);
					this._totalCount = data.count;
					if (data.pageSize) this._pageSize = data.pageSize; else this._pageSize=20;
					if (data.page) this._pageNum = data.page; else this._pageNum =0;
					this.toggleBtnsDisabled();
				} else
					KL.Utils.Log.write(this + ".onDataBind: no data", KL.Utils.Log.type.WARNING);
			} else
				KL.Utils.Log.write(this + ".onDataBind: no HTML Element", KL.Utils.Log.type.WARNING);
		},
		toggleBtnsDisabled: function () {
			var localization = KL.Utils.Localization.getInstance();
			var elt = this.getElt();
			KL.Utils.Log.write(this + ".toggleBtnsDisabled: toggling buttons from " + this._pageNum);
			if (elt) {
				var from = this._pageNum * this._pageSize;
				var to = Math.min(this._totalCount, from + this._pageSize);
				if (this._totalCount && this._totalCount>0)
					elt.find(".pagingInfo").empty().append(localization.getLocaleStringObj("LabelPagerInfo", from+1, to, this._totalCount));
				else
					elt.find(".pagingInfo").empty().html(localization.getLocaleString("LabelPagerNoItems"));
				
				elt.find(".pageBtn0, .pageBtn1").attr("disabled", (from == 0));
				elt.find(".pageBtn2, .pageBtn3").attr("disabled", (to >= this._totalCount));
			}
		},
		_bindPage: function (pageNum, text) {
			var itemElt = $(this._template.bindData({ "pageNum": pageNum, "pageText": text }))
				.appendTo(this._listContainer)
				.addClass("pageBtn" + pageNum)
				.click(KL.Utils.Delegate.create(this, this._pageClick, pageNum, itemElt));
		},
		_pageClick: function (pageNum, elt, e) {
			if (!!e) {
				e.preventDefault();
				e.stopPropagation();
			}
			$(this).trigger("onpagechange", [pageNum]);
		}
	};
	KL.Web.Controls.registerClass("PagingFBNL", PagingFBNL);
	PagingFBNL.extend(KL.Web.Controls.Control);
})()
;
(function () {
	var PagingBN = function (id, setting) {
		KL.Utils.Log.write("PagingBN.constructor: called id=" + id);
		PagingBN._super.call(this, id, setting);
	};
	PagingBN.prototype = {
		_pageNum: 1,
		_pageSize: 20,
		_totalCount: 0,
		_pageLenght: 0,
		_startIndex: 0,
		_listContainer: null,
		_template: null,
		_count :0,
		
		onInitInteraction: function () {
			var elt = this.getElt();
			if (elt) {
				this._listContainer = elt.find(".pagingBtns");
				this._template = new KL.Utils.Template(this._listContainer.html());
				this._listContainer.empty();
				var localization = KL.Utils.Localization.getInstance();
				
				
				this._bindPage(-1, localization.getLocaleString("LabelPrevMessage"));
				this._bindPage(1, localization.getLocaleString("LabelNextMessage"));
			}
		},
		onDataBind: function (data) {
		},
		
		
		setItemId: function(e,index,count){
			var localization = KL.Utils.Localization.getInstance();
			var elt = this.getElt();
			if (elt) 
				if (count && count>0) {
					elt.find(".pagingInfo").empty().append(localization.getLocaleStringObj("LabelPagerBNInfo", index+1, count));
					elt.find(".pageBtn-1").attr("disabled", (index == 0));
					elt.find(".pageBtn1").attr("disabled", (index+1 ==count));
				}
				else
					elt.find(".pagingInfo").empty().html(localization.getLocaleString("LabelPagerNoItems"));
		},
		_bindPage: function (pageNum, text) {
			var itemElt = $(this._template.bindData({ "pageNum": pageNum, "pageText": text }))
				.appendTo(this._listContainer)
				.attr("disabled", false)
				.addClass("pageBtn" + pageNum)
				.click(KL.Utils.Delegate.create(this, this._pageClick, pageNum));
		},
		getNextData: function(){
			$(this).trigger("onpagechange", [0]);
		},		
		_pageClick: function (pageNum, e) {
			if (!!e) {
				e.preventDefault();
				e.stopPropagation();
			}
			$(this).trigger("onpagechange", [pageNum]);
		}
	};
	KL.Web.Controls.registerClass("PagingBN", PagingBN);
	PagingBN.extend(KL.Web.Controls.Control);
})()
;
(function () {
	var PagingNextBack = function (id, setting) {
		PagingNextBack._super.call(this, id, setting);
	};
	PagingNextBack.prototype = {
		_pageNum: 1,
		_pageSize: 20,
		_totalCount: 0,
		_pageLenght: 0,
		_startIndex: 0,
		_listContainer: null,
		_template: null,
		onInitInteraction: function () {
			var elt = this.getElt();
			if (elt) {
				this._listContainer = elt.find(".pagingBtns");
				this._template = new KL.Utils.Template(this._listContainer.html());
				this._listContainer.empty();
				this._bindPage(1, "<");
				this._bindPage(2, ">");
			}
		},
		onDataBind: function (data) {
			var pagingInfo = "";
			var elt = this.getElt();
			if (elt) {
				if (data) {
					
					this._totalCount = data.count;
					this._pageSize = data.pageSize;
					this._pageNum = data.page;
					this.toggleBtnsDisabled();
				} else
					KL.Utils.Log.write(this + ".onDataBind: no data", KL.Utils.Log.type.WARNING);
			} else
				KL.Utils.Log.write(this + ".onDataBind: no HTML Element", KL.Utils.Log.type.WARNING);
		},
		toggleBtnsDisabled: function () {
			var elt = this.getElt();
			KL.Utils.Log.write(this + ".toggleBtnsDisabled: toggling buttons from " + this._pageNum);
			if (elt) {
				var from = this._pageNum * this._pageSize;
				var to = //Math.min(this._totalCount, from + this._pageSize);
				elt.find(".pagingInfo").empty().append(KL.Utils.StringHelper.format("Showing {0} to {1} from {2}", from, to, this._totalCount));
				elt.find(".pageBtn0, .pageBtn1").attr("disabled", (from == 0));
				elt.find(".pageBtn2, .pageBtn3").attr("disabled", (to >= this._totalCount));
			}
		},
		_bindPage: function (pageNum, text) {
			var itemElt = $(this._template.bindData({ "pageNum": pageNum, "pageText": text }))
				.appendTo(this._listContainer)
				.addClass("pageBtn" + pageNum)
				.click(KL.Utils.Delegate.create(this, this._pageClick, pageNum, itemElt));
		},
		_pageClick: function (pageNum, elt, e) {
			if (!!e) {
				e.preventDefault();
				e.stopPropagation();
			}
			$(this).trigger("onpagechange", [pageNum]);
		}
	};
	KL.Web.Controls.registerClass("PagingNextBack", PagingNextBack);
	PagingNextBack.extend( KL.Web.Controls.Control );
})()
;
(function () {
	var LangSelect = function (id) {
		LangSelect._super.call( this, id, null );
	};
	LangSelect.prototype = {
		_currLang: null,
		_isVisible: true,
		onInitInteraction: function () {
			var Log = KL.Utils.Log;
			var localization = KL.Utils.Localization.getInstance();
			Log.write("LangSelect.onInit: called id=" + this.id);
			var _selector = this.getElt().find(".langSelectDD")
				.change(KL.Utils.Delegate.create(this, this._langSwitchHandler)).empty();
			var langs = localization.getLangsList();
			this._isVisible = false;
			if (langs) {
				Log.write("LangSelect.onInit: lang is langs=" + langs.join(", "));
				for (var i = 0, l = langs.length; i < l; i++) {
					var item_i = $("<option value=\"" + langs[i] + "\">" + localization.getLangName(langs[i]) + "</option>")
						.appendTo(_selector);
					this._isVisible = (l > 1);
				}
			}
		},
		onShown: function () {
			if (!this._isVisible)
				this.hide();
		},
		onBeforeShow: function () {
			var Log = KL.Utils.Log;
			var _lang = KL.Utils.Localization.getInstance().getCurrLang();
			Log.write("LangSelect.onBeforeShow: called id=" + this.id + "; lang is " + _lang);
			this.getElt().find(".langSelectDD").val(_lang);
			this._showSelectedLang(_lang);
			this._currLang = _lang;
		},
		_langSwitchHandler: function () {
			var Log = KL.Utils.Log;
			var Localization = KL.Utils.Localization;
			var _lang = this.getElt().find(".langSelectDD").val();
			Log.write("LangSelect._langSwitchHandler: called id=" + this.id + "; lang will be " + _lang);
			this._showSelectedLang(_lang);
			if (_lang != this._currLang) {
				Localization.getInstance().setLanguage(_lang);
				this._currLang = _lang;
			}
		},
		_showSelectedLang: function (lang) {
			var Log = KL.Utils.Log;
			var Localization = KL.Utils.Localization;
			Log.write("LangSelect._showSelectedLang: called id=" + this.id + "; lang is " + lang);
			this.getElt().find(".currLang").html(Localization.getInstance().getLangName(lang));
		}
	};
	KL.Web.Controls.registerClass("LangSelect", LangSelect);
	LangSelect.extend(KL.Web.Controls.Control);
})()
;
(function () {
	var DateSelect = function (id, setting) {
		DateSelect._super.call(this, id, setting);
	};
	DateSelect.prototype = {
		setDate: function (date) {
			var elt = this.getElt();
			if (elt)
				$(elt.find("input")).datepicker("setDate", date);
		},
		getValue: function () {
			var elt = this.getElt();
			if (elt)
				return $(elt.find("input")).datepicker("getDate");
			return null;
		},
		onInitInteraction: function () {
			var Delegate = KL.Utils.Delegate;
			var elt = this.getElt();
			if (elt) {
				$(elt.find("input")).datepicker({
					"onSelect": Delegate.create(this, this._dateChanged)
				}).datepicker("setDate", new Date());
				elt.find(".placeholder").click(Delegate.create(this, this._focus));
			}
		},
		onDataBind: function (data) {
			this.setText(data);
		},
		_dateChanged: function (date) {
			$(this).trigger("ondatechanged", [date]);
		},
		setRangeDate: function (val, type) {
			var elt = this.getElt();
			var instance = $(elt.find("input")).data("datepicker");
			if (type)
				$(elt.find("input")).datepicker("option", type ? type : "maxDate", val);
		},
		reset: function () {
			$(this.getElt().find("input")).datepicker("refresh");
		},
		_focus: function () {
			var elt = this.getElt();
			elt.find(".placeholder").hide();
			elt.find("input").focus();
		}
	};
	KL.Web.Controls.registerClass("DateSelect", DateSelect);
	DateSelect.extend( KL.Web.Controls.Control );
})()
;
(function () {
	var TimeSelect = function (id, setting) {
		TimeSelect._super.call( this, id, setting );
	};
	TimeSelect.prototype = {
		_activeTimePart: 0,
		_timePart: { Hours: 0, Minutes: 1 },
		value: null,
		_evtTimer: null,
		getHours: function () {
			return this.value ? this.value.hours : null;
		},
		getMinutes: function () {
			return this.value ? this.value.minutes : null;
		},
		setHours: function (h) {
			this.value = this.value || { hours: 0, minutes: 0 };
			this.value.hours = h < 0 ? 0 : (h > 23 ? 23 : h);
			this._applyValue();
		},
		setMinutes: function (m) {
			this.value = this.value || { hours: 0, minutes: 0 };
			this.value.minutes = m < 0 ? 0 : (m > 59 ? 59 : m);
			this._applyValue();
		},
		getValue: function () {
			return this.value ? this.value.hours + ":" + this.value.minutes : "00:00";
		},
		onInitInteraction: function () {
			this._evtTimer = null;
			var Delegate = KL.Utils.Delegate;
			var d = new Date();
			this.value = this.value || {
				hours: d.getHours(),
				minutes: d.getMinutes()
			};
			var elt = this.getElt();
			elt.find(".hours").keydown(function () { return false; })
				.focus(Delegate.create(this, this._setActiveTimePart, this._timePart.Hours));
			elt.find(".minutes").keydown(function () { return false; })
				.focus(Delegate.create(this, this._setActiveTimePart, this._timePart.Minutes));
			this._applyValue();
			elt.find(".btnUp").click(Delegate.create(this, this._increase, 1));
			elt.find(".btnDown").click(Delegate.create(this, this._increase, -1));
			elt.mousewheel(Delegate.create(this, this._wheelHandler))
		},
		_setActiveTimePart: function (type) {
			this._activeTimePart = type;
		},
		_wheelHandler: function (e, delta) {
			this._increase(delta);
		},
		_increase: function (delta) {
			if (this._evtTimer)
				window.clearTimeout(this._evtTimer)
			this._evtTimer = null;
			var type = this._activeTimePart == this._timePart.Hours ? "hours" : "minutes";
			var maxVal = this._activeTimePart == this._timePart.Hours ? 23 : 59;
			var currVal = this.value[type];
			var val = currVal + delta;
			val = val >= 0 ? (val <= maxVal ? val : maxVal) : 0;
			this.value[type] = val;
			this._applyValue();
			this._evtTimer = window.setTimeout(KL.Utils.Delegate.create(this, function () {
				$(this).trigger("ontimechanged", [this.getValue()]);
			}), 500);
		},
		_applyValue: function () {
			var elt = this.getElt();
			elt.find(".hours").val(("00" + this.value.hours).slice(-2));
			elt.find(".minutes").val(("00" + this.value.minutes).slice(-2));
			elt.find(".timeVal").val(this.getValue());
		},
		onDataBind: function (data) {
		}
	};
	KL.Web.Controls.registerClass("TimeSelect", TimeSelect);
	TimeSelect.extend(KL.Web.Controls.Control);
})()
;
(function () {
	var ReportView = function (id, setting) {
		ReportView._super.call(this, id, setting);
	};
	ReportView.prototype = {
		text: "",
		htmlurl: "",
		showReport: function (txt) {
			var elt = this.getElt();
			elt.hide();
			elt.html(txt);
			elt.find("dl dd").hover(
				function () { $(this).addClass("over"); },
				function () { $(this).removeClass("over"); }
			);
		},
		onLocalizationComplete: function () {
			this.getElt().show();
		},
		exportHTML: function () {
			if (this.htmlurl) {
				window.open(this.htmlurl, "_blank", "scrollbars=yes,menubar=yes");
			}
		},
		onInit: function () { },
		onDataBind: function (data) {
			this.showReport(data);
		}
	};
	KL.Web.Controls.registerClass("ReportView", ReportView);
	ReportView.extend(KL.Web.Controls.Control);
})()
;
(function () {
	var KeyValueListItem = function (itemInfo, tplStr) {
		var localization = KL.Utils.Localization.getInstance();
		KeyValueListItem._counter = KeyValueListItem._counter || 0;
		this._indx = "index" in itemInfo? itemInfo.index : KeyValueListItem._counter;
		this.id = "keyValueListItem" + KeyValueListItem._counter;
		this.keyhint = !!itemInfo.keyhint;
		this.title = itemInfo.title;
		if (localization.stringExists(this.title))
			this.title = localization.getLocaleString(this.title, this.keyhint);
		this.valueField = itemInfo.value;
		this._isdate = !!itemInfo.isdate;
		this.helper = itemInfo.helper;
		this.helptext = itemInfo.helptext;
		this.helpermethod = itemInfo.helpermethod;
		this.cssClass = itemInfo.cssclass || "";
		if (typeof (itemInfo["defaultValue"]) != "undefined")
			this.defaultValue = itemInfo["defaultValue"];
		this._template = tplStr || "";
		KeyValueListItem._counter++;
	};
	KeyValueListItem.prototype = {
		_template: "",
		_indx: 0,
		title: "",
		valueField: "",
		_isdate: false,
		helper: "",
		helpermethod: "",
		helptext: "",
		defaultValue: null,
		allowhtml: true,
		visiblecount: 1,
		viewlist: false,
		cssClass: "",
		keyhint: false,
		id: "",
		_getDefaultVal: function(val){
		},
		bind: function (data, tplStr) {
			var Log = KL.Utils.Log;
			var DateHelper = KL.Utils.DateHelper;
			var localization = KL.Utils.Localization.getInstance();
			
			var val = data;
			
			this._template = tplStr || this._template;
			if (this.valueField) {
				var fields = (this.valueField || "").split(".");
				for (var i = 0, l = fields.length; i < l; i++) {
					if (typeof (val[fields[i]]) == "undefined") {
						Log.write("KeyValueListItem.bind: " + this.valueField + " - " + fields[i] + " not found");
						val = null;
						break;
					} else {
						val = val[fields[i]];
					}
				}
			}
			if ((val == null || typeof (val) == "undefined" || (val instanceof Array && val.length == 0) ) && this.defaultValue != null) {
				Log.write("KeyValueListItem.bind: applying default value = " + this.defaultValue);
				val = this.defaultValue;
			}
			if (!this.allowhtml && (typeof (val) == "string" || val instanceof String) )
				val = KL.Utils.StringHelper.htmlEncode(val);
			if (localization.stringExists(val))
				val = localization.getLocaleString(val);
			val = this._isdate ? DateHelper.getLocaleDate(this.id, val) : val;
			if (this.helper) {
				try {
					var helper = eval("(" + this.helper + ")");
					if (typeof (helper[this.helpermethod]) == "function") {
						val = helper[this.helpermethod](val, this.id, data,this.valueField);
					}
				} catch (e) { }
			}
			var itemElt = $(KL.Utils.StringHelper.formatTemplate(this._template, { Title: this.title, Value: val })).addClass( this._indx%2?"itemEven":"itemOdd" );
			if (this._isdate)
				DateHelper.applyLocaleDates(this.id, itemElt);
			localization.applyStingObjs(this.id, itemElt);
			itemElt.find(".tooltip").hide();
			var helpTrigger = itemElt.find(".helpIco").hide();
			if( this.helptext ){
				var helpTipId = this.id + "HelpTooltip";
				itemElt.find(".helpTooltip").addClass( helpTipId ).html( KL.Utils.Localization.getInstance().getLocaleString(this.helptext) );
				KL.Utils.TooltipHelper.makeTooltips(helpTrigger.attr("rel",helpTipId), this, itemElt);
				helpTrigger.show();
			}
			if( this.cssClass )
				itemElt.addClass( this.cssClass );
			return itemElt;
		},
		getListValue: function (val) {
			if (val.length == 0)
				return null;
			var StringHelper = KL.Utils.StringHelper;
			for (var i = 0, l = val.length; i < l; i++)
				val[i] = StringHelper.htmlEncode(val[i]);
			var items = val.slice(0, this.visiblecount);
			var items_more = val.slice(this.visiblecount);
			return KL.Utils.StringHelper.format("{0}<div class='hiddenitems'>{1}</div>", items.join(',<br/>'), items_more.join(',<br/>'));
		}
	};
	KL.Web.Controls.registerClass("KeyValueListItem", KeyValueListItem);
})()
;
(function () {
	var KeyValueListControl = function (id, setting) {
		KeyValueListControl._super.call(this, id, setting );
	};
	KeyValueListControl.prototype = {
		_itemTemplate: "",
		_container: null,
		datafield: "",
		items: null,
		_itemsContainer: null,
		_listItems: null,
		allowhtml: true,
		onBeforeDataBind: function () { },
		onItemDataBind: function () { },
		onDataBound: function () { },
		onInit: function(){
			var KeyValueListItem = KL.Web.Controls.KeyValueListItem;
			this._listItems = [];
			for (var i = 0, l = this.items.length; i < l; i++) {
				var dataItem = new KeyValueListItem(this.items[i]);
				dataItem.allowhtml = this.allowhtml;
				this._listItems.push(dataItem);
			}
		},
		onInitInteraction: function () {
			var elt = this.getElt();
			if (elt) {
				this._itemTemplate = elt.html();
				this._itemsContainer = elt;
				elt.empty();
			}
		},
		_getStatData: function (data) {
			var data_out = data;
			if (this.datafield) {
				var fields = (this.datafield || "").split(".");
				for (var i = 0, l = fields.length; i < l; i++) {
					if (typeof (data_out[fields[i]]) == "undefined") {
						KL.Utils.Log.write("KeyValueListControl._getStatData: " + this.datafield + " - " + fields[i] + " not found");
						return null;
					}
					data_out = data_out[fields[i]];
				}
			}
			return data_out;
		},
		onDataBind: function (data) {
			if (!this._itemsContainer)
				return;
			if (typeof (this.onBeforeDataBind) == "function")
				this.onBeforeDataBind(data);
			this._itemsContainer.empty();
			var d = this._getStatData(data);
			if (d) {
				for (var i = 0, l = this.items.length; i < l; i++) {
					if (typeof (this.onItemDataBind) == "function")
						this.onItemDataBind(data);
					
					var dataItem = this._listItems[i],
						itemObj = dataItem.bind(d, this._itemTemplate);
					if (itemObj)
						this._itemsContainer.append(itemObj);
					if (typeof (this.onItemDataBound) == "function")
						this.onItemDataBound(data, d, this.items[i], itemObj);
				}
			}
			if (typeof (this.onDataBound) == "function")
				this.onDataBound(data);
		},
		onDestroy: function () {
			this.items = null;
			if (this._itemsContainer) {
				this._itemsContainer.empty();
				this._itemsContainer = null;
			}
		}
	};
	KL.Web.Controls.registerClass("KeyValueListControl", KeyValueListControl);
	KeyValueListControl.extend( KL.Web.Controls.Control );
})()
;
(function () {
	var ChangePasswdForm = function (id, setting) {
		ChangePasswdForm._super.call(this, id, setting);
	};
	ChangePasswdForm.prototype = {
		_testTimer: null,
		_confirmTimer: null,
		_isNewPassDisabled: null,
		errorWrap: ".errorHelpWrap", // ?
		errorText: ".errorHelpMsg", // ?
		onFormInit: function () {
			var Delegate = KL.Utils.Delegate;
			this._form.find(".cancelBtn").click(Delegate.create(this, this._cancel));
			this._resetStates();
			this._form.find(".inputNewPasswd").keyup(Delegate.create(this, this._startTestPasswd));
			this._form.find(".inputConfirmPasswd").keyup(Delegate.create(this, this._startPasswdConfirm));
		},
		_resetStates: function () {
			this._form.find(".newPassStrength").removeClass("passWeak").removeClass("passGood").removeClass("passOk").html("&nbsp;");
			this._form.find(".newPassConfirmOk").html("&nbsp;");
			this._form.find(".newPassConfirmError").html("&nbsp;");
		},
		_startTestPasswd: function () {
			if (this._testTimer)
				window.clearTimeout(this._testTimer);
			
			this._testTimer = window.setTimeout(KL.Utils.Delegate.create(this, this._testPasswd), 500);
		},
		_startPasswdConfirm: function () {
			if (this._confirmTimer)
				window.clearTimeout(this._confirmTimer);
			this._confirmTimer = window.setTimeout(KL.Utils.Delegate.create(this, this._testPasswdConfirm), 500);
		},
		_testPasswdConfirm: function () {
			if (this._confirmTimer)
				window.clearTimeout(this._confirmTimer);
			this._confirmTimer = null;
			var pwd = $.trim(this._form.find(".inputNewPasswd").val());
			var cnfpwd = $.trim(this._form.find(".inputConfirmPasswd").val());
			if( !pwd || !cnfpwd )
				return false;
			var localization = KL.Utils.Localization.getInstance();
			var retVal = (pwd == cnfpwd);
			this._form.find(".newPassConfirmOk").html(localization.getLocaleString("LabelChangePasswdPasswdConfirmOk"));
			this._form.find(".newPassConfirmError").html("&nbsp;");
			if (!retVal) {
				this._form.find(".newPassConfirmOk").html("&nbsp;");
				this._form.find(".newPassConfirmError").html(localization.getLocaleString("ErrorChangePassword_Confirm"));
			}
			return retVal;
		},
		_testPasswd: function () {
			if (this._testTimer)
				window.clearTimeout(this._testTimer);
			this._testTimer = null;
			var oldPwd = $.trim(this._form.find(".inputOldPasswd").val());
			var pwd = $.trim(this._form.find(".inputNewPasswd").val());
			if(!pwd)
				return 0;
			var localization = KL.Utils.Localization.getInstance();
			this._resetStates();
			this._form.find(".newPassNewMatchesOldWarn").html("&nbsp;");
			if( oldPwd == pwd )
				this._form.find(".newPassNewMatchesOldWarn").html(localization.getLocaleString("ErrorChangePassword_NewMatchesOld"));
			var status = this._getPasswdStatus(pwd);
			if (status.val < 2) // ?
				this.showError( KL.Utils.Exception.ExceptionTypes.ResetWebHelpdeskPasswordFailed ); // ?
			else
				this.hideError();
			this._form.find(".newPassStrength").addClass(status.Class).html(localization.getLocaleString(status.text));
			return status.val;
		},
		
		_getPasswdStatus: function(pwd) {
			var statusText = "LabelChangePasswdNewPasswdWeak";
			var statusClass = "passWeak";
			var statusVal = 0;
			if (pwd.length > 8 && (/[a-z]/g).test(pwd) && (/[A-Z]/g).test(pwd) && (/[0-9]/g).test(pwd) && (/[\@\#\$\%\&\*]/g).test(pwd)) {
				statusText = "LabelChangePasswdNewPasswdGood";
				statusClass = "passGood";
				statusVal = 1;
			} else if (pwd.length >= 8 && (/[a-z]/g).test(pwd) && (/[A-Z]/g).test(pwd) && (/[0-9]/g).test(pwd)) {
				statusText = "LabelChangePasswdNewPasswdOk";
				statusClass = "passOk";
				statusVal = 2;
			}
			return { text: statusText, Class: statusClass, val: statusVal };
		},
		_isEnabled: function(){
			var isNewPassDisabled = !$.trim(this._form.find(".inputOldPasswd").val());
			if( isNewPassDisabled !== this._isNewPassDisabled ){
				this._form.find(".inputNewPasswd, .inputConfirmPasswd").attr("disabled", isNewPassDisabled)
				this._isNewPassDisabled = isNewPassDisabled;
			}
			var newPassOk = this._testPasswd();
			var confPwdOk = this._testPasswdConfirm();
			return !isNewPassDisabled && newPassOk && confPwdOk;
		},
		onFormSubmit: function () {
			if (!this._testPasswd()) {
				this._form.find(".inputNewPasswd").focus();
				return false;
			}
			if (!this._testPasswdConfirm()) {
				this._form.find(".inputConfirmPasswd").focus();
				return false;
			}
			return true;
		},
		
		applyError: function (evt, err) {  // ?
			   this.showError(err.id, KL.Utils.StringHelper.htmlEncode(err.message + ""));
		},
		
		_cancel: function () {
			$(this).trigger("oncancel");
		}
	};
	KL.Web.Controls.registerClass("ChangePasswdForm", ChangePasswdForm);
	ChangePasswdForm.extend( KL.Web.Controls.FormControl );
})()
;
(function () {
	var AboutForm = function (id, setting) {
		AboutForm._super.call(this, id, setting);
	};
	
	AboutForm.prototype = {
		onInitInteraction: function () {
			var elt = this.getElt();
			if (elt)
				elt.find(".cancelBtn").click(KL.Utils.Delegate.create(this, this._cancel));
		},
		
		applyValue: function(evt,value){
			var localization = KL.Utils.Localization.getInstance();
			var appVer = this._page.getApplication().getContext().getData(KL.Web.Context.DataTypes.UiVersion);
			var appVerTxt = ( appVer != value )? "<h4 class=\"productVersion\">"+localization.getLocaleValueFormatString.apply(localization,(["LabelAboutTitleUiVersion"]).concat(appVer.split(/[^\d]/g)))+"</h4>" : "";
			this._page.setTitle("<div class=\"productTitle\"><div class=\"productThumb\"></div>"+
						"<div class=\"productName\">"+
							"<h1>"+localization.getLocaleValueString("LabelSignupTitleProductNameVendor")+"</h1>"+
							"<h2>"+localization.getLocaleValueString("LabelSignupTitleProductName")+"</h2>"+
							"<h4 class=\"productVersion\">"+localization.getLocaleValueFormatString.apply(localization,(["LabelAboutTitleProductVersion"]).concat(value.split(/[^\d]/g)))+"</h4>"+
							appVerTxt +
						"</div></div>");
			
		},
		_cancel: function () {
			if (this._page instanceof KL.Web.Dialog)
				this._page.closeDialog();
		}
	};
	KL.Web.Controls.registerClass("AboutForm", AboutForm);
	AboutForm.extend( KL.Web.Controls.Control );
})()
;
(function () {
	var PageHeader = function (id, setting) {
		PageHeader._super.call(this, id, setting);
	};
	KL.Web.Controls.registerClass("PageHeader", PageHeader);
	PageHeader.extend(KL.Web.Controls.Panel);
})()
;
(function () {
	var PageFooter = function (id, setting) {
		PageFooter._super.call(this, id, setting);
	};
	KL.Web.Controls.registerClass("PageFooter", PageFooter);
	PageFooter.extend(KL.Web.Controls.Panel);
})()
;
(function () {
	var PageContent = function (id, setting) {
		PageContent._super.call(this, id, setting);
	};
	PageContent.prototype = {};
	KL.Web.Controls.registerClass("PageContent", PageContent);
	PageContent.extend(KL.Web.Controls.Control);
})()
;
(function () {
	var SignupPagePanel = function (id, setting) {
		SignupPagePanel._super.call(this, id, setting);
	};
	SignupPagePanel.prototype = {};
	KL.Web.Controls.registerClass("SignupPagePanel", SignupPagePanel);
	SignupPagePanel.extend(KL.Web.Controls.Panel);
})()
;
(function () {
	var logoUrl = "{0}logo_{1}.png",
		defaultLogo = "";
	function _applyLocaleLogo( url ){
		var elt = this.getElt();
		if(elt){
			if(!defaultLogo)
				defaultLogo = elt.find(".logo").css( "background-image" );
			elt.find(".logo").css( "background-image", url );
		} else
			this.logoUrl = url;
	}
	function _loadLocaleLogo (evt, lang) {
		var localization = KL.Utils.Localization.getInstance(),
			image = new Image(),
			url = KL.Utils.StringHelper.format( logoUrl, localization.resourceBaseURL, lang );
		if( defaultLogo )
			_applyLocaleLogo.call(this, defaultLogo);
		if(localization.getKeyValue( "LoadLogo" )){
			image.onload = KL.Utils.Delegate.create( this, _applyLocaleLogo, "url(" + url + ")" );
			image.src = url;
		}
	}
	var ProductLogo = function (id, setting) {
		ProductLogo._super.call(this, id, setting);
		$(KL.Utils.Localization.getInstance()).on("onlangloaded", KL.Utils.Delegate.create( this, _loadLocaleLogo ));
	};
	ProductLogo.prototype = {
		logoUrl: "",
		onBeforeShow: function(){
			_loadLocaleLogo.call(this, null, KL.Utils.Localization.getInstance().getCurrLang());
		}
	};
	KL.Web.Controls.registerClass("ProductLogo", ProductLogo);
	ProductLogo.extend(KL.Web.Controls.Control);
})()
;
(function () {
	var MainNavTabPanel = function (id, setting) { 
		MainNavTabPanel._super.call( this, id, setting );
	};
	MainNavTabPanel.prototype =  {};
	KL.Web.Controls.registerClass("MainNavTabPanel", MainNavTabPanel);
	MainNavTabPanel.extend(KL.Web.Controls.Control);
})()
;
(function () {
	function TooltipForm (id, setting) {
		TooltipForm._super.call( this, id, setting );
	};
	TooltipForm.prototype = {
		_tip: null,
		_form: null,
		_dataObj: null,
		_mate: null,
		_toolTip: null,
		onBeforeShow: function () {
			this._tip = null;
			this._dataObj = null;
			var toolTip = this.getElt();
			if (toolTip) {
				this._toolTip = toolTip;
				var Delegate = KL.Utils.Delegate;
				toolTip.remove().prependTo(document.body).hide();
				if (this.cssclass)
					toolTip.addClass(this.cssclass);
				toolTip.find(".tooltipFooter .cancelBtn").click(Delegate.create(this, this._hideTip));
				this._elt = toolTip;
				this._form = toolTip.find("form").submit(Delegate.create(this, this._submitHandler));
				KL.Utils.Log.write("TooltipForm[" + this.id + "].onBeforeShow: Children are " + this._children);
				if (!!this._children) {
					for (var i = 0, l = this._children.length; i < l; i++) {
						this._children[i].show();
					}
				}
				this._hidden = false;
			}
			return false;
		},
		_makeMate: function () {
			if (this._mate)
				this._mate.remove();
			this._mate = $("<div></div>").prependTo(document.body).hide();
		},
		setButtonClose: function () {
			var toolTip = this.getElt();
			if (toolTip) {
				toolTip.find(".tooltipFooter .cancelBtn").html("<span class=\"left\"><span class=\"right\"><span class=\"center\">"+ KL.Utils.Localization.getInstance().getLocaleString("BtnClose") +"</span></span></span>");
				toolTip.find(".tooltipFooter .okBtn").css("display", "none");
			}
		},
		showTooltip: function (e, extra, trigger, title, isRightAligned, dataObj) {
			var toolTip = this.getElt();
			if (toolTip) {
				this.hideError();
				var localization = KL.Utils.Localization.getInstance();
				if (localization.stringExists(title))
					title = localization.getLocaleString(title);
				toolTip.find(".tooltipTitle").html(title);
				
				if (localization.stringExists(extra)) {
					extra = localization.getLocaleString(extra);
					toolTip.find(".lblTooltipFieldInfo").html(extra);
				}
				
				this._dataObj = dataObj;
				this._tip = $(trigger);
				if (!this._tip.data("tooltip")) {
					this._tip.tooltip({
						delay: 300000,
						tip: toolTip,
						events: {
							def: "hui, none"
						}
					});
				}
				this._tip.data("tooltip").hide();
				KL.Utils.Log.write("TooltipForm.showTooltip: isRightAligned=" + isRightAligned);
				var conf = this._tip.data("tooltip").getConf();
				conf.position = (!!isRightAligned ? "center left" : "center right").split(" ");
				conf.offset = (!isRightAligned ? [0, 20] : [0, -20]);
				toolTip.removeClass("rightTooltip")
					.addClass((!isRightAligned ? "" : "rightTooltip"));
				this._tip.data("tooltip").show();
				this._makeMate();
				if (this._mate)
					this._mate.css({
						"position": "absolute",
						"left": 0,
						"top": 0,
						"right": 0,
						"bottom" :0,
						"z-index": 100
					}).show();
				
				this.setValue(dataObj);
				var localizationResult = KL.Utils.Localization.getInstance().applyDelayed(toolTip);
				$(localizationResult).bind("onresourceapplied", KL.Utils.Delegate.create(this, this._localizationComplete));
			}
		},
		setValue: function (data) {
			var formElt = this._form.get(0);
			if (formElt) {
				for (var param in data) {
					if (data.hasOwnProperty(param)) {
						if (isNaN(param)) {
							this._form.find("[name=" + param + "]").val(data[param]);
						} else
							$(formElt[param]).val(data[param]);
					}
				}
			}
		},
		_hideTip: function () {
			window.setTimeout(KL.Utils.Delegate.create(this, function (dobj) {
				if (this._tip) {
					if (this._tip.data("tooltip"))
						this._tip.data("tooltip").hide();
					else {
						var elt = this.getElt();
						if (!elt) elt = this._toolTip;
						if (elt)
							elt.hide();
					}
				}
				if (this._mate)
					this._mate.remove();
				this._tip = null;
				$(dobj).trigger("ontiphidden", [dobj])
			}, this._dataObj), 0);
		},
		onHidden: function () {
			var elt = this.getElt();
			if (!elt) elt = this._toolTip;
			if (elt)
				elt.remove();
			if (this._mate)
				this._mate.remove();
		},
		getValue: function () {
			return this.getValueRecursive();
		},
		getValueRecursive: function () {
			var formElt = this._form.get(0);
			var data = {};
			if (formElt) {
				for (var i = 0, l = formElt.length; i < l; i++) {
					var formElt_i = $(formElt[i]);
					if (!formElt_i.is("button,[type=button],[type=submit]")) {
						var val = formElt_i.val();
						var name = formElt_i.attr("name");
						if (typeof (val) != "undefined") {
							if (name)
								data[name] = val;
							else
								data[i] = val;
						}
					}
				}
			}
			return data;
		},
		_submitHandler: function () {
			if (this._form && this._dataObj) {
				var val = this.getValueRecursive();
				this._dataObj["val"] = val;
				try {
					$(this._dataObj).trigger("onvaluechange", [val]);
					this._hideTip();
				} catch (e) {
					this.showError(-1, e.message || e);
				}
			}
			return false;
		}
	};
	KL.Web.Controls.registerClass("TooltipForm", TooltipForm);
	TooltipForm.extend( KL.Web.Controls.Control );
})()
;
KL.Web.registerNS("Dependencies");
(function () {
	var DependencyActor = function (id, actorInfo, app) {
		KL.Utils.Log.write("DependencyActor.constructor: called " + id);
		this._app = app;
		this.id = id;
		this._pageId = actorInfo.page;
	};
	DependencyActor.prototype = {
		id: null,
		_app: null,
		_dependency: null,
		_page: null,
		_pageId: null,
		_args: null,
		onInit: function () { },
		getElement: function () { },
		bindAction: function (eventName, reciever, action, args) {
			if (!!action && !!reciever) {
				var elt = this.getElement();
				args = args || [];
				if (!!args && typeof (args) != "Array" && !(args instanceof Array))
					args = [args];
				if (!!elt) {
					$(elt).bind(eventName, KL.Utils.Delegate.create(reciever, reciever.applyAction, action, args));
				}
			}
		},
		applyAction: function (action, args, evt, val) {
			var elt = this.getElement();
			if (!!elt) {
				args = (args||[]).concat(Array.prototype.slice.call(arguments, 2));
				var acts = action;
				if (typeof (acts) != "Array" && !(acts instanceof Array))
					acts = [acts];
				for (var i = 0, l = acts.length; i < l; i++) {
					if (typeof (elt[acts[i]]) == "function" && elt[acts[i]].apply(elt, args) === false)
						this._cacheAction(acts, args, evt, val);
				}
			}
		},
		_cacheAction: function (args) {
			this._app.setLastCancelledEvent(this, args);
		}
	};
	
	KL.Web.Dependencies.registerClass("DependencyActor", DependencyActor);
})()
;
(function () {
	var PageActor = function (id, actorInfo, app) {
		KL.Utils.Log.write("PageActor.constructor: called " + id);
		PageActor._super.call( this, id, actorInfo, app );
	};
	PageActor.prototype = {
		getElement: function () {
			return this._app.getPage(this.id);
		}
	};
	KL.Web.Dependencies.registerClass("PageActor", PageActor);
	PageActor.extend( KL.Web.Dependencies.DependencyActor );
})()
;
(function () {
	
	var QueryActor = function (id, actorInfo, app) {
		KL.Utils.Log.write("QueryActor.constructor: called " + id);
		QueryActor._super.call( this, id, actorInfo, app );
	}
	QueryActor.prototype = {
		getElement: function () {
			return this._app.getQueries(this.id);
		}
	};
	KL.Web.Dependencies.registerClass("QueryActor", QueryActor);
	QueryActor.extend(KL.Web.Dependencies.DependencyActor);
})()
;
(function () {
	
	var ModelActor = function (id, actorInfo, app) {
		KL.Utils.Log.write("ModelActor.constructor: called " + id);
		ModelActor._super.call( this, id, actorInfo, app );
	};
	ModelActor.prototype = {
		getElement: function () {
			return this._app.getSetting(this.id);
		}
	};
	KL.Web.Dependencies.registerClass("ModelActor", ModelActor);
	ModelActor.extend(KL.Web.Dependencies.DependencyActor);
})()
;
(function () {
	var ControlActor = function (id, actorInfo, app) {
		KL.Utils.Log.write("ControlActor.constructor: called " + id);
		ControlActor._super.call( this, id, actorInfo, app );
	};
	ControlActor.prototype = {
		getElement: function () {
			return this._app.getControl(this.id);
		}
	};
	KL.Web.Dependencies.registerClass("ControlActor", ControlActor);
	ControlActor.extend(KL.Web.Dependencies.DependencyActor);
})()
;
(function () {
	var Dependency = function (sender, event) {
		this.id = sender.id;
		if (!!sender) {
			this.sender = sender;
			if (event)
				this.event = event;
		}
	};
	Dependency.prototype = {
		id: null,
		sender: null,
		receivers: null,
		event: null,
		addReceiver: function (receiver, action, args) {
			if (!this.receivers)
				this.receivers = [];
			this.receivers.push({ r: receiver, a: action, args: args });
		},
		applyToSender: function (page) {
			if (!!this.receivers && !!this.sender) {
				for (var i = 0, l = this.receivers.length; i < l; i++) {
					var receiver_i = this.receivers[i].r;
					var action_i = this.receivers[i].a;
					var args_i = this.receivers[i].args;
					this.sender.bindAction(this.event, receiver_i, action_i, args_i);
					this.receivers[i] = null;
				}
				this.receivers = null;
				this.sender = null;
			}
		}
	};
	Dependency._insts = null;
	KL.Web.Dependencies.registerClass("Dependency", Dependency);
})()
;
(function () {
	var DependencyFab = function (app) {
		this.app = app;
	};
	DependencyFab.types = {
		"page": KL.Web.Dependencies.PageActor,
		"control": KL.Web.Dependencies.ControlActor,
		"query": KL.Web.Dependencies.QueryActor,
		"model": KL.Web.Dependencies.ModelActor
	};
	DependencyFab.prototype = {
		app: null,
		_actors: null,
		_insts: null,
		createDependency: function (dependencyInfo) {
			if (!this._insts)
				this._insts = {};
			var d = null;
			if (!!dependencyInfo.sender) {
				var ds = dependencyInfo.sender;
				if (!(ds instanceof Array) && typeof (ds) != "Array")
					ds = [ds];
				d = [];
				for (var i = 0, l = ds.length; i < l; i++) {
					if (!!ds[i])
						d = d.concat(this._createDependency(ds[i], dependencyInfo));
				}
			}
			return d;
		},
		_createDependency: function (senderId, dependencyInfo) {
			var d = null;
			var sender = this._getActor(senderId, dependencyInfo);
			if (!!sender) {
				if (dependencyInfo.event instanceof Array || typeof (dependencyInfo.event) == "Array") {
					d = [];
					for (var i = 0, l = dependencyInfo.event.length; i < l; i++)
						d.push(this._createEventDependency(sender, dependencyInfo.event[i], dependencyInfo));
				} else
					d = this._createEventDependency(sender, dependencyInfo.event, dependencyInfo);
			}
			return d;
		},
		_createEventDependency: function (sender, event, dependencyInfo) {
			var d = new KL.Web.Dependencies.Dependency(sender, event);
			if (!this._insts[d.id])
				this._insts[d.id] = [];
			if (!!dependencyInfo.receivers) {
				var hasReceivers = this._addReceivers(d, dependencyInfo.receivers);
				if (hasReceivers)
					this._insts[d.id].push(d);
			}
			return d;
		},
		_createActor: function (id, actorInfo) {
			var type = DependencyFab.types[actorInfo.type];
			var sender = null
			try {
				sender = new type(id, actorInfo, this.app);
			} catch (e) {}
			return sender;
		},
		_getActor: function (id, actorInfo) {
			this._actors = this._actors || {};
			var typeName = !!actorInfo["type"] ? actorInfo["type"] : "control";
			if (!DependencyFab.types[typeName])
				typeName = "control";
			actorInfo["type"] = typeName;
			this._actors[typeName] = this._actors[typeName] || {};
			
			this._actors[typeName][id] = this._actors[typeName][id] || this._createActor(id, actorInfo);
			return this._actors[typeName][id];
		},
		_addReceivers: function (dependency, receivers) {
			var Log = KL.Utils.Log;
			if (!receivers) {
				Log.write("DependencyFab._addReceivers: Receivers are not defined for " + dependency.id + "!!!", Log.type.WARNING);
				return false;
			}
			if (!(receivers instanceof Array)) {
				this._addReceiver(dependency, receivers);
			} else {
				if (receivers.length == 0) {
					Log.write("DependencyFab._addReceivers: HOLLY CRAP " + dependency.id + " HAS NO RECEIVERS!!!", Log.type.WARNING);
					return false;
				} else {
					for (var i = 0, l = receivers.length; i < l; i++) {
						if (receivers[i]) {
							this._addReceiver(dependency, receivers[i]);
						}
					}
				}
			}
			return true;
		},
		_addReceiver: function (dependency, receiverInfo) {
			var receiverId = receiverInfo.id;
			if (!(receiverId instanceof Array) && (typeof (receiverId) + "").toLowerCase() != "array") {
				if (!!receiverId) {
					var receiver = this._getActor(receiverId, receiverInfo);
					dependency.addReceiver(receiver, receiverInfo.action, receiverInfo.args);
				}
			} else {
				for (var i = 0, l = receiverId.length; i < l; i++) {
					if (receiverId[i]) {
						var receiver_i = this._getActor(receiverId[i], receiverInfo);
						dependency.addReceiver(receiver_i, receiverInfo.action, receiverInfo.args);
					}
				}
			}
		},
		getDependency: function (id) {
			var Log = KL.Utils.Log;
			if (!this._insts)
				this._insts = {};
			var d = null;
			if (!id){
				Log.write("DependencyFab.getDependency: Dependencies for " + id + " can not be found", Log.type.WARNING);
			}else {
				d = this._insts[id];
			}
			return d || null;
		},
		clear: function () {
			this._actors = null;
			this._insts = null;
		}
	};
	KL.Web.Dependencies.registerClass("DependencyFab", DependencyFab);
})()
;
(function () {
	var DataProvider = KL.HTTP.DataProvider;
	var Delegate = KL.Utils.Delegate;
	var Page = function (id, dataProvider, app) {
		this.id = id;
		this._createView();
		this._controls = {};
		this._app = app;
		this._dataProvider = dataProvider;
		if (this._view) {
			this._view.setPage(this);
			this._view.controltemplate = this.toString();
			$(this._view).bind("onchange", Delegate.create(this, this.ctrlChangeHandler));
		}
	};
	Page._pagesCount = 0;
	Page.prototype = {
		constructor: Page,
		id: "",
		onInit: function () { },
		onBeforeInit: function () { },
		ismain: false,
		islogin: false,
		_app: null,
		_dataProvider: null,
		_view: null,
		_controls: null,
		_isVisible: false,
		isVisible: function () { return !!this._isVisible; },
		ctrlChangeHandler: function () { },
		_createView: function(){
			this._view = new KL.Web.Controls.Control(this.id);
		},
		_applyDependencies: function (ctrl) {
			var d = this._app.getDependencies(ctrl.id);
			if (!!d) {
				for (var i = 0, l = d.length; i < l; i++) {
					d[i].applyToSender(this);
				}
			}
		},
		init: function () {
			if (typeof (this.onBeforeInit) == "function")
				this.onBeforeInit();
			var Control = KL.Web.Controls.Control;
			for (var ctrlId in this._controls) {
				if (this._controls[ctrlId] instanceof Control)
					this._applyDependencies(this._controls[ctrlId]);
			}
			this._view.init();
			if (typeof (this.onInit) == "function")
				this.onInit();
		},
		getApplication: function () {
			return this._app;
		},
		registerControl: function (ctrl) {
			this._controls[$.trim(ctrl.id)] = ctrl;
		},
		addControl: function (ctrl) {
			this._view.addSubcontrol(ctrl);
			ctrl.setPage(this);
			ctrl.setParent(this._view);
		},
		getControl: function (id) {
			
			if (!!$.trim(id)) {
				if (id == this._view.id) {
					return this._view;
				} else {
					if (this._controls[id])
						return this._controls[id];
				}
			}
			
			return null;
		},
		getSetting: function (name) {
			return this._app.getSetting(name);
		},
		showPage: function () {
			var pagesContainer = this.getApplication().getPagesContainer();
			if (!pagesContainer || !pagesContainer.length) {
				KL.Utils.Log.write("Page.showPage: no place for page id=" + this.id, KL.Utils.Log.type.WARNING);
				return;
			}
			
			var e = new $.Event("onbeforepageopen");
			$(this).trigger(e);
			
			if (e.isDefaultPrevented()) {
				return false;
			}
			this._view.show(pagesContainer);
			this._isVisible = true;
			KL.Utils.Localization.getInstance().applyDelayed(this._view.getElt());
			$(this).trigger("onpageopen");
		},
		hidePage: function () {
			this._view.hide();
			this._isVisible = false;
			this._triggerOnClose();
		},
		_triggerOnClose: function () {
			$(this).trigger("onpageclose");
		},
		dataLoadHandler: function () { },
		destroy: function () {
			this._view.destroy();
			this._app = null;
			this._dataProvider = null;
			this._view = null;
			this._controls = null;
		}
	};
	KL.Web.registerClass("Page", Page);
})()
;
(function () {
	var Dialog = function (id, dataProvider, app) {
		Dialog._super.call(this, id, dataProvider, app );
	};
	Dialog.prototype = {
		_createView: function(){ this._view = new KL.Web.Controls.ModalDialog(this.id); },
		title: "",
		width: 500,
		setTitle: function (text) {
			this.title = text;
			this._view.setTitle(this.title);
		},
		setDialogClass: function (className) {
			this._view.setDialogClass(className);
		},
		showDialog: function () {
			this.showPage();
		},
		closeDialog: function () {
			this._isVisible = false;
			this._view.closeDialog();
		},
		onInit: function () {
			this._view.width = this.width;
			this._view.setTitle(this.title);
			this._view.setDialogClass(this.id);
			$(this._view).bind("ondialogclose", KL.Utils.Delegate.create(this, this._triggerOnClose));
		}
	};
	KL.Web.registerClass("Dialog", Dialog);
	Dialog.extend(KL.Web.Page);
})()
;
(function () {
	var ConfirmDialogView = function (id, setting) {
		ConfirmDialogView._super.call(this, id, setting );
	};
	ConfirmDialogView.prototype = {
		_label: null,
		_btnOk: null,
		_btnCancel: null,
		onDialogInit: function () {
			var elt = this.getElt();
			if (elt) {
				this._label = elt.find(".dialogText");
				this._btnOk = elt.find(".btnOk")
					.click(KL.Utils.Delegate.create(this, this._okClickHandler));
				this._btnCancel = elt.find(".btnCancel")
					.click(KL.Utils.Delegate.create(this, this._cancelClickHandler));
			}
		},
		_okClickHandler: function () {
			$(this).trigger("onok");
		},
		_cancelClickHandler: function () {
			$(this).trigger("oncancel");
		},
		setMessageText: function (text) {
			if (this._label) {
				var localization = KL.Utils.Localization.getInstance();
				if (localization.stringExists(text))
					text = localization.getLocaleString(text);
				this._label.html(text);
			}
		},
		setOkBtnText: function (text) {
			if (this._btnOk) {
				var localization = KL.Utils.Localization.getInstance();
				if (localization.stringExists(text))
					text = localization.getLocaleString(text);
				this._btnOk.find(".btnText").html(text);
			}
		},
		setCancelBtnText: function (text) {
			if (this._btnCancel) {
				var localization = KL.Utils.Localization.getInstance();
				if (localization.stringExists(text))
					text = localization.getLocaleString(text);
				this._btnCancel.find(".btnText").html(text);
			}
		}
	};
	KL.Web.Controls.registerClass("ConfirmDialogView", ConfirmDialogView);
	ConfirmDialogView.extend( KL.Web.Controls.ModalDialog );
	var ConfirmDialog = function (id, app) {
		ConfirmDialog._super.call(this, id, null, app );
	};
	ConfirmDialog.prototype = {
		width: 300,
		_result: null,
		_btnOk: null,
		_btnCancel: null,
		_label: null,
		_isButtonClicked: false,
		_createView: function(){ this._view = new ConfirmDialogView(this.id); },
		setTilte: function (text) {
			this._view.setTitle(text);
		},
		setMessage: function (text) {
			this._view.setMessageText(text);
		},
		setOkBtnText: function (text) {
			this._view.setOkBtnText(text);
		},
		setCancelBtnText: function (text) {
			this._view.setCancelBtnText(text);
		},
		_okClickHandler: function () {
			this._isButtonClicked = true;
			this.hidePage();
			$(this._result).trigger("onok");
			this._result = null;
		},
		_cancelClickHandler: function () {
			this._isButtonClicked = true;
			this.hidePage();
			this._triggerCancel();
		},
		_triggerCancel: function(){
			$(this._result).trigger("oncancel");
			this._result = null;
		},
		onBeforeInit: function () {
			var Delegate = KL.Utils.Delegate;
			var Button = KL.Web.Controls.Button;
			$(this._view).bind("onok", Delegate.create(this, this._okClickHandler));
			$(this._view).bind("oncancel", Delegate.create(this, this._cancelClickHandler));
		},
		_checkCancel: function(){
			
			this._isButtonClicked = false;
			this._triggerOnClose();
		},
		onInit: function () {
			var Delegate = KL.Utils.Delegate;
			this._view.width = this.width;
			$(this._view).bind("ondialogclose", KL.Utils.Delegate.create(this, this._checkCancel));
		},
		showDialog: function (text, title, buttonsText, width) {
			this.showPage();
			this._isButtonClicked = false;
			this._result = { id: this.id, elt: this._view.getElt() };
			this._view.width = width || this.width;
			this.setTilte(title);
			this.setMessage(text);
			var btnOkText = "Yes";
			var btnCancelText = "No";
			if (!!buttonsText) {
				if ("ok" in buttonsText)
					btnOkText = buttonsText.ok;
				if ("cancel" in buttonsText)
					btnCancelText = buttonsText.cancel;
			}
			this.setOkBtnText(btnOkText);
			this.setCancelBtnText(btnCancelText);
			return this._result;
		}
	}
	KL.Web.registerClass("ConfirmDialog", ConfirmDialog);
	ConfirmDialog.extend( KL.Web.Dialog );
})()
;
(function () {
	var MessageDialogView = function (id, setting) {
		MessageDialogView._super.call(this, id, setting );
	};
	MessageDialogView.prototype = {
		_btn: null,
		_lbl: null,
		setBtnText: function (text) {
			if (this._btn) {
				var localization = KL.Utils.Localization.getInstance();
				if (localization.stringExists(text))
					text = localization.getLocaleString(text);
				this._btn.find(".btnText").html(text);
			}
		},
		setLabelText: function (text) {
			if (this._lbl) {
				var localization = KL.Utils.Localization.getInstance();
				if (localization.stringExists(text))
					text = localization.getLocaleString(text);
				this._lbl.html(text);
				localization.applyStingObjs(this.id, this._lbl);
			}
		},
		onDialogInit: function () {
			var elt = this.getElt();
			if (elt) {
				this._lbl = elt.find(".dialogText");
				this._btn = elt.find(".dialogBtn")
					.click(KL.Utils.Delegate.create(this, this.closeDialog));
			}
		}
	};
	KL.Web.Controls.registerClass("MessageDialogView", MessageDialogView);
	MessageDialogView.extend( KL.Web.Controls.ModalDialog );
	var MessageDialog = function (id, app) {
		MessageDialog._super.call(this, id, null, app);
	};
	MessageDialog.prototype = {
		width: 300,
		_result: null,
		_btnOk: null,
		_createView: function(){ this._view = new MessageDialogView(this.id); },
		setTilte: function (text) {
			this._view.setTitle(text);
		},
		setDialogType: function (mode) {
			var className = (mode == MessageDialog.MessageType.Error ? "errorMessage" : "");
			this.setDialogClass(className);
		},
		setMessage: function (text) {
			this._view.setLabelText(text);
		},
		setBtnText: function (text) {
			this._view.setBtnText(text);
		},
		_triggerOnClose: function () {
			$(this._result).trigger("onok");
			this._result = null;
		},
		showDialog: function (text, title, buttonText, width, mode) {
			this.showPage();
			this._result = { id: this.id, elt: this._view.getElt() };
			this._view.width = width || this.width;
			this.setTilte(title);
			this.setMessage(text);
			this.setDialogType(mode);
			var btnText = "No";
			if (!!buttonText) {
				if (buttonText)
					btnText = buttonText;
			}
			this.setBtnText(btnText);
			KL.Utils.Log.write("MessageDialog.show: " + text, mode == MessageDialog.MessageType.Error?KL.Utils.Log.type.WARNING:null)
			return this._result;
		}
	};
	KL.Web.registerClass("MessageDialog", MessageDialog);
	MessageDialog.extend(KL.Web.Dialog);
	MessageDialog.MessageType = {
		"Message": 1,
		"Error": 2
	};
})()
;
(function () {
	var UnderConstructionDialogView = function (id, setting) {
		this._super( id, setting );
	};
	UnderConstructionDialogView.prototype = {
		_btn: null,
		_lbl: null,
		setBtnText: function (text) {
			if (this._btn) {
				var localization = KL.Utils.Localization.getInstance();
				if (localization.stringExists(text))
					text = localization.getLocaleString(text);
				this._btn.find(".btnText").html(text);
			}
		},
		setLabelText: function (text) {
			if (this._lbl) {
				var localization = KL.Utils.Localization.getInstance();
				if (localization.stringExists(text))
					text = localization.getLocaleString(text);
				this._lbl.html(text);
			}
		},
		onDialogInit: function () {
			var elt = this.getElt();
			if (elt) {
				this._lbl = elt.find(".dialogText");
				this._btn = elt.find(".dialogBtn")
					.click(KL.Utils.Delegate.create(this, this.closeDialog));
			}
		}
	};
	KL.Web.Controls.registerClass("UnderConstructionDialogView", UnderConstructionDialogView);
	UnderConstructionDialogView.extend( KL.Web.Controls.ModalDialog );
	var UnderConstructionDialog = function (id, app) {
		this._super( id, app );
	};
	UnderConstructionDialog.prototype = {
		width: 300,
		_result: null,
		_btnOk: null,
		_createView: function(){ this._view = new MessageDialogView(this.id); },
		setTilte: function (text) {
			this._view.setTitle(text);
		},
		setDialogType: function (mode) {
			var className = (mode == MessageDialog.MessageType.Error ? "errorMessage" : "");
			this.setDialogClass(className);
		},
		setMessage: function (text) {
			this._view.setLabelText(text);
		},
		setBtnText: function (text) {
			this._view.setBtnText(text);
		},
		_triggerOnClose: function () {
			$(this._result).trigger("onok");
			this._result = null;
		},
		showDialog: function (text, title, buttonText, width, mode) {
			this.showPage();
			this._result = { id: this.id, elt: this._view.getElt() };
			this._view.width = width || this.width;
			this.setTilte(title);
			this.setMessage(text);
			this.setDialogType(mode);
			var btnText = "No";
			if (!!buttonText) {
				if (buttonText)
					btnText = buttonText;
			}
			this.setBtnText(btnText);
			return this._result;
		}
	};
	UnderConstructionDialog.MessageType = {
		"Message": 1,
		"Error": 2
	};
	KL.Web.registerClass("UnderConstructionDialog", UnderConstructionDialog);
	UnderConstructionDialog.extend( KL.Web.Dialog );
})()
;
(function () {
	var PageCreator = function (app) {
		this._app = app;
		this._controlFab = new KL.Web.Controls.ControlFab();
	};
	PageCreator.prototype = {
		_controlFab: null,
		_app: null,
		createConfirmDialog: function (id) {
			return new KL.Web.ConfirmDialog(id, this._app);
		},
		createMessageBox: function (id) {
			return new KL.Web.MessageDialog(id, this._app);
		},
		createPage: function (pageInfo, dataProvider) {
			var id = pageInfo.id
			var elts = pageInfo.elements || [];
			delete pageInfo.elements;
			delete pageInfo.id;
			var p = null;
			if (pageInfo.isdialog)
				p = new KL.Web.Dialog(id, dataProvider, this._app);
			else {
				p = new KL.Web.Page(id, dataProvider, this._app);
				$(p).bind("onbeforepageopen", KL.Utils.Delegate.create(this._app, this._app.hideOtherPages, p));
			}
			delete pageInfo.isdialog;
			$.extend(p, pageInfo);
			for (var i = 0, l = elts.length; i < l; i++) {
				if (!!elts[i]) {
					var ctrl = this._controlFab.createControl(elts[i], p.getControl(p.id), p);
					if (!!ctrl)
						p.addControl(ctrl);
				}
			}
			return p;
		}
	};
	KL.Web.registerClass("PageCreator", PageCreator);
})()
;
(function(){
	var cssPatchId = "cssPatchLink",
		jsPatchId = "jsPatchScript",
		scriptPath = "resources/patch-{0}.js?cb={1}",
		cssPath = "resources/patch-{0}.css?cb={1}",
		defaultsCache = {},
		patchesCache = {};
		globalMethodName = "applyKLPatch";
	function applyJsPatch( lang, readyCallback, objPatch ){
		delete window[ globalMethodName ];
		patchesCache[lang] = objPatch;
		if( typeof readyCallback == "function" )
			readyCallback();
	}
	function restoreJS(){
	}
	function PatchWork( lang, options, readyCallback ){
		if( options ){
			if( options.css ){
				var pcss = KL.Utils.StringHelper.format( cssPath, lang, (new Date()).getTime() );
				$("head").append( '<link type="text/css" rel="stylesheet" href="' + pcss + '" id="'+ cssPatchId +'"/>' );
			}
			if( options.js ){
				if( patchesCache[lang] )
					applyJsPatch.call( this, lang, readyCallback, patchesCache[lang] );
				else{
					var pjs = KL.Utils.StringHelper.format( scriptPath, lang, (new Date()).getTime() );
					window[globalMethodName] = KL.Utils.Delegate.create( this, applyJsPatch, lang, readyCallback );
					$("head").append( '<script type="text/javascript" src="' + pjs + '" id="'+ jsPatchId +'"><' + "/script>" );
				}
				return;
			}
		}
		readyCallback();
	}
	PatchWork.prototype = {
		undo: function(){
			restoreJS.call(this);
			$("#" + jsPatchId + ", #" + cssPatchId ).remove();
		}
	};
	KL.Web.registerClass("PatchWork", PatchWork);
})();
;
(function () {
	var timeStart = new Date();
	var _patch = null,
		_inst = null;
	function _triggerLoad() {
		if (this._loadTimer)
			window.clearTimeout(this._loadTimer);
		this._loadTimer = null;
		KL.Utils.Log.write("Application._triggerLoad: called " + document.readyState);
		if (!this._ready) {
			KL.Utils.Log.write("Application._triggerLoad: doc. state is " + document.readyState);
			if ((document.readyState == 4 || document.readyState == "complete")) {
				this._ready = true;
				$(this).trigger("onapplicationready");
			} else
				this._loadTimer = window.setTimeout(KL.Utils.Delegate.create(this, _triggerLoad), 100);
		}
	}
	function _loadSettings (settingsData, dependenciesData, queriesData) {
		if (!!settingsData) {
			if (settingsData instanceof Array) {
				for (var i = 0, l = settingsData.length; i < l; i++) {
					this.addSetting(settingsData[i]);
				}
			} else {
				this.addSetting(settingsData);
			}
		}
		
		window.setTimeout(KL.Utils.Delegate.create(this, _loadDependencies, dependenciesData, queriesData), 0);
	}
	function _loadDependencies(dependencies, queriesData) {
		if (!dependencies)
			return;
		if (dependencies instanceof Array || typeof (dependencies) == "Array") {
			for (var i = 0, l = dependencies.length; i < l; i++) {
				if (!!dependencies[i]) {
					this._dependencyFab.createDependency(dependencies[i]);
				}
			}
		} else {
			if (!!dependencies) {
				this._dependencyFab.createDependency(dependencies);
			}
		}
		
		window.setTimeout(KL.Utils.Delegate.create(this, _loadQueries, queriesData), 0);
	}
	function _loadQueries(queriesData) {
		var Delegate = KL.Utils.Delegate,
			QueryCreator = KL.Data.Queries.QueryCreator;
		$(QueryCreator).on("appready", KL.Utils.Delegate.create(this, this._showDefaultPage));
		this.makeAppQueries(QueryCreator);
		if (!queriesData)
			return;
		$(QueryCreator).on( "ready", Delegate.create(this, _queriesReady) );
		QueryCreator.createQueries(queriesData, this, this._dataProvider);
	}
	function _queriesReady (  ){
		this._init();
	}
	function _httpErrorHandler(e, error) {
		var Log = KL.Utils.Log,
			res, retVal = true;
		Log.write("Application._httpErrorHandler: Application HTTP Error handler");
		if (!!error) {
			var Exception = KL.Utils.Exception;
			switch (error.id) {
				case Exception.ExceptionTypes.InternalServer:
					this._dataProvider.stopLoading();
					res = this.showMessage(Exception.getExceptionText(error.id) || error.message, "LabelDialogTitleConnectionError", "BtnClose", 300, KL.Web.MessageDialog.MessageType.Error);
					$(res).bind("onok", KL.Utils.Delegate.create(this, this.showLoginPage));
					retVal = false;
					break
				case Exception.ExceptionTypes.SessionIdNotFound:
					this._dataProvider.stopLoading();
					this.showLoginPage();
					retVal = false;
					break
				case Exception.ExceptionTypes.UnknownAction:
					this.showMessage(Exception.getExceptionText(error.id), "LabelDialogTitleError", "BtnClose", 300, KL.Web.MessageDialog.MessageType.Error);
					retVal = false;
					break
				case Exception.ExceptionTypes.UnknownActionHandler:
				case Exception.ExceptionTypes.TaskIsRunning:
					Log.write("Application._httpErrorHandler: Alerting of error (" + error.id + "): '" + error.message + "'", Log.type.ERROR);
					break
				case Exception.ExceptionTypes.HTTPInternalServerError:
					this._dataProvider.stopLoading();
					res = this.showMessage(Exception.getExceptionText(error.id), "LabelDialogTitleConnectionError", "BtnClose", 300, KL.Web.MessageDialog.MessageType.Error);
					$(res).bind("onok", KL.Utils.Delegate.create(this, this.showLoginPage));
					retVal = false;
					break
				default:
					Log.write("Application._httpErrorHandler: error messge(" + error.id + "): '" + error.message + "'", Log.type.WARNING);
					retVal = this.projHttpErrorHandler( error );
					break
			}
		}
		if(!retVal && !!e && "stopPropagation" in e)
			e.stopPropagation();
		return retVal;
	}
	function Application (initData, settingsData, dependenciesData, queriesData) {
		var Delegate = KL.Utils.Delegate;
		KL.Utils.Log.write("Application.constructor: called");
		this._dependencyFab = new KL.Web.Dependencies.DependencyFab(this);
		if (KL.Utils.PageHash)
			this._pageHash = KL.Utils.PageHash.create(this);
		this._pages = {};
		this._initData = initData;
		this._dataProvider = new KL.HTTP.DataProvider(this);
		$(this._dataProvider).bind("onerror", Delegate.create(this, _httpErrorHandler));
		this._context = KL.Web.Context.create(this);
		$(this._context).bind("oncontextready", Delegate.create(this, _loadSettings, settingsData, dependenciesData, queriesData));
		KL.Utils.Log.write("Application.constructor: done");
	};
	
	Application.prototype = {
		_pages: null,
		_applicationElt: null,
		_confirm: null,
		_msgBox: null,
		_context: null,
		_dataProvider: null,
		_settings: null,
		_dependencyFab: null,
		initialPage: null,
		loginPage: null,
		initialAction: null,
		licenseInfoAction: "",
		_ready: false,
		_templatesLoaded: false,
		_ignoreLicenseInit: false,
		_contextInited: false,
		_initData: null,
		loader: null,
		_pageHash: null,
		_lastCancelledDependency: null,
		projHttpErrorHandler: function( error ){
			return true;
		},
		makeAppQueries: function(QueryCreator){
			if (this.initialAction)
				QueryCreator.makeAppQuery({"id": "appInitQuery", "action": this.initialAction}, this, this._dataProvider );
		},
		setPageParam: function (key, val) {
			if (this._pageHash)
				this._pageHash.setParam(key, val);
		},
		getPageParam: function (key) {
			if (this._pageHash)
				return this._pageHash.getParamValue(key);
			return null;
		},
		userLogout: function () {
			this.getContext().setData(KL.Web.Context.DataTypes.UserName, null);
			if (this._pageHash)
				this._pageHash.resetParams();
		},
		registerUrlChangeEvent: function (ctrl, paramName) {
			var evtName = "on" + paramName + "change";
			$(this._pageHash).bind(evtName, KL.Utils.Delegate.create(ctrl, ctrl._pageHashChangeHandler));
		},
		_loadTimer: null,
		_addPage: function (pageInfo, pageCreator) {
			var p = pageCreator.createPage(pageInfo, this._dataProvider);
			this._pages[p.id] = p;
			var d = this.getDependencies(p.id);
			if (d) {
				for (var i = 0, l = d.length; i < l; i++) {
					d[i].applyToSender();
				}
			}
			if (p.ismain)
				this.initialPage = p.id;
			else if (p.islogin)
				this.loginPage = p.id;
			return p;
		},
		_tplSource: null,
		registerTemplatesSource: function (obj) {
			this._tplSource = obj || null;
			this._templatesLoaded = true;
			KL.Utils.Log.write("Application.registerTemplatesSource: Done, Starting Applicaton");
			this._start();
		},
		getCtrlTemplate: function (tplId) {
			var tpl = null;
			if (!!this._tplSource)
				tpl = this._tplSource.getTemplate(tplId) || null;
			KL.Utils.Log.write("Application.getCtrlTemplate: Template for " + tplId + (!tpl ? " does not exist" : " exists"));
			return tpl;
		},
		openConfirm: function (text, title, buttonsText, width) {
			return this._confirm ? this._confirm.showDialog(text, title, buttonsText, width) : {};
		},
		showMessage: function (text, title, btnText, width, messageType) {
			return this._msgBox ? this._msgBox.showDialog(text, title, btnText, width, messageType) : {};
		},
		getContext: function () {
			return this._context;
		},
		getPage: function (pageId) {
			return this._pages[pageId] || null;
		},
		getPagesContainer: function () {
			var elt = $("." + this._applicationElt);
			if (!elt.hasClass("_subcontrols"))
				elt = elt.find("._subcontrols").eq(0);
			return elt;
		},
		getControl: function (ctrlId) {
			var Page = KL.Web.Page;
			for (var pageId in this._pages) {
				if (this._pages[pageId] instanceof Page) {
					var ctrl = this._pages[pageId].getControl(ctrlId);
					if (!!ctrl)
						return ctrl;
				}
			}
			return null;
		},
		_init: function () {
			KL.Utils.Log.write("Application._init: Strat");
			
			var initData = this._initData;
			this._initData = null;
			var pageCreator = new KL.Web.PageCreator(this);
			this._confirm = pageCreator.createConfirmDialog("confirmDialog", this);
			this._pages[this._confirm.id] = this._confirm;
			this._msgBox = pageCreator.createMessageBox("messageDialog", this);
			this._pages[this._msgBox.id] = this._msgBox;
			if (initData instanceof Array) {
				for (var i = 0, l = initData.length; i < l; i++) {
					if (!!initData[i])
						this._addPage(initData[i], pageCreator);
				}
			} else {
				if (!!initData)
					this._addPage(initData, pageCreator);
			}
			Application.registerTemplatesSource = KL.Utils.Delegate.create( this, this.registerTemplatesSource );
			var ifr = '<iframe src="templates.shtml" style="width: 10px; height: 10px; position: absolute; left: -10px; top: -10px;"></iframe>';
			$(document.body).append(ifr);
			KL.Utils.Log.write("Application._init: End");
		},
		_start: function () {
			KL.Utils.Log.write("Application._start: Start");
			var Page = KL.Web.Page;
			for (var pageId in this._pages) {
				var p = this._pages[pageId];
				if (p instanceof Page)
					p.init();
			}
			if(!!this.loginPage && !!this._pages[this.loginPage] )
				KL.Data.Queries.QueryCreator.loadNext();
			else
				this._showDefaultPage();
			KL.Utils.Log.write("Application._init: End");
		},
		_showAppElement: function () {
			if (!!this._applicationElt) {
				$("." + this.loader).hide();
				$("." + this._applicationElt).show();
			}
		},
		_showDefaultPage: function () {
			this._showAppElement();
			if (!!this.initialPage && !!this._pages[this.initialPage])
				this._pages[this.initialPage].showPage();
		},
		hideOtherPages: function (page) {
			var Page = KL.Web.Page;
			var Dialog = KL.Web.Dialog;
			for (var pageId in this._pages) {
				var p = this._pages[pageId];
				if (pageId != page.id) {
					if (p instanceof Dialog && !!p.isVisible() && p.closeDialog() === false)
						return false;
					else if (p instanceof Page && !!p.isVisible() && p.hidePage() === false)
						return false;
				}
			}
		},
		setUserAuthorised: function (username, userType) {
			if(this._context){
				var ContextDataTypes = KL.Web.Context.DataTypes;
				this._context.setData(ContextDataTypes.UserName, username);
				this._context.setData(ContextDataTypes.UserType, userType);
			}
			KL.Data.Queries.QueryCreator.loadNext();
		},
		showLoginPage: function () {
			this._showAppElement();
			if (!!this.loginPage && !!this._pages[this.loginPage]) {
				var ctx = this.getContext();
				ctx.setData(KL.Web.Context.DataTypes.UserName, null);
				ctx.setData( KL.Web.Context.DataTypes.LoginEnabled, true );
				var Dialog = KL.Web.Dialog;
				for (var pageId in this._pages) {
					var p = this._pages[pageId];
					if (p instanceof Dialog && !!p.isVisible())
						p.closeDialog();
				}
				this._dataProvider.stopLoading(true);
				KL.Data.Queries.QueryCreator.resetCounter();
				this._pages[this.loginPage].showPage();
				KL.Utils.Log.write("!!!!! DONE IN: " + (( new Date() - timeStart )/1000) + "s");
			}
		},
		getSetting: function (name) {
			return KL.Data.SettingManager.getSetting( name );
		},
		addSetting: function (settingInfo) {
			if (!settingInfo)
				return;
			var s = KL.Data.SettingManager.create(settingInfo);
			return s;
		},
		getDependencies: function (id) {
			return this._dependencyFab?this._dependencyFab.getDependency(id):null;
		},
		setLastCancelledCtrlEvent: function (callback) {
			this._lastCancelledDependency = { "callback": callback };
		},
		setLastCancelledEvent: function (d, args) {
			this._lastCancelledDependency = { "actor": d, "args": args };
		},
		resumeLastCancelledEvent: function () {
			var d = this._lastCancelledDependency;
			if (!!d) {
				if (!!d.actor && (d.actor instanceof KL.Web.Dependencies.DependencyActor) && !!d.args)
					d.actor.applyAction.apply(d.actor, Array.prototype.slice.call(d.args));
				else if (typeof (d.callback) == "function")
					d.callback();
			}
			this._lastCancelledDependency = null;
		},
		getQueries: function (id) {
			return KL.Data.Queries.DataQuery.getInstance(id);
		},
		applyPatch: function( lang, options ){
			if( _patch )
				_patch.undo();
			var res = {};
			_patch = new KL.Web.PatchWork( lang, options, KL.Utils.Delegate.create( this, this.triggerPatchReady ) );
		},
		triggerPatchReady: function(){
			$(this).trigger( "patchready" );
		},
		_destroy: function () {
			KL.Utils.Log.write("Application._destroy: called");
			if (this._loadTimer)
				window.clearTimeout(this._loadTimer);
			this._loadTimer = null;
			if (this._pageHash)
				this._pageHash.destroy();
			this._pageHash = null;
			for (var pageId in this._pages) {
				this._pages[pageId].destroy();
				delete this._pages[pageId];
			}
			this._confirm = null;
			this._msgBox = null;
			this._dataProvider.stopLoading(true);
			delete this._dataProvider;
			$(this).unbind();
			this._pages = null;
		}
	};
	Application.__class = true;
	Application.destroy = function () {
		_inst._destroy();
		_inst = null;
	};
	Application.getContext = function () {
		var ctx = null;
		if (_inst && typeof(_inst.getContext ) == "function") {
			ctx = _inst.getContext();
		}
		return ctx;
	};
	Application.create = function (appData) {
		KL.Utils.Log.write("Application.create: called");
		if (!!appData) {
			var rootElt = appData.root || appData.rootElement;
			var loader = appData.loader || appData.apploader;
			var initialAction = appData.initialAction || appData.initialaction;
			
			var pagesData = appData.pages;
			var settingsData = appData.settings;
			var dependenciesData = appData.dependencies;
			var queriesData = appData.queries;
			_inst = new this(pagesData, settingsData, dependenciesData, queriesData);
			pagesData = null;
			settingsData = null;
			dependenciesData = null;
			queriesData = null;
	
			if (initialAction)
				_inst.initialAction = initialAction;
			if (rootElt)
				_inst._applicationElt = rootElt;
			if (loader)
				_inst.loader = loader;
			var Delegate = KL.Utils.Delegate;
			window.setTimeout(Delegate.create(_inst, _triggerLoad), 100);
			window.onbeforeunload = Delegate.create(this, Application.destroy);
		}
		return _inst;
	};
	
	KL.Web.registerClass("Application", Application);
})();
;
(function(){
function CreateApp(obj) {
	CreateApp.dateStart = CreateApp.dateStart || new Date();
	if (KL && KL.LMS && KL.LMS.Application && typeof (KL.LMS.Application.create) == "function") {
		KL.HTTP.DataProvider._urls = {
			"getLicenseText": "eula/license.{lang}.txt",
			"getKsnLicenseText": "eula/ksn.{lang}.txt"
		};
		KL.LMS.Application.create(obj);
	} else
		window.setTimeout((function (o) { return function () { CreateApp(o); }; })(obj), 200);
}
KL.registerNS("LMS");
KL.LMS.registerNS("Enums");
(function () {
	var DayRanges = {
		"LastHour": 0,
		"LastDay": 1,
		"LastWeek": 2,
		"Last2Weeks": 3,
		"LastMonth": 4,
		"Last3Months": 5,
		"LastYear": 6,
		"UserInterval": 7
	};
	KL.LMS.Enums.registerEnum("DayRanges", DayRanges);
})()
;
(function () {
	var Verdicts = {
		"Any": 0,
		"Spam": 1,
		"Virus": 2,
		"Content": 3,
        "Phishing": 4,
        "FailedToBackup": 5,
        "Blacklist": 6
	};
	KL.LMS.Enums.registerEnum("Verdicts", Verdicts);
})()
;
(function () {
	var ActionTypes = {
		"Reject": 1,
		"Cure" :2,
		"DeleteAttachment": 3,
		"DeleteMessage": 4,
		"Skip": 5
	};
	KL.LMS.Enums.registerEnum("ActionTypes", ActionTypes);
})()
;
(function () {
	var BlDenyActionType = {
		"DeleteMessage": 0,
		"Reject": 1
	};
	KL.LMS.Enums.registerEnum("BlDenyActionType", BlDenyActionType);
})()
;
(function () {
	var GroupActionTypes = {
		"Reject": 1,
		"Skip" :2,
		"Scan": 3
	};
	KL.LMS.Enums.registerEnum("GroupActionTypes", GroupActionTypes);
})()
;
(function () {
	var AsRateLimits = {
		"Minimum": 1,
		"Standard" :2,
		"High": 3,
		"Maximum": 4
	};
	KL.LMS.Enums.registerEnum("AsRateLimits", AsRateLimits);
})()
;
(function () {
	var AddrsTypes = {
		"CIDR": 0,
		"EMailMask": 1,
		"ExternalAccount" : 3
	};
	KL.LMS.Enums.registerEnum("AddrsTypes", AddrsTypes);
})()
;
(function () {
	var SizeCriteria = {
		"Less": 0,
		"Greater": 2
	};
	KL.LMS.Enums.registerEnum("SizeCriteria", SizeCriteria);
})()
;
(function () {
	var FilesTypes = {
		"Execs": {
			"Execs": ".exe;.dll;.ocx;.scr",
			"WinInstall": ".msi",
			"Java": ".class",
			"Links": ".elf",
			"Debian": ".deb",
			"LinuxInstall": ".rpm"
		},
		"Office": {
			"Documents": {
				"Word2003": ".doc",
				"Word2007": ".docx",
				"DocMacro": ".docm",
				"Template": ".dot",
				"Template2007": ".dotx",
				"TemplateMacro": ".dotm",
				"Acrobal": ".pdf",
				"XMLPaperSpec": ".xps",
				"RichText": ".rtf",
				"OpenDoc": ".odt",
				"StarOffice": ".sxw"
			},
			"Spreadsheets": {
				"Excel2003": ".xls;.xlt",
				"Excel2007": ".xlsx",
				"SheetMacro": ".xlsm",
				"ExcelBinary": ".xlsb",
				"Template2007": ".xltx",
				"TemplateMacro": ".xltm",
				"ExtensionMacro": ".xlam",
				"OpenDoc": ".ods"
			},
			"Presentations": {
				"PowerPoint2003": ".ppt;.pot;.pps",
				"PowerPoint2007": ".pptx; .sldx",
				"PowerPointMacro": ".pptm; .sldm",
				"Template2007": ".potx",
				"TemplateMacro": ".potm",
				"Demo2007": ".ppsx",
				"DemoMacro": ".ppsm",
				"OpenDoc": ".odp"
			},
			"Specials": {
				"OutlookMail": ".msg; .oft",
				"OutlookExpressesMail": ".eml",
				"OneNoteDoc": ".one",
				"OneNotePkg": ".onepkg",
				"Visio": ".vsd;.vss;.vst",
				"VisioXML": ".vdx;.vsx;.vtx",
				"InfoPathTpl": ".xsn",
				"PublisherDoc": ".pub"
			}
		},
		"Media": {
			"Video": {
				"Flash": ".flv",
				"VideoF4v": ".fv4",
				"AVI": ".avi",
				"Mpeg4ISO": ".3gp;.3g2;.3gp2;.3p2",
				"MPEG4": ".divx;.mp4",
				"Matroska": ".mkv",
				"Quicktime": ".mov;.qt",
				"Windows": ".asf;.wmv",
				"Real": ".rm;.rmvb",
				"CDDVD": ".vob;.dat;.mpg; mpeg",
				"Bink": ".bik"
			},
			"Audio": {
				"MP3": ".mp3",
				"Flac": ".flac",
				"Ape": ".ape",
				"OGG": ".ogg",
				"AAC": ".aac;.m4a",
				"Windows": ".wma",
				"AC3": ".ac3",
				"Wave": ".wav",
				"Matroska": ".mka",
				"Real": ".rm;.ra;.ravb",
				"MIDI": ".mid;.midi",
				"CD": ".cda"
			}
		},
		"Pictures": {
			"Rastr": {
				"JPEG": ".jpg;.jpe;.jpeg;.jff",
				"GIF": ".gif",
				"PNG": ".png; .apng",
				"BMP": ".bmp",
				"Targa": ".tif;.tiff"
			},
			"Vector": {
				"WinMeta": ".emf;.wmf",
				"PostScript": ".eps",
				"Photoshop": ".psd",
				"CorelDraw": ".cdr"
			},
			"Animated": {
				"Flash": ".swf"
			}
		},
		"Archives": {
			"ZIP": ".zip",
			"7zip": ".7z*;.7-z",
			"RAR": ".rar",
			"ISO": ".iso",
			"WinCab": ".cab",
			"Java": ".jar",
			"BZIP2": ".bz;.bz2;.tbz;.tbz2",
			"Gzip": ".gz;.tgz",
			"ARJ": ".arj"
		},
		"DataBases": {
			"Access2007": ".accdb;.accde;. accdp;. accdr",
			"Access2007Signed": ".accdc",
			"Access2003": ".mdb; .mdt"
		},
		"Other": {
			"Text": ".txt",
			"HtmlHelp": ".chm",
			"HTML": ".html; .htm",
			"MHT": ".mht"
		}
	};
	KL.LMS.Enums.registerEnum("FilesTypes", FilesTypes);
})()
;
(function () {
	var UpdaterSourceTypes = {
		"AKServer": 0,
		"KLServers": 1,
		"Custom": 2
	};
	KL.LMS.Enums.registerEnum("UpdaterSourceTypes", UpdaterSourceTypes);
})()
;
(function () {
	var UpdaterAuthTypes = {
		"NotRequired": 0,
		"Plain": 1
	};
	KL.LMS.Enums.registerEnum("UpdaterAuthTypes", UpdaterAuthTypes);
})()
;
(function () {
	var ScheduleStartRuleType = {
		"Manual": 0,
		"Once": 1,
		"Weekly": 2,
		"Monthly": 3,
		"Hourly": 4,
		"Minutely": 5,
		"Daily": 6,
		"Startup": 7
	};
	KL.LMS.Enums.registerEnum("ScheduleStartRuleType", ScheduleStartRuleType);
})()
;
(function () {
	var UserBlackListTypes = {
		"SURBL": 0,
		"DNSBL": 1
	};
	KL.LMS.Enums.registerEnum("UserBlackListTypes", UserBlackListTypes);
})()
;
(function () {
	var ScriptTypes = {
		"None": 0,
		"LDAPGeneric" :1,
		"AD" :2,
		"Custom":3
	};
	KL.LMS.Enums.registerEnum("ScriptTypes", ScriptTypes);
})()
;
(function () {
	var ReportCreationType = {
		"All":0,
		"Users": 1,
		"Daily": 2,
		"Weekly": 3,
		"Monthly": 4,
		"Yearly": 5
	};
	KL.LMS.Enums.registerEnum("ReportCreationType", ReportCreationType);
})();
;
(function () {
	var ReportFileFormat = {
		"pdf": 0,
		"html": 1,
		"text": 2
	};
	KL.LMS.Enums.registerEnum("ReportFileFormat", ReportFileFormat);
})();
;
(function () {
	var ReportPeriodType = {
		"Day": 0,
		"Month": 1,
		"Year": 2
	};
	KL.LMS.Enums.registerEnum("ReportPeriodType", ReportPeriodType);
})();
;
(function () {
	var ReportLang = {
		"ru": 0,
		"en": 1,
		"de": 2,
		"fr": 3
	};
	KL.LMS.Enums.registerEnum("ReportLang", ReportLang);
})();
;
(function () {
	var AsStatus = {
		"None":-1,
		"NotScanned":0,
		"NotAvailable":1,
		"Clean":2,
		"Trusted":3,
		"Formal":4,
		"Error":5,
		"ProbableSpam":6,
		"Blacklisted":7,
		"Spam":8,
		"MassMail": 9
	};
	KL.LMS.Enums.registerEnum("AsStatus", AsStatus);
})()
;
(function () {
	var AvStatus = {
		"None":-1,
		"NotScanned":0,
		"NotAvailable":1,
		"Clean":2,
		"Encrypted":3,
		"Corrupted":4,
		"Disinfected":5,
		"Suspicious":6,
		"Infected":7,
		"IntrusionThreat":8
	};
	KL.LMS.Enums.registerEnum("AvStatus", AvStatus);
})()
;
(function () {
	var CfStatus = {
		"None":-1,
		"NotScanned":0,
		"NotAvailable":1,
		"Clean":2,
		"SizeExceeded":3,
		"BannedFileName":4,
		"BannedFileFormat":5
	};
	KL.LMS.Enums.registerEnum("CfStatus", CfStatus);
})()
;
(function () {
	var ApStatus = {
		"None":-1,
		"NotScanned": 0,
		"NotAvailable": 1,
		"Clean": 2,
		"Error": 3,
		"Phishing": 4,
		"Malicious": 5
	};
	KL.LMS.Enums.registerEnum("ApStatus", ApStatus);
})()
;
(function () {
	var HeuristicLevelType = {
		"Unknown": 0,
		"Light" :1,
		"Medium": 2,
		"Deep": 3
	};
	KL.LMS.Enums.registerEnum("HeuristicLevelType", HeuristicLevelType);
})()
;
(function () {
	var DbStates = {
		"NoBases": 0,
		"Ok": 1,
		"Outdated":2,
		"Obsoleted":3
	};
	KL.LMS.Enums.registerEnum("DbStates", DbStates);
})()
;
(function () {
	var LicenseInvalidReasons = {
		"Unknown": 0,
		"Valid": 1,
		"Expired": 2,
		"Corrupted": 3,
		"NotSigned": 4,
		"WrongProduct": 5,
		"BlackListed": 6,
		"IllegalUpdate": 7,
		"InconsistentUpdate": 8,
		"KeyCreationDateInvalid": 9,
		"TrialAlreadyInUse": 10,
		"InvalidBlacklist": 11,
		"CantBeUsedAsReserved": 12,
		"KeyInstallDateInvalid": 13,
		"TrialPeriodIsOver": 14,
		"ConflictsWithCommercial": 15,
		"ExpiredAsReserve": 16,
		"SubscriptionAsReserved": 17
	};
	KL.LMS.Enums.registerEnum("LicenseInvalidReasons", LicenseInvalidReasons);
})()
;
(function () {
	var LicenseKeyTypes = {
		"Unknown": 0,
		"Beta": 1,
		"Trial": 2,
		"Test": 3,
		"OEM": 4,
		"Commercial": 5,
		"Subscription": 6,
		"SubscriptionProtection": 7
	};
	KL.LMS.Enums.registerEnum("LicenseKeyTypes", LicenseKeyTypes);
})()
;
(function () {
	var LicenseDashboardStatus = {
		"NotInstalled": 0,
        "Active": 1,
        "ExpiresSoon": 2,
        "Expired": 3,
        "TrialPeriodIsOver": 4,
        "BlackListed": 5,
        "Invalid": 6
	};
	KL.LMS.Enums.registerEnum("LicenseDashboardStatus", LicenseDashboardStatus);
})()
;
(function () {
var EventLoggerFacility = {
		"Kern" 		: 0<<3 , // value="LOG_KERN"/>
		"User" 		: 1<<3 , // value="LOG_USER"/>
		"Mail" 		: 2<<3 , // value="LOG_MAIL"/>
		"Daemon" 	: 3<<3 , // value="LOG_DAEMON"/>
		"Auth" 		: 4<<3 , // value="LOG_AUTH"/>
		"Syslog" 	: 5<<3 , // value="LOG_SYSLOG"/>
		"Lpr" 		: 6<<3 , // value="LOG_LPR"/>
		"News" 		: 7<<3 , // value="LOG_NEWS"/>
		"Uucp" 		: 8<<3,  // value="LOG_UUCP"/>
		"Cron" 		: 9<<3 , // value="LOG_CRON"/>
		"Authpriv" 	: 10<<3 , // value="LOG_AUTHPRIV"/>
		"Ftp" 		: 11<<3 , // value="LOG_FTP"/>
		"Local0" 	: 16<<3 , // value="LOG_LOCAL0"/>
		"Local1" 	: 17<<3 , // value="LOG_LOCAL1"/>
		"Local2" 	: 18<<3 , // value="LOG_LOCAL2"/>
		"Local3" 	: 19<<3 , // value="LOG_LOCAL3"/>
		"Local4" 	: 20<<3 , // value="LOG_LOCAL4"/>
		"Local5" 	: 21<<3 , // value="LOG_LOCAL5"/>
		"Local6" 	: 22<<3 , // value="LOG_LOCAL6"/>
		"Local7" 	: 23<<3  // value="LOG_LOCAL7"/>
	};
	KL.LMS.Enums.registerEnum("EventLoggerFacility", EventLoggerFacility);
})();
;
(function () {
		var EventLoggerLogLevel = {
		"Error" 		: 3 , // value="LOG_ERR"/>
		"Info" 	: 6 // value="LOG_INFO"/>
	};
	KL.LMS.Enums.registerEnum("EventLoggerLogLevel", EventLoggerLogLevel);
})();
;
(function () {
	var DbUpdateStatuses = {
		"Unknown": 0,
		"Ok": 1,
		"Failed": 2,
		"CanceledByUser": 3,
		"LicenseError": 4,
		"SystemError": 5
	};
	KL.LMS.Enums.registerEnum("DbUpdateStatuses", DbUpdateStatuses);
})()
;
(function () {
	var ReportFormatDate = {
         "Default"									: 0,
         "Day_Dot_MonthAbb_Space_Year"				: 1,//"%d.%b %Y";
         "Day_Space_MonthAbb_Comma_Space_Year"		: 2,//"%d %b, %Y";
         "Day_Dash_Month_Dash_YearShort"			: 3,//"%d-%m-%y";
         "Day_Slash_Month_Slash_YearShort"			: 4,//"%d/%m/%y";
         "Day_Dot_Space_Month_Dot_Space_YearShort"	: 5,//"%d. %m. %y";
         "Day_Dot_Month_Dot_YearShort"				: 6,//"%d.%m.%y";
         "Day_Month_YearShort"						: 7,//"%d%m%y";
         "Day_Dash_Month_Dash_Year"					: 8,//"%d-%m-%Y";
         "Day_Slash_Month_Dash_Year"				: 9,//"%d/%m-%Y";
         "Day_Slash_Month_Slash_Year"				: 10,//"%d/%m/%Y";
         "Day_Dot_Space_Month_Dot_Space_Year"		: 11,//"%d. %m. %Y";
         "Day_Dot_Month_Dot_Year"					: 12,//"%d.%m.%Y";
         "Day_Dot_Month_Dot_Year_Dot"				: 13,//"%d.%m.%Y.";
         "DayNoZero_Dot_MonthNoZero_Dot_Year"		: 14,//"%-d.%-m.%Y";
         "Day_Space_Dash_Month_Dash_Year"			: 15,//"%e-%m-%Y";
         "Day_Space_Dot_Month_Dot_Year"				: 16,//"%e.%m.%Y";
         "Month_Slash_Day_Slash_YearShort"			: 17,//"%m/%d/%y";
         "Month_Slash_Day_Slash_Year"				: 18,//"%m/%d/%Y";
         "Year_Dash_MonthAbb_Dash_Day"				: 19,//"%Y-%b-%d";
         "YearShort_Dash_Month_Dash_Day"			: 20,//"%y-%m-%d";
         "Year_Dash_Month_Dash_Day"					: 21,//"%Y-%m-%d";
         "Year_Dot_Month_Dot_Day_Dot"				: 22,//"%Y.%m.%d.";
         "Year_Dot_Month_Dot_Day"					: 23//"%Y.%m.%d";
	};
	KL.LMS.Enums.registerEnum("ReportFormatDate", ReportFormatDate);
})();
;
(function () {
	var BackupFailureActionType = {
		"Ignore":0,
		"TempFail":1,
		"Reject":2
	};
	KL.LMS.Enums.registerEnum("BackupFailureActionType", BackupFailureActionType);
})()
;
(function () {
	var FunctionalityLevel = {
		"Unknown": 0,
		"NoFeatures": 1,
		"OnlyUpdates": 2,
		"AntiVirusWithoutUpdates": 3,
		"AntiSpamWithoutUpdates": 4,
		"FunctionWithoutUpdates": 5,
		"AntiVirusFunctionality": 6,
		"AntiSpamFunctionality": 7,
		"FullFunctionality": 8
	};
	KL.LMS.Enums.registerEnum("FunctionalityLevel", FunctionalityLevel);
})()
;
(function () {
	var SettingsTypes = {
		"ImportAccounts": { "field": "importSections.importWebPasswords", "defaultVal": false },
		"MachineIndependent": {"field": "importSections.importMachineIndependent"},
		"MachineDependent": { "field": "importSections.importMachineDependent", "Extra": {
			"Trace": { "field": "importSections.machineDependent.importTraces" },
			"Proxy": { "field": "importSections.machineDependent.importProxy" },
			"Integration": { "field": "importSections.machineDependent.importAuth" },
			"Backup": { "field": "importSections.machineDependent.importBackup", "Extra": {
				"BackupPath": { "field": "importSections.machineDependent.backupImportSection.importFileStorage", "restartRequired": true, "defaultVal": false }
			}},
			"MailProcessing": { "field": "importSections.machineDependent.importScan", "Extra": {
				"FilterSocket": { "field": "importSections.machineDependent.scanImportSection.importFilterSocket", "restartRequired": true, "defaultVal": false }
			}},
			"Updater": { "field": "importSections.machineDependent.importUpdater" },
			"Quarantine": { "field": "importSections.machineDependent.importQuarantine", "restartRequired": true, "defaultVal": false }
		}},
		"Rules": { "field": "importSections.importRules" },
		"BWLists": { "field": "importSections.importPersonal" }
	};
	KL.LMS.Enums.registerEnum("SettingsTypes", SettingsTypes);
})();
;
(function () {
	var LdapCnnTypes = {
		NoEncryption: 0,
		TLS: 1,
		LDAPoverSSL: 2
	};
	KL.LMS.Enums.registerEnum("LdapCnnTypes", LdapCnnTypes);
})()
;
(function () {
	var PersonalStatus = {
		"NotMatched": 0,
		"BlackList": 1,
		"WhiteList": 2
	};
	KL.LMS.Enums.registerEnum("PersonalStatus", PersonalStatus);
})()
;
KL.LMS.registerNS("Helpers");
(function () {
	var GroupsHelper = {
		groupSendersToStr: function (data) {
			var retStr = [];
			if (data instanceof Array) {
				for (var i = 0, l = data.length; i < l; i++) {
					if (!!data[i] && "value" in data[i]) {
						if (data[i].value=="*") return KL.Utils.Localization.getInstance().getLocaleString("LabelAddressSetAny");	
						retStr.push(data[i].value);
					}
				}
				if (retStr.length==0) retStr.push(KL.Utils.Localization.getInstance().getLocaleString("LabelAddressNotSet"));	
			}
			return retStr.join(", ");
		},
		getGroupEditorTitle: function (data, ctrlId) {
			if (data.isNew)
				return KL.Utils.Localization.getInstance().makeLocaleStringObj(ctrlId, "LabelTitleGroupSettingsNew", KL.Utils.StringHelper.htmlEncode( data.name ));
			if (data.name) {
				return KL.Utils.Localization.getInstance().makeLocaleStringObj(ctrlId, "LabelTitleGroupSettingsChanges", KL.Utils.StringHelper.htmlEncode(data.name));
			}
			else		
				return KL.Utils.Localization.getInstance().makeLocaleStringObj(ctrlId, "LabelTitleGroupSettingsChanges", "???");
		},
		groupReceiversToStr: function (data) {
			var retStr = [];
			if (data instanceof Array) {
				for (var i = 0, l = data.length; i < l; i++) {
					if (!!data[i] && "value" in data[i]) {
						if (data[i].value=="*") return KL.Utils.Localization.getInstance().getLocaleString("LabelAddressSetAny");	
						retStr.push(data[i]["value"]);
					}
				}
				if (retStr.length==0) return KL.Utils.Localization.getInstance().getLocaleString("LabelAddressNotSet");	
			}
			return retStr.join(", ");
		},
		getExcludeTypesText: function (data) {
			var data_out = [];
			var l = KL.Utils.Localization.getInstance();
			for (var prop in data) {
				if (data.hasOwnProperty(prop)) {
					var data_i = data[prop];
					if (data_i) {
						if (typeof (data_i) == "boolean" || data_i instanceof Boolean)
							data_out.push(l.getLocaleString("LabelFilesTypes_" + prop + "Ext"));
						else
							data_out = data_out.concat(this.getExcludeTypesText(data_i));
					}
				}
			}
			return data_out;
		},
		getExcludeTypesTextString: function (data) {
			var data_out = [];
			var l = KL.Utils.Localization.getInstance();
			
			for (var prop in data) {
				if (data.hasOwnProperty(prop)) {
					var data_i = data[prop];
					if (data_i) {
						if (typeof (data_i) == "boolean" || data_i instanceof Boolean)
							data_out.push(l.getLocaleValueString("LabelFilesTypes_" + prop + "Ext"));
						else
							data_out = data_out.concat(this.getExcludeTypesTextString(data_i));
					}
				}
			}
			return data_out;
		},
		actionStr: function (val) {
			return KL.Utils.Localization.getInstance().getLocaleString("LabelSettingAction_" + val);
		},
		getNotificationUsers: function (val,id, data,field) {
			var l = KL.Utils.Localization.getInstance();
			var data_out = [];
			if (data["admin"][field])
				data_out.push(l.getLocaleString("LabelSettingEditorNotification_Admin"));
			if (data["sender"][field])
				data_out.push(l.getLocaleString("LabelSettingEditorNotification_Sender"));
			if (data["recipient"][field])
				data_out.push(l.getLocaleString("LabelSettingEditorNotification_Recipient"));
			if (data["additional"]["options"][field])
				data_out.push(l.getLocaleString("LabelSettingEditorNotification_Additional"));
			if (data_out.length==0)
				data_out = [l.getLocaleString("LabelSettingEditorNotification_None")];
			return data_out.join(", ");
		}
	};
	KL.LMS.Helpers.registerClass("GroupsHelper", GroupsHelper);
})()
;
(function () {
	var sizeTypes = ("B,KB,MB,GB,TB,PB").split(",");
	var CommonHelper = {
		getVersionText: function (data, ctrlId) {
			if (data) {
				var localization = KL.Utils.Localization.getInstance();
				return localization.makeLocaleStringObj.apply(localization, ([ctrlId,"LabelHeaderVersionInfo"]).concat(data.split(/[^\d]/g)));
			}
			return "";
		},
		getServerNameText: function (data, ctrlId) {
			if (data) {
				
				return data;
			}
			return "";
		},
		localSizeObj: function (val,count,noLocalize) {
			
			var size = val;
			var sizeType = sizeTypes[0];
			for (var i = 1; !!(sizeTypes[i]) && size >= 1024; i++) {
				size /= 1024;
				sizeType = sizeTypes[i];
			}
			size = count?Math.round(size):Math.round(size * 100) / 100;
			if( noLocalize )
				return {"value": size, "type": sizeType};
			return KL.Utils.Localization.getInstance().getLocaleStringObj("ResDataSize" + sizeType, size );
		},
		fillSelectWidthEnum: function (select, enm, resName) {
			for (var i in enm) {
				if (enm.hasOwnProperty(i)) {
					$("<option>").appendTo(select).attr({
						"value": enm[i]
					}).addClass("str-local-Label" + resName + i);
				}
			}
		},
		getPersentVal: function (val) {
			return val+"%";
		},
		getSizeInMB: function (val, ctrlId) {
			var size = val;
			var sizeType = sizeTypes[0];
			for (var i = 1; !!(sizeTypes[i]) && size >= 1024; i++) {
				size /= 1024;
				sizeType = sizeTypes[i];
			}
			return KL.Utils.Localization.getInstance().makeLocaleStringObj(ctrlId,"ResDataSize" + sizeType, Math.round(size * 100) / 100);
		},
		
		
		getIsEnabledTxtByBoolVal: function (val, a, b, c) {
			return KL.Utils.Localization.getInstance().getLocaleString(!!val ? "LabelSettingEnabled" : "LabelSettingDisabled");
		},
		getIsEnabledColorTxtByBoolVal: function (val) {
			return KL.Utils.Localization.getInstance().getLocaleString(!!val ? "LabelSettingEnabledColor" : "LabelSettingDisabledColor");
		},
		getIsASEnabledColorTxtByBoolVal: function (val) {
			return this.getIsEnabledColorTxtByBoolVal(val && KL.Web.Application.getContext().getProtectionState("AS") );
		},
		getIsAPEnabledColorTxtByBoolVal: function (val) {
			return this.getIsEnabledColorTxtByBoolVal(val && KL.Web.Application.getContext().getProtectionState("AP") );
		},
		getIsAVEnabledColorTxtByBoolVal: function (val) {
			return this.getIsEnabledColorTxtByBoolVal(val && KL.Web.Application.getContext().getProtectionState("AV") );
		},
		getIsCFEnabledColorTxtByBoolVal: function (val) {
			return this.getIsEnabledColorTxtByBoolVal(val && KL.Web.Application.getContext().getProtectionState("CF") );
		},
		getIsLicenseAccteptedText: function (val) {
			return KL.Utils.Localization.getInstance().getLocaleString(!!val ? "LabelSettingLicenseAccepted" : "LabelSettingLicenseNotAccepted");
		}
	};
	KL.LMS.Helpers.registerClass("CommonHelper", CommonHelper);
})()
;
(function () {
	var UpdateSettingsHelper = {
		getAddress: function (data) {
			if (data=="") return KL.Utils.Localization.getInstance().getLocaleString("LabelAddressNotSet");	
			return data;
		},
		getAdminAddress: function (data) {
			if (data==="") return KL.Utils.Localization.getInstance().getLocaleString("LabelAddressNotSet");
			
			return data.replace(/,/g,"; " );
		},
		getProxyStatus: function (val,id, data) {
			var _useProxy = false;
			if (data.updateCommonSettings.sourceType ==KL.LMS.Enums.UpdaterSourceTypes.Custom)
				_useProxy = data["updateCommonSettings"]["useProxyForCustom"];
			else
				_useProxy = data["updateCommonSettings"]["useProxyForKlServers"];
		
			return KL.Utils.Localization.getInstance().getLocaleString(_useProxy ? "LabelSettingsUpdateUseProxyOn" : "LabelSettingsUpdateUseProxyOff");
		},
		getFtpPassiveStatus: function (val) {
			return KL.Utils.Localization.getInstance().getLocaleString(val ? "LabelSettingsUpdateFtpPassiveOn" : "LabelSettingsUpdateFtpPassiveOff");
		},
		getProxyAuthType: function (val) {
			return KL.Utils.Localization.getInstance().getLocaleString("LabelSettingsUpdateAuth" + KL.LMS.Enums.UpdaterAuthTypes.getKeyByValue(val));
		},
		getUpdateTaskState: function (val, ctrlId,data) {
			var DateHelper = KL.Utils.DateHelper;
			var Log = KL.Utils.Log;
			var localization = KL.Utils.Localization.getInstance();
			var DbUpdateStatuses = KL.LMS.Enums.DbUpdateStatuses;
			var updated = "";
			try{
				if (DateHelper.isServerTimeSet()) {
					if( !data.isRunning ){
						var updateDiff = DateHelper.dateDiffToServer(DateHelper.dateFromUTC(val.time || val), DateHelper.DiffApproximations.Minutes, " ");
						var updateStatus = val.lastUpdateStatus || val.status;
						if( updateStatus != DbUpdateStatuses.Ok ){
							updated = localization.getLocaleString("LabelDashboardLastUpdate"+DbUpdateStatuses.getKeyByValue(updateStatus));
						} else {
							updated = updateDiff ? localization.getLocaleString("LabelDashboardUpdatedAgoPrefix") + updateDiff + localization.getLocaleString("LabelDashboardUpdatedAgo") : localization.getLocaleString("LabelDashboardUpdatedNow");
						}
					}else
						updated = localization.getLocaleString("LabelDashboardUpdateInProgress");
				}
				else {
					window.setTimeout(KL.Utils.Delegate.create(this, this.getUpdateTaskState, val, ctrlId), 500);
				}
			}
			catch(e){
				Log.write( this + ".getUpdateTaskState: Error " + (e.message || e), Log.type.WARNING);
				updated = localization.getLocaleString("LabelDashboardLastUpdateFailed");
			}
			return updated;
		},
		getProxyCnnTimeout: function (val, ctrlId) {
			return KL.Utils.Localization.getInstance().makeLocaleStringObj(ctrlId, "LabelSettingsUpdateTimeout", val);
		},
		getUpdateSource: function (val, id, data) {
			if (val != KL.LMS.Enums.UpdaterSourceTypes.Custom) {
				return KL.Utils.Localization.getInstance().getLocaleString("LabelUpdateSourceTypeOption_"
					+ KL.LMS.Enums.UpdaterSourceTypes.getKeyByValue(val));
			}
			else {
				var str = [KL.Utils.Localization.getInstance().getLocaleString("LabelUpdateDefaultSource")];
				var sources = data.updaterSettings.updateCommonSettings.customSources;
				if (sources instanceof Array) {
					str = [];
					for (var i = 0; i < sources.length; i++) {
						str.push(sources[i]);
					}
				}
				return str.join("; ");
			}
		},
		getScheduleValue: function (val, ctrlId) {
			var ScheduleStartRuleType = KL.LMS.Enums.ScheduleStartRuleType,
				DateHelper = KL.Utils.DateHelper,
				localization = KL.Utils.Localization.getInstance(),
				str_warning = "",
				strOut = "",
				keyString = "LabelUpdateStartType" + ScheduleStartRuleType.getKeyByValue(val.ruleType),
				d = val.startByTime,
				scheduleDate = DateHelper.getDateTimeObj( new Date( d.year, d.month, d.day, d.hour, d.min, 0, 0 ) );
			scheduleDate.setDay(d.day, d.dayOfWeek);
			scheduleDate.dayOfMonth = d.dayOfMonth;
			switch (+val.ruleType) {
				case ScheduleStartRuleType.Daily:
					scheduleDate.DaysPeriod = d.timePeriod;
				case ScheduleStartRuleType.Once:
				case ScheduleStartRuleType.Manual:
					strOut = localization.makeLocaleStringTemplateObj(ctrlId, keyString, scheduleDate);
					break;
				case ScheduleStartRuleType.Weekly:
					keyString += DateHelper.DaysEnum[([null, 1, 2, 3, 4, 5, 6, 0])[d.dayOfWeek]];
					strOut = localization.makeLocaleStringTemplateObj(ctrlId, keyString, scheduleDate);
					break;
				case ScheduleStartRuleType.Hourly:
					scheduleDate.HoursPeriod = d.timePeriod;
					strOut = localization.makeLocaleStringNumTemplateObj( ctrlId, "LabelUpdateStartTypeHourly", scheduleDate, "HoursPeriod" );
					break;
				case ScheduleStartRuleType.Minutely:
					scheduleDate.MinutesPeriod = d.timePeriod;
					strOut = localization.makeLocaleStringNumTemplateObj( ctrlId, "LabelUpdateStartTypeMinutely", scheduleDate, "MinutesPeriod" );
					break;
				case ScheduleStartRuleType.Monthly:
					if (d.dayOfMonth >= 30)
						str_warning = "<span class=\"warningIcon\" title=\"" +
							localization.getLocaleValueString("LabelUpdateStartTypeMonthlyWarning") +
							"\" >&zwnj;</span>";
					
					strOut = localization.makeLocaleStringTemplateObj(ctrlId, "LabelUpdateStartTypeMonthly", scheduleDate) + str_warning;
					break;
			}
			return strOut;
		}
	};
	KL.LMS.Helpers.registerClass("UpdateSettingsHelper", UpdateSettingsHelper);
})()
;
(function () {
	var LdapSearchPanel = function (container, isSingleItemSelect) {
		this._ldapSearchItemCell = "";
		this._ldapSearchItem = "";
		this._ldapSearchPnl = null;
		this._container = null;
		this._multiselect = true;
		this._timerFindEnabled = null;
		this._construct = function (ldapPanel, isMultiselect) {
			var Delegate = KL.Utils.Delegate;
			this._container = ldapPanel;
			this._multiselect = isMultiselect;
			ldapPanel.find(".ldapItemSearch .editField")
				.keyup(Delegate.create(this, this._toggleFindEnabled))
				.focus(Delegate.create(this, this._startCheckToggleFind))
				.blur(Delegate.create(this, this._endCheckToggleFind));
			this._ldapSearchPnl = ldapPanel.find(".ldapSearchResultList .item").parent();
			this._ldapSearchItemCell = this._ldapSearchPnl.find(".item .itemCell").parent().html();
			this._ldapSearchPnl.find(".item .itemCell").parent().empty();
			this._ldapSearchItem = this._ldapSearchPnl.html();
			this._ldapSearchPnl.empty();
			ldapPanel.find(".infoLdapFoundCount").removeClass("infoWarn").html(KL.Utils.Localization.getInstance().getLocaleString("LabelAddrEditTitleFoundInLDAP_Init"));
			ldapPanel.find(".btnFind").click(Delegate.create(this, this._search));
			ldapPanel.find(".clearBtn").click(Delegate.create(this, this._clear));
			this._toggleFindEnabled();
		};
		this._startCheckToggleFind = function () {
			if (this._timerFindEnabled !== null)
				this._endCheckToggleFind();
			this._timerFindEnabled = window.setInterval(KL.Utils.Delegate.create(this, this._toggleFindEnabled), 100);
		};
		this._endCheckToggleFind = function () {
			if (this._timerFindEnabled !== null) {
				window.clearInterval(this._timerFindEnabled);
				this._timerFindEnabled = null;
			}
		};
		this._toggleFindEnabled = function () {
			var val = this.getSearchTerm();
			this._container.find(".ldapItemSearch .btnFind").attr("disabled", !val);
		};
		this._search = function () {
			var term = this.getSearchTerm();
			if (!!term)
				$(this).trigger("onsearch", [term]);
		};
		this._clear = function () {
			this._container.find(".ldapItemSearch .editField").focus().val("");
			this._toggleFindEnabled();
		};
		this.getSearchTerm = function () {
			return $.trim(this._container.find(".ldapItemSearch .editField").val());
		};
		this.getSearchLimit = function () {
			return 51;
		};
		this.clearList = function(){
			this._ldapSearchPnl.empty();
			this._ldapItems = [];
		};
		this.addItems = function (data) {
			var localization = KL.Utils.Localization.getInstance();
			this.clearList();
			this._triggerSelected(null);
			var infoPanel = this._container.find(".infoLdapFoundCount").removeClass("infoWarn");
			if (data.items) {
				var Delegate = KL.Utils.Delegate;
				var countItems = data.items.length;
				if (countItems==51) {
					countItems = 50;
					infoPanel.addClass("infoWarn").html(localization.getLocaleStringObj("LabelAddrEditTitleFoundInLDAP_More", data.items.length));
				} else
					infoPanel.html(localization.getLocaleStringObj("LabelAddrEditTitleFoundInLDAP_True", data.items.length));
				for (var i = 0, l = countItems; i < l; i++) {
					var row = $(this._ldapSearchItem).appendTo(this._ldapSearchPnl);
					data.items[i]["value"] = data.items[i]["entryid"];
					row.data("ldap-item", data.items[i]);
					this._appendLdapString(data.items[i].attributes, row);
					switch (data.items[i].objectType) {
						case 0: break;
						case 1: row.addClass("itemGroup"); break;
						default: row.addClass("itemUnknown"); break;
					}
					row.hover(
						function () { $(this).addClass("itemOver"); },
						function () { $(this).removeClass("itemOver"); }
					).click(Delegate.create(this, this._selectItem, row, data.items[i]));
				}
			}
			else
				infoPanel.html(localization.getLocaleString("LabelAddrEditTitleFoundInLDAP_False"));
		};
		this.removeSelection = function () {
			this._ldapSearchPnl.find(".itemSelected").removeClass("itemSelected").each(function (index, row) {
				$(row).data("ldap-item-selected", false);
			});
		};
		this._selectItem = function (row, data) {
			var evt = $.Event("onbeforeitemselected");
			$(this).trigger(evt, KL.Utils.Delegate.create(this, this._selectItem, row, data));
			if (evt.isDefaultPrevented())
				return;
			if (!this._multiselect)
				this.removeSelection();
			var isSelected = !row.data("ldap-item-selected");
			row.toggleClass("itemSelected", isSelected);
			row.data("ldap-item-selected", isSelected);
			this._triggerSelected(this._ldapSearchPnl.find(".itemSelected").length);
		};
		this._appendLdapString = function (data, row) {
			var result = "";
			for (var i = 0, l = data.length; i < l; i++) {
				if (data[i]["attribute"] != "objectClass")
					result = result + data[i]["attribute"].toUpperCase()+":"+data[i]["values"].join(", ") + ";   ";
			}
			$(this._ldapSearchItemCell).appendTo(row).text(result);
		};
		this.getSelectedItems = function () {
			var data = [];
			this._ldapSearchPnl.find(".itemSelected").each(function (index, row) {
				data.push($(row).data("ldap-item"));
			});
			return data;
		};
		this._triggerSelected = function (count) {
			$(this).trigger("onitemselected", [count]);
		};
		this._construct(container, !isSingleItemSelect);
	};
	var LdapHelper = {
		getScriptName: function (val) {
			var ScriptTypes = KL.LMS.Enums.ScriptTypes;
			var key = ScriptTypes.getKeyByValue(val) || ScriptTypes.getKeyByValue(ScriptTypes.None);
			return KL.Utils.Localization.getInstance().getLocaleString("LabelLdapScriptTypeOption_" + key)
		},
		getStatus: function (val) {
			return KL.Utils.Localization.getInstance().getLocaleString("LabelSettingsLdapStatus_" + val);
		},
		getAccess: function (val) {
			return KL.Utils.Localization.getInstance().getLocaleString("LabelSettingsLdapStatus_BlackWhite_" + val);
		},
		getUseNestedGroups: function (val,id,data,fieldName) {
			var ScriptTypes = KL.LMS.Enums.ScriptTypes;
			var sectionName = ScriptTypes.getKeyByValue(data["integrationType"]) || ScriptTypes.getKeyByValue(ScriptTypes.None);
			if (data[sectionName]["filters"][fieldName])
				return KL.Utils.Localization.getInstance().getLocaleString("LabelUpdateRunMissedOption_On");
			else
				return KL.Utils.Localization.getInstance().getLocaleString("LabelUpdateRunMissedOption_Off");
		},
		
		getLDAPValue: function (val,id,data,fieldName) {
			var ScriptTypes = KL.LMS.Enums.ScriptTypes;
			var sectionName = ScriptTypes.getKeyByValue(data["integrationType"]) || ScriptTypes.getKeyByValue(ScriptTypes.None);
			if (sectionName == "None") return KL.Utils.Localization.getInstance().getLocaleString("LabelSettingsPreviewCnnNotSet");
			
			var val = data[sectionName][fieldName];
			return (val && (typeof (val) == "string" || val instanceof String) ? KL.Utils.StringHelper.htmlEncode(val) : val) || KL.Utils.Localization.getInstance().getLocaleString("LabelSettingsPreviewCnnNotSet");
		},
		getLDAPFiltersValue: function (val,id,data,fieldName) {
			var ScriptTypes = KL.LMS.Enums.ScriptTypes;
			var sectionName = ScriptTypes.getKeyByValue(data["integrationType"]) || ScriptTypes.getKeyByValue(ScriptTypes.None);
			if (sectionName=="None") return "";
			
			var val = data[sectionName]["filters"][fieldName];
			return (typeof (val) == "string" || val instanceof String) ? KL.Utils.StringHelper.htmlEncode(val) : val;
		},
		getCustomBinPath: function (val,id,data,fieldName) {
			if (!val || val == "") return KL.Utils.Localization.getInstance().getLocaleString("LabelSettingsPreviewCnnNotSet");
			else return val;
		},
		
		
		makeSearchPanel: function (elt, isSingleItemSelect) {
			return new LdapSearchPanel(elt, isSingleItemSelect);
		}
	};
	KL.LMS.Helpers.registerClass("LdapHelper", LdapHelper);
})()
;
(function () {
	var SettingsHelper = {
		getHaLevelText: function (val) {
			var HeuristicLevelType = KL.LMS.Enums.HeuristicLevelType;
			var levelName =  HeuristicLevelType.getKeyByValue(val) || HeuristicLevelType.getKeyByValue(HeuristicLevelType.Unknown);
			return KL.Utils.Localization.getInstance().getLocaleString("LabelHeuristicLevel" + levelName);
		},
		getListValueText: function (val, ctrlId) {
			var localization = KL.Utils.Localization.getInstance();
			var str = localization.getLocaleString("LabelSettingsProtectionPreviewEmptyList");
			if (!!val && (val instanceof Array) && !!val.length) {
				var itemsPreview = KL.Utils.StringHelper.cropString( KL.Utils.StringHelper.htmlEncode( val.join(", ") ), 50);
				str = localization.makeLocaleStringNumObj(ctrlId, "LabelSettingsProtectionPreviewListLen", val.length, itemsPreview);
			}
			return str;
		},
		isKsnParticipationActivated: function(val, ctrlId) {
			return KL.Web.Application.getContext().getKsnParticipationActivated();
		},
		isAvSettingsActive: function(val, ctrlId){
			return KL.Web.Application.getContext().getIsLicenseAvEnabled();
		},
		isAsSettingsActive: function(val, ctrlId){
			return KL.Web.Application.getContext().getIsLicenseAsEnabled();
		},
		isAfSettingsActive: function(val, ctrlId){
			return KL.Web.Application.getContext().getIsLicenseApEnabled();
		},
		isCfSettingsActive: function(val, ctrlId){
			return KL.Web.Application.getContext().getIsLicenseCfEnabled();
		},
		getNoLongerText: function (val, ctrlId) {
			return KL.Utils.Localization.getInstance().makeLocaleStringObj(ctrlId, "LabelSettingsProtectionPreviewNoLongerTime", val);
		},
		getSecondsNumText: function (val, ctrlId) {
			return KL.Utils.Localization.getInstance().makeLocaleStringObj(ctrlId, "ResTimeSecondsCount", val);
		},
		getIsDefinedStr: function (val, ctrlId) {
			return $.trim(val)|| KL.Utils.Localization.getInstance().getLocaleString("LabelSettingsMiscSCNotDef");
		},
		getEvenrLoggerFacilityText: function (val, ctrlId) {
			return KL.LMS.Enums.EventLoggerFacility.getKeyByValue(val);
		},
		getEvenrLoggerLevelText: function (val, ctrlId) {
			return KL.LMS.Enums.EventLoggerLogLevel.getKeyByValue(val);
		},
		getBackupFailureActionText: function (val, ctrlId) {
			var localization = KL.Utils.Localization.getInstance();
			var postfix = KL.LMS.Enums.BackupFailureActionType.getKeyByValue(val);
			return localization.makeLocaleStringObj(ctrlId, "LabelSettingsBackupFailureAction_"+ postfix);
		},
		getBlActionText: function(val){
			return KL.Utils.Localization.getInstance().getLocaleString("LabelSettingsBlAction_" + KL.LMS.Enums.BlDenyActionType.getKeyByValue(val) );
		},
		getAsSettingsInactiveReasonMessage: function(){
			return "LabelSettingsTootipAsDisabeld";
		},
		getApSettingsInactiveReasonMessage: function(){
			return "LabelSettingsTootipApDisabeld";
		},
		getAvSettingsInactiveReasonMessage: function(){
			return "LabelSettingsTootipAvDisabeld";
		},
		getCfSettingsInactiveReasonMessage: function(){
			return "LabelSettingsTootipCfDisabeld";
		},
		getIsKsnUsedText: function(val) {
			return KL.Utils.Localization.getInstance().getLocaleString(
				(!!val && this.isKsnParticipationActivated()) ? "LabelSettingEnabledColor" : "LabelSettingDisabledColor");
		}
	};
	KL.LMS.Helpers.registerClass("SettingsHelper", SettingsHelper);
})()
;
(function () {
	function triggerLicenseChange(){
		$(this).trigger("onlicensechanged");
	}
	function ContextChangeAdapter( id, setting ){
		ContextChangeAdapter._super.call(this, id, setting);
		var ctx = KL.Web.Application.getContext();
		$(ctx).on("onlicensechanged", KL.Utils.Delegate.create( this, triggerLicenseChange ));
	}
	ContextChangeAdapter.prototype = {
		_appSettings: null,
		_getTemplate: function(){ return ""; },
		
		applyAppSettings: function(evt, data){
			var ctx = KL.Web.Application.getContext();
			if( ctx )
				ctx.setAppSettings(data);
		},
		applyKsnParticipationActivated: function(evt, data) {
			var ctx = KL.Web.Application.getContext();
			if( ctx )
				ctx.setKsnParticipationActivated(data);
		}
	};
	KL.LMS.registerClass("ContextChangeAdapter", ContextChangeAdapter);
	ContextChangeAdapter.extend(KL.Web.Controls.Control);
})()
;
KL.LMS.registerNS("Groups");
(function () {
	var GroupsGrid = function (id, setting) {
		GroupsGrid._super.call( this, id, setting );
	};
	GroupsGrid.prototype = {
		pageSize: 15,
		_currCount: 0,
		_dataActive: null,
		_dataPriority: null,
		rowsselectable: false,
		enterrowonclick: true,
		_groupId: -1,
		_DefaultRuleId: 1,
		cellHeight: 33,
		applyError: function (evt, err) {
			var errTxt = "";
			var errMsg = KL.Utils.Exception.getExceptionText(err.id) || err.message;
			var localization = KL.Utils.Localization.getInstance();
			
			if (err.data && err.data.items instanceof Array) {
				var rulesDic = {};
				if (this._data && this._data.items instanceof Array) {
					for (var i = 0, l = this._data.items.length; i < l; i++)
						rulesDic[this._data.items[i].groupId] = this._data.items[i].name;
				}
				var rulesNames = [];
				for (var i = 0, l = err.data.items.length; i < l; i++) {
					var item_i = err.data.items[i];
					if (item_i == this._DefaultRuleId)
						errTxt = "<div>"+localization.getLocaleString("ErrorDeletingDefaultRule") + "</div>";
					else
						rulesNames.push(rulesDic[item_i] || item_i);
				}
				if (rulesNames.length > 0)
					errTxt += "<div>" + localization.makeLocaleStringObj(this.id, (rulesNames.length==1?"ErrorDeletingRule":"ErrorDeletingRules"), rulesNames.join("\", \""), errMsg||"") + "</div>";
			}
			var msgRes = this._page.getApplication().showMessage(errTxt || errMsg, "LabelTitleRulesDeleteError", "BtnClose", 300, KL.Web.MessageDialog.MessageType.Error);
			
			localization.applyStingObjs(this.id, msgRes.elt);
		},
		gridDataBound: function(data){
			var elt = this.getElt();
			if( elt ){
				window.setTimeout(function(){
					var headerCell = elt.find(".gridHeader .IDCell").width("auto"),
						cell = elt.find(".gridRow:eq(0) .IDCell").width("auto"),
						w = Math.max(cell.outerWidth(), headerCell.outerWidth());
					cell.width(w); headerCell.width(w);
				}, 0);
			}
		},
		onGridInit: function () {
			this.pageNum = 0;
			this.resetData();
		},
		onShown: function () {
			this.isSetPageSize = false;
		},
		setValuePartial: function (val, a, b) {
			var curVal = this._data;
			if (!curVal || !val || !val.items || !curVal.items || this._currCount == 0) {
				this._currCount = 0;
				KL.Utils.Log.write("GroupsGrid.setValuePartial: no current value");
				curVal = val;
			} else if (val.items) {
				KL.Utils.Log.write("GroupsGrid.setValuePartial: There's a current value. " + this._currCount + " already rendered");
				curVal.items = curVal.items.concat(val.items);
				curVal.count = curVal.items.length;
				curVal.total = val.total;
				curVal.pageSize = val.pageSize;
				curVal.page = val.page;
			}
			if (curVal) {
				curVal.page = this.pageNum;
				curVal.pageSize = this.pageSize;
				this.setValue(curVal);
			}
		},
		
		getGroupIdfromName: function(e,ruleName) {
			var groupId = this._getGroupIdfromName(ruleName);
			$(this).trigger("onsetgroupid",[groupId]);
		},
		_getGroupIdfromName: function (name) {
			var groupId = -1;
			if (this._data && this._data.items) {
				var len = this._data.items.length;
				for (var i = 0; i < len; i++)
					if (this._data.items[i].name == name) {
						groupId = this._data.items[i].groupId;
						break;
					}
			}
			return groupId;
		},
		
		getNewGroupName: function(e,ruleName) {
			var groupId = -1;
			var newGroupName = ruleName;
			var k=0;
			while(this._getGroupIdfromName(newGroupName)>=0){
					k++;
					newGroupName = ruleName+k;
			}
			$(this).trigger("onsetnewgroupname",[newGroupName]);
		},
		
		resetData: function () {
			this.preResetData();
		},
		preResetData: function () {
			this._data = null;
			this._currCount = 0;
			this.resetSelection();
		},
		resetSelection: function () {
			this._removeSelection();
			this.selectedItems = {};
		},
		setValue: function (val) {
			if (this._setting)
				this._setting.applyData(null,val,true);
		},
		setPageNum: function (e, pageNum) {
			if (this._data) {
				var maxPage = Math.ceil(this._data.count / this.pageSize) - 1;
				if (pageNum === 0)
					this.pageNum = 0;
				else if (pageNum === 1)
					this.pageNum--;
				else if (pageNum === 2)
					this.pageNum++;
				else
					this.pageNum = maxPage;
				this.pageNum = this.pageNum < 0 ? 0 : (this.pageNum > maxPage ? maxPage : this.pageNum);
				this._data.page = this.pageNum;
				this._data.pageSize = this.pageSize;
				this._currCount = 0;
				this.setValue(this._data);
			}
		},
		onDataBind: function (data) {
			var elt = this.getElt();
			if (!data || (this._currCount >= this.pageSize)) {
				KL.Utils.Log.write("GroupsGrid.onDataBind: no need to render");
				return false;
			}
			if(!elt){
				KL.Utils.Log.write("GroupsGrid.onDataBind: Why the world is so cruel? I already not exist!", KL.Utils.Log.type.WARNING);
				return false;
			}
			data.pageSize= this.pageSize;
			var proceed = this.onBeforeDataBind(data),
				isAllChecked = false;
			if (proceed === false)
				return;
			if (data.items) {
				if (this._currCount == 0) {
					this._listContainer.empty();
					this._data = data;
					KL.Utils.Log.write("GroupsGrid.onDataBind: page #" + this.pageNum + " first render");
				}
				var from = (this.pageSize * this.pageNum) + this._currCount;
				var to = this.getGridLength(from);
				isAllChecked = true;
				for (var i = from; i < to; i++) {
					var proceed_i = this.itemDataBind(data.items[i], i);
					if (proceed_i !== false) {
						var row = $(this._template.bindData(data.items[i]))
							.appendTo(this._listContainer)
							.addClass((i % 2 ? "oddItem" : "evenItem"))
							.mouseover(function () { $(this).addClass("itemOver"); })
							.mouseout(function () { $(this).removeClass("itemOver"); })
							.data("itemData", data.items[i]);
						if (data.items[i].groupId != 1) {
							row.toggleClass("ruleDisabled", !data.items[i].scanSettings.active)
								.find(".toggle").click(KL.Utils.Delegate.create(this, this._toggleActive, row, data.items[i])).toggleClass("checked", data.items[i].scanSettings.active);
						} else {
							row.find(".toggle")
								.attr("rel","tooltipDefault")
								.toggleClass("checked", data.items[i].scanSettings.active);
							elt.find(".gridContent").parent().append("<span class=\"tooltip tooltipDefault str-local-LabelMessageSetActiveDefaultRule\"></span>")
							row.find(".checkboxCell input[type=checkbox]").remove();
							row.find(".setPriority").parent().html(data.items[i].priority);
						}
						this.itemDataBound(row, data.items[i]);
						if (this.initPageSize(row,i-from)) {
							$(this).trigger("onsetpagesize", [this._data]);
							break;
						}
						isAllChecked = isAllChecked && !!row.data("rowFlag");
					}
					var name_len = 34;
					if (data.items[i].belongingCriteria.sender.length == 0 || data.items[i].belongingCriteria.receiver.length == 0) {
						row.find(".nameCell .warningIcon").attr("rel","tooltip"+i);
						if (elt)
							elt.find(".gridContent").parent().append("<span class=\"tooltip tooltip"+i+" str-local-LabelGroupEmailsEmpty\"></span>");
						name_len = 30;	
					}
					
					if (data.items[i].name.length>name_len)
						row.find(".nameCell .groupNameWrap").attr("title", this._insertDelimiters(data.items[i].name, 8, '\u200B'));
				}
			}
			this.dataBound(this._data);
			if (elt) {
				elt.find(".gridHeader input[type=checkbox]").attr("checked", !!isAllChecked);
				KL.Utils.TooltipHelper.makeTooltips( elt.find(".warningIcon[rel]"), this, elt );
				KL.Utils.TooltipHelper.makeTooltips( elt.find(".toggle[rel]"), this, elt );
			}
		},
		_insertDelimiters: function(str, len, delimiter) {
			var result = "";
			for (var i=0, l=str.length; i < l; i++) {
				var chr = str.charAt(i);
				result = result + chr;
				if (i % len == 0 && i != 0)
					result = result + delimiter;
			}
			return result;
		},
		onRowEnter: function (row, e) {
			var rowData = row.data("itemData");
			var rowId = this.getKeyDataFromIdField(rowData); //rowData[this.idField];
			this.selectedItems = {};
			this.selectedItems[rowId] = rowData;
			if ($(e.currentTarget).is(".setPriority")) {
				this._toggleRowSelection(row, true);
				$(this).trigger("onrowenter_priority", [row]);
				return false;
			}
		},
		getActiveChangeData: function () {
			return this._dataActive;
		},
		getIndexToData: function (param, _value) {
			var _items = this._setting._val.items;
			for (var i = 0; i < this._setting._val.count; i++)
				if (_items[i][param] == _value) return i;
			return -1;
		},
		setPriorityButtons: function () {
			if (this.getSelectedCount() == 1) {
				if (this.getSeletedRowsId() == 1)
					$(this).trigger("setprioritybuttons", [2]);
				else {
					var _index = this.getIndexToData("groupId", this.getSeletedRowsId());
					if (_index == 0) $(this).trigger("setprioritybuttons", [1]);
					if (_index == this._setting._val.count - 2) $(this).trigger("setprioritybuttons", [0]);
				}
			}
		},
		upPriority: function () {
			this._groupId = this.getSeletedRowsId();
			var _groupId_before = -1;
			var _index = this.getIndexToData("groupId", this._groupId);
			if (_index > 0) {
				_groupId_before = this._setting._val.items[_index - 1].groupId;
				this._dataPriority = { "groupId": this._groupId, "groupId_before": _groupId_before };
				$(this).trigger("ongroupprioritychange");
			}
		},
		selectRowBeforeChangePriority: function () {
		},
		downPriority: function () {
			this._groupId = this.getSeletedRowsId();
			var _groupId_before = -1;
			var _index = this.getIndexToData("groupId", this._groupId);
			if (_index != this._setting._val.count - 1 && _index >= 0) {
				_groupId_before = this._setting._val.items[_index + 1].groupId;
				this._dataPriority = { "groupId": _groupId_before, "groupId_before": this._groupId };
				$(this).trigger("ongroupprioritychange");
			}
		},
		
		setPriorityChangeData: function (e, data) {
			var _index = this.getIndexToData("priority", data.priority);
			if (this.getIndexToData("groupId", data.id) < _index) 
				_index = this.getIndexToData("priority", +data.priority + 1);
			
			var _groupId_before = 1;
			if (_index >= 0)
				_groupId_before = this._setting._val.items[_index].groupId;
			if (data.id == _groupId_before) return;
			this._dataPriority = { "groupId": data.id, "groupId_before": _groupId_before };
			$(this).trigger("ongroupprioritychange");
		},
		getPriorityChangeData: function () {
			return this._dataPriority;
		},
		_toggleActive: function (row, data, e) {
			if (e) {
				e.preventDefault();
				e.stopPropagation();
			}
			data.scanSettings.active = !data.scanSettings.active;
			this._dataActive = { "groupId": data.groupId, "active": data.scanSettings.active };
			row.find(".toggle").toggleClass("checked", data.scanSettings.active);
			row.toggleClass("ruleDisabled", !data.scanSettings.active);
			$(this).trigger("ongroupactivechange", [data]);
		},
		_rowEdit: function (row, data, e) {},
		
		itemDataBind: function (itemData) {
			itemData.Priority_ = itemData.priority;
			itemData.Name_ = KL.Utils.StringHelper.htmlEncode(itemData.name); //+"("+itemData.groupId+")";
			var localization = KL.Utils.Localization.getInstance();
			var strAny = localization.getLocaleString( "LabelAddressSetAny" );
			var strNotSet = localization.getLocaleString( "LabelAddressNotSet" );
			itemData._Senders = strNotSet;
			itemData._Receivers = strNotSet;
			itemData._RuleIcon = "noIcon";
			if (itemData.belongingCriteria) {
				var AddrsTypes = KL.LMS.Enums.AddrsTypes;
				if (itemData.belongingCriteria.sender) {
					var f_any = false;
					var senders = {"IP":0, "Ext": 0, "Mail": 0};
					for (var i = 0; i < itemData.belongingCriteria.sender.length; i++) {
						var item = itemData.belongingCriteria.sender[i];
						switch (AddrsTypes[item.type]) {
							case AddrsTypes.ExternalAccount: senders.Ext++; break;
							case AddrsTypes.CIDR: senders.IP++; break;
							case AddrsTypes.EMailMask:
								senders.Mail++;
								if (item.value == "*") {
									itemData._Senders = strAny;
									f_any = true;
								}
								break;
						}
						if (f_any) break;
					}
					if (!f_any && itemData.belongingCriteria.sender.length > 0) {
						itemData._Senders = KL.Utils.StringHelper.formatTemplate( "{Ext} / {IP} / {Mail}", senders );
					} else {
						itemData._RuleIcon = !f_any ? "warningIcon" : itemData._RuleIcon;
					}
				}
				if (itemData.belongingCriteria.receiver) {
					var f_any1 = false;
					var receivers = {"Ext": 0, "Mail": 0};
					for (var i = 0; i < itemData.belongingCriteria.receiver.length; i++) {
						var item = itemData.belongingCriteria.receiver[i];
						switch (AddrsTypes[item.type]) {
							case AddrsTypes.ExternalAccount: receivers.Ext++; break;
							case AddrsTypes.EMailMask:
								receivers.Mail++;
								if (item.value == "*") {
									itemData._Receivers = strAny;
									f_any1 = true;
								}
								break;
						}
						if (f_any1) break;
					}
					if (!f_any1 && itemData.belongingCriteria.receiver.length > 0) {
						itemData._Receivers = KL.Utils.StringHelper.formatTemplate( "{Ext} / {Mail}", receivers );
					} else {
						itemData._RuleIcon = !f_any1 ? "warningIcon" : itemData._RuleIcon;
					}
				}
			}
			if (itemData.scanSettings.groupAction == "Skip")
				itemData.DefenseParametrs_ = "<span class=\"groupSkip\"></span>";
			else
				if (itemData.scanSettings.groupAction == "Reject")
					itemData.DefenseParametrs_ = "<span class=\"groupReject\"></span>";
				else {
					var ctx = this._page.getApplication().getContext(),
						isAVProtectionEnable =  ctx.getProtectionState("AV"),
						isASProtectionEnable =  ctx.getProtectionState("AS"),
						isCFProtectionEnable =  ctx.getProtectionState("CF"),
						isAPProtectionEnable =  ctx.getProtectionState("AP");
					itemData.DefenseParametrs_ = ([
						itemData.scanSettings["asScanSettings.engineSettings.enableScan"] && isASProtectionEnable ? '<span class="defParam paramAsOn">&nbsp;</span>' : '<span class="defParam paramAsOff">&nbsp;</span>',
						itemData.scanSettings["avScanSettings.engineSettings.enableScan"] && isAVProtectionEnable ? '<span class="defParam paramAvOn">&nbsp;</span>' : '<span class="defParam paramAvOff">&nbsp;</span>',
						itemData.scanSettings["cfScanSettings.engineSettings.enableScan"] && isCFProtectionEnable ? '<span class="defParam paramCfOn">&nbsp;</span>' : '<span class="defParam paramCfOff">&nbsp;</span>',
						itemData.scanSettings["apScanSettings.engineSettings.enableScan"] && isAPProtectionEnable ? '<span class="defParam paramApOn">&nbsp;</span>' : '<span class="defParam paramApOff">&nbsp;</span>'
					]).join("&nbsp;");
				}
			this._currCount++;
		},
		setGroupProtection: function (ev,data) {
			this._page.getApplication().getContext().setProtectionState(data);
		},
		
		invokePriorityChangeData: function () {
			if (this.getSelectedCount() > 0) {
				var data = { "data": this.selectedItems };
				
				$(this).trigger("onprioritychangeinvoke", [data]);
			}
		},
		onHidden: function () {
			this._currCount = 0;
			if (this._listContainer)
				this._listContainer.empty();
		},
		onBeforeItemSelected: function (elt, rowData) {
			var data = elt.data("itemData") || rowData;
			if (data && data.groupId == 1)
				return false;
		},
		deleteRows: function () {
			var Delegate = KL.Utils.Delegate;
			var localization = KL.Utils.Localization.getInstance();
			var selectedIds = this.getSeletedRowsId();
			var confirmMessage = localization.makeLocaleStringObj(this.id, "LabelDeleteGroupsConfirm", selectedIds.length);
			if (selectedIds.length == 1) {
				var index = this.getIndexToData("groupId", selectedIds);
				if (this._data.items[index]) {
					var _groupName = KL.Utils.StringHelper.cropString(KL.Utils.StringHelper.htmlEncode(this._data.items[index].name), 20);
					confirmMessage = localization.makeLocaleStringObj(this.id, "LabelDeleteGroupConfirm", _groupName);
				} else
					return;
			}
			var dialogResult = this._page.getApplication().openConfirm(
				confirmMessage,
				localization.getLocaleString("LabelTitleDeleteItems"),
				{ "ok": "BtnYes", "cancel": "BtnCancel" },
				260
			);
			$(dialogResult).bind("onok", Delegate.create(this, this._deleteSelected));
			localization.applyStingObjs(this.id, dialogResult.elt);
		},
		getDeletingGroupIds: function () {
			return KL.Utils.JSON.encode({ items: this.getSeletedRowsId() });
		},
		showLoading: function (arg) {
			KL.Utils.Log.write("GroupsGrid.showLoading: called for id=" + this.id + (arg != undefined ? (" with argument " + arg) : ""));
			this.hideError();
			if( !this._loader )
				this._createLoader();
			if( this._loader )
				this._loader.show();
		},
		hideLoading: function (arg) {
			if (arg == undefined)
				return;
			KL.Utils.Log.write("GroupsGrid.hideLoading: called for id=" + this.id  + (arg != undefined ? (" with argument " + arg) : ""));
			
			if (this._loader)
				this._loader.hide();
		}
	};
	KL.LMS.Groups.registerClass("GroupsGrid", GroupsGrid);
	GroupsGrid.extend(KL.Web.Controls.GridViewControl);
})();
;
(function () {
	var modes = {
		"add": 1,
		"edit": 2,
		"copy": 3
	}
	function GroupEditor (id, initValue) {
		GroupEditor._super.call( this, id, initValue );
	};
	GroupEditor.prototype = {
		_data: null,
		isNew: false,
		name_old: null,
		_isChangeData: false,
		_isChangeDataSave: false,
		isInitData: true,
		_resumeEvent: false,
		_skipCheck: false,
		_mode: modes.edit,
		setMode: function(mode){
			this._mode = modes[mode]||modes.edit;
		},
		onInitInteraction: function () {
			this._data = null;
			var elt = this.getElt();
			if (elt) {
				elt.find(".saveSettingsBtn").click(KL.Utils.Delegate.create(this, this._saveChanges));
				elt.find(".okSettingsBtn").click(KL.Utils.Delegate.create(this, this._savecloseChanges));
				elt.find(".closeSettingsBtn").click(KL.Utils.Delegate.create(this, this._closeEditor));
			}
		},
		notifyLicenseChange: function(){
			if(this.isVisible())
				this.setValue(this._data);
		},
		applyValue: function(evt, data, isLoadComplete){
			this.setValue( data );
		},
		setValue: function (val) {
			this.hideError();
			KL.Utils.Log.write("Control.setValue: setting value \"" + val + "\" to " + this.id);
			this._isChangeData = false;
			this._isChangeDataSave = false;
			this.isInitData = true;
			if (this._setting) {
				var localization = KL.Utils.Localization.getInstance();
				if (val.isNew) {
					val.name = localization.getLocaleValueString("LabelSettingNewGroupName");
					val.scanSettings.active = false;
					$(this).trigger("ongetnewgroupid",[val.name]);
				}
				this._setting.applyData(null,val, true);
			}
		},
		getGroupId: function () {
			return this._data.groupId;
		},
		onDataBind: function (data) {
			var isSaveBtnActive = false;
			this._data = data;
			var localization = KL.Utils.Localization.getInstance();
			var elt = this.getElt();
			
			this._skipCheck = false;
			this.isNew = false;
			
			if (data.isNew || this._mode !== modes.edit ) {
				data.isNew = true;
				this.isNew = true;
				isSaveBtnActive = true;
				if (this.isInitData && elt) {
					elt.find(".applyMsg").html(localization.getLocaleString("LabelWarningUnsavedGroupSettingsNew"));
					elt.find(".okSettingsBtn").html("<span class=\"left\"><span class=\"right\"><span class=\"center\"><span class=\"buttonText str-local-BtnCreate\">{BtnCreate}</span></span></span></span>");
				}
			} else
				elt.find(".applyMsg").html(localization.getLocaleString("LabelWarningUnsavedGroupSettingsChanges"));
			KL.Utils.Log.write("GroupEditor.onDataBind: this.isInitData="+this.isInitData);
			if (this.isInitData) {
				if( this._mode === modes.copy ){
					this._data.name += localization.getLocaleValueString("LabelRuleEditorCopyNameSuffix");
					this._data.name = KL.Utils.StringHelper.cropString(this._data.name, 128, true);
				}
				this.name_old = this._data.name;
				this.isInitData = false;
				this._isChangeData = false;
			}
			else  {
				isSaveBtnActive = true;
				this._isChangeData = true;
				if (!this._isNameValid()) isSaveBtnActive = false;
				if (!this._isDescriptionValid()) isSaveBtnActive = false;
			}
			KL.Utils.Log.write("GroupEditor.onDataBind: this.isInitData="+this.isInitData+" isSaveBtnActive="+isSaveBtnActive);
			
			if (elt) {
				elt.find(".saveSettingsBtn").attr("disabled",!isSaveBtnActive);
				elt.find(".okSettingsBtn").attr("disabled",!isSaveBtnActive);
				if (isSaveBtnActive) elt.find(".applyMsg").css("display","inline");
				else elt.find(".applyMsg").css("display","none");
				if (this.isNew) elt.find(".saveSettingsBtn").css("display","none");
			}
			
			if (KL.LMS.Enums.GroupActionTypes[this._data.scanSettings.groupAction] == KL.LMS.Enums.GroupActionTypes.Scan) {
				$(this).trigger("oneditorpanelshow");
			}
			else {
				$(this).trigger("oneditorpanelhide");
			}
		
		},
		setResumeEvent: function () {
			this._resumeEvent = true;
		},
		onBeforeHide: function () {
			if (!this._hidden && this._data && !this._skipCheck)
				return this.isChangeData();
		},
		isChangeData: function(){
			
			this._skipCheck = true;
			var ctx = this._page.getApplication().getContext(),
				user = ctx.getData(KL.Web.Context.DataTypes.UserName);
				
			if (this._isChangeData && !!user) {
				var Delegate = KL.Utils.Delegate;
				var localization = KL.Utils.Localization.getInstance();
				var dialogResult = this._page.getApplication().openConfirm(
					localization.getLocaleString("LabelDoNotSaveSettingsConfirm"),
					localization.getLocaleString("LabelTitleDoNotSaveSettings"),
					{ "ok": "BtnYes", "cancel": "BtnNo" }
				);
				this._skipCheck = false;
				$(dialogResult).bind("onok", Delegate.create(this, this._savecloseChanges));
				$(dialogResult).bind("oncancel", Delegate.create(this, this._close));
				return false;
			} else {
				KL.Utils.Log.write(this + ".isChangeData(): closing");
				if (this._isChangeDataSave)
					$(this).trigger("oneditorclosereset");
				else
					this._close();
			}
		},
		
		trySetInvisible: function(){
			if (!this._hidden && this._data)
				return this.isChangeData();
			else
				this._close();
		},
		_close: function(){
			this._skipCheck = true;
			this._isChangeData = false;
			$(this).trigger("oneditorclose");
			this._resumeCanceled();
		},
		
		
		resetEdited: function () {
			this._isChangeData = false;
			this._isChangeDataSave = true;
			var elt = this.getElt();
			if (elt) {
				elt.find(".saveSettingsBtn").attr("disabled",true);
				elt.find(".okSettingsBtn").attr("disabled",true);
			}			
		},
		getSettings: function () {
			var retObj = {
				data: KL.Utils.JSON.encode(this._data)
			};
			return retObj;
		},
		applyError: function (evt, err) {
			
			var errTxt = KL.Utils.Exception.getExceptionText(err.id) || err.message;
			this._page.getApplication().showMessage(errTxt, "ErrorTitleGreateGroup", "BtnClose", 300, KL.Web.MessageDialog.MessageType.Error);
				var elt = this.getElt();
				if (elt) {
					elt.find(".saveSettingsBtn").attr("disabled",true);
					
				}
		},
		
		_saveChanges: function () {
			var elt = this.getElt();
			if (elt) {
				elt.find(".saveSettingsBtn").attr("disabled",true);
				elt.find(".okSettingsBtn").attr("disabled",true);
			}				
			this._isChangeDataSave = true;
			this.hideError();
			if (!!this._data)
				if (this.isNew)
					$(this).trigger("onnewsettingssave");
				else {
					if (this._data.name!=this.name_old) this._data["name_old"] = this.name_old;
					else delete this._data.name_old;
					
					this._isChangeDataSave = true;
					if (elt) {
						elt.find(".applyMsg").css("display","none");
					}
					$(this).trigger("onsettingssave");
				}
			KL.Utils.Log.write("GroupEditor._saveChanges: this.isInitData="+this.isInitData);					
		},
		_savecloseChanges: function () {
			var elt = this.getElt();
			if (elt) {
				elt.find(".saveSettingsBtn").attr("disabled",true);
				elt.find(".okSettingsBtn").attr("disabled",true);
			}
			
			this._skipCheck = true;
			this.isInitData = true;
			this.hideError();
			if (!!this._data) {
				if (!this._isNameValid() || !this._isDescriptionValid()) {
					var localization = KL.Utils.Localization.getInstance();
					this._page.getApplication().showMessage(
						localization.getLocaleString("LabelCannotSaveSettingsMessage"),
						localization.getLocaleString("LabelTitleDoNotSaveSettings"),
						"BtnClose", 700, KL.Web.MessageDialog.MessageType.Message);
				} else if (this.isNew) {
					this._isChangeDataSave = true;
					$(this).trigger("onnewsettingssave");
					this._isChangeData = false;
				}
				else {
					if (this._data.name != this.name_old) this._data["name_old"] = this.name_old;
					else delete this._data.name_old;
					this._isChangeDataSave = true;
					$(this).trigger("onsettingssaveclose");
					this._isChangeData = false;
				}
			}
			this._resumeCanceled();
		},
		_resumeCanceled: function () {
			if (this._resumeEvent)
				this._page.getApplication().resumeLastCancelledEvent();
			this._resumeEvent = false;
		},
		_closeEditor: function () {
			this.name_old = null;
			this.isInitData = true;
			this.isChangeData();
		},
		_isNameValid: function() {
			return !(this._data.name=="" || this._data.name.length > 128 );
		},
		_isDescriptionValid: function() {
			return !(unescape(encodeURIComponent(this._data.description)).length>512);
		}
	};
	KL.LMS.Groups.registerClass("GroupEditor", GroupEditor);
	GroupEditor.extend(KL.Web.Controls.Accordion);
})();
;
(function () {
	var BaseGroupSettingsForm = function (id, setting) {
		BaseGroupSettingsForm._super.call( this, id, setting );
	};
	BaseGroupSettingsForm.prototype = {
		_data: null,
		_disabledMessage: "LabelWarningGroupProtectionDisabled",
		_warningTooltip: "tooltip_GroupProtectionDisabled",
		_dataElementsMap: null,
		onBaseFormDataBind: function () { },
		onFormInit: function () {
			var Delegate = KL.Utils.Delegate;
			this._form.find(".tooltip").hide();
			this._form.find("[name=isEnabled]").click(Delegate.create(this, this._toggleEngineEnabled));
			this._fillSelects();
			this._form.find("select").change(Delegate.create(this, this._changeHandler));
			this._form.find("input[type=checkbox]").click(Delegate.create(this, this._changeHandler));
			this._form.find("input[type!=checkbox],textarea").on("change paste", Delegate.create(this, function (e) { window.setTimeout(Delegate.create(this, this._changeHandler, e), 10); }));
			KL.Utils.TooltipHelper.makeTooltips( this._form.find(".helpIco[rel]"), this, this._form );
			KL.Utils.TooltipHelper.makeTooltips( this._form.find("[rel="+this._warningTooltip+"]"), this, this._form );
		},
		
		
		_fillSelects: function () { },
		onDataBind: function (data) {
			this._data = data;
			KL.Utils.ObjectHelper.mapValues(this, this._dataElementsMap, data);
			KL.Utils.Log.write("BaseGroupSettingsForm.onDataBind: data.scanSettings.groupAction=" + data.scanSettings.groupAction);
			
			this._toggleEngineEnabled();
			this.onBaseFormDataBind();
		},
		isViewActionTypechBox: function (val) {
			return (val == KL.LMS.Enums.ActionTypes.Skip);
		},
		setSelectActionTypeVal: function (data, elt, key) {
			var val = KL.LMS.Enums.ActionTypes[key];
			if (key && typeof (val) != "undefined") {
				elt.val(val);
				var chBox = elt.closest(".field").find(".checkbox");
				if (chBox.length > 0) {
					var disabled = this.isViewActionTypechBox(val);
					chBox.toggle(!disabled);
				}
			}
		},
		setActionTypeValue: function (elt, val) {
			var key = KL.LMS.Enums.ActionTypes.getKeyByValue(val);
			if (!key)
				return;
			return key;
		},
		setChboxVal: function (data, elt, val) {
			elt.attr("checked", val);
			if (elt.parent().is(".toggle"))
				elt.parent().toggleClass("checked", val);
		},
		getIsChecked: function (elt, val) {
			return elt.is(":checked");
		},
		getNegIsChecked: function (elt, val) {
			return !this.getIsChecked(elt, val);
		},
		setNegChboxVal: function (data, elt, val) {
			this.setChboxVal(data, elt, !val);
		},
		getFormElement: function (eltClassName) {
			var elt = this._form.find("[name=" + eltClassName + "]");
			if (elt.length == 0)
				elt = this._form.find("." + eltClassName);
			return elt;
		},
		setLinkText: function (data, elt, val) {
			var txt = KL.Utils.StringHelper.htmlEncode(val),
				textMaxLen = 20;
			elt.html(KL.Utils.StringHelper.cropString(txt, textMaxLen)||KL.Utils.Localization.getInstance().getLocaleString("LabelSettingsGroupsMarkNotSet"));
			if (txt.length>textMaxLen)
				elt.attr("title",txt)
		},
		_openTextEditor: function (fieldXPath, title, infoText, isRightAligned, e) {
			if (e) {
				e.preventDefault();
				var triggerElt = $(e.currentTarget);
				if (triggerElt.is("[disabled]"))
					return;
				triggerElt.attr("title", "");
				var dataObj = {
					"0": (KL.Utils.ObjectHelper.getObjValueByPath(this._data, fieldXPath)||"").replace(/^\[|\]$/gi, "")
				};
				$(this).trigger("ontextedit", [infoText, e.currentTarget, title, isRightAligned, dataObj]);
				$(dataObj)
					.on("onvaluechange", KL.Utils.Delegate.create(this, this._setTextValue, fieldXPath))
					.on("ontiphidden", KL.Utils.Delegate.create(this, function(telt, dobj){
						telt.attr("title", "[" +(dobj && dobj["val"] ? dobj.val[0]:dobj[0] ) + "]");
					}, triggerElt, dataObj));
			}
		},
		_setTextValue: function (fieldXPath, e, val) {
			var text = (val && val[0]) ? "[" + val[0] + "]" : "";
			KL.Utils.ObjectHelper.setObjValueByPath(this._data, fieldXPath, text);
			this.setValue(this._data);
		},
		_openFileSizeEditor: function (fieldXPath, title, infoText, limits, isRightAligned, e) {
			if (e) {
				e.preventDefault();
				if ($(e.currentTarget).is("[disabled]"))
					return;
				var num = KL.Utils.ObjectHelper.getObjValueByPath(this._data, fieldXPath);
				num = num > 0 ? num / 1024 : 0;
				var dataObj = { "0": num };
				$(this).trigger("ontextedit", [infoText, e.currentTarget, title, isRightAligned, dataObj,true]);
				$(dataObj).on("onvaluechange", KL.Utils.Delegate.create(this, this._setFilesizeValue, fieldXPath, limits));
			}
		},
		_setFilesizeValue: function (fieldXPath, limits, e, val) {
			var num = (val && val[0]) ? (val[0] + "").replace(/[\,]/g, ".") : null;
			if (num === null || isNaN(num) || isNaN(num * 1)) {
				throw "ErrorFileSizeValueIsNaN";
				return;
			}
			
			num = num * 1;
			if (num<0) {
				throw "ErrorFileSizeValueIsNegative";
				return;
			}
			if (limits) {
				if (limits.min && limits.min > num) {
					throw "ErrorFileSizeValueIsTooLow";
					return;
				} else if (limits.max && limits.max < num) {
					throw "ErrorFileSizeValueIsTooBig";
					return;
				}
			}
			KL.Utils.ObjectHelper.setObjValueByPath(this._data, fieldXPath, Math.ceil(num * 1024));
			this.setValue(this._data);
		},
		setMaxSizeLink: function (data, elt, val) {
			var str = KL.LMS.Helpers.CommonHelper.localSizeObj(val);
			elt.empty().append(str);
		},
		setEngineEnabled: function (enabled) {
			this._form.find("[name=isEnabled]").attr("disabled", enabled);
			this._form.find(".field label").toggleClass("disabled", enabled);
			this._form.find(".fieldsGroup").toggleClass("disabled", enabled);
			this._form.find(".fieldsGroup input, .fieldsGroup select, .fieldsGroup a, .fieldsGroup textarea, .fieldsGroup button").attr("disabled", enabled);
			this._form.find(".disabled").find("input, select, a, textarea, button ,label").attr("disabled", true);
			KL.Utils.Log.write("BaseGroupSettingsForm.setEngineEnabled(" + enabled + ")");
		},
		_protectionEnabled: function () {
			return true;
		},
		
		_toggleEngineEnabled: function () {
			var protectionEnabled = this._protectionEnabled();
			var enabled = this._form.find("[name=isEnabled]").is(":checked") && protectionEnabled;
			this._form.find(".fieldsGroup").toggleClass("disabled", !enabled);
			this._form.find(".fieldsGroup input, .fieldsGroup select, .fieldsGroup a, .fieldsGroup textarea, .fieldsGroup button").attr("disabled", !enabled);
			this._form.find(".disabled").find("input, select, a, textarea, button").attr("disabled", true);
			this._form.find( ".engineDisabledWarningIcon" ).toggle( !protectionEnabled );
			this._form.find(".toggle").toggle(protectionEnabled);
			this._form.find("." + this._warningTooltip).html( KL.Utils.Localization.getInstance().getLocaleString(this._disabledMessage));
		},
		_changeHandler: function (e) {
			if (!this._protectionEnabled()) return;
			if (e) {
				var elt = $(e.target);
				var oldVal = elt.data("default-value");
				var isChanged = false;
				for (var i = 0, l = this._dataElementsMap.length; i < l; i++) {
					var map = this._dataElementsMap[i];
					if (map.set !== null && elt.attr("name") == map.elt) {
						var val = elt.val();
						if (typeof (map.set) != "undefined" && typeof (this[map.set]) == "function")
							val = this[map.set](elt, val);
						if (typeof (val) != "undefined" && oldVal != val) {
							KL.Utils.ObjectHelper.setObjValueByPath(this._data, map.datasource, val);
							isChanged = true;
						}
						break;
					}
				}
				if (isChanged) {
					this.setValue(this._data);
					$(this).trigger("ondatachange");
				}
			}
		},
		setValue: function (val) {
			this.hideError();
			if (this._setting) {
				this._setting.applyData(null,val, true);
			}
		}
	};
	KL.LMS.Groups.registerClass("BaseGroupSettingsForm", BaseGroupSettingsForm);
	BaseGroupSettingsForm.extend(KL.Web.Controls.FormControl);
})();
;
(function () {
	var GroupGeneralSettingsForm = function (id, setting) {
		GroupGeneralSettingsForm._super.call(this, id, setting);
	};
	GroupGeneralSettingsForm.prototype = {
		_data: null,
		newGroupName: "",
		externalAccount: null,
		externalAccount_Display: null,
		isLdapConnect: false,
		namePos: -1,
		descrPos: -1,
		isLocalized: false,
		_listsHistory: {},
		_currAddrEditor: null,
		_lockListEvent: false,
		onFormInit: function () {
			var Delegate = KL.Utils.Delegate;
			var localization = KL.Utils.Localization.getInstance();
			var sendersList = this._form.find(".sendersList");
			var receiversList = this._form.find(".receiversList");
			this._form.find("input[type=text]").on("keyup paste blur",Delegate.create(this, this._textChangeHandler));
			this._form.find(".isActive").click(Delegate.create(this, this._toggleActive));
			this._initAddrList(
				sendersList,
				"belongingCriteria.sender",
				localization.getLocaleValueString("LabelDialogTitleEditGroupSenders"),
				"LabelDialogTitleEditGroupConfirmSendersClear",
				"LabelDialogEditGroupConfirmSendersClear",
				"_Senders"
			);
			this._initAddrList(
				receiversList,
				"belongingCriteria.receiver",
				localization.getLocaleValueString("LabelDialogTitleEditGroupReceivers"),
				"LabelDialogTitleEditGroupConfirmReceiversClear",
				"LabelDialogEditGroupConfirmReceiversClear",
				"_Receivers"
			);
			this._form.find("[name=groupAction]").click(Delegate.create(this, this._checkGroupAction));
			KL.Utils.TooltipHelper.makeTooltips( this._form.find(".helpIco[rel]"), this, this._form );
			KL.Utils.TooltipHelper.makeTooltips( this._form.find(".warningIconSettings[rel]"), this, this._form );
			var elt = this.getElt();
			this.isLocalized = false;
			this._form.find(".groupName")
			if( elt )
				elt.css("visibility", "hidden");
		},
		setNewGroupName: function(e,newName) {
			this.newGroupName = newName;
			
		},
		onLocalizationComplete: function(){
			var elt = this.getElt();
			if( elt ){
				window.setTimeout( KL.Utils.Delegate.create(this, function(){
					elt.css("visibility", "visible");
				}), 100 );
			}
		},
		_checkGroupAction: function () {
			if (this._data.scanSettings) {
				this._data.scanSettings.groupAction = KL.LMS.Enums.GroupActionTypes.getKeyByValue(this._form.find("[name=groupAction]:checked").val());
				this.setValue(this._data);
			}
		},
		_toggleActive: function () {
			var $this = this._form.find(".isActive");
			var isActive = $this.is(":checked");
			$this.parent().toggleClass("checked", isActive);
			if (this._data.scanSettings) {
				this._data.scanSettings.active = isActive;
				this.setValue(this._data);
			}
		},
		onDataBind: function (data) {
			if (!data) return;
			var elt = this.getElt();
			if( elt && !this.isLocalized )
				elt.css("visibility", "hidden");
			this._data = data;
			if (!this.newGroupName=="") {
				this._data.name = this.newGroupName;
				this.newGroupName="";
			}
			this._toggleEmptyLdapSearch(false);
			this._onDataBind();
			this.isLocalized = true;
			this._textChangeHandler();
		},
		_onDataBindBelongingCriteria: function () {
			var data = this._data;
			if (!!data.belongingCriteria) {
					var isActive = data.scanSettings ? data.scanSettings.active : false;
					this._form.find(".isActive").attr("checked", isActive).parent().toggleClass("checked", isActive);
					if (data.belongingCriteria.sender)
						this._bindMailActors(data.belongingCriteria.sender, "belongingCriteria.sender", this._form.find(".sendersList"));
					if (data.belongingCriteria.receiver)
						this._bindMailActors(data.belongingCriteria.receiver, "belongingCriteria.receiver", this._form.find(".receiversList"));
				}
		},
		_onDataBind: function () {
			var localization = KL.Utils.Localization.getInstance();
			var data = this._data;
			if (data.name) {
				this._form.find(".groupName").val(data.name);
			}
			if (data.description)
				this._form.find(".groupDescr").val(data.description);
			this._form.find(".groupPriority").val(data.priority || 0);
			var ga = KL.LMS.Enums.GroupActionTypes[data.scanSettings.groupAction];
			this._form.find("[name=groupAction]").val(["" + ga]);
			
			this._form.find(".groupPriority").attr("disabled", true);
			this._form.find(".btnMaxPriority").attr("disabled", true);
			this._form.find(".btnMinPriority").attr("disabled", true);
			this._form.find(".emailsActors").empty();
			if (data.groupId == 1) {
				this._form.find(".groupName").attr("disabled", true);
				this._form.find(".sendersList").hide();
				this._form.find(".receiversList").hide();
				this._form.find(".labelSenders").html(localization.getLocaleString("LabelSettingSenders_Default"));
				this._form.find(".labelReceivers").html(localization.getLocaleString("LabelSettingReceivers_Default"));
			}
			else {
				this._form.find(".labelSenders").html(localization.getLocaleString("LabelSettingSenders"));
				this._form.find(".labelReceivers").html(localization.getLocaleString("LabelSettingReceivers"));
			}
			if (this.namePos>=0)
				this._setCursorPosition(this._form.find(".groupName"),this.namePos);
			this.namePos = -1;
			
			if (this.descrPos>=0)
				this._setCursorPosition(this._form.find(".groupDescr"),this.descrPos);
			this.descrPos = -1;	
			
			this.prepareLdapData(data.belongingCriteria);
		},
	
		setLdapNotConnect: function (){
			this.isLdapConnect = false;
		},
		setLdapConnect: function (){
			this.isLdapConnect = true;
		},
		prepareLdapData: function (data) {
			this.externalAccount = [];
			this._isLdapQuery = false;
			
			for (var i = 0, l = data.receiver.length; i < l; i++) 
				if (KL.LMS.Enums.AddrsTypes[data.receiver[i].type] == KL.LMS.Enums.AddrsTypes.ExternalAccount) {
					this.externalAccount.push(new String(data.receiver[i].value));
					if (!data.receiver[i].attributes) this._isLdapQuery = true;
				}
			for (var i = 0, l = data.sender.length; i < l; i++) 
				if (KL.LMS.Enums.AddrsTypes[data.sender[i].type] == KL.LMS.Enums.AddrsTypes.ExternalAccount) {
					this.externalAccount.push(new String(data.sender[i].value));
					if (!data.sender[i].attributes) this._isLdapQuery = true;
			}
			if (this.externalAccount.length > 0 && this.isLdapConnect && this._isLdapQuery) {
					this._toggleEmptyLdapSearch(true);
					$(this).trigger("ongetExternalAccountInfo", [this.externalAccount]);
				}
			else
				this._onDataBindBelongingCriteria();
		},
		setLdapData: function () {
			var receiver = this._data.belongingCriteria.receiver;
			var sender = this._data.belongingCriteria.sender;
			for (var i = 0, l = receiver.length; i < l; i++) {
				if (this.isExternalAccount(receiver[i].type)) {
					var display_info = this.getLdapInfo(receiver[i].value);
					this._data.belongingCriteria.receiver[i]["attributes"] = receiver[i].value;
					if (display_info != null)
						if (display_info["attributes"] != null) {
							if (display_info["attributes"].length==0)
								this._data.belongingCriteria.receiver[i]["attributes"] = receiver[i].value;
							else
								this._data.belongingCriteria.receiver[i]["attributes"] = display_info["attributes"];
							this._data.belongingCriteria.receiver[i]["objectType"] = display_info["objectType"];
						}
				}
			}
			for (var i = 0, l = sender.length; i < l; i++) {
				if (this.isExternalAccount(sender[i].type)) {
					var display_info = this.getLdapInfo(sender[i].value);
					this._data.belongingCriteria.sender[i]["attributes"] = sender[i].value;
					if (display_info != null)
						if (display_info["attributes"] != null) {
							if (display_info["attributes"].length==0)
								this._data.belongingCriteria.sender[i]["attributes"] = sender[i].value;
							else
								this._data.belongingCriteria.sender[i]["attributes"] = display_info["attributes"];
							this._data.belongingCriteria.sender[i]["objectType"] = display_info["objectType"];
						}
				}
			}
			this._toggleEmptyLdapSearch(false);
		},
		isExternalAccount: function (type) {
			if (type == KL.LMS.Enums.AddrsTypes.getKeyByValue(KL.LMS.Enums.AddrsTypes.ExternalAccount))
				return true;
			else
				return false;
		},
		_getLdapString: function (data) {
			var result = "";
			if (data instanceof Array)
				for (var i = 0, l = data.length; i < l; i++) {
					result = result + data[i]["attribute"].toUpperCase()+":"+data[i]["values"] + ";   ";
				}
			else result = data;	
			return result;
		},
		getLdapInfo: function (entryId) {
			for (var i = 0, l = this.externalAccount_Display.items.length; i < l; i++) {
				if (this.externalAccount_Display.items[i].entryid == entryId)
					return this.externalAccount_Display.items[i];
			}
			return entryId;
		},
		getExternalAccount: function () {
			items = { "items": this.externalAccount };
			var retObj = {
				data: KL.Utils.JSON.encode(items)
			};
			return retObj;
		},
		setExternalAccount: function (e, data) {
			if (data["items"] != null) {
				this.externalAccount_Display = data;
				this.setLdapData();
				this._onDataBindBelongingCriteria();
			}
			else return;
		},
		_getCursorPosition: function (elt){
			if (!elt.is(":focus")) return -1;
			
			var pos = 0;
			var el = elt.get(0);
			if (document.selection) {
				el.focus();
				var Sel = document.selection.createRange();
				var SelLength = document.selection.createRange().text.length;
				Sel.moveStart('character', -el.value.length); 
				pos = Sel.text.length - SelLength; 
			} 
			else 
				if (el.selectionStart || el.selectionStart == '0')
					pos = el.selectionStart; 
			return pos; 
		},
		_setCursorPosition: function (elt,pos){
			var el = elt.get(0);
			if (el.setSelectionRange) { 
				el.setSelectionRange(pos, pos);
			} 
			else 
				if (el.createTextRange) { 
					var range = el.createTextRange();
					range.collapse(true);
					range.moveEnd('character', pos);
					range.moveStart('character', pos);
					range.select();
				} 
		},
		
		_textChangeHandler: function () {
			window.setTimeout( KL.Utils.Delegate.create( this, function(){
				var elt = this.getElt();
				var name = KL.Utils.StringHelper.rtrim(this._form.find(".groupName").val())||"";
				var descr = this._form.find(".groupDescr").val();
				
				this._form.find(".groupName, .groupDescr").removeClass("error");
				this._form.find(".warningIconSettings").hide();
				if (unescape(encodeURIComponent(descr)).length>512) {
					this._form.find(".groupDescr").addClass("error");
					this._form.find("[rel=tooltip_DescrIsLong]").show();
				}
				
				if (name=="") {
					this._form.find(".groupName").addClass("error");
					this._form.find("[rel=tooltip_ErrorNameEmpty]").show();
				}else if(name.length > 128){
					this._form.find(".groupName").addClass("error");
					this._form.find("[rel=tooltip_ErrorGroupNameTooLong]").show();
				}
				if (name != this._data.name || descr != this._data.description ) {
					this.namePos = this._getCursorPosition(this._form.find(".groupName"));
					this.descrPos = this._getCursorPosition(this._form.find(".groupDescr"));
					this._data.name = name;
					this._data.description = descr;
					this.setValue(this._data);
				}}), 300 );
		},
		_getEditMode: function (container) {
			return container.find(".typeSwitch").dropdown("getValue") * 1;
		},
		_initAddrList: function (elt, fieldXpath, dlgTitle, confirmTitle, confirmText, prefix) {
			var Delegate = KL.Utils.Delegate;
			var isImport = true;
			
			elt.listeditor({
				"editorFiled": ".editBox",
				"editorButton": ".addAddrBtn, .saveAddrBtn",
				"item": ".emailsActors li",
				"selectedClass": "itemActive",
				"checkDuplicate":true,
				"validateOnSave": Delegate.create(this, this._validateOnSave, elt),
				"itemRender": Delegate.create(this, this._editorItemRender, elt, fieldXpath)
			})
				.bind("onvaluechange", Delegate.create(this, this._listEdited, elt, fieldXpath))
				.bind("onitemselect", Delegate.create(this, this._listItemSelected, elt))
				.bind("onotheraction", Delegate.create(this, this._openLdapEditor, fieldXpath, dlgTitle, elt, prefix))
				.data("fieldXpath", fieldXpath);
			elt.find(".undoBtn").click(Delegate.create(this, this._undoListChange, elt, fieldXpath));
			elt.find(".clearBtn").click(Delegate.create(this, this._importList, elt, confirmTitle, confirmText, fieldXpath));
			elt.find(".importBtn").click(Delegate.create(this, this._openImportEditor, fieldXpath, "Import !!!", elt, prefix,isImport ));
			elt.find(".exportBtn").click(Delegate.create(this, this._openImportEditor, fieldXpath, "Export !!!", elt, prefix,!isImport ));
			
			elt.find(".typeSwitch").dropdown()
				.bind("onitemselect", Delegate.create(this, this._changeAddrType, null, elt));
			elt.find(".findAddrBtn").click(Delegate.create(this, this._openLdapEditor, fieldXpath, dlgTitle, elt, prefix));
			this._toggleEmptyList(this._form, false);
			this._toggleAddrBtnsEnabled(elt, false);
		},
		_bindMailActors: function (data, fieldXpath, container) {
			this._toggleEmptyList(container, data.length <= 0);
			this._listsHistory[fieldXpath] = this._listsHistory[fieldXpath]||data;
			container.listeditor("setValue", data);
		},
		_openLdapEditor: function (fieldXpath, title, editor, prefix) {
			var objData = {
				prefix: prefix,
				term: editor.find(".editBox").val(),
				data: KL.Utils.ObjectHelper.getObjValueByPath(this._data, fieldXpath),
				title: KL.Utils.StringHelper.format(title, KL.Utils.StringHelper.htmlEncode(this._data.name) || "")
			};
			$(objData).bind("ondatachange", KL.Utils.Delegate.create(this, this._setListData, fieldXpath));
			$(this).trigger("onlistchange", [objData]);
		},
		_openImportEditor: function (fieldXpath, title, editor, prefix,isImport) {
			var objData = {
				prefix: prefix,
				opener: editor,
				data: KL.Utils.ObjectHelper.getObjValueByPath(this._data, fieldXpath),
				isViewTypeOption:true,
				isImport :isImport,
				title: isImport ? "LabelTitlePasteAddressesDialog" :"LabelTitlePasteAddressesDialogExport"
			};
			
			this._currAddrEditor = editor;
			$(this).trigger("onimportlist", [objData]);
			return false;
		},
		_setListData: function (fieldXpath, e, data) {
			KL.Utils.ObjectHelper.setObjValueByPath(this._data, fieldXpath, data || []);
			this.setValue(this._data);
		},
		_changeAddrType: function (type, container) {
			var AddrsTypes = KL.LMS.Enums.AddrsTypes;
			type = type != null && typeof (type) != "undefined" ? type : this._getEditMode(container);
			if (!container.data("cancel-type-reset")) {
				container.listeditor("removeSelection");
				if (container.data("is-editmode"))
					container.find(".editBox").val("");
				container.data("is-editmode", false);
			}
			container.data("cancel-type-reset", false);
			container.find(".editBox").attr("readOnly",false);
			container.find(".editBox").val("");
			this._toggleAddrBtnsEnabled(container);
		},
		_editorItemRender: function (container, fieldXpath, item, data) {
			if (typeof (data) == "string" || data instanceof String) {
				data = {
					"type": KL.LMS.Enums.AddrsTypes.getKeyByValue(this._getEditMode(container)),
					"value": data
				};
			}
			var txt = data["value"];
			if (this.isExternalAccount(data.type))
				if (this.isLdapConnect)
					txt = this._getLdapString(data["attributes"]);
				else
					txt = data.value;
					
			item.find(".itemValue").text(txt);
			item.find(".typeIcon").addClass("icon" + data.type);
			item.find(".itemDelBtn").click(KL.Utils.Delegate.create(this, this._editorDeleteItem, container, item));
			item.data("listeditor-item-data", data);
			item.hover(
				function () { $(this).addClass("itemOver") },
				function () { $(this).removeClass("itemOver") }
			);
			return data;
		},
		_undoListChange: function(elt, fieldXpath){
			var oldData = this._listsHistory[fieldXpath];
			this._listEdited( elt, fieldXpath, null, oldData );
			return false;
		},
		_listEdited: function (container, fieldXpath, e, data) {
			if(this._lockListEvent)
				return;
			this._listsHistory[fieldXpath] = KL.Utils.ObjectHelper.getObjValueByPath(this._data, fieldXpath);
			KL.Utils.ObjectHelper.setObjValueByPath(this._data, fieldXpath, data || []);
			this.setValue(this._data);
			container.data("is-editmode", false);
			container.find(".editBox").val("")
			this._toggleAddrBtnsEnabled(container);
			this._currAddrEditor = null;
		},
		_listItemSelected: function (container, e, isSelected, itemData) {
			var type = KL.LMS.Enums.AddrsTypes[itemData.type];
			container.data("is-editmode", isSelected);
			container.data("cancel-type-reset", isSelected);
			container.find(".typeSwitch").dropdown("setValue", type);
			container.find(".editBox").val((isSelected&&type != KL.LMS.Enums.AddrsTypes.ExternalAccount) ? itemData.value : "");
		},
		_confirmClearList: function (container, confirmTitle, confirmText, fieldXpath) {
			var dialogResult = this._page.getApplication().openConfirm(confirmText, confirmTitle, {"ok": "BtnYes", "cancel": "BtnNo"}, 300);
			$(dialogResult).bind("onok", KL.Utils.Delegate.create(this, this._clearList, container, fieldXpath));
		},
		_importList: function (container, confirmTitle, confirmText, fieldXpath) {
			var dialogResult = this._page.getApplication().openConfirm(confirmText, confirmTitle, {"ok": "BtnYes", "cancel": "BtnNo"}, 300);
			$(dialogResult).bind("onok", KL.Utils.Delegate.create(this, this._clearList, container, fieldXpath));
		},
		_clearList: function (container, fieldXpath) {
			container.listeditor("clear");
		},
		_toggleEmptyList: function (container, isEmpty) {
			container.find(".emailsActorsEmpty").toggle(isEmpty);
			container.find(".emailsActors").toggle(!isEmpty);
		},
		_toggleEmptyLdapSearch: function (isLoading) {
			if (this._form) {
				this._form.find(".ldaploader").toggle(isLoading);
			}
		},
		_editorDeleteItem: function (container, item, e) {
			if (e) {
				e.preventDefault();
				e.stopPropagation();
			}
			if(!item.data("listeditor-is-selected"))
				item.trigger("click");
			container.listeditor("removeItem");
		},
		_toggleAddrBtnsEnabled: function (container) {
			container.find(".textbox").removeClass("error");
			container.find(".addAddrBtn, .saveAddrBtn, .findAddrBtn").hide();
			var type = this._getEditMode(container);
			if (type == KL.LMS.Enums.AddrsTypes.ExternalAccount) {
				container.listeditor("setSaveOnClick",false);
				container.find(".findAddrBtn").show();
				container.find(".findAddrBtn").attr("disabled",!this.isLdapConnect);
				if (!this.isLdapConnect) {
					container.find(".textbox").addClass("error");
					container.find(".editBox").val(KL.Utils.Localization.getInstance().getLocaleValueString("LabelSettingsLdapStatus_NotAvailable"));
					container.find(".editBox").attr("readOnly",true);
				}	
				else {
					container.find(".editBox").attr("readOnly",false);
				
				}	
			} else {
				container.listeditor("setSaveOnClick",true);
				container.find(container.data("is-editmode") ? ".saveAddrBtn" : ".addAddrBtn").show()
					.attr("disabled", !container.find(".editBox").val());
			}
			container.find(".helpIco").hide();
			
			switch (type) {
				case KL.LMS.Enums.AddrsTypes.CIDR: container.find(".groupEditIpHelpIco").show(); break;
				case KL.LMS.Enums.AddrsTypes.EMailMask: container.find(".groupEditMailHelpIco").show(); break;
				case KL.LMS.Enums.AddrsTypes.ExternalAccount: container.find(".groupEditLdapHelpIco").show(); break;
			}
		},
		_validateOnSave: function (container, val) {
			container.find(".textbox").removeClass("error");
			if (this._getEditMode(container) == KL.LMS.Enums.AddrsTypes.CIDR) {
				this._currAddrEditor = container;
				$(this).trigger("onipvalidate", [val]);
				return false;
			}
			if (this._getEditMode(container) == KL.LMS.Enums.AddrsTypes.EMailMask && $.trim( val ) != "*") {
				this._currAddrEditor = container;
				$(this).trigger("onwildcardvalidate", [val]);
				return false;
			}
			return true;
		},
		getValidatingValue: function () {
			if (this._currAddrEditor)
				return KL.Utils.JSON.encode({"items": [this._currAddrEditor.find(".editBox").val()]});
		},
		setWildcardQueryIsValid: function (e, result, isComplete) {
			if( isComplete )
				this._appendAddressItem( KL.LMS.Enums.AddrsTypes.EMailMask, result );
		},
		setIpIsValid: function (e, result, isComplete) {
			if( isComplete )
				this._appendAddressItem( KL.LMS.Enums.AddrsTypes.CIDR, result );
		},
		_appendAddressItem: function(addrType, result){
			if (this._currAddrEditor) {
				var results = null;
				if( result && result.items && result.items.length > 0 ){
					results = {};
					for( var i=0, l=result.items.length; i<l; i++ )
						results[result.items[i].element] = !!result.items[i].valid;
				}
				var editor = this._currAddrEditor;
				var textBox = editor.find(".editBox");
				var newRecord = {
					"type": KL.LMS.Enums.AddrsTypes.getKeyByValue(addrType),
					"value": $.trim(textBox.val())
				};
			
				if 	(editor.listeditor("isDuplicate",newRecord,["type","value"])) {
					this._page.getApplication().showMessage("ErrorDuplicateRecord", "LabelDialogTitleError", "BtnClose", 300, KL.Web.MessageDialog.MessageType.Error);
					this._currAddrEditor.find(".textbox").addClass("error");
				} else if (results[ newRecord.value ]) {
					var isEdit = editor.data("is-editmode");
					editor.listeditor((isEdit?"saveItem":"addItem"), newRecord);
					textBox.attr("readOnly",false);
					textBox.val("");
					this._toggleAddrBtnsEnabled(editor);
				} else
					this._currAddrEditor.find(".textbox").addClass("error");
			}
		},
		setImportAddresses: function(e, items, editor){
			this._lockListEvent = true;
			if ((editor || this._currAddrEditor) && items) {
				editor = this._currAddrEditor || editor;
				for( var i=0, l=items.length; i<l; i++ ){
					var newRecord = items[i];
					if (!$(editor).listeditor("isDuplicate",newRecord,["type","value"])) {
						if (i == l - 1)
							this._lockListEvent = false;
						$(editor).listeditor("addItem", newRecord);
					}
				}
			}
		},
		setValue: function (val) {
			this.hideError();
			if (this._setting) {
				this._setting.applyData(null,val,true);
			}
		}
	};
	KL.LMS.Groups.registerClass("GroupGeneralSettingsForm", GroupGeneralSettingsForm);
	GroupGeneralSettingsForm.extend( KL.Web.Controls.FormControl );
})();
;
(function () {
	var GroupAvSettingsForm = function (id, setting) {
		GroupAvSettingsForm._super.call( this, id, setting );
	};
	GroupAvSettingsForm.prototype = {
		_data: null,
		_dataElementsMap: [
			{ "elt": "corruptedObjAction", "datasource": "scanSettings.avScanSettings.corruptedAction", "get": "setSelectActionTypeVal", "set": "setActionTypeValue" },
			{ "elt": "corruptedMarkLink", "datasource": "scanSettings.avScanSettings.corruptedMark", "get": "setLinkText", "set": null },
			{ "elt": "disinfectedMarkLink", "datasource": "scanSettings.avScanSettings.disinfectedMark", "get": "setLinkText", "set": null },
			{ "elt": "encriptedObjAction", "datasource": "scanSettings.avScanSettings.encryptedAction", "get": "setSelectActionTypeVal", "set": "setActionTypeValue" },
			{ "elt": "encryptedMarkLink", "datasource": "scanSettings.avScanSettings.encryptedMark", "get": "setLinkText", "set": null },
			{ "elt": "malwareAction", "datasource": "scanSettings.avScanSettings.infectedFirstAction", "get": "setSelectActionTypeVal", "set": "setActionTypeValue" },
			{ "elt": "infectedMarkLink", "datasource": "scanSettings.avScanSettings.infectedMark", "get": "setLinkText", "set": null },
			{ "elt": "uncuredMalwareAction", "datasource": "scanSettings.avScanSettings.infectedSecondAction", "get": "_setSelectActionTypeVal", "set": "setActionTypeValue" },
			{ "elt": "isEnabled", "datasource": "scanSettings.avScanSettings.engineSettings.enableScan", "get": "setChboxVal", "set": "getIsChecked" },
			{"elt": "excludedNamesLink", "datasource": "scanSettings.avScanSettings.engineSettings.excludedNames", "get": "setExcludedNamesLink", "set": null },
			{ "elt": "attachmentMaxSizeLink", "datasource": "scanSettings.avScanSettings.engineSettings.maxSizeLimit", "get": "setMaxSizeLink", "set": null },
			{ "elt": "escArchivesScan", "datasource": "scanSettings.avScanSettings.engineSettings.scanArchived", "get": "setNegChboxVal", "set": "getNegIsChecked" },
			{ "elt": "excludedTypesLink", "datasource": "scanSettings.avScanSettings.engineSettings.excludedFormats", "get": "setExcludedTypesLink", "set": null },
			{ "elt": "backupCorrupted", "datasource": "scanSettings.avScanSettings.backupCorrupted", "get": "setChboxVal", "set": "getIsChecked" },
			{ "elt": "backupEncrypted", "datasource": "scanSettings.avScanSettings.backupEncrypted", "get": "setChboxVal", "set": "getIsChecked" },
			{ "elt": "backupInfected", "datasource": "scanSettings.avScanSettings.backupInfected", "get": "setChboxVal", "set": "getIsChecked" },
			{ "elt": "backupIntrusion", "datasource": "scanSettings.avScanSettings.backupIntrusionThreat", "get": "setChboxVal", "set": "getIsChecked" },
			{ "elt": "backupCorruptedHelpIco", "datasource": "scanSettings.avScanSettings.backupCorrupted", "get": "setHelpVisible", "set": null},
			{ "elt": "backupEncryptedHelpIco", "datasource": "scanSettings.avScanSettings.backupEncrypted", "get": "setHelpVisible", "set": null}
		],
		_warningTooltip: "tooltip_GroupAvProtectionDisabled",
		isViewActionTypechBox: function(val) {
			return (val == KL.LMS.Enums.ActionTypes.Skip || val == KL.LMS.Enums.ActionTypes.Reject);
		},
		_fillSelects: function () {
			var Delegate = KL.Utils.Delegate;
			var CommonHelper = KL.LMS.Helpers.CommonHelper;
			CommonHelper.fillSelectWidthEnum(this._form.find("[name=malwareAction]"), {
				"Cure": KL.LMS.Enums.ActionTypes.Cure,
				"DeleteAttachment": KL.LMS.Enums.ActionTypes.DeleteAttachment,
				"DeleteMessage": KL.LMS.Enums.ActionTypes.DeleteMessage,
				"Reject": KL.LMS.Enums.ActionTypes.Reject,
				"Skip": KL.LMS.Enums.ActionTypes.Skip
			}, "SettingAction_");
			CommonHelper.fillSelectWidthEnum(this._form.find("[name=intrusionThreatAction]"), {
				"DeleteMessage": KL.LMS.Enums.ActionTypes.DeleteMessage,
				"Reject": KL.LMS.Enums.ActionTypes.Reject,
				"Skip": KL.LMS.Enums.ActionTypes.Skip
			}, "SettingAction_");
			CommonHelper.fillSelectWidthEnum(this._form.find("[name=uncuredMalwareAction]"), {
				"DeleteAttachment": KL.LMS.Enums.ActionTypes.DeleteAttachment,
				"DeleteMessage": KL.LMS.Enums.ActionTypes.DeleteMessage,
				"Reject": KL.LMS.Enums.ActionTypes.Reject//,
			}, "SettingAction_");
			CommonHelper.fillSelectWidthEnum(this._form.find("[name=corruptedObjAction]"), {
				"DeleteAttachment": KL.LMS.Enums.ActionTypes.DeleteAttachment,
				"DeleteMessage": KL.LMS.Enums.ActionTypes.DeleteMessage,
				"Reject": KL.LMS.Enums.ActionTypes.Reject,
				"Skip": KL.LMS.Enums.ActionTypes.Skip
			}, "SettingAction_");
			CommonHelper.fillSelectWidthEnum(this._form.find("[name=encriptedObjAction]"), {
				"DeleteAttachment": KL.LMS.Enums.ActionTypes.DeleteAttachment,
				"DeleteMessage": KL.LMS.Enums.ActionTypes.DeleteMessage,
				"Reject": KL.LMS.Enums.ActionTypes.Reject,
				"Skip": KL.LMS.Enums.ActionTypes.Skip
			}, "SettingAction_");
			this._form.find("[name=malwareAction]").change(Delegate.create(this, this._checkUncuredVisible));
			this._form.find(".infectedMarkLink").click(Delegate.create(this, this._openTextEditor, "scanSettings.avScanSettings.infectedMark", "LabelTitleInfectedMark", "LabelTextTooltipInfectedInfo", false));
			this._form.find(".disinfectedMarkLink").click(Delegate.create(this, this._openTextEditor, "scanSettings.avScanSettings.disinfectedMark", "LabelTitleDisinfectedMark", "LabelTextTooltipDisinfectedInfo", false));
			this._form.find(".encryptedMarkLink").click(Delegate.create(this, this._openTextEditor, "scanSettings.avScanSettings.encryptedMark", "LabelTitleEncryptedMark", "LabelTextTooltipEncryptedInfo", false));
			this._form.find(".corruptedMarkLink").click(Delegate.create(this, this._openTextEditor, "scanSettings.avScanSettings.corruptedMark", "LabelTitleCorruptedMark", "LabelTextTooltipCorruptedInfo", false));
			this._form.find(".intrusionThreatMark").click(Delegate.create(this, this._openTextEditor, "scanSettings.avScanSettings.intrusionThreatMark", "LabelTitleThreatMarkMark", "LabelTextTooltipThreatMarkInfo", false));
			this._form.find(".attachmentMaxSizeLink").click(Delegate.create(this, this._openFileSizeEditor, "scanSettings.avScanSettings.engineSettings.maxSizeLimit", "LabelTitleMaxAttachmentSize", "LabelTextMaxAttachmentSizeInfo", {min: 0, max: 1048576}, false));
			this._form.find(".excludedNamesLink").click(Delegate.create(this, this._openExcludesEditor, "scanSettings.avScanSettings.engineSettings.excludedNames", "LabelTitleExcludedNames", "LabelTextExcludedNamesInfo", false));
			this._form.find(".excludedTypesLink").click(Delegate.create(this, this._excludedTypesLinkHandler, "scanSettings.avScanSettings.engineSettings.excludedFormats"));
		},
		onBaseFormDataBind: function () {
			this._checkUncuredVisible();
		},
		setHelpVisible: function(data, elt, val){
			elt[val?"show":"hide"]();
		},
		_setSelectActionTypeVal: function (data, elt, key) {
			var val = KL.LMS.Enums.ActionTypes[key];
			if (key && typeof (val) != "undefined") {
				elt.val(val);
				
			}
		},
		_protectionEnabled: function () {
			var ctx = this._page.getApplication().getContext();
			var enabled = ctx.getIsLicenseAvEnabled();
			this._disabledMessage = enabled?"LabelWarningGroupProtectionDisabled":"LabelWarningGroupProtectionDisabledByLicense";
			return enabled && ctx.getProtectionState("AV");
		},
		_checkUncuredVisible: function () {
			var ActionTypes = KL.LMS.Enums.ActionTypes,
				action = this._form.find("[name=malwareAction]").val(),
				uncuredaction = this._form.find("[name=uncuredMalwareAction]").val();
			this._form.find(".uncuredMalwarePanel").css("visibility",
				action == ActionTypes.Cure ? "visible" : "hidden"
			);
			this._form.find(".backupDeletetedInfected")[(action == ActionTypes.Reject || action == ActionTypes.Skip || (action == ActionTypes.Cure && uncuredaction == ActionTypes.Reject))?"hide":"show"]();
		},
		_excludedTypesLinkHandler: function (fieldXPath, e) {
			if (e) {
				e.preventDefault();
				if ($(e.currentTarget).is("[disabled]"))
					return;
			}
			var val = { data: KL.Utils.ObjectHelper.getObjValueByPath(this._data, fieldXPath) };
			$(val).bind("ondatacheange", KL.Utils.Delegate.create(this, this._excludeTypesChangeHandler));
			$(this).trigger("onexcludedtypes", [val]);
		},
		_excludeTypesChangeHandler: function () {
			this.setValue(this._data);
		},
		setExcludedTypesLink: function (data, elt, val) {
			var types = KL.LMS.Helpers.GroupsHelper.getExcludeTypesText(val);
			var types_str = KL.LMS.Helpers.GroupsHelper.getExcludeTypesTextString(val);
			elt.attr("title","");
			if (types.length < 1)
				types.push(KL.Utils.Localization.getInstance().getLocaleString("LabelSettingsGroupsExcludedNamesNotSet"));
			else {
				elt.attr("title",types_str.join("; "));
			}
			elt.html(types.join("; "));
		},
		setMaxSizeLink: function (data, elt, val) {
			if (val < 1)
				elt.empty().append(KL.Utils.Localization.getInstance().getLocaleString("LabelTextMaxAllowableSize_NotDefined"));
			else{
				var str = KL.LMS.Helpers.CommonHelper.localSizeObj(val);
				elt.empty().append(str);
			}
		},
		setExcludedNamesLink: function (data, elt, val) {
			var str = (val || []).join("; ");//KL.Utils.StringHelper.cropString((val || []).join("; "),40);
			elt.html( KL.Utils.StringHelper.htmlEncode(str) || KL.Utils.Localization.getInstance().getLocaleString("LabelSettingsGroupsExcludedNamesNotSet"));
			if (KL.Utils.StringHelper.htmlEncode(str).length>26)
				elt.attr("title",KL.Utils.StringHelper.htmlEncode(str));
		},
		_openExcludesEditor: function (fieldXPath, title, infoText, isRightAligned, e) {
			if (e) {
				this._form.find(".excludedNamesLink").attr("title","");
				e.preventDefault();
				if ($(e.currentTarget).is("[disabled]"))
					return;
				var val = KL.Utils.ObjectHelper.getObjValueByPath(this._data, fieldXPath);
				var dataObj = { "0": (val || []).join("; ") };
				$(this).trigger("ontextedit", [infoText, e.currentTarget, title, isRightAligned, dataObj]);
				$(dataObj).bind("onvaluechange", KL.Utils.Delegate.create(this, this._setExcludesValue, fieldXPath));
			}
		},
		_setExcludesValue: function (fieldXPath, e, val) {
			var text = (val && val[0]) ? val[0].replace(/;\s/gi, ";").split(/[;]/gi) : [];
			KL.Utils.ObjectHelper.setObjValueByPath(this._data, fieldXPath, text);
			this.setValue(this._data);
		}
	};
	KL.LMS.Groups.registerClass("GroupAvSettingsForm", GroupAvSettingsForm);
	GroupAvSettingsForm.extend( KL.LMS.Groups.BaseGroupSettingsForm );
})();
;
(function () {
	var GroupAsSettingsForm = function (id, setting) {
		GroupAsSettingsForm._super.call(this, id, setting);
	};
	GroupAsSettingsForm.prototype = {
		_data: null,
		_dataElementsMap: [
			{ "elt": "backupProbableSpam", "datasource": "scanSettings.asScanSettings.backupProbableSpam", "get": "setChboxVal", "set": "getIsChecked" },
			{ "elt": "backupBlacklisted", "datasource": "scanSettings.asScanSettings.backupBlacklisted", "get": "setChboxVal", "set": "getIsChecked" },
			{ "elt": "backupSpam", "datasource": "scanSettings.asScanSettings.backupSpam", "get": "setChboxVal", "set": "getIsChecked" },
			{ "elt": "backupMassMail", "datasource": "scanSettings.asScanSettings.backupMassMail", "get": "setChboxVal", "set": "getIsChecked" },
			{ "elt": "blacklistMailAction", "datasource": "scanSettings.asScanSettings.blacklistedAction", "get": "setSelectActionTypeVal", "set": "setActionTypeValue" },
			{ "elt": "blSubjTextLink", "datasource": "scanSettings.asScanSettings.blacklistedMark", "get": "setLinkText", "set": null },
			{ "elt": "possibleSpamAction", "datasource": "scanSettings.asScanSettings.probableSpamAction", "get": "setSelectActionTypeVal", "set": "setActionTypeValue" },
			{ "elt": "probableSpamSubjTextLink", "datasource": "scanSettings.asScanSettings.probableSpamMark", "get": "setLinkText", "set": null },
			{ "elt": "spamAction", "datasource": "scanSettings.asScanSettings.spamAction", "get": "setSelectActionTypeVal", "set": "setActionTypeValue" },
			{ "elt": "spamSubjTextLink", "datasource": "scanSettings.asScanSettings.spamMark", "get": "setLinkText", "set": null },
			{ "elt": "massMailAction", "datasource": "scanSettings.asScanSettings.massMailAction", "get": "setSelectActionTypeVal", "set": "setActionTypeValue" },
			{ "elt": "massMailSpamSubjTextLink", "datasource": "scanSettings.asScanSettings.massMailMark", "get": "setLinkText", "set": null },
			{ "elt": "isEnabled", "datasource": "scanSettings.asScanSettings.engineSettings.enableScan", "get": "setChboxVal", "set": "getIsChecked" },
			{ "elt": "scanMaxSize", "datasource": "scanSettings.asScanSettings.engineSettings.maxSizeLimit", "get": "setMaxSizeLink", "set": null },
			{ "elt": "rateChinese", "datasource": "scanSettings.asScanSettings.engineSettings.advancedOptions.disableLangChinese", "get": "setChboxVal", "set": "getIsChecked" },
			{ "elt": "rateKorean", "datasource": "scanSettings.asScanSettings.engineSettings.advancedOptions.disableLangKorean", "get": "setChboxVal", "set": "getIsChecked" },
			{ "elt": "rateThai", "datasource": "scanSettings.asScanSettings.engineSettings.advancedOptions.disableLangThai", "get": "setChboxVal", "set": "getIsChecked" },
			{ "elt": "rateJapanese", "datasource": "scanSettings.asScanSettings.engineSettings.advancedOptions.disableLangJapanese", "get": "setChboxVal", "set": "getIsChecked" },
			{ "elt": "rateCyrillic", "datasource": "scanSettings.asScanSettings.engineSettings.advancedOptions.disableLangCyrillic", "get": "setChboxVal", "set": "getIsChecked" },
			{"elt": "rateNumsInSender", "datasource": "scanSettings.asScanSettings.engineSettings.advancedOptions.headersFromOrToDigits", "get": "setChboxVal", "set": "getIsChecked" },
			{ "elt": "rateNoDomain", "datasource": "scanSettings.asScanSettings.engineSettings.advancedOptions.headersFromOrToNoDomain", "get": "setChboxVal", "set": "getIsChecked" },
			{ "elt": "rateLongSubj", "datasource": "scanSettings.asScanSettings.engineSettings.advancedOptions.headersSubjectTooLong", "get": "setChboxVal", "set": "getIsChecked" },
			{ "elt": "rateSpacesInSubj", "datasource": "scanSettings.asScanSettings.engineSettings.advancedOptions.headersSubjectWsOrDots", "get": "setChboxVal", "set": "getIsChecked" },
			{ "elt": "rateTimestampInSubj", "datasource": "scanSettings.asScanSettings.engineSettings.advancedOptions.headersSubjectDigitsOrTimeId", "get": "setChboxVal", "set": "getIsChecked" },
			{ "elt": "rateNoReceivers", "datasource": "scanSettings.asScanSettings.engineSettings.advancedOptions.headersToUndisclosed", "get": "setChboxVal", "set": "getIsChecked" },
			{ "elt": "scanRTF", "datasource": "scanSettings.asScanSettings.engineSettings.advancedOptions.parseRtf", "get": "setChboxVal", "set": "getIsChecked" },
			{ "elt": "scanImages", "datasource": "scanSettings.asScanSettings.engineSettings.advancedOptions.useGsg", "get": "setChboxVal", "set": "getIsChecked" },
			{"elt": "allowUseDNS", "datasource": "scanSettings.asScanSettings.engineSettings.externalServices.useDns", "get": "setChboxVal", "set": "getIsChecked" },
			{ "elt": "checkSenderInDNS", "datasource": "scanSettings.asScanSettings.engineSettings.externalServices.dnsHostInDns", "get": "setChboxVal", "set": "getIsChecked" },
			{ "elt": "useCustomDNSBL", "datasource": "scanSettings.asScanSettings.engineSettings.externalServices.useDnsbl", "get": "setChboxVal", "set": "getIsChecked" },
			{ "elt": "useBuiltinDNSBL", "datasource": "scanSettings.asScanSettings.engineSettings.externalServices.useDnsblDefaultList", "get": "setChboxVal", "set": "getIsChecked" },
			{ "elt": "useSPF", "datasource": "scanSettings.asScanSettings.engineSettings.externalServices.useSpf", "get": "setChboxVal", "set": "getIsChecked" },
			{ "elt": "useCustomSURBL", "datasource": "scanSettings.asScanSettings.engineSettings.externalServices.useSurbl", "get": "setChboxVal", "set": "getIsChecked" },
			{ "elt": "useBuiltinSURBL", "datasource": "scanSettings.asScanSettings.engineSettings.externalServices.useSurblDefaultList", "get": "setChboxVal", "set": "getIsChecked" }
		],
		_warningTooltip: "tooltip_GroupAsProtectionDisabled",
		_fillSelects: function () {
			var Delegate = KL.Utils.Delegate;
			var CommonHelper = KL.LMS.Helpers.CommonHelper;
			CommonHelper.fillSelectWidthEnum(this._form.find("[name=spamAction]"), {
				"DeleteMessage": KL.LMS.Enums.ActionTypes.DeleteMessage,
				"Reject": KL.LMS.Enums.ActionTypes.Reject,
				"Skip": KL.LMS.Enums.ActionTypes.Skip
			}, "SettingAction_");
			CommonHelper.fillSelectWidthEnum(this._form.find("[name=possibleSpamAction]"), {
				"DeleteMessage": KL.LMS.Enums.ActionTypes.DeleteMessage,
				"Reject": KL.LMS.Enums.ActionTypes.Reject,
				"Skip": KL.LMS.Enums.ActionTypes.Skip
			}, "SettingAction_");
			CommonHelper.fillSelectWidthEnum(this._form.find("[name=blacklistMailAction]"), {
				"DeleteMessage": KL.LMS.Enums.ActionTypes.DeleteMessage,
				"Reject": KL.LMS.Enums.ActionTypes.Reject,
				"Skip": KL.LMS.Enums.ActionTypes.Skip
			}, "SettingAction_");
			CommonHelper.fillSelectWidthEnum(this._form.find("[name=unreliableMailAction]"), {
				"DeleteMessage": KL.LMS.Enums.ActionTypes.DeleteMessage,
				"Reject": KL.LMS.Enums.ActionTypes.Reject,
				"Skip": KL.LMS.Enums.ActionTypes.Skip
			}, "SettingAction_");
			CommonHelper.fillSelectWidthEnum(this._form.find("[name=massMailAction]"), {
				"DeleteMessage": KL.LMS.Enums.ActionTypes.DeleteMessage,
				"Reject": KL.LMS.Enums.ActionTypes.Reject,
				"Skip": KL.LMS.Enums.ActionTypes.Skip
			}, "SettingAction_");
			this._form.find(".spamSubjTextLink").click(Delegate.create(this, this._openTextEditor, "scanSettings.asScanSettings.spamMark", "LabelTitleSpamMark", "LabelTextTooltipSpamInfo", false));
			this._form.find(".probableSpamSubjTextLink").click(Delegate.create(this, this._openTextEditor, "scanSettings.asScanSettings.probableSpamMark", "LabelTitleProbableSpamMark", "LabelTextTooltipProbableSpamInfo", false));
			this._form.find(".blSubjTextLink").click(Delegate.create(this, this._openTextEditor, "scanSettings.asScanSettings.blacklistedMark", "LabelTitleUnreliableMark", "LabelTextTooltipUnreliableInfo", false));
			this._form.find(".customDnsblField").delegate("a", "click", Delegate.create(this, this._listEditorOpen, "scanSettings.asScanSettings.engineSettings.externalServices.dnsblList", "LabelTitleCustomDNSBL", false, KL.LMS.Enums.UserBlackListTypes.DNSBL));
			this._form.find(".customSurblField").delegate("a", "click", Delegate.create(this, this._listEditorOpen, "scanSettings.asScanSettings.engineSettings.externalServices.surblList", "LabelTitleCustomSURBL", false, KL.LMS.Enums.UserBlackListTypes.SURBL));
			this._form.find(".scanMaxSize").click(Delegate.create(this, this._openFileSizeEditor, "scanSettings.asScanSettings.engineSettings.maxSizeLimit", "LabelTitleMaxLetterSize", "LabelTextMaxLetterASSizeInfo", { max: 1048576, min: 0 }, false));
			this._form.find(".massMailSpamSubjTextLink").click(Delegate.create(this, this._openTextEditor, "scanSettings.asScanSettings.massMailMark", "LabelTitleMassMailMark", "LabelTextTooltipMassMailInfo", false));
		},
		onBaseFormDataBind: function () {
			this._toggleDnsUse();
		},
		setMaxSizeLink: function (data, elt, val) {
			if (val == 0)
				elt.empty().append(KL.Utils.Localization.getInstance().getLocaleString("LabelTextMaxAllowableSize_NotDefined"));
			else {
				var str = KL.LMS.Helpers.CommonHelper.localSizeObj(val);
				elt.empty().append(str);
			}
		},
		
		_protectionEnabled: function () {
			var ctx = this._page.getApplication().getContext();
			var enabled = ctx.getIsLicenseAsEnabled();
			this._disabledMessage = enabled?"LabelWarningGroupProtectionDisabled":"LabelWarningGroupProtectionDisabledByLicense";
			return enabled && ctx.getProtectionState("AS");
		},
		_toggleDnsUse: function () {
			var val = !this._form.find("[name=allowUseDNS]").is(":checked");
			this._form.find(".dnsSettingsFields").toggleClass("disabled", val).find("input").attr("disabled", val);
		},
		setRateLvlLink: function (data, elt, val) {
			var AsRateLimits = KL.LMS.Enums.AsRateLimits;
			var key = val;
			key = key || AsRateLimits.getKeyByValue(AsRateLimits.Standard);
			elt.html(KL.Utils.Localization.getInstance().getLocaleString("LabelSettingAsRateLimit_" + key));
		},
		_listEditorOpen: function (fieldXPath, title, isRightAligned, listType, e) {
			var localization = KL.Utils.Localization.getInstance();
			if (e) {
				e.preventDefault();
				if ($(e.currentTarget).is("[disabled]"))
					return;
				var items = KL.Utils.ObjectHelper.getObjValueByPath(this._data, fieldXPath);
				var data = [];
				if (items != null) {
					for (var i = 0, l = items.length; i < l; i++)
						data.push( { "url": items[i] } );
				}
				var dataObj = { "0": listType,
					"1": { "items": data }
				};
				$(this).trigger("onlistedit", [null, e.currentTarget, title, isRightAligned, dataObj]);
			}
		},
		_setListValue: function (fieldXPath, e, val) {},
		isViewActionTypechBox: function(val) {
			return (val != KL.LMS.Enums.ActionTypes.DeleteMessage);
		},
		_setLevelValue: function (fieldXPath, e, val) {
			var AsRateLimits = KL.LMS.Enums.AsRateLimits;
			var lvl = (val && val[0]) ? val[0] : AsRateLimits.Standard;
			var lvlVal = AsRateLimits.getKeyByValue(lvl);
			if (lvlVal) {
				KL.Utils.ObjectHelper.setObjValueByPath(this._data, fieldXPath, lvlVal);
				this.setValue(this._data);
			}
		}
	};
	KL.LMS.Groups.registerClass("GroupAsSettingsForm", GroupAsSettingsForm);
	GroupAsSettingsForm.extend( KL.LMS.Groups.BaseGroupSettingsForm );
})();
;
(function () {
	var GroupCFSettingsForm = function (id, setting) {
		GroupCFSettingsForm._super.call( this, id, setting );
	}
	GroupCFSettingsForm.prototype = {
		_toValidateValue: "",
		_toValidateFieldXPath: "",
		_data: null,
		_warningTooltip: "tooltip_GroupCfProtectionDisabled",
		_dataElementsMap: [
			{ "elt": "sizeExceededAction", "datasource": "scanSettings.cfScanSettings.sizeExceededAction", "get": "setSelectActionTypeVal", "set": "setActionTypeValue" },
			{ "elt": "bannedFileNameAction", "datasource": "scanSettings.cfScanSettings.bannedFileNameAction", "get": "setSelectActionTypeVal", "set": "setActionTypeValue" },
			{ "elt": "bannedFileFormatAction", "datasource": "scanSettings.cfScanSettings.bannedFileFormatAction", "get": "setSelectActionTypeVal", "set": "setActionTypeValue" },
			{ "elt": "isEnabled", "datasource": "scanSettings.cfScanSettings.engineSettings.enableScan", "get": "setChboxVal", "set": "getIsChecked" },
			{"elt": "bannedFileNames", "datasource": "scanSettings.cfScanSettings.engineSettings.bannedFileNames", "get": "setExcludedNamesLink", "set": null },
			{ "elt": "CFmaxAllowedSize", "datasource": "scanSettings.cfScanSettings.engineSettings.maxAllowedSize", "get": "setMaxSizeLink", "set": null },
			{ "elt": "excludedTypesLinkCF", "datasource": "scanSettings.cfScanSettings.engineSettings.bannedFileFormats", "get": "setExcludedTypesLink", "set": null },
			
			{ "elt": "backupBannedFileFormat", "datasource": "scanSettings.cfScanSettings.backupBannedFileFormat", "get": "setChboxVal", "set": "getIsChecked" },
			{ "elt": "backupBannedFileName", "datasource": "scanSettings.cfScanSettings.backupBannedFileName", "get": "setChboxVal", "set": "getIsChecked" },
			{ "elt": "backupSizeExceeded", "datasource": "scanSettings.cfScanSettings.backupSizeExceeded", "get": "setChboxVal", "set": "getIsChecked" }
		],
		_fillSelects: function () {
			var Delegate = KL.Utils.Delegate;
			var CommonHelper = KL.LMS.Helpers.CommonHelper;
			CommonHelper.fillSelectWidthEnum(this._form.find("[name=sizeExceededAction]"), {
				"DeleteMessage": KL.LMS.Enums.ActionTypes.DeleteMessage,
				"Reject": KL.LMS.Enums.ActionTypes.Reject,
				"Skip": KL.LMS.Enums.ActionTypes.Skip
			}, "SettingAction_");
			CommonHelper.fillSelectWidthEnum(this._form.find("[name=bannedFileNameAction]"), {
				"DeleteMessage": KL.LMS.Enums.ActionTypes.DeleteMessage,
				"DeleteAttachment": KL.LMS.Enums.ActionTypes.DeleteAttachment,
				"Reject": KL.LMS.Enums.ActionTypes.Reject,
				"Skip": KL.LMS.Enums.ActionTypes.Skip
			}, "SettingAction_");
			CommonHelper.fillSelectWidthEnum(this._form.find("[name=bannedFileFormatAction]"), {
				"DeleteMessage": KL.LMS.Enums.ActionTypes.DeleteMessage,
				"DeleteAttachment": KL.LMS.Enums.ActionTypes.DeleteAttachment,
				"Reject": KL.LMS.Enums.ActionTypes.Reject,
				"Skip": KL.LMS.Enums.ActionTypes.Skip
			}, "SettingAction_");
			this._form.find(".CFmaxAllowedSize").click(Delegate.create(this, this._openFileSizeEditor, "scanSettings.cfScanSettings.engineSettings.maxAllowedSize", "LabelTitleMaxAttachmentSize", "LabelTextMaxAllowableSizeInfo", {min: 0, max: 1048576}, false));
			this._form.find(".bannedFileNames").click(Delegate.create(this, this._openExcludesEditor, "scanSettings.cfScanSettings.engineSettings.bannedFileNames", "LabelTitleExcludedNames", "LabelTextExcludedNamesInfo", false));
			this._form.find(".excludedTypesLinkCF").click(Delegate.create(this, this._excludedTypesLinkHandler, "scanSettings.cfScanSettings.engineSettings.bannedFileFormats"));
		},
		onBaseFormDataBind: function () {
		},
		_protectionEnabled: function () {
			var ctx = this._page.getApplication().getContext(),
				enabled = ctx.getIsLicenseCfEnabled();
			this._disabledMessage = enabled?"LabelWarningGroupProtectionDisabled":"LabelWarningGroupProtectionDisabledByLicense";
			return enabled && ctx.getProtectionState("CF");
		},
		_excludedTypesLinkHandler: function (fieldXPath, e) {
			if (e) {
				e.preventDefault();
				if ($(e.currentTarget).is("[disabled]"))
					return;
			}
			var val = { data: KL.Utils.ObjectHelper.getObjValueByPath(this._data, fieldXPath) };
			$(val).bind("ondatacheange", KL.Utils.Delegate.create(this, this._excludeTypesChangeHandler));
			$(this).trigger("onexcludedtypes", [val]);
		},
		_excludeTypesChangeHandler: function () {
			this.setValue(this._data);
		},
		setExcludedTypesLink: function (data, elt, val) {
			var types = KL.LMS.Helpers.GroupsHelper.getExcludeTypesText(val);
			var types_str = KL.LMS.Helpers.GroupsHelper.getExcludeTypesTextString(val);
			if (types.length == 0)
				types.push(KL.Utils.Localization.getInstance().getLocaleString("LabelSettingsGroupsExcludedNamesNotSet"));
			else {
				elt.attr("title",types_str.join("; "));
			}
			elt.html(types.join("; "));
		},
		setMaxSizeLink: function (data, elt, val) {
			if (val == 0) 
				elt.empty().append(KL.Utils.Localization.getInstance().getLocaleString("LabelTextMaxAllowableSize_NotDefined"))
			else{
				var str = KL.LMS.Helpers.CommonHelper.localSizeObj(val);
				elt.empty().append(str);
			}	
		},
		setExcludedNamesLink: function (data, elt, val) {
			var str = (val || []).join("; ");//KL.Utils.StringHelper.cropString((val || []).join("; "),40);
			var str_ = KL.Utils.StringHelper.htmlEncode(str);
			elt.html(str_ || KL.Utils.Localization.getInstance().getLocaleString("LabelSettingsGroupsExcludedNamesNotSet"));
			if (str_.length>26) 
				elt.attr("title",str);
		},
		_openExcludesEditor: function (fieldXPath, title, infoText, isRightAligned, e) {
			if (e) {
				this._form.find(".bannedFileNames").attr("title","")
				e.preventDefault();
				if ($(e.currentTarget).is("[disabled]"))
					return;
				var val = KL.Utils.ObjectHelper.getObjValueByPath(this._data, fieldXPath);
				var dataObj = { "0": (val || []).join("; ") };
				$(this).trigger("ontextedit", [infoText, e.currentTarget, title, isRightAligned, dataObj]);
				$(dataObj).bind("onvaluechange", KL.Utils.Delegate.create(this, this._validateExcludesValue, fieldXPath));
			}
		},
		isViewActionTypechBox: function(val) {
			return !(val == KL.LMS.Enums.ActionTypes.DeleteMessage || val == KL.LMS.Enums.ActionTypes.Skip || val == KL.LMS.Enums.ActionTypes.DeleteAttachment);
		},
		_setExcludesValue: function (fieldXPath, e, val) {
			var newText = [];
			for (var i = 0, l = val.length; i < l; i++) {
				if (!!$.trim(val[i]))
					newText.push(val[i]);
			}
			KL.Utils.ObjectHelper.setObjValueByPath(this._data, fieldXPath, newText);
			this.setValue(this._data);
		},
		_validateExcludesValue: function(fieldXPath, e, val) {
			var values = (val && $.trim(val[0])) ? val[0].replace(/;\s/gi, ";").split(/[;]/gi) : [];
			if (val[0].indexOf("re:") != -1) {
				this._toValidateValue = values;
				this._toValidateFieldXPath = fieldXPath;
				$(this).trigger("onnamevalidate");
			} else
				this._setExcludesValue(fieldXPath, e, values);
		},
		setExcludesValue: function(e, data) {
			if (data.action_id != null) return;
			
			if (!data.items) {
				this._page.getApplication().showMessage("ErrorLicenseInternal", "LabelDialogTitleError", "BtnClose", 300, KL.Web.MessageDialog.MessageType.Error);
				return;
			}
			for(var i = 0, l = data.items.length; i < l; i++) {
				if (!data.items[i].valid) {
					this._page.getApplication().showMessage("ErrorInvalidSettingsValue", "LabelDialogTitleError", "BtnClose", 300, KL.Web.MessageDialog.MessageType.Error);
					return;
				}
			}
			this._setExcludesValue(this._toValidateFieldXPath, null, this._toValidateValue);
		},
		getExcludesValue: function() {
			var val = this._toValidateValue;
			return KL.Utils.JSON.encode({"items": val});
		}
	};
	KL.LMS.Groups.registerClass("GroupCFSettingsForm", GroupCFSettingsForm);
	GroupCFSettingsForm.extend(KL.LMS.Groups.BaseGroupSettingsForm);
})();
;
(function () {
	function GroupApSettingsForm (id, setting) {
		GroupApSettingsForm._super.call( this, id, setting );
	}
	GroupApSettingsForm.prototype = {
		_data: null,
		_warningTooltip: "tooltip_GroupApProtectionDisabled",
		isViewActionTypechBox: function (val) {
			return (val == KL.LMS.Enums.ActionTypes.Skip || val == KL.LMS.Enums.ActionTypes.Reject);
		},
		_dataElementsMap: [
			{ "elt": "isEnabled", "datasource": "scanSettings.apScanSettings.engineSettings.enableScan", "get": "setChboxVal", "set": "getIsChecked" },
			{ "elt": "phishingAction", "datasource": "scanSettings.apScanSettings.phishingAction", "get": "setSelectActionTypeVal", "set": "setActionTypeValue" },
			{ "elt": "phishingMarkLink", "datasource": "scanSettings.apScanSettings.phishingMark", "get": "setLinkText", "set": null },
			{ "elt": "wmufMsgMarkLink", "datasource": "scanSettings.apScanSettings.maliciousMark", "get": "setLinkText", "set": null },
			{ "elt": "backupPhishingMsgs", "datasource": "scanSettings.apScanSettings.backupPhishing", "get": "setChboxVal", "set": "getIsChecked" }
		],
		_fillSelects: function () {
			var Delegate = KL.Utils.Delegate,
				CommonHelper = KL.LMS.Helpers.CommonHelper;
			CommonHelper.fillSelectWidthEnum(this._form.find("[name=phishingAction]"), {
				"DeleteMessage": KL.LMS.Enums.ActionTypes.DeleteMessage,
				"Reject": KL.LMS.Enums.ActionTypes.Reject,
				"Skip": KL.LMS.Enums.ActionTypes.Skip
			}, "SettingAction_");
			this._form.find(".phishingMarkLink").click(Delegate.create(this, this._openTextEditor, "scanSettings.apScanSettings.phishingMark", "LabelTitleApPhishingMark", "LabelTextTooltipApPhishingInfo", false));
			this._form.find(".wmufMsgMarkLink").click(Delegate.create(this, this._openTextEditor, "scanSettings.apScanSettings.maliciousMark", "LabelTitleApMaliciousMark", "LabelTextTooltipApMaliciousInfo", false));
		},
		_protectionEnabled: function () {
			var ctx = this._page.getApplication().getContext(),
				enabled = ctx.getIsLicenseApEnabled();
			this._disabledMessage = enabled?"LabelWarningGroupProtectionDisabled":"LabelWarningGroupProtectionDisabledByLicense";
			return enabled && ctx.getProtectionState("AP");
		}
	};
	KL.LMS.Groups.registerClass("GroupApSettingsForm", GroupApSettingsForm);
	GroupApSettingsForm.extend(KL.LMS.Groups.BaseGroupSettingsForm);
})()
;
(function () {
	var GroupNotificationSettingsForm = function (id, setting) {
		GroupNotificationSettingsForm._super.call(this, id, setting);
	};
	GroupNotificationSettingsForm.prototype = {
		_data: null,
		_dataElementsMap: [
			{ "elt": "infectedAdmin", "datasource": "scanSettings.notificationSettings.admin.enableInfected", "get": "setChboxVal", "set": "getIsChecked" },
			{ "elt": "infectedSender", "datasource": "scanSettings.notificationSettings.sender.enableInfected", "get": "setChboxVal", "set": "getIsChecked" },
			{ "elt": "infectedRecipient", "datasource": "scanSettings.notificationSettings.recipient.enableInfected", "get": "setChboxVal", "set": "getIsChecked" },
			{ "elt": "infectedDoNotAttachSourceLink", "datasource": "scanSettings.notificationSettings.recipient.doNotAttachOriginalForInfected", "get": "setDoNotAttachSourceLink", "set": "getDoNotAttachSource" },
			{ "elt": "infectedAdditional", "datasource": "scanSettings.notificationSettings.additional.options.enableInfected", "get": "setChboxVal", "set": "getIsChecked" },
			{ "elt": "infectedNotificationAdditionalLink", "datasource": "scanSettings.notificationSettings.additional.emailListInfected", "get": "setEmailListLink", "set": null },
			{ "elt": "encryptedAdmin", "datasource": "scanSettings.notificationSettings.admin.enableEncrypted", "get": "setChboxVal", "set": "getIsChecked" },
			{ "elt": "encryptedSender", "datasource": "scanSettings.notificationSettings.sender.enableEncrypted", "get": "setChboxVal", "set": "getIsChecked" },
			{ "elt": "encryptedRecipient", "datasource": "scanSettings.notificationSettings.recipient.enableEncrypted", "get": "setChboxVal", "set": "getIsChecked" },
			{ "elt": "encryptedDoNotAttachSourceLink", "datasource": "scanSettings.notificationSettings.recipient.doNotAttachOriginalForEncrypted", "get": "setDoNotAttachSourceLink", "set": null },
			{ "elt": "encryptedAdditional", "datasource": "scanSettings.notificationSettings.additional.options.enableEncrypted", "get": "setChboxVal", "set": "getIsChecked" },
			{ "elt": "encryptedNotificationAdditionalLink", "datasource": "scanSettings.notificationSettings.additional.emailListEncrypted", "get": "setEmailListLink", "set": null },
			{ "elt": "corruptedAdmin", "datasource": "scanSettings.notificationSettings.admin.enableCorrupted", "get": "setChboxVal", "set": "getIsChecked" },
			{ "elt": "corruptedSender", "datasource": "scanSettings.notificationSettings.sender.enableCorrupted", "get": "setChboxVal", "set": "getIsChecked" },
			{ "elt": "corruptedRecipient", "datasource": "scanSettings.notificationSettings.recipient.enableCorrupted", "get": "setChboxVal", "set": "getIsChecked" },
			{ "elt": "corruptedDoNotAttachSourceLink", "datasource": "scanSettings.notificationSettings.recipient.doNotAttachOriginalForCorrupted", "get": "setDoNotAttachSourceLink", "set": null },
			{ "elt": "corruptedAdditional", "datasource": "scanSettings.notificationSettings.additional.options.enableCorrupted", "get": "setChboxVal", "set": "getIsChecked" },
			{ "elt": "corruptedNotificationAdditionalLink", "datasource": "scanSettings.notificationSettings.additional.emailListCorrupted", "get": "setEmailListLink", "set": null },
			{ "elt": "cffailAdmin", "datasource": "scanSettings.notificationSettings.admin.enableCFFail", "get": "setChboxVal", "set": "getIsChecked" },
			{ "elt": "cffailSender", "datasource": "scanSettings.notificationSettings.sender.enableCFFail", "get": "setChboxVal", "set": "getIsChecked" },
			{ "elt": "cffailRecipient", "datasource": "scanSettings.notificationSettings.recipient.enableCFFail", "get": "setChboxVal", "set": "getIsChecked" },
			{ "elt": "cffailDoNotAttachSourceLink", "datasource": "scanSettings.notificationSettings.recipient.doNotAttachOriginalForCFFail", "get": "setDoNotAttachSourceLink", "set": null },
			{ "elt": "cffailAdditional", "datasource": "scanSettings.notificationSettings.additional.options.enableCFFail", "get": "setChboxVal", "set": "getIsChecked" },
			{ "elt": "cffailNotificationAdditionalLink", "datasource": "scanSettings.notificationSettings.additional.emailListCFFail", "get": "setEmailListLink", "set": null },
			{ "elt": "phishingAdmin", "datasource": "scanSettings.notificationSettings.admin.enablePhishing", "get": "setChboxVal", "set": "getIsChecked" },
			{ "elt": "phishingSender", "datasource": "scanSettings.notificationSettings.sender.enablePhishing", "get": "setChboxVal", "set": "getIsChecked" },
			{ "elt": "phishingRecipient", "datasource": "scanSettings.notificationSettings.recipient.enablePhishing", "get": "setChboxVal", "set": "getIsChecked" },
			{ "elt": "phishingDoNotAttachSourceLink", "datasource": "scanSettings.notificationSettings.recipient.doNotAttachOriginalForPhishing", "get": "setDoNotAttachSourceLink", "set": null },
			{ "elt": "phishingAdditional", "datasource": "scanSettings.notificationSettings.additional.options.enablePhishing", "get": "setChboxVal", "set": "getIsChecked" },
			{ "elt": "phishingNotificationAdditionalLink", "datasource": "scanSettings.notificationSettings.additional.emailListPhishing", "get": "setEmailListLink", "set": null }
		],
		setDoNotAttachSourceLink: function (data, elt, val) {
			var txt = KL.Utils.Localization.getInstance().getLocaleString(!!val?"LabelSettingsGroupsNotifyOnlyText":"LabelSettingsGroupsNotifyIncludeSource");
			elt.html(txt);
		},
		setEmailListLink: function (data, elt, val) {
			var txt = val.join(", ") || KL.Utils.Localization.getInstance().getLocaleString("LabelSettingsGroupsMarkNotSet");
			elt.html(txt);
		},
		_fillSelects: function () {
			var Delegate = KL.Utils.Delegate,
				additionals = {"infectedNotificationAdditionalLink": true, "encryptedNotificationAdditionalLink": true, "corruptedNotificationAdditionalLink": true, "cffailNotificationAdditionalLink": true, "phishingNotificationAdditionalLink": true},
				sendSrcLnks = {"infectedDoNotAttachSourceLink": true, "encryptedDoNotAttachSourceLink": true, "corruptedDoNotAttachSourceLink": true, "cffailDoNotAttachSourceLink": true, "phishingDoNotAttachSourceLink": true};
			for( var i=0, l=this._dataElementsMap.length; i<l; i++ ){
				var mapItem = this._dataElementsMap[i];
				if( !!additionals[mapItem.elt] )
					this._form.find("."+mapItem.elt).click(Delegate.create(this, this._listEditorOpen, mapItem.datasource, "LabelTitleAdditionalSenderList", false));
				else if( !!sendSrcLnks[mapItem.elt] )
					this._form.find("."+mapItem.elt).click(Delegate.create(this, this._attachSourceEditorOpen, mapItem.datasource, "LabelTitleDialogAttachSource", false));
			}
		},
		onBaseFormDataBind: function () {},
		_toggleEngineEnabled: function () {
			var enabled = true;//this._form.find("[name=isEnabled]").is(":checked");
			this._form.find(".fieldsGroup").toggleClass("disabled", !enabled);
			this._form.find(".fieldsGroup input, .fieldsGroup select, .fieldsGroup a, .fieldsGroup textarea, .fieldsGroup button").attr("disabled", !enabled);
			this._form.find(".disabled").find("input, select, a, textarea, button").attr("disabled", true);
		},
		_listEditorOpen: function (fieldXPath, title, isRightAligned, e) {
			if (e) {
				e.preventDefault();
				if ($(e.currentTarget).is("[disabled]"))
					return;
				var data = { "0": KL.Utils.ObjectHelper.getObjValueByPath(this._data, fieldXPath) };
				$(this).trigger("onlistedit", [null, e.currentTarget, title, isRightAligned, data]);
				$(data).bind("onvaluechange", KL.Utils.Delegate.create(this, this._setEmailList, fieldXPath));
			}
		},
		_attachSourceEditorOpen: function(fieldXPath, title, isRightAligned, e){
			if (e) {
				e.preventDefault();
				if ($(e.currentTarget).is("[disabled]"))
					return;
				var data = { "0": KL.Utils.ObjectHelper.getObjValueByPath(this._data, fieldXPath) };
				$(this).trigger("onattachsourceedit", [null, e.currentTarget, title, isRightAligned, data]);
				$(data).bind("onvaluechange", KL.Utils.Delegate.create(this, this._setAttachSourceList, fieldXPath));
			}
		},
		_setAttachSourceList: function (fieldXPath, e, vals) {
			if( vals["0"] === "true" || vals["0"] === "false" ){
				KL.Utils.ObjectHelper.setObjValueByPath(this._data, fieldXPath, vals["0"] === "true");
				this.setValue(this._data);
			}
		},
		_setEmailList: function (fieldXPath, e, vals) {
			if( !!vals ){
				var val = ($.trim(vals["0"]) || "").split("|");
				KL.Utils.ObjectHelper.setObjValueByPath(this._data, fieldXPath, val);
				this.setValue(this._data);
			}
		}
	};
	KL.LMS.Groups.registerClass("GroupNotificationSettingsForm", GroupNotificationSettingsForm);
	GroupNotificationSettingsForm.extend(KL.LMS.Groups.BaseGroupSettingsForm);
})()
;
(function () {
	var ListEditor = function (id, setting) {
		ListEditor._super.call( this, id, setting );
	};
	ListEditor.prototype = {
		onInitInteraction: function () {
			var elt = this.getElt();
			if (elt) {
				elt.listeditor(
						{
						"isSaveOnClick": true,
						"itemText": ".itemText",
						"validateOnSave": KL.Utils.Delegate.create(this, this._validateEmail)
						}
					)
					.bind("onitemselect", KL.Utils.Delegate.create(this, this._recipientSelected))
					.bind("onitemcreate", KL.Utils.Delegate.create(this, this._setRecipientDelete))
					.bind("onvaluechange", KL.Utils.Delegate.create(this, this._recipientsChanged));
				this._recipientSelected(null, false, null);
			}
		},
		_validateEmail: function (val) {
			var elt = this.getElt();
			if (elt) {
				elt.find(".editField").removeClass("error");
					var reg = /^[a-zA-Z0-9][\w\.-]*[a-zA-Z0-9]*@[a-zA-Z0-9][\w\.-]*[a-zA-Z0-9\.]*[a-zA-Z][a-zA-Z\.]*[a-zA-Z]$/;
				if(!reg.test(val)) {
					elt.find(".editField").addClass("error");
					return false;
				}	
			}
			return true;
		},
		
		setValue: function (e, extra, target, title, isRightAligned, dataObj) {
			var elt = this.getElt();
			if (elt) {
				elt.listeditor("setValue", dataObj["0"] || dataObj);
				elt.find(".editField").removeClass("error");
				elt.find(".editField").val("");
				this._recipientsChanged(e, elt.listeditor("getValue"));
			}
		},
		
		_recipientSelected: function (e, isSelected, data) {
			var elt = this.getElt();
			if (elt) {
				elt.find(".button").toggle(isSelected).filter(".btnAdd").toggle(!isSelected);
			}
		},
		_recipientsChanged: function ( e, data ) {
			this._recipientSelected(null, false, null);
			var elt = this.getElt();
			if (elt) {
				var data = elt.listeditor("getValue") || [];
				elt.find(".dataoutfield").val(data.join("|"));
			}
		},
		_setRecipientDelete: function (e, item_i, data, indx) {
			item_i.find(".itemDelBtn").click(KL.Utils.Delegate.create(this, this._deleteRecipient, indx));
		},
		_deleteRecipient: function (indx, e) {
			if(e){
				e.stopPropagation();
				e.preventDefault();
			}
			var elt = this.getElt();
			if (elt) {
				elt.listeditor("removeNumItem", indx);
			}
			this._recipientSelected(null, false, null);
		},
		_valueChanged: function (e, val) {
			var elt = this.getElt();
			if (elt) {
				elt.find(".listvalue").val(val);
			}
		}
	};
	KL.LMS.Groups.registerClass("ListEditor", ListEditor);
	ListEditor.extend(KL.Web.Controls.Control);
})()
;
(function () {
	var BlackListView = function (id, setting) {
		BlackListView._super.call(this, id, setting);
	};
	BlackListView.prototype = {
		_listtype: null,
		onInitInteraction: function () {
			var elt = this.getElt();
			if (elt) {
				this._listtype = KL.LMS.Enums.UserBlackListTypes.DNSBL;
				this._listContainer = elt.find(".item").parent();
				this._initList();
			}
		},
		getListType: function () {
			return this._listtype;
		},
		onBeforeDataBind: function (data) {
			
			var elt = this.getElt();
			if (elt) {
				var isempty = !data || !data.items || data.items.length <= 0;
				elt.find(".listItems").css("background","white");
				elt.find(".listItems").toggle(!isempty);
				elt.find(".emptyListItems").toggle(isempty);
				return !isempty;
			}
			return false;
		},
		itemDataBind: function(itemData){
			itemData.url_txt = KL.Utils.StringHelper.htmlEncode(itemData.url);
		},
		setListType: function (e, extra, target, title, isRightAligned, dataObj) {
			var BLTypes = KL.LMS.Enums.UserBlackListTypes;
			this._listtype = BLTypes.DNSBL
			var data = dataObj[0];
			this.setValue(dataObj[1]);
			if (data == BLTypes.DNSBL || data == BLTypes.SURBL)
				this._listtype = data;
		}
	};
	KL.LMS.Groups.registerClass("BlackListView", BlackListView);
	BlackListView.extend( KL.Web.Controls.ListViewControl );
})()
;
(function () {
	var AddressesEditor = function (id, setting) {
		AddressesEditor._super.call( this, id, setting );
	};
	AddressesEditor.prototype = {
		_data: null,
		_validatingIp: "",
		_ldapListItem: "",
		_selectedDeleteItems: 0,
		_ldapItems: null,
		_ldapSearch: null,
		externalAccount: "",
		onInitInteraction: function () {
			var elt = this.getElt();
			if (elt) {
				var Delegate = KL.Utils.Delegate;
				elt.find(".btnOk").click(Delegate.create(this, this._submitHandler));
				elt.find(".btnCancel").click(Delegate.create(this, this._triggerCancel));
				this._ldapListItem = elt.find(".ldapAccsList").html();
				elt.find(".ldapAccsList").empty();
				this._ldapSearch = KL.LMS.Helpers.LdapHelper.makeSearchPanel(elt);
				$(this._ldapSearch)
					.bind("onsearch", Delegate.create(this, this._search))
					.bind("onitemselected", Delegate.create(this, this._toggleLdapAddBtn));
				elt.find(".btnAddFoundItem").click(Delegate.create(this, this._addSelectedLdapItems));
				elt.find(".btnLdapDelete").click(Delegate.create(this, this._deleteLdapItems));
			}
		},
		applyError: function (evt, err) {
			this._ldapSearch.clearList();
			AddressesEditor._super.prototype.applyError.call(this, evt, err);
		},
		setValue: function (e, data) {
			var elt = this.getElt();
			if (!elt || !data)
				return;
			if (data.title)
				this._page.setTitle(data.title);
			var localization = KL.Utils.Localization.getInstance();
			if (data.prefix) {
				elt.find(".LabelAddrEditTitleLDAP").text(localization.getLocaleValueString("LabelAddrEditTitleLDAP" + data.prefix));
				elt.find(".LabelAddrEditTitleLDAPList").text(localization.getLocaleValueString("LabelAddrEditTitleLDAPList" + data.prefix));
			}
			if (data.data) {
				this._selectedDeleteItems = 0;
				this._toggleLdapDeleteBtn();
				this._data = data;
				var addrs = [];
				var AddrsTypes = KL.LMS.Enums.AddrsTypes;
				for (var i = 0, l = data.data.length; i < l; i++) {
					var addr = data.data[i];
					if (AddrsTypes[addr.type] == AddrsTypes.ExternalAccount)
						this._addLdapItem(addr);
					else
						addrs.push(addr);
				}
				this._data.data = addrs;
			}
			if (data.term) {
				elt.find(".editField").val(data.term).focus();
				$(this).trigger("searchLDAP");
			}
		},
		_addLdapItem: function (data) {
			var elt = this.getElt();
			if (elt && data && !this.isDuplicate(data.value)) {
				var m = elt.find(".ldapAccsList"),
					k = $(this._ldapListItem).find(m),
					item = $(this._ldapListItem).appendTo(elt.find(".ldapAccsList"));
				item.data("ldap-item-value", data);
				item.text(data.attributes ? this._getLdapString(data.attributes) : data.value);
				
				item.hover(
					function () { $(this).addClass("itemOver"); },
					function () { $(this).removeClass("itemOver"); }
				).click(KL.Utils.Delegate.create(this, this._selectLdapItem, item, data));
				switch (data.objectType) {
					case 0: break;
					case 1: item.addClass("itemGroup"); break;
					default: item.addClass("itemUnknown"); break;
				}
			}
		},
		isDuplicate: function(val){
			var elt = this.getElt();
			var dataOut = [];
		
			elt.find(".ldapAccsList .item").each(KL.Utils.Delegate.create(this, function (d, indx, item) {
				var data = $(item).data("ldap-item-value");
				d.push({ "type": KL.LMS.Enums.AddrsTypes.getKeyByValue(KL.LMS.Enums.AddrsTypes.ExternalAccount), "value": data.value,
					"attributes": data.attributes, "objectType": data.objectType
				});
			}, dataOut));
		
			for( var i=0; i<dataOut.length; i++)
				if (dataOut[i].value ==val) return true;
			
								
			return false;
		},
		
		_submitHandler: function () {
			var elt = this.getElt();
			if (elt) {
				var AddrsTypes = KL.LMS.Enums.AddrsTypes;
				var dataOut = this._data.data;
				elt.find(".ldapAccsList .item").each(KL.Utils.Delegate.create(this, function (d, indx, item) {
					var data = $(item).data("ldap-item-value");
					d.push({ "type": KL.LMS.Enums.AddrsTypes.getKeyByValue(KL.LMS.Enums.AddrsTypes.ExternalAccount), "value": data.value,
						"attributes": data.attributes, "objectType": data.objectType
					});
				}, dataOut));
				$(this._data).trigger("ondatachange", [dataOut]);
				$(this).trigger("onok");
			}
		},
		_search: function (e, term) {
			$(this).trigger("searchLDAP");
		},
		getSearchByLDAPData: function (e, data) {
			return this._ldapSearch.getSearchTerm();
		},
		getSearchLimitByLDAPData: function (e, data) {
			return this._ldapSearch.getSearchLimit();
		},
		
		setSearchByLDAPData: function (e, data, isComplete) {
			if (isComplete)
				this._ldapSearch.addItems(data);
		},
		_getLdapString: function (data) {
			if (data instanceof Array) {
				var result = "";
				for (var i = 0, l = data.length; i < l; i++) {
					if (data[i]["attribute"] != "objectClass")
						if (data[i]["attribute"].length===0)
							result = result +data[i]["values"].join(", ") + ";   ";
						else
							result = result + data[i]["attribute"].toUpperCase()+":"+data[i]["values"].join(", ") + ";   ";
				}
				return result;
			}
			else return data;
			
		},
		_selectLdapItem: function (row, data) {
			var isSelected = !row.data("ldap-item-selected");
			row.toggleClass("itemSelected", isSelected);
			row.data("ldap-item-selected", isSelected);
			this._selectedDeleteItems += isSelected ? 1 : -1;
			this._selectedDeleteItems = this._selectedDeleteItems > 0 ? this._selectedDeleteItems : 0;
			this._toggleLdapDeleteBtn();
		},
		_toggleLdapAddBtn: function (e, count) {
			var elt = this.getElt();
			if (elt)
				elt.find(".btnAddFoundItem").attr("disabled", count <= 0);
		},
		_toggleLdapDeleteBtn: function () {
			var elt = this.getElt();
			if (elt)
				elt.find(".btnLdapDelete").attr("disabled", this._selectedDeleteItems <= 0);
		},
		_deleteLdapItems: function () {
			var elt = this.getElt();
			if (elt)
				elt.find(".ldapAccsList .itemSelected").remove();
		},
		_addSelectedLdapItems: function () {
			var items = this._ldapSearch.getSelectedItems();
			this._ldapSearch.removeSelection();
			$(items).each(KL.Utils.Delegate.create(this, this._addFoundItem));
		},
		_addFoundItem: function (indx, data) {
			this._addLdapItem(data);
		},
		_triggerCancel: function () {
			$(this).trigger("oncancel");
		}
	};
	KL.LMS.Groups.registerClass("AddressesEditor", AddressesEditor);
	AddressesEditor.extend(KL.Web.Controls.Control);
})()
;
(function () {
	var AddressesImportEditor = function (id, setting) {
		AddressesImportEditor._super.call( this, id, setting );
	};
	AddressesImportEditor.prototype = {
		_val : null,
		isViewTypeOption : false,
		opener: null,
		onInitInteraction: function () {
			this.hideError();
			var elt = this.getElt();
			if (elt) {
				var Delegate = KL.Utils.Delegate;
				elt.find(".btnOk").click(Delegate.create(this, this._submitHandler));
				elt.find(".btnCancel").click(Delegate.create(this, this._triggerCancel));
			}
		},
		
		setType : function (isRecepient){
			var elt = this.getElt();
			if (elt) {
				if (!isRecepient) 
					KL.LMS.Helpers.CommonHelper.fillSelectWidthEnum(elt.find(".typeSwitch"), {
						"Mail": KL.LMS.Enums.AddrsTypes.EMailMask,
						"Ip": KL.LMS.Enums.AddrsTypes.CIDR,
						"Ldap": KL.LMS.Enums.AddrsTypes.ExternalAccount
					}, "SenderTypeOption");
				else	
					KL.LMS.Helpers.CommonHelper.fillSelectWidthEnum(elt.find(".typeSwitch"), {
						"Mail": KL.LMS.Enums.AddrsTypes.EMailMask,
						"Ldap": KL.LMS.Enums.AddrsTypes.ExternalAccount
					}, "SenderTypeOption");
			}
		
		},	
		
		setExportData: function() {
			var localization = KL.Utils.Localization.getInstance();
			var elt = this.getElt();
			var data = this._val;
			var type = this.isViewTypeOption ? 
				KL.LMS.Enums.AddrsTypes.getKeyByValue( elt.find(".typeSwitch").val()*1 ) : 
				KL.LMS.Enums.AddrsTypes.getKeyByValue(KL.LMS.Enums.AddrsTypes.EMailMask);
			
			if(data && data.length > 0){
				items = [];
				
				for( var i=0, l=data.length; i<l; i++ ){
					if (data[i].type==type)
						items.push( data[i].value ? data[i].value : data[i]);
				}
				if (items.length>0)
					elt.find(".listEditField").val(items.join("\r\n"));
				else {
					elt.find(".listEditField").val("");
					elt.find(".fieldPlaceholder").html(localization.getLocaleString("LabelImportDialogPasteTextHereExport"));
				}
				this._hidePlaceholder();
			}
			else {
					elt.find(".listEditField").val("");
					elt.find(".fieldPlaceholder").html(localization.getLocaleString("LabelImportDialogPasteTextHereExport"));
			}
		},
		
		
		setData : function (e,val){
			var elt = this.getElt();
			this._val = val.data;
			this.isViewTypeOption = val.isViewTypeOption;
			this.opener = val.opener;
			
			if (val.title) this._page.setTitle(val.title);
		
			if (elt) {
				if (!val.isViewTypeOption)  {
					elt.find(".typeSwitch").parent().hide();
					
				}
				else
					this.setType(val.prefix=="_Receivers")	;
				
				if (!val.isImport) {
					elt.find(".btnOk").hide();
					elt.find(".fieldPlaceholder").removeClass("str-local-LabelImportDialogPasteTextHere");
					this.setExportData();
					elt.find(".typeSwitch").change(KL.Utils.Delegate.create(this, this.setExportData));
				}
				else {
					elt.find(".listEditField").on("paste keyup mouseup", KL.Utils.Delegate.create(this, this._hidePlaceholder));
				}
			}
		},		
		
		_submitHandler: function(){
			var elt = this.getElt();
			if (elt) {
				var data = [];
				var evtName = "onok";
				if (this.isViewTypeOption)
					switch( elt.find(".typeSwitch").val()*1 ){
						case KL.LMS.Enums.AddrsTypes.EMailMask: evtName = "ontestemails"; break;
						case KL.LMS.Enums.AddrsTypes.CIDR: evtName = "ontestips"; break;
						default:
							data = [this._getLdapItems()];
							window.setTimeout( KL.Utils.Delegate.create( this, this._closePage ), 0);
							break;
					}
				else
					evtName = "ontestemails";
				$(this).trigger(evtName, data);
			}
			return false;
		},
		_getLdapItems: function(){
			var data = this._getItemsFromField();
			var items = null;
			if(data && data.length > 0){
				items = [];
				var type = KL.LMS.Enums.AddrsTypes.getKeyByValue( KL.LMS.Enums.AddrsTypes.ExternalAccount );
				for( var i=0, l=data.length; i<l; i++ ){
					items.push({
						"value": data[i],
						"type": type
					});
				}
			}
			return items;
		},
		_triggerCancel: function () {
			$(this).trigger("oncancel");
			this._closePage();
		},
		_hidePlaceholder: function(e){
			var elt = this.getElt();
			window.setTimeout( function(){
				if (elt) {
					var val = $.trim(elt.find(".listEditField").val());
					elt.find(".fieldPlaceholder").toggle(!val);
				}
			}, 100 );
		},
		_getItemsFromField: function(){
			var elt = this.getElt(),
				retVal = [];
			if(elt){
				var spltRegex = /[\n\;\,]/g;
				if( elt.find(".typeSwitch").val()*1 == KL.LMS.Enums.AddrsTypes.ExternalAccount )
					spltRegex = /[\n\;]/g;
				var splitted = ($.trim(elt.find(".listEditField").val() || "") + "").replace(/[\r]/g, "\n").replace(/\n+/g, "\n").split(spltRegex);
				for( var i=0, l=splitted.length; i<l; i++ ){
					if( !!$.trim(splitted[i]) )
						retVal.push(splitted[i]);
				}
			}
			return retVal;
		},
		applyValidationResult: function(e, data, isComplete){
			var elt = this.getElt();
			if(elt && isComplete){
				var vals = this._getItemsFromField();
				var notValidData = [];
				var valids = null;
				if( data && data.items && data.items.length ){
					valids = {};
					for (var i = 0, l = data.items.length; i<l; i++)
						valids[data.items[i].element] = !!data.items[i].valid;
				}
				var records = null;
				var type = KL.LMS.Enums.AddrsTypes.getKeyByValue( elt.find(".typeSwitch").val()*1 );
				if( valids ){
					records = [];
					for (var i = 0, l = vals.length; i<l; i++){
						if( valids[vals[i]] ){
							records.push({
								"value": vals[i],
								"type": type
							});
						}else
							notValidData.push( vals[i] );
					}
				}
				notValidData = notValidData.join("\n");
				elt.find(".listEditField").val(notValidData);
				$(this).trigger("onok", [records, this.opener]);
				if( notValidData )
					this.showError(-1, KL.Utils.Localization.getInstance().getLocaleString( "LabelImportDialogError" ));
				else
					this._closePage();
			}
		},
		_closePage: function(){
			if ( this._page instanceof KL.Web.Dialog)
				this._page.closeDialog();
		},
		getValidationData: function (elt) {
			var vals = this._getItemsFromField();
			return KL.Utils.JSON.encode( { "items": vals } );
		}
	};
	KL.LMS.Groups.registerClass("AddressesImportEditor", AddressesImportEditor);
	AddressesImportEditor.extend( KL.Web.Controls.Control )
})()
;
(function () {
	
	function _unfilterItems(elt, evt){
		if(evt)
			evt.preventDefault();
		elt.find(".searchField .textbox").val("");
		_filterItems.call(this, elt);
	}
	function _filterItems(elt, evt){
		if(evt)
			evt.preventDefault();
		var val = $.trim(elt.find(".searchField .textbox").val());
		elt.find(".extension").show();
		if( val ){
			elt.find(".extension:not([data-ext*='"+val+"'])").hide();
		}
	}
	var FilesTypesSelectForm = function (id, setting) {
		FilesTypesSelectForm._super.call( this, id, setting );
	};
	FilesTypesSelectForm.prototype = {
		_itemTpl: "",
		_subItemTpl: "",
		_extTpl: "",
		_listContainer: null,
		_data: null,
		onInitInteraction: function () {
			var elt = this.getElt();
			if (elt) {
				this._listContainer = elt.find(".item").parent();
				this._extTpl = this._listContainer.find(".extension").parent().html();
				this._listContainer.find(".extension").parent().empty();
				this._subItemTpl = this._listContainer.find(".subitem").parent().html();
				this._listContainer.find(".subitem").parent().empty()
				this._itemTpl = this._listContainer.html();
				this._listContainer.empty();
				elt.find(".selectForm").submit(KL.Utils.Delegate.create(this, this._submitHandler));
				elt.find(".btnClose").on("click", KL.Utils.Delegate.create(this, this._triggerClose));
				elt.find( ".searchForm" ).on( "submit", KL.Utils.Delegate.create(this, _filterItems, elt) );
				elt.find( ".clearBtn" ).on( "click", KL.Utils.Delegate.create(this, _unfilterItems, elt) );
			}
		},
		_bindData: function (data) {
			var StringHelper = KL.Utils.StringHelper;
			var localization = KL.Utils.Localization.getInstance();
			var Delegate = KL.Utils.Delegate;
			for (var groupName in data) {
				if (data.hasOwnProperty(groupName)) {
					var group = data[groupName];
					var localStr = "LabelFilesTypes_";
					var item = $(StringHelper.formatTemplate(this._itemTpl, { "Title": localization.getLocaleString(localStr + groupName) })).appendTo(this._listContainer);
					item.find(".threeStateCheckbox").threeStateCheckbox()
					.bind("onchecked", Delegate.create(this, this._toggleAllselect, null, item, true))
					.bind("oncheckednone", Delegate.create(this, this._toggleAllselect, null, item, false));
					item.find(".filesTypesGroupTitle").click(Delegate.create(this, this._toggleExpanded, item));
					this._renderSubItems(item, localStr, data[groupName], groupName);
					this._extensionCheckToggle(item, null, true);
				}
			}
		},
		_renderSubItems: function (container, localStr, data, groupName) {
			var StringHelper = KL.Utils.StringHelper;
			var localization = KL.Utils.Localization.getInstance();
			var Delegate = KL.Utils.Delegate;
			var itemContainer = container.find("._subitems");
			for (var item in data) {
				if (data.hasOwnProperty(item)) {
					var tpl = "";
					if (typeof (data[item]) == "boolean" || data[item] instanceof Boolean) {
						var item_i = $(StringHelper.formatTemplate(this._extTpl, {
							"Value": groupName + "." + item,
							"Ext": localization.getLocaleString(localStr + item + "Ext"),
							"ExtTxt": localization.getLocaleValueString(localStr + item + "Ext"),
							"Descr": localization.getLocaleString(localStr + item + "Descr"),
							"DescrTxt": StringHelper.htmlEncode(localization.getLocaleValueString(localStr + item + "Descr"))
						})).appendTo(itemContainer);
						item_i.find("input[type=checkbox]").click(Delegate.create(this, this._extensionCheckToggle, container, item_i, false)).attr("checked", data[item]);
					} else {
						var item_i = $(StringHelper.formatTemplate(this._subItemTpl, { "Title": localization.getLocaleString(localStr + item) })).appendTo(itemContainer);
						item_i.find(".threeStateCheckbox").threeStateCheckbox()
							.bind("onchecked", Delegate.create(this, this._toggleAllselect, container, item_i, true))
							.bind("oncheckedpartial", Delegate.create(this, this._extensionCheckToggle, container, item_i, false))
							.bind("oncheckednone", Delegate.create(this, this._toggleAllselect, container, item_i, false));
						this._renderSubItems(item_i, localStr, data[item], groupName + "." + item);
						this._extensionCheckToggle(item_i, null, true);
					}
				}
			}
		},
		_extensionCheckToggle: function (parent, elt, cancelEvent) {
			var checkboxes = parent.find("._subitems input[type=checkbox]");
			var action = "uncheck";
			if (checkboxes.filter(":checked").length != 0)
				action = (checkboxes.length == checkboxes.filter(":checked").length) ? "checkAll" : "checkPartial";
			parent.find(".threeStateCheckbox").threeStateCheckbox(action, cancelEvent);
		},
		_toggleAllselect: function (parent, elt, isChecked) {
			elt.find("._subitems .threeStateCheckbox").each(function () { $(this).threeStateCheckbox(isChecked ? "checkAll" : "uncheck"); });
			elt.find("input[type=checkbox]").attr("checked", isChecked);
			if (parent != null)
				this._extensionCheckToggle(parent, elt, true);
		},
		_toggleExpanded: function (target, e) {
			e.stopPropagation();
			var iscollapsed = !target.data("iscollapsed");
			target.find("dd").toggle(!iscollapsed);
			target.find(".filesTypesGroupTitle").toggleClass("expanded", !iscollapsed);
			target.data("iscollapsed", iscollapsed);
		},
		setValue: function (e, dataObj) {
			if (dataObj && dataObj.data) {
				this._data = dataObj;
				this._bindData(dataObj.data);
			}
		},
		_submitHandler: function (e) {
			if (e)
				e.preventDefault();
			if (this._data && this._data.data) {
				this._listContainer.find(".extension input[type=checkbox]").each(KL.Utils.Delegate.create(this, function (indx, item) {
					var chB = $(item);
					KL.Utils.ObjectHelper.setObjValueByPath(this._data.data, chB.val(), chB.is(":checked"));
				}));
				$(this._data).trigger("ondatacheange");
			}
		},
		onBeforeHide: function () {
			this._submitHandler();
		},
		_triggerClose: function () {
			$(this).trigger("onformclose");
		}
	};
	KL.LMS.Groups.registerClass("FilesTypesSelectForm", FilesTypesSelectForm);
	FilesTypesSelectForm.extend( KL.Web.Controls.Control );
})()
;
(function () {
	var PriorityEditor = function (id, setting) {
		PriorityEditor._super.call( this, id, setting );
	};
	PriorityEditor.prototype = {
		_data: null,
		_passeddata: null,
		onInitInteraction: function () {
			var elt = this.getElt();
			if (elt) {
				elt.find("form").submit(KL.Utils.Delegate.create(this, this._submit));
				elt.find(".btnCancel").click(KL.Utils.Delegate.create(this, this._triggerCancel));
				elt.find(".priorityField").keyup(KL.Utils.Delegate.create(this, this._initField));
				elt.find(".clearBtn").click(KL.Utils.Delegate.create(this, this._clearField));
				this._passeddata = null;
			}
		},
		_initField: function () {
			var elt = this.getElt();
			if (elt)
				elt.find(".priorityField").parent().removeClass("error");
		},
		_clearField: function () {
			var elt = this.getElt();
			if (elt)
				elt.find(".priorityField").val("").focus();
			return false;
		},
		setValue: function (e, dataObj) {
			var elt = this.getElt();
			this._data = [];
			if (elt && dataObj) {
				var groupData = dataObj.data;
				this._passeddata = dataObj;
				var names = [];
				var priority = -1;
				for (var prop in groupData) {
					if (groupData.hasOwnProperty(prop)) {
						names.push(groupData[prop].name);
						priority = priority < 0 ? groupData[prop].priority : priority;
						this._data.push(prop);
					}
				}
				elt.find(".groupNameLabel").empty().
					append(KL.Utils.Localization.getInstance().getLocaleStringObj(
						"LabelDialogPriorityChangeFieldName",
						KL.Utils.StringHelper.wordBreak(names.join(",<br/>"), 10)
					));
				elt.find(".priorityField").val(priority);
			}
		},
		_submit: function (e) {
			if (e) {
				e.stopPropagation();
				e.preventDefault();
			}
			var elt = this.getElt();
			if (elt && this._data) {
				var field = elt.find(".priorityField");
				field.parent().removeClass("error");
				var val = field.val();
				var num = val.replace(/[\.]/g, ",");
				if (num === null || isNaN(num) || isNaN(num * 1) || (num*1)<=0) {
					field.focus().parent().addClass("error");
					return;
				}
				if (this._passeddata)
					$(this._passeddata).trigger("onok");
				this._passeddata = null;
				$(this).trigger("onsubmit", [{ id: this._data.join(","), priority: val}]);
			}
		},
		_triggerCancel: function () {
			if (this._passeddata)
				$(this._passeddata).trigger("oncancel");
			this._passeddata = null;
			$(this).trigger("oncancel");
		}
	};
	KL.LMS.Groups.registerClass("PriorityEditor", PriorityEditor);
	PriorityEditor.extend(KL.Web.Controls.Control);
})()
;
(function(){
	function AttachSourceEditor(id, setting) {
		AttachSourceEditor._super.call(this, id, setting);
	}
	AttachSourceEditor.prototype = {
		onInitInteraction: function () {
			var elt = this.getElt();
			if (elt)
				elt.find("[name=donotattachval]").on("click", KL.Utils.Delegate.create( this, this._valueChanged ));
		},
		setValue: function (e, extra, target, title, isRightAligned, dataObj) {
			var elt = this.getElt();
			if (elt)
				elt.find("[name=donotattachval]").val( [!!dataObj["0"]?1:0] );
		},
		_valueChanged: function (e, val) {
			var elt = this.getElt();
			if (elt) {
				elt.find(".donotattachval").val(elt.find("[name=donotattachval]:checked").val() == "1");
			}
		}
	};
	KL.LMS.Groups.registerClass("AttachSourceEditor", AttachSourceEditor);
	AttachSourceEditor.extend( KL.Web.Controls.Control );
})()
;
;
KL.LMS.registerNS("Backup");
(function () {
	var BackupGrid = function (id, setting) {
		BackupGrid._super.call(this, id, setting);
	};
	BackupGrid.prototype = {
		_currCount: 0,
		pageSize: 10,
		letterId: 0,
		_currentIndex: -1,
		_localeStrs: null,
		isActionFromPanel: false,
		deliverMail: null,
		cellHeight: 30,
		indexToDeliver: 0,
		lettersToDeliver: [],
		failedToDeliver: [],
		setValuePartial: function (val) {
			var curVal = this._data;
			if (!curVal || !val || !val.items || !curVal.items || this._currCount == 0) {
				this._currCount = 0;
				this.pageNum = 0;
				KL.Utils.Log.write("BackupGrid.setValuePartial: no current value");
				curVal = val;
			} else if (val.items) {
				KL.Utils.Log.write("BackupGrid.setValuePartial: There's a current value. " + this._currCount + " already rendered");
				curVal.items = curVal.items.concat(val.items);
				curVal.pageSize = val.pageSize;
				curVal.page = val.page;
			}
			if (curVal) {
				if (curVal["items"] != null) {
					curVal.count = curVal.items.length;
				}
				else {
					curVal.count = 0;
				} //val.total||curVal.total;
				curVal.page = this.pageNum;
				curVal.pageSize = this.pageSize;
				this._setValue(curVal);
			}
		},
		applyValue: function (evt, val, isLoadComplete) {
			this.hideError();
			this.setValuePartial( val );
		},
		onGridInit: function (elt) {
			elt.find(".helpLink").click(KL.Utils.Delegate.create(this, this._openHelp));
			elt.find(".closeInfoBtn").click(KL.Utils.Delegate.create(this, this._hideInfo));
		},
		getKeyDataFromIdField: function (data) {
			return data["letterId"] + "_" + data["group"]["groupId"];
		},
		setValue: function (val) {
			this.setValuePartial(val);
		},
		_setValue: function (val) {
			if (this._setting)
				this._setting.applyData(null,val,true);
		},
		setPageNum: function (e, pageNum) {
			var maxPage = 0;
			if (this._data) {
				maxPage = Math.ceil(this._data.count / this.pageSize)-1;
				if (pageNum == 0)
					this.pageNum = 0;
				else if (pageNum == 1)
					this.pageNum--;
				else if (pageNum == 2)
					this.pageNum++;
				else
					this.pageNum = maxPage;
				this.pageNum = this.pageNum < 0 ? 0 : (this.pageNum > maxPage ? maxPage : this.pageNum);
				this._data.page = this.pageNum;
				this._data.pageSize = this.pageSize;
				this._currCount = 0;
				this._setValue(this._data);
			}
		},
		onRowEnter: function (row, e) {
			var rowData = row.data("itemData");
			var rowId = this.getKeyDataFromIdField(rowData); //rowData[this.idField];
			this.selectedItems = {};
			this.selectedItems[rowId] = rowData;
			this._toggleRowSelection(row,true);
			this._fireRowSelectionEvt();
		},
		
		applyFilter: function (e, data) {
			this.filterValue = data;
			this._currCount = 0;
			this._data = null;
			this._listContainer.empty();
			$(this).trigger("onfilterchange", [data]);
		},
		onShown: function () {
			this.filterValue = "";
			this.initFilter();
			this.isSetPageSize = false;
			var elt = this.getElt();
			if (elt)
				elt.find(".notificationArea").hide();
		},
		initFilter: function () {
			var DayRanges = KL.LMS.Enums.DayRanges;
			var data = {};
			var from = KL.Utils.DateHelper.getServerTime();
			if (this.filterValue == "") {
				from.setHours(from.getHours() - 1);
				data.dateType = DayRanges.LastHour;
				data["filterSearchReceivingTime.greater.equal"] = Math.round(from.getTime() / 1000);
				this.filterValue = data;
			}
			else {
				switch (this.filterValue.dateType) {
					case DayRanges.LastDay:
						from.setDate(from.getDate() - 1);
						break;
					case DayRanges.LastHour:
						from.setHours(from.getHours() - 1);
						break;
					case DayRanges.LastWeek:
						from.setDate(from.getDate() - 7);
						break;
					case DayRanges.Last2Weeks:
						from.setDate(from.getDate() - 14);
						break;
					case DayRanges.LastMonth:
						from.setMonth(from.getMonth() - 1);
						break;
					case DayRanges.Last3Months:
						from.setMonth(from.getMonth() - 3);
						break;
					case DayRanges.LastYear:
						from.setFullYear(from.getFullYear() - 1);
						break;
				}
				if (this.filterValue.dateType != DayRanges.UserInterval) {
					this.filterValue["filterSearchReceivingTime.greater.equal"] = Math.round(from.getTime() / 1000);
				}
			}
		},
		onDataBind: function (data) {
			this._localeStrs = {};
			
			var proceed = this.onBeforeDataBind(data);
			if (proceed === false)
				return;
			if (!data || (this._currCount >= this.pageSize)) {
				KL.Utils.Log.write("BackupGrid.onDataBind: no need to render");
			} else {
				var elt = this.getElt();
				if (elt) {
					var footer = elt.find(".gridFooter").empty();
					var total = data.total ? data.total: 0;
					var earliest = data.oldestMessageDate ? data.oldestMessageDate : 0 ;
					if (this.isControlVisible("admin,helpdesk")) {
						footer.append(KL.Utils.Localization.getInstance().getLocaleStringObj("LabelFilterTotalInfo", total));
						if (earliest!=0) {
							var dateStr = KL.Utils.Localization.getInstance().getLocalDateTime( KL.Utils.DateHelper.createDate(earliest));
							footer.append(KL.Utils.Localization.getInstance().getLocaleStringObj("LabelFilterEarliestInfo",dateStr));
							footer.append(dateStr);
						}
					}	
				}
				if (data.items) {
					if (this._currCount == 0) {
						this._listContainer.empty();
						this._removeSelection();
						this._data = data;
						KL.Utils.Log.write("BackupGrid.onDataBind: page #" + this.pageNum + " first render");
					}
					
					
					var from = (this.pageSize * this.pageNum) + this._currCount;
					var to = this.getGridLength(from);
					for (var i = from; i < to; i++) {
						var proceed_i = this.itemDataBind(data.items[i], i);
						if (proceed_i !== false) {
							var row = $(this._template.bindData(data.items[i]))
							.appendTo(this._listContainer)
							.addClass((i % 2 ? "oddItem" : "evenItem"))
							.mouseover(function () { $(this).addClass("itemOver"); })
							.mouseout(function () { $(this).removeClass("itemOver"); })
							.data("itemData", data.items[i]);
							this.itemDataBound(row, data.items[i]);
							if (this.initPageSize(row,i-from)) {
								$(this).trigger("onsetpagesize", [this._data]);
								break;
							}	
						}
					}
				}
			}
			this.dataBound(data);
			if (!KL.Utils.UserHelper.isPriveleged()) {
				var cell = this.getElt().find(".receiversCell");
				cell.addClass("receiversCellNone");
				cell.removeClass("receiversCell");
				
			}
		},
		dataBound: function (data) {
			var Delegate = KL.Utils.Delegate;
			this._listContainer.find(".gridRow").each(Delegate.create(this, this._initRowInteractions));
			this._fireRowSelectionEvt();
			if (typeof (this.gridDataBound) == "function")
				this.gridDataBound(data);
			$(this).trigger("ondatabound", [this._data]);
		},
		gridDataBound: function () {
			var elt = this.getElt();
			if (elt) {
			KL.Utils.DateHelper.applyLocaleDates(this.id, elt);
				if (this._localeStrs) {
					for (var str in this._localeStrs)
						elt.find("#" + str).replaceWith(this._localeStrs[str]);
					this._localeStrs = null;
				}
				if (this._data != null) {
					if (this._data.items.length >= 500) {
						this.setNotificationAreaMessage(500);
						this._showInfo();
					} else
						this._hideInfo();
					if (this._data.items.length == 0) {
						this.setNotificationAreaMessage(0);
						this._showInfo();
					}
				}
				else {
					this.setNotificationAreaMessage(0);
					this._showInfo();
				}
			}
		},
		
		setNotificationAreaMessage: function (val, text) {
			var elt = this.getElt();
			if (elt) {
				var localization = KL.Utils.Localization.getInstance();
				if( val === null && text ){
					if( localization.stringExists( text ) )
						text = localization.getLocaleString( text );
				}else if (val==0)
					text = localization.getLocaleString("LabelInfoLastNotDataShown");
				else
					text = localization.getLocaleString("LabelInfoLast500Shown");
				elt.find(".notificationAreaMessage").html(text);
				
			}
		},
		
		_hideInfo: function () {
			var elt = this.getElt();
			if (elt) {
				elt.find(".gridContent").animate({ top: 39 });
				elt.find(".notificationArea").slideUp(400);
			}
			return false;
		},
		_showInfo: function (text) {
			var elt = this.getElt();
			if (elt) {
				if( text )
					this.setNotificationAreaMessage(null, text);
				elt.find(".gridContent").animate({ top: 77 },  function(){
					elt.find(".notificationArea").slideDown(400);
				} );
			}
		},
		_openHelp: function () {
			$(this).trigger("oncontexthelp");
		},
		setActionFromPanel: function () {
			this.isActionFromPanel = true;
		},
		deleteRows: function () {
			var Delegate = KL.Utils.Delegate,
				localization = KL.Utils.Localization.getInstance(),
				selectedCount = this.getSelectedCount(),
				dialogResult = this._page.getApplication().openConfirm(
					localization.makeLocaleStringObj(this.id, selectedCount > 1 ? "LabelDeleteMessagesConfirm" : "LabelDeleteMessageConfirm", selectedCount),
					localization.getLocaleString("LabelTitleDeleteMessages"),
					{ "ok": "BtnDelete", "cancel": "BtnCancel" }
				);
			$(dialogResult).bind("onok", Delegate.create(this, this._deleteSelected));
			$(dialogResult).bind("oncancel", Delegate.create(this, this.resetActionFromPanel));
			localization.applyStingObjs(this.id, dialogResult.elt);
		},
		getMailAdressDeliver: function () {
			if (KL.Utils.UserHelper.isAdmin()) {
				var dlgResult = {};
				dlgResult.isHeadersMailsEmpty = this.isHeadersMailsEmpty();
				$(dlgResult).bind("ondataready", KL.Utils.Delegate.create(this, this._setDeliveryRecievers));
				$(this).trigger("ongetrecievers", dlgResult);
			}
			else
				$(this).trigger("ondeliverletter");
		},
		isHeadersMailsEmpty: function(){
			var index = this.getSeletedRowsId();
			for (var i = 0, l = this._data.items.length, lj = index.length; i < l; i++) {
				var _item = this._data.items[i],
					_group = _item.group;
				var key = _item.letterId + "_" + _group.groupId;
				for (var j = 0; j < lj; j++) {
					if (key == index[j]) {
						return (_group.receiversTo.length === 0 && _group.receiversCc.length === 0 && (_group.receiversBcc.length === 0 || !KL.Utils.UserHelper.isPriveleged()));
					}
				}
			}
			return true;
		},
		_setDeliveryRecievers: function (e, data) {
			var mails = data.items || [];
			this.deliverMail = { mails: mails || [], useHeaders: !!data.useheaders };
			$(this).trigger("ondeliverletter");
		},
		getSelectedLetterInfo: function(){
			var index = this.getSeletedRowsId();
			var _letterInfo = null,
					k = 0;
			for (var i = 0; i < this._data.items.length; i++) {
					var key = this._data.items[i].letterId + "_" + this._data.items[i].group.groupId;
					for (var j = 0; j < index.length; j++) {
						if (key == index[j]) {
							_letterInfo = this._data.items[i];
							break;
						}
					}
			}
			return _letterInfo;
		},
			getSelectedLettersInfo: function(){
				var index = this.getSeletedRowsId();
				var _letterInfo = [],
					k = 0;
				for (var i = 0; i < this._data.items.length; i++) {
					var key = this._data.items[i].letterId + "_" + this._data.items[i].group.groupId;
					for (var j = 0; j < index.length; j++) {
						if (key == index[j])
							_letterInfo.push(this._data.items[i]);
					}
				}
				return _letterInfo;
			},
			startLettersDelivering: function() {
				this._hideInfo();
				this.lettersToDeliver = this.getSelectedLettersInfo();
				if (this.lettersToDeliver.length) {
					this.indexToDeliver = 0;
					$(this).trigger("ontrydeliverletter");
				}
			},
			onLetterDeliverySuccess: function(e) {
				this.deselectRow(this.indexToDeliver, e);
				this.indexToDeliver++;
			},
			tryDeliverNextLetter: function() {
				if (this.indexToDeliver < this.lettersToDeliver.length)
					$(this).trigger("ontrydeliverletter");
				else 
					$(this).trigger("ondeliveringcomplete");
			},
			getDeliverMessage: function () {
				var _letterInfo = this.lettersToDeliver[this.indexToDeliver];
				if(_letterInfo){
					this.deliverMail = this.deliverMail || {};
					var retObj = {
						letterId: _letterInfo.letterId,
						ruleId: _letterInfo.group.groupId,
						deliverToRuleRecepients: !!this.deliverMail.useHeaders,
						items: ([]).concat(this.deliverMail.mails||[])
					};
					return {
						data: KL.Utils.JSON.encode(retObj)
					};
				}
			},
			onDeliveryComplete: function() {
				if (this.failedToDeliver.length == 0)
					this._showInfo( "LabelBackupInfoMesageDelivered" );
				this.indexToDeliver = 0;
				this.lettersToDeliver = [];
				this.failedToDeliver = [];
			},
			onLetterDeliveryFail: function(e, data) {
				var failedIndex = this.indexToDeliver;
				this.failedToDeliver.push(failedIndex);
				this.indexToDeliver = 0;
				this.lettersToDeliver = [];
				this.applyError(e, data);
			},
			deselectRow: function(selectedIndx, e) {
				var elt = this.getElt();
				if (elt) {
					this._listContainer.find(".item").each(KL.Utils.Delegate.create(this, function (indx, item) {
						var $item  = $(item);
						var rowData = $item.data("itemData");
						var rowId = this.getKeyDataFromIdField(rowData);
						if (rowData.letterId == this.lettersToDeliver[selectedIndx].letterId)
							this.toggleRow($item, e);
					}));
				}
			},
		getSaveMessage: function () {
			var _letterInfo = this.getSelectedLetterInfo(),
				_letterId = "",
				_fileName = KL.Utils.Localization.getInstance().getLocaleValueString("defaultSaveFileName");
			if(_letterInfo){
				_letterId = _letterInfo.letterId;
				_fileName = _letterInfo.subject || _fileName;
				_fileName = KL.Utils.StringHelper.checkFileName(_fileName)? _fileName :	KL.Utils.Localization.getInstance().getLocaleValueString("defaultSaveFileName")+"_"+_letterId;
			}
			var retObj = {
				letterId: _letterId,
				ruleId: _letterInfo.group.groupId,
				fileName: _fileName+".eml",
				saveBcc: false
			};
			var _data = {
				data: KL.Utils.JSON.encode(retObj)
			};
			return _data;
		},
		_deleteSelected: function () {
			var data = [];
			var index = this.getSeletedRowsId();
			for (var itemId in index)//this.selectedItems)
				data.push(itemId);
			$(this).trigger("onrowsdelete", [this.idField, data]);
		},
		resetActionFromPanel: function () {
			this.isActionFromPanel = false;
		},
		itemDataBind: function (itemData, indx) {
			if (itemData == null) return;
			try {
				if (itemData.sender) {
					itemData.Sender_ = itemData.sender.email;
					itemData.Sender_ = KL.Utils.StringHelper.cropString(itemData.Sender_, 20);
					itemData.SenderTitle_ ="";
					if (KL.Utils.StringHelper._isCropString(itemData.Sender_))
						itemData.SenderTitle_ = KL.Utils.StringHelper.htmlEncode(itemData.sender.email);
				}
				itemData.Recipient_ = "";
				itemData.RecipientTitle_ = "";
				var isBlackListed = false,
					str = [],
					recievers = (itemData.group.receiversTo || []).concat( itemData.group.receiversCc || [] );
				if (true || !!KL.Utils.UserHelper.isPriveleged())
					recievers = recievers.concat( itemData.group.receiversBcc || [] );
				
				for (var i = 0; i < recievers.length; i++){
					str.push(recievers[i].email);
					isBlackListed = isBlackListed || (recievers[i].personalStatus == KL.LMS.Enums.PersonalStatus.BlackList);
				}
				
				if (KL.Utils.UserHelper.isPriveleged()) {
					itemData.Recipient_ = KL.Utils.StringHelper.cropString(str.join("; "), 20);
					if (KL.Utils.StringHelper._isCropString(itemData.Recipient_))
						itemData.RecipientTitle_ = KL.Utils.StringHelper.htmlEncode(str.join("; "));
				}
				itemData.VerdictText = ([
						this._getAsIcon(itemData.group.asStatus),
						this._getAvIcon(itemData.group.avStatus),
						this._getCfIcon(itemData.group.cfStatus),
						this._getApIcon(itemData.group.apStatus),
						this._getBlIcon(isBlackListed)
					]).join("");
				itemData.Theme_ = KL.Utils.StringHelper.htmlEncode(itemData.subject);
				itemData.Theme_ = KL.Utils.StringHelper.cropString(itemData.Theme_, 40);
				itemData.ThemeTitle_ ="";
				if (KL.Utils.StringHelper._isCropString(itemData.Theme_))
					itemData.ThemeTitle_ = KL.Utils.StringHelper.htmlEncode(itemData.subject);
				var sizeId = "groupsGridRow" + indx + "_mailsize";
				this._localeStrs[sizeId] = KL.LMS.Helpers.CommonHelper.localSizeObj(itemData.size,0);
				var k = "<span id='" + sizeId + "'></span>";
				itemData.Size_ = k;
				itemData.SizeClass = (itemData.attachments.length > 0 ? "withAttachment" : "noAttachment");
			} catch (e) { //alert(e);
			}
			try {
				itemData.RecevingTime_ = KL.Utils.DateHelper.getLocaleDate(this.id, itemData.receivingTime,"ResDateTimeFormatStorage");
			}
			catch (e) {
				itemData.RecevingTime_ = itemData.receivingTime;
			}
			this._currCount++;
		},
		
		_getAsIcon: function(state) {
			switch (state){
				case KL.LMS.Enums.AsStatus.Error:
				case KL.LMS.Enums.AsStatus.ProbableSpam:
				case KL.LMS.Enums.AsStatus.Blacklisted:
				case KL.LMS.Enums.AsStatus.Spam:
				case KL.LMS.Enums.AsStatus.MassMail:
					return '<span class="verdictStatus statusSpam">&nbsp;</span>';
				default:
					return '<span class="verdictStatus statusClean">&nbsp;</span>';
			}
		},		
		_getAvIcon: function(state) {
			switch (state){
				case KL.LMS.Enums.AvStatus.Encrypted:
				case KL.LMS.Enums.AvStatus.Corrupted:
				case KL.LMS.Enums.AvStatus.Suspicious:
				case KL.LMS.Enums.AvStatus.Infected:
				case KL.LMS.Enums.AvStatus.IntrusionThreat:
					return '<span class="verdictStatus statusVirus">&nbsp;</span>';
				default:
					return '<span class="verdictStatus statusClean">&nbsp;</span>';
			}
		},		
		_getCfIcon: function(state) {
			if (state)
				for (var i=0;i<state.length;i++) {
					switch (state[i]){
						case KL.LMS.Enums.CfStatus.SizeExceeded:
						case KL.LMS.Enums.CfStatus.BannedFileName:
						case KL.LMS.Enums.CfStatus.BannedFileFormat:
							return '<span class="verdictStatus statusContent">&nbsp;</span>';
					}
				}
			return '<span class="verdictStatus statusClean">&nbsp;</span>';
		},
		_getApIcon: function( state ){
			switch (state){
				case KL.LMS.Enums.ApStatus.Error:
				case KL.LMS.Enums.ApStatus.Phishing:
				case KL.LMS.Enums.ApStatus.Malicious:
					return '<span class="verdictStatus statusPhishing">&nbsp;</span>';
				default:
					return '<span class="verdictStatus statusClean">&nbsp;</span>';
			}
		},
		_getBlIcon: function( isBlackListed ){
			return isBlackListed? '<span class="verdictStatus statusBlacklist">&nbsp;</span>' : '<span class="verdictStatus statusClean">&nbsp;</span>';
		},
		
		onHidden: function () {
			this._currCount = 0;
			this._data = null;
			if (this._listContainer)
				this._listContainer.empty();
		},
		initCurrentIndex: function () {
			this._currentIndex = -1;
		},
		changeCurrentIndex: function (e, step) {
			this._currentIndex += step;
			if (this._currentIndex < 0) this._currentIndex = 0;
			if (this._currentIndex >= this._data.items.length) this._currentIndex = this._data.items.length - 1;
		},
		
		
		getDataItem: function () {
			if (this.isActionFromPanel && this._currentIndex < 0)
				$(this).trigger("onclosepanel");
			else {
				if (this._currentIndex < 0)
					this._currentIndex = this.getCurrentIndex();
				$(this).trigger("ongetdata", [this._data.items[this._currentIndex]]);
				$(this).trigger("oncheangeindex", [this._currentIndex, this._data.items.length]);
			}
		},
		resetData: function () {
			this._data = null;
			this._currCount = 0;
			this.pageNum = 0;
			if (this._listContainer)
				this._listContainer.empty();			
		},
		applyDeletedData: function (e,data,_isfinish) {
			if (!_isfinish) return;
			var index = this.getSeletedRowsId();
			var result = [];
			for (var i = 0; i < this._data.items.length; i++) {
				var key = this._data.items[i].letterId + "_" + this._data.items[i].group.groupId;
				var f = false
				for (var j = 0; j < index.length; j++)
					if (key == index[j]) {
						f = true;
						break;
					}
				if (!f) result.push(this._data.items[i]);
			}
			this._data.items = result;
			var tt = this._data;
			this._data = null;
			this.setValuePartial(tt);
			var elt = this.getElt();
			if (elt) {
				var footer = elt.find(".gridFooter").empty();
				var total = data.total ? data.total: 0;
				if (this.isControlVisible("admin,helpdesk")) footer.append(KL.Utils.Localization.getInstance().getLocaleStringObj("LabelFilterTotalInfo", total));
			}
			this._showInfo( index.length > 1?"LabelBackupInfoMesagesDeleted":"LabelBackupInfoMesageDeleted" );
			if (this.isActionFromPanel) {
				$(this).trigger("ongetnextdata");
			}
		},
		getSeletedRowsId: function () {
			var data = [];
			
			if (this.isActionFromPanel) {
				var i = this._currentIndex;
				data[0] = this._data.items[i].letterId + "_" + this._data.items[i].group.groupId;
			}
			else
				for (var itemId in this.selectedItems)
					data.push(itemId);
			return data;
		},
		getSelectedMessage: function () {
			var index = this.getSeletedRowsId();
			var result = [];
			var items = {};
			var k = 0;
			for (var i = 0; i < this._data.items.length; i++) {
				var key = this._data.items[i].letterId + "_" + this._data.items[i].group.groupId;
				for (var j = 0; j < index.length; j++)
					if (key == index[j]) {
						result.push({
							"letterId": this._data.items[i].letterId,
							"groupId": this._data.items[i].group.groupId
						});
					}
			}
			items = { "items": result };
			var retObj = {
				data: KL.Utils.JSON.encode(items)
			};
			return retObj;
		},
		applyError: function (evt, err) {
			var errTxt = "";
			var errMsg = KL.Utils.Exception.getExceptionText(err.id) || err.message;
			var localization = KL.Utils.Localization.getInstance();
			var msgRes = this._page.getApplication().showMessage(errTxt || errMsg, "LabelTitleDeliverMessageError", "BtnClose", 300, KL.Web.MessageDialog.MessageType.Error);
			
		},
		getCurrentIndex: function () {
			var index = this.getSeletedRowsId();
			for (var i = 0; i < this._data.items.length; i++) {
				var key = this._data.items[i].letterId + "_" + this._data.items[i].group.groupId;
				if (key == index[0])
					return i;
			}
			return -1;
		}
	};
	KL.LMS.Backup.registerClass("BackupGrid", BackupGrid);
	BackupGrid.extend(KL.Web.Controls.GridViewControl);
})()
;
(function () {
	var VerdictExecutor = {
		"Any": "",
		"Spam": "AS",
		"Virus": "AV",
		"Content": "CF",
        "Phishing": "AP",
        "FailedToBackup": "XZ",
        "Blacklist": "BL"
	};
	function MessagePanel(id, initValue) {
		MessagePanel._super.call( this, id, initValue );
	}
	MessagePanel.prototype = {
		
		onInitInteraction: function () {
			var elt = this.getElt();
			if (elt && this.titletext) {
				if (KL.Utils.Localization.getInstance().stringExists(this.titletext))
					this.titletext = KL.Utils.Localization.getInstance().getLocaleString(this.titletext);
				elt.find(">.pnlTitle")
					.find(".titleText").html(this.titletext);
			}
		},
		
		setDateTime: function(valTime){
			try {
				return KL.Utils.Localization.getInstance().getLocalDateTime( KL.Utils.DateHelper.createDate(valTime)) ;
			}
			catch (e) {
				return valTime;
			}
		},
		
		setDataItem: function(e,itemData){
			try {
				var elt = this.getElt(),
					localization = KL.Utils.Localization.getInstance(),
					StringHelper = KL.Utils.StringHelper;
				if (elt) {
					elt.find(".letterId").text(itemData.letterId);
					var verdictText = KL.LMS.Enums.Verdicts.getKeyByValue(itemData.group.backupReason),
						verdictIcon = "<span class=\"verdictStatus status"+verdictText+"\">" +
							localization.getLocaleString("LabelVerdicts" + verdictText) +
							"</span>" +
							localization.getLocaleString("LabelStorageMessageBackuper_" + VerdictExecutor[verdictText]),
						receivers = (itemData.group.receiversTo || []).concat( itemData.group.receiversCc || [] ).concat(itemData.group.receiversBcc||[]);
					elt.find(".storageVerdict").html(verdictIcon);
			
					elt.find(".storageMessageSubject")
						.text(itemData.subject)
						.attr("title", itemData.subject);
					
					if (!KL.Utils.UserHelper.isAdmin()) {
						elt.find(".storageMessageRule").parent().hide();
					} else {
						if (itemData.group.name) {
							var str = StringHelper.cropString(StringHelper.htmlEncode(itemData.group.name),50);
							elt.find(".storageMessageRule").html(str);
							if (StringHelper._isCropString(str))
								elt.find(".storageMessageRule").attr("title",StringHelper.htmlEncode(itemData.group.name));
						}
						else
							elt.find(".storageMessageRule").html("----");
					}
					elt.find(".storageMessageSender").html("&lt;"+itemData.sender.email+"&gt;").attr("title", itemData.sender.email);
			
					elt.find(".storageMessageReceiver").html(this.showReceiverXXX(itemData.group.receiversTo));
					elt.find(".storageMessageReceiverCC").html(this.showReceiverXXX(itemData.group.receiversCc));
					
					if (!KL.Utils.UserHelper.isPriveleged()){
						elt.find(".storageMessageReceiverBCC, .smtpMessageID").parent().hide();
					} else {
						elt.find(".storageMessageReceiverBCC").html(this.showReceiverXXX(itemData.group.receiversBcc));
						elt.find(".smtpMessageID").empty().text(itemData.smtpMessageId).attr("title", StringHelper.htmlEncode(itemData.smtpMessageId));
					}
					
					this.fillBWlisters( elt.find(".storageMessageBlacklistRow"), elt.find(".storageMessageWhitelistRow"), receivers );
					elt.find(".storageMessageBackupToTime").empty().append(this.setDateTime(itemData.receivingTime));
					
					elt.find(".storageMessageSize").html(this.showSize(itemData.size));
					elt.find(".storageMessageSendingTime").empty().append(this.setDateTime(itemData.sendingTime));
					elt.find(".storageMessageReceivingTime").empty().append(this.setDateTime(itemData.receivingTime));
					elt.find(".storageMessageAttachment").html(this.showAttachment(itemData.attachments));
					
					elt.find(".storageMessageASVerdict").html(this.showASState(itemData.group.asStatus));
					elt.find(".storageMessageAVVerdict").html(this.showAVState(itemData.group.avStatus));
					elt.find(".storageMessageCFVerdict").html(this.showCFState(itemData.group.cfStatus));
					elt.find(".storageMessageAPVerdict").html(this.showAPState(itemData.group.apStatus));
					
					elt.find(".storageMessageViruses").html(this.showViruses(itemData.group.viruses));
					elt.find(".storageMessageAVBaseDate, .storageMessageASBaseDate").empty().parent().hide();
					if (KL.Utils.UserHelper.isAdmin()) {
						if( KL.LMS.Enums.AsStatus.Formal < itemData.group.avStatus )
							elt.find(".storageMessageAVBaseDate").append(this.setDateTime(itemData.group.avBasesDate)).parent().show();
						if( KL.LMS.Enums.AsStatus.Formal < itemData.group.asStatus )
							elt.find(".storageMessageASBaseDate").append(this.setDateTime(itemData.group.asBasesDate)).parent().show();
					}
					localization.applyStingObjs(this.id, elt);
				}
			}catch(e1){
				KL.Utils.Log.write(this + "["+this.id+"].setDataItem: Error setting data: " + e1.message, KL.Utils.Log.type.WARNING);
			}
			
		},
		
		fillBWlisters: function( rowBl, rowWl, receivers ){
			var bls = [],
				wls = [],
				statusBl = KL.LMS.Enums.PersonalStatus.BlackList,
				statusWl = KL.LMS.Enums.PersonalStatus.WhiteList;
				
			for( var i=0, l=receivers.length; i<l; i++ ){
				if( receivers[i].personalStatus == statusBl )
					bls.push(receivers[i].email);
				else if( receivers[i].personalStatus == statusWl )
					wls.push(receivers[i].email);
			}
			rowBl[bls.length>0?"show":"hide"]().find( ".storageMessageParameter" ).html(bls.join("<br>"));
			rowWl[wls.length>0?"show":"hide"]().find( ".storageMessageParameter" ).html(wls.join("<br>"));
		},
		showReceiverXXX: function(receiverXXX){
			if (receiverXXX.length==0)
				return "<span class=\"storageMessageGrey\">"+KL.Utils.Localization.getInstance().getLocaleString("LabelSettingListNotSet")+"</span>";
			
			var result = [];
			for(var i=0;i<receiverXXX.length;i++)
				result.push("<span title='"+ KL.Utils.StringHelper.htmlEncode(receiverXXX[i].email) +"'>&lt;"+receiverXXX[i].email+"&gt;</span>");
			return result.join("; ");
		},
			
		showAttachment: function(attachments){
			if (attachments.length==0) return "<span class=\"storageMessageGrey\">"+KL.Utils.Localization.getInstance().getLocaleString("LabelSettingListNotSet")+"</span>";
			var StringHelper = KL.Utils.StringHelper;
				result = [];//attachments[0].name+" ("+this.showSize(attachments[0].size)+")";
				for(var i=0;i<attachments.length;i++){
					var itemText = StringHelper.htmlEncode(StringHelper.cropString(attachments[i].name, 50))+" ("+this.showSize(attachments[i].size)+")";
					result.push("<span title='"+StringHelper.htmlEncode(attachments[i].name)+"'>"+itemText+"</span>");
				}
			return result.join(",<br/>");
		},
			
		showViruses: function(viruses){
			var result = ["<span class=\"storageMessageGrey\">"+KL.Utils.Localization.getInstance().getLocaleString("LabelSettingListNotSet")+"</span>"];
			if (viruses.length>0){
				result = [];
				for(var i=0;i<viruses.length;i++){
					var itemText = viruses[i];
					result.push("<span title='"+KL.Utils.StringHelper.htmlEncode(itemText)+"'>"+itemText+"</span>");
				}
			}
			return result.join(",<br>");
		},
		
		showASState: function(state){
			var AsStatus = KL.LMS.Enums.AsStatus,
				key = AsStatus.getKeyByValue(state) || AsStatus.getKeyByValue(AsStatus.None),
				result = KL.Utils.Localization.getInstance().getLocaleString("LabelStorageMessageState_" + key),
				resStr = "<span class=\"storageMessageRed\">"+result+"</span>";
			
			if(!!({"Clean": 1, "Formal": 1, "Trusted": 1})[key] )
				resStr = "<span class=\"storageMessageGreen\">"+result+"</span>";
			else if(!!({"NotScanned": 1, "NotAvailable": 1})[key] )
				resStr = "<span class=\"storageMessageGrey\">"+result+"</span>";
			
			return  resStr;
		},
		showAVState: function(state){
			var AvStatus = KL.LMS.Enums.AvStatus;
			var key = AvStatus.getKeyByValue(state) || AvStatus.getKeyByValue(AvStatus.None);
			result = KL.Utils.Localization.getInstance().getLocaleString("LabelStorageMessageState_" + key);
			
			var resStr = "<span class=\"storageMessageRed\">"+result+"</span>";
			if (state == AvStatus.Clean)
				resStr = "<span class=\"storageMessageGreen\">"+result+"</span>";
			else if(state == AvStatus.NotScanned || state == AvStatus.NotAvailable )
				resStr = "<span class=\"storageMessageGrey\">"+result+"</span>";
			return  resStr;
		},
		showCFState: function(state){
			var CfStatus = KL.LMS.Enums.CfStatus;
			var result="";
			if (state && state != CfStatus.NotScanned){
				for(var i=0;i<state.length;i++) {
					var key = CfStatus.getKeyByValue(state[i]) || CfStatus.getKeyByValue(CfStatus.None);
					str = KL.Utils.Localization.getInstance().getLocaleString("LabelStorageMessageState_" + key);
					if (state[i] == CfStatus.Clean)
						str = "<span class=\"storageMessageGreen\">"+str+"</span>";
					else
						str = "<span class=\"storageMessageRed\">"+str+"</span><br>";
					result+=str;
				}
			}
			else result = "<span class=\"storageMessageGrey\">"
						+KL.Utils.Localization.getInstance().getLocaleString("LabelStorageMessageState_NotScanned")
						+"</span>&nbsp;"
			return result;
		},
		showAPState: function(state){
			var ApStatus = KL.LMS.Enums.ApStatus;
			var key = ApStatus.getKeyByValue(state) || ApStatus.getKeyByValue(ApStatus.None);
			result = KL.Utils.Localization.getInstance().getLocaleString("LabelStorageMessageState_" + key);
			var resStr = "<span class=\"storageMessageRed\">"+result+"</span>";
			if (state == ApStatus.Clean)
				resStr = "<span class=\"storageMessageGreen\">"+result+"</span>";
			else if(state == ApStatus.NotScanned || state == ApStatus.NotAvailable )
				resStr = "<span class=\"storageMessageGrey\">"+result+"</span>";
			return  resStr;
		},
		showStatuses: function(){
			if (viruses.length==0)
				return "<span class=\"storageMessageGrey\">"+KL.Utils.Localization.getInstance().getLocaleString("LabelSettingListNotSet")+"</span>";
			var result = viruses[0];
			if (viruses.length>1)
				for(var i=1;i<viruses.length;i++)
					result = result+"; "+viruses[i].name;
			return result;
		},
		
		showSize: function(size){
			return KL.LMS.Helpers.CommonHelper.getSizeInMB( size, this.id );
		}
	};
	KL.LMS.Backup.registerClass("MessagePanel", MessagePanel);
	MessagePanel.extend(KL.Web.Controls.Panel);
})()
;
(function () {
	var FilterInfo = function (id, setting) {
		FilterInfo._super.call( this, id, setting );
	};
	FilterInfo.prototype = {
		_data: null,
		onInitInteraction: function () {
			var elt = this.getElt();
			if (elt) {
				elt.find(".infoText").delegate("a", "click", KL.Utils.Delegate.create(this, this._openFilterForm));
				elt.find(".refreshBtn").click(KL.Utils.Delegate.create(this, this._triggerRefresh));
				elt.find(".totalText").css("display","none");
			}
			this.applyFilterData();
		},
		_addTitleCropString: function(elt,key,str,cropStr){
			if (cropStr.lastIndexOf("...")==cropStr.length-3) 
				elt.find(".tpl-local-"+key).attr("title",KL.Utils.StringHelper.htmlEncode(str));
		},
		_isCropString: function(value,cropStringLength){
			if (!value) return;
				var str = KL.Utils.StringHelper.htmlEncode(value);
				str = KL.Utils.StringHelper.cropString(str, cropStringLength);
			if (str.lastIndexOf("...")==str.length-3) 
				return true;
			return false;		
		},
		
		applyFilterData: function (e, data) {
			var elt = this.getElt();
			if (elt) {
				var localization = KL.Utils.Localization.getInstance();
				elt.find(".infoText").empty();
				if (data) {
					var cropStringValue = 0;
					var letterCount = 50;	
					var DayRanges = KL.LMS.Enums.DayRanges;
					if (data.dateType != DayRanges.UserInterval) {
						var localStr = KL.LMS.Enums.DayRanges.getKeyByValue(data.dateType);
						elt.find(".infoText").append(" <a href='#'>" + localization.getLocaleString("LabelFilterInfo" + localStr + "Letters") + "</a>");
					}
					else {
						letterCount=letterCount-18;
						if (data["filterSearchReceivingTime.greater.equal"]) {
							var d = new Date();
							d.setTime(data["filterSearchReceivingTime.greater.equal"]*1000);
							var date = KL.Utils.DateHelper.getDateTimeObj(d);
							elt.find(".infoText").append(localization.getLocalDateTime(date, "LabelFilterInfoDateFromSubstr"));
						}
						if (data["filterSearchReceivingTime.less.equal"]) {
							var d = new Date();
							d.setTime(data["filterSearchReceivingTime.less.equal"]*1000 );
							var date = KL.Utils.DateHelper.getDateTimeObj(d);
							elt.find(".infoText").append(localization.getLocalDateTime(date, "LabelFilterInfoDateToSubstr"));
						}
					}
		
					
					if (data["filterSearchSizeInput"] || data["filterSearchSizeInput.greater.equal"] || data["filterSearchSizeInput.less.equal"]) letterCount=letterCount-7;
					
					var count = 0;
					if (data["filterSearchSender.like"]) { cropStringValue+=data["filterSearchSender.like"].length;count++}
					if (data["filterSearchReceiver.like"]) { cropStringValue+=data["filterSearchReceiver.like"].length;count++}
					if (data["filterSearchSubject.like"]) { cropStringValue+=data["filterSearchSubject.like"].length;count++}
					
					cropStringLength = (cropStringValue >letterCount ? letterCount: cropStringValue)/count;
					
					if (data["filterSearchSender.like"]) {
						var str = KL.Utils.StringHelper.htmlEncode(data["filterSearchSender.like"]);
						str = KL.Utils.StringHelper.cropString(str, cropStringLength);
						elt.find(".infoText").append(localization.getLocaleStringObj("LabelFilterInfoFromSubstr", str));
						this._addTitleCropString(elt,"LabelFilterInfoFromSubstr",data["filterSearchSender.like"],str);
					}
					else
						elt.find(".infoText").append(localization.getLocaleString("LabelFilterInfoFromSubstrAny"));
					if (data["filterSearchReceiver.like"]) {
						var str = KL.Utils.StringHelper.htmlEncode(data["filterSearchReceiver.like"]);
						str = KL.Utils.StringHelper.cropString(str, cropStringLength);
						elt.find(".infoText").append(localization.getLocaleStringObj("LabelFilterInfoToSubstr", str));
						this._addTitleCropString(elt,"LabelFilterInfoToSubstr",data["filterSearchReceiver.like"],str);
					}
					else
						elt.find(".infoText").append(localization.getLocaleString("LabelFilterInfoToSubstrAny"));
					if (data["filterSearchSubject.like"]) {
						var str = KL.Utils.StringHelper.htmlEncode(data["filterSearchSubject.like"]);
						str = KL.Utils.StringHelper.cropString(str, cropStringLength);
						elt.find(".infoText").append(localization.getLocaleStringObj("LabelFilterInfoSubjSubstr", str));
						this._addTitleCropString(elt,"LabelFilterInfoSubjSubstr",data["filterSearchSubject.like"],str);
					}
					else
						elt.find(".infoText").append(localization.getLocaleString("LabelFilterInfoSubjSubstrAny"));
					if (data["filterSearchSizeInput"]) {
						var size = data["filterSearchSizeInput"] / 1024;
						if (!isNaN(size))
							elt.find(".infoText").append(localization.getLocaleStringObj("LabelFilterInfoEqualSizeSubstr", size));
					} else if (data["filterSearchSizeInput.greater.equal"]) {
						var size = data["filterSearchSizeInput.greater.equal"] / 1024;
						if (!isNaN(size))
							elt.find(".infoText").append(localization.getLocaleStringObj("LabelFilterInfoGreaterEqualSizeSubstr", size));
					} else if (data["filterSearchSizeInput.less.equal"]) {
						var size = data["filterSearchSizeInput.less.equal"] / 1024;
						if (!isNaN(size))
							elt.find(".infoText").append(localization.getLocaleStringObj("LabelFilterInfoLessEqualSizeSubstr", size));
					}
					else
						elt.find(".infoText").append(localization.getLocaleString("LabelFilterInfoEqualSizeSubstrAny"));
				}
				else {
					elt.find(".infoText").html(" <a href='#'>" + KL.Utils.Localization.getInstance().getLocaleString("LabelFilterInfoLastHourLetters") + "</a>");
					elt.find(".infoText").append(localization.getLocaleString("LabelFilterInfoFromSubstrAny"));
					elt.find(".infoText").append(localization.getLocaleString("LabelFilterInfoToSubstrAny"));
					elt.find(".infoText").append(localization.getLocaleString("LabelFilterInfoSubjSubstrAny"));
					elt.find(".infoText").append(localization.getLocaleString("LabelFilterInfoEqualSizeSubstrAny"));
				}
				elt.find(".infoText").prepend(KL.Utils.Localization.getInstance().getLocaleString("LabelFilterInfoShow"))
			}
		},
		showLoading: function () {
			var elt = this.getElt();
			if (elt) {
				elt.find(".refreshFilter").hide();
				elt.find(".loadingFilter").show();
			}
		},
		
		hideLoading: function () {
			var elt = this.getElt();
			if (elt) {
				elt.find(".refreshFilter").show();
				elt.find(".loadingFilter").hide();
			}
		
		},
		
		_openFilterForm: function (e) {
			if (e)
				e.preventDefault();
			$(this).trigger("onfilteropen", [this._data]);
		},
		_triggerRefresh: function (e) {
			if(e)
				e.preventDefault();
			$(this).trigger("onfilterrefresh");
		},
		
		setTotalCount: function(e,count){
			var elt = this.getElt();
			if (elt) {
				elt.find(".totalText").css("display","none");
			}
		}
	};
	KL.LMS.Backup.registerClass("FilterInfo", FilterInfo);
	FilterInfo.extend(KL.Web.Controls.Control);
})();
;
(function () {
	var FilterDialog = function (id, setting) {
		FilterDialog._super.call( this, id, setting );
		this.d_start = new Date();
		this.d_finish = new Date();
	};
	FilterDialog.prototype = {
		_timePart: { Hours: 0, Minutes: 1 },
		_evtTimer: null,
		_data: null,
		d_start: null,
		d_finish: null,
		onFormInit: function () {
			this.d_start.setDate(1);
			this.d_start.setMonth(0);
			this.d_start.setFullYear(2012);
			this.d_finish = KL.Utils.DateHelper.getServerTime();
			var Delegate = KL.Utils.Delegate;
			this.initDropDown('.storageFilterDlgIntervalSelect', KL.LMS.Enums.DayRanges, 'DayRanges', Delegate.create(this, this.onDateRangeChanged));
			this.initDropDown('.storageFilterDlgSizeSelect', KL.LMS.Enums.SizeCriteria, 'SizeCriteria');
			this._form.find(".btnCancel").click(Delegate.create(this, this._cancel));
			var dates = this._form.find(".storageFilterDlgDateFrom input, .storageFilterDlgDateTill input");
			dates.datepicker({
				defaultDate: new Date(),
				changeMonth: true,
				beforeShow:KL.Utils.Delegate.create(this, this._closeError)
			});
			this._form.find(".storageFilterDlgDateFrom input").datepicker("setDate",this.d_finish);
			this._form.find(".storageFilterDlgDateFrom input").datepicker("option","maxDate",this.d_finish);
			this._form.find(".storageFilterDlgDateFrom input").datepicker("option","minDate",this.d_start);
			this._form.find(".storageFilterDlgDateTill input").datepicker("setDate",this.d_finish);
			this._form.find(".storageFilterDlgDateTill input").datepicker("option","maxDate",this.d_finish);
			this._form.find(".storageFilterDlgDateTill input").datepicker("option","minDate",this.d_start);
			this._form.find(".storageFilterDlgTimeFrom input").timeselect();
			this._form.find(".storageFilterDlgTimeTill input").timeselect();
			this._form.find(".verdictsDiv input").attr("checked", false);
			this._form.find("input[placeholder]").each(Delegate.create(this, this._initPlaceholder));
			this._form.find("input[type=text]").keypress(KL.Utils.Delegate.create(this, this._closeError));
			this._form.find(".storageFilterDlgSize").numberselect();
			this._form.find(".storageFilterDlgRuleId").numberselect();
		},
		_closeError: function(){
			this._form.find("input[type=text]").removeClass("error");
			this._form.find("input[type=text]").attr("title","");
			this._form.find(".storageFilterDlgDateTill input").removeClass("error");
			this._form.find(".storageFilterDlgDateTill input").attr("title","");
		},
		_initPlaceholder: function (indx, elt) {
			elt = $(elt);
			var localization = KL.Utils.Localization.getInstance();
			var text = elt.attr("placeholder");
			var placeholder_support = !!('placeholder' in document.createElement('input'));
			if (!placeholder_support) {
				if (localization.stringExists(text))
					text = localization.getLocaleString(text);
				elt.wrap("<span class='inputWrap'></span>");
				var wrap = elt.closest(".inputWrap");
				var placeholder = $("<span class='placeholder'></span>").appendTo(wrap);
				placeholder.click(KL.Utils.Delegate.create(this, this._hidePlaceholder, elt, placeholder, false));
				elt.blur(KL.Utils.Delegate.create(this, this._showPlaceholder, elt, placeholder))
					.focus(KL.Utils.Delegate.create(this, this._hidePlaceholder, elt, placeholder, true));
				placeholder.html(text);
				elt.blur();
			} else {
				if (localization.stringExists(text))
					text = localization.getLocaleValueString(text);
				elt.attr("placeholder", text);
			}
		},
		_hidePlaceholder: function (tb, ph, escFocus) {
			ph.hide();
			if (!escFocus)
				tb.focus();
		},
		_showPlaceholder: function (tb, ph) {
			ph.hide();
			if ($.trim(tb.val()) === '')
				ph.show();
		},
		onShown: function () {
			this._bindValues();
			this.onDateRangeChanged();
		},
		initDropDown: function (controlClass, valuesEnum, valuesClassName, changeHandler) {
			var dropDown = this._form.find(controlClass);
			var localization = KL.Utils.Localization.getInstance();
			var values = valuesEnum.getKeys();
			for (var i = 0; i < values.length; i++) {
				$('<option value="' + valuesEnum[values[i]] + '" class="str-local-Label' + valuesClassName + values[i] + '">' + i + "</option>").appendTo(dropDown);
			}
			if (typeof (changeHandler) == 'function')
				dropDown.change(changeHandler);
		},
		getValueRecursive: function () {
			var DayRanges = KL.LMS.Enums.DayRanges,
				SizeCriteria = KL.LMS.Enums.SizeCriteria,
				sender = $.trim(this._form.find(".storageFilterDlgSender").val()),
				reciever = $.trim(this._form.find(".storageFilterDlgReciever").val()),
				subj = $.trim(this._form.find(".storageFilterDlgSubject").val()),
				size = this._form.find(".storageFilterDlgSize").val(),
				sizeTypeVal = this._form.find(".storageFilterDlgSizeSelect").val() * 1,
				sizeType = SizeCriteria.getKeyByValue(sizeTypeVal),
				from = KL.Utils.DateHelper.getServerTime(),
				to = null,
				filterByVerdict = false,
				verdictsTypes = ["It", "As", "Av", "Cf", "Ap", "Bl"],
				verdicts = {},
				msgId = $.trim(this._form.find(".storageFilterDlgMsgId").val()),
				ruleId = this._form.find(".storageFilterDlgRuleId").val() * 1,
				dateRangeType = this._form.find(".storageFilterDlgIntervalSelect").val() * 1;
			switch (dateRangeType) {
				case DayRanges.LastDay:
					from.setDate(from.getDate() - 1);
					break;
				case DayRanges.LastHour:
					from.setHours(from.getHours() - 1);
					break;
				case DayRanges.LastWeek:
					from.setDate(from.getDate() - 7);
					break;
				case DayRanges.Last2Weeks:
					from.setDate(from.getDate() - 14);
					break;
				case DayRanges.LastMonth:
					from.setMonth(from.getMonth() - 1);
					break;
				case DayRanges.Last3Months:
					from.setMonth(from.getMonth() - 3);
					break;
				case DayRanges.LastYear:
					from.setFullYear(from.getFullYear() - 1);
					break;
				case DayRanges.UserInterval:
					from = this._form.find(".storageFilterDlgDateFrom input").datepicker("getDate");
					if (from < this.d_start) from = this.d_start;
					if (from > this.d_finish) from = this.d_start;
					to = this._form.find(".storageFilterDlgDateTill input").datepicker("getDate");
					if (to < this.d_start) to = this.d_finish;
					if (to > this.d_finish) to = this.d_finish;
					var timeFrom = this._form.find(".storageFilterDlgTimeFrom input");
					var timeTo = this._form.find(".storageFilterDlgTimeTill input");
					from.setHours(timeFrom.timeselect("getHours"));
					from.setMinutes(timeFrom.timeselect("getMinutes"));
					to.setHours(timeTo.timeselect("getHours"));
					to.setMinutes(timeTo.timeselect("getMinutes"));
					break;
			}
			var data = null;
			if (from) {
				data = data || {};
				data["dateType"] = dateRangeType;
				data["filterSearchReceivingTime.greater.equal"] = Math.round(from.getTime() / 1000);
			}
			if (to) {
				data = data || {};
				data["filterSearchReceivingTime.less.equal"] = Math.round(to.getTime() / 1000);
			}
			if (sender) {
				data = data || {};
				data["filterSearchSender.like"] = sender;
			}
			if (reciever) {
				data = data || {};
				data["filterSearchReceiver.like"] = reciever;
			}
			if (subj) {
				data = data || {};
				data["filterSearchSubject.like"] = subj;
			}
			if (msgId) {
				data = data || {};
				data["filterSearchSmtpMessageId.like"] = msgId;
			}
			if (size) {
				data = data || {};
				var field = {
					Equals: "filterSearchSizeInput",
					Greater: "filterSearchSizeInput.greater.equal",
					Less: "filterSearchSizeInput.less.equal"
				};
				data[field[sizeType]] = Math.round(size * 1024);
			}
			if (ruleId) {
				data = data || {};
				data["filterSearchRuleId"] = ruleId;
			}
			this._data = {
				"sender": sender,
				"reciever": reciever,
				"subj": subj,
				"sizeType": sizeTypeVal,
				"size": size,
				"from": from ? from.getTime() : null,
				"to": to ? to.getTime() : null,
				"dateType": dateRangeType,
				"messageId": msgId,
				"ruleId": ruleId,
				"verdicts": {}
			};
			for( var i=1, l=verdictsTypes.length; i<l; i++ ){
				var verdictId = verdictsTypes[i];
				this._data.verdicts[ verdictId ] = this._form.find("[name=verdict"+verdictId+"]").is(":checked");
				filterByVerdict = filterByVerdict || !this._data.verdicts[ verdictId ];
			}
			if( filterByVerdict ){
				for( var v in this._data.verdicts ){
					if( this._data.verdicts.hasOwnProperty(v) && this._data.verdicts[v])
						data[ "filterSearchHas"+v+"Status" ] = 1;
				}
			}
			return data;
		},
		validate: function(){
			var size = this._form.find(".storageFilterDlgSize").val();
			if (size!=="")  {
				if (+size != +size ){
					this._form.find(".storageFilterDlgSize").addClass("error");
					this.showError(-1,KL.Utils.Localization.getInstance().getLocaleValueString("ErrorFileSizeValueIsNaN"));
					return false;
				}
				if (size=="Infinity" || size == "-Infinity" || (size*1)>1048576 ){
					this._form.find(".storageFilterDlgSize").addClass("error");
					this.showError(-1,KL.Utils.Localization.getInstance().getLocaleValueString("ErrorFileSizeValueIsMoreGb"));
					return false;
				}
				if ((size*1)<0){
					this._form.find(".storageFilterDlgSize").addClass("error");
					this.showError(-1, KL.Utils.Localization.getInstance().getLocaleValueString("ErrorFileSizeValueIsNegative"));
					return false;
				}
			}
			var ruleId = this._form.find(".storageFilterDlgRuleId").val();
			if (ruleId!=="")  {
				if (+ruleId != +ruleId ){
					this._form.find(".storageFilterDlgRuleId").addClass("error");
					this.showError(-1,KL.Utils.Localization.getInstance().getLocaleValueString("ErrorRuleIdValueIsNaN"));
					return false;
				}
				if (ruleId=="Infinity" || ruleId == "-Infinity" || +ruleId > 1000000000) {
					this._form.find(".storageFilterDlgRuleId").addClass("error");
					this.showError(-1,KL.Utils.Localization.getInstance().getLocaleValueString("ErrorRuleIdIsTooBig"));
					return false;
				}
				if ((ruleId*1)<0){
					this._form.find(".storageFilterDlgRuleId").addClass("error");
					this.showError(-1, KL.Utils.Localization.getInstance().getLocaleValueString("ErrorRuleIdIsNegative"));
					return false;
				}
			}
			var dateRangeType = this._form.find(".storageFilterDlgIntervalSelect").val() * 1;
			if (dateRangeType==KL.LMS.Enums.DayRanges.UserInterval) {
				from = this._form.find(".storageFilterDlgDateFrom input").datepicker("getDate");
				to = this._form.find(".storageFilterDlgDateTill input").datepicker("getDate");
				if (from>to) {
					this._form.find(".storageFilterDlgDateTill input").addClass("error");
					this.showError(-1,KL.Utils.Localization.getInstance().getLocaleValueString("ErrorBackupFilterDiapazon"));
					return false;
				}
			}
			return true;
		},
		onFormSubmit: function () {
			return this.validate();
		},
		initValues: function () {
			this._data = {};
		},
		_bindValues: function () {
			var data = this._data || {};
			this._form.find(".storageFilterDlgIntervalSelect").val(data.dateType || KL.LMS.Enums.DayRanges.LastHour).blur();
			this._form.find(".storageFilterDlgSizeSelect").val(data.sizeType || KL.LMS.Enums.SizeCriteria.Equals).blur();
			if (data.to) {
				var dt = new Date();
				dt.setTime(data.to);
				this._form.find(".storageFilterDlgTimeTill input").timeselect("setValue", dt);
				this._form.find(".storageFilterDlgDateTill input").datepicker("setDate", dt);
			}
			if (data.from) {
				var df = new Date();
				df.setTime(data.from);
				this._form.find(".storageFilterDlgTimeFrom input").timeselect("setValue", df);
				this._form.find(".storageFilterDlgDateFrom input").datepicker("setDate", df);
			}
			this._form.find(".storageFilterDlgSender").val(data.sender || "").blur();
			this._form.find(".storageFilterDlgReciever").val(data.reciever || "").blur();
			this._form.find(".storageFilterDlgSubject").val(data.subj || "").blur();
			this._form.find(".storageFilterDlgSize").val(data.size || "").blur();
			this._form.find(".storageFilterDlgMsgId").val( data.messageId || "" ).blur();
			this._form.find(".storageFilterDlgRuleId").val( data.ruleId || "" ).blur();
			this._form.find(".storageFilterDlgSize").val(data.size || "").blur();
			if (data.verdicts) {
				for( var v in data.verdicts ){
					if(data.verdicts.hasOwnProperty(v))
						this._form.find("[name=verdict"+v+"]").attr("checked", !!data.verdicts[v]);
				}
			}
		},
		onDateRangeChanged: function () {
			var value = this._form.find('.storageFilterDlgIntervalSelect').val();
			this._form.find('.storageFilterDlgDateFrom, .storageFilterDlgTimeFrom, .storageFilterDlgDateTill, .storageFilterDlgTimeTill').toggle(value == KL.LMS.Enums.DayRanges.UserInterval);
		},
		onBeforeShow: function () {
			this.hideError();
			this.hideSuccess();
		},
		_cancel: function () {
			$(this).trigger("oncancel");
		}
	};
	KL.LMS.Backup.registerClass("FilterDialog", FilterDialog);
	FilterDialog.extend(KL.Web.Controls.FormControl);
})()
;
(function () {
	var ButtonCollapsePanel = function (id, setting) {
		Log.write("ButtonCollapsePanel.constructor: called id=" + id);
		ButtonCollapsePanel._super.call(this, id, setting);
	};
	ButtonCollapsePanel.prototype = {
		onInitInteraction: function () {
			var localization = KL.Utils.Localization.getInstance();
			this._collapsed = true;
			this._setPanelClass();
			if (localization.stringExists(this.titletext))
				this.titletext = localization.getLocaleString(this.titletext);
			this._elt.find(".pnlExpandButton:eq(0)")
				.click(KL.Utils.Delegate.create(this, this.expandPanel))
				.find(".titleText").html(this.titletext);
			this._elt.find(".pnlCollapseButton:eq(0)")
				.click(KL.Utils.Delegate.create(this, this.collapsePanel))
				.find(".titleText").html(this.titletext);
			this._elt.find(".pnlPreview:eq(0)").show();
			this._elt.find(".pnlContent:eq(0)").hide();
			this._elt.find(".pnlCollapseButton:eq(0)").hide();
		},
		collapsePanel: function () {
			this._collapsed = false;
			this._elt.find(".pnlCollapseButton:eq(0)").hide();
			this._elt.find(".pnlExpandButton:eq(0)").show();
			this._togglePanelCollapsed();
		},
		expandPanel: function () {
			if (!!this._enabled) {
				this._collapsed = true;
				this._elt.find(".pnlExpandButton:eq(0)").hide();
				this._elt.find(".pnlCollapseButton:eq(0)").show();
				this._togglePanelCollapsed();
			}
		}
	};
	KL.LMS.Backup.registerClass("ButtonCollapsePanel", ButtonCollapsePanel);
	ButtonCollapsePanel.extend(KL.Web.Controls.CollapsePanel);
})()
;
(function () {
	var DeliverDialogForm = function (id, setting) {
		DeliverDialogForm._super.call( this, id, setting );
	};
	DeliverDialogForm.prototype = {
		_timePart: { Hours: 0, Minutes: 1 },
		_evtTimer: null,
		_data: null,
		setData: function (e, data) {
			this._data = data || {};
			this._toggleExtraMails();
			if (data.isHeadersMailsEmpty) {
					this._form.find("[name=headersMails]").attr("disabled",true);
					this._form.find("[name=headersMailsMsg]").css("color","#999");
					var localization = KL.Utils.Localization.getInstance();
					this._form.find("[name=headersMailsWarning]").attr("title",localization.getLocaleValueString("LabelDeliverDialogOnHeaderAddrsEmpty"));
			}
			else {
				this._form.find("[name=headersMailsWarning]").css("display","none");
			}
		},
		onFormInit: function () {
			this._form.find(".btnCancel").click(KL.Utils.Delegate.create(this, this._cancel));
			this._form.find("[name=extraMails]").click(KL.Utils.Delegate.create(this, this._toggleExtraMails));
			this._form.find("[name=headersMails]").click(KL.Utils.Delegate.create(this, this._toggleBtnOk));
			this._form.find(".btnOk").attr("disabled",true);
			this._form.find("[name=emails]").keyup(KL.Utils.Delegate.create(this, this._toggleBtnOk));
		},
		onShown: function () {},
		getValueRecursive: function () {},
		_toggleBtnOk: function() {
			if (this._isEnabled()) this._form.find(".btnOk").attr("disabled",false);
			else this._form.find(".btnOk").attr("disabled",true);
		},
		_isEnabled: function(){
			return	this._form.find("[name=headersMails]").is(":checked") || 
				(
					this._form.find("[name=extraMails]").is(":checked")&&
					((this._form.find("[name=emails]").val() || "") + "").length>0 
				);
		},
		checkFieldEmpty: function (escTimeout) {
			this._toggleBtnOk();
		},
		
		_toggleExtraMails: function(){
			this._form.find("[name=emails]").attr("disabled", !this._form.find("[name=extraMails]").is(":checked"));
			this._toggleBtnOk();
		},
		onFormSubmit: function () {
			this._data.useheaders = this._form.find("[name=headersMails]").is(":checked");
			this._data.items = [];
			if (this._form.find("[name=extraMails]").is(":checked"))
				this._data.items = ((this._form.find("[name=emails]").val() || "") + "").split(/[;,]/gi) || [];
			$(this._data).trigger("ondataready", this._data);
			return true;
		},
		onBeforeShow: function () {
			this.hideError();
			this.hideSuccess();
		},
		_cancel: function () {
			$(this).trigger("oncancel");
		}
	};
	KL.LMS.Backup.registerClass("DeliverDialogForm", DeliverDialogForm);
	DeliverDialogForm.extend(KL.Web.Controls.FormControl);
})()
;
KL.LMS.registerNS("Settings");
(function () {
	var BaseSettingsForm = function (id, setting) {
		BaseSettingsForm._super.call( this, id, setting );
	};
	BaseSettingsForm.prototype = {
		_map: [],
		_prepareForm: function () { },
		onDataSet: function () { },
		_validate: function () { return true; },
		closeoncancel: false,
		datafield: null,
		_datacache: null,
		onFormInit: function () {
			this._form.find(".btnCancel").click(KL.Utils.Delegate.create(this, this._triggerCancel));
			this._form.find(".setDefaultLink").click(KL.Utils.Delegate.create(this, this.setDefaultData));
			this._datacache = {};
			this._prepareForm();
		},
		setDefaultData : function (e) {
			if( e )
				e.preventDefault();
			if (this._data && typeof(this._data["default"])!= "undefined") {
				var d = this._data["default"];
				if (!!this.datafield)
					d = KL.Utils.ObjectHelper.getObjValueByPath( d, this.datafield );
				if( typeof(d) == "undefined" )
					d = this._data["default"];
				KL.Utils.ObjectHelper.mapValues(this, this._map, d);
				
			    this.onDataSet();
			}
		},
		
		onErrorHide: function () {
			this._form.find(".error").removeClass("error");
		},
		applyError: function (e, data) {
			if (data && this._form) {
				if (data.id)
					this.showError(data.id, data.message);
				if (data.data && data.data.items)
					for (var i = 0, l = data.data.items.length; i < l; i++)
						this._highliteError(data.data.items[i]);
			}
		},
		_highliteError: function (fieldName) {
			var field = "";
			for (var i = 0, l = this._map.length; i < l; i++) {
				if (fieldName.toLowerCase().indexOf(this._map[i].datasource.toLowerCase()) != -1) {
					field = this._map[i].elt;
					break;
				}
			}
			if (field) {
				var elt = this.getFormElement(field);
				if (elt)
					elt.addClass("error");
			}
		},
		getFormElement: function (eltClassName) {
			var elt = null;
			if (this._form) {
				elt = this._form.find("[name=" + eltClassName + "]");
				if (elt.length == 0)
					elt = this._form.find("." + eltClassName);
			}
			return elt;
		},
		onBeforeShow: function () {
			this.hideError();
			this.hideSuccess();
			this.checkFieldEmpty(true);
		},
		_restoreData: function () {
			this._data = $.extend(true, this._data, this._datacache);
		},
		_triggerCancel: function () {
			$(this).trigger("oncancel");
			if (this.closeoncancel && this._page instanceof KL.Web.Dialog) {
				this._restoreData();
				this._page.closeDialog();
			}
		},
		setData: function (e, data, fieldName) {
			this._datacache = $.extend(true, {}, data);
			this._data = data;
			var d = data;
			if (!!this.datafield )
				d = KL.Utils.ObjectHelper.getObjValueByPath( data, this.datafield );
			if( typeof(d) == "undefined" )
				d = data;
			KL.Utils.ObjectHelper.mapValues(this, this._map, d);
			this.focusField(fieldName);
			this.onDataSet();
		},
		focusField: function(fieldName){
			if( this._map instanceof Array ){
				for( var i=0, l=this._map.length; i<l; i++ ){
					var map = this._map[i];
					var elt;
					if( map.datasource == fieldName ){
						if(elt = this.getFormElement(map.elt)){
							try{
								elt.focus();
							}catch(e){}
						}
					}
				}
			};
		},
		setChboxVal: function (data, elt, val) {
			elt.attr("checked", val);
		},
		getIsChecked: function (elt, val) {
			return elt.is(":checked");
		},
		setRadioVal: function (data, elt, val) {
			elt.val([val]);
		},
		getRadioVal: function (elt, val) {
				return elt.filter(":checked").val();
		},
		
		setBoolSelectVal: function (data, elt, val) {
			elt.val(val ? "1" : "0");
		},
		getBoolSelectVal: function (elt, val) {
			return (val * 1) == 1;
		},
		
		onFormSubmit: function () {
			if (this._validate() === false) {
				return false;
			}
			
			var ObjectHelper = KL.Utils.ObjectHelper,
				d = this._data;
			if( !!this.datafield )
				d = ObjectHelper.getObjValueByPath( this._data, this.datafield );
			d = (typeof(d) == "undefined")?this._data:d;
			for (var i = 0, l = this._map.length; i < l; i++) {
				var map = this._map[i];
				var elt = this.getFormElement(map.elt);
				if (map.set !== null && elt && elt.length > 0) {
					var val = elt.val();
					if (typeof (map.set) != "undefined" && typeof (this[map.set]) == "function")
						val = this[map.set](elt, val, ObjectHelper.getObjValueByPath(d, map.datasource));
					if (typeof (map.validate) != "undefined" && this[map.validate](elt, val) === false) {
						this.showError("");
						elt.focus();
						return false;
					}
					if (typeof (val) != "undefined")
						KL.Utils.ObjectHelper.setObjValueByPath(d, map.datasource, val);
				}
			}
		},
		getFormValue: function () {
			if (this._submitData) {
				return { data: KL.Utils.JSON.encode(this._submitData) };
			}
			return null;
		},
		getValueString: function () {
			
			
			return KL.Utils.JSON.encode(this._data);
		}
	};
	KL.LMS.Settings.registerClass("BaseSettingsForm", BaseSettingsForm);
	BaseSettingsForm.extend( KL.Web.Controls.FormControl );
})()
;
(function () {
	var SettingsPreviewPanel = function (id, setting) {
		SettingsPreviewPanel._super.call( this, id, setting );
	};
	SettingsPreviewPanel.prototype = {
		buttons: null,
		titletext: "",
		datafield: "",
		_btTpl: "",
		_data: null,
		onInitInteraction: function () {
			var elt = this.getElt();
			if (elt) {
				this.setTitle(this.titletext);
				this._btTpl = elt.find(".linksWrap").html();
				elt.find(".linksWrap").empty();
				this._exludeGroups = [];
				elt.hover(
					function () { $(this).addClass("settingsPreviewOver"); },
					function () { $(this).removeClass("settingsPreviewOver"); }
				);
			}
		},
		setTitle: function (txt) {
			var elt = this.getElt();
			if (elt && txt) {
				var localization = KL.Utils.Localization.getInstance();
				if (localization.stringExists(txt))
					txt = localization.getLocaleString(txt);
				elt.find(".titleText").html(txt);
			}
		},
		onDataBind: function (data) {
			this._data = data;
			this._renderButtons();
		},
		_renderButtons: function () {
			var elt = this.getElt();
			var StringHelper = KL.Utils.StringHelper;
			var localization = KL.Utils.Localization.getInstance();
			var Delegate = KL.Utils.Delegate;
			if (elt && this.buttons && (this.buttons instanceof Array)) {
				var btnsWrap = elt.find(".linksWrap");
				btnsWrap.empty();
				var btnGroups = {};
				for (var i = 0, j = 0, l = this.buttons.length; i < l; i++) {
					var btnInfo = this.buttons[i];
					if (this.testCondition(btnInfo)) {
						if (j > 0)
							btnsWrap.append("&nbsp;|&nbsp;");
						var txt = localization.getText(btnInfo.text);
						var btn = $(StringHelper.formatTemplate(this._btTpl, { "BtnText": txt })).appendTo(btnsWrap);
						if (btnInfo.cssclass)
							btn.addClass(btnInfo.cssclass);
						btn.click(Delegate.create(this, this._btnClickHandler, (btnInfo.event || "onbtn" + i + "click"), btnInfo, btn));
						if (typeof (btnInfo.excludegroup) != "undefined") {
							btn.addClass(btnInfo.excludegroup);
							btn.toggle(!btnGroups[btnInfo.excludegroup]);
							btnGroups[btnInfo.excludegroup] = true;
							j--;
						}
						j++;
					}
				}
			}
		},
		testCondition: function (btn) {
			var retVal = true;
			if (typeof (btn["datafield"]) != "undefined") {
				var val = KL.Utils.ObjectHelper.getObjValueByPath(this._data, btn.datafield);
				if (typeof (btn["conditionValue"]) != "undefined")
					retVal = val === btn["conditionValue"];
				else if (typeof (btn["conditionValueLT"]) != "undefined")
					retVal = val < btn["conditionValueLT"];
				else if (typeof (btn["conditionValueGT"]) != "undefined")
					retVal = val > btn["conditionValueGT"];
			}
			return retVal;
		},
		getValueRecursive: function () {
			return KL.Utils.JSON.encode(this._data);
		},
		_btnClickHandler: function (evtname, btnInfo, btnElt, e) {
			e.preventDefault();
			e.stopPropagation();
			var elt = this.getElt();
			if (typeof (btnInfo.excludegroup) != "undefined" && elt) {
				elt.find("." + btnInfo.excludegroup).show();
				btnElt.hide();
			}
			var data = this._data;
			if (this.datafield)
				data = KL.Utils.ObjectHelper.getObjValueByPath(this._data, this.datafield);
			data = [(data == null || typeof (data) == "undefined") ? this._data : data];
			if (typeof (btnInfo["clickparams"]) != "undefined") {
				if (btnInfo.clickparams instanceof Array)
					data = data.concat(btnInfo.clickparams);
				else
					data.push(btnInfo.clickparams);
			}
			$(this).trigger(evtname || "onbtnclick", data);
			return false;
		}
	};
	KL.LMS.Settings.registerClass("SettingsPreviewPanel", SettingsPreviewPanel);
	SettingsPreviewPanel.extend(KL.Web.Controls.Control);
})()
;
(function () {
	var ToggleableSettingsPreviewPanel = function (id, setting) {
		ToggleableSettingsPreviewPanel._super.call( this, id, setting );
	};
	ToggleableSettingsPreviewPanel.prototype = {
		titletext: "",
		datafield: "",
		toggledatafield: "",
		helptext: "",
		editable: true,
		_data: null,
		showtoggle: true,
		_isclicked: false,
		isEditable: function(){
			var editable = this.editable === true,
				elt = this.getElt();
			if( !editable && !!this.editable && this.editable.hasOwnProperty( "helper" ) && this.editable.hasOwnProperty( "method" ) ){
				var helper = KL.getType(this.editable.helper);
				if( helper ){
					if((typeof helper[this.editable.method] ) == "function" )
						editable = helper[this.editable.method].call( helper );
					editable = !!editable || (typeof editable) == "undefined";
				}
			}
			if(elt)
				elt.find(".warningIcon")[!editable?"show": "hide"]();
			return editable;
		},
		notifyLicenseChange: function(){
			if(this.isVisible() && this._data)
				this.setValue(this._data);
		},
		onInitInteraction: function () {
			var elt = this.getElt();
			if (elt) {
				var tipId = this.id + "WarnTooltip";
				elt.find(".warnTooltip").addClass( tipId );
				KL.Utils.TooltipHelper.makeTooltips(elt.find(".warningIcon").attr("rel",tipId), this, elt);
				
				this.setTitle(this.titletext);
				elt.find(".toggle").toggle(!!this.showtoggle).find("input").click(KL.Utils.Delegate.create(this, this._toggleClickHandler));
				var helpTrigger = elt.find(".title .helpIco").hide();
				if( this.helptext ){
					var helpTipId = this.id + "HelpTooltip";
					elt.find(".helpTooltip").addClass( helpTipId ).html( KL.Utils.Localization.getInstance().getLocaleString(this.helptext) );
					KL.Utils.TooltipHelper.makeTooltips(helpTrigger.attr("rel",helpTipId), this, elt);
					helpTrigger.show();
				}
				elt.hover(
					function () { $(this).addClass("settingsPreviewOver"); },
					function () { $(this).removeClass("settingsPreviewOver"); }
				);
			}
		},
		setTitle: function (txt) {
			var elt = this.getElt();
			if (elt) {
				var localization = KL.Utils.Localization.getInstance();
				
				if (txt && localization.stringExists(txt))
					txt = localization.getLocaleString(txt);
				elt.find(".titleText").html(txt);
				var editable = this.isEditable();
				if( this.editable  && this.editable.hasOwnProperty( "helper" ) && this.editable.hasOwnProperty( "warningmessage" ) ){
					if(!editable){
						var helper = KL.getType(this.editable.helper),
							msg = this.editable.warningmessage;
						if((typeof helper[msg] ) == "function" )
							msg = helper[msg].call( helper );
						if (localization.stringExists(msg))
							msg = localization.getLocaleString(msg);
						$("."+elt.find(".warningIcon").attr("rel")).html( msg );
					}
				}
			}
		},
		onDataBind: function (data) {
			this._data = data;
			var val = false;
			if (!!this.toggledatafield && this.isEditable() )
				val = KL.Utils.ObjectHelper.getObjValueByPath(this._data, this.toggledatafield);
			this._isclicked = false;
			this._setToggle(!!val);
		},
		_toggleClickHandler: function () {
			if (this._isclicked || !this.isEditable())
				return false;
			this._isclicked = true;
			var ison = this._setToggle();
			var data = [this._data];
			if (typeof (this.toggledatafield) != "undefined") {
				if (this.toggledatafield instanceof Array) {
					data = data.concat(this.toggledatafield);
					for (var i = 0, l = this.toggledatafield.length; i < l; i++)
						KL.Utils.ObjectHelper.setObjValueByPath(this._data, this.toggledatafield[i], ison);
				}
				else {
					data.push(this.toggledatafield);
					KL.Utils.ObjectHelper.setObjValueByPath(this._data, this.toggledatafield, ison);
				}
			}
			
			$(this).trigger((ison ? "onsettingenable" : "onsettingdisable"), data);
		},
		_setToggle: function (isOn) {
			var elt = this.getElt();
			if (elt) {
				var t = elt.find(".toggle");
				var cb = t.find("input");
				isOn = typeof (isOn) == "undefined" ? cb.is(":checked") : isOn;
				t.toggleClass("checked", isOn);
				cb.attr("checked", isOn);
			}
			return isOn;
		}
	};
	KL.LMS.Settings.registerClass("ToggleableSettingsPreviewPanel", ToggleableSettingsPreviewPanel);
	ToggleableSettingsPreviewPanel.extend(KL.Web.Controls.Control);
})()
;
(function () {
	var CnnSettingsForm = function (id, setting) {
		CnnSettingsForm._super.call( this, id, setting );
	};
	CnnSettingsForm.prototype = {
		_passplaceholder: "******",
		_map: [
			{ "elt": "useProxy", "datasource": "enable" , "get": "setBoolSelectVal", "set": "getBoolSelectVal"},
			{ "elt": "address", "datasource": "serverAddress" },
			{ "elt": "port", "datasource": "port" },
			{ "elt": "auth", "datasource": "authenticationType" },
			{ "elt": "login", "datasource": "user" },
			{ "elt": "passwd", "datasource": "password", "get": "getPasswdVal", "set": "setPasswdVal" }, //, "get": null, "set": function () { return ""; } },
			{ "elt": "proxyBypassLocal", "datasource": "proxyBypassLocalAddresses", "get": "setBoolSelectVal", "set": "getBoolSelectVal" }
		],
		_prepareForm: function () {
			this.hideError();
			
			this._form.find("input[name=port]").numberselect({
				min: 0,
				max: 65535,
				defaultValue: 3128,
				step: 1
			});
			this._form.find("[name=showPasswd]").change(KL.Utils.Delegate.create(this, this._passwdShow));
				
			var CommonHelper = KL.LMS.Helpers.CommonHelper;
			CommonHelper.fillSelectWidthEnum(this._form.find("[name=auth]").change(KL.Utils.Delegate.create(this, this._toggleAuthEnabled)), {
				"NotRequired": KL.LMS.Enums.UpdaterAuthTypes.NotRequired,
				"Plain": KL.LMS.Enums.UpdaterAuthTypes.Plain
			}, "UpdateAuthOption_");
		},
		_passwdFocus: function () {
			var p = this._form.find("[name=passwd]");
			if (p.val() === this._passplaceholder)
				p.val("");
		},
		_passwdShow: function () {
			var p = this._form.find("[name=showPasswd]");
			var p_c = this._form.find("[name=passwd]");
			var change = p.is(":checked") ? "text" : "password";
                var rep = $("<input type='" + change + "' />")
                    .attr("name", p_c.attr("name"))
                    .attr('class', p_c.attr('class'))
                    .attr('disabled', !!p_c.attr('disabled'))
                    .val(p_c.val())
                    .insertBefore(p_c);
                p_c.remove();
                p_c = rep;
		},
		_passwdBlur: function () {
			var p = this._form.find("[name=passwd]");
			if (!$.trim(p.val()))
				p.val(this._passplaceholder);
		},
		onDataSet: function () {
			this.hideError();
			this._toggleAuthEnabled();
		},
		_toggleAuthEnabled: function () {
			var val = (this._form.find("[name=auth]").val() * 1) == KL.LMS.Enums.UpdaterAuthTypes.NotRequired;
			this._form.find("[name=login], [name=passwd]").attr("disabled", val);
			this._form.find(".userNameField, .userPasswdField").toggleClass("disabled", val);
		},
		setPasswdVal: function (elt, val, prevVal) {
			if (val === this._passplaceholder)
				return prevVal;
			return val;
		},
		getPasswdVal: function (elt, val, prevVal) {
			var p = this._form.find("[name=passwd]");
			p.val(prevVal);
		},
		_validate: function () {
			var localization = KL.Utils.Localization.getInstance();
			var port = $.trim(this._form.find("[name=port]").removeClass("error").val());
			if (port === "" || (isNaN(port * 1) || Math.round(port * 1) != (port * 1)) || (port < 1 || port > 65535)) {
				this.showError(-1, localization.getLocaleString("LabelSettingsPanelUpdate_ErrorPort"));
				this._form.find("[name=port]").addClass("error").focus();
				return false;
			}
			var val = (this._form.find("[name=useProxy]").val() * 1) == 1;
			if (val) {
				var address = $.trim(this._form.find("[name=address]").removeClass("error").val());
				if (address=="") {
					this._form.find("[name=address]").addClass("error").focus();
					return false;
				}
			}
			val = (this._form.find("[name=auth]").val() * 1) == KL.LMS.Enums.UpdaterAuthTypes.Plain;
			if (val) {
				var login = $.trim(this._form.find("[name=login]").removeClass("error").val());
				if (login=="") {
					this._form.find("[name=login]").addClass("error").focus();
					return false;
				}
			}
			
			
			return true;
		}
	};
	KL.LMS.Settings.registerClass("CnnSettingsForm", CnnSettingsForm);
	CnnSettingsForm.extend(KL.LMS.Settings.BaseSettingsForm);
})()
;
(function () {
	var UpdateSettingsForm = function (id, setting) {
		UpdateSettingsForm._super.call( this, id, setting );
	};
	UpdateSettingsForm.prototype = {
		_map: [
			{ "elt": "periodType", "datasource": "schedule.ruleType", "set": "getPeriodTypeFieldValue", "get": "setPeriodTypeSelectValue" },
			{ "elt": "randInterval", "datasource": "schedule.randInterval" },
			{ "elt": "execTimeLimit", "datasource": "schedule.execTimeLimit" },
			{ "elt": "runMissed", "datasource": "schedule.runMissed", "get": "setBoolSelectVal", "set": "getBoolSelectVal" }
		],
		_prepareForm: function () {
			KL.Utils.TooltipHelper.makeTooltips( this._form.find(".helpIco[rel]"), this, this._form );
			this._form.find("input[name=randInterval]").numberselect({
				min: 0,
				max: 1000,
				defaultValue: 50,
				step: 1
			});
			this._form.find("input[name=execTimeLimit]").numberselect({
				min: 0,
				max: 1000,
				defaultValue: 50,
				step: 1
			});
			this._form.find("input[name=monthDay]").numberselect({
				min: 1,
				max: 31,
				defaultValue: (new Date()).getDate(),
				step: 1
			});
			this._form.find("input[name=customNum]").numberselect({
				min: 1,
				max: 999,
				defaultValue: 1,
				step: 1
			});
			this._fillSelects();
			this._form.find("input[name=onceDate]").datepicker();
			this._form.find("[name=runeveryDate]").datepicker();
			this._form.find("input[name=onceTime], input[name=weeklyTime], input[name=monthlyTime], input[name=customTime]").each(function () { $(this).timeselect(); });
		},
		_fillSelects: function () {
			var CommonHelper = KL.LMS.Helpers.CommonHelper;
			var DaysEnum = KL.Utils.DateHelper.DaysEnum;
			var StringHelper = KL.Utils.StringHelper;
			var localization = KL.Utils.Localization.getInstance();
			
			
			
			CommonHelper.fillSelectWidthEnum(this._form.find("[name=runMissed]"), {
				"On": 1,
				"Off": 0
			}, "UpdateRunMissedOption_");
			CommonHelper.fillSelectWidthEnum(this._form.find("[name=periodCustomType]").change(KL.Utils.Delegate.create(this, this._togglePlannedTimeEnabled)), {
				"Minutely": KL.LMS.Enums.ScheduleStartRuleType.Minutely,
				"Hourly": KL.LMS.Enums.ScheduleStartRuleType.Hourly,
				"Daily": KL.LMS.Enums.ScheduleStartRuleType.Daily
			}, "ScheduleCustomStartTypeOption_");
			CommonHelper.fillSelectWidthEnum(this._form.find("[name=periodType]").change(KL.Utils.Delegate.create(this, this._toggleStartTimeEnabled)), {
				"Manual": KL.LMS.Enums.ScheduleStartRuleType.Manual,
				"Once": KL.LMS.Enums.ScheduleStartRuleType.Once,
				"Weekly": KL.LMS.Enums.ScheduleStartRuleType.Weekly,
				"Monthly": KL.LMS.Enums.ScheduleStartRuleType.Monthly,
				"RunEvery": -1
			}, "ScheduleStartTypeOption_");
			var weekDaySelect = this._form.find("[name=weekDay]");
			for (var i = 0, l = KL.Utils.DateHelper.DaysEnum.length; i < l; i++)
				weekDaySelect.append(StringHelper.format('<option value="{0}" class="str-local-ResDayName{1}">{{1}}</option>', i, DaysEnum[i]));
			
		},
		setPeriodTypeSelectValue: function (data, elt, val) {
			var ScheduleStartRuleType = KL.LMS.Enums.ScheduleStartRuleType;
			var time = [data.schedule.startByTime.hour || 12, data.schedule.startByTime.min];
			elt.val(val);
			this._form.find("[name=customTime]").timeselect("setValue", time);
			this._form.find("[name=onceTime]").timeselect("setValue", time);
			this._form.find("[name=monthlyTime]").timeselect("setValue", time);
			this._form.find("[name=weeklyTime]").timeselect("setValue", time);
			this._form.find("[name=weekDay]").val(([7,1,2,3,4,5,6])[data.schedule.startByTime.dayOfWeek]);
			this._form.find("[name=monthDay]").val(data.schedule.startByTime.dayOfMonth||1);
			
			var d = new Date();
			
			if (val == ScheduleStartRuleType.Daily || val == ScheduleStartRuleType.Hourly || val == ScheduleStartRuleType.Minutely) {
				elt.val([-1]);
				this._form.find("[name=periodCustomType]").val(val);
				this._form.find("[name=customNum]").val(data.schedule.startByTime.timePeriod);
				if (val != ScheduleStartRuleType.Daily ){
					if (data.schedule.startByTime.month*1) {
						d = this._setDate(data.schedule.startByTime);
					}
				}
			} else if (val == ScheduleStartRuleType.Once) {
				d = this._setDate(data.schedule.startByTime);
			}
			this._form.find("[name=onceDate]").datepicker("setDate", d);
			this._form.find("[name=runeveryDate]").datepicker("setDate", d);
		},
		
		_setDate: function(_date){
			if (_date.month*1) {
					return new Date(
						_date.year,
						_date.month-1,
						_date.day
					);
			}
			else return new Date();
		},
		
		getPeriodTypeFieldValue: function (elt, val) {
			var ScheduleStartRuleType = KL.LMS.Enums.ScheduleStartRuleType,
				_data = this._data;
			if( !!this.datafield )
				_data = KL.Utils.ObjectHelper.getObjValueByPath( this._data, this.datafield );
			_data = (typeof(_data) == "undefined")?this._data:_data;
			val = elt.val() * 1;
			switch (val) {
				case ScheduleStartRuleType.Manual:
					break;
				case ScheduleStartRuleType.Once:
					var d = this._form.find("[name=onceDate]").datepicker("getDate");
					_data.schedule.startByTime.year = d.getFullYear();
					_data.schedule.startByTime.month = d.getMonth()+1;
					_data.schedule.startByTime.day = d.getDate();
					_data.schedule.startByTime.hour = this._form.find("[name=onceTime]").timeselect("getHours");
					_data.schedule.startByTime.min = this._form.find("[name=onceTime]").timeselect("getMinutes");
					_data.schedule.startByTime.sec = 0;
					_data.schedule.startByTime.dayOfMonth = d.getDate();
					_data.schedule.startByTime.dayOfWeek = d.getDay();
					break;
				case ScheduleStartRuleType.Startup:
					break;
				case ScheduleStartRuleType.Monthly:
					_data.schedule.startByTime.hour = this._form.find("[name=monthlyTime]").timeselect("getHours");
					_data.schedule.startByTime.min = this._form.find("[name=monthlyTime]").timeselect("getMinutes");
					_data.schedule.startByTime.sec = 0;
					_data.schedule.startByTime.dayOfMonth = this._form.find("[name=monthDay]").val() > 0 ? this._form.find("[name=monthDay]").val():1;
					
					break;
				case ScheduleStartRuleType.Weekly:
					_data.schedule.startByTime.hour = this._form.find("[name=weeklyTime]").timeselect("getHours");
					_data.schedule.startByTime.min = this._form.find("[name=weeklyTime]").timeselect("getMinutes");
					_data.schedule.startByTime.sec = 0;
					_data.schedule.startByTime.dayOfWeek = ([7,1,2,3,4,5,6])[this._form.find("[name=weekDay]").val()*1];
					break;
				case -1:
					val = this._form.find("[name=periodCustomType]").val();
					_data.schedule.startByTime.timePeriod = this._form.find("[name=customNum]").val();
					_data.schedule.startByTime.hour = this._form.find("[name=customTime]").timeselect("getHours");
					_data.schedule.startByTime.min = this._form.find("[name=customTime]").timeselect("getMinutes");
					if (val==KL.LMS.Enums.ScheduleStartRuleType.Daily || val==KL.LMS.Enums.ScheduleStartRuleType.Minutely) {
						_data.schedule.startByTime.year = 0;
						_data.schedule.startByTime.month = 0;
						_data.schedule.startByTime.day = 0;
					}
					if (val==KL.LMS.Enums.ScheduleStartRuleType.Hourly) {
						var d = this._form.find("[name=runeveryDate]").datepicker("getDate");
						_data.schedule.startByTime.year = d.getFullYear();
						_data.schedule.startByTime.month = d.getMonth()+1;
						_data.schedule.startByTime.day = d.getDate();
					}
					
					
					
					break;
			}
			return val;
		},
		
		
		onDataSet: function (e, data) {
			this._toggleStartTimeEnabled();
		},
		_toggleStartTimeEnabled: function () {
			var StartRuleType = KL.LMS.Enums.ScheduleStartRuleType;
			var val = this._form.find("[name=periodType]").val();
			this._form.find(".priodStartTime").hide();
			var elt = "";
			switch (val * 1) {
				case StartRuleType.Manual: elt = ""; break;
				case StartRuleType.Once: elt = ".periodOnce"; break;
				case StartRuleType.Weekly: elt = ".periodWeekly"; break;
				case StartRuleType.Monthly: elt = ".periodMonthly"; break;
				default: 
					elt = ".periodCustom";
					break;
			}
			if (elt) {
				this._form.find(elt).show();
				this._togglePlannedTimeEnabled();
			}
		},
		_togglePlannedTimeEnabled: function () {
			var m = KL.LMS.Enums.ScheduleStartRuleType.Minutely,
				d = KL.LMS.Enums.ScheduleStartRuleType.Daily,
				h = KL.LMS.Enums.ScheduleStartRuleType.Hourly,
				val = this._form.find("[name=periodCustomType]").val() * 1;
			this._form.find("[name=runeveryDate]").toggle(val == h);
			this._form.find("[name=customTime]").timeselect("toggle",(val == d || val == h || val == m));
		},
		
		_validate: function () {
			var customNum = $.trim(this._form.find("[name=customNum]").removeClass("error").val());
			if (customNum != "" && (isNaN(customNum * 1) || Math.round(customNum * 1) != (customNum * 1))) {
				this._form.find("[name=customNum]").addClass("error");
				return false;
			}
			return true;
		}
	};
	KL.LMS.Settings.registerClass("UpdateSettingsForm", UpdateSettingsForm);
	UpdateSettingsForm.extend(KL.LMS.Settings.BaseSettingsForm);
})();
;
(function () {
	var UpdateSettingsSourceForm = function (id, setting) {
		UpdateSettingsSourceForm._super.call( this, id, setting );
	};
	UpdateSettingsSourceForm.prototype = {
		_map: [
			{ "elt": "reportUsersPeriod", "datasource": "updateCommonSettings.sourceType","set": "getRadioVal", "get": "setRadioVal" },
			{ "elt": "useKlAltSource", "datasource": "updateCommonSettings.useKlServersWhenUnavailable", "set": "getIsChecked", "get": "setChboxVal" },
			{"elt": "sourceAddr", "datasource": "updateCommonSettings.customSources", "set": "setCustomSources", "get": "getCustomSources" }
		],
		_prepareForm: function () {
			KL.Utils.TooltipHelper.makeTooltips( this._form.find(".helpIco[rel]"), this, this._form );
			this._form.find("[name=reportUsersPeriod]").click(KL.Utils.Delegate.create(this, this._toggleCustomSourceEnabled));
			this._form.find("[name=sourceAddr]").focus(KL.Utils.Delegate.create(this, this._setCustomSourceEnabled));
		},
		_fillSelects: function () {
		
		},
		setCustomSources: function (elt, val) {
			var str = elt.val().split(";");
			var result = [];
			for (var i = 0; i < str.length; i++) {
				result.push(str[i]);
			}
			return result;
		},
		getCustomSources: function (data, elt, val) {
			if (val instanceof Array) {
				var str = [];
				for (var i = 0; i < val.length; i++) {
					str.push(val[i]);
				}
				elt.val(str.join(";"));
			}
		},
		onDataSet: function (e, data) {
			this._toggleCustomSourceEnabled();
		},
		_setCustomSourceEnabled: function(){
			var val = this._form.find("[name=reportUsersPeriod]:checked").val()*1;
			if(val != KL.LMS.Enums.UpdaterSourceTypes.Custom){
				this._form.find("[name=reportUsersPeriod]").val([KL.LMS.Enums.UpdaterSourceTypes.Custom]);
				this._toggleCustomSourceEnabled();
			}
		},
		_toggleCustomSourceEnabled: function () {
			var val = this._form.find("[name=reportUsersPeriod]:checked").val()*1;
			var isKLSource = (val == KL.LMS.Enums.UpdaterSourceTypes.KLServers);
			this._form.find(".useKLAltSourceField").toggleClass("disabled", isKLSource).find("[name=useKlAltSource]").attr("disabled", isKLSource);
			if(val == KL.LMS.Enums.UpdaterSourceTypes.Custom)
				this._form.find("[name=sourceAddr]").focus();
		},
		_validate: function () {
			var sourceAddr = $.trim(this._form.find("[name=sourceAddr]").val()),
				val = this._form.find("[name=reportUsersPeriod]:checked").val()*1;
			if ( val == KL.LMS.Enums.UpdaterSourceTypes.Custom && sourceAddr === "" ) {
				var localization = KL.Utils.Localization.getInstance();
				var msgRes = this._page.getApplication().showMessage(localization.getLocaleValueString("ErrorUpdater_SourceIsNull"), "LabelDialogTitleError", "BtnClose", 300, KL.Web.MessageDialog.MessageType.Error);
				return false;
			}
			return true;
		}
	};
	KL.LMS.Settings.registerClass("UpdateSettingsSourceForm", UpdateSettingsSourceForm);
	UpdateSettingsSourceForm.extend(KL.LMS.Settings.BaseSettingsForm);
})();
;
(function () {
	var commandClass=".str-local-LabelSettingsPanelUpdate_link_StartUpdate";
	var UpdateSettingsPreviewPanel = function (id, setting) {
		UpdateSettingsPreviewPanel._super.call( this, id, setting );
	};
	UpdateSettingsPreviewPanel.prototype = {
		_statusData: null,
		
		setTitle: function (txt) {
			var elt = this.getElt();
			if (elt && txt) {
				var localization = KL.Utils.Localization.getInstance();
				if (localization.stringExists(txt))
					txt = localization.getLocaleString(txt);
				elt.find(".titleText").html(txt);
			}
			if (elt) {
				elt.find(".linksWrap a").css("max-width","100%");
				var updateRersent = elt.find(".linksWrap").parent();
				updateRersent.append("<div class=\"updatePersent\"></div>");
				
				elt.find(".updatePersent").append("<span class=\" str-local-LabelSettingsPanelUpdate_notlink_Update\"></span>");
				elt.find(".updatePersent").append("<span class=\"persentValue\">&nbsp;0%</span>");
				elt.find(".updatePersent").hide();
			}
			
			this._page.getApplication().getContext().setStartedTask(this.datafield,0);
			
			this.getPersent();
		},
		onDataBind: function (data) {
			var localization = KL.Utils.Localization.getInstance();
			var elt = this.getElt();
			if (data) {
				this._data = data;
				this._statusData = data;
				this._renderButtons();
				if (elt) {
					if (!data.isRunning) {
							
							var waitStarted = this._page.getApplication().getContext().getStartedTask("AVS_ASP");
							if (waitStarted >0) {
								waitStarted++;
								if (waitStarted>7) waitStarted=0;
								elt.find(commandClass).parent().hide();
								elt.find(".updatePersent").show();
								this._page.getApplication().getContext().setStartedTask("AVS_ASP",waitStarted); 
							}
							else {							
								elt.find(".updatePersent").hide();
								elt.find(commandClass).parent().show();
							}
					}
					else {
						this._page.getApplication().getContext().setStartedTask(this.datafield,0);
						elt.find(commandClass).parent().hide();
						elt.find(".persentValue").html("&nbsp;"+data.progress+"%");
						elt.find(".updatePersent").show();
					}
				}
			}
		},
	
		getPersent: function(){
			$(this).trigger("ontaskprogress");
		},
	
		applyError: function (evt, err) {
			if (err.id == KL.Utils.Exception.UpdateTask_LicenseError) {
				var errTxt = KL.Utils.Exception.getExceptionText(err.id) || err.message;
				this._page.getApplication().showMessage(errTxt, "LabelDialogTitleError","BtnClose", 300, KL.Web.MessageDialog.MessageType.Error);
			}
		},
		start: function(){
			this._page.getApplication().getContext().setStartedTask(this.datafield,1);
			var elt = this.getElt();
			if (elt) {
				elt.find(commandClass).parent().hide();
				elt.find(".persentValue").html("&nbsp;0%");
				elt.find(".updatePersent").show();
			}
		}
	};
	KL.LMS.Settings.registerClass("UpdateSettingsPreviewPanel", UpdateSettingsPreviewPanel);
	UpdateSettingsPreviewPanel.extend(KL.LMS.Settings.SettingsPreviewPanel);
})()
;
(function () {
	var LdapCnnPreviewControl = function (id, setting) {
		LdapCnnPreviewControl._super.call(this, id, setting);
		this._cnnstatus = this._statuses.Unknown;
	};
	LdapCnnPreviewControl.prototype = {
		_statuses: {
			"Loading": 0,
			"Unavailable": 1,
			"Available": 2,
			"Unknown": 3,
			"NotSet": 4
		},
		errorMessage: "",
		_cnnstatus: null,
		title: "",
		statusunknowntext: "",
		cnnavailabletext: "",
		cnnunavailabletext: "",
		loadingtext: "",
		cnnnotsettext: "",
		disabled: false,
		itemcssclass: "",
		datafield: "",
		_data: null,
		onBtnInited: function () {
			this.setText();
			this.onToggleEnabled();
		},
		onToggleEnabled: function () {
			var elt = this.getElt();
			if (elt) {
				var _enabled = !this.disabled;
				if (this.datafield && this._data) {
					var val = KL.Utils.ObjectHelper.getObjValueByPath(this._data, this.datafield);
					_enabled = _enabled && (val !== KL.LMS.Enums.ScriptTypes.None);
				}
				elt.toggleClass("disabled", (!_enabled|| !this._enabled));
			}
		},
		onDataBind: function (data) {
			this._data = data;
			if (this.datafield && this._data) {
				var val = KL.Utils.ObjectHelper.getObjValueByPath(this._data, this.datafield);
				if (val == KL.LMS.Enums.ScriptTypes.None) {
					this.hide();//this.setStatusNotSet();
					$(this).trigger("onhidepriview");
				} else if (val == KL.LMS.Enums.ScriptTypes.Custom) {
					this.enable();
					this.show();
					$(this).trigger("ontestconnection");
					$(this).trigger("onshowcustompriview");
				} else {
					this.enable();
					this.show();
					$(this).trigger("ontestconnection");
					$(this).trigger("onshowpriview");
				}
			}
			else this.hide();
		},
		setText: function () {
			var elt = this.getElt();
			if (elt) {
				var localization = KL.Utils.Localization.getInstance();
				var valueText = ([
					this.loadingtext,
					this.cnnunavailabletext,
					this.cnnavailabletext,
					this.statusunknowntext,
					this.cnnnotsettext
				])[this._cnnstatus];
				var isLoading = this._cnnstatus == this._statuses.Loading;
				if(this.itemcssclass)
					elt.find(".keyValueItem").addClass(this.itemcssclass);
				
				elt.find(".keyLabel").html(localization.getLocaleString(this.title) + "&nbsp;");
				if (this.id=="ldapBwAvailablePreview"){
					var str = this.cnnavailabletext;
					if (this._cnnstatus == this._statuses.Unavailable) str = this.cnnunavailabletext;
					elt.find(".valueLabel").toggle(!isLoading).html(localization.getLocaleString(valueText) + "&nbsp;");
					elt.find(".valueLoading").toggle(isLoading);
					return;
				}
				if (this._cnnstatus == this._statuses.Unavailable) {
					if (this._data && this._data.integrationType == KL.LMS.Enums.ScriptTypes.Custom)
						elt.find(".valueLabel").toggle(!isLoading).html(localization.getLocaleString(valueText) + "&nbsp;");
					else
						elt.find(".valueLabel").toggle(!isLoading).html(KL.Utils.StringHelper.htmlEncode(this.errorMessage) + "&nbsp;");
				}
				else
					elt.find(".valueLabel").toggle(!isLoading).html(localization.getLocaleString(valueText) + "&nbsp;");
				elt.find(".valueLoading").toggle(isLoading);
			}
		},
		setStatusLoading: function () {
			this._cnnstatus = this._statuses.Loading;
			this.setText();
		},
		setStatusAvailable: function () {
			this._cnnstatus = this._statuses.Available;
			this.setText();
		},
		setStatusNotAvailable: function (evt,data) {
			this.errorMessage=data.message;
			this._cnnstatus = this._statuses.Unavailable;
			this.setText();
		},
		setStatusNotSet: function () {
			this._cnnstatus = this._statuses.NotSet;
			this.disable();
			this.setText();
		}
	};
	KL.LMS.Settings.registerClass("LdapCnnPreviewControl", LdapCnnPreviewControl);
	LdapCnnPreviewControl.extend(KL.Web.Controls.Button);
})()
;
(function () {
	var LdapCnnSettingsForm = function (id, setting) {
		LdapCnnSettingsForm._super.call(this, id, setting);
		this._cnnstatus = this._statuses.Unknown;
	};
	LdapCnnSettingsForm.prototype = {
		_passwdPlaceholder: "*******",
		_servertype: KL.LMS.Enums.ScriptTypes.None,
		
		_statuses: {
			"Loading": 0,
			"Unavailable": 1,
			"Available": 2,
			"Unknown": 3,
			"NotSet": 4
		},
		_cnnstatus: null,
		errorMessage: "",
		
		title: "",
		statusunknowntext: "",
		cnnavailabletext: "",
		cnnunavailabletext: "",
		loadingtext: "",
		cnnnotsettext: "",
		setData: function (e, data, fieldName) {
			this._data = data;
			var ScriptTypes = KL.LMS.Enums.ScriptTypes;
			var sectionName = ScriptTypes.getKeyByValue(data["integrationType"]) || ScriptTypes.getKeyByValue(ScriptTypes.None);
			
			this._map = [
				{ "elt": "servertype", "datasource": "integrationType", "get": "getServerType", "set": "setServerType"},
				{ "elt": "servername", "datasource": sectionName+".host" },
				{ "elt": "cnntype", "datasource": sectionName+".connectionType" },
				{ "elt": "port", "datasource": sectionName+".port" },
				{ "elt": "login", "datasource": sectionName+".bindDn" },
				{ "elt": "passwd", "datasource": sectionName+".password", "get": "getPasswdFieldVal", "set": "setPasswdFieldVal" },
				{ "elt": "searchbase", "datasource": sectionName+".searchBase" }
			];
			this._cnnstatus = this._statuses.Unknown;
			this.setText();
			KL.Utils.ObjectHelper.mapValues(this, this._map, data);
			this.focusField(sectionName + "." + fieldName);
			this.onDataSet();
		},
		setScriptTypes: function (e,value,data) {
			this.setData(e,value);
		},
		
		_prepareForm: function () {
			var Delegate = KL.Utils.Delegate;
			this._form.find("[name=passwd]")
				.focus(Delegate.create(this, this._passwdFocus))
				.blur(Delegate.create(this, this._passwdBlur));
			this._form.find("input[name=port]").numberselect({
				min: 1,
				max:65535,
				defaultValue: 389,
				step: 1
			});
			this._form.find(".btnTest").click(Delegate.create(this, this._checkLdapCnnSettings));
			this._form.find(".valueLabel").show();
			this._form.find("input[type=text]").click(Delegate.create(this, this.setStatusUnknown));
			KL.LMS.Helpers.CommonHelper.fillSelectWidthEnum(this._form.find("[name=cnntype]"), {
				"LDAPoverSSL": KL.LMS.Enums.LdapCnnTypes.LDAPoverSSL,
				"TLS": KL.LMS.Enums.LdapCnnTypes.TLS,
				"NoEncryption": KL.LMS.Enums.LdapCnnTypes.NoEncryption
			}, "LdapCnnType");
			KL.Utils.TooltipHelper.makeTooltips( this._form.find(".helpIco[rel]"), this, this._form );
		},
		_checkLdapCnnSettings: function () {
			if (this._validate()) {
				this.errorMessage="";
				$(this).trigger("onchecksettings");
			}
		},
		setText: function () {
			var elt = this.getElt();
			if (elt) {
				var localization = KL.Utils.Localization.getInstance();
				var valueText = ([
					"LabelSettingsFormCnnLoading",
					"LabelSettingsFormCnnUnavailable",
					"LabelSettingsFormCnnAvailable",
					"LabelSettingsFormCnnUnknown",
					"LabelSettingsFormCnnNotSet"
				])[this._cnnstatus];
				var isLoading = this._cnnstatus == this._statuses.Loading;
				elt.find(".valueLabel").css("padding-left","40px");
				if (this._cnnstatus == this._statuses.Loading)
					elt.find(".valueLabel").addClass("valueLoading");
				else
					elt.find(".valueLabel").removeClass("valueLoading");
				switch (this._cnnstatus ) {
					case this._statuses.Unavailable:
							elt.find(".valueLabel").html(KL.Utils.StringHelper.htmlEncode(this.errorMessage) || "&nbsp;");
							elt.find(".valueLabel").css("color","#af0000");
						break;
					case this._statuses.Available :
							elt.find(".valueLabel").css("color","#005001");
							elt.find(".valueLabel").html(localization.getLocaleString(valueText) || "&nbsp;");
						break;
					case this._statuses.Unknown :
							elt.find(".valueLabel").css("padding-left","10px");
					default:
							elt.find(".valueLabel").css("color","#333");
							elt.find(".valueLabel").html(localization.getLocaleString(valueText) || "&nbsp;");
				}
			}
		},
		
		clone: function (o){
			if(!o || "object" !== typeof o)  {
				return o;
			}
			var c = "function" === typeof o.pop ? [] : {};
			var p, v;
			for(p in o) {
				if(o.hasOwnProperty(p)) {
					v = o[p];
					if(v && "object" === typeof v) {
						c[p] = this.clone(v);
					}
				else c[p] = v;
				}
			}
			return c;
		},
		getValueRecursive: function() {
			if (this._validate() === false) {
				return false;
			}
			
			var oldData = this.clone(this._data);
			for (var i = 0, l = this._map.length; i < l; i++) {
				var map = this._map[i];
				var elt = this.getFormElement(map.elt);
				if (map.set !== null && elt && elt.length > 0) {
					var val = elt.val();
					if (typeof (map.set) != "undefined" && typeof (this[map.set]) == "function")
						val = this[map.set](elt, val, KL.Utils.ObjectHelper.getObjValueByPath(oldData, map.datasource));
					if (typeof (map.validate) != "undefined" && this[map.validate](elt, val) === false) {
						this.showError("");
						elt.focus();
						return false;
					}
					if (typeof (val) != "undefined")
						KL.Utils.ObjectHelper.setObjValueByPath(oldData, map.datasource, val);
				}
			}
			return { data: KL.Utils.JSON.encode(oldData) };
		},
		
		setStatusUnknown: function () {
			this._cnnstatus = this._statuses.Unknown;
			this.setText();
		},
		
		setStatusLoading: function () {
			this._cnnstatus = this._statuses.Loading;
			this.setText();
		},
		setStatusAvailable: function () {
			this._cnnstatus = this._statuses.Available;
			this.setText();
		},
		setStatusNotAvailable: function (evt,data) {
			this.errorMessage=data.message;
			this._cnnstatus = this._statuses.Unavailable;
			this.setText();
		},
		setStatusNotSet: function () {
			this._cnnstatus = this._statuses.NotSet;
			this.disable();
			this.setText();
		},
		
		_passwdFocus: function () {
			var field = this._form.find("[name=passwd]");
			if (field.val() == this._passwdPlaceholder)
				field.val("");
		},
		_passwdBlur: function () {
			var field = this._form.find("[name=passwd]");
			if ($.trim(field.val()) == "")
				field.val(this._passwdPlaceholder);
		},
		onDataSet: function () {
		},
		
		getServerType: function (data, elt, val) {
			var localization = KL.Utils.Localization.getInstance();
			this._servertype = val;
			type = localization.getLocaleString("LabelLdapScriptTypeOption_" + KL.LMS.Enums.ScriptTypes.getKeyByValue(val));
			elt.html("<b>"+type+"</b>");
			if (val==KL.LMS.Enums.ScriptTypes.AD)
			this._form.find(".str-local-LabelSettingsDialogLdadAccName")
				.removeClass("str-local-LabelSettingsDialogLdadAccName")
				.addClass("str-local-LabelSettingsDialogLdadAccNameAD");
		},
		setServerType: function (data, elt, val) {
			return this._servertype;
		},
		getPasswdFieldVal: function (data, elt, val) {
			elt.val(this._passwdPlaceholder);
		},
		setPasswdFieldVal: function (elt, val, oldVal) {
			return val == this._passwdPlaceholder ? oldVal : val;
		},
		_validate: function () {
		
			var searchbase = $.trim(this._form.find("[name=searchbase]").removeClass("error").val());
			if (searchbase === "" ) {
				this._form.find("[name=searchbase]").addClass("error").focus();
				return false;
			}
			
			var servername = $.trim(this._form.find("[name=servername]").removeClass("error").val());
			if (servername === "" ) {
				this._form.find("[name=servername]").addClass("error").focus();
				return false;
			}
			var login = $.trim(this._form.find("[name=login]").removeClass("error").val());
			if (login === "" ) {
				this._form.find("[name=login]").addClass("error").focus();
				return false;
			}
			return true;
		}
	};
	KL.LMS.Settings.registerClass("LdapCnnSettingsForm", LdapCnnSettingsForm);
	LdapCnnSettingsForm.extend(KL.LMS.Settings.BaseSettingsForm);
})()
;
(function () {
	var LdapCnnCustomSettingsForm = function (id, setting) {
		LdapCnnCustomSettingsForm._super.call(this, id, setting);
	};
	LdapCnnCustomSettingsForm.prototype = {
		_map: [
			{ "elt": "BinPath", "datasource": "binPath" }
		],
		
		
		_validate: function () {
			var binPath = $.trim(this._form.find("[name=BinPath]").removeClass("error").val());
			if (binPath == "") {
				this._form.find("[name=BinPath]").addClass("error");
				return false;
			}
			return true;
		}
	};
	KL.LMS.Settings.registerClass("LdapCnnCustomSettingsForm", LdapCnnCustomSettingsForm);
	LdapCnnCustomSettingsForm.extend(KL.LMS.Settings.BaseSettingsForm);
})();
;
(function () {
	var LdapAccessSettingsForm = function (id, setting) {
		LdapAccessSettingsForm._super.call(this, id, setting);
	};
	LdapAccessSettingsForm.prototype = {
		sectionName: null,
		
		setData: function (e, data, fieldName) {
			this._data = data;
			var ScriptTypes = KL.LMS.Enums.ScriptTypes;
			this.sectionName = ScriptTypes.getKeyByValue(data["integrationType"]) || ScriptTypes.getKeyByValue(ScriptTypes.None);
			
			this._map = [
				{ "elt": "backupaccess", "datasource": this.sectionName+".filters.login" },
				{ "elt": "searchstr", "datasource": this.sectionName+".filters.search" },
				{ "elt": "usermatchstr", "datasource": this.sectionName+".filters.user" },
				{ "elt": "childmatchstr", "datasource": this.sectionName+".filters.groupList" },
				{ "elt": "searchrecursive", "datasource": this.sectionName+".filters.useNestedGroups", "get": "setChboxVal", "set": "getIsChecked" }
			];
			KL.Utils.ObjectHelper.mapValues(this, this._map, data);
			this.focusField(this.sectionName + ".filters." + fieldName);
			this.onDataSet();
		},
		_prepareForm: function () {
			var elt = this.getElt();
			if (elt) {
				KL.Utils.TooltipHelper.makeTooltips( elt.find(".helpIco[rel]"), this, elt );
			}
			this._form.find(".backupaccessDefault").click(KL.Utils.Delegate.create(this, this.setDefaultValue,"backupaccess","login"));
			this._form.find(".searchstrDefault").click(KL.Utils.Delegate.create(this, this.setDefaultValue,"searchstr","search"));
			this._form.find(".usermatchstrDefault").click(KL.Utils.Delegate.create(this, this.setDefaultValue,"usermatchstr","user"));
			this._form.find(".childmatchstrDefault").click(KL.Utils.Delegate.create(this, this.setDefaultValue,"childmatchstr","groupList"));
		},
		setDefaultValue: function(elt_name,param_name){
			var elt = this.getElt();
			if (elt) {
				elt.find("[name="+elt_name+"]").val(this._data["default"][this.sectionName]["filters"][param_name]);			
			}
		},
		
		
		onDataSet: function () {},
		_validate: function () {
			var port = $.trim(this._form.find("[name=port]").removeClass("error").val());
			if (port != "" && (isNaN(port * 1) || Math.round(port * 1) != (port * 1))) {
				this._form.find("[name=port]").addClass("error");
				return false;
			}
			return true;
		}
	};
	KL.LMS.Settings.registerClass("LdapAccessSettingsForm", LdapAccessSettingsForm);
	LdapAccessSettingsForm.extend(KL.LMS.Settings.BaseSettingsForm);
})();
;
(function () {
	var LdapTypeSettingsForm = function (id, setting) {
		LdapTypeSettingsForm._super.call( this, id, setting );
	};
	LdapTypeSettingsForm.prototype = {
		_map: [
			{ "elt": "servertype", "datasource": "integrationType", "set": "getRadioVal", "get": "setRadioVal" }
		],
		_prepareForm: function () {
			var CommonHelper = KL.LMS.Helpers.CommonHelper;
			var ScriptTypes = KL.LMS.Enums.ScriptTypes;
			var elt = this.getElt();
			if (elt)
				KL.Utils.TooltipHelper.makeTooltips( elt.find(".helpIco[rel]"), this, elt );
		},
		setRadioVal: function (data, elt, val) {
			elt.val([val]);
		},
		getRadioVal: function (elt, val) {
			return elt.filter(":checked").val();
		},
		
		checkScriptTypes: function(e,value,data) {
			if (value.servertype=="0") {
				$(this).trigger("onsave",data._data);
			}
			
			else{
				$(this).trigger("onshowdialog",data._data);
			}
		},
		onDataSet: function () {}
	};
	KL.LMS.Settings.registerClass("LdapTypeSettingsForm", LdapTypeSettingsForm);
	LdapTypeSettingsForm.extend(KL.LMS.Settings.BaseSettingsForm);
})()
;
(function () {
	var NotificationEditForm = function (id, setting) {
		NotificationEditForm._super.call( this, id, setting );
	};
	NotificationEditForm.prototype = {
		_submitData: null,
		_datafield: "",
		_optionsData: null,
		_optionsVisible: false,
		_focusfield: "",
		_focusOptions: false,
		onFormInit: function () {
			this._form.find(".optionsField").hide();
			if (!!this._submitData && !!this._datafield)
				this._bindFormVals();
			this._form.find(".btnCancel").click(KL.Utils.Delegate.create(this, this._cancel));
		},
		onBeforeShow: function () {
			this.hideError();
			this.hideSuccess();
			this.checkFieldEmpty(true);
		},
		setOptions: function (e, data, datafield, eventname) {
			this._optionsData = {"data": data, "field": datafield, "eventname": eventname};
			this._optionsVisible = true;
			if( this._focusOptions )
				this._focusfield = datafield;
			var optionVal = KL.Utils.ObjectHelper.getObjValueByPath(this._optionsData.data, this._optionsData.field);
			var optionField = this._form.find(".optionsField").show().find(".expireText");
			optionField.numberselect({"min": 0, "max": 99});
			optionField.val(optionVal);
		},
		focusOptions: function() {
			this._focusOptions = true;
		},
		getValueRecursive: function () {
			if (this._submitData) {
				return { data: KL.Utils.JSON.encode(this._submitData) };
			}
			return null;
		},
		_setTitle: function (datafield) {
			var localization = KL.Utils.Localization.getInstance();
			var title = localization.getLocaleValueString("LabelDialogTitleEditNotification");
			var prefix = datafield.substr(datafield.indexOf(".")+1);
			
			title=title+" ("+localization.getLocaleValueString("LabelDialogTitleEditNotification_"+prefix)+")";
			
			this._page.setTitle(title);
		},
		
		setData: function (e, data, datafield, fieldName) {
			this._setTitle(datafield);
			this._submitData = data;
			this._datafield = datafield;
			this._focusfield = fieldName;
			this._optionsData = null;
			this._optionsVisible = false;
			if (this.isVisible())
				this._bindFormVals();
		},
		_bindFormVals: function () {
			var val = KL.Utils.ObjectHelper.getObjValueByPath(this._submitData, this._datafield);
			if (val) {
				this._form.find(".optionsField").hide();
				if (typeof (val["subject"]) != "undefined")
					this._form.find(".subjField").val(val.subject);
				if (typeof (val["body"]) != "undefined")
					this._form.find(".bodyField").val(val.body);
			}
		},
		onShown: function(){
			window.setTimeout( KL.Utils.Delegate.create(this, function(){
				if (this._focusfield == (this._datafield+".subject"))
					this._form.find(".subjField").focus();
				if (this._focusfield == (this._datafield+".body"))
					this._form.find(".bodyField").focus();
				if( this._focusOptions && this._optionsData && this._focusfield == this._optionsData.field )
					this._form.find(".optionsField .expireText").focus();
				this._focusOptions = false;
			}), 100);
		},
		onFormSubmit: function () {
			var ObjectHelper = KL.Utils.ObjectHelper;
			ObjectHelper.setObjValueByPath(this._submitData, this._datafield + ".subject", this._form.find(".subjField").val());
			ObjectHelper.setObjValueByPath(this._submitData, this._datafield + ".body", this._form.find(".bodyField").val());
			if( this._optionsVisible && this._optionsData ){
				ObjectHelper.setObjValueByPath(this._optionsData.data, this._optionsData.field, this._form.find(".optionsField .expireText").val());
				if(this._optionsData.eventname)
					$(this).trigger(this._optionsData.eventname);
			}
			this._optionsVisible = false;
			this._optionsData = null;
		},
		_toggleNotificationEnabled: function (data, datafield, val) {
			KL.Utils.ObjectHelper.setObjValueByPath(data, datafield, val);
			this._submitData = data;
			$(this).trigger("onformsubmit");
		},
		setNotifictionEnabled: function (e, data, datafield) {
			this._toggleNotificationEnabled(data, datafield, true);
		},
		setNotifictionDisabled: function (e, data, datafield) {
			this._toggleNotificationEnabled(data, datafield, false);
		},
		_cancel: function () {
			this._page.closeDialog();
		}
	};
	KL.LMS.Settings.registerClass("NotificationEditForm", NotificationEditForm);
	NotificationEditForm.extend(KL.Web.Controls.FormControl);
})()
;
(function () {
	var NotificationEmailEditForm = function (id, setting) {
		NotificationEmailEditForm._super.call( this, id, setting );
	};
	NotificationEmailEditForm.prototype = {
		_submitData: null,
		oldValue: null,
		onFormInit: function () {
			this._form.find(".emailField").listeditor({
				"itemText": ".itemText"
			}).bind("onitemcreate", KL.Utils.Delegate.create(this, this._bindItemDelete));
			if (!!this._submitData)
				this._bindFormVals();
			this._form.find(".btnCancel").click(KL.Utils.Delegate.create(this, this._cancel));
			this._form.find(".emailField").keypress(KL.Utils.Delegate.create(this, this._closeError));
		},
		_closeError: function(){
			this._form.find(".emailField").removeClass("error");
		},
		_bindItemDelete: function (e, item, data, indx) {
			item.find(".itemDelBtn").click(KL.Utils.Delegate.create(this, this._deleteItem, indx));
		},
		_deleteItem: function ( indx, e) {
			this._form.find(".emailField").listeditor("removeNumItem", indx);
			return false;
		},
		onBeforeShow: function () {
			this.hideError();
			this._form.find(".emailField").removeClass("error");
			this.hideSuccess();
			this.checkFieldEmpty(true);
		},
		getValueRecursive: function () {
			if (this._submitData) {
				return { data: KL.Utils.JSON.encode(this._submitData) };
			}
			return null;
		},
		setData: function (e, data) {
			this._submitData = data;
			if (this.isVisible())
				this._bindFormVals();
		},
		applyError: function (e,data) {
			var localization = KL.Utils.Localization.getInstance();
			this.showError(-1,localization.getLocaleString("LabelSettingsPreviewNotificationsEmail_Error"));
			this._form.find(".emailField").addClass("error").focus();
			this._submitData.adminEmailAddresses = this.oldValue ;
		},		
		
		_bindFormVals: function () {
			if (this._submitData) {
				var d = $.trim(this._submitData.adminEmailAddresses) ? $.trim(this._submitData.adminEmailAddresses).split(/[\n;,]/gi) : [];
				this._form.find(".emailField").listeditor("setValue", d || "");
				this.oldValue = this._submitData.adminEmailAddresses;
			}
		},
		onFormSubmit: function () {
			if (this._submitData)
				this._submitData.adminEmailAddresses = this._form.find(".emailField").listeditor("getValue").join(",");
		},
		_cancel: function () {
			this._page.closeDialog();
		}
	};
	KL.LMS.Settings.registerClass("NotificationEmailEditForm", NotificationEmailEditForm);
	NotificationEmailEditForm.extend( KL.Web.Controls.FormControl );
})()
;
(function () {
	function _appendAddressItem(result){
		if (this._currAddrEditor) {
			var results = null;
			if( result && result.items && result.items.length > 0 ){
				results = {};
				for( var i=0, l=result.items.length; i<l; i++ )
					results[result.items[i].element] = !!result.items[i].valid;
			}
			var editor = this._currAddrEditor;
			var textBox = editor.find(".textbox").removeClass("error");
			var newRecord = $.trim(textBox.val());
		
			if 	(editor.listeditor("isDuplicate",newRecord)) {
				this._page.getApplication().showMessage("ErrorDuplicateRecord", "LabelDialogTitleError", "BtnClose", 300, KL.Web.MessageDialog.MessageType.Error);
				textBox.addClass("error");
			} else if (results && results[ newRecord ]) {
				var isEdit = editor.data("is-editmode");
				editor.listeditor((isEdit?"saveItem":"addItem"), newRecord);
				textBox.attr("readOnly",false);
				textBox.val("");
			} else
				textBox.addClass("error");
		}
	}
	var BWListsForm = function (id, setting) {
		BWListsForm._super.call( this, id, setting );
	};
	BWListsForm.prototype = {
		_ldapSearch: null,
		_selectedItem: null,
		_blackListEditor: null,
		_whiteListEditor: null,
		_isEdited: false,
		_cancelChangeEvt: true,
		mode: "normal",
		errorText: ".infoLdapFoundCount",
		
		onFormInit: function () {
			var Delegate = KL.Utils.Delegate;
			this._selectedItem = null;
			this._isEdited = false;
			this._blackListEditor = this._form.find(".blackListEditor");
			this._whiteListEditor = this._form.find(".whiteListEdotor");
			this._blackListEditor.listeditor({
				"isSaveOnClick": true,
				"checkDuplicate":true,
				"validateOnSave": Delegate.create(this, this._validateEmail, this._blackListEditor)
			}).bind("onitemselect", Delegate.create(this, this._toggleDelBtn, this._blackListEditor))
				.bind("onvaluechange", Delegate.create(this, this._setDataChanged, this._blackListEditor, true));
			this._whiteListEditor.listeditor({
				"isSaveOnClick": true,
				"checkDuplicate":true,
				"validateOnSave": Delegate.create(this, this._validateEmail, this._whiteListEditor)
			}).bind("onitemselect", Delegate.create(this, this._toggleDelBtn, this._whiteListEditor))
				.bind("onvaluechange", Delegate.create(this, this._setDataChanged, this._whiteListEditor, false));
			this._blackListEditor.find(".delBtn").click(Delegate.create(this, this._deleteListItem, this._blackListEditor));
			this._whiteListEditor.find(".delBtn").click(Delegate.create(this, this._deleteListItem, this._whiteListEditor));
			this._ldapSearch = KL.LMS.Helpers.LdapHelper.makeSearchPanel(this._form.find(".ldapPanel"), true);
			$(this._ldapSearch)
				.bind("onsearch", Delegate.create(this, this._search))
				.bind("onbeforeitemselected", Delegate.create(this, this._checkEdited))
				.bind("onitemselected", Delegate.create(this, this._triggerSelected));
			this._form.find(".btnsBar").hide();
			if (KL.Utils.UserHelper.isPriveleged()){
				if( this.mode == "dialog" )
					this._form.find(".btnsBar").show();
				this._form.addClass("ldapSeachEnabled");
				this._toggleListsVisible(false);
			} else {
				this._form.find(".searchLdap").hide();
				this._form.find(".userListsTitle").hide();
				$(this).trigger("onaccountselected");
			}
			
			this._form.find(".btnCancel, .btnClose").click(Delegate.create(this, this._cancel));
			this._form.find(".btnOk").click(Delegate.create(this, this._saveClose));
			this._toggleButtons();
		},
		
		getUserAccount: function () {
			if (KL.Utils.UserHelper.isPriveleged())
				return this._selectedItem["entryid"];
			else
				return "";
		},
		getSearchTerm: function () {
			return this._ldapSearch.getSearchTerm();
		},
		getSearchLimit: function () {
			return this._ldapSearch.getSearchLimit();
		},
		applySearchResult: function (e, data) {
			this._isEdited = false;
			this._form.removeClass( "searchErr" );
			this._ldapSearch.addItems(data);
		},
		applyError: function (evt, err) {
			this._form.addClass( "searchErr" );
			BWListsForm._super.prototype.applyError.call( this, evt, err );
		},
		_search: function () {
			this._form.removeClass( "searchErr" );
			if (!!this._isEdited) {
				var cnf = this._page.getApplication().openConfirm("LabelConfirmInfoUnsavedBWLists", "LabelConfirmTitleUnsavedBWLists", { "ok": "BtnYes", "cancel": "BtnNo" });
				$(cnf).bind("onok", KL.Utils.Delegate.create(this, function () {
					this._isEdited = false; 
					window.setTimeout(KL.Utils.Delegate.create(this, function () { $(this).trigger("searchLDAP"); }), 0);
					}));
			}
			else 
				window.setTimeout(KL.Utils.Delegate.create(this, function () { $(this).trigger("searchLDAP"); }), 0);
		},
		_checkEdited: function (e, callback) {
			if (!!this._isEdited) {
				this._form.removeClass( "searchErr" );
				e.preventDefault();
				var cnf = this._page.getApplication().openConfirm("LabelConfirmInfoUnsavedBWLists", "LabelConfirmTitleUnsavedBWLists", { "ok": "BtnYes", "cancel": "BtnNo" });
				$(cnf).bind("onok", KL.Utils.Delegate.create(this, function () { this._isEdited = false; callback(); }));
			}
		},
		_triggerSelected: function (e, count) {
			this._selectedItem = null;
			
			this._cancelChangeEvt = true;
			this._toggleListsVisible(false);
			this._blackListEditor.listeditor("clear");
			this._whiteListEditor.listeditor("clear");
			this._cancelChangeEvt = true;
			this._isEdited = false;
			this._toggleButtons();
			if (count > 0) {
				this._selectedItem = this._ldapSearch.getSelectedItems()[0];
				window.setTimeout(KL.Utils.Delegate.create(this, function () { $(this).trigger("onaccountselected"); }), 0);
			}
		},
		
		_toggleDelBtn: function (editor, e, isSelected) {
			if (isSelected)
				editor.find(".addIco").addClass("okIco").removeClass("addIco");
			else
				editor.find(".okIco").addClass("addIco").removeClass("okIco");
			
			editor.find(".delBtn").attr("disabled", !isSelected).toggleClass("disabled", !isSelected);
			editor.data("is-editmode", isSelected);
		},
		_trySubmit: function(){
			if (this.mode !== "dialog" && !this._cancelChangeEvt)
				this._form.submit();
		},
		_deleteListItem: function (editor) {
			editor.listeditor("removeItem");
		},
		_setDataChanged: function (editor, isBlackList, e, data) {
			this._isEdited = true;
			this._updateListTitle(editor, isBlackList, e, data);
			this._toggleButtons();
			this._toggleDelBtn(editor, null, false);
			this._trySubmit();
		},
		_updateListTitle: function (editor, isBlackList, e, data) {
			var localization = KL.Utils.Localization.getInstance();
			var l = data.length;
			var t = isBlackList ? "LabelTitleBlackListLength" : "LabelTitleWhiteListLength";
			editor.find(".listTitle").empty()
				.append(localization.getLocaleStringObj(t + localization.getLocaleSuffixNum(l), l));
		},
		_toggleListsVisible: function (visible) {
			this._form.find(".listsEditors").css("visibility", visible ? "visible" : "hidden");
			this._toggleDelBtn(this._blackListEditor, null, false);
			this._toggleDelBtn(this._whiteListEditor, null, false);
		},
		_validateEmail: function (editor, val) {
			this._currAddrEditor = editor;
			$(this).trigger("onwildcardvalidate", [val]);
			return false;
		},
		getValidatingValue: function () {
			if (this._currAddrEditor)
				return KL.Utils.JSON.encode({"items": [this._currAddrEditor.find(".editField").val()]});
		},
		setWildcardQueryIsValid: function (e, result, isComplete) {
			if( isComplete )
				_appendAddressItem.call( this, result );
		},
		applyListsData: function (e, data) {
			this._cancelChangeEvt = true;
			this._blackListEditor.listeditor("clear");
			this._whiteListEditor.listeditor("clear");
			this._isEdited = false;
			var isImport = true;
			if (data) {
				var StringHelper = KL.Utils.StringHelper;
				this._toggleListsVisible(true);
				
				try {
				this._form.find(".userListsTitle").empty()
					.append(KL.Utils.Localization.getInstance().getLocaleStringObj("LabelTitleUsersPersonalLists", this._form.find(".ldapPanel").find(".itemSelected").text()));
				}
				catch(e){
				}
				if (data.blackList) {
					this._blackListEditor.listeditor("setValue", data.blackList);
					this._updateListTitle(this._blackListEditor, true, null, data.blackList);
				}
				if (data.whiteList) {
					this._whiteListEditor.listeditor("setValue", data.whiteList);
					this._updateListTitle(this._whiteListEditor, false, null, data.whiteList);
				}
				this._toggleButtons();
				this._blackListEditor.find(".importBtn").click(KL.Utils.Delegate.create(this, this._openImportEditor, data.blackList,this._blackListEditor,"LabelTitlePasteAddressesDialog_Black",isImport));
				this._blackListEditor.find(".exportBtn").click(KL.Utils.Delegate.create(this, this._openImportEditor, data.blackList,this._blackListEditor,"LabelTitlePasteAddressesDialogExport_Black",!isImport));
				this._whiteListEditor.find(".importBtn").click(KL.Utils.Delegate.create(this, this._openImportEditor, data.whiteList,this._whiteListEditor,"LabelTitlePasteAddressesDialog_White",isImport));
				this._whiteListEditor.find(".exportBtn").click(KL.Utils.Delegate.create(this, this._openImportEditor, data.whiteList,this._whiteListEditor,"LabelTitlePasteAddressesDialogExport_White",!isImport));
			}
			this._cancelChangeEvt = false;
		},
		_openImportEditor : function (p1, editor,name,isImport ) {
			var _d_array = editor.listeditor("getValue");
			var _d_array_object = [];
			for( var i=0, l=_d_array.length; i<l; i++ ){
				_d_array_object.push({
					"type":KL.LMS.Enums.AddrsTypes.getKeyByValue(KL.LMS.Enums.AddrsTypes.EMailMask),
					"value":_d_array[i]
				});
			}
			
			var objData = {
				data: _d_array_object,
				isImport:isImport,
				title: name
			};
			this._currAddrEditor = editor;
			$(this).trigger("onimportlist",[objData]);
			return false;
		},
		setImportAddresses : function(e, items){
			if (this._currAddrEditor && items) {
				var editor = this._currAddrEditor;
				this._cancelChangeEvt = true;
				for( var i=0, l=items.length; i<l; i++ ){
					var newRecord = items[i];
					if (!editor.listeditor("isDuplicate",newRecord.value))
						editor.listeditor("addItem", newRecord.value);
				}
				this._cancelChangeEvt = false;
				this._trySubmit();
			}
		},
		_toggleButtons: function () {
			this._form.find(".leftBtns").toggle(this._isEdited);
			this._form.find(".btnClose").toggle(!this._isEdited);
			this._form.find(".btnCancel").toggle(this._isEdited);
		},
		getValueRecursive: function () {
		
			return { "account": this.getUserAccount(), "data": KL.Utils.JSON.encode({
					"blackList": this._blackListEditor.listeditor("getValue"),
					"whiteList": this._whiteListEditor.listeditor("getValue")
				})
			};
		},
		applySaveComplete: function () {
			this._isEdited = false;
			this._toggleButtons();
		},
		_saveClose: function () {
			this._isEdited = false;
			this._form.submit();
			this._cancel();
		},
		
		_cancel: function () {
			if (!!this._isEdited) {
				var cnf = this._page.getApplication().openConfirm("LabelConfirmInfoUnsavedBWLists", "LabelConfirmTitleUnsavedBWLists", { "ok": "BtnYes", "cancel": "BtnNo" });
				$(cnf).bind("onok", KL.Utils.Delegate.create(this, function () {
					this._isEdited = false; 
					this._page.closeDialog();
					}));
			}
			else 
				this._page.closeDialog();
		}
	};
	KL.LMS.Settings.registerClass("BWListsForm", BWListsForm);
	BWListsForm.extend(KL.Web.Controls.FormControl);
})()
;
(function () {
	var KeyValueListControl = function (id, setting) {
		this._events = {};
		KeyValueListControl._super.call( this, id, setting);
	};
	KeyValueListControl.prototype = {
		_data: null,
		_events: null,
		onBeforeDataBind: function (data) {
			this._data = data;
		},
		onItemDataBound: function (data, dataItem, itemInfo, itemElt) {
			if (itemElt){
				var handler = KL.Utils.Delegate.create(this, this._triggerItemEvent, data, dataItem, itemInfo);
				var evt = ([]).concat(itemInfo.event||"onitemclick");
				for( var i=0, l=evt.length; i<l; i++ )
					this._events[evt[i]] = handler;
				itemElt.filter("a").click(handler);
			}
		},
		onToggleEnabled: function () {
			var elt = this.getElt();
			if (elt)
				elt.toggleClass("disabled", !this._enabled);
		},
		fireChangeEvent: function(evtName, e){
			if( typeof(this._events[evtName]) == "function"){
				var evt = $.Event( evtName );
				this._events[evtName](evt);
			}
		},
		_triggerItemEvent: function (fullData, dataItem, itemInfo, e) {
			e.preventDefault();
			e.stopPropagation();
			if (this._enabled) {
				var data = this._data;
				if (this.datafield)
					data = KL.Utils.ObjectHelper.getObjValueByPath(this._data, this.datafield);
				data = [(data == null || typeof (data) == "undefined") ? this._data : data];
				if (typeof (itemInfo["clickparams"]) != "undefined") {
					if (itemInfo.clickparams instanceof Array)
						data = data.concat(itemInfo.clickparams);
					else
						data.push(itemInfo.clickparams);
				}
				
				data.push(itemInfo.value);
				
				if( this._events[e.type] )
					$(this).trigger(e.type, data);
				else{
					var evt = ([]).concat(itemInfo.event||"onitemclick");
					for( var i=0, l=evt.length; i<l; i++ )
						$(this).trigger(evt[i], data);
				}
			}
			return false;
		}
	};
	KL.LMS.Settings.registerClass("KeyValueListControl", KeyValueListControl);
	KeyValueListControl.extend(KL.Web.Controls.KeyValueListControl);
})()
;
(function () {
	var KeyValueListControlLdapCnn = function (id, setting) {
		KeyValueListControlLdapCnn._super.call( this, id, setting );
	};
	KeyValueListControlLdapCnn.prototype = {
		onBeforeDataBind: function (data) {
			this._data = data;
			if (data.integrationType==KL.LMS.Enums.ScriptTypes.AD) 
				this.items[2].title="LabelSettingsPreviewCnnLdadAccNameAD";
			else 
				this.items[2].title="LabelSettingsPreviewCnnLdadAccName";
		}
	};
	KL.LMS.Settings.registerClass("KeyValueListControlLdapCnn", KeyValueListControlLdapCnn);
	KeyValueListControlLdapCnn.extend(KL.LMS.Settings.KeyValueListControl);
})()
;
(function () {
	var ListValueControl = function (id, setting) {
		ListValueControl._super.call( this, id, setting );
	};
	ListValueControl.prototype = {
		_data: null,
		_hiddenContainer: null,
		onInitInteraction: function () {
			var elt = this.getElt();
			if (elt) {
				this._itemsContainer = elt.find(".visibleList");
				this._itemTemplate = this._itemsContainer.html();
				this._itemsContainer.empty();
				this._hiddenContainer = elt.find(".hiddenList");
				this._hiddenContainer.empty();
			}
		},
		onDataBind: function (data) {
			if (!this._itemsContainer)
				return;
			if (typeof (this.onBeforeDataBind) == "function")
				this.onBeforeDataBind(data);
			this._itemsContainer.empty();
			this._hiddenContainer.empty().hide();
			if (this.items instanceof Array && this.items.length > 0) {
				var itemInfo = $.extend({}, this.items[0]);
				var visibleCount = itemInfo.visiblecount;
				var value = "";
				if (itemInfo.value) {
					value = itemInfo.value;
					delete itemInfo.value;
				}
				var d = KL.Utils.ObjectHelper.getObjValueByPath(this._getStatData(data), value);
				
				if (d instanceof Array && d.length > 0) {
					for (var i = 0, l = d.length; i < l; i++) {
						this._makeItem(data, d[i], itemInfo, (i < visibleCount ? this._itemsContainer : this._hiddenContainer));
					}
				}else
					this._makeItem(data, d, itemInfo, this._itemsContainer);
			}
			if (typeof (this.onDataBound) == "function")
				this.onDataBound(data);
		},
		_makeItem: function (data, d, item, container) {
			if (typeof (this.onItemDataBind) == "function")
				this.onItemDataBind(data);
			var dataItem = new KL.Web.Controls.KeyValueListItem(item, this._itemTemplate);
			dataItem.allowhtml = this.allowhtml;
			var itemObj = dataItem.bind(d);
			if (itemObj)
				container.append(itemObj);
			if (typeof (this.onItemDataBound) == "function")
				this.onItemDataBound(data, d, item, itemObj);
		},
		expand: function () {
			if(this._hiddenContainer)
				this._hiddenContainer.slideDown();
		},
		collapse: function () {
			if (this._hiddenContainer)
				this._hiddenContainer.slideUp();
		}
	};
	KL.LMS.Settings.registerClass("ListValueControl", ListValueControl);
	ListValueControl.extend(KL.LMS.Settings.KeyValueListControl);
})()
;
(function () {
	var StatusPanel = function (id, setting) {
		StatusPanel._super.call( this, id, setting );
	};
	StatusPanel.prototype = {
		text: "",
		_canBeShown: false,
		onInitInteraction: function () {
			var elt = this.getElt();
			if (elt) {
				elt.find(".closeInfoBtn").click(KL.Utils.Delegate.create(this, this.hide));
			}
		},
		onBeforeShow: function () {
			var elt = this.getElt();
			if (elt) {
				elt.hide();
				if (this.text) {
					var txt = KL.Utils.Localization.getInstance().getLocaleString(this.text);
					elt.find(".notificationAreaMessage").html(txt);
				}
			}
			return this._canBeShown;
		}
	};
	KL.LMS.Settings.registerClass("StatusPanel", StatusPanel);
	StatusPanel.extend(KL.Web.Controls.Control);
})();
;
(function () {
	var AvProtectionEditForm = function (id, setting) {
		AvProtectionEditForm._super.call(this, id, setting);
	};
	AvProtectionEditForm.prototype = {
		closeoncancel: true,
		_map: [
			{ "elt": "useHeuristics", "datasource": "scanLogic.avSettings.useAnalyzer", "get": "setBoolSelectVal", "set": "getBoolSelectVal" },
			{ "elt": "heuristicsLvl", "datasource": "scanLogic.avSettings.heuristicLevel" },
			{ "elt": "maxScanTime", "datasource": "scanLogic.avSettings.scanTimeLimit" },
			{ "elt": "maxNestingLvl", "datasource": "scanLogic.avSettings.maxNestingLevel" }
		],
		_prepareForm: function () {
			var isEnabled = KL.Web.Application.getContext().getIsLicenseAvEnabled();
			this._form.find("fieldset").toggleClass("disabled", !isEnabled).find( "input,textarea,select" ).attr("disabled", !isEnabled);
			this._form.find(".setDefaultLink, .btnOk")[isEnabled?"show":"hide"]();
			this.hideError();
			var CommonHelper = KL.LMS.Helpers.CommonHelper;
			this._form.find(".maxScanTime").numberselect();
			this._form.find(".maxNestingLvl").numberselect();
			CommonHelper.fillSelectWidthEnum(this._form.find("[name=heuristicsLvl]"), {
				"Light": KL.LMS.Enums.HeuristicLevelType.Light,
				"Medium": KL.LMS.Enums.HeuristicLevelType.Medium,
				"Deep": KL.LMS.Enums.HeuristicLevelType.Deep
			}, "HeuristicLevel");
		},
		onDataSet: function () {
			this.hideError();
		},
		_validate: function () {
			return true;
		}
	};
	KL.LMS.Settings.registerClass("AvProtectionEditForm", AvProtectionEditForm);
	AvProtectionEditForm.extend(KL.LMS.Settings.BaseSettingsForm);
})()
;
(function () {
	var AsProtectionEditForm = function (id, setting) {
		AsProtectionEditForm._super.call(this, id, setting);
	};
	AsProtectionEditForm.prototype = {
		closeoncancel: true,
		_map: [
			{ "elt": "dnsTimeout", "datasource": "scanLogic.asSettings.externalServices.dnsTimeout" },
			{ "elt": "useKSN", "datasource": "scanLogic.asSettings.useKsnStatus", "get": "setBoolSelectVal", "set": "getBoolSelectVal" },
			{ "elt": "useEnforcedAntiSpamUpdatesService", "datasource": "scanLogic.asSettings.useEnforcedAntiSpamUpdatesService", "get": "setBoolSelectVal", "set": "getBoolSelectVal" },
			{ "elt": "useRate", "datasource": "scanLogic.asSettings.enableReputationFiltering", "get": "setBoolSelectVal", "set": "getBoolSelectVal" },
			{ "elt": "maxScanTime", "datasource": "scanLogic.asSettings.scanTimeLimit" }
		],
		_prepareForm: function () {
			this.hideError();
			var elt = this.getElt();
			if (elt){
				var isEnabled = KL.Web.Application.getContext().getIsLicenseAsEnabled();
				this._form.find("fieldset").toggleClass("disabled", !isEnabled).find( "input,textarea,select" ).attr("disabled", !isEnabled);
				this._form.find(".setDefaultLink, .btnOk")[isEnabled?"show":"hide"]();
				KL.Utils.TooltipHelper.makeTooltips( elt.find(".helpIco[rel]"), this, elt );
			}
		},
		onDataSet: function () {
			this.hideError();
		},
		_validate: function () {
			return true;
		}
	};
	KL.LMS.Settings.registerClass("AsProtectionEditForm", AsProtectionEditForm);
	AsProtectionEditForm.extend(KL.LMS.Settings.BaseSettingsForm);
})();
;
(function () {
	var AfProtectionEditForm = function (id, setting) {
		AfProtectionEditForm._super.call(this, id, setting);
	};
	AfProtectionEditForm.prototype = {
		closeoncancel: true,
		_map: [
			{ "elt": "useKSN", "datasource": "scanLogic.apSettings.useKsnStatus", "get": "setBoolSelectVal", "set": "getBoolSelectVal" },
			{ "elt": "maxScanTime", "datasource": "scanLogic.apSettings.scanTimeLimit" },
			{ "elt": "useHeuristicAntiPhishing", "datasource": "scanLogic.apSettings.enableHeuristic", "get": "setBoolSelectVal", "set": "getBoolSelectVal" }
		],
		_prepareForm: function () {
			this.hideError();
			var elt = this.getElt();
			if (elt){
				var isEnabled = KL.Web.Application.getContext().getIsLicenseApEnabled();
				this._form.find("fieldset").toggleClass("disabled", !isEnabled).find( "input,textarea,select" ).attr("disabled", !isEnabled);
				this._form.find(".setDefaultLink, .btnOk")[isEnabled?"show":"hide"]();
				KL.Utils.TooltipHelper.makeTooltips( elt.find(".helpIco[rel]"), this, elt );
			}
		},
		onDataSet: function () {
			this.hideError();
		},
		_validate: function () {
			return true;
		}
	};
	KL.LMS.Settings.registerClass("AfProtectionEditForm", AfProtectionEditForm);
	AfProtectionEditForm.extend(KL.LMS.Settings.BaseSettingsForm);
})()
;
(function () {
	var BlackListEditForm = function (id, setting) {
		BlackListEditForm._super.call( this, id, setting );
	};
	BlackListEditForm.prototype = {
		closeoncancel: true,
		_subfield: null,
		_map: [
			{ "elt": "listEditField", "datasource": "", "set": "getListVal", "get": "setListVal" }
		],
		_prepareForm: function () {
			this.hideError();
			
		},
		_validate: function(){
			var elt = this.getFormElement(this._map[0].elt),
				retVal = !!elt,
				val = $.trim(elt.val()||"").replace(/;/g,"\n");
			if( retVal && !!val && !(/^[a-z0-9\.\-]+[a-z0-9\.]$/gim).test( val ) ){
				this.showError( -1, "ErrorDNSBL_SURBLBadCharacters" );
				retVal =  false;
			}
			return retVal;
		},
		setListVal: function (data, elt, val) {
			elt.val(((val instanceof Array)?val:[]).join("\n"));
		},
		getListVal: function (elt, val) {
			var retVal = [];
				val_i = ((val || "") + "").split(/[\n,\;]/g);
			for( var i=0, l=val_i.length; i<l; i++ )
				if( !!$.trim(val_i[i]) )
					retVal.push(val_i[i]);
			return retVal;
		},
		setData: function (e, data, fieldName) {
			this._data = data;
			for (var i = 0, l = this._map.length; i < l; i++)
				this._map[i].datasource = fieldName;
			KL.Utils.ObjectHelper.mapValues(this, this._map, data);
			this.focusField(fieldName);
			this.hideError();
		}
	};
	KL.LMS.Settings.registerClass("BlackListEditForm", BlackListEditForm);
	BlackListEditForm.extend(KL.LMS.Settings.BaseSettingsForm);
})()
;
(function () {
	var KsnLicenseAcceptForm = function (id, setting) {
		KsnLicenseAcceptForm._super.call(this, id, setting);
	};
	KsnLicenseAcceptForm.prototype = {
		closeoncancel: true,
		_licenseText: "",
		_map: [
			{ "elt": "licenseStatus", "datasource": "ksnParticipationActivated", "get": "setBoolRadioVal", "set": "getBoolRadioVal" }
		],
		_prepareForm: function () {
			this.hideError();
			
			this._licenseText = "";
			this._renderLicense();
		},
		setBoolRadioVal: function (data, elt, val) {
			elt.val([val ? "1" : "0"]);
		},
		getBoolRadioVal: function (elt, val) {
			val = elt.filter(":checked").val();
			return (val * 1) == 1;
		},
		onDataSet: function () {
			this.hideError();
		},
			
		_renderLicense: function () {
			var elt = this.getElt();
			if (elt)
				elt.find(".licenseTextPanel .textContent").html(this._licenseText);
		},
		setLicenseText: function (e, data) {
			var arr = data.replace(/\r/gm, "").replace(/\n+/g, "\n").split("\n");
			if (arr.length > 0) {
				var title = "<h3>" + arr[0] + "</h3><p>";
				arr = arr.slice(1);
				this._licenseText = title + arr.join("</p><p>") + "</p>";
				this._renderLicense();
			}
		},
		getLanguage: function () {
			return this._page.getApplication().getContext().getLanguage();
		},
		_validate: function () {
			return true;
		}
	};
	KL.LMS.Settings.registerClass("KsnLicenseAcceptForm", KsnLicenseAcceptForm);
	KsnLicenseAcceptForm.extend(KL.LMS.Settings.BaseSettingsForm);
})()
;
(function () {
	var BackupSettingsForm = function (id, setting) {
		BackupSettingsForm._super.call( this, id, setting );
	};
	BackupSettingsForm.prototype = {
		_map: [
			{ "elt": "MaxSize", "datasource": "maxSize", "get": "setMaxSizeMB", "set": "getMaxSizeMB" },
			{ "elt": "Threshold", "datasource": "threshold" },
			{ "elt": "AvThreatsRestoration", "datasource": "allowAvThreatsRestoration", "get": "setBoolSelectVal", "set": "getBoolSelectVal" },
			{ "elt": "BackupFailureAction", "datasource": "scanLogic.backupFailureAction"}
		],
		_prepareForm: function () {
			this.hideError();
			var BackupFailureActionType = KL.LMS.Enums.BackupFailureActionType;
			this._form.find("input[name=MaxSize]").numberselect({
				min: 100 ,
				defaultValue: 1024 ,
				step: 1
			});
			this._form.find("input[name=Threshold]").numberselect({
				min: 10,
				max: 90,
				defaultValue: 50,
				step: 1
			});
			var BackupFailureAction = this._form.find("[name=BackupFailureAction]");
			
			for (var i = 0; i < BackupFailureActionType._keys.length; i++) {
				var key = BackupFailureActionType._keys[i];
				var localization = KL.Utils.Localization.getInstance();
				BackupFailureAction.append( KL.Utils.StringHelper.format('<option value="{0}">{1}</option>', i, localization.getLocaleValueString("LabelSettingsBackupFailureAction_"+ key)));
			}
			KL.Utils.TooltipHelper.makeTooltips( this._form.find(".helpIco[rel]"), this, this._form );
		},
		setMaxSizeMB: function (data, elt, val) {
				var size =  Math.round(val/1024/1024 * 100) / 100;
				elt.val([size]);
		},
		getMaxSizeMB: function (elt, val) {
				return val * 1024*1024;
		},
		
		onDataSet: function () {
			this.hideError();
		},
		_validate: function () { 
			if (this._form) {
				var size = this._form.find("input[name=MaxSize]").val();
				debugger;
				if (this._stringNumberCompare(size, '17592186044416') != -1) {
					this.applyError(null, { id: KL.Utils.Exception.ExceptionTypes.InvalidSettingsValue });
					this.focusField('maxSize');
					return false;
				} else
					this.hideError();
			}
			return true; 
		},
		_stringNumberCompare: function(a, b) {
			if (!a || !b || typeof(a) != "string" || typeof(b) != "string")
				return null;
			var left = KL.Utils.StringHelper.ltrim(a, "0");
			var right = KL.Utils.StringHelper.ltrim(b, "0");
			
			if (left.length < right.length)
				return -1;
			else if (left.length > right.length)
				return 1;
			
			for (var i=0, l=a.length; i < l; i++) {
				if (+left[i] < +right[i])
					return -1;
				else if (+left[i] > +right[i])
					return 1;
			}
			return 0;
		}
	};
	KL.LMS.Settings.registerClass("BackupSettingsForm", BackupSettingsForm);
	BackupSettingsForm.extend(KL.LMS.Settings.BaseSettingsForm);
})()
;
(function () {
	var SNMPCnnSettingsForm = function (id, setting) {
		SNMPCnnSettingsForm._super.call( this, id, setting );
	};
	SNMPCnnSettingsForm.prototype = {
		_map: [
			{ "elt": "MasterAgentAddress", "datasource": "masterAgentAddress"},
			{ "elt": "PingIntervalInSeconds", "datasource": "pingIntervalInSeconds" }
		],
		_prepareForm: function () {
			this.hideError();
			this._form.find("input[name=PingIntervalInSeconds]").numberselect({
				min: 1,
				max:255,
				defaultValue: 15,
				step: 1
			});
		},
		onDataSet: function () {
			this.hideError();
		}
	};
	KL.LMS.Settings.registerClass("SNMPCnnSettingsForm", SNMPCnnSettingsForm);
	SNMPCnnSettingsForm.extend(KL.LMS.Settings.BaseSettingsForm);
})()
;
(function () {
	var SNMPSettingsForm = function (id, setting) {
		SNMPSettingsForm._super.call( this, id, setting );
	};
	SNMPSettingsForm.prototype = {
		_map: [
			{ "elt": "antiSpamErrorEventEnable", "datasource": "antiSpamErrorEventEnable", "set": "getBoolSelectVal", "get": "setBoolSelectVal" },
			{ "elt": "antiVirusErrorEventEnable", "datasource": "antiVirusErrorEventEnable", "set": "getBoolSelectVal", "get": "setBoolSelectVal" },
			{ "elt": "aspBasesCompilationFailedEventEnable", "datasource": "aspBasesCompilationFailedEventEnable", "set": "getBoolSelectVal", "get": "setBoolSelectVal" },
			{ "elt": "aspBasesObsoletedEventEnable", "datasource": "aspBasesObsoletedEventEnable", "set": "getBoolSelectVal", "get": "setBoolSelectVal" },
			{ "elt": "aspBasesOutdatedEventEnable", "datasource": "aspBasesOutdatedEventEnable", "set": "getBoolSelectVal", "get": "setBoolSelectVal" },
			{ "elt": "avBasesObsoletedEventEnable", "datasource": "avBasesObsoletedEventEnable", "set": "getBoolSelectVal", "get": "setBoolSelectVal" },
			{ "elt": "avBasesOutdatedEventEnable", "datasource": "avBasesOutdatedEventEnable", "set": "getBoolSelectVal", "get": "setBoolSelectVal" },
			{ "elt": "updateErrorEventEnable", "datasource": "updateErrorEventEnable", "set": "getBoolSelectVal", "get": "setBoolSelectVal" },
			{ "elt": "backupAddErrorEventEnable", "datasource": "backupAddErrorEventEnable", "set": "getBoolSelectVal", "get": "setBoolSelectVal" },
			{ "elt": "backupLimitReachedEventEnable", "datasource": "backupLimitReachedEventEnable", "set": "getBoolSelectVal", "get": "setBoolSelectVal" },
			{ "elt": "backupRotateErrorEventEnable", "datasource": "backupRotateErrorEventEnable", "set": "getBoolSelectVal", "get": "setBoolSelectVal" },
			{ "elt": "licenseBlacklistedEventEnable", "datasource": "licenseBlacklistedEventEnable", "set": "getBoolSelectVal", "get": "setBoolSelectVal" },
			{ "elt": "licenseExpiredEventEnable", "datasource": "licenseExpiredEventEnable", "set": "getBoolSelectVal", "get": "setBoolSelectVal" },
			{ "elt": "licenseExpiresSoonEventEnable", "datasource": "licenseExpiresSoonEventEnable", "set": "getBoolSelectVal", "get": "setBoolSelectVal" },
			{ "elt": "licenseInstalledEventEnable", "datasource": "licenseInstalledEventEnable", "set": "getBoolSelectVal", "get": "setBoolSelectVal" },
			{ "elt": "licenseRevokedEventEnable", "datasource": "licenseRevokedEventEnable", "set": "getBoolSelectVal", "get": "setBoolSelectVal" },
			{ "elt": "productStartEventEnable", "datasource": "productStartEventEnable", "set": "getBoolSelectVal", "get": "setBoolSelectVal" },
			{ "elt": "taskCrashEventEnable", "datasource": "taskCrashEventEnable", "set": "getBoolSelectVal", "get": "setBoolSelectVal" },
			{ "elt": "taskRestartEventEnable", "datasource": "taskRestartEventEnable", "set": "getBoolSelectVal", "get": "setBoolSelectVal" },
			{ "elt": "threatDetectedEventEnable", "datasource": "threatDetectedEventEnable", "set": "getBoolSelectVal", "get": "setBoolSelectVal" },
			{ "elt": "authCommunicationErrorEventEnable", "datasource": "externalDirectoryServiceErrorEventEnable", "set": "getBoolSelectVal", "get": "setBoolSelectVal" },
			{ "elt": "authCommunicationUpEventEnable", "datasource": "externalDirectoryServiceUpEventEnable", "set": "getBoolSelectVal", "get": "setBoolSelectVal" }
		],
		viewName: "",
		
		_prepareForm: function () {
			this.hideError();
			KL.Utils.TooltipHelper.makeTooltips( this._form.find(".helpIco[rel]"), this, this._form );
		},
		viewErrorUpdate: function () {
			this.viewName = ".ErrorUpdate";
		},
		
		viewBasesError: function () {
			this.viewName = ".BasesError";
		},
		
		viewMisc: function () {
			this.viewName = ".Misc";
		},
		viewTask: function () {
			this.viewName = ".Task";
		},
		viewLicense: function () {
			this.viewName = ".License";
		},
		viewBackup: function () {
			this.viewName = ".Backup";
		},
		viewBases: function () {
			this.viewName = ".Bases";
		},
		viewExternalServiceError: function () {
			this.viewName = ".ExternalService";
		},
		
		onDataSet: function () {
			this.hideError();
			this._form.find(".snmpTrapSuite").each(function () {
				 $(this).css("display","none");
			});
			this._form.find(this.viewName).css("display","block")
		}
	};
	KL.LMS.Settings.registerClass("SNMPSettingsForm", SNMPSettingsForm);
	SNMPSettingsForm.extend( KL.LMS.Settings.BaseSettingsForm );
})()
;
(function () {
	var ProductMailSettingsForm = function (id, setting) {
		ProductMailSettingsForm._super.call( this, id, setting );
	};
	ProductMailSettingsForm.prototype = {
		_map: [
			{ "elt": "editField", "datasource": "replyEmailAddress"}
		],
		_prepareForm: function () {
			this._form.find(".clearBtn").click(KL.Utils.Delegate.create(this, this._clearField));
		},
		
		_clearField: function () {
			var elt = this.getElt();
			if (elt)
				elt.find(".editField").val("");
			return false;
		}
	};
	KL.LMS.Settings.registerClass("ProductMailSettingsForm", ProductMailSettingsForm);
	ProductMailSettingsForm.extend( KL.LMS.Settings.BaseSettingsForm );
})();
;
(function () {
	var AdminEMailSettingsForm = function (id, setting) {
		AdminEMailSettingsForm._super.call(this, id, setting);
	};
	AdminEMailSettingsForm.prototype = {
		_submitData: null,
		oldValue: null,
		onFormInit: function () {
			this._form.find(".emailField").listeditor({
				"itemText": ".itemText",
				"isSaveOnClick": true,
				"validateOnSave": KL.Utils.Delegate.create(this, this._validateEmail)
			}).bind("onitemcreate", KL.Utils.Delegate.create(this, this._bindItemDelete));
			if (!!this._submitData)
				this._bindFormVals();
			this._form.find(".btnCancel").click(KL.Utils.Delegate.create(this, this._cancel));
			this._form.find(".emailField").keypress(KL.Utils.Delegate.create(this, this._closeError));
		},
		_closeError: function(){
			this._form.find(".emailField").removeClass("error");
		},
		_bindItemDelete: function (e, item, data, indx) {
			item.find(".itemDelBtn").click(KL.Utils.Delegate.create(this, this._deleteItem, indx));
		},
		_deleteItem: function ( indx, e) {
			this._form.find(".emailField").listeditor("removeNumItem", indx);
			return false;
		},
		onBeforeShow: function () {
			this.hideError();
			this._form.find(".emailField").removeClass("error");
			this.hideSuccess();
			this.checkFieldEmpty(true);
		},
		getValueRecursive: function () {
			if (this._submitData) {
				return { data: KL.Utils.JSON.encode(this._submitData) };
			}
			return null;
		},
		setData: function (e, data, fieldName) {
			this._submitData = data;
			if (this.isVisible()){
				this._bindFormVals();
				this._form.find(".emailField .editField").focus();
			}
		},
		applyError: function (e,data) {
			if( this._form ){
				var localization = KL.Utils.Localization.getInstance();
				this.showError(-1,localization.getLocaleString("LabelTitleDialogMisc_EMails_Error"));
				this._form.find(".emailField").addClass("error").focus();
				this._submitData.adminEmailAddresses = this.oldValue ;
			}
		},		
		
		_bindFormVals: function () {
			if (this._submitData) {
				var d = $.trim(this._submitData.adminEmailAddresses) ? $.trim(this._submitData.adminEmailAddresses).split(/[\n;,]/gi) : [];
				this._form.find(".emailField").listeditor("setValue", d || "");
				this.oldValue = this._submitData.adminEmailAddresses;
			}
		},
		onFormSubmit: function () {
			if (this._submitData)
				this._submitData.adminEmailAddresses = this._form.find(".emailField").listeditor("getValue").join(",");
		},
		_cancel: function () {
			this._page.closeDialog();
		},
		_validateEmail: function (val) {
			var elt = this.getElt();
			if (elt) {
				elt.find(".editField").removeClass("error");
					var reg = /^[a-zA-Z0-9][\w\.-]*[a-zA-Z0-9]*@[a-zA-Z0-9][\w\.-]*[a-zA-Z0-9\.]*[a-zA-Z][a-zA-Z\.]*[a-zA-Z0-9]$/;
				if(!reg.test(val)) {
					elt.find(".editField").addClass("error");
					return false;
				}	
			}
			return true;
		}
	};
	KL.LMS.Settings.registerClass("AdminEMailSettingsForm", AdminEMailSettingsForm);
	AdminEMailSettingsForm.extend( KL.Web.Controls.FormControl );
})()
;
(function () {
	var EventLoggerEditForm = function (id, setting) {
		EventLoggerEditForm._super.call( this, id, setting );
	};
	EventLoggerEditForm.prototype = {
		_map: [
			{ "elt": "Facility", "datasource": "facility"},
			{ "elt": "LogLevel", "datasource": "logLevel" }
		],
		_prepareForm: function () {
			this.hideError();
			var Facility = this._form.find("[name=Facility]");
			var EventLoggerFacility = KL.LMS.Enums.EventLoggerFacility;
			for (var i = 0; i < EventLoggerFacility._keys.length; i++) {
				var key = EventLoggerFacility._keys[i];
				Facility.append( KL.Utils.StringHelper.format('<option value="{0}">{1}</option>', EventLoggerFacility[key], key));
			}
			var LogLevel = this._form.find("[name=LogLevel]");
			var EventLoggerLogLevel = KL.LMS.Enums.EventLoggerLogLevel;
			for (var i = 0; i < EventLoggerLogLevel._keys.length; i++) {
				var key = EventLoggerLogLevel._keys[i];
				LogLevel.append( KL.Utils.StringHelper.format('<option value="{0}">{1}</option>', EventLoggerLogLevel[key], key));
			}
		},
		onDataSet: function () {
			this.hideError();
		}
	};
	KL.LMS.Settings.registerClass("EventLoggerEditForm", EventLoggerEditForm);
	EventLoggerEditForm.extend(KL.LMS.Settings.BaseSettingsForm);
})()
;
(function () {
	var PerformanceEditForm = function (id, setting) {
		PerformanceEditForm._super.call( this, id, setting );
	};
	PerformanceEditForm.prototype = {
		_map: [
			{ "elt": "ScanThreads", "datasource": "scanThreads"}
		],
		_prepareForm: function () {
			this.hideError();
			this._form.find("input[name=ScanThreads]").numberselect({
				min: 1,
				max: 128,
				defaultValue: 8,
				step: 1
			});
		},
		onDataSet: function () {
			this.hideError();
		}
	};
	KL.LMS.Settings.registerClass("PerformanceEditForm", PerformanceEditForm);
	PerformanceEditForm.extend( KL.LMS.Settings.BaseSettingsForm );
})()
;
(function () {
	var HeaderMarksEditForm = function (id, setting) {
		HeaderMarksEditForm._super.call( this, id, setting );
	};
	HeaderMarksEditForm.prototype = {
		_map: [
			{ "elt": "AddXHeaders", "datasource": "addXHeaders" , "get": "setBoolSelectVal", "set": "getBoolSelectVal"}
		],
		_prepareForm: function () {
			this.hideError();
		},
		onDataSet: function () {
			this.hideError();
		}
	};
	KL.LMS.Settings.registerClass("HeaderMarksEditForm", HeaderMarksEditForm);
	HeaderMarksEditForm.extend( KL.LMS.Settings.BaseSettingsForm );
})()
;
(function () {
	var PlaceholderEditForm = function (id, setting) {
		PlaceholderEditForm._super.call( this, id, setting );
	};
	PlaceholderEditForm.prototype = {
		_map: [
			{ "elt": "DeletedAttachmentPlaceholder", "datasource": "deletedAttachmentPlaceholder"}
		],
		onDataSet: function () {
			this.hideError();
		}
	};
	KL.LMS.Settings.registerClass("PlaceholderEditForm", PlaceholderEditForm);
	PlaceholderEditForm.extend( KL.LMS.Settings.BaseSettingsForm );
})()
;
(function () {
	var KSNSettingsEditForm = function (id, setting) {
		KSNSettingsEditForm._super.call(this, id, setting);
	};
	KSNSettingsEditForm.prototype = {
		closeoncancel: true,
		_map: [
			{ "elt": "ksnTimeout", "datasource": "scanLogic.ksnTimeout" }
		],
		_prepareForm: function () {
			this.hideError();
			var elt = this.getElt();
			if (elt){
				var appSettings = this._page.getApplication().getContext().getAppSettings();
				if( appSettings )
					this.setBoolSelectVal(appSettings, elt.find("[name=ksnEulaState]"), appSettings.ksnParticipationActivated);
				KL.Utils.TooltipHelper.makeTooltips( elt.find(".helpIco[rel]"), this, elt );
				elt.find( ".ksnTimeout" ).numberselect({
					min: 1,
					max: 3600
				});
			}
		},
		onDataSet: function () {
			this.hideError();
		},
		_validate: function () {
			
			return true;
		}
	};
	KL.LMS.Settings.registerClass("KSNSettingsEditForm", KSNSettingsEditForm);
	KSNSettingsEditForm.extend(KL.LMS.Settings.BaseSettingsForm);
})();
;
(function () {
	var uploadTpl = "";
	function closeDialog(){
		this._page.closeDialog();
	}
	function fileChanged(){
		var elt = this.getElt();
		if( elt ){
			var fileField = elt.find(".uploadField"),
				val = fileField.val();
			if( fileField.length>0 && fileField[0].files && fileField[0].files.length > 0 )
				val = fileField[0].files[0].name;
			elt.find(".uploadWrap .textbox").text(val);
			elt.find(".btnNext").show();
		}
	}
	function updateUploadField( elt ){
		elt.find(".uploadWrap").empty().html(uploadTpl);
		elt.find(".uploadField").on( "change", KL.Utils.Delegate.create( this, fileChanged ) );
	}
	function openTypeSelector(elt){
		elt.find(".btnNext").hide();
		renderTypes.call( this, this._listContainer, KL.LMS.Enums.SettingsTypes );
		unselectAll.call(this,elt);
		KL.Utils.TooltipHelper.makeTooltips( elt.find(".warningIcon[rel]"), this, elt );
		elt.find( ".fileSelectPanel" ).slideUp("fast", function(){
			elt.find( ".settinsTypes" ).slideDown( "fast", function () {
				elt.find(".btnOk").show();
			} );
		});
	}
	function renderTypes(parent, items){
		var StringHelper = KL.Utils.StringHelper;
		var localization = KL.Utils.Localization.getInstance();
		var Delegate = KL.Utils.Delegate;
		var elt = parent.closest(".importExportSettingsForm");
		for( var propName in items ){
			var itemType = items[propName];
			if( itemType && typeof itemType == typeof {} && "field" in itemType ){
				var item = $( StringHelper.formatTemplate(this._itemTpl, {
					"Name": propName,
					"Title": localization.getLocaleString( "LabelProductSettings" + propName ),
					"Descr": localization.getLocaleString( "LabelProductSettings" + propName + "Info" ),
					"DescrText": localization.getLocaleValueString( "LabelProductSettings" + propName + "Info" ),
					"RestartRequiredClass": itemType.restartRequired?"warn":"nowarn"
				})).appendTo(parent).data( "setting-type", itemType );
				item.find("input[type=checkbox]").data( "setting-type", itemType )
					.on( "click", Delegate.create(this, unselectAll, elt, item ))
					.attr("checked", !!itemType.defaultVal || typeof(itemType.defaultVal) == "undefined");
				if( "Extra" in itemType ){
					renderTypes.call(this, item.find("._subitems"), itemType.Extra);
				} else
					item.find("._subitems").remove();
			}
		}
	}
	function unselectAll(elt, node, evt){
		elt.find( "input[name=selectAll]" ).val([0]);
		if(node)
			node.find("._subitems input[type=checkbox]").attr("checked", $(evt.currentTarget).is(":checked"));
		elt.find(".btnOk")[elt.find("input[type=checkbox]:checked").length>0?"show":"hide"]();
	}
	function selectAll (elt) {
		elt.find( "input[name=selectAll]" ).val([1]);
		elt.find( "input[type=checkbox]" ).attr( "checked", true );
		elt.find(".btnOk").show();
	}
	function submit (elt) {
		var objOut = {},
			restartRequired = false;
		elt.find( "input[type=checkbox]" ).each(function(){
			var $this = $(this),
				val = $this.is(":checked"),
				data = $this.data("setting-type");
			restartRequired = restartRequired || ( val && data.restartRequired );
			KL.Utils.ObjectHelper.setObjValueByPath( objOut, data.field, val );
		});
		this._restartRequired = restartRequired;
		elt.find("[name=data]").val( KL.Utils.JSON.encode( objOut ) );
		$(this).trigger("onsettingsupload", [elt.find("form")]);
	}
	function callRestart(elt){
		var $this = $(this);
		elt.find(".successPanel").slideUp("fast", function(){
			elt.find(".restartPanel").slideDown("fast", function(){
				elt.find(".btnRestart").hide();
				window.setTimeout(function(){
					$this.trigger("onrestartproduct");
				}, 1000);
			});
		});
	}
	var ImportSettingsForm = function (id, setting) {
		ImportSettingsForm._super.call( this, id, setting );
	};
	ImportSettingsForm.prototype = {
		_listContainer: null,
		_itemTpl: "",
		_restartRequired: false,
		setUploadeFailed: function(e, err){
			var elt = this.getElt();
			if( elt ){
				elt.find(".btnNext, .btnOk, .btnCancel, .successPanel, .errMessage, .btnRestart").hide();
				var excText = KL.Utils.Exception.getExceptionText(err.id);
				if( excText )
					elt.find( ".errMessage" ).show().html(excText);
				elt.find(".importPanel").slideUp( "fast", function(){
					elt.find(".errorPanel").slideDown("fast", function(){
						elt.find(".btnClose").show();
					});
				} );
			}
		},
		setUploadeFinished: function (){
			var elt = this.getElt();
			if( elt ){
				elt.find(".btnNext, .btnOk, .btnCancel, .errorPanel, .btnRestart").hide();
				var needRestart = !!this._restartRequired;
				elt.find(".importPanel").slideUp( "fast", function(){
					elt.find(".successPanel").slideDown("fast", function(){
						elt.find(".btnClose").show();
						if(needRestart)
							elt.find(".btnRestart").show();
					});
				} );
			}
		},
		onInitInteraction: function () {
			var elt = this.getElt(),
				Delegate = KL.Utils.Delegate;
			if( elt ){
				elt.find(".tooltip").hide();
				this._restartRequired = false;
				this._listContainer = elt.find(".item").parent();
				this._itemTpl = this._listContainer.html();
				this._listContainer.empty();
				elt.find(".btnNext").hide().on("click", Delegate.create( this, openTypeSelector , elt ) );
				elt.find(".btnOk").hide().on("click", Delegate.create( this, submit , elt ) );
				elt.find(".btnCancel, .btnClose").on("click", Delegate.create( this, closeDialog ));
				elt.find(".btnRestart").on("click", Delegate.create( this, callRestart, elt ));
				elt.find(".btnClose, .btnRestart, .formContent, .settinsTypes, .errMessage").hide();
				elt.find( ".importPanel, .fileSelectPanel" ).show();
				elt.find( "input[name=selectAll][value=1]" ).on("click", Delegate.create( this, selectAll, elt, null ));
				uploadTpl = elt.find(".uploadWrap").html();
				updateUploadField.call(this, elt);
			}
		}
	};
	KL.LMS.Settings.registerClass("ImportSettingsForm", ImportSettingsForm);
	ImportSettingsForm.extend(KL.Web.Controls.Control);
})()
;
(function () {
	function closeDialog(){
		this._page.closeDialog();
	}
	function triggerDownload(){
		var elt = this.getElt();
		if( elt ){
			elt.find(".btnOk, .btnCancel").hide();
			elt.find(".btnClose").show();
		}
		$(this).trigger("onsettingsload");
	}
	var ExportSettingsForm = function (id, setting) {
		ExportSettingsForm._super.call( this, id, setting );
	};
	ExportSettingsForm.prototype = {
		onInitInteraction: function () {
			var elt = this.getElt();
			if( elt ){
				elt.find(".btnCancel, .btnClose").show()
					.on("click", KL.Utils.Delegate.create( this, closeDialog ))
					.filter(".btnClose").hide();
				elt.find(".btnOk").show().on("click", KL.Utils.Delegate.create( this, triggerDownload ));
			}
		}
	};
	KL.LMS.Settings.registerClass("ExportSettingsForm", ExportSettingsForm);
	ExportSettingsForm.extend(KL.Web.Controls.Control);
})()
;
(function(){
	function HelpdeskSettingsForm(id, setting){
		HelpdeskSettingsForm._super.call( this, id, setting );
	}
	HelpdeskSettingsForm.prototype = {
		closeoncancel: true,
		_appData: null,
		_helpdeskData: null,
		_map: [
			{ "elt": "userName", "datasource": "userName" },
			{ "elt": "passwd", "datasource": "password", "get": "initPasswdFields" },
			{ "elt": "editBwlSelect", "datasource": "helpdeskSettings.accessBlackWhiteList", "get": "setBoolSelectVal" },
			{ "elt": "fwdMalwareValue", "datasource": "allowAvThreatsRestoration", "get": "setAllowForwardVal" }
		],
		initPasswdFields: function(){
			this._form.find("[name=passwd], [name=passwdCnf]").on( "blur", function(){
				if( !$.trim($(this).val()) )
					$(this).val("      ");
			} ).on( "focus", function(){
				if( !$.trim($(this).val()) )
					$(this).val("");
			} ).val("      ");
		},
		_prepareForm: function () {
			this.hideError();
			this._form.find(".btnCancel").click(KL.Utils.Delegate.create(this, this._triggerCancel));
			var elt = this.getElt();
			if(elt)
				KL.Utils.TooltipHelper.makeTooltips( elt.find(".helpIco[rel]"), this, elt );
		},
		setAllowForwardVal: function(data, elt, val){
			elt.html( KL.Utils.Localization.getInstance().getLocaleString(!!val?"LabelSettingEnabled":"LabelSettingDisabled") );
		},
		_restoreData: function(){},
		setAppSettings: function(evt, data){
			this._data = this._data || {};
			this._data.helpdeskSettings = this._data.helpdeskSettings || {};
			this._data.helpdeskSettings.accessBlackWhiteList = data.helpdeskSettings.accessBlackWhiteList;
			this._appData = data;
		},
		setUserName: function(evt, data){
			this._data = this._data || {};
			var userName = "";
			if(data && data.items && data.items.length > 0){
				for(var i=0, l=data.items.length; i<l; i++){
					if( data.items[i].permissionType == KL.Utils.UserTypes.HelpDesk )
						userName = data.items[i].accountName;
				}
			}
			this._data.userName = userName;
			this._helpdeskData = data;
		},
		setCanForvardMalware: function(evt, data){
			this._data = this._data || {}
			this._data.allowAvThreatsRestoration = data.allowAvThreatsRestoration;
		},
		setData: function (e, data, fieldName) {
			HelpdeskSettingsForm._super.prototype.setData.call(this, e, this._data, fieldName);
		},
		onDataSet: function () {
			this.hideError();
		},
		onFormSubmit: function () {
			var userName = $.trim(this._form.find("[name=userName]").val()),
				newPwd = $.trim(this._form.find("[name=passwd]").val())||"",
				cnfPwd = $.trim(this._form.find("[name=passwdCnf]").val())||"",
				returnVal = true;
			if(userName){
				if( !!newPwd && newPwd.length < 8 ) {
					returnVal = false;
					this.showError( KL.Utils.Exception.ExceptionTypes.ResetWebHelpdeskPasswordFailed );
				} else if( !!newPwd && newPwd !== cnfPwd ){
					returnVal = false;
					this.showError( KL.Utils.Exception.ExceptionTypes.PasswordNotMatch );
				} else
					KL.Utils.ObjectHelper.setObjValueByPath(this._appData, "helpdeskSettings.accessBlackWhiteList", this._form.find("[name=editBwlSelect]").val()==1);
			}else{
				returnVal = false;
				this.showError( KL.Utils.Exception.ExceptionTypes.Authentication );
			}
			return returnVal;
		},
		getAccData: function(){
			var dataOut = {"accountName":  $.trim(this._form.find("[name=userName]").val())},
				newPwd = $.trim(this._form.find("[name=passwd]").val())||"",
				cnfPwd = $.trim(this._form.find("[name=passwdCnf]").val())||"";
			if( newPwd ){
				dataOut.newPassword = newPwd;
				dataOut.newPasswordAgain = cnfPwd;
			}
			return dataOut;
		},
		_validate: function () {
			return true;
		}
	};
	KL.LMS.Settings.registerClass("HelpdeskSettingsForm", HelpdeskSettingsForm);
	HelpdeskSettingsForm.extend(KL.LMS.Settings.BaseSettingsForm);
})()
;
(function () {
	var ScClusterIdEditForm = function (id, setting) {
		ScClusterIdEditForm._super.call( this, id, setting );
	};
	ScClusterIdEditForm.prototype = {
		closeoncancel: true,
		_map: [
			{ "elt": "editField", "datasource": "securityCenterClusterID"}
		],
		_prepareForm: function () {
			this._form.find(".clearBtn").click(KL.Utils.Delegate.create(this, this._clearField));
		},
		_clearField: function () {
			var elt = this.getElt();
			if (elt)
				elt.find(".editField").val("");
			return false;
		},
		applyError: function(evt, err){
			if( err.id == KL.Utils.Exception.ExceptionTypes.SaveAppSettingsUexpectedError )
				this.showError(-1, "ErrorScClusterIdBadSymbols" );
			else
				ScClusterIdEditForm._super.prototype.applyError.call(this, evt, err);
		}
	};
	KL.LMS.Settings.registerClass("ScClusterIdEditForm", ScClusterIdEditForm);
	ScClusterIdEditForm.extend( KL.LMS.Settings.BaseSettingsForm );
})()
;
(function () {
	var BlProtectionEditForm = function (id, setting) {
		BlProtectionEditForm._super.call(this, id, setting);
	};
	BlProtectionEditForm.prototype = {
		closeoncancel: true,
		_map: [
			{ "elt": "blPutInBackup", "datasource": "scanLogic.backupPersonalBlacklist", "get": "setBoolSelectVal", "set": "getBoolSelectVal" },
			{ "elt": "personalBlAction", "datasource": "scanLogic.personalBlacklistAction" }
		],
		_prepareForm: function () {
			this.hideError();
			var elt = this.getElt();
			if (elt){
				KL.LMS.Helpers.CommonHelper.fillSelectWidthEnum(elt.find("[name=personalBlAction]"), {
					"DeleteMessage": KL.LMS.Enums.BlDenyActionType.DeleteMessage,
					"Reject": KL.LMS.Enums.BlDenyActionType.Reject
				}, "SettingAction_");
				
			}
		},
		onDataSet: function () {
			this.hideError();
		},
		_validate: function () {
			return true;
		}
	};
	KL.LMS.Settings.registerClass("BlProtectionEditForm", BlProtectionEditForm);
	BlProtectionEditForm.extend(KL.LMS.Settings.BaseSettingsForm);
})()
;
KL.LMS.registerNS("Reports");
(function () {
	var ReportsGrid = function (id, setting) {
		ReportsGrid._super.call( this, id, setting );
	};
	ReportsGrid.prototype = {
		_currCount: 0,
		pageSize: 20,
		_currentIndex: -1,
		_localeStrs: null,
		filter_creationType: 0,
		localeList: [],
		
		onGridInit: function () {
			this.pageNum = 0;
			this.resetData();
		},
		setValuePartial: function (val) {
			var curVal = this._data;
			if (!curVal || !val || !val.items || !curVal.items || this._currCount == 0) {
				this._currCount = 0;
				this.pageNum = 0;
				KL.Utils.Log.write("ReportsGrid.setValuePartial: no current value");
				curVal = val;
			} else if (val.items) {
				KL.Utils.Log.write("ReportsGrid.setValuePartial: There's a current value. " + this._currCount + " already rendered");
				curVal.items = curVal.items.concat(val.items);
				curVal.page = val.page;
			}
			if (curVal) {
				if (curVal["items"] != null) {
					curVal.count = curVal.items.length;
				}
				else {
					curVal.count = 0;
				} 
				curVal.page = this.pageNum;
				this._setValue(curVal);
			}
		},
		onGridInit: function (elt) {
			elt.find(".helpLink").click(KL.Utils.Delegate.create(this, this._openHelp));
			elt.find(".closeInfoBtn").click(KL.Utils.Delegate.create(this, this._hideInfo));
		},
		setValue: function (val) {
			this.setValuePartial(val);
		},
		_setValue: function (val) {
			if (this._setting)
				this._setting.applyData(null,val,true);
		},
		
		getKeyDataFromIdField: function (data) {
			return data.fileName + "_" + data.creationType;
		},
		
		applyFilter: function (e, data) {
			this.filterValue = data;
			this._currCount = 0;
			this._data = null;
			this._listContainer.empty();
			$(this).trigger("onfilterchange", [data]);
		},
		onShown: function () {
			this.filterValue = "";
			this.initFilter();
			var elt = this.getElt();
			if (elt)
				elt.find(".notificationArea").hide();
		},
		initFilter: function () {
			this.filter_creationType = KL.LMS.Enums.ReportCreationType.All;
		},
		setFilter: function (e,type) {
			this.filter_creationType = type;
			 $(this).trigger("onfilterchange");
		},
		getFilter: function () {
			var d = new Date();
			var result = {
				"params": {
					"dateFrom": Math.round(d.getTime() / 1000),
					"dateTo": Math.round(d.getTime() / 1000),
					"lang": KL.Web.Application.getContext().getLanguage()
				}
			};
			if (this.filter_creationType != null)
				result.params["creationType"] = this.filter_creationType;
			var retObj ={
				data : KL.Utils.JSON.encode(result)
			};
			return retObj;
		},
		
		onDataBind: function (data) {
			this._localeStrs = {};
			var proceed = this.onBeforeDataBind(data);
			if (proceed === false)
				return;
			if (!data){// || (this._currCount >= this.pageSize)) {
				KL.Utils.Log.write("ReportsGrid.onDataBind: no need to render");
			} else {
				if (data.items) {
					if (this._currCount == 0) {
						this._listContainer.empty();
						this._data = data;
						KL.Utils.Log.write("ReportsGrid.onDataBind: page #" + this.pageNum + " first render");
					}
					var from = 0;
					var to = data.items.length;
					for (var i = from; i < to; i++) {
						var proceed_i = this.itemDataBind(data.items[i], i);
						if (proceed_i !== false) {
							var row = $(this._template.bindData(data.items[i]))
							.appendTo(this._listContainer)
							.addClass((i % 2 ? "oddItem" : "evenItem"))
							.mouseover(function () { $(this).addClass("itemOver"); })
							.mouseout(function () { $(this).removeClass("itemOver"); })
							.data("itemData", data.items[i]);
							this.itemDataBound(row, data.items[i]);
						}
					}
				}
				else {
					this._listContainer.empty();
				}
			}
			this.dataBound(data);
		},
		gridDataBound: function () {
			var elt = this.getElt();
			if (elt) {
				KL.Utils.DateHelper.applyLocaleDates(this.id, elt);
				if (this._localeStrs) {
					for (var str in this._localeStrs)
						elt.find("#" + str).replaceWith(this._localeStrs[str]);
					this._localeStrs = null;
				}
				if (this._data != null) {
					if (this._data.items.length == 0) {
						this.setNotificationAreaMessage(0);
						this._showInfo();
					}
					else
						this._hideInfo();
				}
				else {
					this.setNotificationAreaMessage(0);
					this._showInfo();				
				}
			}
		},
		
		setNotificationAreaMessage: function (val) {
			var elt = this.getElt();
			if (elt) {
				var localization = KL.Utils.Localization.getInstance();
				
					elt.find(".notificationAreaMessage").html(localization.getLocaleString("LabelInfoLastNotReportShown"));
				
			}
		},
		
		_hideInfo: function () {
			var elt = this.getElt();
			if (elt) {
				elt.find(".notificationArea").slideUp(400);
				elt.find(".gridContent").animate({ top: 37 });
			}
		},
		_showInfo: function () {
			var elt = this.getElt();
			if (elt) {
				elt.find(".notificationArea").slideDown(400);
				elt.find(".gridContent").animate({ top: 75 });
			}
		},
		_openHelp: function () {
			$(this).trigger("oncontexthelp");
		},
		deleteRows: function () {
			var Delegate = KL.Utils.Delegate,
				localization = KL.Utils.Localization.getInstance(),
				selectedCount = this.getSelectedCount(),
				dialogResult = this._page.getApplication().openConfirm(
					localization.makeLocaleStringObj(this.id, selectedCount > 1 ? "LabelDeleteReportsConfirm" : "LabelDeleteReportConfirm", selectedCount),
					localization.getLocaleString("LabelTitleDeleteReports"),
					{ "ok": "BtnDelete", "cancel": "BtnCancel" }
				);
			$(dialogResult).bind("onok", Delegate.create(this, this._deleteSelected));
			localization.applyStingObjs(this.id, dialogResult.elt);
		},
		_deleteSelected: function () {
			var data = [];
			var index = this.getSeletedRowsId();
			for (var itemId in index)//this.selectedItems)
				data.push(itemId);
			$(this).trigger("onrowsdelete", [this.idField, data]);
		},
		getSeletedRowsId: function () {
			var data = [];
			if (this.isActionFromPanel) {
				var i = this._currentIndex;
				data[0] = this._data.items[i].fileName + "_" + this._data.items[i].creationType;
			}
			else
				for (var itemId in this.selectedItems)
					data.push(itemId);
			return data;
		},
		
		getDownloadReport: function () {
			var index = this.getSeletedRowsId();
			var result = {};
			var k = 0;
			for (var i = 0; i < this._data.items.length; i++) {
				var key = this._data.items[i].fileName + "_" + this._data.items[i].creationType;
				for (var j = 0; j < index.length; j++)
					if (key == index[j]) {
						result["reportShortName"] = this._data.items[i].fileName;
						result["creationType"] = this._data.items[i].creationType;
					}
			}
			var retObj = {
				data: KL.Utils.JSON.encode(result)
			};
			this.selectedItems = {};
			return retObj;
		},
		setLocaleList: function (e,data) {
			if (data) {
				this.localeList = data;
			}
		},
		_getLocaleName: function (shortName) {
			for (var i=0;i<this.localeList.items.length;i++) 
				if (shortName==this.localeList.items[i].lang) {   
					if (this.localeList.items[i].name) return this.localeList.items[i].name
				}
			return 	shortName;
		},
		
		getSelectedReport: function () {
			var index = this.getSeletedRowsId();
			var result = [];
			var items = {};
			var k = 0;
			for (var i = 0; i < this._data.items.length; i++) {
				var key = this._data.items[i].fileName + "_" + this._data.items[i].creationType;
				for (var j = 0; j < index.length; j++)
					if (key == index[j]) {
						result.push({
							"reportShortName": this._data.items[i].fileName,
							"creationType": this._data.items[i].creationType
						})
					}
			}
			items = { "items": result };
			var retObj = {
				data: KL.Utils.JSON.encode(items)
			};
			return retObj;
		},
		getCurrentIndex: function () {
			var index = this.getSeletedRowsId();
			for (var i = 0; i < this._data.items.length; i++) {
				var key = this._data.items[i].fileName + "_" + this._data.items[i].creationType;
				if (key == index[0])
					return i;
			}
			return -1;
		},
		onRowEnter: function (row, e) {
			var rowData = row.data("itemData");
			var rowId = this.getKeyDataFromIdField(rowData); //rowData[this.idField];
			this.selectedItems = {};
			this.selectedItems[rowId] = rowData;
			if ($(e.currentTarget).is(".downloadFile")) {
				$(this).trigger("onrowenter_download", [row]);
				return false;
			}
		},
		
		invokeDownloadReport: function () {
			$(this).trigger("ondownloadReport");
		},
		itemDataBind: function (itemData, indx) {
			if (itemData == null) return;
			try {
				itemData.createDate_ = KL.Utils.DateHelper.getLocaleDate(this.id,itemData.creationDate);
				itemData.typeReport_ = 
					KL.Utils.Localization.getInstance().getLocaleString("LabelReportsType_"+  KL.LMS.Enums.ReportCreationType.getKeyByValue(itemData.creationType));
				
				var formatDate = "ResShortDateFormat";
				switch (itemData.periodType)
				{
					case KL.LMS.Enums.ReportPeriodType.Day : 	break;
					case KL.LMS.Enums.ReportPeriodType.Month : formatDate+="_Month";	break;
					case KL.LMS.Enums.ReportPeriodType.Year : formatDate+="_Year";	break;
				}
				
				itemData.Period_ = this._getPeriodString(itemData.periodType,itemData.periodBegin,itemData.periodEnd,formatDate);
				if (itemData.fileSize>0)
					itemData.FileType_ = "<a href=\"#\" class=\"downloadFile\"><b>PDF</b></a>";
				else
					itemData.FileType_ = "<span style=\"color:red\"><b>"
						+KL.Utils.Localization.getInstance().getLocaleValueString("LabelReports_Error")
						+"<b></span>";
				
				itemData.Lang_ = this._getLocaleName(itemData.lang);//KL.Utils.Localization.getInstance().getLocaleString("LabelReportsFormat_Language_"+itemData.lang);
			} catch (e) { //alert(e);
			}
			this._currCount++;
		},
		
		_getPeriodString: function (periodType,periodBegin,periodEnd,formatDate){
			if (periodType != KL.LMS.Enums.ReportPeriodType.Day)
				return KL.Utils.DateHelper.getGMTDate(this.id,periodBegin,formatDate);
			else {
					var d1 = new Date();
					var d2 = new Date();
					var timeStamp = d1.getTimezoneOffset() * 60000;
					d1.setTime(periodBegin* 1000 + timeStamp);
					d2.setTime(periodEnd* 1000 + timeStamp);
					if (d1.getDay()==d2.getDay() && d1.getMonth()==d2.getMonth() && d1.getYear()==d2.getYear())
						return KL.Utils.DateHelper.getGMTDate(this.id,periodBegin,formatDate);
					str = KL.Utils.DateHelper.getGMTDate(this.id,periodBegin,formatDate); 
					str1 = KL.Utils.DateHelper.getGMTDate(this.id,periodEnd,formatDate);
					return str+" - "+str1;
			}
		},		
		
		onHidden: function () {
			this._currCount = 0;
			this._data = null;
			if (this._listContainer)
				this._listContainer.empty();
		},
		initCurrentIndex: function () {
			this._currentIndex = -1;
		},
		changeCurrentIndex: function (e, step) {
			this._currentIndex += step;
			if (this._currentIndex < 0) this._currentIndex = 0;
			if (this._currentIndex >= this._data.items.length) this._currentIndex = this._data.items.length - 1;
		},
		resetData: function () {
			this._data = null;
			this._currCount = 0;
			if (this._listContainer)
				this._listContainer.empty();
		}
	};
	KL.LMS.Reports.registerClass("ReportsGrid", ReportsGrid);
	ReportsGrid.extend(KL.Web.Controls.GridViewControl);
})();
;
(function () {
	var ReportsFilter = function (id, setting) {
		ReportsFilter._super.call(this, id, setting);
	};
	ReportsFilter.prototype = {
		items: [],
		_data: null,
		_selected: 0,
		schParams: {},
		localeList: [],
		onInitInteraction: function () {
			var elt = this.getElt();
			if (elt) {
				var localization = KL.Utils.Localization.getInstance();
				var Delegate = KL.Utils.Delegate;
				var btnsWrap = elt.find(".reportFilters");
				var itemtpl = btnsWrap.html();
				btnsWrap.empty();
				var selected = null;
				var selectedData = null;
				for (var i = 0, l = this.items.length; i < l; i++) {
					var item_i = this.items[i];
					var item_elt = $(KL.Utils.StringHelper.formatTemplate(itemtpl, { "ItemText": localization.getLocaleString(item_i.text) })).appendTo(btnsWrap);
					this.items[i].item_elt = item_elt;
					item_elt.click(Delegate.create(this, this._itemClick, item_elt, item_i));
					item_elt.hover(
						function () { $(this).addClass("itemOver") },
						function () { $(this).removeClass("itemOver") }
					);
					
					if (typeof (item_i.showtogge) != 'undefined' && !item_i.showtogge)
						item_elt.find(".toggle").remove();
					else
						item_elt.find(".toggle").click(Delegate.create(this, this._toggleItem, item_elt, item_i));
					if (typeof (item_i.settingsavailable) != 'undefined' && !item_i.settingsavailable)
						item_elt.find(".paramsBtn").remove();
					else
						item_elt.find(".paramsBtn").click(Delegate.create(this, this._itemParamsClick, item_elt, item_i));
					if (i == this._selected) {
						selected = item_elt;
					}
				}
				$(this).trigger("ongetlocalelist");	
				if (!!selected)
					selected.click();
			}
		},
		_toggleItem: function (item_elt, item_i, e) {
			if (e)
				e.stopPropagation();
			var t  = item_elt.find(".toggle");
			var isChecked = !item_elt.data("item-checked");
			t.toggleClass("checked", isChecked);
			item_elt.data("item-checked", isChecked);
			this.setReportParams(item_i.datatype,isChecked);
			$(this).trigger("onitemdisabled", [item_i]);
		},
		setReportParams: function(datatype,enableReport){
			var ReportCreationType = KL.LMS.Enums.ReportCreationType;
			this.schParams = {};
			var params = {};
			var settings = this._data[datatype];
			
			settings["enableReport"] = enableReport;
			this.schParams = {
				"type": 0,
				"params": {
					"creationType": ({
						"daily": ReportCreationType.Daily,
						"weekly": ReportCreationType.Weekly,
						"monthly": ReportCreationType.Monthly
					})[datatype]
				},
				"settings": settings
			};
		},
		
		getReportParams: function(){
			var retObj ={
				data : KL.Utils.JSON.encode(this.schParams)
			};
			return retObj;		
		},
		
		setLocaleList: function (e,data) {
			if (data) {
				this.localeList = data;
			}
		},
		
		onDataBind: function (data) {
			this._data = data;
			for( var i=0, l=this.items.length; i<l; i++ ){
				if (this.items[i].showtogge !== false && !!data[this.items[i].datatype]) {
					var isChecked = data[this.items[i].datatype].enableReport;
					this.items[i].item_elt.data("item-checked",isChecked).find(".toggle").toggleClass("checked", isChecked);
				}
			}
		},
		_itemClick: function (itemElt, itemData, e) {
			if (e) {
				e.preventDefault();
			}
			
			var elt = this.getElt();
			if (elt)
				elt.find(".selected").removeClass("selected");
			itemElt.addClass("selected");
			var ReportCreationType = KL.LMS.Enums.ReportCreationType;
			var type = null;
			if (itemData.datatype) {
				var typeName = itemData.datatype[0].toLocaleUpperCase() + itemData.datatype.substr(1);
				if (typeof (ReportCreationType[typeName]) != "undefined")
					type = ReportCreationType[typeName];
			}
			if (!!itemData.event)
				$(this).trigger(itemData.event, [type]);
			$(this).trigger("onfilterchange", [type]);
		},
		_itemParamsClick: function (itemElt, itemData, e) {
			if (e) {
				e.preventDefault();
				e.stopPropagation();
			}
			var data = (itemData.datatype ? KL.Utils.ObjectHelper.getObjValueByPath(this._data, itemData.datatype) : this._data) || {};
			data["type"] = itemData.datatype[0].toLocaleUpperCase() + itemData.datatype.substr(1);
			data["localeList"] = this.localeList; 
			
			$(this).trigger("onsettingschange", [data]);
		}
	};
	KL.LMS.Reports.registerClass("ReportsFilter", ReportsFilter);
	ReportsFilter.extend(KL.Web.Controls.Control);
})();
;
(function () {
	var ReportParamsForm = function (id, setting) {
		ReportParamsForm._super.call( this, id, setting );
	};
	ReportParamsForm.prototype = {
		reportUsersPeriod: 0,
		
		_map: [
			
			{ "elt": "receiversEditor", "datasource": "sendOptions.recipientsAddresses", "get": "setRecipientsVal", "set": "getRecipientsVal" }
		],
		_prepareForm: function () {
			var d = new Date();
			d = KL.Utils.DateHelper.getServerTime();
			this._form.find("input[name=monthDay]").numberselect({
				min: 1,
				max: 31,
				defaultValue: d.getDate(),
				step: 1
			});
			this._fillSelects();
			this._form.find("[name=monthDays]").datepicker();
			this._form.find("[name=usersDateStart]").datepicker();
			this._form.find("[name=usersDateFinish]").datepicker();
			this._form.find("input[name=dailyTime], input[name=weeklyTime], input[name=monthlyTime], input[name=customTime]").each(function () { $(this).timeselect(); });
			this._form.find(".receiversEditor").listeditor({
				"isSaveOnClick": true,
				"itemText": ".itemText",
				"validateOnSave": KL.Utils.Delegate.create(this, this._validateEmail)
			}).bind("onitemselect", KL.Utils.Delegate.create(this, this._recipientSelected))
				.bind("onitemcreate", KL.Utils.Delegate.create(this, this._setRecipientDelete))
				.bind("onvaluechange", KL.Utils.Delegate.create(this, this._recipientsChanged));
			var reportFormatDateSelect = this._form.find("[name=reportDateFormat]");
			var keysReportFormatDate = KL.LMS.Enums.ReportFormatDate._keys;
			for (var i = 0, l = keysReportFormatDate.length; i < l; i++) {
					reportFormatDateSelect.append(KL.Utils.StringHelper.format('<option value="{0}" class="str-local-LabelReportsParamsTitle_ReportDateFormat_{1}">{{1}}</option>', i, keysReportFormatDate[i]));
				}
			
			this._recipientSelected(null, false, null);
			
		},
		_recipientSelected: function (e, isSelected, data) {
			this._form.find(".receiversEditor .button").toggle(isSelected).filter(".btnAdd").toggle(!isSelected);
		},
		_recipientsChanged: function ( e, data ) {
		},
		_setRecipientDelete: function (e, item_i, data, indx) {
			item_i.find(".itemDelBtn").click(KL.Utils.Delegate.create(this, this._deleteRecipient, indx));
		},
		_deleteRecipient: function (indx, e) {
			if(e){
				e.stopPropagation();
				e.preventDefault();
			}
			this._form.find(".receiversEditor").listeditor("removeNumItem", indx);
			this._recipientSelected(null, false, null);
		},
		_checkReportUsersPeriod: function(){
			this.reportUsersPeriod = this._form.find("[name=reportUsersPeriod]:checked").val()*1;
		},
		
		_fillSelects: function () {
			var CommonHelper = KL.LMS.Helpers.CommonHelper;
			var DaysEnum = KL.Utils.DateHelper.DaysEnum;
			var StringHelper = KL.Utils.StringHelper;
			var localization = KL.Utils.Localization.getInstance();
			
			var weekDaySelect = this._form.find("[name=weekDay]");
			for (var i = 0, l = KL.Utils.DateHelper.DaysEnum.length; i < l; i++)
				weekDaySelect.append(StringHelper.format('<option value="{0}" class="str-local-ResDayName{1}">{{1}}</option>', i, DaysEnum[i]));
				
			var d = KL.Utils.DateHelper.getServerTime();//new Date();
			
			var MonthSelect = this._form.find("[name=usersMonth]");//ResDateMonthJan
			var monthKeys = ["Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"];
			var availableMonth = [];
			availableMonth[0] ={};
			availableMonth[0].month = d.getMonth();
			availableMonth[0].year = d.getFullYear();
			
			for(var i=1;i<4;i++) {
				availableMonth[i] ={};
				num = d.getMonth()-i;
				availableMonth[i].year = d.getFullYear();
				if (num>=0) availableMonth[i].month = num;
				else {
					availableMonth[i].month = 12+num;
					availableMonth[i].year = availableMonth[i].year-1;
				}	
			}
			var monthAfterYear = localization.getKeyValue("ResDatepickerMonthAfterYear");
			for (var i = 0, l=3; i <= l; i++) {
				var str = monthAfterYear ?
					(availableMonth[i].year 
						+ localization.getLocaleValueString("ResDatepickerYearSuffix")
						+localization.getLocaleValueString( "ResDateMonth" + monthKeys[availableMonth[i].month])) :
					(localization.getLocaleValueString( "ResDateMonth" + monthKeys[availableMonth[i].month]) 
						+ localization.getLocaleValueString("ResDatepickerYearSuffix")
						+ availableMonth[i].year);
				$(StringHelper.format('<option value="{0}"></option>', i)).appendTo(MonthSelect).append(str);
			}
				
			var monthDaySelect = this._form.find("[name=monthDay]");
			var monthDaysKeys = ["LabelOptionDayNumNth", "LabelOptionDayNum1st", "LabelOptionDayNum2nd", "LabelOptionDayNum3d"];
			for (var i = 1, l = 31; i <= l; i++) {
				var str = localization.getLocaleStringObj(monthDaysKeys[i % 10] || monthDaysKeys[0], i);
				$(StringHelper.format('<option value="{0}"></option>', i)).appendTo(monthDaySelect).append(str);
			}
			var YearSelect = this._form.find("[name=usersYear]");//ResDateMonthJan
			for (k=2;k>=0;k--) {	
				var d1 = new Date();
				d1.setFullYear(d.getFullYear()-k);
				if (d1.getFullYear()>=2012)
					$(StringHelper.format('<option value="{0}"></option>', d1.getFullYear())).appendTo(YearSelect).append(d1.getFullYear());
				}
			YearSelect.bind("focus", KL.Utils.Delegate.create(this, this._setReportUsersPeriod,2));
			MonthSelect.bind("focus", KL.Utils.Delegate.create(this, this._setReportUsersPeriod,1));
			
		},
		
		_setReportUsersPeriod : function(val){
			this._form.find("[name=reportUsersPeriod]").val([val]);
		},
		
		setRecipientsVal: function (data, elt, val) {
			if (val) {
				var data = (val|| "").split(/[,; \r]/gi);
				elt.listeditor("setValue", data);
			}
		},
		
		getRecipientsVal: function (elt, val) {
			var data = elt.listeditor("getValue");
			return data.join(",");
		},
		getReportParams: function (){
			if (KL.LMS.Enums.ReportCreationType[this._data.type] ==  KL.LMS.Enums.ReportCreationType.Users)
				return this.getUsersParams();
			else
				return this.getSchuduleParams();
			
		},
		
		getSchuduleParams: function(){
			var ReportCreationType = KL.LMS.Enums.ReportCreationType;
			var ReportPeriodType = KL.LMS.Enums.ReportPeriodType;
			
			var result = {};
			var params = {};
			var settings = {};
			var localeOptions = {};
			
			var lang = this._form.find("[name=sourceCountry]").val();
			localeOptions["lang"] = lang;
			localeOptions["dateFormat"] = this._form.find("[name=reportDateFormat]").val();
			settings["localeOptions"] = localeOptions;
			
			settings["sendOptions"] ={};
			settings["sendOptions"]["enableSend"] = this._form.find("[name=enableSendReport]").is(":checked");
			settings["sendOptions"]["sendToAdmin"] = this._form.find("[name=sendToAdminReport]").is(":checked");
			settings["sendOptions"]["recipientsAddresses"] = this.getRecipientsVal(this._form.find(".receiversEditor"));
			settings["enableReport"] = this._data["enableReport"];
			var schType = KL.LMS.Enums.ReportCreationType[this._data.type];
			switch (schType) {
				case ReportCreationType.Daily:
					settings["hour"] = this._form.find("[name=dailyTime]").timeselect("getHours");
					settings["min"] = this._form.find("[name=dailyTime]").timeselect("getMinutes");
					break;
				case ReportCreationType.Weekly:
					settings["dayOfWeek"] = ([7,1,2,3,4,5,6])[this._form.find("[name=weekDay]").val()*1];
					settings["hour"] = this._form.find("[name=weeklyTime]").timeselect("getHours");
					settings["min"] = this._form.find("[name=weeklyTime]").timeselect("getMinutes");
					break;
				case ReportCreationType.Monthly:
					settings["dayOfMonth"] = this._form.find("[name=monthDay]").val() > 0 ? this._form.find("[name=monthDay]").val():1;
					settings["hour"] = this._form.find("[name=monthlyTime]").timeselect("getHours");
					settings["min"] = this._form.find("[name=monthlyTime]").timeselect("getMinutes");
					break;
			}
			result["type"] =0;
			params["creationType"] = schType;
			result["params"] = params;
			result["settings"] = settings;
			
			var retObj ={
				data : KL.Utils.JSON.encode(result)
			};
			return retObj;		
		},
		
		
		getUsersParams: function(){
			var ReportCreationType = KL.LMS.Enums.ReportCreationType;
			var ReportPeriodType = KL.LMS.Enums.ReportPeriodType;
			
			var result = {};
			var params = {};
			this._checkReportUsersPeriod();
			
			var d = KL.Utils.DateHelper.getServerTime();//new Date();
			d = this._form.find("[name=monthDays]").datepicker("getDate");
			d.setHours(12);
			switch (this.reportUsersPeriod) {
				case 0 : 
					params["startDate"] = Math.round(d.getTime() / 1000);
					params["periodType"] = ReportPeriodType.Day;
					params["periodCount"] = 1;
					break;
				case 1 : 
					var MonthSelect = this._form.find("[name=usersMonth]");
					var month = MonthSelect.val()*1;
					d.setMonth(d.getMonth()- month);
					params["startDate"] = Math.round(d.getTime() / 1000);
					params["periodType"] = ReportPeriodType.Month;
					params["periodCount"] = 1;
					break;
				case 2 :
					var YearSelect = this._form.find("[name=usersYear]");
					var year = YearSelect.val()*1;
					d.setFullYear(year);
					d.setMonth(0);
					d.setDate(1);
					params["startDate"] = Math.round(d.getTime() / 1000);
					params["periodType"] = ReportPeriodType.Year;
					params["periodCount"] = 1;
					break;
				case 3 : 
					d = this._form.find("[name=usersDateStart]").datepicker("getDate");
					d.setHours(12);
					var d_finish = new Date();
					d_finish = this._form.find("[name=usersDateFinish]").datepicker("getDate");
					d_finish.setHours(12);//debugger;
					var periodCount = (Math.round(d_finish.getTime() / 1000) - Math.round(d.getTime() / 1000))/60/60/24;
						
					params["startDate"] = Math.round(d.getTime() / 1000);
					params["periodType"] = ReportPeriodType.Day;
					params["periodCount"] = periodCount+1;
					break;
			}
			var lang = this._form.find("[name=sourceCountry]").val();
			params["lang"] = lang;
			params["dateFormat"] = this._form.find("[name=reportDateFormat]").val();
			
			params["format"] = 0;
			params["creationType"] = ReportCreationType.Users;
			params["mailList"] = this._form.find(".receiversEditor").listeditor("getValue");
			params["sendToAdmin"] = this._form.find("[name=sendToAdminReport]").is(":checked");
			result["type"] =0;
			result["params"] = params;
			
			var retObj ={
				data : KL.Utils.JSON.encode(result)
			};
			return retObj;
		},
		
		onDataSet: function () {
			var localization = KL.Utils.Localization.getInstance();
			var ReportCreationType = KL.LMS.Enums.ReportCreationType;
			var val = KL.LMS.Enums.ReportCreationType[this._data.type];
			this._form.find(".periodStartTime").hide();
			
			var elt = "";
			if (this._data && this._data.sendOptions) {
				this._form.find("[name=enableSendReport]").attr("checked",this._data.sendOptions.enableSend);
				this._form.find("[name=sendToAdminReport]").attr("checked", this._data.sendOptions.sendToAdmin);
			}
			
			var l = this._data["localeList"];
			var reportLocaleSelect = this._form.find("[name=sourceCountry]")
			
			if (l && l.count)
				for (var i = 0; i <l.count; i++) {
					var str = l.items[i].lang;
					if (l.items[i].name) str=l.items[i].name
					$(KL.Utils.StringHelper.format('<option value="{0}"></option>', l.items[i].lang)).appendTo(reportLocaleSelect).append(str);
				}
			else 
				$(KL.Utils.StringHelper.format('<option value="{0}"></option>', "en_US")).appendTo(reportLocaleSelect).append("en_US");
			if (this._data.localeOptions) {
				this._form.find("[name=reportDateFormat]").val(this._data.localeOptions.dateFormat)
				this._form.find("[name=sourceCountry]").val(this._data.localeOptions.lang);
			}
			else {
				this._form.find("[name=reportDateFormat]").val(0)
				this._form.find("[name=sourceCountry]").val(0);
			
			}
			
			switch (val) {
				case ReportCreationType.Manual: 
				case ReportCreationType.Users: elt = ".periodUser"; 
					this._form.find("[name=enableSendReport]").hide();
						
					var d = KL.Utils.DateHelper.getServerTime();
					var d_min = new Date(d);
					d_min.setTime(d.getTime() - 1000 * 60 * 60 * 24 * 122);
						
					this._form.find("[name=monthDays]").datepicker("setDate", d);
					this._form.find("[name=monthDays]").datepicker("option","maxDate",d);
					this._form.find("[name=monthDays]").datepicker("option","minDate",d_min);
						
					this._form.find("[name=usersDateFinish]").datepicker("setDate", d);
					this._form.find("[name=usersDateFinish]").datepicker("option","maxDate",d);
					this._form.find("[name=usersDateFinish]").datepicker("option","minDate",d_min);
					this._form.find("[name=usersDateStart]").datepicker("setDate", d_min);
					this._form.find("[name=usersDateStart]").datepicker("option","maxDate",d);
					this._form.find("[name=usersDateStart]").datepicker("option","minDate",d_min);
					this._form.find(".btnOk").html("<span class=\"left\"><span class=\"right\"><span class=\"center\"><span class=\"buttonText str-local-BtnCreate\">{BtnCreate}</span></span></span></span>");
						
					break;
				case ReportCreationType.Daily: elt = ".periodDay";
					this._form.find("[name=dailyTime]").timeselect("setHours", this._data.hour);
					this._form.find("[name=dailyTime]").timeselect("setMinutes", this._data.min);
					break;
				case ReportCreationType.Weekly: elt = ".periodWeekly"; 
					this._form.find("[name=weeklyTime]").timeselect("setHours", this._data.hour);
					this._form.find("[name=weeklyTime]").timeselect("setMinutes", this._data.min);
					this._form.find("[name=weekDay]").val(([7,1,2,3,4,5,6])[this._data.dayOfWeek]);
					break;
				case ReportCreationType.Monthly: elt = ".periodMonthly"; 
					this._form.find("[name=monthlyTime]").timeselect("setHours", this._data.hour);
					this._form.find("[name=monthlyTime]").timeselect("setMinutes", this._data.min);
					this._form.find("[name=monthDay]").val(this._data.dayOfMonth||1);
					break;
				case ReportCreationType.Yearly: elt = ".periodYearly"; break;
			}
			if (elt) {
				this._form.find(elt).show();
				this._page.setTitle(localization.getLocaleString("LabelReportsParamsTitle_"+this._data.type));
				this._form.find(".ReportsTypeFiled").html(localization.getLocaleString("LabelReportsParamsTitle_Schedule_"+this._data.type));
			}
		},
		_getPeriod: function(d_start,d_finish){
			return (Math.round(d_finish.getTime() / 1000) - Math.round(d_start.getTime() / 1000))/60/60/24;
		},
		
		_checkDataAlreadyOccured: function(d_check){
			var d_now = new Date();
			d_now = KL.Utils.DateHelper.getServerTime();
			return (d_check.getTime()>=d_now.getTime() ) ?	false : true;
		},
		_checkDataIsInDataBase: function(d_check){
			var d_now = new Date();
			d_now = KL.Utils.DateHelper.getServerTime();
			return this._getPeriod(d_check,d_now) <123 ?	true : false;
		},
		
		_showPeriodError: function(d_start,d_finish) {
			var localization = KL.Utils.Localization.getInstance();
			if (d_start) {
				if (!this._checkDataAlreadyOccured(d_start)) {
					this.showError(-1, localization.getLocaleString("LabelSettingsPanelReport_ErrorNotYetBegun"));
					return true;
				}	
				if (!this._checkDataIsInDataBase(d_start)) {
					this.showError(-1, localization.getLocaleString("LabelSettingsPanelReport_ErrorNotIsInDatabase"));
					return true;
				}	
			}
			if (d_finish) {
				if (!this._checkDataAlreadyOccured(d_finish)) {
					this.showError(-1, localization.getLocaleString("LabelSettingsPanelReport_ErrorNotYetBegun"));
					return true;
				}	
				if (!this._checkDataIsInDataBase(d_finish)) {
					this.showError(-1, localization.getLocaleString("LabelSettingsPanelReport_ErrorNotIsInDatabase"));
					return true;
				}	
			}
			if (d_start && d_finish && d_finish.getTime()<d_start.getTime()) {
				this.showError(-1, localization.getLocaleString("LabelSettingsPanelReport_ErrorRangeExceeds"));
				return true;
			}	
			return false;
		},
		
		onBeforeHide: function () {
			if (this._form) {
				this._form.find("[name=monthDays]").datepicker("hide");
				this._form.find("[name=usersDateStart]").datepicker("hide");
				this._form.find("[name=usersDateFinish]").datepicker("hide");
			}
		},
		_validate: function () {
			this._checkReportUsersPeriod();
			if (KL.LMS.Enums.ReportCreationType[this._data.type] ==  KL.LMS.Enums.ReportCreationType.Users) {
				switch (this.reportUsersPeriod) {
					case 0 : 
							
							var d = new Date();
							d = this._form.find("[name=monthDays]").datepicker("getDate");
							if (this._showPeriodError(d) ) {
								this._form.find("[name=monthDays]").addClass("error");
								return false;
							}
							break;
					case 1 : 
						break;
					case 2 : 
						break;
					case 3 : var d_start = new Date();
							d_start = this._form.find("[name=usersDateStart]").datepicker("getDate");
							var d_finish = new Date();
							d_finish = this._form.find("[name=usersDateFinish]").datepicker("getDate");
							if (this._showPeriodError(d_start) ) {
								this._form.find("[name=usersDateStart]").addClass("error");
								return false;
							}	
							if (this._showPeriodError(null,d_finish) ) {
								this._form.find("[name=usersDateFinish]").addClass("error");
								return false;
							}	
							
							if (this._showPeriodError(d_start,d_finish))  {
								this._form.find("[name=usersDateFinish]").addClass("error");
								this._form.find("[name=usersDateStart]").addClass("error");
								return false;
							}
						break;
				}				
			}
			return true;
		},
		_validateEmail: function (val) {
			var elt = this.getElt();
			if (elt) {
				elt.find(".editField").removeClass("error");
					var reg = /^[a-zA-Z0-9][\w\.-]*[a-zA-Z0-9]*@[a-zA-Z0-9][\w\.-]*[a-zA-Z0-9\.]*[a-zA-Z][a-zA-Z\.]*[a-zA-Z]$/;
				if(!reg.test(val)) {
					elt.find(".editField").addClass("error");
					return false;
				}	
			}
			return true;
		}
	};
	KL.LMS.Reports.registerClass("ReportParamsForm", ReportParamsForm);
	ReportParamsForm.extend(KL.LMS.Settings.BaseSettingsForm);
})();
;
(function () {
	var SignupForm = function (id, setting) {
		SignupForm._super.call(this, id, setting);
	};
	SignupForm.prototype = {
		_username: "",
		applyValue: function (evt, data, isLoadCompleted) {
			if(isLoadCompleted){
				this._hideLoading();
				var userType = (data.hasOwnProperty("userType")?data.userType:(!!data.admin?KL.Utils.UserTypes.Admin:KL.Utils.UserTypes.User));
				this._page.getApplication().setUserAuthorised(this._username, userType);
				this._showLoading();
				$(this).trigger("onloginsuccess");
			}
		},
		
		signOut: function () {
			var app = this._page.getApplication();
			app.getContext().setData(KL.Web.Context.DataTypes.UserName, null);
			app.showLoginPage();
		},
		applyError: function (evt, err) {
			this._form.find("input[type=password]").val("");
			this._toggleSubmitEnabled(false);
			this.showError(err.id, err.message);
			this._hideLoading();
			$(this).trigger("onloginerror");
		},
		_showLoading: function () {
			this._form.find(".signInLoaderLbl").show();
			this._form.find("button").hide();
		},
		_hideLoading: function () {
			this._form.find(".signInLoaderLbl").hide();
			this._form.find("button").show();
		},
		onFormSubmit: function () {
			this._showLoading();
			this._username = this._form.find("input[name=username]").val();
		},
		onFormInit: function () {
			this._form.find("input[type=password]").focus(function () { $(this).select(); });
			this._hideLoading();
			$(this._page).bind( "onpageopen", KL.Utils.Delegate.create( this, this._formOpenHanlder ) );
		},
		_formOpenHanlder: function(){
			var isLoginEnabled = this._page.getApplication().getContext().getData( KL.Web.Context.DataTypes.LoginEnabled );
			
			if( isLoginEnabled === false )
				this.disable();
			else
				this.enable();
			this._hideLoading();
			this._form.find("input[name=username]").focus();
			this._toggleSubmitEnabled(!!this._form.find("input[name=username]").val() && !!this._form.find("input[name=password]").val());
		},
		_toggleSubmitEnabled: function (enabled) {
			this._form.find("button").attr("disabled", !enabled);
		}
	};
	KL.LMS.registerClass("SignupForm", SignupForm);
	SignupForm.extend(KL.Web.Controls.FormControl);
})()
;
(function () {
	var TwoColumnsLayout = function (id, setting) {
		TwoColumnsLayout._super.call( this, id, setting );
	};
	TwoColumnsLayout.prototype = {
		_data: null,
		onInitInteraction: function () {
			
		}
	};
	KL.LMS.registerClass("TwoColumnsLayout", TwoColumnsLayout);
	TwoColumnsLayout.extend(KL.Web.Controls.Control);
})()
;
(function () {
	var LdapSearch = function (id, setting) {
		LdapSearch._super.call(this, id, setting);
	};
	LdapSearch.prototype = {
		_data: null,
		_term: "",
		_response: null,
		applyData: function (e, data) {
		},
		onInitInteraction: function () {
			var elt = this.getElt();
			if (elt) {
				var Delegate = KL.Utils.Delegate;
				this.hideLoading();
				this._response = null;
				elt.find(".addrField").autocomplete({
					"minLength": 0,
					"delay": 500,
					"source": Delegate.create(this, this._startSearch),
					"select": Delegate.create(this, this._itemSelect)
				}).data("autocomplete")._renderItem = Delegate.create(this, this._renderAutocompleteItem);
			}
		},
		getTerm: function () {
			return this._term;
		},
		_startSearch: function (request, response) {
			var elt = this.getElt();
			if (elt) {
				var ac = elt.find(".addrField");
				ac.autocomplete("close");
				response([]);
			}
			this._term = request.term;
			this._response = response;
			$(this).trigger("onsearchstart");
		},
		_itemSelect: function (e, ui) {
			var elt = this.getElt();
			if (elt) {
				elt.find(".addrField").val(ui.item.label);
			}
		},
		setSearchResult: function (e, data) {
			if (this._response != null && data.items && data.items.length > 0) {
				this._response($.map(data.items, KL.Utils.Delegate.create(this, function (item) {
					return {
						"label": item.attributes ? this._getLdapString(item.attributes) : "-",
						"value": item["entryid"],
						"itemData": item
					};
				})));
				this._response = null;
			}
		},
		_renderAutocompleteItem: function (ul, item) {
			var className = (["itemGroup", "itemGroup"])[item.itemData.objectType] || "itemUnknown";
			return $(KL.Utils.StringHelper.format("<li class='{1}'><a>{0}</a></li>", item.label, className))
				.data("item.autocomplete", item)
				.appendTo(ul);
		},
		_getLdapString: function (data) {
			var result = "";
			for (var i = 0, l = data.length; i < l; i++) {
				if (data[i]["attribute"] != "objectClass")
					result = result + data[i]["values"].join(", ") + "   ";
			}
			return result;
		},
		showLoading: function () {
			var elt = this.getElt();
			if (elt)
				elt.find(".loader").show();
		},
		hideLoading: function () {
			var elt = this.getElt();
			if (elt)
				elt.find(".loader").hide();
		},
		_save: function () {
			var elt = this.getElt();
			if (elt) {
			}
			$(this).trigger("onok");
			return false;
		}
	};
	KL.LMS.registerClass("LdapSearch", LdapSearch);
	LdapSearch.extend(KL.Web.Controls.Control);
})()
;
(function () {
	var Dashboard = function (id, setting) {
		Dashboard._super.call(this, id, setting);
		this.stateClasses = [
			"storageEmpty",
			"storageEmpty",
			"storageEmpty",
			"storageHalf",
			"storageHalf",
			"storageHalf",
			"storageWarn",
			"storageWarn",
			"storageFull",
			"storageFull",
			"storageFull"
		];
		this._filterTypes = {
			"Month": 0,
			"Week": 1,
			"Day": 2,
			"Hour": 3
		};
		this._dataTypes = {
			"Msgs": 1,
			"Size": 2
		};
		this._filters = [
			{ "data": { "type": 1, "barsCount": 30 }, "filterType": this._filterTypes.Month },
			{ "data": { "type": 1, "barsCount": 7 }, "filterType": this._filterTypes.Week },
			{ "data": { "type": 2, "barsCount": 24 }, "filterType": this._filterTypes.Day },
			{ "data": { "type": 3, "barsCount": 12 }, "filterType": this._filterTypes.Hour }
		];
		this._legendTitles = {
			"clean": {"title": "LabelDashboardLegendClear", "showhint": true, "hintid": "dashboardTooltipClean"},
			"malware": {"title": "LabelDashboardLegendMalware", "showhint": true, "hintid": "dashboardTooltipThreats"},
			"notScanned": {"title": "LabelDashboardLegendUnprocessed", "showhint": true, "hintid": "dashboardTooltipUnprocessed"},
			"spam": {"title": "LabelDashboardLegendSpam", "showhint": true, "hintid": "dashboardTooltipSpam"},
			"content": {"title": "LabelDashboardLegendContent", "showhint": true, "hintid": "dashboardTooltipContent"},
			"phishing": {"title": "LabelDashboardLegendPhishing", "showhint": true, "hintid": "dashboardTooltipPhishing"}
		};
		this.verdictsOrder = ["clean", "malware", "notScanned", "spam", "content", "phishing"];
		this._chartData = { verdicts: null, stat: null, visible: { malware: true, spam: true, content: true, notScanned: true, clean: true, total: true, phishing: true } };
	};
	var InfoTypes = { "Charts": 1, "Trheats": 2 },
		TreatTypes = { "IntrusionThreat": 0, "Dangerous": 1, "Suspisious": 2 },
		TypesContainerIDs = [".othersList", ".dangerousList", ".suspiciousList"],
		maxthreatIcemsCount = 5;
	Dashboard.prototype = {
		_filterVal: null,
		_dataTypeVal: null,
		_filterPageParamName: "chartperiod",
		_typePageParamName: "chartby",
		_filterInited: false,
		stateClasses: null,
		_filterTypes: null,
		_filters: null,
		_legendTitles: null,
		_chartData: null,
		legendTpl: "",
		legendWrap: null,
		verdictsOrder: null,
		threatsItemsTpls: [],
		infoViewType: InfoTypes.Charts,
		onInitInteraction: function () {
			var elt = this.getElt();
			if (elt) {
				var Delegate = KL.Utils.Delegate;
				this._initCharts(elt);
				this._initViewSwitch(elt);
				elt.find(".slatAvStatus, .slatAsStatus").find(".slatInfo").hide();
				elt.find(".slat, .chartsLegend").addClass("loading");
				elt.find(".slatLdap .slatIco").click(Delegate.create(this, this._triggerEvt, "onldapenter"));
				elt.find(".slatStorage .slatIco").click(Delegate.create(this, this._triggerEvt, "onstorageenter"));
				elt.find(".slatDiskUsage .slatIco").click(Delegate.create(this, this._triggerEvt, "onusageenter"));
				
				elt.find(".chartRefreshBtn").click(Delegate.create(this, this._triggerFilterChange));
				elt.find(".tooltip").hide();
				elt.find(".slatDiskUsage,.slatStorage").show();
				elt.find(".slatStorageErr").hide();
			}
		},
		_initCharts: function (elt){
			var Delegate = KL.Utils.Delegate;
			this.legendWrap = elt.find(".legendItems .item").parent();
			this.legendTpl = this.legendWrap.html();
			this.legendWrap.empty();
			var activeFilter = this._page.getApplication().getPageParam(this._filterPageParamName);
			var activeType = this._page.getApplication().getPageParam(this._typePageParamName);
			activeFilter = (activeFilter ? this._filterTypes[activeFilter[0].toUpperCase() + activeFilter.slice(1)] : 0)||0;
			activeType = (activeType ? this._dataTypes[activeType[0].toUpperCase() + activeType.slice(1)] : 1)||1;
			elt.find(".chart").each(Delegate.create(this, function (indx, item) { $(item).barchart({ "ySegments": 4 }); $(item).barchart("setData", { "max": 0, "data": [0, 0, 0], "layout": ($(item).is(".horizontalchart")?"horisontal":"") }); }));
			this._filterInited = false;
			elt.find(".periodFilter a").each(Delegate.create(this, function (indx, item) {
				$(item).click(Delegate.create(this, this._applyFilter, item, indx));
			})).eq(activeFilter).click();
			this._filterInited = false;
			elt.find(".typeSelector a").each(Delegate.create(this, function (indx, item) {
				$(item).click(Delegate.create(this, this._applyType, item));
			})).eq(activeType-1).click();
		},
		_initViewSwitch: function(elt){
			var btns = elt.find(".dashboardMainPanel .pnlBtns .button");
			for( var i=0, l=TypesContainerIDs.length; i<l; i++ ){
				var list = elt.find(TypesContainerIDs[i] + " .threatsList");
				this.threatsItemsTpls.push( list.html() );
				list.empty();
			}
			btns.each( KL.Utils.Delegate.create(this, function (_btns, indx, item) {
				$( item ).click( KL.Utils.Delegate.create(this, function (bs, btn) {
					bs.attr( "disabled", false);
					var viewtype = $( btn ).attr( "disabled", true).data("viewtype");
					this._showViewPanel( viewtype );
				}, _btns, item ));
			}, btns) ).eq( this.infoViewType - 1 ).click();
		},
		_triggerEvt: function (evtname) {
			$(this).trigger(evtname);
			return false;
		},
		_applyFilter: function (link, indx, e) {
			if (e) {
				e.stopPropagation();
				e.preventDefault();
			}
			var elt = this.getElt();
			if (elt) {
				elt.find(".periodFilter .selected").removeClass("selected");
				var filterIndx = ($(link).addClass("selected").data("filter") || 0) * 1;
				
				for (var filterName in this._filterTypes) {
					if (filterIndx == this._filterTypes[filterName]) {
						this._page.getApplication().setPageParam( this._filterPageParamName, filterName.toLowerCase() );
						break;
					}
				}
				if (this._filters[filterIndx]) {
					this._filterVal = this._filters[filterIndx];
					this._triggerFilterChange();
				} else {
					this._filterVal = null;
				}
			}
		},
		currView: 0,
		_showViewPanel: function(viewType){
			var elt = this.getElt();
			if(elt){
				elt.find(".dashboardViewPanel").hide();
				viewType = viewType || InfoTypes.Charts;
				this.currView = viewType;
				switch(viewType){
					case InfoTypes.Charts:
						elt.find(".titleText").html( KL.Utils.Localization.getInstance().getLocaleString("LabelTitleDashboardCharts") );
						elt.find(".dashboardCharts").show();
						this._filterInited = true;
						this._triggerFilterChange();
						break;
					case InfoTypes.Trheats:
						elt.find(".titleText").html( KL.Utils.Localization.getInstance().getLocaleString("LabelTitleDashboardThreats") );
						elt.find(".loadingPanel").show();
						this._triggerEvt("onloadthreats");
						break;
				}
			}
		},
		applyThreatsData: function(evt, data, isLoaded){
			if(isLoaded){
				var elt = this.getElt();
				if(elt && this.currView === InfoTypes.Trheats){
					elt.find(".dashboardViewPanel").hide();
					data = data || {};
					data.items = data.items || [
						{"threatType": {"typeID": TreatTypes.Dangerous } },
						{"threatType": {"typeID": TreatTypes.Suspisious } }
					];
					for( var i=0, l=data.items.length; i<l; i++ )
						if (data.items[i].threatType.typeID != TreatTypes.IntrusionThreat)
							this._renderThreatTypeInfo( data.items[i].threatType.typeID, data.items[i].threats, elt );
					elt.find(".dashboardTreatsList").show();
				}
			}
		},
		_renderThreatTypeInfo: function(type, items, elt ){
			var container = elt.find( TypesContainerIDs[type] ),
				listContaier = container.find(".threatsList"),
				Delegate = KL.Utils.Delegate,
				DateHelper = KL.Utils.DateHelper,
				StringHelper = KL.Utils.StringHelper;
			container.find(".emptyList").hide();
			container.find(".threatsList").show();
			if( !items || !(items instanceof Array) || !items.length )
				container.find(".emptyList").show();
			listContaier.empty();
			var tpl = $.trim(this.threatsItemsTpls[type]);
			for( var i=0, l= maxthreatIcemsCount; i<l; i++ ){
				if(items[i]){
					var item = $( StringHelper.formatTemplate(tpl, {
						"Class": i%2?"itemEven":"itemOdd",
						"Name": items[i].name,
						"Date": DateHelper.getLocaleDate( this.id, items[i].time )
					}) ).appendTo(listContaier);
					item.find( ".descr" ).on("click", Delegate.create( this, this._showThreatInfo, items[i] ));
				}else
					$( StringHelper.formatTemplate(tpl, {"Class": i%2?"itemEven":"itemOdd", "Name": "&nbsp;", "Date": "&nbsp;"})).appendTo(listContaier).find( "a" ).remove();
			}
			window.setTimeout( Delegate.create( DateHelper, DateHelper.applyLocaleDates, this.id, elt.find(".dashboardTreatsList") ), 100);
		},
		_showThreatInfo: function(data, e){
			if (e) {
				e.preventDefault();
			}
			$( this ).trigger("onthreatinfo", ["!!!", e.currentTarget, "LabelTitleDashboardThreatDetails", false, data]);
		},
		_applyType: function(link, e){
			if (e) {
				e.stopPropagation();
				e.preventDefault();
			}
			var elt = this.getElt();
			if (elt) {
				elt.find(".typeSelector .selected").removeClass("selected");
				this._dataTypeVal = ($(link).addClass("selected").data("filter") || 1) * 1;
				for (var filterName in this._dataTypes) {
					if (this._dataTypeVal == this._dataTypes[filterName]) {
						this._page.getApplication().setPageParam( this._typePageParamName, filterName.toLowerCase() );
						break;
					}
				}
				this._triggerFilterChange();
			}
		},
		_triggerFilterChange: function () {
			var elt = this.getElt();
			if (elt && this._filterInited) {
				$(this).trigger("onfilterchange");
				elt.find(".chart").addClass("loading");
			}
			this._filterInited = true;
			return false;
		},
		applyStatsData: function (e, data) {
			var elt = this.getElt();
			if (elt && data && data.items && this.legendWrap) {
				this.legendWrap.empty();
				var total = Array.prototype.slice.call(arguments, -1);
				var StringHelper = KL.Utils.StringHelper;
				var localization = KL.Utils.Localization.getInstance();
				var cd = { "max": 0, "data": []	};
				var cdsmall = { malware: 0, spam: 0, content: 0, phishing: 0, notScanned: 0, clean: 0, total: 0, max: 0 };
				var valueK = this._dataTypeVal == this._dataTypes.Size? 1/(1024*1024) : 1;
				if (this._filterVal ) {
					var type = this._filterVal.filterType;
					for (var i = 0, l = data.items.length; i < l; i++) {
						var item_i = data.items[i];
						if("notChecked" in item_i){
							item_i["notScanned"] = item_i["notChecked"];
							delete item_i.notChecked;
						}
						cd.data.push({
							"type": type,
							"value": item_i
						});
						cd.max = Math.max(cd.max,item_i.total);
						for (var propname in cdsmall) {
							var _propname = propname == "notScanned" && ("notChecked" in item_i)?"notChecked":propname;
							if (typeof (item_i[_propname]) != "undefined")
								cdsmall[propname] += item_i[_propname];
						}
					}
					this._chartData.stat = cd;
					var cd1 = [];
					
					for (var i = 0, l = this.verdictsOrder.length; i < l; i++) {
						var perc = (Math.round(10000 * cdsmall[this.verdictsOrder[i]] / cdsmall.total) / 100) || 0;
						var val_i = (valueK * cdsmall[this.verdictsOrder[i]])||0;
						var item_i = $(StringHelper.format(
							this.legendTpl,
							0 < Math.abs(val_i) && Math.abs(val_i) < 0.01? "< 0.01" : Math.round(val_i*100)/100,
							localization.makeLocaleStringObj( this.id + "_StatsData", "ResPercentFormat", perc ),
							i,
							localization.getLocaleString(this._legendTitles[this.verdictsOrder[i]]?this._legendTitles[this.verdictsOrder[i]].title:""),
							(this._legendTitles[this.verdictsOrder[i]]?this._legendTitles[this.verdictsOrder[i]].hintid:""),
							(i<l-1)?"":"itemLast"
						)).appendTo(this.legendWrap);
						item_i.find( ".helpIco" ).toggle(this._legendTitles[this.verdictsOrder[i]]?!!this._legendTitles[this.verdictsOrder[i]].showhint:false);
						item_i.find("input[type=checkbox]").click(KL.Utils.Delegate.create(this, this._toggleColor, i, item_i, this.verdictsOrder[i])).attr( "checked", this._chartData.visible[this.verdictsOrder[i]] );
						cd1.push({ "value": cdsmall[this.verdictsOrder[i]], "label": null });
					}
					KL.Utils.TooltipHelper.makeTooltips( elt.find(".helpIco[rel]"), this, elt );
					total = cdsmall.total * valueK;
					total = 0 < Math.abs(total) && Math.abs(total) < 0.01? "< 0.01" : Math.round(total*100)/100;
					elt.find(".legendItems .legendTotal .count").text( total+ "");
					elt.find(".legendItems .legendTotal .percent").html( localization.getLocaleStringObj( "ResPercentFormat", 100 ) );
					this._chartData.verdicts = cd1;
					elt.find(".chartsLegend").removeClass("loading");
					var time = new Date();//KL.Utils.DateHelper.getServerTime();
					elt.find(".filterInfo").empty().append(KL.Utils.Localization.getInstance().getLocalDateTime(KL.Utils.DateHelper.createDate((time / 1000)), "LabelDashboardDataReceivedDate"));
					elt.find(".oldestMsgInfo").empty().toggle(!!data.oldestMessageDate).append(KL.Utils.Localization.getInstance().getLocalDateTime(KL.Utils.DateHelper.createDate(data.oldestMessageDate), "LabelDashboardDataOldestMsgDate"));
					this._renderChartData();
					localization.applyStingObjs( this.id + "_StatsData", elt );
				}
			}
		},
		_getChartRullerLabel: function (date, type, indx) {
			var localization = KL.Utils.Localization.getInstance(),
				lbl = "";
			switch (type) {
				case this._filterTypes.Month: lbl = (!(indx % 8))? KL.Utils.DateHelper.getLocaleDate(this.id, date, "ResMonthDateFormat") : ""; break;
				case this._filterTypes.Week: lbl = KL.Utils.DateHelper.getLocaleDate(this.id, date, "ResShortMonthDateFormat"); break;
				case this._filterTypes.Day: lbl = (!((indx+1)%3))?KL.Utils.DateHelper.getLocaleDate(this.id, date, "ResTimeFormat"):""; break;
				case this._filterTypes.Hour: lbl = (indx % 2)?KL.Utils.DateHelper.getLocaleDate(this.id, date, "ResTimeFormat"):""; break;
				default: lbl = KL.Utils.DateHelper.getLocaleDate(this.id, date, "ResDateUnknown"); break;
			}
			return lbl;
		},
		_renderChartData: function () {
			var elt = this.getElt();
			if (elt) {
				var localization = KL.Utils.Localization.getInstance(),
					cd0 = { "max": 0, "data": [] }, cd1 = [],
					valueK = this._dataTypeVal == this._dataTypes.Size? 1/(1024*1024) : 1;
				for (var i = 0, l = this._chartData.stat.data.length; i < l; i++) {
					var data_i = this._chartData.stat.data[i];
					var val_i = [];
					var total = 0;
					for (var v = 0, lv = this.verdictsOrder.length; v < lv; v++) {
						var verdict_val =  (valueK * (this._chartData.visible[this.verdictsOrder[v]] ? data_i.value[this.verdictsOrder[v]] * 1 : 0 ))||0;
						val_i.push(verdict_val);
						total += verdict_val;
					}
					cd0.data.push({
						"label": this._getChartRullerLabel(data_i.value.time, data_i.type, i),
						"value": val_i
					});
					cd0.max = Math.max(cd0.max, total);
				}
				var vals = [];
				for (var i = 0, l = this.verdictsOrder.length; i < l; i++) {
					var verdictVal = { "value": (valueK * (this._chartData.visible[this.verdictsOrder[i]] ? this._chartData.verdicts[i].value : 0))||0, "label": null };
					vals.push(verdictVal.value);
					cd1.push(verdictVal);
				}
				elt.find(".wideChart .chart").removeClass( "loading" ).barchart("setData", cd0);
				elt.find(".smallChart .chart").removeClass("loading").barchart("setData", {
					"max": Math.max.apply(Math, vals),
					"title": localization.getLocaleString( (this._dataTypeVal == this._dataTypes.Size && localization.stringExists("LabelDashboardChartTitleVerdictsMb"))? "LabelDashboardChartTitleVerdictsMb" :"LabelDashboardChartTitleVerdicts" ),
					"layout": "horisontal",
					"data": cd1
				});
				KL.Utils.DateHelper.applyLocaleDates(this.id, elt);
			}
			
		},
		_toggleColor: function (i, item, verdict) {
			var visible = item.find("input[type=checkbox]").is(":checked");
			if (typeof (this._chartData.visible[verdict]) != "undefined")
				this._chartData.visible[verdict] = visible;
			this._renderChartData();
		},
		
		getStatData: function () {
			if (this._filterVal)
				return KL.Utils.JSON.encode( $.extend({"volumeType": this._dataTypeVal},this._filterVal.data));
			return false;
		},
		applyAsError: function (e, data) {
			var elt = this.getElt();
			if (elt && data) {
				this._makeAvspError(data, elt.find(".slatAsStatus"), elt);
				KL.Utils.Log.write(this + ".AS_Error: " + data.message, KL.Utils.Log.type.WARNING);
				window.setTimeout( KL.Utils.Delegate.create(this, this._triggerEvt, "onasinforeload"), 5000 );
			}
		},
		applyAvError: function (e, data) {
			var elt = this.getElt();
			if (elt && data) {
				this._makeAvspError(data, elt.find(".slatAvStatus"), elt);
				KL.Utils.Log.write(this + ".AV_Error: " + data.message, KL.Utils.Log.type.WARNING);
				window.setTimeout( KL.Utils.Delegate.create(this, this._triggerEvt, "onavinforeload"), 5000 );
			}
		},
		applyApError: function (e, data) {
			var elt = this.getElt();
			if (elt && data) {
				this._makeAvspError(data, elt.find(".slatApStatus"), elt);
				KL.Utils.Log.write(this + ".AP_Error: " + data.message, KL.Utils.Log.type.WARNING);
				window.setTimeout( KL.Utils.Delegate.create(this, this._triggerEvt, "onapinforeload"), 5000 );
			}
		},
		applyAsStats: function (e, data) {
			var elt = this.getElt();
			if (elt && data)
				this._makeAvspSlat(data, elt.find(".slatAsStatus"), this._page.getApplication().getContext().getIsLicenseAsEnabled());
		},
		applyAvStats: function (e, data) {
			var elt = this.getElt();
			if (elt && data)
				this._makeAvspSlat(data, elt.find(".slatAvStatus"), this._page.getApplication().getContext().getIsLicenseAvEnabled());
		},
		applyApStats: function (e, data) {
			var elt = this.getElt();
			if (elt && data)
				this._makeAvspSlat(data, elt.find(".slatApStatus"), this._page.getApplication().getContext().getIsLicenseApEnabled());
		},
		_makeAvspError: function (data, container, elt) {
			var dOut = {
				'status': KL.Utils.Localization.getInstance().getLocaleString("LabelDashboardDbError"),
				'val': KL.Utils.Exception.getExceptionText(typeof (data.id) != "undefined" ? data.id : KL.Utils.Exception.ExceptionTypes.SystemError)
			};
			container.removeClass("loading")
				.addClass("slatWarn");
			container.find(".statusText").html(dOut.status);
			container.find(".slatStatus .infoVal").addClass("colorObsoleted").html(dOut.val);
			this.applyUpdateError( dOut, elt.find( ".slatUpdate" ) );
		},
		_makeAvspSlat: function (data, container, isEngineEnabled) {
			if( !this.isVisible() )
				return;
			var localization = KL.Utils.Localization.getInstance();
			container.removeClass("loading slatWarn slatOutdated slatObsoleted");
			container.find(".slatInfo").show();
			if (typeof (data.messagesInQuarantine) != "undefined") {
				var quarantineSize = data.messagesInQuarantine;
				container.find(".quarantineSize .infoVal").html(quarantineSize);
			}
			
			data.enable = isEngineEnabled && data.enable;
			container.toggleClass("slatWarn", (!data.enable));
			container.find(".statusText").html(localization.getLocaleString(data.enable ? "LabelDashboardStatusEnabled" : "LabelDashboardStatusDisabled"));
			if (typeof (data.status) != "undefined") {
				var statusName = KL.LMS.Enums.DbStates.getKeyByValue(data.status);
				container.addClass("slat" + statusName);
				
				container.find(".slatStatus .infoVal")
					.removeClass("colorObsoleted colorOutdated colorNoBases").addClass("color" + statusName)
					.html(localization.getLocaleString("LabelDashboardDb" + statusName));
			}
			this.applyUpdateStatus(null, data);
		},
		applyUpdateError: function(data, container){
			container.removeClass("loading slatWarn slatOutdated slatObsoleted");
			container.find(".infoVal").addClass("colorObsoleted").html(data.val);
			container.find(".statusText").addClass("colorObsoleted").html(data.status);
		},
		applyUpdateStatus: function(e, data){
			
			var elt = this.getElt();
			if (elt && data && !!this.isVisible() ) {
				var DateHelper = KL.Utils.DateHelper,
					DbUpdateStatuses = KL.LMS.Enums.DbUpdateStatuses,
					localization = KL.Utils.Localization.getInstance(),
					container = elt.find( ".slatUpdate" ).show().removeClass("loading slatWarn slatOutdated slatObsoleted"),
					infoVal = container.find(".infoVal").removeClass("colorObsoleted colorOutdated colorNoBases colorOk"),
					statusText = container.find(".statusText").removeClass("colorObsoleted colorOutdated colorNoBases colorOk").empty(),
					updateStatus = data.lastUpdate?(data.lastUpdate.status||DbUpdateStatuses.Unknown):DbUpdateStatuses.Unknown,
					updated = "";
				container.find(".slatInfo").show();
				if( updateStatus != DbUpdateStatuses.Ok ){
					container.addClass("slatObsoleted");
					statusText.addClass("colorObsoleted")
						.html(localization.getLocaleString("LabelDashboardLastUpdate"+DbUpdateStatuses.getKeyByValue(updateStatus)));
					infoVal.addClass("colorObsoleted");
				}
				if(!!data.lastUpdate) {
					infoVal.hide();
					if (DateHelper.isServerTimeSet() && updateStatus != DbUpdateStatuses.Unknown) {
						updated = DateHelper.dateDiffToServer(DateHelper.dateFromUTC(data.lastUpdate.time), DateHelper.DiffApproximations.Minutes, " ");
						updated = updated ? localization.getLocaleString("LabelDashboardUpdatedAgoPrefix") +updated + localization.getLocaleString("LabelDashboardUpdatedAgo") : localization.getLocaleString("LabelDashboardUpdatedNow");
						infoVal.show().html(updated);
					} else {
						KL.Utils.Log.write(this + ".applyUpdateStatus: " + KL.Utils.JSON.encode(data));
						window.setTimeout(KL.Utils.Delegate.create(this, this.applyUpdateStatus, e, data), 1000);
					}
				}
				if( updateStatus == DbUpdateStatuses.Ok )
					infoVal.addClass("colorOk");
			}
		},
		applyLdapStats: function (e, data) {
			var elt = this.getElt();
			if (elt && data) {
				var scriptType = KL.LMS.Enums.ScriptTypes.getKeyByValue(data.integrationType);
				elt.find(".slatLdap").removeClass("loading");
				var text = KL.Utils.Localization.getInstance().getLocaleString("LabelDashboardServiceType" + scriptType);
				if(data.integrationType == KL.LMS.Enums.ScriptTypes.None){
					elt.find(".slatLdap").removeClass("slatWarn slatUnknown").addClass("slatDisabled").find(".serviceType").hide();
					elt.find(".slatLdap .cnnStatus").html(text);
				}else{
					elt.find(".slatLdap .serviceType").show().find(".infoVal").html(text);
					window.setTimeout( KL.Utils.Delegate.create(this, this._triggerEvt, "onldapinfoloaded"), 5000 );
				}
			}
		},
		applyLdapStatsError: function(){
		},
		setLdapConnected: function () {
			var elt = this.getElt();
			if (elt)
				elt.find(".slatLdap").removeClass("slatWarn loading slatDisabled slatUnknown").find(".cnnStatus").html(KL.Utils.Localization.getInstance().getLocaleString("LabelDashboardLdapConnected"));
		},
		setLdapDisconnected: function () {
			var elt = this.getElt();
			if (elt)
				elt.find(".slatLdap").removeClass("loading slatUnknown").addClass("slatWarn").find(".cnnStatus").html(KL.Utils.Localization.getInstance().getLocaleString("LabelDashboardLdapDisconnected"));
			window.setTimeout( KL.Utils.Delegate.create(this, this._triggerEvt, "onldapinforeload"), 5000 );
		},
		applyBackupStats: function (e, data) {
			var elt = this.getElt();
			if (elt && data) {
				var container = elt.find(".slatStorage").removeClass("loading").show();
				var realPerc = 100 * data.usedSpaceInByte / data.capacity;
				var percent = Math.round(100 * realPerc )/100;
				var sizeVal = KL.LMS.Helpers.CommonHelper.localSizeObj(data.usedSpaceInByte, false, true);
				var statusClass = this.stateClasses[Math.floor(realPerc / 10)];
				elt.find(".slatStorageErr").hide();
				
				$(this.stateClasses).each(function (indx, item) { container.removeClass(item); });
				container.addClass(statusClass);
				container.find(".vaultFillBar").css({ "width": (realPerc < 1 ? 1 : (realPerc > 99.99 ? 100 : realPerc)) + "%" });
				container.find(".slatStatus .infoVal").text(data.messagesCount);
				container.find(".usedSpace .infoVal").empty().append(
					KL.Utils.Localization.getInstance().getLocaleStringObj(
						"LabelDashboardBackupUsedSpaceValue" + sizeVal.type,
						data.usedSpaceInByte > 0 && realPerc < 1 ? "<1" : percent,
						sizeVal.value
					)
				);
				this.bindDiskUsage(data);
			}
		},
		applyBackupStatsError: function (evt, err) {
			var elt = this.getElt();
			if (elt && err) {
				elt.find(".slatDiskUsage,.slatStorage").hide();
				elt.find(".slatStorageErr").show().find( ".slatInfo" ).html( KL.Utils.Exception.getExceptionText(err.id) );
			}
		},
		
		bindDiskUsage: function (data) {
			var elt = this.getElt();
			if (elt && data) {
				var spaceLeft = data.availableDiskUsage;
				var realPerc = 100 *(1- (spaceLeft / data.capacityDiskUsage));
				var statusClass = this.stateClasses[(data.capacity*1.30)<spaceLeft?0:9];
				var container = elt.find(".slatDiskUsage").show().removeClass("loading storageEmpty storageHalf storageWarn storageFull").addClass(statusClass);
				elt.find(".slatStorageErr").hide();
				container.find(".vaultFillBar").css({ "width": (realPerc < 1 ? 1 : (realPerc > 99.99 ? 100 : realPerc)) + "%" });
				container.find(".leftSpace .infoVal").empty().append(KL.LMS.Helpers.CommonHelper.localSizeObj(Math.abs(spaceLeft)));
			}
		},
		_bindChart: function (data, parent) {
			
		}
	};
	KL.LMS.registerClass("Dashboard", Dashboard);
	Dashboard.extend( KL.Web.Controls.Control );
})()
;
(function () {
	var LicensesEditForm = function (id, setting) {
		LicensesEditForm._super.call( this, id, setting );
	};
	LicensesEditForm.prototype = {
		_page: null,
		_licenseContainer: null,
		_licenseTemplate: "",
		_licenseInfo: null,
		onInitInteraction: function () {
			var elt = this.getElt();
			if (elt){
				elt.find(".btnCancel").click(KL.Utils.Delegate.create(this, this._closeDialog));
				this._listContainer = elt.find(".licenseInfo").parent();
				if (this._listContainer)
					this._initList();
				this._showLoading();
			}
		},
		_showLoading: function () {
			var elt = this.getElt();
			if (elt) {
				this._listContainer.hide();
				elt.find(".loader").show();
			}
		},
		_hideLoading: function () {
			var elt = this.getElt();
			if (elt) {
				this._listContainer.show();
				elt.find(".loader").hide();
			}
		},
		setValuePartial: function (val) {},
		onBeforeDataBind: function (data) {
			if (!data || !data.items)
				return false;
			while (data.items.length < 2)
				data.items.push({
					"ItemStatus": "itemInactive",
					"IsActiveKey": data.items.length == 0
				});
			this._hideLoading();
		},
		applyError: function(evt, data){
			KL.Utils.Log.write( this + "["+this.id+"].applyError(): Error accured.." );
			this._hideLoading();
			if( data.id != KL.Utils.Exception.ExceptionTypes.LicenseNoKeyInstalled )
				this.showError(data.id, data.message);
		},
		applyEmptyLicenseInfo: function (e, data) {
			KL.Utils.Log.write( this + "["+this.id+"].applyEmptyLicenseInfo(): Error accured. Showing blank data." );
			this.applyValue(e, {items:[]}, true);
			this.applyError(e, data);
		},
		applyLicenseInfo: function (e, data) {
			if (data) {
				this._page.getApplication().getContext().setLicenseData(data);
				KL.Utils.Log.write( this + "["+this.id+"].applyLicenseInfo(): License data loaded." );
				this._licenseInfo = data;
				$(this).trigger("onlicenseloaded");
			}
		},
		itemDataBind: function (data, indx) {
			if (data) {
				var isNotSet = (typeof (data.licenseSerial) == "undefined");
				var LicenseKeyTypes = KL.LMS.Enums.LicenseKeyTypes;
				var FunctionalityLevel = KL.LMS.Enums.FunctionalityLevel;
				var LicenseInvalidReasons = KL.LMS.Enums.LicenseInvalidReasons;
				var DateHelper = KL.Utils.DateHelper;
				var localization = KL.Utils.Localization.getInstance();
				var serverTime = DateHelper.getServerTime() || new Date();
				var activationDate = isNotSet? "": (data.keyInstallationDate ? new Date(data.keyInstallationDate.year, data.keyInstallationDate.month-1, data.keyInstallationDate.day, 0, 0, 0, 0) : serverTime);
				var expirationDate = isNotSet? "": (data.keyExpirationDate ? new Date(data.keyExpirationDate.year, data.keyExpirationDate.month-1, data.keyExpirationDate.day, 23, 59, 59, 999) : serverTime);
				var funcLvlText = isNotSet? "": "LabelLicenseFeatureLvl" + KL.LMS.Enums.FunctionalityLevel.getKeyByValue( data.functionalityLevel );
				var isCurrent = (!isNotSet && this._licenseInfo && data.licenseSerial == this._licenseInfo.activeLicenseSerial);
				var isError = !isNotSet && data.invalidReason != LicenseInvalidReasons.Valid;
				var statusText = isNotSet? "": ( isError ? "LabelLicenseDetailsStatusError" : (isCurrent ? "LabelLicenseDetailsStatusUsing" : "LabelLicenseDetailsStatusReserved"));
				if (isError)
					statusText += (LicenseInvalidReasons.getKeyByValue(data.invalidReason) || LicenseInvalidReasons.getKeyByValue(LicenseInvalidReasons.Unknown));
				data["IsActiveKey"] = data["IsActiveKey"] || isCurrent;
				data["SerialNum"] = isNotSet ? "&nbsp;" : data.licenseSerial;
				data["StatusClass"] = isNotSet ? "statusIdle" : (isError ? "statusErr" : (isCurrent ? "statusOk" : "statusIdle"));
				data["StatusText"] = isNotSet? "&nbsp;": localization.getLocaleString(statusText);
				data["TypeText"] = isNotSet? "&nbsp;": localization.getLocaleString(funcLvlText);
				data["UnitsCount"] = isNotSet? "&nbsp;": data.licenseCount;
				data["ActivationDate"] = isNotSet? "&nbsp;": DateHelper.getLocaleDate(this.id, activationDate.getTime()/1000, "ResShortDateFormat");
				data["ExpirationDate"] = isNotSet ? "&nbsp;" : DateHelper.getLocaleDate(this.id, expirationDate.getTime() / 1000, "ResShortDateFormat");
				var daysDiff = 0;
				if( !isNotSet && data.invalidReason != LicenseInvalidReasons.Expired ){
					var initDate = serverTime;
					if (indx==1) initDate= activationDate;
					
					var dateDiff = DateHelper.dateDiffNum( expirationDate,initDate );
					daysDiff = dateDiff.years*365 + dateDiff.days;
				}
				data["DaysLeft"] = isNotSet? "&nbsp;": localization.makeLocaleStringNumObj(this.id, "LabelLicenseDetailsExpInDays", daysDiff);
			}
		},
		dataBound: function (strOut) {
			if (this._listContainer) {
				KL.Utils.Log.write( this + "["+this.id+"].dataBound(): Data ha been applied." );
				KL.Utils.DateHelper.applyLocaleDates(this.id, this._listContainer);
				KL.Utils.Localization.getInstance().applyStingObjs(this.id, this._listContainer);
			}
		},
		itemDataBound: function (row, itemData) {
			row.hover(
				function () { $(this).addClass("licenseDetailsOver"); },
				function () { $(this).removeClass("licenseDetailsOver"); }
			);
			row.find(".itemDelBtn").click(KL.Utils.Delegate.create(this, this._confirmDeleteLicense, itemData));
			row.find("input[name=fileContent]").change(KL.Utils.Delegate.create(this, this._triggerUpload, itemData, row));
		},
		keyChangeComplete: function () {
			window.setTimeout( KL.Utils.Delegate.create(this, function(){$(this).trigger("onkeychanged" );}), 100 );
		},
		_triggerUpload: function (itemData, row) {
			this.hideError();
			
			row.find("input[name=data]").val(KL.Utils.JSON.encode({ "reserveKey": !itemData.IsActiveKey }));
			$(this).trigger("onkeyupload", [row.find("form")]);
			this._showLoading();
		},
		_licenseToDelete: "",
		getDeletingLicense: function () {
			KL.Utils.Log.write( this + "["+this.id+"].getDeletingLicense(): Deleting "+(this._licenseToDelete?"reserved":"main")+" license." );
			return { "data": KL.Utils.JSON.encode({ "reserveKey": this._licenseToDelete }) };
		},
		_confirmDeleteLicense: function(itemData, evt){
			if (evt) {
				evt.preventDefault();
				evt.stopPropagation();
			}
			var res = this._page.getApplication().openConfirm("LabelDialogConnfirmLicenseDelete", "LabelDialogTitleConnfirmLicenseDelete", {"ok": "BtnYes", "cancel": "BtnNo"}, 300);
			$(res).bind("onok", KL.Utils.Delegate.create(this, this._deleteLicense, itemData));
		},
		_deleteLicense: function (itemData) {
			
			this.hideError();
			if (itemData && itemData.licenseSerial) {
				this._licenseToDelete = !itemData.IsActiveKey;
				KL.Utils.Log.write( this + "["+this.id+"]._deleteLicense(): Starting deleting "+(this._licenseToDelete?"reserved":"main")+" license." );
				this._showLoading();
				$(this).trigger("onlicensedelete");
			}
		},
		_closeDialog: function () {
			this._page.closeDialog();
		}
	};
	KL.LMS.registerClass("LicensesEditForm", LicensesEditForm);
	LicensesEditForm.extend(KL.Web.Controls.ListViewControl);
})()
;
(function () {
	function updateTime(){
		var elt = this.getElt();
		if (elt && this._page){
			var ctx = this._page.getApplication().getContext(),
				serverTime = ctx.getServerTime(),
				localization = KL.Utils.Localization.getInstance(),
				serverTimeObj = ctx.getData( KL.Web.Context.DataTypes.ServerTime ),
				dateObj = KL.Utils.DateHelper.createDate(serverTime.getTime()/1000);
			if( serverTimeObj&&serverTimeObj.tz ){
				dateObj.setTimezoneName( serverTimeObj.tz.tzAbbr );
				dateObj.setTimezoneOffset( serverTimeObj.tz.tzOffset );
			}
			elt.html(localization._getLocalFormatDateStr(dateObj, "ResFullDateTimeFormat"));
		}else{
			if (this._timer!==null)
				window.clearInterval(this._timer);
			this._timer = null;
		}
	}
	var ServerTimeLabel = function (id, setting) {
		ServerTimeLabel._super.call( this, id, setting );
	};
	ServerTimeLabel.prototype = {
		_timer: null,
		
		applyText: function (evt, txt) {
			if (this._timer!==null)
				window.clearInterval(this._timer);
			
			this._timer = window.setInterval(KL.Utils.Delegate.create(this,updateTime),1000);
		},
		onDestroy: function(){
			if (this._timer!==null)
				window.clearInterval(this._timer);
		}
	};
	KL.LMS.registerClass("ServerTimeLabel", ServerTimeLabel);
	ServerTimeLabel.extend(KL.Web.Controls.Label);
})()
;
(function () {
	var ServerNameLabel = function (id, setting) {
		ServerNameLabel._super.call(this, id, setting);
	};
	ServerNameLabel.prototype = {
		applyText: function(evt,txt){
			var elt = this.getElt();
			if (elt) {
				var serverName = txt.serverName;//this._page.getApplication().getContext().getServerName();
				elt.html(KL.LMS.Helpers.CommonHelper.getServerNameText(serverName));
				if (serverName.length>20) elt.attr("title",serverName)
			}
		}
	};
	KL.LMS.registerClass("ServerNameLabel", ServerNameLabel);
	ServerNameLabel.extend(KL.Web.Controls.Label);
})()
;
(function () {
	var statusStrs = {
		"NotInstalled": "LabelHeaderNoLicenseInstalled",
		"Active": "LabelHeaderLicenseInfoInvalidActive",
		"ExpiresSoon": "LabelHeaderLicenseInfoInvalidExpiresSoon",
		"Expired": "LabelHeaderLicenseInfoInvalidExpired",
		"TrialPeriodIsOver": "LabelHeaderLicenseInfoInvalidTrialPeriodIsOver",
		"BlackListed": "LabelHeaderLicenseInfoInvalidBlackListed",
		"Invalid": "LabelHeaderLicenseInfoInvalidInvalid"
	};
	function setLicenseText(elt,data){
		var daysLeft = data.expirationDays;
		elt.empty().append(KL.Utils.Localization.getInstance().getLocaleStringNumObj("LabelHeaderLicenseInfoDays", daysLeft));
	}
	function setLicenseError(elt,data){
		var LicenseDashboardStatus = KL.LMS.Enums.LicenseDashboardStatus,
			licenseStr = statusStrs[LicenseDashboardStatus.getKeyByValue(data.status)];
		elt.empty().addClass("licenseError").html(KL.Utils.Localization.getInstance().getLocaleString(licenseStr));
	}
	var LicenseLabel = function (id, setting) {
		LicenseLabel._super.call(this, id, setting);
	};
	LicenseLabel.prototype = {
		_time: null,
		serverTime: null,
		gmtStr: " GMT ",
		applyError: function(evt, data){
			var elt = this.getElt();
			if (elt && data && data.id ){
				var ExceptionTypes = KL.Utils.Exception.ExceptionTypes;
				var licenseStr = "LabelHeaderUnknownLicenseError";
				switch(data.id){
					case ExceptionTypes.LicenseNoKeyInstalled:
						this._page.getApplication().getContext().setLicenseData(null);
						licenseStr = "LabelHeaderNoLicenseInstalled";
						break;
				}
				elt.empty().addClass("licenseError").append(KL.Utils.Localization.getInstance().getLocaleString(licenseStr));
				this._setLinkClick();
			}else
				this.hide();
		},
		applyText: function (evt, data) {
			var elt = this.getElt(),
				LicenseDashboardStatus = KL.LMS.Enums.LicenseDashboardStatus;
			if (elt && data) {
				this._page.getApplication().getContext().setLicenseData(data);
				elt.empty().removeClass("licenseError licenseWarn");
				switch( data.status ){
					case LicenseDashboardStatus.ExpiresSoon:
						elt.addClass("licenseWarn");
					case LicenseDashboardStatus.Active:
						setLicenseText.call(this,elt,data);
						break;
					default:
						setLicenseError.call(this,elt,data);
				}
				this._setLinkClick();
			}
		},
		_setLinkClick: function(){
			var elt = this.getElt();
			if (elt)
				elt.off("click", "a").on("click", "a", KL.Utils.Delegate.create(this, this._triggerClick));
		},
		_triggerClick: function () {
			$(this).trigger("onlicenseopen");
			return false;
		}
	};
	KL.LMS.registerClass("LicenseLabel", LicenseLabel);
	LicenseLabel.extend(KL.Web.Controls.Label);
})()
;
(function(){
	function ThreatInfoPanel(id, setting){
		ThreatInfoPanel._super.call(this, id, setting);
	}
	ThreatInfoPanel.prototype = {
		_infoTpl: "",
		onBeforeShow: function(){
			var elt = this.getElt();
			if(elt){
				this._infoTpl = elt.html();
				elt.empty();
			}
		},
		applyInfo: function (e, extra, trigger, title, isRightAligned, dataObj){
			var elt = this.getElt();
			if(elt){
				elt.html(KL.Utils.StringHelper.formatTemplate( this._infoTpl, {
					"ThreatName": dataObj.name || "-",
					"Sender": dataObj.sender || "-",
					"Recipients": (dataObj.recipients instanceof Array?dataObj.recipients.join(", "): dataObj.recipients) || "-",
					"Subject": "-",
					"Date": KL.Utils.DateHelper.getLocaleDate(this.id, dataObj.time)
				}));
				window.setTimeout( KL.Utils.Delegate.create( KL.Utils.DateHelper, KL.Utils.DateHelper.applyLocaleDates, this.id, elt), 100);
			}
		}
	};
	KL.LMS.registerClass("ThreatInfoPanel", ThreatInfoPanel);
	ThreatInfoPanel.extend( KL.Web.Controls.Control );
})()
;
(function () {
	var appInfoAction, serverTimeAction, licenseInfoAction;
	function triggerLicenseChange(){
		$(this).trigger("onlicensechanged");
	}
	function _appSettingsLoadComplete( evt, data, a, b, c ){
		this._context.setAppSettings(data);
	}
	function _appSettingsLoadError(){
		var res = this.showMessage("LabelDialogTitlrAppInfoNotLoaded", "LabelDialogAppInfoNotLoadedText", "BtnClose", 300, KL.Web.MessageDialog.MessageType.Error);
		$(res).bind("onok", KL.Utils.Delegate.create(this, this.showLoginPage));
	}
	function _serverTimeActionComplete(evt, data){
		var ctx = this.getContext();
		var serverTime = data;
					
		ctx.setServerTime( data );
		
		if(!this._isServerTimeLoad){
			this._isServerTimeLoad = true;
			return true;
		}
		return false;
	}
	function _serverTimeLoadErr(e, error){
		if(error.id != KL.Utils.Exception.ExceptionTypes.SessionIdNotFound){
			var res = this.showMessage("ErrorLicenseUnexpectedErr", "ErrorServerTimeNotRecieved", "BtnClose", 300, KL.Web.MessageDialog.MessageType.Error);
			$(res).bind("onok", KL.Utils.Delegate.create(this, this.showLoginPage));
		}
	}
	function _appVerLoadErr(){
		var res = this.showMessage("LabelDialogVersionFileNotLoadedText", "LabelDialogTitleVersionFileNotLoaded", "BtnClose", 300, KL.Web.MessageDialog.MessageType.Error);
		$(res).bind("onok", KL.Utils.Delegate.create(this, this.showLoginPage));
	}
	function _appVerLoadComplete( evt, data ){
		this.getContext().setData(KL.Web.Context.DataTypes.UiVersion, data);
	}
	function _licenseActionComplete( evt, data ){
		this.getContext().setLicenseData(data);
	}
	function _licenseInfoLoadErr( evt, data ){
		KL.Data.Queries.QueryCreator.loadNext(evt);
	}
	function _infoActionComplete(evt, data){
		var ctx = this.getContext();
		var appVer = ctx.getData(KL.Web.Context.DataTypes.UiVersion);
		var prodVer = data;
		ctx.setData( KL.Web.Context.DataTypes.LoginEnabled, true );
		if( !KL.Utils.ObjectHelper.testVersions(appVer, prodVer ) ){
			ctx.setData( KL.Web.Context.DataTypes.LoginEnabled, false );
			var str = KL.Utils.Localization.getInstance().makeLocaleStringObj( this._msgBox.id, "LabelDialogVersionMismatchText", appVer, prodVer );
			var res = this.showMessage(str, "LabelDialogTitleVersionMismatch", "BtnClose", 300, KL.Web.MessageDialog.MessageType.Error);
			$(res).bind("onok", KL.Utils.Delegate.create(this, this.showLoginPage));
			return false;
		}
	}
	function _appInfoLoadErr(){
	}
	function Application( initData, settingsData, dependenciesData, queriesData ){
		Application._super.call(this, initData, settingsData, dependenciesData, queriesData);
	}
	Application.prototype = {
		_serverTimeQueryId: "appServerTimeQuery",
		_isServerTimeLoad : false,
		_appversionUrl: "webui_version.txt?cb={0}",
		makeAppQueries: function(QueryCreator){
			var Delegate = KL.Utils.Delegate;
			if( this._appversionUrl ){
				var getUiVersionAction = "getUiVersion";
				KL.HTTP.DataProvider._urls = KL.HTTP.DataProvider._urls || {};
				KL.HTTP.DataProvider._urls[getUiVersionAction] = this._appversionUrl;
				QueryCreator.makeAppQuery(
					{"id": "appUiVersionQuery", "action": getUiVersionAction, "type": "text" }, this, this._dataProvider,
					Delegate.create( this,_appVerLoadComplete),
					Delegate.create( this,_appVerLoadErr)
				);
			}
			Application._super.prototype.makeAppQueries.call(this, QueryCreator);
			QueryCreator.makeAppQuery(
				{"id": "appSettingsQuery", "action": "getAppSettings", "roleVisible": "admin,helpdesk"}, this, this._dataProvider,
				Delegate.create( this,_appSettingsLoadComplete),
				Delegate.create( this,_appSettingsLoadError)
			);
			if (serverTimeAction){
				QueryCreator.makeAppQuery( {"id": this._serverTimeQueryId, "action": serverTimeAction ,"timeout":60000*5 }, this, this._dataProvider, 
					Delegate.create( this,_serverTimeActionComplete),
					Delegate.create( this,_serverTimeLoadErr)
				);
			}
			if (appInfoAction){
				QueryCreator.makeAppQuery(
					{"id": "appInfoQuery", "action": appInfoAction }, this, this._dataProvider,
					Delegate.create( this,_infoActionComplete),
					Delegate.create( this,_appInfoLoadErr) 
				);
			}
			if (licenseInfoAction){
				QueryCreator.makeAppQuery(
					{"id": "appLicenseInfoQuery", "action": licenseInfoAction, "roleVisible": "admin" }, this, this._dataProvider, 
					Delegate.create( this,_licenseActionComplete),
					Delegate.create( this,_licenseInfoLoadErr) 
				);
			}
			
		},
		userLogout: function(){
			var stQuery = KL.Data.Queries.DataQuery.getInstance(this._serverTimeQueryId);
			if(stQuery)
				stQuery.stopTimeout();
			Application._super.prototype.userLogout.call(this);
			this._isServerTimeLoad = false;
		},
		showLoginPage: function(){
			var stQuery = KL.Data.Queries.DataQuery.getInstance(this._serverTimeQueryId);
			if(stQuery)
				stQuery.stopTimeout();
			this._isServerTimeLoad = false;
			Application._super.prototype.showLoginPage.call(this);			
		}
	};
	Application.create = function(appData){
		appInfoAction = appData.appInfoAction || appData.appinfoaction;
		serverTimeAction = appData.serverTimeAction || appData.servertimeaction;
		licenseInfoAction = appData.licenseInfoAction || appData.licenseinfoaction;
		
		return KL.Web.Application.create.call(this, appData);
	}
	KL.LMS.registerClass("Application", Application);
	Application.extend(KL.Web.Application);
})();
;
;
CreateApp({
	"initialAction": "checkSession",
	"appInfoAction": "appInfo",
	"serverTimeAction": "serverTime",
	"licenseInfoAction": "getLicenseStatus",
	
	"root": "pageWrap",
	"loader": "appLoader",
	"pages": [
		
		{"id": "addressesEditDialog", "isdialog": true, "width": 750, "elements": [
				{ "id": "addressEditForm", "type": "KL.LMS.Groups.AddressesEditor" }
		]
		},
		{"id": "addressesImportEditDialog", "title": "LabelTitlePasteAddressesDialog", "isdialog": true, "width": 500, "elements": [
				{ "id": "addressImportEditForm", "type": "KL.LMS.Groups.AddressesImportEditor" }
		]
		},
		{"id": "addressesPersonalImportEditDialog", "title": "LabelTitlePasteAddressesDialog", "isdialog": true, "width": 500, "elements": [
				{ "id": "addressPersonalImportEditForm", "type": "KL.LMS.Groups.AddressesImportEditor" }
		]
		},
		{"id": "addressesAdminImportEditDialog", "title": "LabelTitlePasteAddressesDialog", "isdialog": true, "width": 500, "elements": [
				{ "id": "addressAdminImportEditForm", "type": "KL.LMS.Groups.AddressesImportEditor" }
		]
		},
		{"id": "aboutDialogView", "isdialog": true, "width": 500, "title":"Kaspersky Linux Mail Security", "elements": [
				{ "id": "aboutDialogForm", "type": "KL.Web.Controls.AboutForm" }
		]
		},
		{ "id": "sorageFilterDialog", "title": "LabelDialogTitleBackupFilter", "isdialog": true, "width": 550, "elements": [
				{ "id": "storagFilterForm", "type": "KL.LMS.Backup.FilterDialog" }
		]
		},
		{ "id": "filesTypesDialog", "title": "LabelDialogFilesTypesExceptions", "isdialog": true, "width": 700, "elements": [
				{ "id": "filesTypesDialogForm", "type": "KL.LMS.Groups.FilesTypesSelectForm" }
		]
		},
		{ "id": "priorityEditorDialog", "title": "LabelDialogPiorityEditor", "isdialog": true, "width": 385, "elements": [
				{ "id": "priorityEditorForm", "type": "KL.LMS.Groups.PriorityEditor" }
		]
		},
		{ "id": "changePasswdDialog", "title": "TitleChangePasswd", "isdialog": true, "width": 500, "elements": [
				{ "id": "chPasswdForm", "type": "KL.Web.Controls.ChangePasswdForm" }
		]
		},
	
		{"id": "ProxySettingsDialog", "title": "LabelSettingsDialogUpdate_NetworkConnection", "isdialog": true, "width": 500, "elements": [
				{ "id": "ProxySettingsForm", "type": "KL.LMS.Settings.CnnSettingsForm" },
				{ "id": "ProxySettingsForm1", "type": "KL.LMS.Settings.CnnSettingsForm" }
			]
		},
		{"id": "baseUpdateSourceSettingsDialog", "title": "LabelSettingsDialogUpdate_Bases", "isdialog": true, "width": 560, "elements": [
				{ "id": "baseUpdateSourceSettingsForm", "type": "KL.LMS.Settings.UpdateSettingsSourceForm","datafield":"updaterSettings"}
		]
		},
		{"id": "baseUpdateScheduleSettingsDialog", "title": "LabelSettingsDialogUpdate_Bases", "isdialog": true, "width": 560, "elements": [
				{ "id": "baseUpdateScheduleSettingsForm", "type": "KL.LMS.Settings.UpdateSettingsForm","datafield":"updaterSettings"}
		]
		},
		{ "id": "ldapTypeSettingsDialog", "title": "LabelSettingsDialogTitle_LdapServiceType", "isdialog": true, "width": 380, "elements": [
				{ "id": "ldapTypeSettingsForm", "type": "KL.LMS.Settings.LdapTypeSettingsForm" }
		]
		},
		{ "id": "ldapCnnSettingsDialog", "title": "LabelSettingsDialogTitle_LdapConnection", "isdialog": true, "width": 450, "elements": [
				{ "id": "ldapCnnSettingsForm", "type": "KL.LMS.Settings.LdapCnnSettingsForm" }
		]
		},
		{ "id": "ldapAccessSettingsDialog", "title": "LabelSettingsDialogTitle_LdapAccess", "isdialog": true, "width": 600, "elements": [
				{ "id": "ldapAccessSettingsForm", "type": "KL.LMS.Settings.LdapAccessSettingsForm" }
		]
		},
		{ "id": "deliverMailDialog", "title": "LabelDialogTitleDeliverMessage", "isdialog": true, "width": 530, "elements": [
				{ "id": "deliverDialogForm", "type": "KL.LMS.Backup.DeliverDialogForm" }
		]
		},
		{ "id": "usersBWListsEditDialog", "title": "LabelDialogTitleEditBWLists", "isdialog": true, "width": 750, "elements": [
				{ "id": "usersBWListsEditForm", "type": "KL.LMS.Settings.BWListsForm", "mode": "dialog" }
		]
		},
		{ "id": "notificationEditDialog", "title": "LabelDialogTitleEditNotification", "isdialog": true, "width": 750, "elements": [
				{ "id": "notificationEditForm", "type": "KL.LMS.Settings.NotificationEditForm" }
		]
		},
		{ "id": "notificationEmailEditDialog", "title": "LabelDialogTitleEditNotificationEmail", "isdialog": true, "width": 380, "elements": [
				{ "id": "notificationEmailEditForm", "type": "KL.LMS.Settings.NotificationEmailEditForm" }
		]
		},
		{"id": "reportParamsDialog", "title": "ReportForm", "isdialog": true, "width": 500, "elements": [
				{ "id": "reportParamsForm", "type": "KL.LMS.Reports.ReportParamsForm" }
		]
		},
		{ "id": "avProtectionEditDialog", "title": "LabelDialogTitleAvProtectionSettings", "isdialog": true, "width": 460, "elements": [
				{ "id": "avProtectionEditForm", "type": "KL.LMS.Settings.AvProtectionEditForm" }
		]
		},
		{ "id": "asProtectionEditDialog", "title": "LabelDialogTitleAsProtectionSettings", "isdialog": true, "width": 510, "elements": [
				{ "id": "asProtectionEditForm", "type": "KL.LMS.Settings.AsProtectionEditForm" }
		]
		},
		{ "id": "afProtectionEditDialog", "title": "LabelDialogTitleApProtectionSettings", "isdialog": true, "width": 510, "elements": [
				{ "id": "afProtectionEditForm", "type": "KL.LMS.Settings.AfProtectionEditForm" }
		]
		},
		{ "id": "blProtectionEditDialog", "title": "LabelDialogTitleBlProtectionSettings", "isdialog": true, "width": 510, "elements": [
				{ "id": "blProtectionEditForm", "type": "KL.LMS.Settings.BlProtectionEditForm" }
			]
		},
		{ "id": "settingsDnsblEditDialog", "title": "LabelSettingsDialogProtection_CustomDNSBL", "isdialog": true, "width": 400, "elements": [
				{ "id": "settingsDnsblEditForm", "type": "KL.LMS.Settings.BlackListEditForm" }
		]
		},
		{ "id": "settingsSurblEditDialog", "title": "LabelSettingsDialogProtection_CustomSURBL", "isdialog": true, "width": 400, "elements": [
				{ "id": "settingsSurblEditForm", "type": "KL.LMS.Settings.BlackListEditForm" }
		]
		},
		{ "id": "ksnLicenseDialog", "title": "LabelTitleSettingsKsnLicenseDialog", "isdialog": true, "width": 700, "elements": [
				{ "id": "ksnLicenseAcceptForm", "type": "KL.LMS.Settings.KsnLicenseAcceptForm" }
			]
		},
		{ "id": "ksnSettingsDialog", "title": "LabelTitleSettingsKsnSettingsDialog", "isdialog": true, "width": 500, "elements": [
				{ "id": "ksnSettingsEditForm", "type": "KL.LMS.Settings.KSNSettingsEditForm" }
			]
		},
		{ "id": "backupSettingsDialog", "title": "LabelTitleSettingsPanelBackup", "isdialog": true, "width": 420, "elements": [
				{ "id": "backupSettingsForm", "type": "KL.LMS.Settings.BackupSettingsForm" }
		]
		},
		{ "id": "snmpCnnSettingsDialog", "title": "LabelTitleSettingsSNMP_Connection", "isdialog": true, "width": 400, "elements": [
				{ "id": "snmpCnnSettingsForm", "type": "KL.LMS.Settings.SNMPCnnSettingsForm" }
		]
		},
		{ "id": "trapSuiteSNMPSettingsDialog", "title": "LabelTitleSettingsSNMP_Settings", "isdialog": true, "width": 520, "elements": [
				{ "id": "trapSuiteSNMPSettingsForm", "type": "KL.LMS.Settings.SNMPSettingsForm" }
		]
		},
		{ "id": "ProductMailSettingsDialog", "title": "LabelTitleSettingsMisc_EMails_Product", "isdialog": true, "width": 400, "elements": [
				{ "id": "ProductMailSettingsForm", "type": "KL.LMS.Settings.ProductMailSettingsForm" }
		]
		},
		{ "id": "AdminEMailSettingsDialog", "title": "LabelTitleSettingsMisc_EMails_Admins", "isdialog": true, "width": 450, "elements": [
				{ "id": "AdminEMailSettingsForm", "type": "KL.LMS.Settings.AdminEMailSettingsForm" }
			]
		},
		{ "id": "scClusterIdEditDialog", "title": "LabelTitleDialogSCIntegration", "isdialog": true, "width": 500, "elements": [
				{ "id": "scClusterIdEditForm", "type": "KL.LMS.Settings.ScClusterIdEditForm" }
			]
		},
		{ "id": "EventLoggerEditDialog", "title": "LabelTitleSettingsMisc_EventLogger", "isdialog": true, "width": 380, "elements": [
				{ "id": "eventLoggerEditForm", "type": "KL.LMS.Settings.EventLoggerEditForm" }
			]
		},
		{ "id": "PerformanceEditDialog", "title": "LabelTitleSettingsMisc_Performance", "isdialog": true, "width": 400, "elements": [
				{ "id": "PerformanceEditForm", "type": "KL.LMS.Settings.PerformanceEditForm" }
			]
		},
		{ "id": "HeaderMarksEditDialog", "title": "LabelTitleSettingsMisc_HeaderMarks", "isdialog": true, "width": 380, "elements": [
				{ "id": "HeaderMarksEditForm", "type": "KL.LMS.Settings.HeaderMarksEditForm" }
			]
		},
		
		{ "id": "PlaceholderEditDialog", "title": "LabelTitleSettingsMisc_Placeholder", "isdialog": true, "width": 750, "elements": [
				{ "id": "PlaceholderEditForm", "type": "KL.LMS.Settings.PlaceholderEditForm" }
			]
		},
		{ "id": "LicensesDialog", "title": "LabelTitleLicensesDialog", "isdialog": true, "width": 900, "elements": [
				{ "id": "licensesEditForm", "type": "KL.LMS.LicensesEditForm", "setting": "LicensesInfoSetting" }
			]
		},
		{ "id": "importSettingsDialog", "title": "LabelTitleImportSettingsDialog", "isdialog": true, "width": 600, "elements": [
				{ "id": "importSettingsForm", "type": "KL.LMS.Settings.ImportSettingsForm" }
			]
		},
		{ "id": "exportSettingsDialog", "title": "LabelTitleExportSettingsDialog", "isdialog": true, "width": 500, "elements": [
				{ "id": "exportSettingsForm", "type": "KL.LMS.Settings.ExportSettingsForm" }
			]
		},
		{ "id": "helpdeskSettingsDialog", "title": "LabelTitleHelpdeskSettingsDialog", "isdialog": true, "width": 500, "elements": [
				{ "id": "helpdeskSettingsForm", "type": "KL.LMS.Settings.HelpdeskSettingsForm" }
			]
		},
		{ "id": "restartProductConfirmDialog", "title": "LabelTitleRestartConfirmDialog", "isdialog": true, "width": 380, "elements": [
				{ "type": "KL.Web.Controls.Panel", "cssclass": "dialogContent", "elements": [
					{"id": "lblRestartConfirmDlgWarn", "type": "KL.Web.Controls.Label", "text": "LabelRestartConfirmDialogText" },
					{"id": "lblRestartConfirmDlgDone", "type": "KL.Web.Controls.Label", "text": "LabelRestartConfirmDialogStartedText" }
				] },
				{ "type": "KL.Web.Controls.Panel", "cssclass": "btnsBar", "elements": [
					{ "id": "btnRestartProduct", "type": "KL.Web.Controls.Button", "text": "BtnYes" },
					{ "id": "btnCancelRestartDlg", "type": "KL.Web.Controls.Button", "text": "BtnNo", "cssclass": "defaultBtn" },
					{ "id": "btnCloseRestartDlg", "type": "KL.Web.Controls.Button", "text": "BtnClose", "cssclass": "defaultBtn" }
				] }
			]
		},
		{"id": "signupPage", "islogin": true, "elements": [
				{ "id": "headerWrap", "type": "KL.Web.Controls.Panel", "elements": [
						{ "id": "signupHeaderInfo", "cssclass": "mainHeaderInfo", "type": "KL.Web.Controls.Panel", "elements": [
								{ "id": "signupLangSelector", "type": "KL.Web.Controls.LangSelect" }
							]
						}
					]
				},
				{ "id": "signupPageContent", "type": "KL.Web.Controls.SignupPagePanel", "elements": [
						{ "id": "loginForm", "type": "KL.LMS.SignupForm" }
					]
				}
			]
		},
		{"id": "mainPage", "ismain": true, "elements": [
				{ "id": "contextChangeAdapter", "type": "KL.LMS.ContextChangeAdapter" },
				{ "id": "mainPageHeader", "type": "KL.Web.Controls.PageHeader", "elements": [
						{ "id": "panelHeaderInfo", "type": "KL.Web.Controls.Panel", "cssclass": "mainHeaderInfo", "elements": [
								{ "id": "mainHelpBtn", "type": "KL.Web.Controls.HelpBtn" },
								{ "id": "mainLangSelector", "type": "KL.Web.Controls.LangSelect" },
								{ "id": "infoLink", "type": "KL.Web.Controls.LinkButton", "text": "LabelHeaderInfo" },
								{ "id": "mainLicenseLink", "type": "KL.LMS.LicenseLabel", "role_visible": "admin" },
								{ "id": "serverNameLabel", "type": "KL.LMS.ServerNameLabel", "text": "", "cssclass": "serverName" },
								{ "id": "serverTimeLabel", "type": "KL.LMS.ServerTimeLabel", "text": "", "cssclass": "serverTime" }
							]
						},
						{ "id": "panelHeaderContent", "type": "KL.Web.Controls.Panel", "cssclass": "mainHeaderContent", "elements": [
								{ "id": "headerLogo", "type": "KL.Web.Controls.ProductLogo" },
								{ "id": "userPanel", "type": "KL.Web.Controls.Panel", "elements": [
										{ "id": "userWelcome", "type": "KL.Web.Controls.Panel", "elements": [
												{ "id": "userWelcomeLabel", "type": "KL.Web.Controls.Label", "text": "LabelUserWelcome", "helper": "KL.Utils.UserHelper", "helpermethod": "getUserGreeting", "cssclass": "userGreeting" },
												{ "id": "changePasswdLinkBtn", "type": "KL.Web.Controls.LinkButton", "cssclass": "changePasswdBtn", "text": "LabelHeaderChangePasswd", "role_visible": "admin" }
											]
										},
										{ "id": "signoutLink", "type": "KL.Web.Controls.Button", "text": "BtnSignOut", "cssclass": "signOutBtn" }
									]
								},
								{ "type": "KL.Web.Controls.MainNav", "id": "topNav", "param": "mainnav", "items": [
										{ "text": "LabelNavTitleDashboard", "panel": "DashboardPagePanel", "role_visible": "admin" },
										{ "text": "LabelNavTitleGroups", "panel": "GroupsPagePanel" ,"role_visible":"admin"},
										{ "text": "LabelNavTitleBackup", "panel": "BackupPagePanel" ,"role_visible":"always"},
										{ "text": "LabelNavTitleBWLists", "panel": "bwListsPagePanel" ,"role_visible":"user,bwlistviewer"},
										{ "text": "LabelNavTitleReports", "panel": "ReportsPagePanel","role_visible":"admin" },
										{ "text": "LabelNavTitleSettings", "panel": "SettingsPagePanel", "role_visible": "admin" }
									]
								}
							]
						}
					]
				},
				{ "type": "KL.Web.Controls.PageContent", "id": "pageContentWrap", "elements": [
						{ "type": "KL.Web.Controls.MainNavTabPanel", "id": "DashboardPagePanel", "elements": [
								{ "type": "KL.Web.Controls.TooltipForm", "id": "threatInfoTooltipForm", "cssclass": "threatInfoTooltip", "elements": [
										{ "type": "KL.LMS.ThreatInfoPanel", "id": "threatInfoPanel" }
									]
								},
								{ "type": "KL.LMS.Dashboard", "id": "dashboard" }
							]
						},
						{ "type": "KL.Web.Controls.MainNavTabPanel", "id": "GroupsPagePanel", "elements": [
								{ "type": "KL.Web.Controls.Panel", "id": "GroupsSearchPage", "elements": [
										{ "id": "GroupsGridWrap", "type": "KL.Web.Controls.Panel", "cssclass": "gridWrap", "elements": [
												{ "id": "GroupsListTopToolbar", "type": "KL.Web.Controls.Toolbar", "istall": true, "elements": [
														{ "type": "KL.Web.Controls.Button", "id": "btnUp_GroupsTop", "text": "<span class='btnIco upIco'>&nbsp;</span>", "width": 12,"left":477 },
														{ "type": "KL.Web.Controls.Button", "id": "btnDown_GroupsTop", "text": "<span class='btnIco downIco'>&nbsp;</span>", "width": 12,"left":512},
														{ "type": "KL.Web.Controls.Button", "id": "btnCreate_GroupsTop", "text": "BtnCreate", "cssclass": "btnAddIco leftBtn" },
														{ "type": "KL.Web.Controls.Button", "id": "btnCopy_GroupsTop", "text": "BtnCopy", "cssclass": "btnCopyIco"},
														{ "type": "KL.Web.Controls.Button", "id": "btnDelete_GroupsTop", "text": "BtnDelete", "cssclass": "btnDelIco"}
													]
												},
												{ "type": "KL.LMS.Groups.GroupsGrid", "id": "GroupsGridControl", "setting": "GroupsList", "idField": "groupId", "enterrowonclick": false, "rowsselectable": true }
											]
										},
										{ "type": "KL.Web.Controls.Toolbar", "id": "GroupsListBottomToolbar", "isbottom": true, "istall": true, "elements": [
												{ "type": "KL.Web.Controls.Button", "id": "btnUp_GroupsBottom", "text": "<span class='btnIco upIco'>&nbsp;</span>", "width": 12 ,"left":477},
												{ "type": "KL.Web.Controls.Button", "id": "btnDown_GroupsBottom", "text": "<span class='btnIco downIco'>&nbsp;</span>", "width": 12,"left":512 },
												{ "type": "KL.Web.Controls.PagingFBNL", "id": "GroupsGridBottomPager", "setting": "GroupsList" },
												{ "type": "KL.Web.Controls.Button", "id": "btnCreate_GroupsBottom", "text": "BtnCreate", "cssclass": "btnAddIco leftBtn" },
												{ "type": "KL.Web.Controls.Button", "id": "btnCopy_GroupsBottom", "text": "BtnCopy", "cssclass": "btnCopyIco"},
												{ "type": "KL.Web.Controls.Button", "id": "btnDelete_GroupsBottom", "text": "BtnDelete", "cssclass": "btnDelIco"}
											]
										}
									]
								},
								
								{ "type": "KL.Web.Controls.Panel", "id": "GroupViewEditPage", "elements": [
										{ "type": "KL.Web.Controls.TooltipForm", "id": "textTooltipForm", "elements": [
												{ "type": "KL.Web.Controls.TextBox", "id": "textTooltipFormField" },
												{ "type": "KL.Web.Controls.Label", "id": "lblTooltipFieldInfo", "text": "LabelTextTooltipSpamInfo" }
										]
										},
										{ "type": "KL.Web.Controls.TooltipForm", "id": "listViewToltip", "elements": [
												{ "type": "KL.LMS.Groups.BlackListView", "id": "userBListViewCtrl", "setting": "BlackListSetting" }
										]
										},
										{ "type": "KL.Web.Controls.TooltipForm", "id": "emailEditTooltipForm", "elements": [
												{ "type": "KL.LMS.Groups.ListEditor", "id": "emailListEditorCtrl" }
											]
										},
										{ "type": "KL.Web.Controls.TooltipForm", "id": "attachSourceEditTooltipForm", "elements": [
												{ "type": "KL.LMS.Groups.AttachSourceEditor", "id": "attachSourceEditForm" }
											]
										},
										{ "type": "KL.Web.Controls.Panel", "id": "editGroupsToolbar", "elements": [
												{ "type": "KL.Web.Controls.Button", "id": "btnBackToGroupList", "text": "btnBackToGroupList" },
												{ "type": "KL.Web.Controls.Label", "id": "lblGroupEditorTitle", "cssclass": "groupEditorTitle", "setting": "GroupSettings", "helper": "KL.LMS.Helpers.GroupsHelper", "helpermethod": "getGroupEditorTitle" }
										]
										},
										{ "type": "KL.LMS.Groups.GroupEditor", "id": "GroupSettingsEditor", "setting": "GroupSettings", "elements": [
												{ "type": "KL.Web.Controls.AccordionItem", "id": "GroupGeneralParamsSettingsItem1", "elements": [
														{ "type": "KL.Web.Controls.AccordionTab", "id": "GroupGeneralParamsSettingsTab", "text": "LabelGroupGeneralParamsSettings", "elements": [
																{ "type": "KL.Web.Controls.KeyValueListControl", "id": "groupGeneralParamsPreview", "setting": "GroupSettings", "allowhtml": false, "items": [
																		{ "title": "LabelLocalGroupEditorGroupName", "value": "name" ,"defaultValue":"LabelSettingNewGroupName"},
																		{ "title": "LabelLocalGroupEditorDescr", "value": "description" ,"defaultValue":"-"},
																		{ "title": "LabelLocalGroupEditorSenders", "value": "belongingCriteria.sender", "helper": "KL.LMS.Helpers.GroupsHelper", "helpermethod": "groupSendersToStr" },
																		{ "title": "LabelLocalGroupEditorReceivers", "value": "belongingCriteria.receiver", "helper": "KL.LMS.Helpers.GroupsHelper", "helpermethod": "groupReceiversToStr" }
																]
																}
														]
														},
														{ "type": "KL.Web.Controls.AccordionPanel", "id": "GroupGeneralParamsPanel", "elements": [
																{ "type": "KL.LMS.Groups.GroupGeneralSettingsForm", "setting": "GroupSettings", "id": "groupGeneralSettingsForm" }
														]
														}
												]
												},
												{ "type": "KL.Web.Controls.AccordionItem", "id": "antiSpamParamsSettingsItem", "elements": [
														{ "type": "KL.Web.Controls.AccordionTab", "id": "AntiSpamParamsSettingsTab", "text": "LabelAntiSpamParamsSettings", "elements": [
																{ "type": "KL.Web.Controls.KeyValueListControl", "id": "antiSpamParamsPreview", "setting": "GroupSettings", "datafield": "scanSettings.asScanSettings", "allowhtml": false, "items": [
																		{ "title": "LabelLocalGroupEditorCheckSpam", "value": "engineSettings.enableScan", "helper": "KL.LMS.Helpers.CommonHelper", "helpermethod": "getIsASEnabledColorTxtByBoolVal" },
																		{ "title": "LabelLocalGroupEditorSpamMessage", "value": "spamAction", "helper": "KL.LMS.Helpers.GroupsHelper", "helpermethod": "actionStr" },
																		{ "title": "LabelLocalGroupEditorUnreliableRecipient", "value": "blacklistedAction", "helper": "KL.LMS.Helpers.GroupsHelper", "helpermethod": "actionStr" },
																		{ "title": "LabelLocalGroupEditorSuspMessage", "value": "probableSpamAction", "helper": "KL.LMS.Helpers.GroupsHelper", "helpermethod": "actionStr" },
																		{ "title": "LabelLocalGroupEditorMassmail", "value": "massMailAction", "helper": "KL.LMS.Helpers.GroupsHelper", "helpermethod": "actionStr" }
																]
																}
														]
														},
														{ "type": "KL.Web.Controls.AccordionPanel", "id": "AntiSpamParamsPanel", "elements": [
																{ "type": "KL.LMS.Groups.GroupAsSettingsForm", "setting": "GroupSettings", "id": "groupAsSettingsForm" }
														]
														}
												]
												},
												{ "type": "KL.Web.Controls.AccordionItem", "id": "antiVirusParamsSettingsItem", "elements": [
														{ "type": "KL.Web.Controls.AccordionTab", "id": "AntiVirusParamsSettingsTab", "text": "LabelAntiVirusParamsSettings", "elements": [
																{ "type": "KL.Web.Controls.KeyValueListControl", "id": "antiVirusParamsPreview", "setting": "GroupSettings", "datafield": "scanSettings.avScanSettings", "allowhtml": false, "items": [
																		{ "title": "LabelLocalGroupEditorCheckVirus", "value": "engineSettings.enableScan", "helper": "KL.LMS.Helpers.CommonHelper", "helpermethod": "getIsAVEnabledColorTxtByBoolVal" },
																		{ "title": "LabelLocalGroupEditorInfectedFiles", "value": "infectedFirstAction", "helper": "KL.LMS.Helpers.GroupsHelper", "helpermethod": "actionStr" },
																		{ "title": "LabelLocalGroupEditorCorruptFiles", "value": "corruptedAction", "helper": "KL.LMS.Helpers.GroupsHelper", "helpermethod": "actionStr" },
																		{ "title": "LabelLocalGroupEditorEncryptFiles", "value": "encryptedAction", "helper": "KL.LMS.Helpers.GroupsHelper", "helpermethod": "actionStr" }
																]
																}
														]
														},
														{ "type": "KL.Web.Controls.AccordionPanel", "id": "AntiVirusParamsPanel", "elements": [
																{ "type": "KL.LMS.Groups.GroupAvSettingsForm", "setting": "GroupSettings", "id": "groupAvSettingsForm" }
														]
														}
												]
												},
												{ "type": "KL.Web.Controls.AccordionItem", "id": "antiPhishingParamsSettingsItem", "elements": [
														{ "type": "KL.Web.Controls.AccordionTab", "id": "AntiPhishingParamsSettingsTab", "text": "LabelAntiPhishingParamsSettings", "elements": [
																{ "type": "KL.Web.Controls.KeyValueListControl", "id": "antiPhishingParamsPreview", "setting": "GroupSettings", "datafield": "scanSettings.apScanSettings", "allowhtml": false, "items": [
																		{ "title": "LabelLocalGroupEditorCheckPhishing", "value": "engineSettings.enableScan", "helper": "KL.LMS.Helpers.CommonHelper", "helpermethod": "getIsAPEnabledColorTxtByBoolVal" },
																		{ "title": "LabelLocalGroupEditorPhishingAction", "value": "phishingAction", "helper": "KL.LMS.Helpers.GroupsHelper", "helpermethod": "actionStr" }
																	]
																}
															]
														},
														{ "type": "KL.Web.Controls.AccordionPanel", "id": "AntiPhishingParamsPanel", "elements": [
																{ "type": "KL.LMS.Groups.GroupApSettingsForm", "setting": "GroupSettings", "id": "groupApSettingsForm" }
															]
														}
												]
												},
												{ "type": "KL.Web.Controls.AccordionItem", "id": "cfParamsSettingsItem", "elements": [
														{ "type": "KL.Web.Controls.AccordionTab", "id": "CFParamsSettingsTab", "text": "LabelCFParamsSettings", "elements": [
																{ "type": "KL.Web.Controls.KeyValueListControl", "id": "CFParamsPreview", "setting": "GroupSettings", "datafield": "scanSettings.cfScanSettings", "allowhtml": false, "items": [
																		{ "title": "LabelLocalGroupEditorCheckCF", "value": "engineSettings.enableScan", "helper": "KL.LMS.Helpers.CommonHelper", "helpermethod": "getIsCFEnabledColorTxtByBoolVal" },
																		{ "title": "LabelLocalGroupEditorCFSizeExceeded", "value": "sizeExceededAction", "helper": "KL.LMS.Helpers.GroupsHelper", "helpermethod": "actionStr" },
																		{ "title": "LabelLocalGroupEditorCFBannedFileName", "value": "bannedFileNameAction", "helper": "KL.LMS.Helpers.GroupsHelper", "helpermethod": "actionStr" },
																		{ "title": "LabelLocalGroupEditorCFBannedFileFormat", "value": "bannedFileFormatAction", "helper": "KL.LMS.Helpers.GroupsHelper", "helpermethod": "actionStr" }
																	]
																}
															]
														},
														{ "type": "KL.Web.Controls.AccordionPanel", "id": "CFParamsPanel", "elements": [
																{ "type": "KL.LMS.Groups.GroupCFSettingsForm", "setting": "GroupSettings", "id": "groupCFSettingsForm" }
															]
														}
													]
												},
												{ "type": "KL.Web.Controls.AccordionItem", "id": "notificationParamsSettingsItem", "elements": [
														{ "type": "KL.Web.Controls.AccordionTab", "id": "NotificationParamsSettingsTab", "text": "LabelNotificationParamsSettings", "elements": [
																{ "type": "KL.Web.Controls.KeyValueListControl", "id": "NotificationParamsPreview", "setting": "GroupSettings", "datafield": "scanSettings.notificationSettings", "allowhtml": false, "items": [
																		{ "title": "LabelLocalGroupEditorNotificationInfected", "value": "enableInfected", "helper": "KL.LMS.Helpers.GroupsHelper", "helpermethod": "getNotificationUsers" },
																		{ "title": "LabelLocalGroupEditorNotificationEncrypted", "value": "enableEncrypted", "helper": "KL.LMS.Helpers.GroupsHelper", "helpermethod": "getNotificationUsers" },
																		{ "title": "LabelLocalGroupEditorNotificationCorrupted", "value": "enableCorrupted", "helper": "KL.LMS.Helpers.GroupsHelper", "helpermethod": "getNotificationUsers" },
																		{ "title": "LabelLocalGroupEditorNotificationCFFail", "value": "enableCFFail", "helper": "KL.LMS.Helpers.GroupsHelper", "helpermethod": "getNotificationUsers" },
																		{ "title": "LabelLocalGroupEditorNotificationPhishing", "value": "enablePhishing", "helper": "KL.LMS.Helpers.GroupsHelper", "helpermethod": "getNotificationUsers" }
																	]
																}
															]
														},
														{ "type": "KL.Web.Controls.AccordionPanel", "id": "notificationParamsPanel", "elements": [
																{ "type": "KL.LMS.Groups.GroupNotificationSettingsForm", "setting": "GroupSettings", "id": "groupNotificationSettingsForm" }
														]
														}
													]
												}
												
											]
										}
									]
								}
							]
						},
						{ "type": "KL.Web.Controls.MainNavTabPanel", "id": "bwListsPagePanel" ,"role_visible":"user,bwlistviewer", "elements": [
								{ "id": "personalBWListsPanel", "type": "KL.LMS.Settings.BWListsForm" }
							]
						},
						{ "type": "KL.Web.Controls.MainNavTabPanel", "id": "BackupPagePanel", "elements": [
								{ "type": "KL.Web.Controls.Panel", "id": "BackupSearchPage", "elements": [
										{ "id": "BackupGridWrap", "type": "KL.Web.Controls.Panel", "cssclass": "gridWrap", "elements": [
												{ "id": "backupListTopToolbar", "type": "KL.Web.Controls.Toolbar", "elements": [
														{ "type": "KL.Web.Controls.PagingFBNL" , "id": "BackupGridTopPager", "setting": "BackupList" },
														{ "type": "KL.Web.Controls.Button", "id": "btnDeliver_BackupTop", "text": "btnDeliver", "cssclass": "btnDeliverIco leftBtn" },
														{ "type": "KL.Web.Controls.Button", "id": "btnView_BackupTop", "text": "btnView", "cssclass": "btnViewIco" },
														{ "type": "KL.Web.Controls.Button", "id": "btnDelete_BackupTop", "text": "BtnDelete", "cssclass": "btnDelIco","role_visible":"admin,user"},
														{ "type": "KL.Web.Controls.Button" , "id": "btnSave_BackupTop", "text": "BtnSave", "cssclass": "btnSaveIco","role_visible":"admin" }
													]
												},
												{ "type": "KL.LMS.Backup.FilterInfo", "id": "lblFilterInfo" },
												{ "type": "KL.LMS.Backup.BackupGrid", "id": "BackupGridControl", "setting": "BackupList", "idField": "letterId", "checkboxenabled": true, "usectrlclick": false }
											]
										}
									]
								},
								{ "type": "KL.Web.Controls.Panel", "id": "MessageViewEditPage", "elements": [
										{ "type": "KL.Web.Controls.Panel" , "id": "storageMessageWrap", "setting": "MessageSettings" , "elements":
											[
												{ "type": "KL.Web.Controls.Toolbar", "id": "MessageViewTopbar", "istall": true, "elements": [
														{ "type": "KL.Web.Controls.Button" , "id": "btnBackupSearch", "text": "btnBackToBackupList", "cssclass": "leftBtn" },
														{ "type": "KL.Web.Controls.PagingBN" , "id": "MessageTopPager", "setting": "MessageSettings" }
													]
												},
												{ "type": "KL.Web.Controls.Toolbar", "id": "MessageCommandsTopbar", "elements": [
														{ "type": "KL.Web.Controls.Button", "id": "btnDeliver_MessageTop", "text": "btnDeliver",  "cssclass": "btnDeliverIco leftBtn" },
														{ "type": "KL.Web.Controls.Button" , "id": "btnDelete_MessageTop", "text": "BtnDelete", "cssclass": "btnDelIco","role_visible":"admin,user" },
														{ "type": "KL.Web.Controls.Button" , "id": "btnSave_MessageTop", "text": "BtnSave", "cssclass": "btnSaveIco","role_visible":"admin" }
													]
												},
										
												{ "type": "KL.LMS.Backup.MessagePanel" , "id": "MessageSettingsTab"}
											]
										}
									]
								}
							]
						},
						{ "type": "KL.Web.Controls.MainNavTabPanel", "id": "ReportsPagePanel", "elements": [
								{"id": "reportsFilterBtns", "type": "KL.LMS.Reports.ReportsFilter", "setting": "ReportSettings", "items": [
										{"text": "LabelReportsFilter_All", "event": "onfilterall", "showtogge": false, "settingsavailable": false ,"datatype": "all" }, //reportFilterAll
										{"text": "LabelReportsFilter_Daily", "event": "onfilterdaily", "datatype": "daily" }, //reportFilterDaily
										{"text": "LabelReportsFilter_Weekly", "event": "onfilterdaily", "datatype": "weekly" }, //reportFilterWeekly
										{"text": "LabelReportsFilter_Monthly", "event": "onfilterdaily", "datatype": "monthly" }, //reportFilterMonthly
										{"text": "LabelReportsFilter_Users", "event": "onfilterdaily","showtogge": false, "datatype": "users"} //reportFilterUsers
										
									]
								},
								{ "type": "KL.Web.Controls.Panel", "id": "ReportsSearchPage", "elements": [
										{ "id": "ReportsGridWrap", "type": "KL.Web.Controls.Panel", "cssclass": "gridWrap", "elements": [
												{ "id": "ReportsListTopToolbar", "type": "KL.Web.Controls.Toolbar", "elements": [
													{ "type": "KL.Web.Controls.Button", "id": "btnDelete_ReportsTop", "text": "BtnDelete", "cssclass": "btnDelIco leftBtn" }
													]
												},
												{ "type": "KL.LMS.Reports.ReportsGrid", "id": "ReportsGridControl", "setting": "ReportsList", "idField": "fileName", "checkboxenabled": true, "usectrlclick": false }
											]
										}
									]
								}
							]
						},
						{ "type": "KL.Web.Controls.MainNavTabPanel", "id": "SettingsPagePanel", "cssclass":"settingsPagePanel", "elements": [
								{ "id": "settingsTabsPanel", "cssclass": "subTabsListWrap", "type": "KL.Web.Controls.Panel", "elements": [
										{ "id": "settingsTabsPanel", "cssclass": "subTabsList", "type": "KL.Web.Controls.Panel", "elements": [
												{ "type": "KL.Web.Controls.TabsList", "param": "subnav", "id": "settingsSubNav", "items": [
														{ "text": "LabelTitleSettingsTabUpdate", "panel": "pnlSettingsUpdate" },
														{ "text": "LabelTitleSettingsTabLDAP", "panel": "pnlSettingsLDAP" },
														{ "text": "LabelTitleSettingsTabUsers", "panel": "pnlSettingsUsers","role_visible":"never" },
														{ "text": "LabelTitleSettingsTabNotifications", "panel": "pnlSettingsNotifications" },
														{ "text": "LabelTitleSettingsTabBackup", "panel": "pnlSettingsBackup"},
														{ "text": "LabelTitleSettingsTabMTA", "panel": "pnlSettingsMTA" ,"role_visible":"never"},
														{ "text": "LabelTitleSettingsTabProtection", "panel": "pnlSettingsProtection" },
														{ "text": "LabelTitleSettingsTabSNMP", "panel": "pnlSettingsSNMP" },
														{ "text": "LabelTitleSettingsTabPerformance", "panel": "pnlSettingsPerformance","role_visible":"never" },
														{ "text": "LabelTitleSettingsTabMisc", "panel": "pnlSettingsMisc" }
													]
												},
												{ "type": "KL.Web.Controls.TabPanel", "id": "pnlSettingsUpdate", "elements": [
														{ "id": "pnlSettingsUpdateContent", "titletext": "LabelTitleSettingsPanelUpdate", "type": "KL.Web.Controls.TitledPanel","elements": [
																{ "id": "updateProxySettings", "titletext": "LabelSettingsPanelUpdate_PanelProxy", "type": "KL.LMS.Settings.ToggleableSettingsPreviewPanel", "helptext": "LabelUpdateTooltip_ProxySettingsCanBeOpenedHere" ,"setting": "UpdateProxySettings",
																	"toggledatafield": "proxySettings.enable",
																	"elements": [
																			{ "type": "KL.LMS.Settings.KeyValueListControl", "id": "updateProxySettingsPreview", "datafield": "proxySettings", "setting": "UpdateProxySettings", "allowhtml": false, "items": [
																					{ "title": "LabelSettingsPanelUpdate_Address", "index": 0, "value": "serverAddress", "defaultValue": "", "helper": "KL.LMS.Helpers.UpdateSettingsHelper", "helpermethod": "getAddress","event": "oncnnchange" },
																					{ "title": "LabelSettingsDialogUpdate_BypassLocalAddresses", "index": 1, "value": "proxyBypassLocalAddresses", "defaultValue": true, "helper": "KL.LMS.Helpers.UpdateSettingsHelper", "helpermethod": "getFtpPassiveStatus", "event": "oncnnchange" }
																				]
																			}
																	]
																},
																{ "id": "baseUpdateSettings", "titletext": "LabelSettingsPanelUpdate_Panel", "type": "KL.LMS.Settings.UpdateSettingsPreviewPanel", "setting": "UpdateStateSettings", "buttons": [
																		{ "text": "LabelSettingsPanelUpdate_link_StartUpdate", "event": "onupdatestart" }
																	], "elements": [
																		{ "type": "KL.LMS.Settings.KeyValueListControl", "id": "baseUpdateSettingsPreview", "setting": "UpdateSettings","allowhtml": false, "items": [
																				{ "title": "LabelSettingsPanelUpdate_UpdateSource", "index": 0, "value": "updaterSettings.updateCommonSettings.sourceType", "helper": "KL.LMS.Helpers.UpdateSettingsHelper", "helpermethod": "getUpdateSource", "event": "onsourcechange" },
																				{ "title": "LabelSettingsPanelUpdate_ScheduledUpdate", "index": 1, "value": "updaterSettings.schedule", "helper": "KL.LMS.Helpers.UpdateSettingsHelper", "helpermethod": "getScheduleValue", "event": "onschedulechange" }
																		]
																		},
																		{ "type": "KL.Web.Controls.KeyValueListControl", "id": "baseUpdateStatePreview", "setting": "UpdateStateSettings", "allowhtml": false, "items": [
																				{ "title": "LabelSettingsPanelUpdate_Task_LastTimeStart", "index": 0, "cssclass": "nonEditableItem", "value": "lastUpdate", "helper": "KL.LMS.Helpers.UpdateSettingsHelper", "helpermethod": "getUpdateTaskState" }
																		]
																		}
																	]
																}
															]
														}
													]
												},
												{ "type": "KL.Web.Controls.TabPanel", "id": "pnlSettingsLDAP", "elements": [
														{ "id": "pnlSettingsLdapContent", "titletext": "LabelTitleSettingsPanelLDAP", "type": "KL.Web.Controls.TitledPanel", "elements": [
																{ "id": "ldapTypeSettings", "titletext": "LabelSettingsTitleLdapTypeSettings", "type": "KL.LMS.Settings.SettingsPreviewPanel", "setting": "LdapSetting", "elements": [
																		{ "type": "KL.LMS.Settings.KeyValueListControl", "id": "ldapTypeSettingsPreview", "setting": "LdapSetting", "allowhtml": false, "items": [
																				{ "title": "LabelSettingsPreviewCnnLdapServerType", "index": 0, "value": "integrationType", "defaultValue": 0, "helper": "KL.LMS.Helpers.LdapHelper", "helpermethod": "getScriptName", "event": "onsettingschange" }
																			]
																		},
																		{ "type": "KL.LMS.Settings.LdapCnnPreviewControl", "id": "ldapCnnAvailablePreview", "setting": "LdapSetting", "datafield": "integrationType",
																			"disabled": true,
																			"title": "LabelSettingsPreviewCnnLdapStatus",
																			"loadingtext": "LabelSettingsPreviewCnnLoading",
																			"statusunknowntext": "LabelSettingsPreviewCnnUnknown",
																			"cnnavailabletext": "LabelSettingsPreviewCnnAvailable",
																			"cnnunavailabletext": "LabelSettingsPreviewCnnUnavailable",
																			"cnnnotsettext": "LabelSettingsPreviewCnnNotSet",
																			"itemcssclass": "itemEven"
																		}
																	]
																},
																{ "id": "ldapCnnSettings", "titletext": "LabelSettingsTitleLdapCnnSettings", "type": "KL.LMS.Settings.SettingsPreviewPanel", "setting": "LdapSetting", "elements": [
																		{ "type": "KL.LMS.Settings.KeyValueListControlLdapCnn", "id": "ldapCnnSettingsPreview", "setting": "LdapSetting", "allowhtml": false, "items": [
																				{ "title": "LabelSettingsPreviewCnnLdapServerName", "index": 0, "value": "host", "defaultValue": "0","helper": "KL.LMS.Helpers.LdapHelper", "helpermethod": "getLDAPValue", "event": "onsettingschange" },
																				{ "title": "LabelSettingsPreviewCnnLdapServerPort", "index": 1, "value": "port", "defaultValue": 0, "helper": "KL.LMS.Helpers.LdapHelper", "helpermethod": "getLDAPValue","event": "onsettingschange" },
																				{ "title": "LabelSettingsPreviewCnnLdadAccName", "index": 0, "value": "bindDn", "defaultValue": "0", "helper": "KL.LMS.Helpers.LdapHelper", "helpermethod": "getLDAPValue","event": "onsettingschange" },
																				{ "title": "LabelSettingsPreviewCnnLdapSearchBase", "index": 1, "value": "searchBase", "defaultValue": "0", "helper": "KL.LMS.Helpers.LdapHelper", "helpermethod": "getLDAPValue","event": "onsettingschange" }
																			]
																		}
																	]
																},
																{ "id": "ldapAccessSettings", "titletext": "LabelSettingsTitleLdapAccessSettings", "type": "KL.LMS.Settings.SettingsPreviewPanel", "setting": "LdapSetting", "elements": [
																		{ "type": "KL.LMS.Settings.KeyValueListControl", "id": "ldapAccessSettingsPreview", "setting": "LdapSetting", "allowhtml": false, "items": [
																				{ "title": "LabelSettingsPreviewAccessLdapBackup", "index": 0, "value": "login", "defaultValue": "0", "helper": "KL.LMS.Helpers.LdapHelper", "helpermethod": "getLDAPFiltersValue", "event": "onsettingschange" },
																				{ "title": "LabelSettingsPreviewAccessLdapDefSearchStr", "index": 1, "value": "search", "defaultValue": "0", "helper": "KL.LMS.Helpers.LdapHelper", "helpermethod": "getLDAPFiltersValue", "event": "onsettingschange" },
																				{ "title": "LabelSettingsPreviewAccessLdapMatchUser", "index": 0, "value": "user", "defaultValue": "0", "helper": "KL.LMS.Helpers.LdapHelper", "helpermethod": "getLDAPFiltersValue", "event": "onsettingschange" },
																				{ "title": "LabelSettingsPreviewAccessLdapMatchGroup", "index": 1, "value": "groupList", "defaultValue": "", "helper": "KL.LMS.Helpers.LdapHelper", "helpermethod": "getLDAPFiltersValue", "event": "onsettingschange" },
																				{ "title": "LabelSettingsPreviewAccessLdapMatchChild", "index": 0, "value": "useNestedGroups", "defaultValue": false, "helper": "KL.LMS.Helpers.LdapHelper", "helpermethod": "getUseNestedGroups", "event": "onsettingschange" }
																			]
																		}
																	]
																},
																
																{ "id": "ldapBWListsSettings", "titletext": "LabelSettingsTitleLdapBWListsSettings", "type": "KL.LMS.Settings.SettingsPreviewPanel", "setting": "LdapSetting", "elements": [
																		{ "type": "KL.LMS.Settings.LdapCnnPreviewControl", "id": "ldapBwAvailablePreview",
																			"title": "LabelSettingsBWListsAccess",
																			"cnnavailabletext": "LabelSettingsBWListsAvailable",
																			"cnnunavailabletext": "LabelSettingsBWListsUnavailable",
																			"itemcssclass": "itemOdd"
																		}
																]
																}
														]
														}
												]
												},
												{ "type": "KL.Web.Controls.TabPanel", "id": "pnlSettingsUsers", "elements": []},
												{ "type": "KL.Web.Controls.TabPanel", "id": "pnlSettingsNotifications", "elements": [
														{ "id": "pnlNotificationsSettingsContent", "titletext": "LabelTitleSettingsPanelNotifications", "type": "KL.Web.Controls.TitledPanel", "setting": "NotificationsSetting", "elements": [
															
																{ "id": "notification1", "titletext": "LabelSettingsTitleAsEvents", "type": "KL.LMS.Settings.ToggleableSettingsPreviewPanel", "setting": "NotificationsSetting",
																	"toggledatafield": "notificationFlags.antiSpamBasesOutdated",
																	"elements": [
																		{ "type": "KL.LMS.Settings.KeyValueListControl", "id": "notification1Preview", "setting": "NotificationsSetting", "allowhtml": false, "items": [
																				{ "title": "LabelSettingsPreviewNotificationsDBOutdated_Sub", "index": 0, "keyhint": true, "value": "notificationTemplates.antiSpamBasesOutdated.subject", "defaultValue": "-", "event": "onchangeoutdatedtext", "clickparams": ["notificationTemplates.antiSpamBasesOutdated"] },
																				{ "title": "LabelSettingsPreviewNotificationsDBOutdated_Msg", "index": 1, "keyhint": true, "value": "notificationTemplates.antiSpamBasesOutdated.body", "defaultValue": "-", "event": "onchangeoutdatedtext", "clickparams": ["notificationTemplates.antiSpamBasesOutdated"] },
																				{ "title": "LabelSettingsPreviewNotificationsDBObsoleted_Sub", "index": 0, "keyhint": true, "value": "notificationTemplates.antiSpamBasesObsoleted.subject", "defaultValue": "-", "event": "onchangeobsoletetext", "clickparams": ["notificationTemplates.antiSpamBasesObsoleted"] },
																				{ "title": "LabelSettingsPreviewNotificationsDBObsoleted_Msg", "index": 1, "keyhint": true, "value": "notificationTemplates.antiSpamBasesObsoleted.body", "defaultValue": "-", "event": "onchangeobsoletetext", "clickparams": ["notificationTemplates.antiSpamBasesObsoleted"] }
																		]
																		}
																	]
																},
																{ "id": "notification2", "titletext": "LabelSettingsTitleAvEvents", "type": "KL.LMS.Settings.ToggleableSettingsPreviewPanel", "setting": "NotificationsSetting",
																	"toggledatafield": "notificationFlags.antiVirusBasesOutdated",
																	"elements": [
																		{ "type": "KL.LMS.Settings.KeyValueListControl", "id": "notification2Preview", "setting": "NotificationsSetting", "allowhtml": false, "items": [
																				{ "title": "LabelSettingsPreviewNotificationsDBOutdated_Sub", "index": 0, "keyhint": true, "value": "notificationTemplates.antiVirusBasesOutdated.subject", "defaultValue": "-", "event": "onchangeoutdatedtext", "clickparams": ["notificationTemplates.antiVirusBasesOutdated"] },
																				{ "title": "LabelSettingsPreviewNotificationsDBOutdated_Msg", "index": 1, "keyhint": true, "value": "notificationTemplates.antiVirusBasesOutdated.body", "defaultValue": "-", "event": "onchangeoutdatedtext", "clickparams": ["notificationTemplates.antiVirusBasesOutdated"] },
																				{ "title": "LabelSettingsPreviewNotificationsDBObsoleted_Sub", "index": 0, "keyhint": true, "value": "notificationTemplates.antiVirusBasesObsoleted.subject", "defaultValue": "-", "event": "onchangeobsoletetext", "clickparams": ["notificationTemplates.antiVirusBasesObsoleted"] },
																				{ "title": "LabelSettingsPreviewNotificationsDBObsoleted_Msg", "index": 1, "keyhint": true, "value": "notificationTemplates.antiVirusBasesObsoleted.body", "defaultValue": "-", "event": "onchangeobsoletetext", "clickparams": ["notificationTemplates.antiVirusBasesObsoleted"] }
																		]
																		}
																	]
																},
																{ "id": "notification3", "titletext": "LabelSettingsTitleFailedToMoveToBackup", "type": "KL.LMS.Settings.ToggleableSettingsPreviewPanel", "setting": "NotificationsSetting",
																	"toggledatafield": "notificationFlags.messageBackupFailed",
																	"elements": [
																		{ "type": "KL.LMS.Settings.KeyValueListControl", "id": "notification3Preview", "index": 0, "setting": "NotificationsSetting", "allowhtml": false, "items": [
																				{ "title": "LabelSettingsPreviewNotificationsBackupSingleObjMsgSubj", "index": 1, "keyhint": true, "value": "notificationTemplates.messageBackupFailed.subject", "defaultValue": "-", "event": "onchangetext1", "clickparams": ["notificationTemplates.messageBackupFailed"] },
																				{ "title": "LabelSettingsPreviewNotificationsBackupSingleObjMsg", "index": 0, "keyhint": true, "value": "notificationTemplates.messageBackupFailed.body", "defaultValue": "-", "event": "onchangetext1", "clickparams": ["notificationTemplates.messageBackupFailed"] },
																				{ "title": "LabelSettingsPreviewNotificationsBackupMultiObjMsgSubj", "index": 1, "keyhint": true, "value": "notificationTemplates.severalMessagesBackupFailed.subject", "defaultValue": "-", "event": "onchangetext2", "clickparams": ["notificationTemplates.severalMessagesBackupFailed"] },
																				{ "title": "LabelSettingsPreviewNotificationsBackupMultiObjMsg", "index": 0, "keyhint": true, "value": "notificationTemplates.severalMessagesBackupFailed.body", "defaultValue": "-", "event": "onchangetext2", "clickparams": ["notificationTemplates.severalMessagesBackupFailed"] }
																			]
																		}
																	]
																},
																{ "id": "notification4", "titletext": "LabelSettingsTitleFailedCleanBackup", "type": "KL.LMS.Settings.ToggleableSettingsPreviewPanel", "setting": "NotificationsSetting",
																	"toggledatafield": "notificationFlags.backupCleanupFailed",
																	"elements": [
																		{ "type": "KL.LMS.Settings.KeyValueListControl", "id": "notification4Preview", "setting": "NotificationsSetting", "allowhtml": false, "items": [
																				{ "title": "LabelSettingsPreviewNotificationsMsgSubj", "index": 0, "keyhint": true, "value": "notificationTemplates.backupCleanupFailed.subject", "defaultValue": "-", "event": "onchangetext", "clickparams": ["notificationTemplates.backupCleanupFailed"] },
																				{ "title": "LabelSettingsPreviewNotificationsMsg", "index": 1, "keyhint": true, "value": "notificationTemplates.backupCleanupFailed.body", "defaultValue": "-", "event": "onchangetext", "clickparams": ["notificationTemplates.backupCleanupFailed"] }
																		]
																		}
																	]
																},
																{ "id": "notification5", "titletext": "LabelSettingsTitleBackupFull", "type": "KL.LMS.Settings.ToggleableSettingsPreviewPanel", "setting": "NotificationsSetting",
																	"toggledatafield": "notificationFlags.backupAlmostFull",
																	"elements": [
																		{ "type": "KL.LMS.Settings.KeyValueListControl", "id": "notification5Preview", "setting": "NotificationsSetting", "allowhtml": false, "items": [
																				{ "title": "LabelSettingsPreviewNotificationsMsgSubj", "index": 0, "keyhint": true, "value": "notificationTemplates.backupAlmostFull.subject", "defaultValue": "-", "event": "onchangetext", "clickparams": ["notificationTemplates.backupAlmostFull"] },
																				{ "title": "LabelSettingsPreviewNotificationsMsg", "index": 1, "keyhint": true, "value": "notificationTemplates.backupAlmostFull.body", "defaultValue": "-", "event": "onchangetext", "clickparams": ["notificationTemplates.backupAlmostFull"] }
																		]
																		}
																	]
																},
																{ "id": "notification6", "titletext": "LabelSettingsTitleLicenseAboutToExpire", "type": "KL.LMS.Settings.ToggleableSettingsPreviewPanel", "setting": "NotificationsSetting",
																	"toggledatafield": "notificationFlags.licenseExpiresSoon",
																	"elements": [
																		{ "type": "KL.LMS.Settings.KeyValueListControl", "id": "notificationLicenseAboutToExpireDaysSettingsPreview", "setting": "NotificationsLicenserSettings", "allowhtml": false, "items": [
																				{ "title": "LabelSettingsPreviewNotificationsOptions", "index": 0, "keyhint": true, "value": "licenseExpiresSoonWarningDays", "defaultValue": 0, "event": ["onvaluechange","onoptionschange"], "clickparams": ["licenseExpiresSoonWarningDays", "onlicenseexpiressoondayschange"] }
																			]
																		},
																		{ "type": "KL.LMS.Settings.KeyValueListControl", "id": "notification6Preview", "setting": "NotificationsSetting", "allowhtml": false, "items": [
																				{ "title": "LabelSettingsPreviewNotificationsMsgSubj", "keyhint": true, "value": "notificationTemplates.licenseExpiresSoon.subject", "defaultValue": "-", "event": "onchangetext", "clickparams": ["notificationTemplates.licenseExpiresSoon"] },
																				{ "title": "LabelSettingsPreviewNotificationsMsg", "index": 0, "keyhint": true, "value": "notificationTemplates.licenseExpiresSoon.body", "defaultValue": "-", "event": "onchangetext", "clickparams": ["notificationTemplates.licenseExpiresSoon"] }
																			]
																		}
																	]
																},
																{ "id": "notification7", "titletext": "LabelSettingsTitleLicenseExpired", "type": "KL.LMS.Settings.ToggleableSettingsPreviewPanel", "setting": "NotificationsSetting",
																	"toggledatafield": "notificationFlags.licenseExpired",
																	"elements": [
																		{ "type": "KL.LMS.Settings.KeyValueListControl", "id": "notification7Preview", "setting": "NotificationsSetting", "allowhtml": false, "items": [
																				{ "title": "LabelSettingsPreviewNotificationsMsgSubj", "index": 0, "keyhint": true, "value": "notificationTemplates.licenseExpired.subject", "defaultValue": "-", "event": "onchangetext", "clickparams": ["notificationTemplates.licenseExpired"] },
																				{ "title": "LabelSettingsPreviewNotificationsMsg", "index": 1, "keyhint": true, "value": "notificationTemplates.licenseExpired.body", "defaultValue": "-", "event": "onchangetext", "clickparams": ["notificationTemplates.licenseExpired"] }
																		]
																		}
																	]
																},
																{ "id": "notification8", "titletext": "LabelSettingsTitleLicenseBlacklisted", "type": "KL.LMS.Settings.ToggleableSettingsPreviewPanel", "setting": "NotificationsSetting",
																	"toggledatafield": "notificationFlags.licenseBlacklisted",
																	"elements": [
																		{ "type": "KL.LMS.Settings.KeyValueListControl", "id": "notification8Preview", "setting": "NotificationsSetting", "allowhtml": false, "items": [
																				{ "title": "LabelSettingsPreviewNotificationsMsgSubj", "index": 0, "keyhint": true, "value": "notificationTemplates.licenseBlacklisted.subject", "defaultValue": "-", "event": "onchangetext", "clickparams": ["notificationTemplates.licenseBlacklisted"] },
																				{ "title": "LabelSettingsPreviewNotificationsMsg", "index": 1, "keyhint": true, "value": "notificationTemplates.licenseBlacklisted.body", "defaultValue": "-", "event": "onchangetext", "clickparams": ["notificationTemplates.licenseBlacklisted"] }
																		]
																		}
																	]
																},
																{ "id": "notification14", "titletext": "LabelSettingsTitleExternalDirectoryServicesError", "type": "KL.LMS.Settings.ToggleableSettingsPreviewPanel", "setting": "NotificationsSetting",
																	"toggledatafield": "notificationFlags.externalDirectoryServicesError",
																	"elements": [
																		{ "type": "KL.LMS.Settings.KeyValueListControl", "id": "notification14Preview", "setting": "NotificationsSetting", "allowhtml": false, "items": [
																				{ "title": "LabelSettingsPreviewNotificationsExternalDirectoryServiceErrorMsgSubj", "index": 0, "keyhint": true, "value": "notificationTemplates.externalDirectoryServiceError.subject", "defaultValue": "-", "event": "onchangetext1", "clickparams": ["notificationTemplates.externalDirectoryServiceError"] },
																				{ "title": "LabelSettingsPreviewNotificationsExternalDirectoryServiceErrorMsg", "index": 1, "keyhint": true, "value": "notificationTemplates.externalDirectoryServiceError.body", "defaultValue": "-", "event": "onchangetext1", "clickparams": ["notificationTemplates.externalDirectoryServiceError"] },
																				{ "title": "LabelSettingsPreviewNotificationsExternalDirectoryServiceErrorAggregationMsgSubj", "index": 0, "keyhint": true, "value": "notificationTemplates.externalDirectoryServiceErrorAggregation.subject", "defaultValue": "-", "event": "onchangetext2", "clickparams": ["notificationTemplates.externalDirectoryServiceErrorAggregation"] },
																				{ "title": "LabelSettingsPreviewNotificationsExternalDirectoryServiceErrorAggregationMsg", "index": 1, "keyhint": true, "value": "notificationTemplates.externalDirectoryServiceErrorAggregation.body", "defaultValue": "-", "event": "onchangetext2", "clickparams": ["notificationTemplates.externalDirectoryServiceErrorAggregation"] }
																		]
																		}
																	]
																},
																{ "id": "notification9", "titletext": "LabelSettingsTitleFailedToReject", "type": "KL.LMS.Settings.SettingsPreviewPanel", "setting": "NotificationsSetting",
																	"elements": [
																		{ "type": "KL.LMS.Settings.KeyValueListControl", "id": "notification9Preview", "setting": "NotificationsSetting", "allowhtml": false, "items": [
																				{ "title": "LabelSettingsPreviewNotificationsMsgSubj", "index": 0, "keyhint": true, "value": "notificationTemplates.messageBounce.subject", "defaultValue": "-", "event": "onchangetext", "clickparams": ["notificationTemplates.messageBounce"] },
																				{ "title": "LabelSettingsPreviewNotificationsMsg", "index": 1, "keyhint": true, "value": "notificationTemplates.messageBounce.body", "defaultValue": "-", "event": "onchangetext", "clickparams": ["notificationTemplates.messageBounce"] }
																		]
																		}
																	]
																},
																{ "id": "notification10", "titletext": "LabelSettingsTitleSenderNotification", "type": "KL.LMS.Settings.SettingsPreviewPanel", "setting": "NotificationsSetting",
																	"elements": [
																		{ "type": "KL.LMS.Settings.KeyValueListControl", "id": "notification10Preview", "setting": "NotificationsSetting", "allowhtml": false, "items": [
																				{ "title": "LabelSettingsPreviewNotificationsMsgSubj", "index": 0, "keyhint": true, "value": "notificationTemplates.scanStatusAlertForSender.subject", "defaultValue": "-", "event": "onchangetext", "clickparams": ["notificationTemplates.scanStatusAlertForSender"] },
																				{ "title": "LabelSettingsPreviewNotificationsMsg", "index": 1, "keyhint": true, "value": "notificationTemplates.scanStatusAlertForSender.body", "defaultValue": "-", "event": "onchangetext", "clickparams": ["notificationTemplates.scanStatusAlertForSender"] }
																		]
																		}
																	]
																},
																{ "id": "notification11", "titletext": "LabelSettingsTitleRecipientNotification", "type": "KL.LMS.Settings.SettingsPreviewPanel", "setting": "NotificationsSetting",
																	"elements": [
																		{ "type": "KL.LMS.Settings.KeyValueListControl", "id": "notification11Preview", "setting": "NotificationsSetting", "allowhtml": false, "items": [
																				{ "title": "LabelSettingsPreviewNotificationsMsgSubj", "index": 0, "keyhint": true, "value": "notificationTemplates.scanStatusAlertForRecipient.subject", "defaultValue": "-", "event": "onchangetext", "clickparams": ["notificationTemplates.scanStatusAlertForRecipient"] },
																				{ "title": "LabelSettingsPreviewNotificationsMsg", "index": 1, "keyhint": true, "value": "notificationTemplates.scanStatusAlertForRecipient.body", "defaultValue": "-", "event": "onchangetext", "clickparams": ["notificationTemplates.scanStatusAlertForRecipient"] }
																		]
																		}
																	]
																},
																{ "id": "notification12", "titletext": "LabelSettingsTitleAdministratorNotification", "type": "KL.LMS.Settings.SettingsPreviewPanel", "setting": "NotificationsSetting",
																	"elements": [
																		{ "type": "KL.LMS.Settings.KeyValueListControl", "id": "notification12Preview", "setting": "NotificationsSetting", "allowhtml": false, "items": [
																				{ "title": "LabelSettingsPreviewNotificationsMsgSubj", "index": 0, "keyhint": true, "value": "notificationTemplates.scanStatusAlertForAdmin.subject", "defaultValue": "-", "event": "onchangetext", "clickparams": ["notificationTemplates.scanStatusAlertForAdmin"] },
																				{ "title": "LabelSettingsPreviewNotificationsMsg", "index": 1, "keyhint": true, "value": "notificationTemplates.scanStatusAlertForAdmin.body", "defaultValue": "-", "event": "onchangetext", "clickparams": ["notificationTemplates.scanStatusAlertForAdmin"] }
																			]
																		}
																	]
																},
																{ "id": "notification13", "titletext": "LabelSettingsTitleOptionalRecipientNotification", "type": "KL.LMS.Settings.SettingsPreviewPanel", "setting": "NotificationsSetting",
																	"elements": [
																		{ "type": "KL.LMS.Settings.KeyValueListControl", "id": "notification13Preview", "setting": "NotificationsSetting", "allowhtml": false, "items": [
																				{ "title": "LabelSettingsPreviewNotificationsMsgSubj", "index": 0, "keyhint": true, "value": "notificationTemplates.scanStatusAlertForOthers.subject", "defaultValue": "-", "event": "onchangetext", "clickparams": ["notificationTemplates.scanStatusAlertForOthers"] },
																				{ "title": "LabelSettingsPreviewNotificationsMsg", "index": 1, "keyhint": true, "value": "notificationTemplates.scanStatusAlertForOthers.body", "defaultValue": "-", "event": "onchangetext", "clickparams": ["notificationTemplates.scanStatusAlertForOthers"] }
																			]
																		}
																	]
																}
															]
														}
													]
												},
												{ "type": "KL.Web.Controls.TabPanel", "id": "pnlSettingsBackup", "elements": [
														{ "id": "pnlBackupSettingsContent", "titletext": "LabelTitleSettingsPanelBackup", "type": "KL.Web.Controls.TitledPanel", "elements": [
																{ "id": "backupSettings", "titletext": "LabelTitleSettingsBackup", "type": "KL.LMS.Settings.SettingsPreviewPanel", "elements": [
																		{ "type": "KL.LMS.Settings.KeyValueListControl", "id": "backupSettingsPreview", "setting": "BackupSettings", "allowhtml": false, "items": [
																				{ "title": "LabelSettingsBackup_MaxSize", "index": 0, "value": "maxSize", "defaultValue": 1073741824, "helper": "KL.LMS.Helpers.CommonHelper", "helpermethod": "getSizeInMB", "event": "onsettingschange" },
																				{ "title": "LabelSettingsBackup_Threshold", "index": 1, "value": "threshold", "defaultValue": 10, "helper": "KL.LMS.Helpers.CommonHelper", "helpermethod": "getPersentVal", "event": "onsettingschange" },
																				{ "title": "LabelSettingsBackup_AvThreatsRestoration", "index": 0, "value": "allowAvThreatsRestoration", "defaultValue": false ,"helper": "KL.LMS.Helpers.CommonHelper", "helpermethod": "getIsEnabledTxtByBoolVal", "event": "onsettingschange"},
																				{ "title": "LabelTitleSettingsMisc_FailureAction_Backup", "index": 1, "value": "scanLogic.backupFailureAction", "defaultValue": false, "helper": "KL.LMS.Helpers.SettingsHelper", "helpermethod": "getBackupFailureActionText", "event": "onsettingschange" }
																			]
																		}
																	]
																}
															]
														}
													]
												},
												{ "type": "KL.Web.Controls.TabPanel", "id": "pnlSettingsMTA", "elements": [] },
												{ "type": "KL.Web.Controls.TabPanel", "id": "pnlSettingsSNMP", "elements": [
														{ "id": "pnlSNMPSettingsContent", "titletext": "LabelTitleSettingsPanelSNMP", "type": "KL.Web.Controls.TitledPanel", "elements": [
																{ "id": "enableSNMPSettings", "titletext": "LabelTitleSettingsSNMP_Statistics", "type": "KL.LMS.Settings.ToggleableSettingsPreviewPanel", "setting": "SNMPSettings",
																	"toggledatafield": "enableSNMP"},
																{ "id": "connectionSNMPSettings", "titletext": "LabelTitleSettingsSNMP_Connection", "type": "KL.LMS.Settings.SettingsPreviewPanel", "elements": [
																		{ "type": "KL.LMS.Settings.KeyValueListControl", "id": "connectionSNMPPreview", "setting": "SNMPSettings", "allowhtml": false, "items": [
																				{ "title": "LabelTitleSettingsSNMP_Connection_Socket", "index": 0, "keyhint": true, "value": "masterAgentAddress", "defaultValue": "",  "event": "onsettingschange" },
																				{ "title": "LabelTitleSettingsSNMP_Connection_Timeout", "index": 1, "keyhint": true, "value": "pingIntervalInSeconds", "defaultValue": 0,"helper": "KL.LMS.Helpers.SettingsHelper", "helpermethod": "getSecondsNumText", "event": "onsettingschange" }
																			]
																		}
																	]
																},
																{ "id": "trapSuiteSNMPSettings", "titletext": "LabelTitleSettingsSNMP_Settings", "type": "KL.LMS.Settings.ToggleableSettingsPreviewPanel", "setting": "SNMPSettings",
																	"toggledatafield": "trapsEnable",
																	"elements": [
																		{ "type": "KL.LMS.Settings.KeyValueListControl", "id": "trapSuiteSNMPPreview_ErrorUpdate", "setting": "SNMPSettings", "allowhtml": false, "datafield":"trapSuite","items": [
																				{ "title": "LabelTitleSettingsSNMP_Settings_updateErrorEventEnable", "index": 0, "keyhint": true, "value": "updateErrorEventEnable", "defaultValue": false, "helper": "KL.LMS.Helpers.CommonHelper", "helpermethod": "getIsEnabledTxtByBoolVal", "event": "onsettingschange"}
																			]
																		},
																		{ "type": "KL.LMS.Settings.KeyValueListControl", "id": "trapSuiteSNMPPreview_Bases", "setting": "SNMPSettings", "allowhtml": false, "datafield":"trapSuite","items": [
																				{ "title": "LabelTitleSettingsSNMP_Settings_aspBasesCompilationFailedEventEnable", "index": 1, "keyhint": true, "value": "aspBasesCompilationFailedEventEnable", "defaultValue": false, "helper": "KL.LMS.Helpers.CommonHelper", "helpermethod": "getIsEnabledTxtByBoolVal", "event": "onsettingschange"},
																				{ "title": "LabelTitleSettingsSNMP_Settings_aspBasesObsoletedEventEnable", "index": 0, "keyhint": true, "value": "aspBasesObsoletedEventEnable", "defaultValue": false, "helper": "KL.LMS.Helpers.CommonHelper", "helpermethod": "getIsEnabledTxtByBoolVal", "event": "onsettingschange"},
																				{ "title": "LabelTitleSettingsSNMP_Settings_aspBasesOutdatedEventEnable", "index": 1, "keyhint": true, "value": "aspBasesOutdatedEventEnable", "defaultValue": false, "helper": "KL.LMS.Helpers.CommonHelper", "helpermethod": "getIsEnabledTxtByBoolVal", "event": "onsettingschange"},
																				{ "title": "LabelTitleSettingsSNMP_Settings_avBasesObsoletedEventEnable", "index": 0, "keyhint": true, "value": "avBasesObsoletedEventEnable", "defaultValue": false, "helper": "KL.LMS.Helpers.CommonHelper", "helpermethod": "getIsEnabledTxtByBoolVal", "event": "onsettingschange"},
																				{ "title": "LabelTitleSettingsSNMP_Settings_avBasesOutdatedEventEnable", "index": 1, "keyhint": true, "value": "avBasesOutdatedEventEnable", "defaultValue": false, "helper": "KL.LMS.Helpers.CommonHelper", "helpermethod": "getIsEnabledTxtByBoolVal", "event": "onsettingschange"}
																			]
																		},
																		{ "type": "KL.LMS.Settings.KeyValueListControl", "id": "trapSuiteSNMPPreview_Backup", "setting": "SNMPSettings", "allowhtml": false, "datafield":"trapSuite","items": [
																				{ "title": "LabelTitleSettingsSNMP_Settings_backupAddErrorEventEnable", "index": 0, "keyhint": true, "value": "backupAddErrorEventEnable", "defaultValue": false, "helper": "KL.LMS.Helpers.CommonHelper", "helpermethod": "getIsEnabledTxtByBoolVal", "event": "onsettingschange"},
																				{ "title": "LabelTitleSettingsSNMP_Settings_backupLimitReachedEventEnable", "index": 1, "keyhint": true, "value": "backupLimitReachedEventEnable", "defaultValue": false, "helper": "KL.LMS.Helpers.CommonHelper", "helpermethod": "getIsEnabledTxtByBoolVal", "event": "onsettingschange"},
																				{ "title": "LabelTitleSettingsSNMP_Settings_backupRotateErrorEventEnable", "index": 0, "keyhint": true, "value": "backupRotateErrorEventEnable", "defaultValue": false, "helper": "KL.LMS.Helpers.CommonHelper", "helpermethod": "getIsEnabledTxtByBoolVal", "event": "onsettingschange"}
																			]
																		},
																		{ "type": "KL.LMS.Settings.KeyValueListControl", "id": "trapSuiteSNMPPreview_License", "setting": "SNMPSettings", "allowhtml": false, "datafield":"trapSuite","items": [
																				{ "title": "LabelTitleSettingsSNMP_Settings_licenseBlacklistedEventEnable", "index": 1, "keyhint": true, "value": "licenseBlacklistedEventEnable", "defaultValue": false, "helper": "KL.LMS.Helpers.CommonHelper", "helpermethod": "getIsEnabledTxtByBoolVal", "event": "onsettingschange"},
																				{ "title": "LabelTitleSettingsSNMP_Settings_licenseExpiredEventEnable", "index": 0, "keyhint": true, "value": "licenseExpiredEventEnable", "defaultValue": false, "helper": "KL.LMS.Helpers.CommonHelper", "helpermethod": "getIsEnabledTxtByBoolVal", "event": "onsettingschange"},
																				{ "title": "LabelTitleSettingsSNMP_Settings_licenseExpiresSoonEventEnable", "index": 1, "keyhint": true, "value": "licenseExpiresSoonEventEnable", "defaultValue": false, "helper": "KL.LMS.Helpers.CommonHelper", "helpermethod": "getIsEnabledTxtByBoolVal", "event": "onsettingschange"},
																				{ "title": "LabelTitleSettingsSNMP_Settings_licenseInstalledEventEnable", "index": 0, "keyhint": true, "value": "licenseInstalledEventEnable", "defaultValue": false, "helper": "KL.LMS.Helpers.CommonHelper", "helpermethod": "getIsEnabledTxtByBoolVal", "event": "onsettingschange"},
																				{ "title": "LabelTitleSettingsSNMP_Settings_licenseRevokedEventEnable", "index": 1, "keyhint": true, "value": "licenseRevokedEventEnable", "defaultValue": false, "helper": "KL.LMS.Helpers.CommonHelper", "helpermethod": "getIsEnabledTxtByBoolVal", "event": "onsettingschange"}
																			]
																		},
																		{ "type": "KL.LMS.Settings.KeyValueListControl", "id": "trapSuiteSNMPPreview_Task", "setting": "SNMPSettings", "allowhtml": false, "datafield":"trapSuite","items": [
																				{ "title": "LabelTitleSettingsSNMP_Settings_taskCrashEventEnable", "index": 0, "keyhint": true, "value": "taskCrashEventEnable", "defaultValue": false, "helper": "KL.LMS.Helpers.CommonHelper", "helpermethod": "getIsEnabledTxtByBoolVal", "event": "onsettingschange"},
																				{ "title": "LabelTitleSettingsSNMP_Settings_taskRestartEventEnable", "index": 1, "keyhint": true, "value": "taskRestartEventEnable", "defaultValue": false, "helper": "KL.LMS.Helpers.CommonHelper", "helpermethod": "getIsEnabledTxtByBoolVal", "event": "onsettingschange"}
																			]
																		},
																		{ "type": "KL.LMS.Settings.KeyValueListControl", "id": "trapSuiteSNMPPreview_Misc", "setting": "SNMPSettings", "allowhtml": false, "datafield":"trapSuite","items": [
																				{ "title": "LabelTitleSettingsSNMP_Settings_productStartEventEnable", "index": 0, "keyhint": true, "value": "productStartEventEnable", "defaultValue": false, "helper": "KL.LMS.Helpers.CommonHelper", "helpermethod": "getIsEnabledTxtByBoolVal", "event": "onsettingschange"},
																				{ "title": "LabelTitleSettingsSNMP_Settings_threatDetectedEventEnable", "index": 1, "keyhint": true, "value": "threatDetectedEventEnable", "defaultValue": false, "helper": "KL.LMS.Helpers.CommonHelper", "helpermethod": "getIsEnabledTxtByBoolVal", "event": "onsettingschange"}
																			]
																		},
																		{ "type": "KL.LMS.Settings.KeyValueListControl", "id": "trapSuiteSNMPPreview_BasesError", "setting": "SNMPSettings", "allowhtml": false, "datafield":"trapSuite","items": [
																				{ "title": "LabelTitleSettingsSNMP_Settings_antiSpamErrorEventEnable", "index": 0, "keyhint": true, "value": "antiSpamErrorEventEnable", "defaultValue": false, "helper": "KL.LMS.Helpers.CommonHelper", "helpermethod": "getIsEnabledTxtByBoolVal", "event": "onsettingschange"},
																				{ "title": "LabelTitleSettingsSNMP_Settings_antiVirusErrorEventEnable", "index": 1, "keyhint": true, "value": "antiVirusErrorEventEnable", "defaultValue": false, "helper": "KL.LMS.Helpers.CommonHelper", "helpermethod": "getIsEnabledTxtByBoolVal", "event": "onsettingschange"}
																		]
																		},
																		{ "type": "KL.LMS.Settings.KeyValueListControl", "id": "trapSuiteSNMPPreview_ExternalServiceError", "setting": "SNMPSettings", "allowhtml": false, "datafield":"trapSuite","items": [
																				{ "title": "LabelTitleSettingsSNMP_Settings_authCommunicationErrorEventEnable", "index": 0, "keyhint": true, "value": "externalDirectoryServiceErrorEventEnable", "defaultValue": false, "helper": "KL.LMS.Helpers.CommonHelper", "helpermethod": "getIsEnabledTxtByBoolVal", "event": "onsettingschange"},
																				{ "title": "LabelTitleSettingsSNMP_Settings_authCommunicationUpEventEnable", "index": 1, "keyhint": true, "value": "externalDirectoryServiceUpEventEnable", "defaultValue": false, "helper": "KL.LMS.Helpers.CommonHelper", "helpermethod": "getIsEnabledTxtByBoolVal", "event": "onsettingschange"}
																			]
																		}
																	]
																}
															]
														}
													]
												},
												{ "type": "KL.Web.Controls.TabPanel", "id": "pnlSettingsProtection", "elements": [
														{ "id": "pnlProtectionSettingsContent", "titletext": "LabelTitleSettingsPanelProtection", "type": "KL.Web.Controls.TitledPanel", "elements": [
																{ "id": "ksnProtectionSettings", "titletext": "LabelSettingsProtectionPreviewTitleKsn", "type": "KL.LMS.Settings.SettingsPreviewPanel", "setting": "ProtectionKsnSettings", "elements": [
																		{ "type": "KL.LMS.Settings.KeyValueListControl", "id": "ksnProtectionPreview", "setting": "ProtectionKsnSettings", "allowhtml": false, "items": [
																				{ "title": "LabelSettingsProtectionPreviewKsnEula", "index": 0, "value": "ksnParticipationActivated", "defaultValue": false, "helper": "KL.LMS.Helpers.CommonHelper", "helpermethod": "getIsLicenseAccteptedText", "event": "onsettingschange" }
																			]
																		},
																		{ "type": "KL.LMS.Settings.KeyValueListControl", "id": "ksnProtectionPreview1", "setting": "ProtectionSettings", "allowhtml": false, "items": [
																				{ "title": "LabelSettingsProtectionPreviewAsKsnTimeout", "index": 1, "value": "scanLogic.ksnTimeout", "defaultValue": 0, "helper": "KL.LMS.Helpers.SettingsHelper", "helpermethod": "getNoLongerText", "event": "onsettingschange" }
																			]
																		}
																	]
																},
																{ "id": "avProtectionSettings", "titletext": "LabelSettingsProtectionPreviewTitleAv", "type": "KL.LMS.Settings.ToggleableSettingsPreviewPanel", "setting": "ProtectionSettings",
																	"toggledatafield": "scanLogic.avSettings.enableAvScan",
																	"editable": { "helper": "KL.LMS.Helpers.SettingsHelper", "method": "isAvSettingsActive", "warningmessage": "getAvSettingsInactiveReasonMessage" },
																	"elements": [
																		{ "type": "KL.LMS.Settings.KeyValueListControl", "id": "avProtectionPreview", "setting": "ProtectionSettings",  "allowhtml": false, "items": [
																				{ "title": "LabelSettingsProtectionPreviewAvHeuristic", "index": 0, "value": "scanLogic.avSettings.useAnalyzer", "defaultValue": false, "helper": "KL.LMS.Helpers.CommonHelper", "helpermethod": "getIsEnabledTxtByBoolVal", "event": "onsettingschange" },
																				{ "title": "LabelSettingsProtectionPreviewAvHaLevel", "index": 1, "value": "scanLogic.avSettings.heuristicLevel", "defaultValue": 2, "helper": "KL.LMS.Helpers.SettingsHelper", "helpermethod": "getHaLevelText", "event": "onsettingschange" },
																				{ "title": "LabelSettingsProtectionPreviewAvMaxScanTime", "index": 0, "value": "scanLogic.avSettings.scanTimeLimit", "defaultValue": 0, "helper": "KL.LMS.Helpers.SettingsHelper", "helpermethod": "getSecondsNumText", "event": "onsettingschange" },
																				{ "title": "LabelSettingsProtectionPreviewAvMaxNestingLvl", "index": 1, "value": "scanLogic.avSettings.maxNestingLevel", "defaultValue": 0, "event": "onsettingschange" }
																		]
																		}
																	]
																},
																{ "id": "asProtectionSettings", "titletext": "LabelSettingsProtectionPreviewTitleAs", "type": "KL.LMS.Settings.ToggleableSettingsPreviewPanel", "setting": "ProtectionSettings",
																	"toggledatafield": "scanLogic.asSettings.enableAsScan",
																	"editable": { "helper": "KL.LMS.Helpers.SettingsHelper", "method": "isAsSettingsActive", "warningmessage": "getAsSettingsInactiveReasonMessage" },
																	"elements": [
																		{ "type": "KL.LMS.Settings.KeyValueListControl", "id": "asProtectionPreview", "setting": "ProtectionSettings", "allowhtml": false, "items": [
																				{ "title": "LabelSettingsProtectionPreviewAsDnsTimeout", "index": 0, "value": "scanLogic.asSettings.externalServices.dnsTimeout", "defaultValue": 0, "helper": "KL.LMS.Helpers.SettingsHelper", "helpermethod": "getNoLongerText", "event": "onsettingschange" },
																				{ "title": "LabelSettingsProtectionPreviewAsUseKsn", "index": 1, "value": "scanLogic.asSettings.useKsnStatus", "defaultValue": false, "helper": "KL.LMS.Helpers.CommonHelper", "helpermethod": "getIsEnabledTxtByBoolVal", "event": "onsettingschange" },
																				{ "title": "LabelSettingsProtectionPreviewAsUseAUS", "index": 0, "value": "scanLogic.asSettings.useEnforcedAntiSpamUpdatesService", "defaultValue": false, "helper": "KL.LMS.Helpers.CommonHelper", "helpermethod": "getIsEnabledTxtByBoolVal", "event": "onsettingschange" },
																				{ "title": "LabelSettingsProtectionPreviewAsUseRates", "index": 1, "value": "scanLogic.asSettings.enableReputationFiltering", "defaultValue": false, "helper": "KL.LMS.Helpers.CommonHelper", "helpermethod": "getIsEnabledTxtByBoolVal", "event": "onsettingschange" },
																				{ "title": "LabelSettingsProtectionPreviewAsScanTimeout", "index": 0, "value": "scanLogic.asSettings.scanTimeLimit", "defaultValue": 0, "helper": "KL.LMS.Helpers.SettingsHelper", "helpermethod": "getSecondsNumText", "event": "onsettingschange" },
																				{ "title": "LabelSettingsProtectionPreviewDNSBL", "index": 1, "value": "scanLogic.asSettings.externalServices.dnsblList", "defaultValue": null, "helper": "KL.LMS.Helpers.SettingsHelper", "helpermethod": "getListValueText", "event": "ondnsblchange", "clickparams": ["scanLogic.asSettings.externalServices.dnsblList"] },
																				{ "title": "LabelSettingsProtectionPreviewSURBL", "index": 0, "value": "scanLogic.asSettings.externalServices.surblList", "defaultValue": null, "helper": "KL.LMS.Helpers.SettingsHelper", "helpermethod": "getListValueText", "event": "onsurblchange", "clickparams": ["scanLogic.asSettings.externalServices.surblList"] }
																		]
																		}
																	]
																},
																{ "id": "afProtectionSettings", "titletext": "LabelSettingsProtectionPreviewTitleAp", "type": "KL.LMS.Settings.ToggleableSettingsPreviewPanel", "setting": "ProtectionSettings",
																	"toggledatafield": "scanLogic.apSettings.enableApScan",
																	"editable": { "helper": "KL.LMS.Helpers.SettingsHelper", "method": "isAfSettingsActive", "warningmessage": "getApSettingsInactiveReasonMessage" },
																	"elements": [
																		{ "type": "KL.LMS.Settings.KeyValueListControl", "id": "afProtectionPreview", "setting": "ProtectionSettings", "allowhtml": false, "items": [
																				{ "title": "LabelSettingsProtectionPreviewApUseHeuristics", "index": 0, "value": "scanLogic.apSettings.enableHeuristic", "defaultValue": false, "helper": "KL.LMS.Helpers.CommonHelper", "helpermethod": "getIsEnabledTxtByBoolVal", "event": "onsettingschange" },
																				{ "title": "LabelSettingsProtectionPreviewApMaxCheckTime", "index": 1, "value": "scanLogic.apSettings.scanTimeLimit", "defaultValue": 0, "helper": "KL.LMS.Helpers.SettingsHelper", "helpermethod": "getSecondsNumText", "event": "onsettingschange" },
																				{ "title": "LabelSettingsProtectionPreviewApUseKsn", "index": 0, "value": "scanLogic.apSettings.useKsnStatus", "defaultValue": false, "helper": "KL.LMS.Helpers.CommonHelper", "helpermethod": "getIsEnabledTxtByBoolVal", "event": "onsettingschange" }
																			]
																		}
																	]
																},
																{ "id": "cfProtectionSettings", "titletext": "LabelSettingsProtectionPreviewTitleCf", "type": "KL.LMS.Settings.ToggleableSettingsPreviewPanel", "setting": "ProtectionSettings",
																	"toggledatafield": "scanLogic.cfSettings.enableCfScan",
																	"editable": { "helper": "KL.LMS.Helpers.SettingsHelper", "method": "isCfSettingsActive", "warningmessage": "getCfSettingsInactiveReasonMessage" },
																	"elements": [
																		{ "type": "KL.Web.Controls.KeyValueListControl", "setting": "ProtectionSettings", "allowhtml": false, "items": [
																				{ "title": "LabelSettingsProtectionPreviewCfEnabled", "index": 0, "value": "scanLogic.cfSettings.enableCfScan", "cssclass": "nonEditableItem", "defaultValue": false, "helper": "KL.LMS.Helpers.CommonHelper", "helpermethod": "getIsEnabledTxtByBoolVal", "event": "onsettingschange" }
																			]
																		}
																	]
																},
																{ "id": "blProtectionSettings", "titletext": "LabelSettingsProtectionPreviewTitleBL", "type": "KL.LMS.Settings.SettingsPreviewPanel", "setting": "ProtectionSettings",
																	"elements": [
																		{ "type": "KL.LMS.Settings.KeyValueListControl", "id": "blProtectionPreview", "setting": "ProtectionSettings", "allowhtml": false, "items": [
																				{ "title": "LabelSettingsProtectionPreviewBlAction", "index": 0, "value": "scanLogic.personalBlacklistAction", "defaultValue": 0, "helper": "KL.LMS.Helpers.SettingsHelper", "helpermethod": "getBlActionText", "event": "onsettingschange" },
																				{ "title": "LabelSettingsProtectionPreviewBlEnabled", "index": 1, "value": "scanLogic.backupPersonalBlacklist", "defaultValue": false, "helper": "KL.LMS.Helpers.CommonHelper", "helpermethod": "getIsEnabledTxtByBoolVal", "event": "onsettingschange" }
																			]
																		}
																	]
																}
															]
														}
												]
												},
												
												{ "type": "KL.Web.Controls.TabPanel", "id": "pnlSettingsMisc", "elements": [
														{ "id": "pnlMiscSettingsContent", "titletext": "LabelTitleSettingsPanelMisc", "type": "KL.Web.Controls.TitledPanel", "elements": [
																{ "id": "AppProxySettings", "titletext": "LabelSettingsPanelUpdate_PanelProxy", "type": "KL.LMS.Settings.ToggleableSettingsPreviewPanel", "helptext": "LabelMiscTooltip_ProxySettingsCanBeOpenedHere" ,"setting": "AppMiscSettings",
																	"toggledatafield": "proxySettings.enable",
																	"elements": [
																		{ "type": "KL.LMS.Settings.KeyValueListControl", "id": "ProxySettingsPreview", "datafield": "proxySettings", "setting": "AppMiscSettings", "allowhtml": false, "items": [
																				{ "title": "LabelSettingsPanelUpdate_Address", "index": 0, "value": "serverAddress", "defaultValue": "", "helper": "KL.LMS.Helpers.UpdateSettingsHelper", "helpermethod": "getAddress","event": "oncnnchange" },
																				{ "title": "LabelSettingsDialogUpdate_BypassLocalAddresses", "index": 1, "value": "proxyBypassLocalAddresses", "defaultValue": true, "helper": "KL.LMS.Helpers.UpdateSettingsHelper", "helpermethod": "getFtpPassiveStatus", "event": "oncnnchange" }
																			]
																		}
																	]
																},
																{ "id": "miscSettingsEMail", "titletext": "LabelTitleSettingsMisc_EMails", "type": "KL.LMS.Settings.SettingsPreviewPanel", "elements": [
																		{ "type": "KL.LMS.Settings.KeyValueListControl", "id": "miscSettingsPreviewEMail", "setting": "AppMiscSettings", "allowhtml": false, "items": [
																				{ "title": "LabelTitleSettingsMisc_EMails_Product", "index": 0, "value": "replyEmailAddress", "defaultValue": "",  "helper": "KL.LMS.Helpers.UpdateSettingsHelper", "helpermethod": "getAddress","event": "onproductmailchange" },
																				{ "title": "LabelTitleSettingsMisc_EMails_Admins", "index": 1, "value": "adminEmailAddresses", "defaultValue": "", "helper": "KL.LMS.Helpers.UpdateSettingsHelper", "helpermethod": "getAdminAddress","event": "onadminmailchange" }
																			]
																		}
																	]
																},
																{ "id": "miscSettingsHelpdesk", "titletext": "LabelTitleSettingsMisk_Helpdesk", "type": "KL.LMS.Settings.ToggleableSettingsPreviewPanel", "setting": "AppMiscSettings",
																	"toggledatafield": "helpdeskSettings.enable",
																	"elements": [
																		{ "type": "KL.LMS.Settings.KeyValueListControl", "id": "miscHelpdeskPreview", "setting": "HelpdeskSettings", "allowhtml": false, "items": [
																				{ "title": "LabelSettingsMisk_HelpdeskName", "index": 0, "value": "userName", "defaultValue": "", "event": "onsettingschange", "helper": "KL.Utils.UserHelper", "helpermethod":"getHelpDeskUserName" }
																			]
																		},
																		{ "type": "KL.LMS.Settings.KeyValueListControl", "id": "miscHelpdeskBWlEditPreview", "setting": "AppMiscSettings", "allowhtml": false, "items": [
																				{ "title": "LabelSettingsMisk_HelpdeskCanEditBWL", "index": 1, "value": "helpdeskSettings.accessBlackWhiteList", "defaultValue": false, "helptext": "LabelGeneralSettingsBWListsHelpdeskTooltip", "helper": "KL.LMS.Helpers.CommonHelper", "helpermethod": "getIsEnabledTxtByBoolVal", "event": "onsettingschange" }
																			]
																		},
																		{ "type": "KL.LMS.Settings.KeyValueListControl", "id": "miscHelpdeskBackupPreview", "setting": "HelpdeskBackupSettings", "allowhtml": false, "items": [
																				{ "title": "LabelSettingsMisk_HelpdeskCanForvardMalware", "index": 0, "value": "allowAvThreatsRestoration", "defaultValue": false, "helper": "KL.LMS.Helpers.CommonHelper", "helpermethod": "getIsEnabledTxtByBoolVal", "event": "onsettingschange" }
																			]
																		}
																	]
																},
																{ "id": "miscSettingsEventLogger", "titletext": "LabelTitleSettingsMisc_EventLogger", "type": "KL.LMS.Settings.SettingsPreviewPanel", "elements": [
																		{ "type": "KL.LMS.Settings.KeyValueListControl", "id": "miscSettingsPreviewEventLogger", "setting": "EventLoggerSettings", "allowhtml": false, "items": [
																				{ "title": "LabelTitleSettingsMisc_EventLogger_SendFacility", "index": 0, "value": "facility", "defaultValue": 0, "helper": "KL.LMS.Helpers.SettingsHelper", "helpermethod": "getEvenrLoggerFacilityText", "event": "onsettingschange" },
																				{ "title": "LabelTitleSettingsMisc_EventLogger_ErrorLevel", "index": 1, "value": "logLevel", "defaultValue": 0, "helper": "KL.LMS.Helpers.SettingsHelper", "helpermethod": "getEvenrLoggerLevelText", "event": "onsettingschange" }
																			]
																		}
																	]
																},
																{ "id": "miscSettingsPerformance", "titletext": "LabelTitleSettingsMisc_Performance", "type": "KL.LMS.Settings.SettingsPreviewPanel", "elements": [
																		{ "type": "KL.LMS.Settings.KeyValueListControl", "id": "miscSettingsPreviewPerformance", "setting": "ScanLogicSettings", "datafield": "scanLogic","allowhtml": false, "items": [
																			{ "title": "LabelTitleSettingsMisc_Performance_NumberScan", "index": 0, "value": "scanThreads", "defaultValue": 0,  "event": "onsettingschange" }
																			]
																		}
																	]
																},
																{ "id": "miscSettingsHeaderMarks", "titletext": "LabelTitleSettingsMisc_HeaderMarks", "type": "KL.LMS.Settings.SettingsPreviewPanel", "elements": [
																		{ "type": "KL.LMS.Settings.KeyValueListControl", "id": "miscSettingsPreviewHeaderMarks", "setting": "ScanLogicSettings", "datafield": "scanLogic","allowhtml": false, "items": [
																				{ "title": "LabelTitleSettingsMisc_HeaderMarks_Add", "index": 0, "value": "addXHeaders", "defaultValue": false, "helper": "KL.LMS.Helpers.CommonHelper", "helpermethod": "getIsEnabledTxtByBoolVal", "event": "onsettingschange" }
																			]
																		}
																	]
																},
																{ "id": "miscSettingsPlaceholder", "titletext": "LabelTitleSettingsMisc_Placeholder", "type": "KL.LMS.Settings.SettingsPreviewPanel", "elements": [
																		{ "type": "KL.LMS.Settings.KeyValueListControl", "id": "miscSettingsPreviewPlaceholder", "setting": "ScanLogicSettings", "datafield": "scanLogic", "allowhtml": false, "items": [
																				{ "title": "LabelTitleSettingsMisc_Placeholder_DeletedAttachment", "index": 0, "value": "deletedAttachmentPlaceholder", "defaultValue": "",  "event": "onsettingschange" }
																			]
																		}
																	]
																},
																{ "id": "miscSettingsImportExport", "titletext": "LabelTitleSettingsMiscImportExport", "type": "KL.LMS.Settings.SettingsPreviewPanel", "elements": [
																		{ "type": "KL.LMS.Settings.KeyValueListControl", "id": "miscSettingsPreviewImportExport", "setting": "AppMiscSettings", "allowhtml": true, "items": [
																				{ "title": "LabelTitleSettingsMiscExportSettings", "index": 0, "value": "null", "defaultValue": "LabelTitleSettingsMiscExportSettingsDescr",  "event": "onexportsettings" },
																				{ "title": "LabelTitleSettingsMiscImportSettings", "index": 1, "value": "null", "defaultValue": "LabelTitleSettingsMiscImportSettingsDescr",  "event": "onimportsettings" },
																				{ "title": "LabelTitleSettingsMiscRestart", "index": 0, "value": "null", "defaultValue": "LabelTitleSettingsMiscRestartDescr",  "event": "onrestartproduct" }
																			]
																		}
																	]
																},
																{ "id": "miscSettingsScIntegration", "titletext": "LabelTitleSettingsMiscSCIntegration", "type": "KL.LMS.Settings.SettingsPreviewPanel", "elements": [
																		{ "type": "KL.LMS.Settings.KeyValueListControl", "id": "miscSettingsPreviewScIntegration", "setting": "AppMiscSettings", "allowhtml": false, "items": [
																				{ "title": "LabelSettingsMiscSCClusterId", "index": 0, "value": "securityCenterClusterID", "defaultValue": "",  "event": "onsettingschange", "helper": "KL.LMS.Helpers.SettingsHelper", "helpermethod": "getIsDefinedStr" }
																			]
																		}
																	]
																}
															]
														}
													]
												}
											]
										}
									]
								}
							]
						}
					]
				}
			]
		}
	],
	"settings":
		[
			{ "name": "GroupsList", "type": "List" },
			{ "name": "GroupSettings", "type": "List" },
			{ "name": "BackupList", "type": "List" },
			{ "name": "ReportsList", "type": "List" },
			{ "name": "ReportSettings", "type": "List" },
			{ "name": "BackupSetting", "type": "List" },
			{ "name": "UpdateSettings", "type": "List" },
			{ "name": "UpdateProxySettings", "type": "List" },
			{ "name": "LdapSetting", "type": "List" },
			{ "name": "BackupSettings", "type": "List" },
			{ "name": "NotificationsSetting", "type": "List" },
			{ "name": "AppNotificationsSetting", "type": "List" },
			{ "name": "ProtectionSettings", "type": "List" },
			{ "name": "ProtectionKsnSettings", "type": "Text" },
			{ "name": "ScanLogicSettings", "type": "List" },
			{ "name": "BlackListSetting", "type": "List" },
			{ "name": "LicensesInfoSetting", "type": "List"},
			{ "name": "UpdateStateSettings", "type": "List"},
			{ "name": "SNMPSettings", "type": "List"},
			{ "name": "NotificationsLicenserSettings", "type": "List"},
			{ "name": "AppMiscSettings", "type": "List"},
			{ "name": "EventLoggerSettings", "type": "List"},
			{ "name": "HelpdeskSettings", "type": "List"},
			{ "name": "HelpdeskAppSettings", "type": "List"},
			{ "name": "HelpdeskBackupSettings", "type": "List"}
		],
	"dependencies":
		[
			{ "sender": "contextChangeAdapter", "event": "onlicensechanged", "type": "control", "receivers":[
					{ "id": ["GroupSettingsEditor", "avProtectionSettings", "asProtectionSettings", "afProtectionSettings"], "page": "mainPage", "action": "notifyLicenseChange", "type": "control" }
				]
			},
			{"sender": "loginForm", "event": "onformsubmit", "type": "control", "receivers": [
					{ "id": "signupQuery", "action": "loadData", "type": "query" }
				]
			},
			{ "sender": "signupQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "loginForm", "page": "signupPage", "action": "applyValue", "type": "control" }
				]
			},
			{ "sender": "signupQuery", "event": "onerror", "type": "query", "receivers": [
					{ "id": "loginForm", "page": "signupPage", "action": "applyError", "type": "control" }
			]
			},
			{ "sender": "signoutLink", "type": "control", "event": "onclick", "receivers": [
					{ "id": "signoutQuery", "action": "loadData", "type": "query" }
				]
			},
			{ "sender": "infoLink", "type": "control", "event": "onclick", "receivers": [
					{ "id": "GetAppInfoQuery", "action": "loadData", "type": "query" }
			]
			},
			{ "sender": "GetAppInfoQuery", "type": "query", "event": "onsuccess", "receivers": [
					{ "id": "aboutDialogForm", "page": "aboutDialogView", "action": "applyValue", "type": "control" },
					{ "id": "aboutDialogView", "page": "aboutDialogView", "action": "showDialog", "type": "page" }
				]
			},
			{ "sender": "mainLicenseLink", "type": "control", "event": "onlicenseopen", "receivers": [
					{ "id": "LicensesDialog", "page": "LicensesDialog", "action": "showDialog", "type": "page" },
					{ "id": "getLicenseQuery", "action": "loadData", "type": "query" }
				]
			},
			{ "sender": "mainLicenseLink", "type": "control", "event": "onshow", "receivers": [
					{ "id": "headerGetLicenseQuery", "action": "loadData", "type": "query" }
				]
			},
			{"sender": ["headerGetLicenseQuery", "getLicenseQuery"], "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "mainLicenseLink", "page": "mainPage", "action": "applyText", "type": "control" }
				]
			},
			{"sender": ["headerGetLicenseQuery", "getLicenseQuery"], "event": "onerror", "type": "query", "receivers": [
					{ "id": "mainLicenseLink", "page": "mainPage", "action": "applyError", "type": "control" }
				]
			},
			
			{ "sender": "licensesEditForm", "type": "control", "event": "onlicenseloaded", "receivers": [
					{ "id": "getLicensesInfoQuery", "action": "loadData", "type": "query" }
				]
			},
			{ "sender": "getLicenseQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "licensesEditForm", "page": "LicensesDialog", "action": "applyLicenseInfo", "type": "control" }
				]
			},
			{"sender": "getLicensesInfoQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "licensesEditForm", "page": "LicensesDialog", "action": "applyValue", "type": "control" }
				]
			},
			{"sender": ["revokeLicenseKeyQuery","uploadLicenseKeyQuery"], "event": "onerror", "type": "query", "receivers": [
					{ "id": "licensesEditForm", "page": "LicensesDialog", "action": "applyError", "type": "control" }
				]
			},
			{"sender": "getLicenseQuery", "event": "onerror", "type": "query", "receivers": [
					{ "id": "licensesEditForm", "page": "LicensesDialog", "action": "applyEmptyLicenseInfo", "type": "control" }
				]
			},
			{ "sender": "licensesEditForm", "type": "control", "event": "onkeyupload", "receivers": [
					{ "id": "uploadLicenseKeyQuery", "action": "uploadData", "type": "query" }
				]
			},
			{ "sender": "licensesEditForm", "type": "control", "event": "onkeychanged", "receivers": [
					{ "id": "getLicenseQuery", "action": "loadData", "type": "query" }
				]
			},
			{ "sender": ["revokeLicenseKeyQuery","uploadLicenseKeyQuery"], "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "licensesEditForm", "page": "LicensesDialog", "action": "keyChangeComplete", "type": "control" }
				]
			},
			{ "sender": "licensesEditForm", "type": "control", "event": "onlicensedelete", "receivers": [
					{ "id": "revokeLicenseKeyQuery", "action": "loadData", "type": "query" }
				]
			},
			{ "sender": "signoutQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "loginForm", "page": "signupPage", "action": "signOut", "type": "control" }
				]
			},
			{"sender": "changePasswdLinkBtn", "type": "control", "event": "onclick", "receivers": [
					{ "id": "changePasswdDialog", "page": "changePasswdDialog", "action": "showDialog", "type": "page" }
			]
			},
			{"sender": "chPasswdForm", "type": "control", "event": "oncancel", "receivers": [
					{ "id": "changePasswdDialog", "page": "changePasswdDialog", "action": "closeDialog", "type": "page" }
			]
			},
			{"sender": "chPasswdForm", "event": "onformsubmit", "type": "control", "receivers": [
					{ "id": "changeAdminPasswordQuery", "action": "loadData", "type": "query" }
			]
			},
			{ "sender": "changeAdminPasswordQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "changePasswdDialog", "page": "changePasswdDialog", "action": "closeDialog", "type": "page" }
			]
			},
			{ "sender": "changeAdminPasswordQuery", "event": "onerror", "type": "query", "receivers": [
					{ "id": "changePasswdDialog", "page": "changePasswdDialog", "action": "applyError", "type": "control" }
			]
			},
			{"sender": "serverTimeLabel", "event": "onshow", "type": "control", "receivers": [
					{ "id": "serverTimeLabel", "page": "mainPage", "action": "applyText", "type": "control" }
				]
			},
			{"sender": "serverTimeLabel", "event": "onhide", "type": "control", "receivers": [
					{ "id": "getServerTime", "action": "stopTimeout", "type": "query" }
				]
			},
			{"sender": "serverNameLabel", "event": "onshow", "type": "control", "receivers": [
					{ "id": "getServerName", "action": "loadData", "type": "query" }
				]
			},
			{ "sender": "getServerName", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "serverNameLabel", "page": "mainPage", "action": "applyText", "type": "control" }
				]
			},
			
			{ "sender": "dashboard", "event": "onshow", "type": "control", "receivers": [
					{ "id": ["dashboardAvQuery", "dashboardApQuery", "dashboardAsQuery", "dashboardBackupQuery", "dashboardLdapSettingsQuery"], "action": "loadData", "type": "query" }
				]
			},
			{ "sender": "dashboard", "event": "onasinforeload", "type": "control", "receivers": [
					{ "id": "dashboardAsQuery", "action": ["stopTimeout","loadData"], "type": "query" }
				]
			},
			{ "sender": "dashboard", "event": "onavinforeload", "type": "control", "receivers": [
					{ "id": "dashboardAvQuery", "action": ["stopTimeout","loadData"], "type": "query" }
				]
			},
			{ "sender": "dashboard", "event": "onapinforeload", "type": "control", "receivers": [
					{ "id": "dashboardApQuery", "action": ["stopTimeout","loadData"], "type": "query" }
				]
			},
			{ "sender": "dashboard", "event": "onldapinfoloaded", "type": "control", "receivers": [
					{ "id": "dashboardLdapQuery", "action": "loadData", "type": "query" }
				]
			},
			{ "sender": "dashboard", "event": "onldapenter", "type": "control", "receivers": [
					{ "id": "topNav", "page": "mainPage", "action": "openPanel", "type": "control", "args": ["SettingsPagePanel"] },
					{ "id": "settingsSubNav", "page": "mainPage", "action": "openPanel", "type": "control", "args": ["pnlSettingsLDAP"] }
				]
			},
			{ "sender": "dashboard", "event": "onusageenter", "type": "control", "receivers": [
					{ "id": "topNav", "page": "mainPage", "action": "openPanel", "type": "control", "args": ["SettingsPagePanel"] },
					{ "id": "settingsSubNav", "page": "mainPage", "action": "openPanel", "type": "control", "args": ["pnlSettingsBackup"] }
				]
			},
			{ "sender": "dashboard", "event": "onstorageenter", "type": "control", "receivers": [
					{ "id": "topNav", "page": "mainPage", "action": "openPanel", "type": "control", "args": ["BackupPagePanel"] }
				]
			},
			{"sender": "dashboard", "event": "onfilterchange", "type": "control", "receivers": [
					{ "id": "dashboardLoadThreatsQuery", "action": "stopTimeout", "type": "query" },
					{ "id": "dashboardStatsQuery", "action": "loadData", "type": "query" }
				]
			},
			{ "sender": "dashboard", "event": "onhide", "type": "control", "receivers": [
					{ "id": ["dashboardAvQuery", "dashboardApQuery", "dashboardAsQuery", "dashboardBackupQuery", "dashboardLdapSettingsQuery", "dashboardLoadThreatsQuery"], "action": "stopTimeout", "type": "query" }
				]
			},
			{ "sender": "dashboard", "event": "onloadthreats", "type": "control", "receivers": [
					{ "id": "dashboardLoadThreatsQuery", "action": ["stopTimeout","loadData"], "type": "query" }
				]
			},
			{ "sender": "dashboardLoadThreatsQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "dashboard", "page": "mainPage", "action": "applyThreatsData", "type": "control" }
				]
			},
			{ "sender": "dashboard", "event": "onthreatinfo", "type": "control", "receivers": [
					{ "id": "threatInfoTooltipForm", "action": ["setButtonClose","showTooltip"], "type": "control", "page": "mainPage" },
					{ "id": "threatInfoPanel", "action": "applyInfo", "type": "control", "page": "mainPage" }
				]
			},
			{ "sender": "dashboardAvQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "dashboard", "page": "mainPage", "action": "applyAvStats", "type": "control" }
				]
			},
			{ "sender": "dashboardAvQuery", "event": "onerror", "type": "query", "receivers": [
					{ "id": "dashboard", "page": "mainPage", "action": "applyAvError", "type": "control" }
				]
			},
			{ "sender": "dashboardApQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "dashboard", "page": "mainPage", "action": "applyApStats", "type": "control" }
				]
			},
			{ "sender": "dashboardApQuery", "event": "onerror", "type": "query", "receivers": [
					{ "id": "dashboard", "page": "mainPage", "action": "applyApError", "type": "control" }
				]
			},
			{ "sender": "dashboardAsQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "dashboard", "page": "mainPage", "action": "applyAsStats", "type": "control" }
				]
			},
			{ "sender": "dashboardAsQuery", "event": "onerror", "type": "query", "receivers": [
					{ "id": "dashboard", "page": "mainPage", "action": "applyAsError", "type": "control" }
				]
			},
			{ "sender": "dashboardLdapSettingsQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "dashboard", "page": "mainPage", "action": "applyLdapStats", "type": "control" }
				]
			},
			{ "sender": "dashboardLdapQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "dashboard", "page": "mainPage", "action": "setLdapConnected", "type": "control" }
				]
			},
			{ "sender": "dashboardLdapQuery", "event": "onerror", "type": "query", "receivers": [
					{ "id": "dashboard", "page": "mainPage", "action": "setLdapDisconnected", "type": "control" }
				]
			},
			{ "sender": "dashboardBackupQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "dashboard", "page": "mainPage", "action": "applyBackupStats", "type": "control" }
				]
			},
			{ "sender": "dashboardBackupQuery", "event": "onerror", "type": "query", "receivers": [
					{ "id": "dashboard", "page": "mainPage", "action": "applyBackupStatsError", "type": "control" }
				]
			},
			{ "sender": "dashboardStatsQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "dashboard", "page": "mainPage", "action": "applyStatsData", "type": "control" }
				]
			},
			
			{"sender": "GroupsPagePanel", "event": "onshow", "type": "control", "receivers": [
					{ "id": "GroupViewEditPage", "page": "mainPage", "action": "hide", "type": "control" }
				]
			},
			{"sender": "GroupsPagePanel", "event": "onbeforehide", "type": "control", "receivers": [
					{ "id": "GroupSettingsEditor", "page": "mainPage", "action": "setResumeEvent", "type": "control" }
				]
			},
			{"sender": "GroupsSearchPage", "event": ["onshow", "onsetvisible"], "type": "control", "receivers": [
					{ "id": "GroupViewEditPage", "page": "mainPage", "action": "hide", "type": "control" }
				]
			},
			{ "sender": "btnBackToGroupList", "event": "onclick", "type": "control", "receivers": [
					{ "id": "GroupSettingsEditor", "page": "mainPage", "action": "trySetInvisible", "type": "control" }
					
				]
			},
			
			{ "sender": "GroupSettingsEditor", "event": "oneditorpanelhide", "type": "control", "receivers": [
					{ "id": ["antiSpamParamsSettingsItem", "antiVirusParamsSettingsItem", "cfParamsSettingsItem", "antiPhishingParamsSettingsItem", "notificationParamsSettingsItem"], "page": "mainPage", "action": "setInvisible", "type": "control" }
				]
			},
			{ "sender": "GroupSettingsEditor", "event": "oneditorpanelshow", "type": "control", "receivers": [
					{ "id": ["antiSpamParamsSettingsItem", "antiVirusParamsSettingsItem", "cfParamsSettingsItem", "antiPhishingParamsSettingsItem", "notificationParamsSettingsItem"], "page": "mainPage", "action": "setVisible", "type": "control" }
				]
			},
			
			
			{ "sender": "GroupSettingsEditor", "event": "oneditorclosereset", "type": "control", "receivers": [
					
					{ "id": "GroupsGridControl", "action": "resetData", "type": "control" },
					{ "id": "GroupsSearchPage", "page": "mainPage", "action": "setVisible", "type": "control" },
					{ "id": "GroupsListLoadQuery", "action": "loadData", "type": "query" }
			]
			},
			{ "sender": ["btnCopy_GroupsTop", "btnCopy_GroupsBottom"], "event": "onclick", "type": "control", "receivers": [
					{ "id": "GroupsGridControl", "page": "mainPage", "action": "showLoading", "type": "control", "args": ["btnCopy_GroupsTop_btnCopy_GroupsBottom.onclick"] },
					{ "id": "GroupSettingsEditor", "page": "mainPage", "action": "setMode", "args": ["copy"], "type": "control" },
					{ "id": "GroupSettingLoadQuery", "action": "loadData", "type": "query" }
			]
			},
			{ "sender": "GroupSettingLoadQuery", "event": "onsuccess", "type": "query", "receivers":
				[
					{ "id": "GroupViewEditPage", "page": "mainPage", "action": "show", "type": "control" },
					{ "id": "GroupsSearchPage", "page": "mainPage", "action": "setInvisible", "type": "control" },
					{ "id": "GroupSettingsEditor", "page": "mainPage", "action": "applyValue", "type": "control" }
				]
			},
			{ "sender": ["btnCreate_GroupsTop", "btnCreate_GroupsBottom"], "event": "onclick", "type": "control", "receivers": [
					{ "id": "GroupSettingDefaultLoadQuery", "action": "loadData", "type": "query" }
				]
			},
			
			{ "sender": ["btnDelete_GroupsTop", "btnDelete_GroupsBottom"], "event": "onclick", "type": "control", "receivers": [
					{ "id": "GroupsGridControl", "action": "deleteRows", "type": "control" }
				]
			},
			{ "sender": "GroupsGridControl", "event": "onrowsdelete", "type": "control", "receivers": [
					{ "id": "GroupsGridControl", "action": "showLoading", "type": "control" },
					{ "id": "DeleteGroupQuery", "action": "loadData", "type": "query" }
				]
			},
			
			{ "sender": ["DeleteGroupQuery","GroupSetActive"], "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "GroupsGridControl", "action": "hideLoading", "type": "control" },
					{ "id": "GroupsGridControl", "action": "resetData", "type": "control" },
					{ "id": "GroupsSearchPage", "page": "mainPage", "action": "setVisible", "type": "control" },
					{ "id": "GroupsListLoadQuery", "action": "loadData", "type": "query" }
			]
			},
			{ "sender": "GroupSetPriority", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "GroupsGridControl", "action": "preResetData", "type": "control" },
					{ "id": "GroupsSearchPage", "page": "mainPage", "action": "setVisible", "type": "control" },
					{ "id": "GroupsListLoadQuery", "action": "loadData", "type": "query" }
				]
			},
			{ "sender": "GroupSettingDefaultLoadQuery", "event": "onsuccess", "type": "query", "receivers":
				[
					{ "id": "GroupViewEditPage", "page": "mainPage", "action": "show", "type": "control" },
					{ "id": "GroupsSearchPage", "page": "mainPage", "action": "setInvisible", "type": "control" },
					{ "id": "GroupSettingsEditor", "page": "mainPage", "action": "applyValue", "type": "control" }
				]
			},
			
			{ "sender": "GroupSettingsEditor", "event": "ongetnewgroupid", "type": "control", "receivers": [
					{ "id": "GroupsGridControl", "action": "getNewGroupName", "type": "control" }
			]
			},
			
			{ "sender": "GroupsGridControl", "event": "onsetnewgroupname", "type": "control", "receivers": [
					{ "id": "groupGeneralSettingsForm", "action": "setNewGroupName", "type": "control" }
			]
			},
			
			
			{ "sender": ["btnUp_GroupsTop", "btnUp_GroupsBottom"], "event": "onclick", "type": "control", "receivers": [
					{ "id": "GroupsGridControl", "action": "upPriority", "type": "control" }
			]
			},
			{ "sender": ["btnDown_GroupsTop", "btnDown_GroupsBottom"], "event": "onclick", "type": "control", "receivers": [
					{ "id": "GroupsGridControl", "action": "downPriority", "type": "control" }
			]
			},
			{ "sender": "GroupsGridControl", "event": "ongroupprioritychange", "type": "control", "receivers": [
					{ "id": "GroupsGridControl", "page": "mainPage", "action": "showLoading", "type": "control", "args": ["GroupsGridControl.ongroupprioritychange"] },
					{ "id": "GroupSetPriority", "action": "loadData", "type": "query" }
			]
			},
						
			{ "sender": ["groupAsSettingsForm", "groupAvSettingsForm","groupCFSettingsForm", "groupApSettingsForm"], "event": "ontextedit", "type": "control", "receivers": [
					{ "id": "textTooltipForm", "page": "mainPage", "action": "showTooltip", "type": "control" }
			]
			},
			{ "sender": ["groupAvSettingsForm","groupCFSettingsForm"], "event": "onexcludedtypes", "type": "control", "receivers": [
					{ "id": "filesTypesDialog", "page": "filesTypesDialog", "action": "showDialog", "type": "page" },
					{ "id": "filesTypesDialogForm", "page": "filesTypesDialog", "action": "setValue", "type": "control" }
			]
			},
			{ "sender": "filesTypesDialogForm", "event": "onformclose", "type": "control", "receivers": [
					{ "id": "filesTypesDialog", "page": "filesTypesDialog", "action": "closeDialog", "type": "page" }
			]
			},
			{ "sender": "groupCFSettingsForm", "event": "onnamevalidate", "type": "control", "receivers": [
					{ "id": "ValidateFileNameQuery", "action": "loadData", "type": "query" }
			]
			},
			{ "sender": "ValidateFileNameQuery", "type": "query", "event": "onsuccess", "receivers": [
					{ "id": "groupCFSettingsForm", "type": "control", "action": "setExcludesValue" }
			]
			},
			{ "sender": "ValidateFileNameQuery", "type": "query", "event": "onerror", "receivers": [
					{ "id": "groupCFSettingsForm", "page": "mainPage", "action": "applyError", "type": "control" }
			]
			},
			
			{ "sender": "groupAsSettingsForm", "event": "onlistedit", "type": "control", "receivers": [
					{ "id": "userBListViewCtrl", "page": "mainPage", "action": "setListType", "type": "control" },
					{ "id": "listViewToltip", "page": "mainPage", "action": "setButtonClose", "type": "control" },
					{ "id": "listViewToltip", "page": "mainPage", "action": "showTooltip", "type": "control" }
			]
			},
			{ "sender": "groupNotificationSettingsForm", "event": "onlistedit", "type": "control", "receivers": [
					{ "id": "emailEditTooltipForm", "page": "mainPage", "action": "showTooltip", "type": "control" },
					{ "id": "emailListEditorCtrl", "page": "mainPage", "action": "setValue", "type": "control" }
				]
			},
			{ "sender": "groupNotificationSettingsForm", "event": "onattachsourceedit", "type": "control", "receivers": [
					{ "id": "attachSourceEditTooltipForm", "page": "mainPage", "action": "showTooltip", "type": "control" },
					{ "id": "attachSourceEditForm", "page": "mainPage", "action": "setValue", "type": "control" }
				]
			},
			{ "sender": "GroupSettingsEditor", "event": "oneditorclose", "type": "control", "receivers": [
					{ "id": "GroupsSearchPage", "page": "mainPage", "action": "setVisible", "type": "control" },
					{ "id": "GroupsGridControl", "action": "resetSelection", "type": "control" }
			]
			},
			{ "sender": "GroupSettingsEditor", "event": "onsettingssave", "type": "control", "receivers": [
					{ "id": "GroupSettingsSaveQuery", "action": "loadData", "type": "query" }
			]
			},
			{ "sender": "GroupSettingsEditor", "event": "onsettingssaveclose", "type": "control", "receivers": [
					{ "id": "GroupSettingsSaveCloseQuery", "action": "loadData", "type": "query" }
			]
			},
			{ "sender": ["GroupSettingsSaveQuery"], "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "GroupSettingsEditor", "page": "mainPage", "action": "resetEdited", "type": "control" }
			]
			},
			{ "sender": [ "GroupNewSettingsSaveQuery","GroupSettingsSaveCloseQuery"], "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "GroupsGridControl", "action": "resetData", "type": "control" },
					{ "id": "GroupsSearchPage", "page": "mainPage", "action": "setVisible", "type": "control" },
					{ "id": "GroupsListLoadQuery", "action": "loadData", "type": "query" }
			]
			},
			{ "sender": ["GroupSettingsSaveQuery","GroupNewSettingsSaveQuery","GroupSettingsSaveCloseQuery"], "event": "onloadstarted", "type": "query", "receivers": [
					{ "id": "GroupSettingsEditor", "page": "mainPage", "action": "showLoading", "type": "control" }
				]
			},
			{ "sender": ["GroupSettingsSaveQuery","GroupNewSettingsSaveQuery","GroupSettingsSaveCloseQuery"], "event": "onloadcomplete", "type": "query", "receivers": [
					{ "id": "GroupSettingsEditor", "page": "mainPage", "action": "hideLoading", "type": "control" }
				]
			},
			
			
			
			
	
			{ "sender": "GroupSettingsEditor", "event": "onnewsettingssave", "type": "control", "receivers": [
					{ "id": "GroupNewSettingsSaveQuery", "action": "loadData", "type": "query" }
			]
			},
			{ "sender": ["GroupSettingsSaveQuery", "GroupNewSettingsSaveQuery","GroupSettingsSaveCloseQuery"], "event": "onerror", "type": "query", "receivers": [
					{ "id": "GroupSettingsEditor", "page": "mainPage", "action": "applyError", "type": "control" }
			]
			},
			{ "sender": "GroupsGridControl", "event": "onrowenter", "type": "control", "receivers": [
					{ "id": "GroupsGridControl", "page": "mainPage", "action": "showLoading", "type": "control", "args": ["GroupsGridControl.onrowenter"] },					
					{ "id": "GroupSettingLoadQuery", "action": "loadData", "type": "query" },
					{ "id": "GroupSettingsEditor", "page": "mainPage", "action": "setMode", "args": ["edit"], "type": "control" }
			]
			},
			{ "sender": "GroupsGridControl", "event": "ongroupactivechange", "type": "control", "receivers": [
					{ "id": "GroupsGridControl", "page": "mainPage", "action": "showLoading", "type": "control", "args": ["GroupsGridControl.ongroupactivechange"] },
					{ "id": "GroupSetActive", "action": "loadData", "type": "query" }
			]
			},
			{ "sender": ["GroupSetActive", "DeleteGroupQuery", "GroupSetPriority"], "event": "onerror", "type": "query", "receivers": [
					{ "id": "GroupsGridControl", "page": "mainPage", "action": "applyError", "type": "control" }
			]
			},
			
			{"sender": "GroupsGridControl", "event": "onpagechange", "type": "control", "receivers": [
					{ "id": "GroupsGridControl", "page": "mainPage", "action": "viewPage", "type": "control" }
			]
			},
			{ "sender": "GroupsGridControl", "event": "onsetpagesize", "type": "control", "receivers": [
					{ "id": "GroupsGridBottomPager", "page": "mainPage", "action": "initData", "type": "control" }
			]
			},
			
			
			{ "sender": ["GroupsGridTopPager", "GroupsGridBottomPager"], "event": "onpagechange", "type": "control", "receivers": [
					{ "id": "GroupsGridControl", "page": "mainPage", "action": "setPageNum", "type": "control" }
			]
			},
			{ "sender": "GroupsGridControl", "event": "onrowselected", "type": "control", "receivers": [
					{ "id": ["GroupsListTopToolbar", "GroupsListBottomToolbar"], "action": "toggleButtons", "type": "control", "page": "mainPage" },
					{ "id": "GroupsGridControl", "action": "setPriorityButtons", "type": "control", "page": "mainPage" }
			]
			},
			{ "sender": "GroupsGridControl", "event": ["onshow", "onpagechange"], "type": "control", "receivers": [
					{ "id": "getGroupProtectionMiscSettingsQuery", "action": "loadData", "type": "query" },
					{ "id": "GroupsListLoadQuery", "action": "loadData", "type": "query" }
			]
			},
			{ "sender": "GroupsGridControl", "event": "onrowenter_priority", "type": "control", "receivers": [
					{ "id": "GroupsGridControl", "action": "invokePriorityChangeData", "type": "control", "page": "mainPage" }
			]
			},
			{ "sender": ["btnChangePririty_GroupsBottom", "btnChangePririty_GroupsTop"], "event": "onclick", "type": "control", "receivers": [
					{ "id": "GroupsGridControl", "action": "invokePriorityChangeData", "type": "control", "page": "mainPage" }
			]
			},
			{ "sender": "GroupsGridControl", "event": "onprioritychangeinvoke", "type": "control", "receivers": [
					{ "id": "priorityEditorDialog", "action": "showDialog", "type": "page", "page": "priorityEditorDialog" },
					{ "id": "priorityEditorForm", "action": "setValue", "type": "control", "page": "priorityEditorDialog" }
					
			]
			},
			{ "sender": "priorityEditorForm", "event": "oncancel", "type": "control", "receivers": [
					{ "id": "priorityEditorDialog", "action": "closeDialog", "type": "page", "page": "priorityEditorDialog" }
			]
			},
			{ "sender": "priorityEditorForm", "event": "onsubmit", "type": "control", "receivers": [
					{ "id": "GroupsGridControl", "action": "setPriorityChangeData", "type": "control", "page": "mainPage" },
					{ "id": "priorityEditorDialog", "action": "closeDialog", "type": "page", "page": "priorityEditorDialog" }
			]
			},
			
	
			{ "sender": "GroupsGridControl", "event": "setprioritybuttons", "type": "control", "receivers": [
					{ "id": ["GroupsListTopToolbar", "GroupsListBottomToolbar"], "action": "setPriorityButtons", "type": "control", "page": "mainPage" }
			]
			},	
			{ "sender": "GroupsListTopToolbar", "event": "ondownprioritydisabled", "type": "control", "receivers": [
					{ "id": ["btnDown_GroupsTop"], "page": "mainPage", "action": "disable", "type": "control" }
			]
			},
			{ "sender": "GroupsListBottomToolbar", "event": "ondownprioritydisabled", "type": "control", "receivers": [
					{ "id": ["btnDown_GroupsBottom"], "page": "mainPage", "action": "disable", "type": "control" }
			]
			},
			{ "sender": "GroupsListTopToolbar", "event": "onupprioritydisabled", "type": "control", "receivers": [
					{ "id": ["btnUp_GroupsTop"], "page": "mainPage", "action": "disable", "type": "control" }
			]
			},
			{ "sender": "GroupsListBottomToolbar", "event": "onupprioritydisabled", "type": "control", "receivers": [
					{ "id": ["btnUp_GroupsBottom"], "page": "mainPage", "action": "disable", "type": "control" }
			]
			},
			{ "sender": "GroupsListTopToolbar", "event": "onupdownprioritydisabled", "type": "control", "receivers": [
					{ "id": ["btnUp_GroupsTop","btnDown_GroupsTop","btnDelete_GroupsTop","btnCopy_GroupsTop","btnChangePririty_GroupsTop"], "page": "mainPage", "action": "disable", "type": "control" }
			]
			},
			{ "sender": "GroupsListBottomToolbar", "event": "onupdownprioritydisabled", "type": "control", "receivers": [
					{ "id": ["btnUp_GroupsBottom","btnDown_GroupsBottom","btnDelete_GroupsBottom","btnCopy_GroupsBottom","btnChangePririty_GroupsBottom"], "page": "mainPage", "action": "disable", "type": "control" }
			]
			},
			{ "sender": "GroupsListTopToolbar", "event": "onactionsdisabled", "type": "control", "receivers": [
					{ "id": "btnCreate_GroupsTop", "page": "mainPage", "action": "enable", "type": "control" },
					{ "id": ["btnDelete_GroupsTop","btnCopy_GroupsTop", "btnChangePririty_GroupsTop", "btnUp_GroupsTop", "btnDown_GroupsTop"], "page": "mainPage", "action": "disable", "type": "control" }
			]
			},
			{ "sender": "GroupsListBottomToolbar", "event": "onactionsdisabled", "type": "control", "receivers": [
					{ "id": "btnCreate_GroupsBottom", "page": "mainPage", "action": "enable", "type": "control" },
					{ "id": ["btnDelete_GroupsBottom","btnCopy_GroupsBottom", "btnChangePririty_GroupsBottom", "btnUp_GroupsBottom", "btnDown_GroupsBottom"], "page": "mainPage", "action": "disable", "type": "control" }
			]
			},
			{ "sender": "GroupsListTopToolbar", "event": "onsingleitemaction", "type": "control", "receivers": [
					{ "id": ["btnCreate_GroupsTop", "btnDelete_GroupsTop","btnCopy_GroupsTop", "btnChangePririty_GroupsTop", "btnUp_GroupsTop", "btnDown_GroupsTop"], "page": "mainPage", "action": "enable", "type": "control" }
			]
			},
			{ "sender": "GroupsListBottomToolbar", "event": "onsingleitemaction", "type": "control", "receivers": [
					{ "id": ["btnCreate_GroupsBottom", "btnDelete_GroupsBottom","btnCopy_GroupsBottom", "btnChangePririty_GroupsBottom", "btnUp_GroupsBottom", "btnDown_GroupsBottom"], "page": "mainPage", "action": "enable", "type": "control" }
			]
			},
			{ "sender": "GroupsListTopToolbar", "event": "onmultipleitemsaction", "type": "control", "receivers": [
					{ "id": ["btnCreate_GroupsTop","btnDelete_GroupsTop"], "page": "mainPage", "action": "enable", "type": "control" },
					{ "id": ["btnUp_GroupsTop","btnCopy_GroupsTop", "btnDown_GroupsTop",  "btnChangePririty_GroupsTop"], "page": "mainPage", "action": "disable", "type": "control" }
			]
			},
			{ "sender": "GroupsListBottomToolbar", "event": "onmultipleitemsaction", "type": "control", "receivers": [
					{ "id": ["btnCreate_GroupsBottom", "btnDelete_GroupsBottom"], "page": "mainPage", "action": "enable", "type": "control" },
					{ "id": ["btnUp_GroupsBottom","btnCopy_GroupsBottom", "btnDown_GroupsBottom", "btnChangePririty_GroupsBottom"], "page": "mainPage", "action": "disable", "type": "control" }
			]
			},
			{ "sender": "GroupsListLoadQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "GroupsGridControl", "page": "mainPage", "action": "applyValue", "type": "control" },
					{ "id": "GroupsGridControl", "action": "setPriorityButtons", "type": "control", "page": "mainPage" }
			]
			},
			{ "sender": "GroupsListLoadQuery", "event": "onloadstarted", "type": "query", "receivers": [
					{ "id": "isLdapConnectQuery", "action": "loadData", "type": "query" },
					{ "id": "GroupsGridControl", "page": "mainPage", "action": "showLoading", "type": "control", "args": ["GroupsListLoadQuery.onloadstarted"] }
			]
			},
			{ "sender": "GroupsListLoadQuery", "event": "onloadcomplete", "type": "query", "receivers": [
					{ "id": "GroupsGridControl", "page": "mainPage", "action": "hideLoading", "type": "control", "args": ["GroupsListLoadQuery.onloadcomplete"] }
					
			]
			},
			{ "sender": "groupGeneralSettingsForm", "event": "onlistchange", "type": "control", "receivers": [
					{ "id": "addressesEditDialog", "page": "addressesEditDialog", "action": "showDialog", "type": "page" },
					{ "id": "addressEditForm", "page": "addressesEditDialog", "action": "setValue", "type": "control" }
				]
			},
			{ "sender": "groupGeneralSettingsForm", "event": "onimportlist", "type": "control", "receivers": [
					{ "id": "addressesImportEditDialog", "page": "addressesImportEditDialog", "action": "showDialog", "type": "page" },
					{ "id": "addressImportEditForm", "page": "addressesImportEditDialog", "action": "setData", "type": "control" }
				]
			},
			
			{ "sender": "addressImportEditForm", "event": "ontestips", "type": "control", "receivers": [
					{ "id": "validateImportingIpQuery", "action": "loadData", "type": "query" }
				]
			},
			{ "sender": "addressImportEditForm", "event": "ontestemails", "type": "control", "receivers": [
					{ "id": "validateImportingEmailQuery", "action": "loadData", "type": "query" }
				]
			},
			{ "sender": ["validateImportingIpQuery", "validateImportingEmailQuery"], "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "addressImportEditForm", "page": "addressesImportEditDialog", "action": "applyValidationResult", "type": "control" }
				]
			},
			{ "sender": ["validateImportingIpQuery", "validateImportingEmailQuery"], "event": "onloadstarted", "type": "query", "receivers": [
					{ "id": "addressImportEditForm", "page": "addressesImportEditDialog", "action": "showLoading", "type": "control" }
				]
			},
			{ "sender": ["validateImportingIpQuery", "validateImportingEmailQuery"], "event": "onloadcomplete", "type": "query", "receivers": [
					{ "id": "addressImportEditForm", "page": "addressesImportEditDialog", "action": "hideLoading", "type": "control" }
				]
			},
			{ "sender": "addressImportEditForm", "event": "onok", "type": "control", "receivers": [
					{ "id": "groupGeneralSettingsForm", "action": "setImportAddresses", "type": "control" }
				]
			},
			
			
			{ "sender": "groupGeneralSettingsForm", "event": "ongetExternalAccountInfo", "type": "control", "receivers": [
					{ "id": "GetLDAPInfoQuery", "action": "loadData", "type": "query" }
				]
			},
			{ "sender": "getGroupProtectionMiscSettingsQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "GroupsGridControl", "action": "setGroupProtection", "type": "control" }
			]
			},
			{ "sender": "isLdapConnectQuery", "event": "onerror", "type": "query", "receivers": [
					{ "id": "groupGeneralSettingsForm", "action": "setLdapNotConnect", "type": "control" }
			]
			},
			{ "sender": "isLdapConnectQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "groupGeneralSettingsForm", "action": "setLdapConnect", "type": "control" }
			]
			},
			{ "sender": "GetLDAPInfoQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "groupGeneralSettingsForm", "action": "setExternalAccount", "type": "control" }
			]
			},
			{ "sender": "groupGeneralSettingsForm", "event": "onipvalidate", "type": "control", "receivers": [
					{ "id": "validateIpQuery", "action": "loadData", "type": "query" },
					{ "id": "groupGeneralSettingsForm", "page": "mainPage", "action": "showLoading", "type": "control" }
			]
			},
			{ "sender": "validateIpQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "groupGeneralSettingsForm", "page": "mainPage", "action": "setIpIsValid", "type": "control" }
			]
			},
			{ "sender": "validateIpQuery", "event": "onloadcomplete", "type": "query", "receivers": [
					{ "id": "groupGeneralSettingsForm", "page": "mainPage", "action": "hideLoading", "type": "control" }
			]
			},
			{ "sender": "groupGeneralSettingsForm", "event": "onwildcardvalidate", "type": "control", "receivers": [
					{ "id": "validateWildcardQuery", "action": "loadData", "type": "query" },
					{ "id": "groupGeneralSettingsForm", "page": "mainPage", "action": "showLoading", "type": "control" }
			]
			},
			{ "sender": "validateWildcardQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "groupGeneralSettingsForm", "page": "mainPage", "action": "setWildcardQueryIsValid", "type": "control" }
			]
			},
			{ "sender": "validateWildcardQuery", "event": "onloadcomplete", "type": "query", "receivers": [
					{ "id": "groupGeneralSettingsForm", "page": "mainPage", "action": "hideLoading", "type": "control" }
			]
			},
			
			{ "sender": "SearchLDAPQuery", "event": "onloadcomplete", "type": "query", "receivers": [
					{ "id": "addressEditForm", "page": "addressesEditDialog", "action": "hideLoading", "type": "control" }
			]
			},
			
			{ "sender": "addressEditForm", "event": ["oncancel", "onok"], "type": "control", "receivers": [
					{ "id": "addressesEditDialog", "page": "addressesEditDialog", "action": "closeDialog", "type": "page" }
			]
			},
			{ "sender": "addressEditForm", "event": "searchLDAP", "type": "control", "receivers": [
					{ "id": "SearchLDAPQuery", "action": "loadData", "type": "query" },
					{ "id": "addressEditForm", "page": "addressesEditDialog", "action": "showLoading", "type": "control" }
			]
			},
			{ "sender": "SearchLDAPQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "addressEditForm", "page": "addressesEditDialog", "action": "setSearchByLDAPData", "type": "control" }
				]
			},
			{ "sender": "SearchLDAPQuery", "event": "onerror", "type": "query", "receivers": [
					{ "id": "addressEditForm", "page": "addressesEditDialog", "action": "applyError", "type": "control" }
				]
			},
			{"sender": "BackupSearchPanel", "event": "onformsubmit", "type": "control", "receivers": [
					{ "id": "BackupGridControl", "page": "mainPage", "action": "applyFilter", "type": "control" }
			]
			},
			{ "sender": "BackupGridTopPager", "event": "onpagechange", "type": "control", "receivers": [
					{ "id": "BackupGridControl", "page": "mainPage", "action": "setPageNum", "type": "control" }
			]
			},
			{ "sender": "BackupGridControl", "event": "onsetpagesize", "type": "control", "receivers": [
					{ "id": "BackupGridTopPager", "page": "mainPage", "action": "initData", "type": "control" }
			]
			},
			
			{ "sender": "BackupGridControl", "event": "onshow", "type": "control", "receivers": [
					{ "id": "BackupListLoadQuery", "action": "loadData", "type": "query" },
					{ "id": "storagFilterForm", "action": "initValues", "type": "control", "page": "sorageFilterDialog" }
			]
			},
			{ "sender": "BackupGridControl", "event": "onfilterchange", "type": "control", "receivers": [
					{ "id": "BackupListLoadQuery", "action": "loadData", "type": "query" }
			]
			},
			{ "sender": "BackupListLoadQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "backupListTopToolbar", "action": "toggleButtons", "type": "control", "page": "mainPage" },
					{ "id": "BackupGridControl", "page": "mainPage", "action": "applyValue", "type": "control" }
				]
			},
			{ "sender": "BackupListLoadQuery", "event": "onerror", "type": "query", "receivers": [
					{ "id": "backupListTopToolbar", "action": "toggleButtons", "type": "control", "page": "mainPage" },
					{ "id": "BackupGridControl", "page": "mainPage", "action": "applyError", "type": "control" }
				]
			},
			{ "sender": "BackupListLoadQuery", "event": "onloadstarted", "type": "query", "receivers": [
					{ "id": "BackupGridControl", "page": "mainPage", "action": "showLoading", "type": "control" },
					{ "id": "lblFilterInfo", "page": "mainPage", "action": "showLoading", "type": "control" }
				]
			},
			{ "sender": "BackupListLoadQuery", "event": "onloadcomplete", "type": "query", "receivers": [
					{ "id": "BackupGridControl", "page": "mainPage", "action": "hideLoading", "type": "control" },
					{ "id": "lblFilterInfo", "page": "mainPage", "action": "hideLoading", "type": "control" }
			]
			},
			{ "sender": "lblFilterInfo", "event": "onfilteropen", "type": "control", "receivers": [
					{ "id": "sorageFilterDialog", "action": "showDialog", "type": "page", "page": "sorageFilterDialog" }
			]
			},
			{ "sender": "storagFilterForm", "event": "oncancel", "type": "control", "receivers": [
					{ "id": "sorageFilterDialog", "action": "closeDialog", "type": "page", "page": "sorageFilterDialog" }
			]
			},
			{ "sender": "storagFilterForm", "event": "onformsubmit", "type": "control", "receivers": [
					{ "id": "BackupGridControl", "page": "mainPage", "action": "applyFilter", "type": "control" },
					{ "id": "sorageFilterDialog", "action": "closeDialog", "type": "page", "page": "sorageFilterDialog" },
					{ "id": "lblFilterInfo", "page": "mainPage", "action": "applyFilterData", "type": "control" }
			]
			},
			{ "sender": "lblFilterInfo", "event": "onfilterrefresh", "type": "control", "receivers": [
					{ "id": "BackupGridControl", "page": "mainPage", "action": "initFilter", "type": "control" },
					{ "id": "BackupGridControl", "page": "mainPage", "action": "resetData", "type": "control" },
					{ "id": "BackupListLoadQuery", "action": "loadData", "type": "query" }
			]
			},
			
			{ "sender": "BackupGridControl", "event": "onrowselected", "type": "control", "receivers": [
					{ "id": "backupListTopToolbar", "action": "toggleButtons", "type": "control", "page": "mainPage" }
			]
			},
			{ "sender": "backupListTopToolbar", "event": "onactionsdisabled", "type": "control", "receivers": [
					{ "id": ["btnDeliver_BackupTop", "btnView_BackupTop", "btnDelete_BackupTop", "btnSave_BackupTop"], "page": "mainPage", "action": "disable", "type": "control" }
			]
			},
			{ "sender": "backupListTopToolbar", "event": "onsingleitemaction", "type": "control", "receivers": [
					{ "id": ["btnDeliver_BackupTop", "btnView_BackupTop", "btnDelete_BackupTop", "btnSave_BackupTop"], "page": "mainPage", "action": "enable", "type": "control" }
			]
			},
			{ "sender": "backupListTopToolbar", "event": "onmultipleitemsaction", "type": "control", "receivers": [
					{ "id": ["btnDeliver_BackupTop", "btnDelete_BackupTop"], "page": "mainPage", "action": "enable", "type": "control" },
					{ "id": ["btnView_BackupTop", "btnSave_BackupTop"], "page": "mainPage", "action": "disable", "type": "control" }
			]
			},
			
			{ "sender": "BackupPagePanel", "event": "onshow", "type": "control", "receivers": [
					{ "id": "MessageViewEditPage", "page": "mainPage", "action": "hide", "type": "control" }
			]
			},
			
			{"sender": "btnView_BackupTop", "event":"onclick", "type":"control", "receivers": [
				{ "id": "BackupSearchPage", "page": "mainPage", "action": "setInvisible", "type": "control" },
				{ "id": "BackupGridControl", "page": "mainPage", "action": "getDataItem", "type": "control" }
			]},
			{ "sender": "BackupGridControl", "event": "onrowenter", "type": "control", "receivers": [
				{ "id": "BackupSearchPage", "page": "mainPage", "action": "setInvisible", "type": "control" },
				{ "id": "BackupGridControl", "page": "mainPage", "action": "getDataItem", "type": "control" }
			]
			},
			
			
			{"sender":"btnDelete_BackupTop", "event":"onclick", "type":"control", "receivers": [
				{"id": "BackupGridControl","action": "deleteRows","type": "control"}
			]},
			{"sender":"btnDeliver_BackupTop", "event":"onclick", "type":"control", "receivers": [
				{"id": "BackupGridControl","action": "getMailAdressDeliver","type": "control"}
			]},
			{"sender": "btnSave_BackupTop", "event":"onclick", "type":"control", "receivers": [
				{"id": "MessageSaveQuery","action": "loadFile","type": "query"}
			]},
			{"sender":"btnSave_MessageTop", "event":"onclick", "type":"control", "receivers": [
				{"id": "BackupGridControl","action": "setActionFromPanel","type": "control"},
				{"id": "MessageSaveQuery","action": "loadFile","type": "query"}
			]},
			{ "sender": "BackupGridControl", "event": "ongetrecievers", "type": "control", "receivers": [
					{ "id": "deliverMailDialog", "page": "deliverMailDialog", "action": "showDialog", "type": "page" },
					{"id": "deliverDialogForm", "page": "deliverMailDialog", "action": "setData","type": "control"}
			]
			},
			
			{ "sender": "deliverDialogForm", "event": "oncancel", "type": "control", "receivers": [
					{ "id": "deliverMailDialog", "page": "deliverMailDialog", "action": "closeDialog", "type": "page" }
			]
			},
			{"sender":"btnDelete_MessageTop", "event":"onclick", "type":"control", "receivers": [
				{"id": "BackupGridControl","action": "setActionFromPanel","type": "control"},
				{"id": "BackupGridControl","action": "deleteRows","type": "control"}
			]},
			{"sender":"btnDeliver_MessageTop", "event":"onclick", "type":"control", "receivers": [
				{"id": "BackupGridControl","action": "setActionFromPanel","type": "control"},
				{"id": "BackupGridControl","action": "getMailAdressDeliver","type": "control"}
			]},
			
			
			{ "sender": "BackupGridControl", "event": "onrowsdelete", "type": "control", "receivers": [
					{ "id": "BackupPagePanel", "page": "mainPage", "action": "showLoading", "type": "control" },
					{ "id": "MessageDeleteQuery", "action": "loadData", "type": "query" }
			]
			},
			{ "sender": "BackupGridControl", "event": "ongetnextdata", "type": "control", "receivers": [
					{ "id": "MessageTopPager", "action": "getNextData", "type": "control" }
			]
			},
			{ "sender": "MessageDeleteQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "deliverMailDialog", "page": "deliverMailDialog", "action": "closeDialog", "type": "page" },
					{ "id": "BackupGridControl","action": "applyDeletedData","type": "control"}
					
			]
			},
			{ "sender": "MessageDeleteQuery", "event": "onloadcomplete", "type": "query", "receivers": [
					{ "id": "BackupPagePanel", "page": "mainPage", "action": "hideLoading", "type": "control" }
					
			]
			},
			{ "sender": "MessageDeleteQuery", "event": "onerror", "type": "query", "receivers": [
					{ "id": ["BackupGridControl","MessageViewEditPage"], "page": "mainPage", "action": "hideLoading", "type": "control" },
					{ "id": "BackupGridControl", "page": "mainPage", "action": "applyError", "type": "control" }
			]
			},
			{ "sender": "MessageSaveQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "BackupGridControl", "page": "mainPage", "action": "resetActionFromPanel", "type": "control" }
			]
			},
			{ "sender": "MessageSaveQuery", "event": "onerror", "type": "query", "receivers": [
					{ "id": "BackupGridControl", "page": "mainPage", "action": "resetActionFromPanel", "type": "control" },
					{ "id": "BackupGridControl", "page": "mainPage", "action": "applyError", "type": "control" }
			]
			},
			{ "sender": "BackupGridControl", "event": "ondeliverletter", "type": "control", "receivers": [
					{ "id": "deliverMailDialog", "page": "deliverMailDialog", "action": "closeDialog", "type": "page" },
					{ "id": "BackupGridControl", "page": "mainPage", "action": "showLoading", "type": "control" },
					{ "id": "MessageViewEditPage", "page": "mainPage", "action": "showLoading", "type": "control" },
					{ "id": "BackupGridControl", "page": "mainPage", "action": "startLettersDelivering", "type": "control" }
				]
			},
				{ "sender": "BackupGridControl", "event": "ontrydeliverletter", "type": "control", "receivers": [
						{ "id": "MessageDeliverQuery", "action": "loadData", "type": "query" }
					]
				},
				{ "sender": "MessageDeliverQuery", "event": "onsuccess", "type": "query", "receivers": [
						{ "id": "BackupGridControl", "page": "mainPage", "action": "onLetterDeliverySuccess", "type": "control" }
					]
				},
				{ "sender": "MessageDeliverQuery", "event": "onloadcomplete", "type": "query", "receivers": [
						{ "id": "BackupGridControl", "page": "mainPage", "action": "tryDeliverNextLetter", "type": "control" }
					]
				},
				{ "sender": "MessageDeliverQuery", "event": "onerror", "type": "query", "receivers": [
						{ "id": "BackupGridControl", "page": "mainPage", "action": "hideLoading", "type": "control" },
						{ "id": "MessageViewEditPage", "page": "mainPage", "action": "hideLoading", "type": "control" },
						{ "id": "BackupGridControl", "page": "mainPage", "action": "onLetterDeliveryFail", "type": "control" }
					]
				},
				{ "sender": "BackupGridControl", "event": "ondeliveringcomplete", "type": "control", "receivers": [
						{ "id": "BackupGridControl", "page": "mainPage", "action": "hideLoading", "type": "control" },
						{ "id": "MessageViewEditPage", "page": "mainPage", "action": "hideLoading", "type": "control" },
						{ "id": "BackupGridControl", "page": "mainPage", "action": "onDeliveryComplete", "type": "control" }
					]
				},
			{"sender":"MessageSettingsTab", "event":"onhide", "type":"control", "receivers": 
				[
					{ "id": "BackupGridControl", "page": "mainPage", "action": "initCurrentIndex", "type": "control" }
				]
			},
		
			{"sender":"btnBackupSearch", "event":"onclick", "type":"control", "receivers": [
				{ "id": "BackupSearchPage", "page": "mainPage", "action": "setVisible", "type": "control" },
				{ "id": "MessageViewEditPage", "page": "mainPage", "action": "hide", "type": "control" },
				{ "id": "BackupGridControl", "page": "mainPage", "action": "resetActionFromPanel","type": "control"}				
			]},
			{"sender":"BackupGridControl", "event":"ongetdata", "type":"control", "receivers": [
					{ "id": "MessageViewEditPage","page": "mainPage","action": "show","type": "control"},
					{ "id": "MessageSettingsTab","page": "mainPage","action": "setDataItem","type": "control"}
			]
			},
			{"sender":"BackupGridControl", "event":"oncheangeindex", "type":"control", "receivers":  [
					{ "id": "MessageTopPager","page": "mainPage","action": "setItemId","type": "control"}
			]
			},
			{"sender":"BackupGridControl", "event":"onclosepanel", "type":"control", "receivers": [
				{ "id": "BackupGridControl", "page": "mainPage", "action": "resetActionFromPanel","type": "control"},
				{ "id": "BackupSearchPage", "page": "mainPage", "action": "setVisible", "type": "control" },
				{ "id": "MessageViewEditPage", "page": "mainPage", "action": "hide", "type": "control" }
			]},
			
			
			{"sender": "MessageTopPager","event": "onpagechange", "type":"control", "receivers": [
					{ "id": "BackupGridControl", "page": "mainPage", "action": "changeCurrentIndex","type": "control"},
					{ "id": "BackupGridControl", "page": "mainPage", "action": "getDataItem", "type": "control" }
				]
			},
	
			{"sender": "testLdapSearchForm", "event": "onsearchstart", "type":"control", "receivers": [
					{ "id": "SearchLDAPQueryAutocomplete", "action": "loadData", "type": "query" }
			]
			},
			{ "sender": "SearchLDAPQueryAutocomplete", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "testLdapSearchForm", "page": "mainPage", "action": "setSearchResult", "type": "control" }
			]
			},
			{ "sender": "SearchLDAPQueryAutocomplete", "event": "onloadstarted", "type": "query", "receivers": [
					{ "id": "testLdapSearchForm", "page": "mainPage", "action": "showLoading", "type": "control" }
			]
			},
			{ "sender": "SearchLDAPQueryAutocomplete", "event": "onloadcomplete", "type": "query", "receivers": [
					{ "id": "testLdapSearchForm", "page": "mainPage", "action": "hideLoading", "type": "control" }
			]
			},
			
			{ "sender": "ReportsGridControl", "event": "onrowenter_download", "type": "control", "receivers": [
					{ "id": "ReportsGridControl", "action": "invokeDownloadReport", "type": "control", "page": "mainPage" }
			]
			},
			
			{ "sender": "ReportsGridControl", "event": "ondownloadReport", "type": "control", "receivers": [
					{ "id": "DownloadReportQuery", "action": "loadFile", "type": "query" }
			]
			},
			
			{ "sender": "ReportsGridControl", "event": "onfilterchange", "type": "control", "receivers": [
					{ "id": "ReportsListLoadQuery", "action": "loadData", "type": "query" }
			]
			},
			{ "sender": "ReportsListLoadQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "ReportsGridControl", "action": "resetData", "type": "control" },
					{ "id": ["ReportsListTopToolbar", "ReportsListBottomToolbar"], "action": "toggleButtons", "type": "control", "page": "mainPage" },
					{ "id": "ReportsGridControl", "page": "mainPage", "action": "applyValue", "type": "control" }
				]
			},
			{ "sender": "ReportsListLoadQuery", "event": "onloadcomplete", "type": "query", "receivers": [
					{ "id": "ReportsGridControl", "page": "mainPage", "action": "hideLoading", "type": "control" }
				]
			},
			{ "sender": "ReportsScheduleSettingsQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "reportsFilterBtns", "action": "applyValue", "type": "control", "page": "mainPage" }
			]
			},
			{"sender": "reportsFilterBtns", "event": "ongetlocalelist", "type": "control", "receivers": [
					{ "id": "reportsFilterBtns", "page": "mainPage", "action": "showLoading", "type": "control" },
					{ "id": "ReportsLocaleListQuery", "action": "loadData", "type": "query" }
			]
			},
			{ "sender": "ReportsLocaleListQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "ReportsGridControl", "action": "setLocaleList", "type": "control", "page": "mainPage" },
					{ "id": "reportsFilterBtns", "action": "setLocaleList", "type": "control", "page": "mainPage" }
				]
			},
			{ "sender": "ReportsLocaleListQuery", "event": "onloadcomplete", "type": "query", "receivers": [
					{ "id": "reportsFilterBtns", "page": "mainPage", "action": "hideLoading", "type": "control" }
				]
			},
			{"sender": "reportsFilterBtns", "event": ["onfilterchange"], "type": "control", "receivers": [
					{ "id": "reportsFilterBtns", "page": "mainPage", "action": "showLoading", "type": "control" },
					{ "id": "ReportsScheduleSettingsQuery", "action": "loadData", "type": "query" }
			]
			},
			
			{ "sender": "reportsFilterBtns", "event": "onfilterchange", "type": "control", "receivers": [
					{ "id": "ReportsGridControl", "page": "mainPage", "action": "setFilter", "type": "control" }
			]
			},
			{ "sender": "reportsFilterBtns", "event": "onitemdisabled", "type": "control", "receivers": [
					{ "id": "setReportsScheduleEnabledQuery", "action": "loadData", "type": "query" }
			]
			},
			{ "sender": "CreateReportQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "ReportsScheduleSettingsQuery", "action": "loadData", "type": "query" }
			]
			},
			
			{ "sender": "setReportsScheduleEnabledQuery", "event": "onloadstarted", "type": "query", "receivers": [
					{ "id": "reportsFilterBtns", "page": "mainPage", "action": "showLoading", "type": "control" },
					{ "id": "ReportsGridControl", "page": "mainPage", "action": "showLoading", "type": "control" }
			]
			},
			{ "sender": "setReportsScheduleEnabledQuery", "event": "onloadcomplete", "type": "query", "receivers": [
					{ "id": "reportsFilterBtns", "page": "mainPage", "action": "hideLoading", "type": "control" },
					{ "id": "ReportsGridControl", "page": "mainPage", "action": "hideLoading", "type": "control" }
			]
			},
			
			{ "sender": "ReportsListLoadQuery", "event": "onloadstarted", "type": "query", "receivers": [
					{ "id": "ReportsGridControl", "page": "mainPage", "action": "showLoading", "type": "control" }
			]
			},
			{ "sender": "ReportsListLoadQuery", "event": "onloadcomplete", "type": "query", "receivers": [
					{ "id": "ReportsGridControl", "page": "mainPage", "action": "hideLoading", "type": "control" }
			]
			},
			
			{ "sender": "btnDelete_ReportsTop", "event": "onclick", "type": "control", "receivers": [
					{ "id": "ReportsGridControl", "action": "deleteRows", "type": "control" }
			]
			},
			{ "sender": "ReportsGridControl", "event": "onrowsdelete", "type": "control", "receivers": [
					{ "id": "DeleteReportsQuery", "action": "loadData", "type": "query" }
			]
			},
			{ "sender": "ReportsGridControl", "event": "onrowselected", "type": "control", "receivers": [
					{ "id": ["ReportsListTopToolbar", "ReportsListBottomToolbar"], "action": "toggleButtons", "type": "control", "page": "mainPage" }
			]
			},
			
			{ "sender": "DeleteReportsQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "ReportsGridControl", "action": "resetData", "type": "control" },
					{ "id": "ReportsListLoadQuery", "action": "loadData", "type": "query" }
			]
			},	
			{ "sender": "DeleteReportsQuery", "event": "onerror", "type": "query", "receivers": [
					{ "id": "ReportsGridControl", "action": "applyError", "type": "control" },
					{ "id": "ReportsListLoadQuery", "action": "loadData", "type": "query" }
			]
			},	
			
			{ "sender": "ReportsGridControl", "event": "onrowselected", "type": "control", "receivers": [
					{ "id": ["ReportsListTopToolbar", "ReportsListBottomToolbar"], "action": "toggleButtons", "type": "control", "page": "mainPage" }
			]
			},
			{ "sender": "ReportsListTopToolbar", "event": "onactionsdisabled", "type": "control", "receivers": [
					{ "id": "btnDelete_ReportsTop", "page": "mainPage", "action": "disable", "type": "control" }
			]
			},
			{ "sender": "ReportsListTopToolbar", "event": "onsingleitemaction", "type": "control", "receivers": [
					{ "id": "btnDelete_ReportsTop", "page": "mainPage", "action": "enable", "type": "control" }
			]
			},
			{ "sender": "ReportsListTopToolbar", "event": "onmultipleitemsaction", "type": "control", "receivers": [
					{ "id": "btnDelete_ReportsTop", "page": "mainPage", "action": "enable", "type": "control" }
			]
			},
			
			{"sender": "reportsFilterBtns", "event": "onsettingschange", "type": "control", "receivers": [
					{ "id": "reportParamsDialog", "page": "reportParamsDialog", "action": "showDialog", "type": "page" },
					{ "id": "reportParamsForm", "page": "reportParamsDialog", "action": "setData", "type": "control" }
			]
			},
			{ "sender": "reportParamsForm", "event": "oncancel", "type": "control", "receivers": [
					{ "id": "reportParamsDialog", "page": "reportParamsDialog", "action": "closeDialog", "type": "page" }
			]
			},	
			{ "sender": "reportParamsForm",  "event": "onformsubmit", "type": "control", "receivers": [
					{ "id": "reportParamsForm", "page": "reportParamsDialog", "action": "showLoading", "type": "control" },
					{ "id": "CreateReportQuery", "action": "loadData", "type": "query" }
			]
			},
			{ "sender": "CreateReportQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "reportParamsForm", "page": "reportParamsDialog", "action": "hideLoading", "type": "control" },
					{ "id": "reportParamsDialog", "page": "reportParamsDialog", "action": "closeDialog", "type": "page" },
					{ "id": "ReportsListLoadQuery", "action": "loadData", "type": "query" }
			]
			},
			{ "sender": "CreateReportQuery", "event": "onerror", "type": "query", "receivers": [
					{ "id": "reportParamsForm", "page": "reportParamsDialog", "action": "hideLoading", "type": "control" },
					{ "id": "reportParamsDialog", "page": "reportParamsDialog", "action": "applyError", "type": "control" }
			]
			},
		
			{"sender": "pnlSettingsUpdateContent", "event": "onshow", "type": "control", "receivers": [
					{ "id": "getUpdateProxySettingsQuery", "action": "loadData", "type": "query" },
					{ "id": "getUpdateSettingsQuery", "action": "loadData", "type": "query" }
					
				]
			},
			{"sender": "pnlSettingsUpdateContent", "event": "onhide", "type": "control", "receivers": [
					{ "id": "getUpdaterDownloadProgressQuery", "action": "stopTimeout", "type": "query" }
				]
			},
			{ "sender": "getUpdateSettingsQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "baseUpdateSettingsPreview", "page": "mainPage", "action": "applyValue", "type": "control" }
				]
			},
			{ "sender": "getUpdateProxySettingsQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "updateProxySettingsPreview", "page": "mainPage", "action": "applyValue", "type": "control" },
					{ "id": "contextChangeAdapter", "page": "mainPage", "action": "applyAppSettings", "type": "control" }
				]
			},
			{ "sender": "getUpdateSettingsQuery", "event": "onloadcomplete", "type": "query", "receivers": [
					{ "id": "pnlSettingsUpdateContent", "page": "mainPage", "action": "hideLoading", "type": "control" }
			]
			},
			{ "sender": "getUpdateSettingsQuery", "event": "onloadstarted", "type": "query", "receivers": [
					{ "id": "pnlSettingsUpdateContent", "page": "mainPage", "action": "showLoading", "type": "control" }
			]
			},
			{"sender": "AppProxySettings", "event": ["onsettingenable","onsettingdisable"], "type": "control", "receivers": [
					{ "id": "pnlMiscSettingsContent", "page": "mainPage", "action": "showLoading", "type": "control" },
					{ "id": "saveAppProxySettingsQuery", "action": "loadData", "type": "query" }
				]
			},
			{"sender": "updateProxySettings", "event": ["onsettingenable","onsettingdisable"], "type": "control", "receivers": [
					{ "id": "pnlSettingsUpdateContent", "page": "mainPage", "action": "showLoading", "type": "control" },
					{ "id": "saveAppProxySettingsQuery1", "action": "loadData", "type": "query" }
				]
			},
			
			{ "sender": "ProxySettingsPreview", "event": "oncnnchange", "type": "control", "receivers": [
					{ "id": "ProxySettingsDialog", "page": "ProxySettingsDialog", "action": "showDialog", "type": "page" },
					{ "id": "ProxySettingsForm1", "page": "ProxySettingsDialog", "action": "hide", "type": "control" },
					{ "id": "ProxySettingsForm", "page": "ProxySettingsDialog", "action": ["show","setData"], "type": "control" }
				]
			},
			{ "sender": "updateProxySettingsPreview", "event": "oncnnchange", "type": "control", "receivers": [
					{ "id": "ProxySettingsDialog", "page": "ProxySettingsDialog", "action": "showDialog", "type": "page" },
					{ "id": "ProxySettingsForm", "page": "ProxySettingsDialog", "action": "hide", "type": "control" },
					{ "id": "ProxySettingsForm1", "page": "ProxySettingsDialog", "action": ["show","setData"], "type": "control" }
				]
			},
			{ "sender": ["ProxySettingsForm", "ProxySettingsForm1"], "event": "oncancel", "type": "control", "receivers": [
					{ "id": "ProxySettingsDialog", "page": "ProxySettingsDialog", "action": "closeDialog", "type": "page" }
			]
			},
			
			{ "sender": "ProxySettingsForm", "event": "onformsubmit", "type": "control", "receivers": [
					{ "id": "ProxySettingsForm", "page": "ProxySettingsDialog", "action": "showLoading", "type": "control" },
					{ "id": "saveAppProxySettingsQuery", "action": "loadData", "type": "query" }
				]
			},
			{ "sender": "ProxySettingsForm1", "event": "onformsubmit", "type": "control", "receivers": [
					{ "id": "ProxySettingsForm1", "page": "ProxySettingsDialog", "action": "showLoading", "type": "control" },
					{ "id": "saveAppProxySettingsQuery1", "action": "loadData", "type": "query" }
				]
			},
			{ "sender": "saveAppProxySettingsQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "ProxySettingsDialog", "page": "ProxySettingsDialog", "action": "closeDialog", "type": "page" },
					{ "id": "pnlMiscSettingsContent", "page": "mainPage", "action": "showLoading", "type": "control" },
					{ "id": "getAppEmailSettingsQuery", "action": "loadData", "type": "query" }
				]
			},
			{ "sender": ["saveAppProxySettingsQuery","saveAppProxySettingsQuery1"], "event": "onloadcomplete", "type": "query", "receivers": [
					{ "id": ["ProxySettingsForm","ProxySettingsForm1"], "page": "ProxySettingsDialog", "action": "hideLoading", "type": "control" }
				]
			},
			{ "sender": "saveAppProxySettingsQuery1", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "ProxySettingsDialog", "page": "ProxySettingsDialog", "action": "closeDialog", "type": "page" },
					{ "id": "pnlSettingsUpdateContent", "page": "mainPage", "action": "hideLoading", "type": "control" },
					{ "id": "getUpdateProxySettingsQuery", "action": "loadData", "type": "query" }
				]
			},
			{ "sender": "baseUpdateSettingsPreview", "event": "onsourcechange", "type": "control", "receivers": [
					{ "id": "baseUpdateSourceSettingsDialog", "page": "baseUpdateSourceSettingsDialog", "action": "showDialog", "type": "page" },
					{ "id": "baseUpdateSourceSettingsForm", "page": "baseUpdateSourceSettingsDialog", "action": "setData", "type": "control" }
			]
			},
			{ "sender": "baseUpdateSourceSettingsForm", "event": "oncancel", "type": "control", "receivers": [
					{ "id": "baseUpdateSourceSettingsDialog", "page": "baseUpdateSourceSettingsDialog", "action": "closeDialog", "type": "page" }
			]
			},
			{ "sender": "baseUpdateSourceSettingsForm", "event": "onformsubmit", "type": "control", "receivers": [
					{ "id": "saveUpdateSettingsQuery", "action": "loadData", "type": "query" }
			]
			},
			{ "sender": "saveUpdateSettingsQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "baseUpdateSourceSettingsDialog", "page": "baseUpdateSourceSettingsDialog", "action": "closeDialog", "type": "page" },
					{ "id": "getUpdateSettingsQuery", "action": "loadData", "type": "query" }
			]
			},
			{ "sender": "saveUpdateSettingsQuery", "event": "onerror", "type": "query", "receivers": [
					{ "id": "baseUpdateSourceSettingsForm", "page": "baseUpdateSourceSettingsDialog", "action": "applyError", "type": "control" },
					{ "id": "getUpdateSettingsQuery", "action": "loadData", "type": "query" }
			]
			},
			{ "sender": "baseUpdateSettingsPreview", "event": "onschedulechange", "type": "control", "receivers": [
					{ "id": "baseUpdateScheduleSettingsDialog", "page": "baseUpdateScheduleSettingsDialog", "action": "showDialog", "type": "page" },
					{ "id": "baseUpdateScheduleSettingsForm", "page": "baseUpdateScheduleSettingsDialog", "action": "setData", "type": "control" }
			]
			},
			{ "sender": "baseUpdateScheduleSettingsForm", "event": "oncancel", "type": "control", "receivers": [
					{ "id": "baseUpdateScheduleSettingsDialog", "page": "baseUpdateScheduleSettingsDialog", "action": "closeDialog", "type": "page" }
			]
			},
				{ "sender": "baseUpdateScheduleSettingsForm", "event": "onformsubmit", "type": "control", "receivers": [
						{ "id": "saveUpdateScheduleSettingsQuery", "action": "loadData", "type": "query" }
				]
				},
				{ "sender": "saveUpdateScheduleSettingsQuery", "event": "onsuccess", "type": "query", "receivers": [
						{ "id": "baseUpdateScheduleSettingsDialog", "page": "baseUpdateScheduleSettingsDialog", "action": "closeDialog", "type": "page" },
						{ "id": "getUpdateSettingsQuery", "action": "loadData", "type": "query" }
				]
				},
				{ "sender": "saveUpdateScheduleSettingsQuery", "event": "onerror", "type": "query", "receivers": [
						{ "id": "baseUpdateScheduleSettingsForm", "page": "baseUpdateScheduleSettingsDialog", "action": "applyError", "type": "control" },
						{ "id": "getUpdateSettingsQuery", "action": "loadData", "type": "query" }					
				]
				},
			
			{ "sender": "ksnProtectionPreview", "event": "onsettingschange", "type": "control", "receivers": [
					{ "id": "ksnLicenseDialog", "page": "ksnLicenseDialog", "action": "showDialog", "type": "page" },
					{ "id": "ksnLicenseAcceptForm", "page": "ksnLicenseDialog", "action": "setData", "type": "control" },
					{ "id": "getKsnLicenseTextQuery", "action": "loadData", "type": "query" }
				]
			},
			{ "sender": "pnlBackupSettingsContent", "event": "onshow", "type": "control", "receivers": [
					{ "id": "getBackupSettingsQuery", "action": "loadData", "type": "query" }
			]
			},
			{ "sender": "getBackupSettingsQuery", "event": "onloadcomplete", "type": "query", "receivers": [
					{ "id": "pnlBackupSettingsContent", "page": "mainPage", "action": "hideLoading", "type": "control" }
			]
			},
			{ "sender": "getBackupSettingsQuery", "event": "onloadstarted", "type": "query", "receivers": [
					{ "id": "pnlBackupSettingsContent", "page": "mainPage", "action": "showLoading", "type": "control" }
			]
			},
			{ "sender": "getBackupSettingsQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "backupSettingsPreview", "page": "mainPage", "action": "applyValue", "type": "control" }
			]
			},
			{"sender": "backupSettingsPreview", "event": "onsettingschange", "type": "control", "receivers": [
					{ "id": "backupSettingsDialog", "page": "backupSettingsDialog", "action": "showDialog", "type": "page" },
					{ "id": "backupSettingsForm", "page": "backupSettingsDialog", "action": "setData", "type": "control" }
			]
			},
			{ "sender": "backupSettingsForm", "event": "oncancel", "type": "control", "receivers": [
					{ "id": "backupSettingsDialog", "page": "backupSettingsDialog", "action": "closeDialog", "type": "page" }
			]
			},
			{ "sender": "backupSettingsForm", "event": "onformsubmit", "type": "control", "receivers": [
					{ "id": "saveBackupSettingsQuery", "action": "loadData", "type": "query" }
				]
			},
			{ "sender": "saveBackupSettingsQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "backupSettingsDialog", "page": "backupSettingsDialog", "action": "closeDialog", "type": "page" },
					{ "id": "getBackupSettingsQuery", "action": "loadData", "type": "query" }
			]
			},
			{ "sender": "saveBackupSettingsQuery", "event": "onerror", "type": "query", "receivers": [
					{ "id": "backupSettingsForm", "page": "backupSettingsDialog", "action": "applyError", "type": "control" },
					{ "id": "getBackupSettingsQuery", "action": "loadData", "type": "query" }
			]
			},
			
		
			{ "sender": "pnlSNMPSettingsContent", "event": "onshow", "type": "control", "receivers": [
					{ "id": "getSNMPSettingsQuery", "action": "loadData", "type": "query" }
			]
			},
			{ "sender": "getSNMPSettingsQuery", "event": "onloadcomplete", "type": "query", "receivers": [
					{ "id": "pnlSNMPSettingsContent", "page": "mainPage", "action": "hideLoading", "type": "control" }
			]
			},
			{ "sender": "getSNMPSettingsQuery", "event": "onloadstarted", "type": "query", "receivers": [
					{ "id": "pnlSNMPSettingsContent", "page": "mainPage", "action": "showLoading", "type": "control" }
			]
			},
			{ "sender": "getSNMPSettingsQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "connectionSNMPPreview", "page": "mainPage", "action": "applyValue", "type": "control" },
					{ "id": "trapSuiteSNMPPreview", "page": "mainPage", "action": "applyValue", "type": "control" }
			]
			},
			{"sender": ["trapSuiteSNMPSettings","enableSNMPSettings"], "event": ["onsettingenable","onsettingdisable"], "type": "control", "receivers": [
					{ "id": "pnlSNMPSettingsContent", "page": "mainPage", "action": "showLoading", "type": "control" },
					{ "id": "saveSNMPSettingsQuery", "action": "loadData", "type": "query" }
				]
			},
			
			{ "sender": "saveSNMPSettingsQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "snmpCnnSettingsDialog", "page": "snmpCnnSettingsDialog", "action": "closeDialog", "type": "page" },
					{ "id": "trapSuiteSNMPSettingsDialog", "page": "snmpCnnSettingsDialog", "action": "closeDialog", "type": "page" },
					{ "id": "pnlSNMPSettingsContent", "page": "mainPage", "action": "showLoading", "type": "control" },
					{ "id": "getSNMPSettingsQuery", "action": "loadData", "type": "query" }
			]
			},
			{ "sender": "saveSNMPSettingsQuery", "event": "onerror", "type": "query", "receivers": [
					{ "id": "snmpCnnSettingsForm", "page": "snmpCnnSettingsDialog", "action": "applyError", "type": "control" },
					{ "id": "getSNMPSettingsQuery", "action": "loadData", "type": "query" }
			]
			},
			
			
			{"sender": "connectionSNMPPreview", "event": "onsettingschange", "type": "control", "receivers": [
					{ "id": "snmpCnnSettingsDialog", "page": "snmpCnnSettingsDialog", "action": "showDialog", "type": "page" },
					{ "id": "snmpCnnSettingsForm", "page": "snmpCnnSettingsDialog", "action": "setData", "type": "control" }
			]
			},
			{ "sender": ["snmpCnnSettingsForm","trapSuiteSNMPPreview_ErrorUpdate","trapSuiteSNMPPreview_Bases","trapSuiteSNMPPreview_Backup",
						"trapSuiteSNMPPreview_License","trapSuiteSNMPPreview_Task","trapSuiteSNMPPreview_Misc","trapSuiteSNMPPreview_BasesError","trapSuiteSNMPPreview_ExternalServiceError"], "event": "oncancel", "type": "control", "receivers": [
					{ "id": "snmpCnnSettingsDialog", "page": "snmpCnnSettingsDialog", "action": "closeDialog", "type": "page" },
					{ "id": "trapSuiteSNMPSettingsDialog", "page": "snmpCnnSettingsDialog", "action": "closeDialog", "type": "page" }
			]
			},
			
			{"sender": "trapSuiteSNMPPreview_ErrorUpdate", "event": "onsettingschange", "type": "control", "receivers": [
					{ "id": "trapSuiteSNMPSettingsForm", "page": "trapSuiteSNMPSettingsDialog", "action": "viewErrorUpdate", "type": "control" },
					{ "id": "trapSuiteSNMPSettingsDialog", "page": "trapSuiteSNMPSettingsDialog", "action": "showDialog", "type": "page" },
					{ "id": "trapSuiteSNMPSettingsForm", "page": "trapSuiteSNMPSettingsDialog", "action": "setData", "type": "control" }
			]
			},
			{"sender": "trapSuiteSNMPPreview_Bases", "event": "onsettingschange", "type": "control", "receivers": [
					{ "id": "trapSuiteSNMPSettingsForm", "page": "trapSuiteSNMPSettingsDialog", "action": "viewBases", "type": "control" },
					{ "id": "trapSuiteSNMPSettingsDialog", "page": "trapSuiteSNMPSettingsDialog", "action": "showDialog", "type": "page" },
					{ "id": "trapSuiteSNMPSettingsForm", "page": "trapSuiteSNMPSettingsDialog", "action": "setData", "type": "control" }
			]
			},
			{"sender": "trapSuiteSNMPPreview_Backup", "event": "onsettingschange", "type": "control", "receivers": [
					{ "id": "trapSuiteSNMPSettingsForm", "page": "trapSuiteSNMPSettingsDialog", "action": "viewBackup", "type": "control" },
					{ "id": "trapSuiteSNMPSettingsDialog", "page": "trapSuiteSNMPSettingsDialog", "action": "showDialog", "type": "page" },
					{ "id": "trapSuiteSNMPSettingsForm", "page": "trapSuiteSNMPSettingsDialog", "action": "setData", "type": "control" }
			]
			},
			{"sender": "trapSuiteSNMPPreview_License", "event": "onsettingschange", "type": "control", "receivers": [
					{ "id": "trapSuiteSNMPSettingsForm", "page": "trapSuiteSNMPSettingsDialog", "action": "viewLicense", "type": "control" },
					{ "id": "trapSuiteSNMPSettingsDialog", "page": "trapSuiteSNMPSettingsDialog", "action": "showDialog", "type": "page" },
					{ "id": "trapSuiteSNMPSettingsForm", "page": "trapSuiteSNMPSettingsDialog", "action": "setData", "type": "control" }
			]
			},
			{"sender": "trapSuiteSNMPPreview_Task", "event": "onsettingschange", "type": "control", "receivers": [
					{ "id": "trapSuiteSNMPSettingsForm", "page": "trapSuiteSNMPSettingsDialog", "action": "viewTask", "type": "control" },
					{ "id": "trapSuiteSNMPSettingsDialog", "page": "trapSuiteSNMPSettingsDialog", "action": "showDialog", "type": "page" },
					{ "id": "trapSuiteSNMPSettingsForm", "page": "trapSuiteSNMPSettingsDialog", "action": "setData", "type": "control" }
			]
			},
			{"sender": "trapSuiteSNMPPreview_Misc", "event": "onsettingschange", "type": "control", "receivers": [
					{ "id": "trapSuiteSNMPSettingsForm", "page": "trapSuiteSNMPSettingsDialog", "action": "viewMisc", "type": "control" },
					{ "id": "trapSuiteSNMPSettingsDialog", "page": "trapSuiteSNMPSettingsDialog", "action": "showDialog", "type": "page" },
					{ "id": "trapSuiteSNMPSettingsForm", "page": "trapSuiteSNMPSettingsDialog", "action": "setData", "type": "control" }
			]
			},
			{"sender": "trapSuiteSNMPPreview_BasesError", "event": "onsettingschange", "type": "control", "receivers": [
					{ "id": "trapSuiteSNMPSettingsForm", "page": "trapSuiteSNMPSettingsDialog", "action": "viewBasesError", "type": "control" },
					{ "id": "trapSuiteSNMPSettingsDialog", "page": "trapSuiteSNMPSettingsDialog", "action": "showDialog", "type": "page" },
					{ "id": "trapSuiteSNMPSettingsForm", "page": "trapSuiteSNMPSettingsDialog", "action": "setData", "type": "control" }
			]
			},
			{"sender": "trapSuiteSNMPPreview_ExternalServiceError", "event": "onsettingschange", "type": "control", "receivers": [
					{ "id": "trapSuiteSNMPSettingsForm", "page": "trapSuiteSNMPSettingsDialog", "action": "viewExternalServiceError", "type": "control" },
					{ "id": "trapSuiteSNMPSettingsDialog", "page": "trapSuiteSNMPSettingsDialog", "action": "showDialog", "type": "page" },
					{ "id": "trapSuiteSNMPSettingsForm", "page": "trapSuiteSNMPSettingsDialog", "action": "setData", "type": "control" }
			]
			},
			{ "sender": "trapSuiteSNMPSettingsForm", "event": "oncancel", "type": "control", "receivers": [
					{ "id": "trapSuiteSNMPSettingsDialog", "page": "trapSuiteSNMPSettingsDialog", "action": "closeDialog", "type": "page" }
			]
			},
			{ "sender": ["snmpCnnSettingsForm","trapSuiteSNMPSettingsForm"], "event": "onformsubmit", "type": "control", "receivers": [
					{ "id": "saveSNMPSettingsQuery", "action": "loadData", "type": "query" }
				]
			},
			
		
			{ "sender": "pnlMiscSettingsContent", "event": "onshow", "type": "control", "receivers": [
					{ "id": "getEventLoggerSettingsQuery", "action": "loadData", "type": "query" },
					{ "id": "getAppEmailSettingsQuery", "action": "loadData", "type": "query" },
					{ "id": "getProtectionMiscSettingsQuery", "action": "loadData", "type": "query" },
					{ "id": "getHelpdeskAccSettingsQuery", "action": "loadData", "type": "query" },
					{ "id": "getHelpdeskBackupSettingsQuery", "action": "loadData", "type": "query" }
					
			]
			},
			{ "sender": ["getEventLoggerSettingsQuery","getAppEmailSettingsQuery","getProtectionMiscSettingsQuery", "getHelpdeskAccSettingsQuery", "getHelpdeskBackupSettingsQuery", "saveHelpdeskAccSettingsQuery"], "event": "onloadcomplete", "type": "query", "receivers": [
					{ "id": "pnlMiscSettingsContent", "page": "mainPage", "action": "hideLoading", "type": "control" }
			]
			},
			{ "sender": ["getEventLoggerSettingsQuery","getAppEmailSettingsQuery","getProtectionMiscSettingsQuery", "getHelpdeskAccSettingsQuery", "getHelpdeskBackupSettingsQuery", "saveHelpdeskAccSettingsQuery"], "event": "onloadstarted", "type": "query", "receivers": [
					{ "id": "pnlMiscSettingsContent", "page": "mainPage", "action": "showLoading", "type": "control" }
			]
			},
			
			{ "sender": "getEventLoggerSettingsQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "miscSettingsPreviewEventLogger", "page": "mainPage", "action": "applyValue", "type": "control" }
			]
			},
			{ "sender": "getProtectionMiscSettingsQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "miscSettingsPreviewPerformance", "page": "mainPage", "action": "applyValue", "type": "control" },
					{ "id": "miscSettingsPreviewHeaderMarks", "page": "mainPage", "action": "applyValue", "type": "control" },
					{ "id": "miscSettingsPreviewPlaceholder", "page": "mainPage", "action": "applyValue", "type": "control" }
			]
			},
			{ "sender": "getAppEmailSettingsQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "miscSettingsPreviewEMail", "page": "mainPage", "action": "applyValue", "type": "control" },
					{ "id": "helpdeskSettingsForm", "page": "helpdeskSettingsDialog", "action": "setAppSettings", "type": "control" },
					{ "id": "contextChangeAdapter", "page": "mainPage", "action": "applyAppSettings", "type": "control" }
				]
			},
			{ "sender": "getHelpdeskAccSettingsQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "miscHelpdeskPreview", "page": "mainPage", "action": "applyValue", "type": "control" },
					{ "id": "helpdeskSettingsForm", "page": "helpdeskSettingsDialog", "action": "setUserName", "type": "control" }
				]
			},
			{ "sender": "getHelpdeskBackupSettingsQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "miscHelpdeskBackupPreview", "page": "mainPage", "action": "applyValue", "type": "control" },
					{ "id": "helpdeskSettingsForm", "page": "helpdeskSettingsDialog", "action": "setCanForvardMalware", "type": "control" }
				]
			},
			{"sender": "miscSettingsHelpdesk", "event": ["onsettingenable","onsettingdisable"], "type": "control", "receivers": [
					{ "id": "saveHelpdeskAppSettingsQuery", "action": "loadData", "type": "query" }
				]
			},
			{"sender": "helpdeskSettingsForm", "event": "onformsubmit", "type": "control", "receivers": [
					{ "id": "saveHelpdeskAccSettingsQuery", "action": "loadData", "type": "query" }
				]
			},
			{"sender": ["miscHelpdeskPreview", "miscHelpdeskBackupPreview", "miscHelpdeskBWlEditPreview"], "event": "onsettingschange", "type": "control", "receivers": [
					{ "id": "helpdeskSettingsDialog", "action": "showDialog", "type": "page" },
					{ "id": "helpdeskSettingsForm", "page": "helpdeskSettingsDialog", "action": "setData", "type": "control" }
				]
			},
			{ "sender": "saveHelpdeskAccSettingsQuery", "event": "onsuccess", "type": "query", "receivers": [
				{ "id": "saveHelpdeskAppSettingsQuery", "action": "loadData", "type": "query" }
			]},
			{ "sender": "saveHelpdeskAppSettingsQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "helpdeskSettingsDialog", "page": "helpdeskSettingsDialog", "action": "closeDialog", "type": "page" },
					{ "id": "getHelpdeskAccSettingsQuery", "action": "loadData", "type": "query" },
					{ "id": ["getAppEmailSettingsQuery", "getHelpdeskAccSettingsQuery", "getHelpdeskBackupSettingsQuery"], "action": "loadData", "type": "query" }
				]
			},
			{ "sender": "saveHelpdeskAccSettingsQuery", "event": "onerror", "type": "query", "receivers": [
					{ "id": "helpdeskSettingsForm", "page": "helpdeskSettingsDialog", "action": "applyError", "type": "control" },
					{ "id": "getHelpdeskAccSettingsQuery", "action": "loadData", "type": "query" }
				]
			},
			{"sender": "miscSettingsPreviewEMail", "event": "onproductmailchange", "type": "control", "receivers": [
					{ "id": "ProductMailSettingsDialog", "page": "ProductMailSettingsDialog", "action": "showDialog", "type": "page" },
					{ "id": "ProductMailSettingsForm", "page": "ProductMailSettingsDialog", "action": "setData", "type": "control" }
			]
			},
			{"sender": "miscSettingsPreviewEMail", "event": "onadminmailchange", "type": "control", "receivers": [
					{ "id": "AdminEMailSettingsDialog", "page": "AdminEMailSettingsDialog", "action": "showDialog", "type": "page" },
					{ "id": "AdminEMailSettingsForm", "page": "AdminEMailSettingsDialog", "action": "setData", "type": "control" }
			]
			},
			{ "sender": ["ProductMailSettingsForm","AdminEMailSettingsForm"], "event": "oncancel", "type": "control", "receivers": [
					{ "id": "ProductMailSettingsDialog", "page": "ProductMailSettingsDialog", "action": "closeDialog", "type": "page" }
			]
			},
			{ "sender": ["ProductMailSettingsForm","AdminEMailSettingsForm", "scClusterIdEditForm"], "event": "onformsubmit", "type": "control", "receivers": [
					{ "id": "setAppEmailSettingsQuery", "action": "loadData", "type": "query" }
				]
			},
			{ "sender": "setAppEmailSettingsQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "ProductMailSettingsDialog", "page": "ProductMailSettingsDialog", "action": "closeDialog", "type": "page" },
					{ "id": "AdminEMailSettingsDialog", "page": "AdminEMailSettingsDialog", "action": "closeDialog", "type": "page" },
					{ "id": "scClusterIdEditDialog", "page": "scClusterIdEditDialog", "action": "closeDialog", "type": "page" },
					{ "id": "pnlMiscSettingsContent", "page": "mainPage", "action": "showLoading", "type": "control" },
					{ "id": "getAppEmailSettingsQuery", "action": "loadData", "type": "query" }
			]
			},
			{ "sender": "setAppEmailSettingsQuery", "event": "onerror", "type": "query", "receivers": [
					{ "id": "ProductMailSettingsForm", "page": "ProductMailSettingsDialog", "action": "applyError", "type": "control" },
					{ "id": "AdminEMailSettingsForm", "page": "AdminEMailSettingsDialog", "action": "applyError", "type": "control" },
					{ "id": "scClusterIdEditForm", "page": "scClusterIdEditDialog", "action": "applyError", "type": "control" }
				]
			},
			{ "sender": "setAppEmailSettingsQuery", "event": "onloadstarted", "type": "query", "receivers": [
					{ "id": "ProductMailSettingsForm", "page": "ProductMailSettingsDialog", "action": "showLoading", "type": "control" },
					{ "id": "AdminEMailSettingsForm", "page": "AdminEMailSettingsDialog", "action": "showLoading", "type": "control" },
					{ "id": "scClusterIdEditForm", "page": "scClusterIdEditDialog", "action": "showLoading", "type": "control" }
				]
			},
			{ "sender": "setAppEmailSettingsQuery", "event": "onloadcomplete", "type": "query", "receivers": [
					{ "id": "ProductMailSettingsForm", "page": "ProductMailSettingsDialog", "action": "hideLoading", "type": "control" },
					{ "id": "AdminEMailSettingsForm", "page": "AdminEMailSettingsDialog", "action": "hideLoading", "type": "control" },
					{ "id": "scClusterIdEditForm", "page": "scClusterIdEditDialog", "action": "hideLoading", "type": "control" }
				]
			},
			{"sender": "miscSettingsPreviewScIntegration", "event": "onsettingschange", "type": "control", "receivers": [
					{ "id": "scClusterIdEditDialog", "page": "scClusterIdEditDialog", "action": "showDialog", "type": "page" },
					{ "id": "scClusterIdEditForm", "page": "scClusterIdEditDialog", "action": "setData", "type": "control" }
				]
			},
			{"sender": "miscSettingsPreviewEventLogger", "event": "onsettingschange", "type": "control", "receivers": [
					{ "id": "EventLoggerEditDialog", "page": "EventLoggerEditDialog", "action": "showDialog", "type": "page" },
					{ "id": "eventLoggerEditForm", "page": "EventLoggerEditDialog", "action": "setData", "type": "control" }
			]
			},
			{ "sender": "eventLoggerEditForm", "event": "oncancel", "type": "control", "receivers": [
					{ "id": "EventLoggerEditDialog", "page": "EventLoggerEditDialog", "action": "closeDialog", "type": "page" }
			]
			},
			{ "sender": "eventLoggerEditForm", "event": "onformsubmit", "type": "control", "receivers": [
					{ "id": "setEventLoggerSettingsQuery", "action": "loadData", "type": "query" }
				]
			},
			{ "sender": "setEventLoggerSettingsQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "EventLoggerEditDialog", "page": "EventLoggerEditDialog", "action": "closeDialog", "type": "page" },
					{ "id": "pnlMiscSettingsContent", "page": "mainPage", "action": "showLoading", "type": "control" },
					{ "id": "getEventLoggerSettingsQuery", "action": "loadData", "type": "query" }
			]
			},
			{ "sender": "setEventLoggerSettingsQuery", "event": "onerror", "type": "query", "receivers": [
					{ "id": "eventLoggerEditForm", "page": "EventLoggerEditDialog", "action": "applyError", "type": "control" }
			]
			},
			
			{"sender": "miscSettingsPreviewPerformance", "event": "onsettingschange", "type": "control", "receivers": [
					{ "id": "PerformanceEditDialog", "page": "PerformanceEditDialog", "action": "showDialog", "type": "page" },
					{ "id": "PerformanceEditForm", "page": "PerformanceEditDialog", "action": "setData", "type": "control" }
			]
			},
			{"sender": "miscSettingsPreviewHeaderMarks", "event": "onsettingschange", "type": "control", "receivers": [
					{ "id": "HeaderMarksEditDialog", "page": "HeaderMarksEditDialog", "action": "showDialog", "type": "page" },
					{ "id": "HeaderMarksEditForm", "page": "HeaderMarksEditDialog", "action": "setData", "type": "control" }
			]
			},
			
			{"sender": "miscSettingsPreviewPlaceholder", "event": "onsettingschange", "type": "control", "receivers": [
					{ "id": "PlaceholderEditDialog", "page": "PlaceholderEditDialog", "action": "showDialog", "type": "page" },
					{ "id": "PlaceholderEditForm", "page": "PlaceholderEditDialog", "action": "setData", "type": "control" }
			]
			},
			{"sender": "miscSettingsPreviewImportExport", "event": "onimportsettings", "type": "control", "receivers": [
					{ "id": "importSettingsDialog", "page": "importSettingsDialog", "action": "showDialog", "type": "page" }
				]
			},
			{"sender": "miscSettingsPreviewImportExport", "event": "onrestartproduct", "type": "control", "receivers": [
					{ "id": "restartProductConfirmDialog", "page": "restartProductConfirmDialog", "action": "showDialog", "type": "page" },
					{ "id": ["btnCloseRestartDlg", "lblRestartConfirmDlgDone"], "page": "restartProductConfirmDialog", "action": "hide", "type": "control" }
				]
			},
			{"sender": ["btnCancelRestartDlg","btnCloseRestartDlg"], "event": "onclick", "type": "control", "receivers": [
					{ "id": "restartProductConfirmDialog", "page": "restartProductConfirmDialog", "action": "closeDialog", "type": "page" }
				]
			},
			{"sender": "btnRestartProduct", "event": "onclick", "type": "control", "receivers": [
					{ "id": "btnRestartProduct", "page": "restartProductConfirmDialog", "action": "hide", "type": "control" },
					{ "id": "restartProductQuery", "action": "loadData", "type": "query" }
				]
			},
			{"sender": "importSettingsForm", "event": "onrestartproduct", "type": "control", "receivers": [
					{ "id": "importRestartProductQuery", "type": "query", "action": "loadData" }
				]
			},
			{ "sender": "restartProductQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": ["lblRestartConfirmDlgWarn", "btnCancelRestartDlg"], "page": "restartProductConfirmDialog", "action": "hide", "type": "control" },
					{ "id": ["btnCloseRestartDlg", "lblRestartConfirmDlgDone"], "page": "restartProductConfirmDialog", "action": "show", "type": "control" }
				]
			},
			{"sender": "importSettingsForm", "event": "onsettingsupload", "type": "control", "receivers": [
					{ "id": "importSettingsForm", "page": "importSettingsDialog", "action": "showLoading", "type": "control" },
					{ "id": "uploadSettingsQuery", "type": "query", "action": "uploadData" }
				]
			},
			{ "sender": "uploadSettingsQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "importSettingsForm", "page": "importSettingsDialog", "action": ["hideLoading", "setUploadeFinished"], "type": "control" }
				]
			},
			{ "sender": "uploadSettingsQuery", "event": "onerror", "type": "query", "receivers": [
					{ "id": "importSettingsForm", "page": "importSettingsDialog", "action": ["hideLoading", "setUploadeFailed"], "type": "control" }
				]
			},
			{"sender": "miscSettingsPreviewImportExport", "event": "onexportsettings", "type": "control", "receivers": [
					{ "id": "exportSettingsDialog", "page": "exportSettingsDialog", "action": "showDialog", "type": "page" }
				]
			},
			{"sender": "exportSettingsForm", "event": "onsettingsload", "type": "control", "receivers": [
					{"id": "downloadSettingsQuery", "type": "query", "action": "loadFile"}
				]
			},
			{ "sender": "PerformanceEditForm", "event": "oncancel", "type": "control", "receivers": [
					{ "id": "PerformanceEditDialog", "page": "PerformanceEditDialog", "action": "closeDialog", "type": "page" }
			]
			},
			{ "sender": "HeaderMarksEditForm", "event": "oncancel", "type": "control", "receivers": [
					{ "id": "HeaderMarksEditDialog", "page": "HeaderMarksEditDialog", "action": "closeDialog", "type": "page" }
			]
			},
			
			{ "sender": "PlaceholderEditForm", "event": "oncancel", "type": "control", "receivers": [
					{ "id": "PlaceholderEditDialog", "page": "PlaceholderEditDialog", "action": "closeDialog", "type": "page" }
			]
			},
			{ "sender": ["PerformanceEditForm","HeaderMarksEditForm","FailureActionEditForm","PlaceholderEditForm"], "event": "onformsubmit", "type": "control", "receivers": [
					{ "id": "setProtectionMiscSettingsQuery", "action": "loadData", "type": "query" }
				]
			},
			{ "sender": "setProtectionMiscSettingsQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "PerformanceEditDialog", "page": "PerformanceEditDialog", "action": "closeDialog", "type": "page" },
					{ "id": "HeaderMarksEditDialog", "page": "HeaderMarksEditDialog", "action": "closeDialog", "type": "page" },
					{ "id": "PlaceholderEditDialog", "page": "PlaceholderEditDialog", "action": "closeDialog", "type": "page" },
					{ "id": "pnlMiscSettingsContent", "page": "mainPage", "action": "showLoading", "type": "control" },
					{ "id": "getProtectionMiscSettingsQuery", "action": "loadData", "type": "query" }
			]
			},
			{ "sender": "setProtectionMiscSettingsQuery", "event": "onerror", "type": "query", "receivers": [
					{ "id": "PerformanceEditForm", "page": "PerformanceEditDialog", "action": "applyError", "type": "control" },
					{ "id": "HeaderMarksEditForm", "page": "HeaderMarksEditDialog", "action": "applyError", "type": "control" },
					{ "id": "PlaceholderEditDialog", "page": "PlaceholderEditDialog", "action": "applyError", "type": "control"}
			]
			},
	
			
			{"sender": "ldapTypeSettings", "event": "onshow", "type": "control", "receivers": [
					{ "id": "pnlSettingsLdapContent", "page": "mainPage", "action": "showLoading", "type": "control" },
					{ "id": "getLdapSettingsQuery", "action": "loadData", "type": "query" },
					{ "id": "ldapBwAvailablePreview", "page": "mainPage", "action": ["disable", "setStatusNotAvailable"], "type": "control" }
			]
			},
			{ "sender": "ldapCnnAvailablePreview", "event": "ontestconnection", "type": "control", "receivers": [
					{ "id": "testLdapSettingsQuery", "action": "loadData", "type": "query" }
			]
			},
			{ "sender": "pnlSettingsLdapContent", "event": "onshow", "type": "control", "receivers": [
					{ "id": ["ldapCnnAvailablePreview","ldapCnnSettings","ldapAccessSettings","ldapBWListsSettings"], "action": "hide", "type": "control" }
			]
			},
			{ "sender": "ldapCnnAvailablePreview", "event": "onhidepriview", "type": "control", "receivers": [
					{ "id": ["ldapAccessSettings", "ldapBWListsSettings", "ldapCnnSettings"], "action": "hide", "type": "control" }
			]
			},
			{ "sender": "ldapCnnAvailablePreview", "event": "onshowcustompriview", "type": "control", "receivers": [
					{ "id": ["ldapCnnAvailablePreview","ldapCnnSettings","ldapAccessSettings","ldapBWListsSettings"], "action": "hide", "type": "control" },
					{ "id": ["ldapCnnAvailablePreview","ldapBWListsSettings"], "action": "show", "type": "control" }
			]
			},
			{ "sender": "ldapCnnAvailablePreview", "event": "onshowpriview", "type": "control", "receivers": [
					{ "id": [,"ldapBWListsSettings"], "action": "hide", "type": "control" },
					{ "id": [ "ldapCnnSettings","ldapAccessSettings", "ldapBWListsSettings"], "action": "show", "type": "control" }
					
			]
			},
			{ "sender": "testLdapSettingsQuery", "event": "onloadstarted", "type": "query", "receivers": [
					{ "id": "ldapCnnAvailablePreview", "page": "mainPage", "action": ["disable", "setStatusLoading"], "type": "control" }
			]
			},
			{ "sender": "testLdapSettingsQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "ldapCnnAvailablePreview", "page": "mainPage", "action": ["enable", "setStatusAvailable"], "type": "control" },
					{ "id": "ldapBwAvailablePreview", "page": "mainPage", "action": ["enable", "setStatusAvailable"], "type": "control" }
			]
			},
			{ "sender": "testLdapSettingsQuery", "event": "onerror", "type": "query", "receivers": [
					{ "id": "ldapCnnAvailablePreview", "page": "mainPage", "action": ["enable", "setStatusNotAvailable"], "type": "control" },
					{ "id": "ldapBwAvailablePreview", "page": "mainPage", "action": ["disable", "setStatusNotAvailable"], "type": "control" }
			]
			},
			{ "sender": "ldapTypeSettingsPreview", "event": "onsettingschange", "type": "control", "receivers": [
					{ "id": "ldapTypeSettingsDialog", "page": "ldapTypeSettingsDialog", "action": "showDialog", "type": "page" },
					{ "id": "ldapTypeSettingsForm", "page": "ldapTypeSettingsDialog", "action": "setData", "type": "control" }
			]
			},
			{ "sender": "ldapCnnSettingsPreview", "event": "onsettingschange", "type": "control", "receivers": [
					{ "id": "ldapCnnSettingsDialog", "page": "ldapCnnSettingsDialog", "action": "showDialog", "type": "page" },
					{ "id": "ldapCnnSettingsForm", "page": "ldapCnnSettingsDialog", "action": "setData", "type": "control" }
			]
			},
			{ "sender": "ldapAccessSettingsPreview", "event": "onsettingschange", "type": "control", "receivers": [
					{ "id": "ldapAccessSettingsDialog", "page": "ldapAccessSettingsDialog", "action": "showDialog", "type": "page" },
					{ "id": "ldapAccessSettingsForm", "page": "ldapAccessSettingsDialog", "action": "setData", "type": "control" }
			]
			},
			
			
			{ "sender": "getLdapSettingsQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "pnlSettingsLdapContent", "page": "mainPage", "action": "hideLoading", "type": "control" },
					{ "id": "ldapCnnSettingsPreview", "page": "mainPage", "action": "applyValue", "type": "control" },
					{ "id": "ldapTypeSettingsPreview", "page": "mainPage", "action": "applyValue", "type": "control" }
					
				]
			},
			{ "sender": "getLdapSettingsQuery", "event": "onerror", "type": "query", "receivers": [
				]
			},
			
			{ "sender": ["ldapTypeSettingsForm","ldapCnnSettingsForm", "ldapAccessSettingsForm"], "event": "onformsubmit", "type": "control", "receivers": [
					{ "id": "saveLdapSettingsQuery", "action": "loadData", "type": "query" }
			]
			},
			{ "sender": "ldapCnnSettingsForm", "event": "onchecksettings", "type": "control", "receivers": [
					{ "id": "checkLdapSettingsQuery", "action": "loadData", "type": "query" }
			]
			},
			
			{ "sender": "checkLdapSettingsQuery", "event": "onloadstarted", "type": "query", "receivers": [
					{ "id": "ldapCnnSettingsForm", "page": "ldapCnnSettingsDialog", "action": "setStatusLoading", "type": "control" }
			]
			},
			{ "sender": "checkLdapSettingsQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "ldapCnnSettingsForm", "page": "ldapCnnSettingsDialog", "action": "setStatusAvailable", "type": "control" }
				]
			},
			
			{ "sender": "checkLdapSettingsQuery", "event": "onerror", "type": "query", "receivers": [
					{ "id": "ldapCnnSettingsForm", "page": "ldapCnnSettingsDialog", "action": "setStatusNotAvailable", "type": "control" }
				]
			},
			
			
			
			
			
			{ "sender": "saveLdapSettingsQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "ldapTypeSettingsDialog", "page": "ldapTypeSettingsDialog", "action": "closeDialog", "type": "page" },
					{ "id": "ldapCnnSettingsDialog", "page": "ldapCnnSettingsDialog", "action": "closeDialog", "type": "page" },
					{ "id": "ldapAccessSettingsDialog", "page": "ldapAccessSettingsDialog", "action": "closeDialog", "type": "page" },
					{ "id": "pnlSettingsLdapContent", "page": "mainPage", "action": "showLoading", "type": "control" },
					{ "id": "getLdapSettingsQuery", "action": "loadData", "type": "query" }
			]
			},
			{ "sender": "saveLdapSettingsQuery", "event": "onerror", "type": "query", "receivers": [
					{ "id": "pnlSettingsLdapContent", "page": "mainPage", "action": "hideLoading", "type": "control" },
					{ "id": "ldapCnnSettingsDialog", "page": "ldapCnnSettings", "action": "applyError", "type": "control" },
					{ "id": "ldapAccessSettingsDialog", "page": "ldapCnnSettings", "action": "applyError", "type": "control" }
			]
			},
			{ "sender": "saveLdapSettingsQuery", "event": "onloadstarted", "type": "query", "receivers": [
					{ "id": "ldapTypeSettingsForm", "page": "ldapTypeSettingsDialog", "action": "showLoading", "type": "control" },
					{ "id": "ldapCnnSettingsForm", "page": "ldapCnnSettingsDialog", "action": "showLoading", "type": "control" },
					{ "id": "ldapAccessSettingsForm", "page": "ldapAccessSettingsDialog", "action": "showLoading", "type": "control" }
			]
			},
			{ "sender": "saveLdapSettingsQuery", "event": "onloadcomplete", "type": "query", "receivers": [
					{ "id": "ldapTypeSettingsDialog", "page": "ldapTypeSettingsDialog", "action": "hideLoading", "type": "control" },
					{ "id": "ldapCnnSettingsForm", "page": "ldapCnnSettingsDialog", "action": "hideLoading", "type": "control" },
					{ "id": "ldapAccessSettingsForm", "page": "ldapAccessSettingsDialog", "action": "hideLoading", "type": "control" }
			]
			},
			{"sender": "ldapBwAvailablePreview", "event": "onclick", "type": "control", "receivers": [
					{ "id": "usersBWListsEditDialog", "page": "usersBWListsEditDialog", "action": "showDialog", "type": "page" }
			]
			},
	
			{"sender": "pnlNotificationsSettingsContent", "event": "onshow", "type": "control", "receivers": [
					{ "id": "getNotificationSettingsQuery", "action": "loadData", "type": "query" },
					{ "id": "getNotifAppSettingsQuery", "action": "loadData", "type": "query" },
					{ "id": "getNotificationLicenserSettingsQuery", "action": "loadData", "type": "query" }
				]
			},
			{ "sender": "getNotificationSettingsQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "pnlNotificationsSettingsContent", "page": "mainPage", "action": "applyValue", "type": "control" }
			]
			},
			{ "sender": ["getNotificationSettingsQuery","getNotifAppSettingsQuery"], "event": "onloadstarted", "type": "query", "receivers": [
					{ "id": "pnlNotificationsSettingsContent", "page": "mainPage", "action": "showLoading", "type": "control" }
			]
			},
			{ "sender": ["getNotificationSettingsQuery","getNotifAppSettingsQuery"], "event": "onloadcomplete", "type": "query", "receivers": [
					{ "id": "pnlNotificationsSettingsContent", "page": "mainPage", "action": "hideLoading", "type": "control" }
			]
			},
			{ "sender": "getNotifAppSettingsQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "notificationSenderSettingsPreview", "page": "mainPage", "action": "applyValue", "type": "control" },
					{ "id": "contextChangeAdapter", "page": "mainPage", "action": "applyAppSettings", "type": "control" }
				]
			},
			
			{ "sender": "setNotifAppSettingsQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "getNotifAppSettingsQuery", "action": "loadData", "type": "query" },
					{ "id": "notificationEmailEditDialog", "page": "notificationEmailEditDialog", "action": "closeDialog", "type": "page" }
				]
			},
			{ "sender": "saveNotificationSettingsQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "getNotificationSettingsQuery", "action": "loadData", "type": "query" },
					{ "id": "notificationEditDialog", "page": "notificationEditDialog", "action": "closeDialog", "type": "page" }
				]
			},
			{ "sender": "setNotificationLicenserSettingsQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "getNotificationLicenserSettingsQuery", "action": "loadData", "type": "query" }
				]
			},
			{ "sender": "setNotifAppSettingsQuery", "event": "onerror", "type": "query", "receivers": [
					{ "id": "notificationEmailEditForm", "page": "notificationEmailEditDialog", "action": "applyError", "type": "control" }
			]
			},
			{ "sender": ["saveNotificationSettingsQuery", "setNotificationLicenserSettingsQuery"], "event": "onloadcomplete", "type": "query", "receivers": [
					{ "id": "notificationEditForm", "page": "notificationEditDialog", "action": "hideLoading", "type": "control" },
					{ "id": "pnlNotificationsSettingsContent", "page": "mainPage", "action": "hideLoading", "type": "control" }
				]
			},
			{ "sender": "setNotifAppSettingsQuery", "event": "onloadcomplete", "type": "query", "receivers": [
					{ "id": "notificationEmailEditForm", "page": "notificationEmailEditDialog", "action": "hideLoading", "type": "control" }
				]
			},
			{ "sender": ["notification1", "notification2", "notification3", "notification4", "notification5", "notification6", "notification7", "notification8", "notification9","notification14"], "event": "onsettingenable", "type": "control", "receivers": [
					{ "id": "notificationEditForm", "page": "notificationEditDialog", "action": "setNotifictionEnabled", "type": "control" },
					{ "id": "pnlNotificationsSettingsContent", "page": "mainPage", "action": "showLoading", "type": "control" }
				]
			},
			{ "sender": ["notification1", "notification2", "notification3", "notification4", "notification5", "notification6", "notification7", "notification8", "notification9","notification14"], "event": "onsettingdisable", "type": "control", "receivers": [
					{ "id": "notificationEditForm", "page": "notificationEditDialog", "action": "setNotifictionDisabled", "type": "control" },
					{ "id": "pnlNotificationsSettingsContent", "page": "mainPage", "action": "showLoading", "type": "control" }
				]
			},
			{ "sender": "notificationSenderSettingsPreview", "event": "onsettingschange", "type": "control", "receivers": [
					{ "id": "notificationEmailEditForm", "page": "notificationEmailEditDialog", "action": "setData", "type": "control" },
					{ "id": "notificationEmailEditDialog", "page": "notificationEmailEditDialog", "action": "showDialog", "type": "page" }
			]
			},
			{ "sender": "notificationLicenseAboutToExpireDaysSettingsPreview", "event": "onvaluechange", "type": "control", "receivers": [
					{ "id": "notificationEditForm", "page": "mainPage", "action": "focusOptions", "type": "control" },
					{ "id": "notification6Preview", "page": "mainPage", "action": "fireChangeEvent", "args": ["onchangetext"], "type": "control" }
				]
			},
			{ "sender": "notificationLicenseAboutToExpireDaysSettingsPreview", "event": "onoptionschange", "type": "control", "receivers": [
					{ "id": "notificationEditForm", "page": "notificationEditDialog", "action": "setOptions", "type": "control" }
				]
			},
			{ "sender": "notification6Preview", "event": "onchangetext", "type": "control", "receivers": [
					{ "id": "notificationEditForm", "page": "notificationEditDialog", "action": "setData", "type": "control" },
					{ "id": "notificationEditDialog", "page": "notificationEditDialog", "action": "showDialog", "type": "page" },
					{ "id": "notificationLicenseAboutToExpireDaysSettingsPreview", "page": "mainPage", "action": "fireChangeEvent", "args": ["onoptionschange"], "type": "control" }
				]
			},
			{ "sender": ["notification4Preview", "notification5Preview", "notification7Preview", "notification8Preview",
						"notification9Preview", "notification10Preview", "notification11Preview", "notification12Preview", "notification13Preview"
						], "event": "onchangetext", "type": "control", "receivers": [
					{ "id": "notificationEditForm", "page": "notificationEditDialog", "action": "setData", "type": "control" },
					{ "id": "notificationEditDialog", "page": "notificationEditDialog", "action": "showDialog", "type": "page" }
			]
			},
			{ "sender": ["notification1Preview", "notification2Preview"], "event": ["onchangeoutdatedtext", "onchangeobsoletetext"], "type": "control", "receivers": [
					{ "id": "notificationEditForm", "page": "notificationEditDialog", "action": "setData", "type": "control" },
					{ "id": "notificationEditDialog", "page": "notificationEditDialog", "action": "showDialog", "type": "page" }
			]
			},
			{ "sender": "notification3Preview", "event": ["onchangetext1", "onchangetext2"], "type": "control", "receivers": [
					{ "id": "notificationEditForm", "page": "notificationEditDialog", "action": "setData", "type": "control" },
					{ "id": "notificationEditDialog", "page": "notificationEditDialog", "action": "showDialog", "type": "page" }
			]
			},
			{ "sender": "notification14Preview", "event": ["onchangetext1", "onchangetext2"], "type": "control", "receivers": [
					{ "id": "notificationEditForm", "page": "notificationEditDialog", "action": "setData", "type": "control" },
					{ "id": "notificationEditDialog", "page": "notificationEditDialog", "action": "showDialog", "type": "page" }
			]
			},
			{ "sender": "notificationEditForm", "event": "onformsubmit", "type": "control", "receivers": [
					{ "id": "notificationEditForm", "page": "notificationEditDialog", "action": "showLoading", "type": "control" },
					{ "id": "saveNotificationSettingsQuery", "action": "loadData", "type": "query" }
			]
			},
			{ "sender": "notificationEditForm", "event": "onlicenseexpiressoondayschange", "type": "control", "receivers": [
					{ "id": "notificationEditForm", "page": "notificationEditDialog", "action": "showLoading", "type": "control" },
					{ "id": "setNotificationLicenserSettingsQuery", "action": "loadData", "type": "query" }
				]
			},
			
			{ "sender": "notificationEmailEditForm", "event": "onformsubmit", "type": "control", "receivers": [
					{ "id": "notificationEmailEditForm", "page": "notificationEmailEditDialog", "action": "showLoading", "type": "control" },
					{ "id": "setNotifAppSettingsQuery", "action": "loadData", "type": "query" }
			]
			},
			{ "sender": "getNotificationLicenserSettingsQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "NotificationsLicenserSettings", "action": "applyData", "type": "model" }
				]
			},
	
			{ "sender": "pnlProtectionSettingsContent", "event": "onshow", "type": "control", "receivers": [
					{ "id": "ksnProtectionSettings", "action": "disable", "type": "control" },
					{ "id": "getProtectionSettingsQuery", "action": "loadData", "type": "query" },
					{ "id": "getKsnAppSettingsQuery", "action": "loadData", "type": "query" }
				]
			},
			{ "sender": "getProtectionSettingsQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "avProtectionPreview", "page": "mainPage", "action": "applyValue", "type": "control" }
				]
			},
			{ "sender": "getProtectionSettingsQuery", "event": "onloadstarted", "type": "query", "receivers": [
					{ "id": "pnlProtectionSettingsContent", "page": "mainPage", "action": "showLoading", "type": "control" }
			]
			},
			{ "sender": "getProtectionSettingsQuery", "event": "onloadcomplete", "type": "query", "receivers": [
					{ "id": "pnlProtectionSettingsContent", "page": "mainPage", "action": "hideLoading", "type": "control" }
			]
			},
			{"sender": "avProtectionPreview", "event": "onsettingschange", "type": "control", "receivers": [
					{ "id": "avProtectionEditDialog", "page": "avProtectionEditDialog", "action": "showDialog", "type": "page" },
					{ "id": "avProtectionEditForm", "page": "avProtectionEditDialog", "action": "setData", "type": "control" }
			]
			},
			{ "sender": "asProtectionPreview", "event": "onsettingschange", "type": "control", "receivers": [
					{ "id": "asProtectionEditDialog", "page": "asProtectionEditDialog", "action": "showDialog", "type": "page" },
					{ "id": "asProtectionEditForm", "page": "asProtectionEditDialog", "action": "setData", "type": "control" }
			]
			},
			{ "sender": "afProtectionPreview", "event": "onsettingschange", "type": "control", "receivers": [
					{ "id": "afProtectionEditDialog", "page": "afProtectionEditDialog", "action": "showDialog", "type": "page" },
					{ "id": "afProtectionEditForm", "page": "afProtectionEditDialog", "action": "setData", "type": "control" }
				]
			},
			{ "sender": "blProtectionPreview", "event": "onsettingschange", "type": "control", "receivers": [
					{ "id": "blProtectionEditDialog", "page": "blProtectionEditDialog", "action": "showDialog", "type": "page" },
					{ "id": "blProtectionEditForm", "page": "blProtectionEditDialog", "action": "setData", "type": "control" }
				]
			},
			{ "sender": "ksnProtectionPreview1", "event": "onsettingschange", "type": "control", "receivers": [
					{ "id": "ksnSettingsDialog", "page": "ksnSettingsDialog", "action": "showDialog", "type": "page" },
					{ "id": "ksnSettingsEditForm", "page": "ksnSettingsDialog", "action": "setData", "type": "control" }
				]
			},
			{ "sender": "asProtectionPreview", "event": "ondnsblchange", "type": "control", "receivers": [
					{ "id": "settingsDnsblEditDialog", "page": "settingsDnsblEditDialog", "action": "showDialog", "type": "page" },
					{ "id": "settingsDnsblEditForm", "page": "settingsDnsblEditDialog", "action": "setData", "type": "control" }
				]
			},
			{ "sender": "asProtectionPreview", "event": "onsurblchange", "type": "control", "receivers": [
					{ "id": "settingsSurblEditDialog", "page": "settingsSurblEditDialog", "action": "showDialog", "type": "page" },
					{ "id": "settingsSurblEditForm", "page": "settingsSurblEditDialog", "action": "setData", "type": "control" }
				]
			},
					
			{"sender": ["avProtectionSettings", "asProtectionSettings", "cfProtectionSettings", "afProtectionSettings"], "event": ["onsettingenable","onsettingdisable"], "type": "control", "receivers": [
					{ "id": "setProtectionSettingsQuery", "action": "loadData", "type": "query" }
				]
			},
			{"sender": "ksnLicenseAcceptForm", "event": "onformsubmit", "type": "control", "receivers": [
					{ "id": "setKsnAppSettingsQuery", "action": "loadData", "type": "query" }
				]
			},
			{ "sender": "setKsnAppSettingsQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "ksnLicenseDialog", "page": "ksnLicenseDialog", "action": "closeDialog", "type": "page" },
					{ "id": "getKsnAppSettingsQuery", "action": "loadData", "type": "query" },
					{ "id": "getProtectionSettingsQuery", "action": "loadData", "type": "query" }
				]
			},
			{ "sender": "setKsnAppSettingsQuery", "event": "onloadstarted", "type": "query", "receivers": [
					{ "id": "ksnLicenseAcceptForm", "page": "ksnLicenseDialog", "action": "showLoading", "type": "control" }
				]
			},
			{ "sender": "setKsnAppSettingsQuery", "event": "onloadcomplete", "type": "query", "receivers": [
					{ "id": "ksnLicenseAcceptForm", "page": "ksnLicenseDialog", "action": "hideLoading", "type": "control" }
				]
			},
			{"sender": ["avProtectionEditForm", "settingsDnsblEditForm", "settingsSurblEditForm", "asProtectionEditForm", "afProtectionEditForm", "ksnSettingsEditForm", "blProtectionEditForm"], "event": "onformsubmit", "type": "control", "receivers": [
					{ "id": "setProtectionSettingsQuery", "action": "loadData", "type": "query" }
				]
			},
			
			{ "sender": "setProtectionSettingsQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "ksnSettingsDialog", "page": "ksnSettingsDialog", "action": "closeDialog", "type": "page" },
					{ "id": "avProtectionEditDialog", "page": "avProtectionEditDialog", "action": "closeDialog", "type": "page" },
					{ "id": "asProtectionEditDialog", "page": "asProtectionEditDialog", "action": "closeDialog", "type": "page" },
					{ "id": "afProtectionEditDialog", "page": "afProtectionEditDialog", "action": "closeDialog", "type": "page" },
					{ "id": "settingsDnsblEditDialog", "page": "settingsDnsblEditDialog", "action": "closeDialog", "type": "page" },
					{ "id": "settingsSurblEditDialog", "page": "settingsSurblEditDialog", "action": "closeDialog", "type": "page" },
					{ "id": "blProtectionEditDialog", "page": "blProtectionEditDialog", "action": "closeDialog", "type": "page" },
					{ "id": "getProtectionSettingsQuery", "action": "loadData", "type": "query" }
				]
			},
			{ "sender": "setProtectionSettingsQuery", "event": "onloadstarted", "type": "query", "receivers": [
					{ "id": "pnlProtectionSettingsContent", "page": "mainPage", "action": "showLoading", "type": "control" },
					{ "id": "ksnSettingsEditForm", "page": "ksnSettingsDialog", "action": "showLoading", "type": "control" },
					{ "id": "avProtectionEditForm", "page": "avProtectionEditDialog", "action": "showLoading", "type": "control" },
					{ "id": "settingsDnsblEditForm", "page": "settingsDnsblEditDialog", "action": "showLoading", "type": "control" },
					{ "id": "settingsSurblEditForm", "page": "settingsSurblEditDialog", "action": "showLoading", "type": "control" },
					{ "id": "asProtectionEditForm", "page": "asProtectionEditDialog", "action": "showLoading", "type": "control" },
					{ "id": "blProtectionEditForm", "page": "blProtectionEditDialog", "action": "showLoading", "type": "control" },
					{ "id": "afProtectionEditForm", "page": "afProtectionEditDialog", "action": "showLoading", "type": "control" }
					
				]
			},
			{ "sender": "setProtectionSettingsQuery", "event": "onloadcomplete", "type": "query", "receivers": [
					{ "id": "pnlProtectionSettingsContent", "page": "mainPage", "action": "hideLoading", "type": "control" },
					{ "id": "ksnSettingsEditForm", "page": "ksnSettingsDialog", "action": "hideLoading", "type": "control" },
					{ "id": "avProtectionEditForm", "page": "avProtectionEditDialog", "action": "hideLoading", "type": "control" },
					{ "id": "settingsDnsblEditForm", "page": "settingsDnsblEditDialog", "action": "hideLoading", "type": "control" },
					{ "id": "settingsSurblEditForm", "page": "settingsSurblEditDialog", "action": "hideLoading", "type": "control" },
					{ "id": "asProtectionEditForm", "page": "asProtectionEditDialog", "action": "hideLoading", "type": "control" },
					{ "id": "blProtectionEditForm", "page": "blProtectionEditDialog", "action": "hideLoading", "type": "control" },
					{ "id": "afProtectionEditForm", "page": "afProtectionEditDialog", "action": "hideLoading", "type": "control" }
				]
			},
			{ "sender": "setProtectionSettingsQuery", "event": "onerror", "type": "query", "receivers": [
					{ "id": "ksnSettingsEditForm", "page": "ksnSettingsDialog", "action": "applyError", "type": "control" },
					{ "id": "avProtectionEditForm", "page": "avProtectionEditDialog", "action": "applyError", "type": "control" },
					{ "id": "settingsDnsblEditForm", "page": "settingsDnsblEditDialog", "action": "applyError", "type": "control" },
					{ "id": "settingsSurblEditForm", "page": "settingsSurblEditDialog", "action": "applyError", "type": "control" },
					{ "id": "asProtectionEditForm", "page": "asProtectionEditDialog", "action": "applyError", "type": "control" },
					{ "id": "blProtectionEditForm", "page": "blProtectionEditDialog", "action": "applyError", "type": "control" },
					{ "id": "afProtectionEditForm", "page": "afProtectionEditDialog", "action": "applyError", "type": "control" }
				]
			},
			{ "sender": "getKsnAppSettingsQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "ksnProtectionSettings", "action": "enable", "type": "control" },
					{ "id": "ksnProtectionSettings", "action": "applyValue", "type": "control" },
					{ "id": "contextChangeAdapter", "page": "mainPage", "action": "applyAppSettings", "type": "control" },
					{ "id": "contextChangeAdapter", "page": "mainPage", "action": "applyKsnParticipationActivated", "type": "control" }
				]
			},
			{ "sender": "getKsnLicenseTextQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "ksnLicenseAcceptForm", "page": "ksnLicenseDialog", "action": "setLicenseText" }
				]
			},
			
		
			{ "sender": "baseUpdateSettings", "event": "onupdatestart", "type": "control", "receivers": [
					{ "id": "baseUpdateSettings", "page": "mainPage", "action": "start", "type": "control" },
					{ "id": "StartUpdaterQuery", "action": "loadData", "type": "query" }
			]
			},
			
			{ "sender": "StartUpdaterQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "baseUpdateSettings", "page": "mainPage", "action": "start", "type": "control" }
				]
			},
			{ "sender": "StartUpdaterQuery", "event": "onerror", "type": "query", "receivers": [
					{ "id": "baseUpdateSettings", "page": "mainPage", "action": "applyError", "type": "control" }
			]
			},
			{ "sender": "StartUpdaterAvsQuery", "event": "onerror", "type": "query", "receivers": [
					{ "id": "baseUpdateSettings", "page": "mainPage", "action": "applyError", "type": "control" }
			]
			},
			
			{ "sender": "baseUpdateSettings", "event": "ontaskprogress", "type": "control", "receivers": [
					{ "id": "getUpdaterDownloadProgressQuery", "action": "loadData", "type": "query" }
			]
			},
			
			{ "sender": "getUpdaterDownloadProgressQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "baseUpdateStatePreview", "page": "mainPage", "action": "applyValue", "type": "control" },
					{ "id": "baseUpdateSettings", "page": "mainPage", "action": "applyValue", "type": "control" }
			]
			},
			
			
			
			
			
			{ "sender": "ldapTypeSettingsForm", "event": "oncancel", "type": "control", "receivers": [
					{ "id": "ldapTypeSettingsDialog", "page": "ldapTypeSettingsDialog", "action": "closeDialog", "type": "page" }
			]
			},
			{ "sender": "ldapCnnSettingsForm", "event": "oncancel", "type": "control", "receivers": [
					{ "id": "ldapCnnSettingsDialog", "page": "ldapCnnSettingsDialog", "action": "closeDialog", "type": "page" }
			]
			},
			
			
			{ "sender": "ldapAccessSettingsForm", "event": "oncancel", "type": "control", "receivers": [
					{ "id": "ldapAccessSettingsDialog", "page": "ldapAccessSettingsDialog", "action": "closeDialog", "type": "page" }
			]
			},
			
			{ "sender": "usersBWListsEditForm", "event": "oncancel", "type": "control", "receivers": [
					{ "id": "usersBWListsEditDialog", "page": "usersBWListsEditDialog", "action": "closeDialog", "type": "page" }
			]
			},
			{ "sender": "usersBWListsEditForm", "event": "searchLDAP", "type": "control", "receivers": [
					{ "id": "SearchBWListsLDAPQuery", "action": "loadData", "type": "query" }
				]
			},
			{ "sender": "usersBWListsEditForm", "event": "onwildcardvalidate", "type": "control", "receivers": [
					{ "id": "validateLdapBwWildcardQuery", "action": "loadData", "type": "query" }
				]
			},
			{ "sender": "validateLdapBwWildcardQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "usersBWListsEditForm", "page": "usersBWListsEditDialog", "action": "setWildcardQueryIsValid", "type": "control" }
				]
			},
			{ "sender": "usersBWListsEditForm", "event": "onformsubmit", "type": "control", "receivers": [
					{ "id": "saveUserBWListsQuery", "action": "loadData", "type": "query" }
			]
			},
			{ "sender": "usersBWListsEditForm", "event": "onaccountselected", "type": "control", "receivers": [
					{ "id": "loadUserBWListsQuery", "action": "loadData", "type": "query" }
			]
			},
			{ "sender": "SearchBWListsLDAPQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "usersBWListsEditForm", "page": "usersBWListsEditDialog", "action": "applySearchResult", "type": "control" }
			]
			},
 			{ "sender": "SearchBWListsLDAPQuery", "event": "onerror", "type": "query", "receivers": [
					{ "id": "usersBWListsEditForm", "page": "usersBWListsEditDialog", "action": "applyError", "type": "control" }
			]
			},
			{ "sender": "loadUserBWListsQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "usersBWListsEditForm", "page": "usersBWListsEditDialog", "action": "applyListsData", "type": "control" }
			]
			},
			{ "sender": "saveUserBWListsQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "usersBWListsEditForm", "page": "usersBWListsEditDialog", "action": "applySaveComplete", "type": "control" }
			]
			},
			{ "sender": ["SearchBWListsLDAPQuery", "loadUserBWListsQuery", "saveUserBWListsQuery", "validateLdapBwWildcardQuery"], "event": "onloadstarted", "type": "query", "receivers": [
					{ "id": "usersBWListsEditForm", "page": "usersBWListsEditDialog", "action": "showLoading", "type": "control" }
			]
			},
			{ "sender": ["SearchBWListsLDAPQuery", "loadUserBWListsQuery", "saveUserBWListsQuery", "validateLdapBwWildcardQuery"], "event": "onloadcomplete", "type": "query", "receivers": [
					{ "id": "usersBWListsEditForm", "page": "usersBWListsEditDialog", "action": "hideLoading", "type": "control" }
			]
			},
			{ "sender": "usersBWListsEditForm", "event": "onimportlist", "type": "control", "receivers": [
					{ "id": "addressesAdminImportEditDialog", "page": "addressesAdminImportEditDialog", "action": "showDialog", "type": "page" },
					{ "id": "addressAdminImportEditForm", "page": "addressesAdminImportEditDialog", "action": "setData", "type": "control" }
				]
			},
			{ "sender": "addressAdminImportEditForm", "event": "ontestemails", "type": "control", "receivers": [
					{ "id": "validateAdminImportingEmailQuery", "action": "loadData", "type": "query" }
				]
			},
			{ "sender": "validateAdminImportingEmailQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "addressAdminImportEditForm", "page": "addressesAdminImportEditDialog", "action": "applyValidationResult", "type": "control" }
				]
			},
			
			
			{ "sender": "validateAdminImportingEmailQuery", "event": "onloadstarted", "type": "query", "receivers": [
					{ "id": "addressAdminImportEditForm", "page": "addressesAdminImportEditDialog", "action": "showLoading", "type": "control" }
				]
			},
			{ "sender": "validateAdminImportingEmailQuery", "event": "onloadcomplete", "type": "query", "receivers": [
					{ "id": "addressAdminImportEditForm", "page": "addressesAdminImportEditDialog", "action": "hideLoading", "type": "control" }
				]
			},
			{ "sender": "addressAdminImportEditForm", "event": "onok", "type": "control", "receivers": [
					{ "id": "usersBWListsEditForm", "action": "setImportAddresses", "type": "control" }
				]
			},
			{ "sender": "personalBWListsPanel", "event": "searchLDAP", "type": "control", "receivers": [
					{ "id": "searchPersonalBWListsLDAPQuery", "action": "loadData", "type": "query" }
				]
			},
			{ "sender": "searchPersonalBWListsLDAPQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "personalBWListsPanel", "page": "mainPage", "action": "applySearchResult", "type": "control" }
				]
			},
 			{ "sender": "searchPersonalBWListsLDAPQuery", "event": "onerror", "type": "query", "receivers": [
					{ "id": "personalBWListsPanel", "page": "mainPage", "action": "applyError", "type": "control" }
				]
			},
			{ "sender": "personalBWListsPanel", "event": "onaccountselected", "type": "control", "receivers": [
					{ "id": "loadPersonalBWListsQuery", "action": "loadData", "type": "query" }
				]
			},
			
			{ "sender": "personalBWListsPanel", "event": "onloaduserlists", "type": "control", "receivers": [
					{ "id": "loadPersonalBWListsQuery",  "action": "loadData", "type": "query" }
				]
			},			
			{ "sender": ["loadPersonalBWListsQuery","savePersonalBWListsQuery", "searchPersonalBWListsLDAPQuery"], "event": "onloadstarted", "type": "query", "receivers": [
					{ "id": "personalBWListsPanel", "page": "main", "action": "showLoading", "type": "control" }
				]
			},
			{ "sender": ["loadPersonalBWListsQuery","savePersonalBWListsQuery", "searchPersonalBWListsLDAPQuery"], "event": "onloadcomplete", "type": "query", "receivers": [
					{ "id": "personalBWListsPanel", "page": "main", "action": "hideLoading", "type": "control" }
				]
			},
			{ "sender": "loadPersonalBWListsQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "personalBWListsPanel", "page": "main", "action": "applyListsData", "type": "control" }
				]
			},
			{ "sender": "personalBWListsPanel", "event": "onformsubmit", "type": "control", "receivers": [
					{ "id": "savePersonalBWListsQuery", "action": "loadData", "type": "query" }
				]
			},
			{ "sender": "savePersonalBWListsQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "personalBWListsPanel", "page": "main", "action": "applySaveComplete", "type": "control" }
				]
			},
			{ "sender": "personalBWListsPanel", "event": "onwildcardvalidate", "type": "control", "receivers": [
					{ "id": "validatePersonalWildcardQuery", "action": "loadData", "type": "query" },
					{ "id": "personalBWListsPanel", "page": "mainPage", "action": "showLoading", "type": "control" }
				]
			},
			{ "sender": "validatePersonalWildcardQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "personalBWListsPanel", "page": "mainPage", "action": "setWildcardQueryIsValid", "type": "control" }
				]
			},
			{ "sender": "validatePersonalWildcardQuery", "event": "onloadcomplete", "type": "query", "receivers": [
					{ "id": "personalBWListsPanel", "page": "mainPage", "action": "hideLoading", "type": "control" }
				]
			},
			
			{ "sender": "personalBWListsPanel", "event": "onimportlist", "type": "control", "receivers": [
					{ "id": "addressesPersonalImportEditDialog", "page": "addressesPersonalImportEditDialog", "action": "showDialog", "type": "page" },
					{ "id": "addressPersonalImportEditForm", "page": "addressesPersonalImportEditDialog", "action": "setData", "type": "control" }
				]
			},
			
			{ "sender": "addressPersonalImportEditForm", "event": "ontestemails", "type": "control", "receivers": [
					{ "id": "validatePersonalImportingEmailQuery", "action": "loadData", "type": "query" }
				]
			},
			{ "sender": "validatePersonalImportingEmailQuery", "event": "onsuccess", "type": "query", "receivers": [
					{ "id": "addressPersonalImportEditForm", "page": "addressesPersonalImportEditDialog", "action": "applyValidationResult", "type": "control" }
				]
			},
			
			
			{ "sender": "validatePersonalImportingEmailQuery", "event": "onloadstarted", "type": "query", "receivers": [
					{ "id": "addressPersonalImportEditForm", "page": "addressesPersonalImportEditDialog", "action": "showLoading", "type": "control" }
				]
			},
			{ "sender": "validatePersonalImportingEmailQuery", "event": "onloadcomplete", "type": "query", "receivers": [
					{ "id": "addressPersonalImportEditForm", "page": "addressesPersonalImportEditDialog", "action": "hideLoading", "type": "control" }
				]
			},
			{ "sender": "addressPersonalImportEditForm", "event": "onok", "type": "control", "receivers": [
					{ "id": "personalBWListsPanel", "action": "setImportAddresses", "type": "control" }
				]
			}
		],
	"queries":
		[
			{ "id": "getServerTime", "action": "serverTime", "timeout":60000	},
			{ "id": "getServerName", "action": "getServerName"	},
			
			{ "id": "signupQuery", "action": "userLogin", 
				"paramsset": { "id": "loginForm", "page": "signupPage"}
			},
			{ "id": "signoutQuery", "action": "userLogout"
			},
			{ "id": "changeAdminPasswordQuery", "action": "changeAdminPassword",
				"paramsset": {"id": "chPasswdForm", "page": "changePasswdDialog" }
			},
			
			{ "id": "DeleteGroupQuery", "action": "deleteGroup",
				"params": { "data": { "id": "GroupsGridControl", "action": "getDeletingGroupIds", "page": "mainPage" } }
			},
			
			{ "id": "GroupSettingLoadQuery", "action": "getGroupInfo",
				"params": { "groupId": { "id": "GroupsGridControl", "action": "getSeletedRowsId", "page": "mainPage"} }
			},
			{ "id": "GroupSettingDefaultLoadQuery", "action": "getGroupDefaultSettings"
			},
			{ "id": "GroupSettingsSaveQuery", "action": "setGroupSettings",
				"paramsset": { "id": "GroupSettingsEditor", "action": "getSettings", "page": "mainPage" },
				"params": { "groupId": { "id": "GroupSettingsEditor", "action": "getGroupId", "page": "mainPage"} }
			},
			{ "id": "GroupSettingsSaveCloseQuery", "action": "setGroupSettings",
				"paramsset": { "id": "GroupSettingsEditor", "action": "getSettings", "page": "mainPage" },
				"params": { "groupId": { "id": "GroupSettingsEditor", "action": "getGroupId", "page": "mainPage"} }
			},
			{ "id": "GroupNewSettingsSaveQuery", "action": "createGroup",
				"paramsset": { "id": "GroupSettingsEditor", "action": "getSettings", "page": "mainPage" }
			},
			{ "id": "GroupsListLoadQuery", "action": "getAllGroupsInfo"
			},
			
			{ "id": "ValidateFileNameQuery", "action": "checkOptionalRegex",
				"params": { "data": { "id": "groupCFSettingsForm", "action": "getExcludesValue", "page": "mainPage"} }
			},
			{ "id": "getGroupProtectionMiscSettingsQuery", "action": "getScanLogicSettings" },
			{ "id": "GroupSetActive", "action": "setGroupActiveFlag",
				"paramsset": {  "id": "GroupsGridControl", "action": "getActiveChangeData", "page": "mainPage"} 
				
			},
			{ "id": "GroupSetPriority", "action": "setPriorityBefore",
				"paramsset": {  "id": "GroupsGridControl", "action": "getPriorityChangeData", "page": "mainPage"} 
			},
			{ "id": "BackupListLoadQuery", "action": "backupQuery",
				"paramsset": { "id": "BackupGridControl", "action": "getFilter", "page": "mainPage" }
			},
			{ "id": "MessageDeleteQuery", "action": "backupDelete",
				"paramsset": {  "id": "BackupGridControl", "action": "getSelectedMessage", "page": "mainPage"} 
			},
			
			{ "id": "MessageDeliverQuery", "action": "deliverLetter",
				"paramsset": {  "id": "BackupGridControl", "action": "getDeliverMessage", "page": "mainPage"} 
			},
			{ "id": "MessageSaveQuery", "action": "downloadLetter",
				"paramsset": {  "id": "BackupGridControl", "action": "getSaveMessage", "page": "mainPage"} 
			},
			{ "id": "SearchLDAPQuery", "action": "searchByLDAP",
				"params": { 
					"data":{ "id": "addressEditForm", "action": "getSearchByLDAPData", "page": "addressesEditDialog"},
					"limit":{ "id": "addressEditForm", "action": "getSearchLimitByLDAPData", "page": "addressesEditDialog"}
				}
			},
			{ "id": "isLdapConnectQuery", "action": "testLdapScript" },
			{ "id": "GetLDAPInfoQuery", "action": "getInfoByEntryId",
				"paramsset": { "id": "groupGeneralSettingsForm", "action": "getExternalAccount", "page": "mainPage"}
			},
			{"id": "SearchLDAPQueryAutocomplete", "action": "searchByLDAP",
				"params": { "data": { "id": "testLdapSearchForm", "action": "getTerm", "page": "mainPage"} }
			},
			
			{ "id": "ReportsListLoadQuery", "action": "getReportList",
				"paramsset": { "id": "ReportsGridControl", "action": "getFilter", "page": "mainPage" } 
			},
			
			
			{ "id": "DeleteReportsQuery", "action": "removeReports",
				"paramsset": { "id": "ReportsGridControl", "action": "getSelectedReport", "page": "mainPage"} 
			},
			{ "id": "CreateReportQuery", "action": "createReport",
				"paramsset": { "id": "reportParamsForm", "action": "getReportParams", "page": "reportParamsDialog" }
			},
			{ "id": "ReportsScheduleSettingsQuery", "action": "getReportScheduleSettings"},
			{ "id": "ReportsLocaleListQuery", "action" : "getLocaleList"},
			{ "id": "setReportsScheduleEnabledQuery", "action": "createReport",
				"paramsset": { "id": "reportsFilterBtns", "action": "getReportParams", "page": "mainPage" }
			},
			{ "id": "DownloadReportQuery", "action": "downloadReport",
				"paramsset": { "id": "ReportsGridControl", "action": "getDownloadReport", "page": "mainPage"} 
			},
			
			{ "id": "validateIpQuery", "action": "checkIp",
				"params": { "data": { "id": "groupGeneralSettingsForm", "action": "getValidatingValue", "page": "mainPage"} }
			},
			{ "id": "validateWildcardQuery", "action": "checkWildcardEMailAddress",
				"params": { "data": { "id": "groupGeneralSettingsForm", "action": "getValidatingValue", "page": "mainPage"} }
			},
			
			{ "id": "validateLdapBwWildcardQuery", "action": "checkWildcardEMailAddress",
				"params": { "data": { "id": "usersBWListsEditForm", "action": "getValidatingValue", "page": "usersBWListsEditDialog"} }
			},
			{ "id": "validateImportingIpQuery", "action": "checkIp",
				"params": { "data": { "id": "addressImportEditForm", "action": "getValidationData", "page": "addressesImportEditDialog"} }
			},
			{ "id": "validateImportingEmailQuery", "action": "checkWildcardEMailAddress",
				"params": { "data": { "id": "addressImportEditForm", "action": "getValidationData", "page": "addressesImportEditDialog"} }
			},
			{ "id": "validatePersonalImportingEmailQuery", "action": "checkWildcardEMailAddress",
				"params": { "data": { "id": "addressPersonalImportEditForm", "action": "getValidationData", "page": "addressesPersonalImportEditDialog"} }
			},
			{ "id": "validateAdminImportingEmailQuery", "action": "checkWildcardEMailAddress",
				"params": { "data": { "id": "addressAdminImportEditForm", "action": "getValidationData", "page": "addressesAdminImportEditDialog"} }
			},
			{ "id": "validatePersonalWildcardQuery", "action": "checkWildcardEMailAddress",
				"params": { "data": { "id": "personalBWListsPanel", "action": "getValidatingValue", "page": "mainPage"} }
			},
			{ "id": "getUpdateSettingsQuery", "action": "getUpdaterSettings" },
			{ "id": "saveUpdateSettingsQuery", "action": "setUpdaterSettings",//"model": { "data": "UpdateSettings" }
				"params": {
					"data": { "id": "baseUpdateSourceSettingsForm", "action": "getValueString", "page": "baseUpdateSourceSettingsDialog" }
				}
			},
			{ "id": "saveUpdateScheduleSettingsQuery", "action": "setUpdaterSettings",//"model": { "data": "UpdateSettings" }
				"params": {
					"data": { "id": "baseUpdateScheduleSettingsForm", "action": "getValueString", "page": "baseUpdateScheduleSettingsDialog" }
				}
			},
			{ "id": "saveUpdateAVSettingsQuery", "action": "setUpdaterAvsSettings","model": { "data": "UpdateAVSettings" }
				
			},
			{ "id": "saveAppProxySettingsQuery", "action": "setAppSettings", "model": { "data": "AppMiscSettings" } },
			{ "id": "getUpdateProxySettingsQuery", "action": "getAppSettings"},
			{ "id": "saveAppProxySettingsQuery1", "action": "setAppSettings", "model": { "data": "UpdateProxySettings" } },
			
			{ "id": "StartUpdaterQuery", "action": "startUpdater"	},
		
			{ "id": "getUpdaterDownloadProgressQuery", "action": "getUpdaterDownloadProgress","timeout":10000
			},
			
			
			
			
			
			{ "id": "GetAppInfoQuery", "action": "appInfo" },
			{ "id": "getNotificationSettingsQuery", "action": "getNotifierSettings" },
			{ "id": "saveNotificationSettingsQuery", "action": "setNotifierSettings", "paramsset": { "id": "notificationEditForm", "page": "notificationEditDialog", "action": "getValueRecursive" } },
			{ "id": "getNotificationLicenserSettingsQuery", "action": "getLicenserSettings" },
			{ "id": "setNotificationLicenserSettingsQuery", "action": "setLicenserSettings", "model": { "data": "NotificationsLicenserSettings" } },
			
			{ "id": "getProtectionSettingsQuery", "action": "getScanLogicSettings" },
			{ "id": "setProtectionSettingsQuery", "action": "setScanLogicSettings", "model": { "data": "ProtectionSettings" } },
			{ "id": "getProtectionMiscSettingsQuery", "action": "getScanLogicSettings" },
			{ "id": "setProtectionMiscSettingsQuery", "action": "setScanLogicSettings", "model": { "data": "ScanLogicSettings" } },
			{ "id": "getAppEmailSettingsQuery", "action": "getAppSettings" },
			{ "id": "setAppEmailSettingsQuery", "action": "setAppSettings","model": { "data": "AppMiscSettings" } },
			
			{ "id": "getBackupSettingsQuery", "action": "getBackupSettings" },
			{ "id": "saveBackupSettingsQuery", "action": "setBackupSettings", "model": { "data": "BackupSettings" } },
			
			{ "id": "getSNMPSettingsQuery", "action": "getSNMPSettings" },
			{ "id": "saveSNMPSettingsQuery", "action": "setSNMPSettings", "model": { "data": "SNMPSettings" } },
			{ "id": "getLdapSettingsQuery", "action": "getLdapSettings" },
			{ "id": "testLdapSettingsQuery", "action": "testLdapScript" },
			
			{ "id": "checkLdapSettingsQuery", "action": "checkAuthSettings", "paramsset": { "id": "ldapCnnSettingsForm", "action": "getValueRecursive", "page": "ldapCnnSettingsDialog" }
			
			},
			
			
			{ "id": "saveLdapSettingsQuery", "action": "setLdapSettings", "params": {
					"data": { "id": "ldapCnnSettings", "action": "getValueRecursive", "page": "mainPage" }
				}
			},
			{ "id": "SearchBWListsLDAPQuery", "action": "searchByLDAP",
				"params": { 
					"data":{ "id": "usersBWListsEditForm", "page": "usersBWListsEditDialog", "action": "getSearchTerm"},
					"limit":{ "id": "usersBWListsEditForm", "page": "usersBWListsEditDialog", "action": "getSearchLimit"}
				}
			},
			{ "id": "loadUserBWListsQuery", "action": "getBlackWhiteListSettings",
				"params": { "account":{ "id": "usersBWListsEditForm", "page": "usersBWListsEditDialog", "action": "getUserAccount"} }
			},
			{ "id": "saveUserBWListsQuery", "action": "setBlackWhiteListSettings",
				"paramsset": { "id": "usersBWListsEditForm", "page": "usersBWListsEditDialog", "action": "getValueRecursive"}
			},
			{ "id": "savePersonalBWListsQuery", "action": "setBlackWhiteListSettings",
				"paramsset": { "id": "personalBWListsPanel",  "action": "getValueRecursive", "page": "mainPage" }
			},
			{ "id": "searchPersonalBWListsLDAPQuery", "action": "searchByLDAP",
				"params": { 
					"data":{ "id": "personalBWListsPanel", "page": "mainPage", "action": "getSearchTerm"},
					"limit":{ "id": "personalBWListsPanel", "page": "mainPage", "action": "getSearchLimit"}
				}
			},
			{ "id": "loadPersonalBWListsQuery", "action": "getBlackWhiteListSettings",
				"params": { "account":{ "id": "personalBWListsPanel", "page": "mainPage", "action": "getUserAccount"} }
			},
			{ "id": "getKsnLicenseTextQuery", "action": "getKsnLicenseText", "type": "text", "params": {
					"lang":{ "id": "ksnLicenseAcceptForm", "page": "ksnLicenseDialog", "action": "getLanguage"}
				}
			},
			{ "id": "getKsnAppSettingsQuery", "action": "getAppSettings" },
			{ "id": "setKsnAppSettingsQuery", "action": "setAppSettings", "model": { "data": "ProtectionKsnSettings" } },
			{ "id": "getNotifAppSettingsQuery", "action": "getAppSettings" },
			{ "id": "setNotifAppSettingsQuery", "action": "setAppSettings", "model": { "data": "AppNotificationsSetting" } },
		
			{ "id": "getEventLoggerSettingsQuery", "action": "getEventLoggerSettings" },
			{ "id": "setEventLoggerSettingsQuery", "action": "setEventLoggerSettings", "model": { "data": "EventLoggerSettings" } },
			
			{ "id": "dashboardStatsQuery", "action": "getStatisticsForTimePeriod", "params": { "data": { "id": "dashboard", "action": "getStatData", "page": "mainPage" } } },
			{ "id": "dashboardAvQuery", "action": "getAvBrief", "timeout": 4000 },
			{ "id": "dashboardAsQuery", "action": "getAsBrief", "timeout": 4000 },
			{ "id": "dashboardApQuery", "action": "getApBrief", "timeout": 4000 },
			
			{ "id": "dashboardLdapSettingsQuery", "action": "getLdapSettings", "timeout": 4000 },
			{ "id": "dashboardLdapQuery", "action": "getLdapBrief" },
			{ "id": "dashboardBackupQuery", "action": "getBackupBrief", "timeout": 4000 },
			
			{ "id": "headerGetLicenseQuery", "action": "getLicenseStatus" },
			{ "id": "getLicensesInfoQuery", "action": "getKeys" },
			{ "id": "getLicenseQuery", "action": "getLicenseStatus" },
			{ "id": "uploadLicenseKeyQuery", "action": "installKey" },
			{ "id": "uploadSettingsQuery", "action": "importSettings" },
			{ "id": "restartProductQuery", "action": "restartProduct" },
			{ "id": "importRestartProductQuery", "action": "restartProduct" },
			{ "id": "revokeLicenseKeyQuery", "action": "revokeKey", "paramsset": { "id": "licensesEditForm", "page": "LicensesDialog", "action": "getDeletingLicense" } },
			{ "id": "dashboardLoadThreatsQuery", "action": "getRecentThreats", "timeout": 30000 },
			{ "id": "downloadSettingsQuery", "action": "exportAllSettings", "hidden": true },
			
			{ "id": "getHelpdeskAccSettingsQuery", "action": "getUsersList" },
			{ "id": "getHelpdeskBackupSettingsQuery", "action": "getBackupSettings" },
			{ "id": "saveHelpdeskAppSettingsQuery", "action": "setAppSettings", "model": { "data": "AppMiscSettings" } },
			{ "id": "saveHelpdeskAccSettingsQuery", "action": "changeHelpDeskAccount", "paramsset": { "id": "helpdeskSettingsForm", "page": "helpdeskSettingsDialog", "action": "getAccData" } }
		]
})
;
})();
;
})();
